/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_EASYANALYZER
#define H_LUCY_ANALYSIS_EASYANALYZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_EASYANALYZER
struct lucy_EasyAnalyzer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* language;
    lucy_StandardTokenizer* tokenizer;
    lucy_Normalizer* normalizer;
    lucy_SnowballStemmer* stemmer;
};

#endif /* C_LUCY_EASYANALYZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_EasyAnalyzer*
lucy_EasyAnalyzer_new(const lucy_CharBuf* language);

lucy_EasyAnalyzer*
lucy_EasyAnalyzer_init(lucy_EasyAnalyzer* self, const lucy_CharBuf* language);

void
lucy_EasyAnalyzer_destroy(lucy_EasyAnalyzer* self);

chy_bool_t
lucy_EasyAnalyzer_equals(lucy_EasyAnalyzer* self, lucy_Obj* other);

lucy_Hash*
lucy_EasyAnalyzer_dump(lucy_EasyAnalyzer* self);

lucy_EasyAnalyzer*
lucy_EasyAnalyzer_load(lucy_EasyAnalyzer* self, lucy_Obj* dump);

lucy_Inversion*
lucy_EasyAnalyzer_transform(lucy_EasyAnalyzer* self, lucy_Inversion* inversion);

lucy_Inversion*
lucy_EasyAnalyzer_transform_text(lucy_EasyAnalyzer* self, lucy_CharBuf* text);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_EasyAnalyzer_destroy_CALLBACK;
extern cfish_Callback lucy_EasyAnalyzer_equals_CALLBACK;
extern cfish_Callback lucy_EasyAnalyzer_dump_CALLBACK;
extern cfish_Callback lucy_EasyAnalyzer_load_CALLBACK;
extern cfish_Callback lucy_EasyAnalyzer_transform_CALLBACK;
extern cfish_Callback lucy_EasyAnalyzer_transform_text_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_EasyAnalyzer_destroy_t)(lucy_EasyAnalyzer* self);

typedef chy_bool_t
(*lucy_EasyAnalyzer_equals_t)(lucy_EasyAnalyzer* self, lucy_Obj* other);

typedef lucy_Hash*
(*lucy_EasyAnalyzer_dump_t)(lucy_EasyAnalyzer* self);

typedef lucy_EasyAnalyzer*
(*lucy_EasyAnalyzer_load_t)(lucy_EasyAnalyzer* self, lucy_Obj* dump);

typedef lucy_Inversion*
(*lucy_EasyAnalyzer_transform_t)(lucy_EasyAnalyzer* self, lucy_Inversion* inversion);

typedef lucy_Inversion*
(*lucy_EasyAnalyzer_transform_text_t)(lucy_EasyAnalyzer* self, lucy_CharBuf* text);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_EasyAnalyzer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_EasyAnalyzer_Make(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_EasyAnalyzer_Get_RefCount(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_EasyAnalyzer_Inc_RefCount(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_EasyAnalyzer_Dec_RefCount(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_EasyAnalyzer_To_Host(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_EasyAnalyzer_Clone(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_EasyAnalyzer_Destroy(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Destroy_OFFSET;
    const lucy_EasyAnalyzer_destroy_t method = *((lucy_EasyAnalyzer_destroy_t*)method_address);
    method((lucy_EasyAnalyzer*)self);
}

extern size_t Lucy_EasyAnalyzer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_EasyAnalyzer_Equals(const lucy_EasyAnalyzer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Equals_OFFSET;
    const lucy_EasyAnalyzer_equals_t method = *((lucy_EasyAnalyzer_equals_t*)method_address);
    return method((lucy_EasyAnalyzer*)self, other);
}

extern size_t Lucy_EasyAnalyzer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_EasyAnalyzer_Compare_To(const lucy_EasyAnalyzer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_EasyAnalyzer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_EasyAnalyzer_Hash_Sum(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_EasyAnalyzer_Get_VTable(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_EasyAnalyzer_Get_Class_Name(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_EasyAnalyzer_Is_A(const lucy_EasyAnalyzer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_EasyAnalyzer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_EasyAnalyzer_To_String(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_EasyAnalyzer_To_I64(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_EasyAnalyzer_To_F64(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_EasyAnalyzer_To_Bool(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_EasyAnalyzer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_EasyAnalyzer_Serialize(const lucy_EasyAnalyzer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_EasyAnalyzer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_EasyAnalyzer_Deserialize(const lucy_EasyAnalyzer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_EasyAnalyzer_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_EasyAnalyzer_Dump(const lucy_EasyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Dump_OFFSET;
    const lucy_EasyAnalyzer_dump_t method = *((lucy_EasyAnalyzer_dump_t*)method_address);
    return method((lucy_EasyAnalyzer*)self);
}

extern size_t Lucy_EasyAnalyzer_Load_OFFSET;
static CHY_INLINE lucy_EasyAnalyzer*
Lucy_EasyAnalyzer_Load(const lucy_EasyAnalyzer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Load_OFFSET;
    const lucy_EasyAnalyzer_load_t method = *((lucy_EasyAnalyzer_load_t*)method_address);
    return method((lucy_EasyAnalyzer*)self, dump);
}

extern size_t Lucy_EasyAnalyzer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_EasyAnalyzer_Mimic(const lucy_EasyAnalyzer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_EasyAnalyzer_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_EasyAnalyzer_Transform(const lucy_EasyAnalyzer *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Transform_OFFSET;
    const lucy_EasyAnalyzer_transform_t method = *((lucy_EasyAnalyzer_transform_t*)method_address);
    return method((lucy_EasyAnalyzer*)self, inversion);
}

extern size_t Lucy_EasyAnalyzer_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_EasyAnalyzer_Transform_Text(const lucy_EasyAnalyzer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Transform_Text_OFFSET;
    const lucy_EasyAnalyzer_transform_text_t method = *((lucy_EasyAnalyzer_transform_text_t*)method_address);
    return method((lucy_EasyAnalyzer*)self, text);
}

extern size_t Lucy_EasyAnalyzer_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_EasyAnalyzer_Split(const lucy_EasyAnalyzer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_EasyAnalyzer_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_EASYANALYZER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_EASYANALYZER_VT;
extern struct LUCY_EASYANALYZER_VT LUCY_EASYANALYZER_vt;
#define LUCY_EASYANALYZER ((cfish_VTable*)&LUCY_EASYANALYZER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define EasyAnalyzer lucy_EasyAnalyzer
  #define EASYANALYZER LUCY_EASYANALYZER
  #define EasyAnalyzer_new lucy_EasyAnalyzer_new
  #define EasyAnalyzer_init lucy_EasyAnalyzer_init
  #define EasyAnalyzer_destroy_t lucy_EasyAnalyzer_destroy_t
  #define EasyAnalyzer_destroy lucy_EasyAnalyzer_destroy
  #define EasyAnalyzer_equals_t lucy_EasyAnalyzer_equals_t
  #define EasyAnalyzer_equals lucy_EasyAnalyzer_equals
  #define EasyAnalyzer_dump_t lucy_EasyAnalyzer_dump_t
  #define EasyAnalyzer_dump lucy_EasyAnalyzer_dump
  #define EasyAnalyzer_load_t lucy_EasyAnalyzer_load_t
  #define EasyAnalyzer_load lucy_EasyAnalyzer_load
  #define EasyAnalyzer_transform_t lucy_EasyAnalyzer_transform_t
  #define EasyAnalyzer_transform lucy_EasyAnalyzer_transform
  #define EasyAnalyzer_transform_text_t lucy_EasyAnalyzer_transform_text_t
  #define EasyAnalyzer_transform_text lucy_EasyAnalyzer_transform_text
  #define EasyAnalyzer_Make Lucy_EasyAnalyzer_Make
  #define EasyAnalyzer_Get_RefCount Lucy_EasyAnalyzer_Get_RefCount
  #define EasyAnalyzer_Inc_RefCount Lucy_EasyAnalyzer_Inc_RefCount
  #define EasyAnalyzer_Dec_RefCount Lucy_EasyAnalyzer_Dec_RefCount
  #define EasyAnalyzer_To_Host Lucy_EasyAnalyzer_To_Host
  #define EasyAnalyzer_Clone Lucy_EasyAnalyzer_Clone
  #define EasyAnalyzer_Destroy Lucy_EasyAnalyzer_Destroy
  #define EasyAnalyzer_Equals Lucy_EasyAnalyzer_Equals
  #define EasyAnalyzer_Compare_To Lucy_EasyAnalyzer_Compare_To
  #define EasyAnalyzer_Hash_Sum Lucy_EasyAnalyzer_Hash_Sum
  #define EasyAnalyzer_Get_VTable Lucy_EasyAnalyzer_Get_VTable
  #define EasyAnalyzer_Get_Class_Name Lucy_EasyAnalyzer_Get_Class_Name
  #define EasyAnalyzer_Is_A Lucy_EasyAnalyzer_Is_A
  #define EasyAnalyzer_To_String Lucy_EasyAnalyzer_To_String
  #define EasyAnalyzer_To_I64 Lucy_EasyAnalyzer_To_I64
  #define EasyAnalyzer_To_F64 Lucy_EasyAnalyzer_To_F64
  #define EasyAnalyzer_To_Bool Lucy_EasyAnalyzer_To_Bool
  #define EasyAnalyzer_Serialize Lucy_EasyAnalyzer_Serialize
  #define EasyAnalyzer_Deserialize Lucy_EasyAnalyzer_Deserialize
  #define EasyAnalyzer_Dump Lucy_EasyAnalyzer_Dump
  #define EasyAnalyzer_Load Lucy_EasyAnalyzer_Load
  #define EasyAnalyzer_Mimic Lucy_EasyAnalyzer_Mimic
  #define EasyAnalyzer_Transform Lucy_EasyAnalyzer_Transform
  #define EasyAnalyzer_Transform_Text Lucy_EasyAnalyzer_Transform_Text
  #define EasyAnalyzer_Split Lucy_EasyAnalyzer_Split
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_EASYANALYZER */




