/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_INVERSION
#define H_LUCY_ANALYSIS_INVERSION 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INVERSION
struct lucy_Inversion {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Token** tokens;
    uint32_t size;
    uint32_t cap;
    uint32_t cur;
    chy_bool_t inverted;
    uint32_t* cluster_counts;
    uint32_t cluster_counts_size;
};

#endif /* C_LUCY_INVERSION */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Inversion*
lucy_Inversion_new(lucy_Token* seed);

void
lucy_Inversion_destroy(lucy_Inversion* self);

void
lucy_Inversion_append(lucy_Inversion* self, lucy_Token* token);

lucy_Token*
lucy_Inversion_next(lucy_Inversion* self);

void
lucy_Inversion_reset(lucy_Inversion* self);

void
lucy_Inversion_invert(lucy_Inversion* self);

lucy_Token**
lucy_Inversion_next_cluster(lucy_Inversion* self, uint32_t* count);

uint32_t
lucy_Inversion_get_size(lucy_Inversion* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Inversion_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Inversion_destroy_t)(lucy_Inversion* self);

typedef void
(*lucy_Inversion_append_t)(lucy_Inversion* self, lucy_Token* token);

typedef lucy_Token*
(*lucy_Inversion_next_t)(lucy_Inversion* self);

typedef void
(*lucy_Inversion_reset_t)(lucy_Inversion* self);

typedef void
(*lucy_Inversion_invert_t)(lucy_Inversion* self);

typedef lucy_Token**
(*lucy_Inversion_next_cluster_t)(lucy_Inversion* self, uint32_t* count);

typedef uint32_t
(*lucy_Inversion_get_size_t)(lucy_Inversion* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Inversion_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inversion_Make(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Inversion_Get_RefCount(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inversion_Inc_RefCount(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Inversion_Dec_RefCount(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Inversion_To_Host(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inversion_Clone(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Inversion_Destroy(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Destroy_OFFSET;
    const lucy_Inversion_destroy_t method = *((lucy_Inversion_destroy_t*)method_address);
    method((lucy_Inversion*)self);
}

extern size_t Lucy_Inversion_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Inversion_Equals(const lucy_Inversion *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Inversion_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Inversion_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Inversion_Compare_To(const lucy_Inversion *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Inversion_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Inversion_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Inversion_Hash_Sum(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Inversion_Get_VTable(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Inversion_Get_Class_Name(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Inversion_Is_A(const lucy_Inversion *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Inversion_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Inversion_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Inversion_To_String(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Inversion_To_I64(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Inversion_To_F64(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Inversion_To_Bool(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Inversion_Serialize(const lucy_Inversion *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Inversion_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Inversion_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inversion_Deserialize(const lucy_Inversion *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Inversion_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Inversion_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inversion_Dump(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inversion_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inversion_Load(const lucy_Inversion *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Inversion_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Inversion_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Inversion_Mimic(const lucy_Inversion *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Inversion_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Inversion_Append_OFFSET;
static CHY_INLINE void
Lucy_Inversion_Append(const lucy_Inversion *self, lucy_Token* token) {
    char *const method_address = *(char**)self + Lucy_Inversion_Append_OFFSET;
    const lucy_Inversion_append_t method = *((lucy_Inversion_append_t*)method_address);
    method((lucy_Inversion*)self, token);
}

extern size_t Lucy_Inversion_Next_OFFSET;
static CHY_INLINE lucy_Token*
Lucy_Inversion_Next(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Next_OFFSET;
    const lucy_Inversion_next_t method = *((lucy_Inversion_next_t*)method_address);
    return method((lucy_Inversion*)self);
}

extern size_t Lucy_Inversion_Reset_OFFSET;
static CHY_INLINE void
Lucy_Inversion_Reset(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Reset_OFFSET;
    const lucy_Inversion_reset_t method = *((lucy_Inversion_reset_t*)method_address);
    method((lucy_Inversion*)self);
}

extern size_t Lucy_Inversion_Invert_OFFSET;
static CHY_INLINE void
Lucy_Inversion_Invert(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Invert_OFFSET;
    const lucy_Inversion_invert_t method = *((lucy_Inversion_invert_t*)method_address);
    method((lucy_Inversion*)self);
}

extern size_t Lucy_Inversion_Next_Cluster_OFFSET;
static CHY_INLINE lucy_Token**
Lucy_Inversion_Next_Cluster(const lucy_Inversion *self, uint32_t* count) {
    char *const method_address = *(char**)self + Lucy_Inversion_Next_Cluster_OFFSET;
    const lucy_Inversion_next_cluster_t method = *((lucy_Inversion_next_cluster_t*)method_address);
    return method((lucy_Inversion*)self, count);
}

extern size_t Lucy_Inversion_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_Inversion_Get_Size(const lucy_Inversion *self) {
    char *const method_address = *(char**)self + Lucy_Inversion_Get_Size_OFFSET;
    const lucy_Inversion_get_size_t method = *((lucy_Inversion_get_size_t*)method_address);
    return method((lucy_Inversion*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INVERSION_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_INVERSION_VT;
extern struct LUCY_INVERSION_VT LUCY_INVERSION_vt;
#define LUCY_INVERSION ((cfish_VTable*)&LUCY_INVERSION_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Inversion lucy_Inversion
  #define INVERSION LUCY_INVERSION
  #define Inversion_new lucy_Inversion_new
  #define Inversion_destroy_t lucy_Inversion_destroy_t
  #define Inversion_destroy lucy_Inversion_destroy
  #define Inversion_append_t lucy_Inversion_append_t
  #define Inversion_append lucy_Inversion_append
  #define Inversion_next_t lucy_Inversion_next_t
  #define Inversion_next lucy_Inversion_next
  #define Inversion_reset_t lucy_Inversion_reset_t
  #define Inversion_reset lucy_Inversion_reset
  #define Inversion_invert_t lucy_Inversion_invert_t
  #define Inversion_invert lucy_Inversion_invert
  #define Inversion_next_cluster_t lucy_Inversion_next_cluster_t
  #define Inversion_next_cluster lucy_Inversion_next_cluster
  #define Inversion_get_size_t lucy_Inversion_get_size_t
  #define Inversion_get_size lucy_Inversion_get_size
  #define Inversion_Make Lucy_Inversion_Make
  #define Inversion_Get_RefCount Lucy_Inversion_Get_RefCount
  #define Inversion_Inc_RefCount Lucy_Inversion_Inc_RefCount
  #define Inversion_Dec_RefCount Lucy_Inversion_Dec_RefCount
  #define Inversion_To_Host Lucy_Inversion_To_Host
  #define Inversion_Clone Lucy_Inversion_Clone
  #define Inversion_Destroy Lucy_Inversion_Destroy
  #define Inversion_Equals Lucy_Inversion_Equals
  #define Inversion_Compare_To Lucy_Inversion_Compare_To
  #define Inversion_Hash_Sum Lucy_Inversion_Hash_Sum
  #define Inversion_Get_VTable Lucy_Inversion_Get_VTable
  #define Inversion_Get_Class_Name Lucy_Inversion_Get_Class_Name
  #define Inversion_Is_A Lucy_Inversion_Is_A
  #define Inversion_To_String Lucy_Inversion_To_String
  #define Inversion_To_I64 Lucy_Inversion_To_I64
  #define Inversion_To_F64 Lucy_Inversion_To_F64
  #define Inversion_To_Bool Lucy_Inversion_To_Bool
  #define Inversion_Serialize Lucy_Inversion_Serialize
  #define Inversion_Deserialize Lucy_Inversion_Deserialize
  #define Inversion_Dump Lucy_Inversion_Dump
  #define Inversion_Load Lucy_Inversion_Load
  #define Inversion_Mimic Lucy_Inversion_Mimic
  #define Inversion_Append Lucy_Inversion_Append
  #define Inversion_Next Lucy_Inversion_Next
  #define Inversion_Reset Lucy_Inversion_Reset
  #define Inversion_Invert Lucy_Inversion_Invert
  #define Inversion_Next_Cluster Lucy_Inversion_Next_Cluster
  #define Inversion_Get_Size Lucy_Inversion_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_INVERSION */




