/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_NORMALIZER
#define H_LUCY_ANALYSIS_NORMALIZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_NORMALIZER
struct lucy_Normalizer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int options;
};

#endif /* C_LUCY_NORMALIZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Normalizer*
lucy_Normalizer_new(const lucy_CharBuf* normalization_form, chy_bool_t case_fold, chy_bool_t strip_accents);

lucy_Normalizer*
lucy_Normalizer_init(lucy_Normalizer* self, const lucy_CharBuf* normalization_form, chy_bool_t case_fold, chy_bool_t strip_accents);

chy_bool_t
lucy_Normalizer_equals(lucy_Normalizer* self, lucy_Obj* other);

lucy_Hash*
lucy_Normalizer_dump(lucy_Normalizer* self);

lucy_Normalizer*
lucy_Normalizer_load(lucy_Normalizer* self, lucy_Obj* dump);

lucy_Inversion*
lucy_Normalizer_transform(lucy_Normalizer* self, lucy_Inversion* inversion);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Normalizer_equals_CALLBACK;
extern cfish_Callback lucy_Normalizer_dump_CALLBACK;
extern cfish_Callback lucy_Normalizer_load_CALLBACK;
extern cfish_Callback lucy_Normalizer_transform_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_Normalizer_equals_t)(lucy_Normalizer* self, lucy_Obj* other);

typedef lucy_Hash*
(*lucy_Normalizer_dump_t)(lucy_Normalizer* self);

typedef lucy_Normalizer*
(*lucy_Normalizer_load_t)(lucy_Normalizer* self, lucy_Obj* dump);

typedef lucy_Inversion*
(*lucy_Normalizer_transform_t)(lucy_Normalizer* self, lucy_Inversion* inversion);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Normalizer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Normalizer_Make(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Normalizer_Get_RefCount(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Normalizer_Inc_RefCount(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Normalizer_Dec_RefCount(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Normalizer_To_Host(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Normalizer_Clone(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Normalizer_Destroy(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Normalizer_Equals(const lucy_Normalizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Equals_OFFSET;
    const lucy_Normalizer_equals_t method = *((lucy_Normalizer_equals_t*)method_address);
    return method((lucy_Normalizer*)self, other);
}

extern size_t Lucy_Normalizer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Normalizer_Compare_To(const lucy_Normalizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Normalizer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Normalizer_Hash_Sum(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Normalizer_Get_VTable(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Normalizer_Get_Class_Name(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Normalizer_Is_A(const lucy_Normalizer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Normalizer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Normalizer_To_String(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Normalizer_To_I64(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Normalizer_To_F64(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Normalizer_To_Bool(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Normalizer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Normalizer_Serialize(const lucy_Normalizer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Normalizer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Normalizer_Deserialize(const lucy_Normalizer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Normalizer_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_Normalizer_Dump(const lucy_Normalizer *self) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Dump_OFFSET;
    const lucy_Normalizer_dump_t method = *((lucy_Normalizer_dump_t*)method_address);
    return method((lucy_Normalizer*)self);
}

extern size_t Lucy_Normalizer_Load_OFFSET;
static CHY_INLINE lucy_Normalizer*
Lucy_Normalizer_Load(const lucy_Normalizer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Load_OFFSET;
    const lucy_Normalizer_load_t method = *((lucy_Normalizer_load_t*)method_address);
    return method((lucy_Normalizer*)self, dump);
}

extern size_t Lucy_Normalizer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Normalizer_Mimic(const lucy_Normalizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Normalizer_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_Normalizer_Transform(const lucy_Normalizer *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Transform_OFFSET;
    const lucy_Normalizer_transform_t method = *((lucy_Normalizer_transform_t*)method_address);
    return method((lucy_Normalizer*)self, inversion);
}

extern size_t Lucy_Normalizer_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_Normalizer_Transform_Text(const lucy_Normalizer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Transform_Text_OFFSET;
    const lucy_Analyzer_transform_text_t method = *((lucy_Analyzer_transform_text_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}

extern size_t Lucy_Normalizer_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Normalizer_Split(const lucy_Normalizer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_Normalizer_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_NORMALIZER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_NORMALIZER_VT;
extern struct LUCY_NORMALIZER_VT LUCY_NORMALIZER_vt;
#define LUCY_NORMALIZER ((cfish_VTable*)&LUCY_NORMALIZER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Normalizer lucy_Normalizer
  #define NORMALIZER LUCY_NORMALIZER
  #define Normalizer_new lucy_Normalizer_new
  #define Normalizer_init lucy_Normalizer_init
  #define Normalizer_equals_t lucy_Normalizer_equals_t
  #define Normalizer_equals lucy_Normalizer_equals
  #define Normalizer_dump_t lucy_Normalizer_dump_t
  #define Normalizer_dump lucy_Normalizer_dump
  #define Normalizer_load_t lucy_Normalizer_load_t
  #define Normalizer_load lucy_Normalizer_load
  #define Normalizer_transform_t lucy_Normalizer_transform_t
  #define Normalizer_transform lucy_Normalizer_transform
  #define Normalizer_Make Lucy_Normalizer_Make
  #define Normalizer_Get_RefCount Lucy_Normalizer_Get_RefCount
  #define Normalizer_Inc_RefCount Lucy_Normalizer_Inc_RefCount
  #define Normalizer_Dec_RefCount Lucy_Normalizer_Dec_RefCount
  #define Normalizer_To_Host Lucy_Normalizer_To_Host
  #define Normalizer_Clone Lucy_Normalizer_Clone
  #define Normalizer_Destroy Lucy_Normalizer_Destroy
  #define Normalizer_Equals Lucy_Normalizer_Equals
  #define Normalizer_Compare_To Lucy_Normalizer_Compare_To
  #define Normalizer_Hash_Sum Lucy_Normalizer_Hash_Sum
  #define Normalizer_Get_VTable Lucy_Normalizer_Get_VTable
  #define Normalizer_Get_Class_Name Lucy_Normalizer_Get_Class_Name
  #define Normalizer_Is_A Lucy_Normalizer_Is_A
  #define Normalizer_To_String Lucy_Normalizer_To_String
  #define Normalizer_To_I64 Lucy_Normalizer_To_I64
  #define Normalizer_To_F64 Lucy_Normalizer_To_F64
  #define Normalizer_To_Bool Lucy_Normalizer_To_Bool
  #define Normalizer_Serialize Lucy_Normalizer_Serialize
  #define Normalizer_Deserialize Lucy_Normalizer_Deserialize
  #define Normalizer_Dump Lucy_Normalizer_Dump
  #define Normalizer_Load Lucy_Normalizer_Load
  #define Normalizer_Mimic Lucy_Normalizer_Mimic
  #define Normalizer_Transform Lucy_Normalizer_Transform
  #define Normalizer_Transform_Text Lucy_Normalizer_Transform_Text
  #define Normalizer_Split Lucy_Normalizer_Split
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_NORMALIZER */




