/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_POLYANALYZER
#define H_LUCY_ANALYSIS_POLYANALYZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYANALYZER
struct lucy_PolyAnalyzer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* analyzers;
};

#endif /* C_LUCY_POLYANALYZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyAnalyzer*
lucy_PolyAnalyzer_new(const lucy_CharBuf* language, lucy_VArray* analyzers);

lucy_PolyAnalyzer*
lucy_PolyAnalyzer_init(lucy_PolyAnalyzer* self, const lucy_CharBuf* language, lucy_VArray* analyzers);

void
lucy_PolyAnalyzer_destroy(lucy_PolyAnalyzer* self);

chy_bool_t
lucy_PolyAnalyzer_equals(lucy_PolyAnalyzer* self, lucy_Obj* other);

lucy_Obj*
lucy_PolyAnalyzer_dump(lucy_PolyAnalyzer* self);

lucy_PolyAnalyzer*
lucy_PolyAnalyzer_load(lucy_PolyAnalyzer* self, lucy_Obj* dump);

lucy_Inversion*
lucy_PolyAnalyzer_transform(lucy_PolyAnalyzer* self, lucy_Inversion* inversion);

lucy_Inversion*
lucy_PolyAnalyzer_transform_text(lucy_PolyAnalyzer* self, lucy_CharBuf* text);

lucy_VArray*
lucy_PolyAnalyzer_get_analyzers(lucy_PolyAnalyzer* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyAnalyzer_destroy_CALLBACK;
extern cfish_Callback lucy_PolyAnalyzer_equals_CALLBACK;
extern cfish_Callback lucy_PolyAnalyzer_dump_CALLBACK;
extern cfish_Callback lucy_PolyAnalyzer_load_CALLBACK;
extern cfish_Callback lucy_PolyAnalyzer_transform_CALLBACK;
extern cfish_Callback lucy_PolyAnalyzer_transform_text_CALLBACK;
extern cfish_Callback lucy_PolyAnalyzer_get_analyzers_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyAnalyzer_destroy_t)(lucy_PolyAnalyzer* self);

typedef chy_bool_t
(*lucy_PolyAnalyzer_equals_t)(lucy_PolyAnalyzer* self, lucy_Obj* other);

typedef lucy_Obj*
(*lucy_PolyAnalyzer_dump_t)(lucy_PolyAnalyzer* self);

typedef lucy_PolyAnalyzer*
(*lucy_PolyAnalyzer_load_t)(lucy_PolyAnalyzer* self, lucy_Obj* dump);

typedef lucy_Inversion*
(*lucy_PolyAnalyzer_transform_t)(lucy_PolyAnalyzer* self, lucy_Inversion* inversion);

typedef lucy_Inversion*
(*lucy_PolyAnalyzer_transform_text_t)(lucy_PolyAnalyzer* self, lucy_CharBuf* text);

typedef lucy_VArray*
(*lucy_PolyAnalyzer_get_analyzers_t)(lucy_PolyAnalyzer* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyAnalyzer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyAnalyzer_Make(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyAnalyzer_Get_RefCount(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyAnalyzer_Inc_RefCount(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyAnalyzer_Dec_RefCount(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyAnalyzer_To_Host(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyAnalyzer_Clone(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyAnalyzer_Destroy(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Destroy_OFFSET;
    const lucy_PolyAnalyzer_destroy_t method = *((lucy_PolyAnalyzer_destroy_t*)method_address);
    method((lucy_PolyAnalyzer*)self);
}

extern size_t Lucy_PolyAnalyzer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyAnalyzer_Equals(const lucy_PolyAnalyzer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Equals_OFFSET;
    const lucy_PolyAnalyzer_equals_t method = *((lucy_PolyAnalyzer_equals_t*)method_address);
    return method((lucy_PolyAnalyzer*)self, other);
}

extern size_t Lucy_PolyAnalyzer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyAnalyzer_Compare_To(const lucy_PolyAnalyzer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyAnalyzer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyAnalyzer_Hash_Sum(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyAnalyzer_Get_VTable(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyAnalyzer_Get_Class_Name(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyAnalyzer_Is_A(const lucy_PolyAnalyzer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyAnalyzer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyAnalyzer_To_String(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyAnalyzer_To_I64(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyAnalyzer_To_F64(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyAnalyzer_To_Bool(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyAnalyzer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyAnalyzer_Serialize(const lucy_PolyAnalyzer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyAnalyzer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyAnalyzer_Deserialize(const lucy_PolyAnalyzer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyAnalyzer_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyAnalyzer_Dump(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Dump_OFFSET;
    const lucy_PolyAnalyzer_dump_t method = *((lucy_PolyAnalyzer_dump_t*)method_address);
    return method((lucy_PolyAnalyzer*)self);
}

extern size_t Lucy_PolyAnalyzer_Load_OFFSET;
static CHY_INLINE lucy_PolyAnalyzer*
Lucy_PolyAnalyzer_Load(const lucy_PolyAnalyzer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Load_OFFSET;
    const lucy_PolyAnalyzer_load_t method = *((lucy_PolyAnalyzer_load_t*)method_address);
    return method((lucy_PolyAnalyzer*)self, dump);
}

extern size_t Lucy_PolyAnalyzer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyAnalyzer_Mimic(const lucy_PolyAnalyzer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyAnalyzer_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_PolyAnalyzer_Transform(const lucy_PolyAnalyzer *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Transform_OFFSET;
    const lucy_PolyAnalyzer_transform_t method = *((lucy_PolyAnalyzer_transform_t*)method_address);
    return method((lucy_PolyAnalyzer*)self, inversion);
}

extern size_t Lucy_PolyAnalyzer_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_PolyAnalyzer_Transform_Text(const lucy_PolyAnalyzer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Transform_Text_OFFSET;
    const lucy_PolyAnalyzer_transform_text_t method = *((lucy_PolyAnalyzer_transform_text_t*)method_address);
    return method((lucy_PolyAnalyzer*)self, text);
}

extern size_t Lucy_PolyAnalyzer_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyAnalyzer_Split(const lucy_PolyAnalyzer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}

extern size_t Lucy_PolyAnalyzer_Get_Analyzers_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyAnalyzer_Get_Analyzers(const lucy_PolyAnalyzer *self) {
    char *const method_address = *(char**)self + Lucy_PolyAnalyzer_Get_Analyzers_OFFSET;
    const lucy_PolyAnalyzer_get_analyzers_t method = *((lucy_PolyAnalyzer_get_analyzers_t*)method_address);
    return method((lucy_PolyAnalyzer*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYANALYZER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[26];
} LUCY_POLYANALYZER_VT;
extern struct LUCY_POLYANALYZER_VT LUCY_POLYANALYZER_vt;
#define LUCY_POLYANALYZER ((cfish_VTable*)&LUCY_POLYANALYZER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyAnalyzer lucy_PolyAnalyzer
  #define POLYANALYZER LUCY_POLYANALYZER
  #define PolyAnalyzer_new lucy_PolyAnalyzer_new
  #define PolyAnalyzer_init lucy_PolyAnalyzer_init
  #define PolyAnalyzer_destroy_t lucy_PolyAnalyzer_destroy_t
  #define PolyAnalyzer_destroy lucy_PolyAnalyzer_destroy
  #define PolyAnalyzer_equals_t lucy_PolyAnalyzer_equals_t
  #define PolyAnalyzer_equals lucy_PolyAnalyzer_equals
  #define PolyAnalyzer_dump_t lucy_PolyAnalyzer_dump_t
  #define PolyAnalyzer_dump lucy_PolyAnalyzer_dump
  #define PolyAnalyzer_load_t lucy_PolyAnalyzer_load_t
  #define PolyAnalyzer_load lucy_PolyAnalyzer_load
  #define PolyAnalyzer_transform_t lucy_PolyAnalyzer_transform_t
  #define PolyAnalyzer_transform lucy_PolyAnalyzer_transform
  #define PolyAnalyzer_transform_text_t lucy_PolyAnalyzer_transform_text_t
  #define PolyAnalyzer_transform_text lucy_PolyAnalyzer_transform_text
  #define PolyAnalyzer_get_analyzers_t lucy_PolyAnalyzer_get_analyzers_t
  #define PolyAnalyzer_get_analyzers lucy_PolyAnalyzer_get_analyzers
  #define PolyAnalyzer_Make Lucy_PolyAnalyzer_Make
  #define PolyAnalyzer_Get_RefCount Lucy_PolyAnalyzer_Get_RefCount
  #define PolyAnalyzer_Inc_RefCount Lucy_PolyAnalyzer_Inc_RefCount
  #define PolyAnalyzer_Dec_RefCount Lucy_PolyAnalyzer_Dec_RefCount
  #define PolyAnalyzer_To_Host Lucy_PolyAnalyzer_To_Host
  #define PolyAnalyzer_Clone Lucy_PolyAnalyzer_Clone
  #define PolyAnalyzer_Destroy Lucy_PolyAnalyzer_Destroy
  #define PolyAnalyzer_Equals Lucy_PolyAnalyzer_Equals
  #define PolyAnalyzer_Compare_To Lucy_PolyAnalyzer_Compare_To
  #define PolyAnalyzer_Hash_Sum Lucy_PolyAnalyzer_Hash_Sum
  #define PolyAnalyzer_Get_VTable Lucy_PolyAnalyzer_Get_VTable
  #define PolyAnalyzer_Get_Class_Name Lucy_PolyAnalyzer_Get_Class_Name
  #define PolyAnalyzer_Is_A Lucy_PolyAnalyzer_Is_A
  #define PolyAnalyzer_To_String Lucy_PolyAnalyzer_To_String
  #define PolyAnalyzer_To_I64 Lucy_PolyAnalyzer_To_I64
  #define PolyAnalyzer_To_F64 Lucy_PolyAnalyzer_To_F64
  #define PolyAnalyzer_To_Bool Lucy_PolyAnalyzer_To_Bool
  #define PolyAnalyzer_Serialize Lucy_PolyAnalyzer_Serialize
  #define PolyAnalyzer_Deserialize Lucy_PolyAnalyzer_Deserialize
  #define PolyAnalyzer_Dump Lucy_PolyAnalyzer_Dump
  #define PolyAnalyzer_Load Lucy_PolyAnalyzer_Load
  #define PolyAnalyzer_Mimic Lucy_PolyAnalyzer_Mimic
  #define PolyAnalyzer_Transform Lucy_PolyAnalyzer_Transform
  #define PolyAnalyzer_Transform_Text Lucy_PolyAnalyzer_Transform_Text
  #define PolyAnalyzer_Split Lucy_PolyAnalyzer_Split
  #define PolyAnalyzer_Get_Analyzers Lucy_PolyAnalyzer_Get_Analyzers
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_POLYANALYZER */




