/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_REGEXTOKENIZER
#define H_LUCY_ANALYSIS_REGEXTOKENIZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_REGEXTOKENIZER
struct lucy_RegexTokenizer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* pattern;
    void* token_re;
};

#endif /* C_LUCY_REGEXTOKENIZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RegexTokenizer*
lucy_RegexTokenizer_new(const lucy_CharBuf* pattern);

lucy_RegexTokenizer*
lucy_RegexTokenizer_init(lucy_RegexTokenizer* self, const lucy_CharBuf* pattern);

void
lucy_RegexTokenizer_destroy(lucy_RegexTokenizer* self);

chy_bool_t
lucy_RegexTokenizer_equals(lucy_RegexTokenizer* self, lucy_Obj* other);

lucy_Obj*
lucy_RegexTokenizer_dump(lucy_RegexTokenizer* self);

lucy_RegexTokenizer*
lucy_RegexTokenizer_load(lucy_RegexTokenizer* self, lucy_Obj* dump);

lucy_Inversion*
lucy_RegexTokenizer_transform(lucy_RegexTokenizer* self, lucy_Inversion* inversion);

lucy_Inversion*
lucy_RegexTokenizer_transform_text(lucy_RegexTokenizer* self, lucy_CharBuf* text);

void
lucy_RegexTokenizer_tokenize_str(lucy_RegexTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);

void
lucy_RegexTokenizer_set_token_re(lucy_RegexTokenizer* self, void* token_re);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RegexTokenizer_destroy_CALLBACK;
extern cfish_Callback lucy_RegexTokenizer_equals_CALLBACK;
extern cfish_Callback lucy_RegexTokenizer_dump_CALLBACK;
extern cfish_Callback lucy_RegexTokenizer_load_CALLBACK;
extern cfish_Callback lucy_RegexTokenizer_transform_CALLBACK;
extern cfish_Callback lucy_RegexTokenizer_transform_text_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RegexTokenizer_destroy_t)(lucy_RegexTokenizer* self);

typedef chy_bool_t
(*lucy_RegexTokenizer_equals_t)(lucy_RegexTokenizer* self, lucy_Obj* other);

typedef lucy_Obj*
(*lucy_RegexTokenizer_dump_t)(lucy_RegexTokenizer* self);

typedef lucy_RegexTokenizer*
(*lucy_RegexTokenizer_load_t)(lucy_RegexTokenizer* self, lucy_Obj* dump);

typedef lucy_Inversion*
(*lucy_RegexTokenizer_transform_t)(lucy_RegexTokenizer* self, lucy_Inversion* inversion);

typedef lucy_Inversion*
(*lucy_RegexTokenizer_transform_text_t)(lucy_RegexTokenizer* self, lucy_CharBuf* text);

typedef void
(*lucy_RegexTokenizer_tokenize_str_t)(lucy_RegexTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);

typedef void
(*lucy_RegexTokenizer_set_token_re_t)(lucy_RegexTokenizer* self, void* token_re);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RegexTokenizer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RegexTokenizer_Make(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RegexTokenizer_Get_RefCount(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RegexTokenizer_Inc_RefCount(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RegexTokenizer_Dec_RefCount(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RegexTokenizer_To_Host(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RegexTokenizer_Clone(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RegexTokenizer_Destroy(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Destroy_OFFSET;
    const lucy_RegexTokenizer_destroy_t method = *((lucy_RegexTokenizer_destroy_t*)method_address);
    method((lucy_RegexTokenizer*)self);
}

extern size_t Lucy_RegexTokenizer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RegexTokenizer_Equals(const lucy_RegexTokenizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Equals_OFFSET;
    const lucy_RegexTokenizer_equals_t method = *((lucy_RegexTokenizer_equals_t*)method_address);
    return method((lucy_RegexTokenizer*)self, other);
}

extern size_t Lucy_RegexTokenizer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RegexTokenizer_Compare_To(const lucy_RegexTokenizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RegexTokenizer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RegexTokenizer_Hash_Sum(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RegexTokenizer_Get_VTable(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RegexTokenizer_Get_Class_Name(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RegexTokenizer_Is_A(const lucy_RegexTokenizer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RegexTokenizer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RegexTokenizer_To_String(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RegexTokenizer_To_I64(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RegexTokenizer_To_F64(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RegexTokenizer_To_Bool(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RegexTokenizer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RegexTokenizer_Serialize(const lucy_RegexTokenizer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RegexTokenizer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RegexTokenizer_Deserialize(const lucy_RegexTokenizer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RegexTokenizer_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RegexTokenizer_Dump(const lucy_RegexTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Dump_OFFSET;
    const lucy_RegexTokenizer_dump_t method = *((lucy_RegexTokenizer_dump_t*)method_address);
    return method((lucy_RegexTokenizer*)self);
}

extern size_t Lucy_RegexTokenizer_Load_OFFSET;
static CHY_INLINE lucy_RegexTokenizer*
Lucy_RegexTokenizer_Load(const lucy_RegexTokenizer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Load_OFFSET;
    const lucy_RegexTokenizer_load_t method = *((lucy_RegexTokenizer_load_t*)method_address);
    return method((lucy_RegexTokenizer*)self, dump);
}

extern size_t Lucy_RegexTokenizer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RegexTokenizer_Mimic(const lucy_RegexTokenizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RegexTokenizer_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_RegexTokenizer_Transform(const lucy_RegexTokenizer *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Transform_OFFSET;
    const lucy_RegexTokenizer_transform_t method = *((lucy_RegexTokenizer_transform_t*)method_address);
    return method((lucy_RegexTokenizer*)self, inversion);
}

extern size_t Lucy_RegexTokenizer_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_RegexTokenizer_Transform_Text(const lucy_RegexTokenizer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Transform_Text_OFFSET;
    const lucy_RegexTokenizer_transform_text_t method = *((lucy_RegexTokenizer_transform_text_t*)method_address);
    return method((lucy_RegexTokenizer*)self, text);
}

extern size_t Lucy_RegexTokenizer_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_RegexTokenizer_Split(const lucy_RegexTokenizer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}

extern size_t Lucy_RegexTokenizer_Tokenize_Str_OFFSET;
static CHY_INLINE void
Lucy_RegexTokenizer_Tokenize_Str(const lucy_RegexTokenizer *self, const char* text, size_t len, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Tokenize_Str_OFFSET;
    const lucy_RegexTokenizer_tokenize_str_t method = *((lucy_RegexTokenizer_tokenize_str_t*)method_address);
    method((lucy_RegexTokenizer*)self, text, len, inversion);
}

extern size_t Lucy_RegexTokenizer_Set_Token_RE_OFFSET;
static CHY_INLINE void
Lucy_RegexTokenizer_Set_Token_RE(const lucy_RegexTokenizer *self, void* token_re) {
    char *const method_address = *(char**)self + Lucy_RegexTokenizer_Set_Token_RE_OFFSET;
    const lucy_RegexTokenizer_set_token_re_t method = *((lucy_RegexTokenizer_set_token_re_t*)method_address);
    method((lucy_RegexTokenizer*)self, token_re);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_REGEXTOKENIZER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_REGEXTOKENIZER_VT;
extern struct LUCY_REGEXTOKENIZER_VT LUCY_REGEXTOKENIZER_vt;
#define LUCY_REGEXTOKENIZER ((cfish_VTable*)&LUCY_REGEXTOKENIZER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RegexTokenizer lucy_RegexTokenizer
  #define REGEXTOKENIZER LUCY_REGEXTOKENIZER
  #define RegexTokenizer_new lucy_RegexTokenizer_new
  #define RegexTokenizer_init lucy_RegexTokenizer_init
  #define RegexTokenizer_destroy_t lucy_RegexTokenizer_destroy_t
  #define RegexTokenizer_destroy lucy_RegexTokenizer_destroy
  #define RegexTokenizer_equals_t lucy_RegexTokenizer_equals_t
  #define RegexTokenizer_equals lucy_RegexTokenizer_equals
  #define RegexTokenizer_dump_t lucy_RegexTokenizer_dump_t
  #define RegexTokenizer_dump lucy_RegexTokenizer_dump
  #define RegexTokenizer_load_t lucy_RegexTokenizer_load_t
  #define RegexTokenizer_load lucy_RegexTokenizer_load
  #define RegexTokenizer_transform_t lucy_RegexTokenizer_transform_t
  #define RegexTokenizer_transform lucy_RegexTokenizer_transform
  #define RegexTokenizer_transform_text_t lucy_RegexTokenizer_transform_text_t
  #define RegexTokenizer_transform_text lucy_RegexTokenizer_transform_text
  #define RegexTokenizer_tokenize_str_t lucy_RegexTokenizer_tokenize_str_t
  #define RegexTokenizer_tokenize_str lucy_RegexTokenizer_tokenize_str
  #define RegexTokenizer_set_token_re_t lucy_RegexTokenizer_set_token_re_t
  #define RegexTokenizer_set_token_re lucy_RegexTokenizer_set_token_re
  #define RegexTokenizer_Make Lucy_RegexTokenizer_Make
  #define RegexTokenizer_Get_RefCount Lucy_RegexTokenizer_Get_RefCount
  #define RegexTokenizer_Inc_RefCount Lucy_RegexTokenizer_Inc_RefCount
  #define RegexTokenizer_Dec_RefCount Lucy_RegexTokenizer_Dec_RefCount
  #define RegexTokenizer_To_Host Lucy_RegexTokenizer_To_Host
  #define RegexTokenizer_Clone Lucy_RegexTokenizer_Clone
  #define RegexTokenizer_Destroy Lucy_RegexTokenizer_Destroy
  #define RegexTokenizer_Equals Lucy_RegexTokenizer_Equals
  #define RegexTokenizer_Compare_To Lucy_RegexTokenizer_Compare_To
  #define RegexTokenizer_Hash_Sum Lucy_RegexTokenizer_Hash_Sum
  #define RegexTokenizer_Get_VTable Lucy_RegexTokenizer_Get_VTable
  #define RegexTokenizer_Get_Class_Name Lucy_RegexTokenizer_Get_Class_Name
  #define RegexTokenizer_Is_A Lucy_RegexTokenizer_Is_A
  #define RegexTokenizer_To_String Lucy_RegexTokenizer_To_String
  #define RegexTokenizer_To_I64 Lucy_RegexTokenizer_To_I64
  #define RegexTokenizer_To_F64 Lucy_RegexTokenizer_To_F64
  #define RegexTokenizer_To_Bool Lucy_RegexTokenizer_To_Bool
  #define RegexTokenizer_Serialize Lucy_RegexTokenizer_Serialize
  #define RegexTokenizer_Deserialize Lucy_RegexTokenizer_Deserialize
  #define RegexTokenizer_Dump Lucy_RegexTokenizer_Dump
  #define RegexTokenizer_Load Lucy_RegexTokenizer_Load
  #define RegexTokenizer_Mimic Lucy_RegexTokenizer_Mimic
  #define RegexTokenizer_Transform Lucy_RegexTokenizer_Transform
  #define RegexTokenizer_Transform_Text Lucy_RegexTokenizer_Transform_Text
  #define RegexTokenizer_Split Lucy_RegexTokenizer_Split
  #define RegexTokenizer_Tokenize_Str Lucy_RegexTokenizer_Tokenize_Str
  #define RegexTokenizer_Set_Token_RE Lucy_RegexTokenizer_Set_Token_RE
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_REGEXTOKENIZER */




