/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_SNOWBALLSTEMMER
#define H_LUCY_ANALYSIS_SNOWBALLSTEMMER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SNOWBALLSTEMMER
struct lucy_SnowballStemmer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    void* snowstemmer;
    lucy_CharBuf* language;
};

#endif /* C_LUCY_SNOWBALLSTEMMER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SnowballStemmer*
lucy_SnowStemmer_new(const lucy_CharBuf* language);

lucy_SnowballStemmer*
lucy_SnowStemmer_init(lucy_SnowballStemmer* self, const lucy_CharBuf* language);

void
lucy_SnowStemmer_destroy(lucy_SnowballStemmer* self);

chy_bool_t
lucy_SnowStemmer_equals(lucy_SnowballStemmer* self, lucy_Obj* other);

lucy_Hash*
lucy_SnowStemmer_dump(lucy_SnowballStemmer* self);

lucy_SnowballStemmer*
lucy_SnowStemmer_load(lucy_SnowballStemmer* self, lucy_Obj* dump);

lucy_Inversion*
lucy_SnowStemmer_transform(lucy_SnowballStemmer* self, lucy_Inversion* inversion);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SnowStemmer_destroy_CALLBACK;
extern cfish_Callback lucy_SnowStemmer_equals_CALLBACK;
extern cfish_Callback lucy_SnowStemmer_dump_CALLBACK;
extern cfish_Callback lucy_SnowStemmer_load_CALLBACK;
extern cfish_Callback lucy_SnowStemmer_transform_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SnowStemmer_destroy_t)(lucy_SnowballStemmer* self);

typedef chy_bool_t
(*lucy_SnowStemmer_equals_t)(lucy_SnowballStemmer* self, lucy_Obj* other);

typedef lucy_Hash*
(*lucy_SnowStemmer_dump_t)(lucy_SnowballStemmer* self);

typedef lucy_SnowballStemmer*
(*lucy_SnowStemmer_load_t)(lucy_SnowballStemmer* self, lucy_Obj* dump);

typedef lucy_Inversion*
(*lucy_SnowStemmer_transform_t)(lucy_SnowballStemmer* self, lucy_Inversion* inversion);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SnowStemmer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStemmer_Make(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SnowStemmer_Get_RefCount(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStemmer_Inc_RefCount(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SnowStemmer_Dec_RefCount(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SnowStemmer_To_Host(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStemmer_Clone(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SnowStemmer_Destroy(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Destroy_OFFSET;
    const lucy_SnowStemmer_destroy_t method = *((lucy_SnowStemmer_destroy_t*)method_address);
    method((lucy_SnowballStemmer*)self);
}

extern size_t Lucy_SnowStemmer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SnowStemmer_Equals(const lucy_SnowballStemmer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Equals_OFFSET;
    const lucy_SnowStemmer_equals_t method = *((lucy_SnowStemmer_equals_t*)method_address);
    return method((lucy_SnowballStemmer*)self, other);
}

extern size_t Lucy_SnowStemmer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SnowStemmer_Compare_To(const lucy_SnowballStemmer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SnowStemmer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SnowStemmer_Hash_Sum(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SnowStemmer_Get_VTable(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SnowStemmer_Get_Class_Name(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SnowStemmer_Is_A(const lucy_SnowballStemmer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SnowStemmer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SnowStemmer_To_String(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SnowStemmer_To_I64(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SnowStemmer_To_F64(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SnowStemmer_To_Bool(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStemmer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SnowStemmer_Serialize(const lucy_SnowballStemmer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SnowStemmer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStemmer_Deserialize(const lucy_SnowballStemmer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SnowStemmer_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_SnowStemmer_Dump(const lucy_SnowballStemmer *self) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Dump_OFFSET;
    const lucy_SnowStemmer_dump_t method = *((lucy_SnowStemmer_dump_t*)method_address);
    return method((lucy_SnowballStemmer*)self);
}

extern size_t Lucy_SnowStemmer_Load_OFFSET;
static CHY_INLINE lucy_SnowballStemmer*
Lucy_SnowStemmer_Load(const lucy_SnowballStemmer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Load_OFFSET;
    const lucy_SnowStemmer_load_t method = *((lucy_SnowStemmer_load_t*)method_address);
    return method((lucy_SnowballStemmer*)self, dump);
}

extern size_t Lucy_SnowStemmer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SnowStemmer_Mimic(const lucy_SnowballStemmer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SnowStemmer_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_SnowStemmer_Transform(const lucy_SnowballStemmer *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Transform_OFFSET;
    const lucy_SnowStemmer_transform_t method = *((lucy_SnowStemmer_transform_t*)method_address);
    return method((lucy_SnowballStemmer*)self, inversion);
}

extern size_t Lucy_SnowStemmer_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_SnowStemmer_Transform_Text(const lucy_SnowballStemmer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Transform_Text_OFFSET;
    const lucy_Analyzer_transform_text_t method = *((lucy_Analyzer_transform_text_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}

extern size_t Lucy_SnowStemmer_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SnowStemmer_Split(const lucy_SnowballStemmer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_SnowStemmer_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SNOWBALLSTEMMER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_SNOWBALLSTEMMER_VT;
extern struct LUCY_SNOWBALLSTEMMER_VT LUCY_SNOWBALLSTEMMER_vt;
#define LUCY_SNOWBALLSTEMMER ((cfish_VTable*)&LUCY_SNOWBALLSTEMMER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SnowballStemmer lucy_SnowballStemmer
  #define SNOWBALLSTEMMER LUCY_SNOWBALLSTEMMER
  #define SnowStemmer_new lucy_SnowStemmer_new
  #define SnowStemmer_init lucy_SnowStemmer_init
  #define SnowStemmer_destroy_t lucy_SnowStemmer_destroy_t
  #define SnowStemmer_destroy lucy_SnowStemmer_destroy
  #define SnowStemmer_equals_t lucy_SnowStemmer_equals_t
  #define SnowStemmer_equals lucy_SnowStemmer_equals
  #define SnowStemmer_dump_t lucy_SnowStemmer_dump_t
  #define SnowStemmer_dump lucy_SnowStemmer_dump
  #define SnowStemmer_load_t lucy_SnowStemmer_load_t
  #define SnowStemmer_load lucy_SnowStemmer_load
  #define SnowStemmer_transform_t lucy_SnowStemmer_transform_t
  #define SnowStemmer_transform lucy_SnowStemmer_transform
  #define SnowStemmer_Make Lucy_SnowStemmer_Make
  #define SnowStemmer_Get_RefCount Lucy_SnowStemmer_Get_RefCount
  #define SnowStemmer_Inc_RefCount Lucy_SnowStemmer_Inc_RefCount
  #define SnowStemmer_Dec_RefCount Lucy_SnowStemmer_Dec_RefCount
  #define SnowStemmer_To_Host Lucy_SnowStemmer_To_Host
  #define SnowStemmer_Clone Lucy_SnowStemmer_Clone
  #define SnowStemmer_Destroy Lucy_SnowStemmer_Destroy
  #define SnowStemmer_Equals Lucy_SnowStemmer_Equals
  #define SnowStemmer_Compare_To Lucy_SnowStemmer_Compare_To
  #define SnowStemmer_Hash_Sum Lucy_SnowStemmer_Hash_Sum
  #define SnowStemmer_Get_VTable Lucy_SnowStemmer_Get_VTable
  #define SnowStemmer_Get_Class_Name Lucy_SnowStemmer_Get_Class_Name
  #define SnowStemmer_Is_A Lucy_SnowStemmer_Is_A
  #define SnowStemmer_To_String Lucy_SnowStemmer_To_String
  #define SnowStemmer_To_I64 Lucy_SnowStemmer_To_I64
  #define SnowStemmer_To_F64 Lucy_SnowStemmer_To_F64
  #define SnowStemmer_To_Bool Lucy_SnowStemmer_To_Bool
  #define SnowStemmer_Serialize Lucy_SnowStemmer_Serialize
  #define SnowStemmer_Deserialize Lucy_SnowStemmer_Deserialize
  #define SnowStemmer_Dump Lucy_SnowStemmer_Dump
  #define SnowStemmer_Load Lucy_SnowStemmer_Load
  #define SnowStemmer_Mimic Lucy_SnowStemmer_Mimic
  #define SnowStemmer_Transform Lucy_SnowStemmer_Transform
  #define SnowStemmer_Transform_Text Lucy_SnowStemmer_Transform_Text
  #define SnowStemmer_Split Lucy_SnowStemmer_Split
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_SNOWBALLSTEMMER */




