/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_SNOWBALLSTOPFILTER
#define H_LUCY_ANALYSIS_SNOWBALLSTOPFILTER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SNOWBALLSTOPFILTER
struct lucy_SnowballStopFilter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Hash* stoplist;
};

#endif /* C_LUCY_SNOWBALLSTOPFILTER */

/* Declare this class's inert variables.
 */

extern const uint8_t** lucy_SnowStop_snow_da;
extern const uint8_t** lucy_SnowStop_snow_de;
extern const uint8_t** lucy_SnowStop_snow_en;
extern const uint8_t** lucy_SnowStop_snow_es;
extern const uint8_t** lucy_SnowStop_snow_fi;
extern const uint8_t** lucy_SnowStop_snow_fr;
extern const uint8_t** lucy_SnowStop_snow_hu;
extern const uint8_t** lucy_SnowStop_snow_it;
extern const uint8_t** lucy_SnowStop_snow_nl;
extern const uint8_t** lucy_SnowStop_snow_no;
extern const uint8_t** lucy_SnowStop_snow_pt;
extern const uint8_t** lucy_SnowStop_snow_ru;
extern const uint8_t** lucy_SnowStop_snow_sv;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SnowballStopFilter*
lucy_SnowStop_new(const lucy_CharBuf* language, lucy_Hash* stoplist);

lucy_SnowballStopFilter*
lucy_SnowStop_init(lucy_SnowballStopFilter* self, const lucy_CharBuf* language, lucy_Hash* stoplist);

lucy_Hash*
lucy_SnowStop_gen_stoplist(const lucy_CharBuf* language);

void
lucy_SnowStop_destroy(lucy_SnowballStopFilter* self);

chy_bool_t
lucy_SnowStop_equals(lucy_SnowballStopFilter* self, lucy_Obj* other);

lucy_Obj*
lucy_SnowStop_dump(lucy_SnowballStopFilter* self);

lucy_Obj*
lucy_SnowStop_load(lucy_SnowballStopFilter* self, lucy_Obj* dump);

lucy_Inversion*
lucy_SnowStop_transform(lucy_SnowballStopFilter* self, lucy_Inversion* inversion);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SnowStop_destroy_CALLBACK;
extern cfish_Callback lucy_SnowStop_equals_CALLBACK;
extern cfish_Callback lucy_SnowStop_dump_CALLBACK;
extern cfish_Callback lucy_SnowStop_load_CALLBACK;
extern cfish_Callback lucy_SnowStop_transform_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SnowStop_destroy_t)(lucy_SnowballStopFilter* self);

typedef chy_bool_t
(*lucy_SnowStop_equals_t)(lucy_SnowballStopFilter* self, lucy_Obj* other);

typedef lucy_Obj*
(*lucy_SnowStop_dump_t)(lucy_SnowballStopFilter* self);

typedef lucy_Obj*
(*lucy_SnowStop_load_t)(lucy_SnowballStopFilter* self, lucy_Obj* dump);

typedef lucy_Inversion*
(*lucy_SnowStop_transform_t)(lucy_SnowballStopFilter* self, lucy_Inversion* inversion);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SnowStop_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStop_Make(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SnowStop_Get_RefCount(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStop_Inc_RefCount(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SnowStop_Dec_RefCount(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SnowStop_To_Host(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStop_Clone(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SnowStop_Destroy(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Destroy_OFFSET;
    const lucy_SnowStop_destroy_t method = *((lucy_SnowStop_destroy_t*)method_address);
    method((lucy_SnowballStopFilter*)self);
}

extern size_t Lucy_SnowStop_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SnowStop_Equals(const lucy_SnowballStopFilter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Equals_OFFSET;
    const lucy_SnowStop_equals_t method = *((lucy_SnowStop_equals_t*)method_address);
    return method((lucy_SnowballStopFilter*)self, other);
}

extern size_t Lucy_SnowStop_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SnowStop_Compare_To(const lucy_SnowballStopFilter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SnowStop_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SnowStop_Hash_Sum(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SnowStop_Get_VTable(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SnowStop_Get_Class_Name(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SnowStop_Is_A(const lucy_SnowballStopFilter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SnowStop_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SnowStop_To_String(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SnowStop_To_I64(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SnowStop_To_F64(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SnowStop_To_Bool(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SnowStop_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SnowStop_Serialize(const lucy_SnowballStopFilter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SnowStop_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStop_Deserialize(const lucy_SnowballStopFilter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SnowStop_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStop_Dump(const lucy_SnowballStopFilter *self) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Dump_OFFSET;
    const lucy_SnowStop_dump_t method = *((lucy_SnowStop_dump_t*)method_address);
    return method((lucy_SnowballStopFilter*)self);
}

extern size_t Lucy_SnowStop_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SnowStop_Load(const lucy_SnowballStopFilter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Load_OFFSET;
    const lucy_SnowStop_load_t method = *((lucy_SnowStop_load_t*)method_address);
    return method((lucy_SnowballStopFilter*)self, dump);
}

extern size_t Lucy_SnowStop_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SnowStop_Mimic(const lucy_SnowballStopFilter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SnowStop_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_SnowStop_Transform(const lucy_SnowballStopFilter *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Transform_OFFSET;
    const lucy_SnowStop_transform_t method = *((lucy_SnowStop_transform_t*)method_address);
    return method((lucy_SnowballStopFilter*)self, inversion);
}

extern size_t Lucy_SnowStop_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_SnowStop_Transform_Text(const lucy_SnowballStopFilter *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Transform_Text_OFFSET;
    const lucy_Analyzer_transform_text_t method = *((lucy_Analyzer_transform_text_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}

extern size_t Lucy_SnowStop_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SnowStop_Split(const lucy_SnowballStopFilter *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_SnowStop_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SNOWBALLSTOPFILTER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_SNOWBALLSTOPFILTER_VT;
extern struct LUCY_SNOWBALLSTOPFILTER_VT LUCY_SNOWBALLSTOPFILTER_vt;
#define LUCY_SNOWBALLSTOPFILTER ((cfish_VTable*)&LUCY_SNOWBALLSTOPFILTER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SnowballStopFilter lucy_SnowballStopFilter
  #define SNOWBALLSTOPFILTER LUCY_SNOWBALLSTOPFILTER
  #define SnowStop_new lucy_SnowStop_new
  #define SnowStop_init lucy_SnowStop_init
  #define SnowStop_gen_stoplist lucy_SnowStop_gen_stoplist
  #define SnowStop_snow_da lucy_SnowStop_snow_da
  #define SnowStop_snow_de lucy_SnowStop_snow_de
  #define SnowStop_snow_en lucy_SnowStop_snow_en
  #define SnowStop_snow_es lucy_SnowStop_snow_es
  #define SnowStop_snow_fi lucy_SnowStop_snow_fi
  #define SnowStop_snow_fr lucy_SnowStop_snow_fr
  #define SnowStop_snow_hu lucy_SnowStop_snow_hu
  #define SnowStop_snow_it lucy_SnowStop_snow_it
  #define SnowStop_snow_nl lucy_SnowStop_snow_nl
  #define SnowStop_snow_no lucy_SnowStop_snow_no
  #define SnowStop_snow_pt lucy_SnowStop_snow_pt
  #define SnowStop_snow_ru lucy_SnowStop_snow_ru
  #define SnowStop_snow_sv lucy_SnowStop_snow_sv
  #define SnowStop_destroy_t lucy_SnowStop_destroy_t
  #define SnowStop_destroy lucy_SnowStop_destroy
  #define SnowStop_equals_t lucy_SnowStop_equals_t
  #define SnowStop_equals lucy_SnowStop_equals
  #define SnowStop_dump_t lucy_SnowStop_dump_t
  #define SnowStop_dump lucy_SnowStop_dump
  #define SnowStop_load_t lucy_SnowStop_load_t
  #define SnowStop_load lucy_SnowStop_load
  #define SnowStop_transform_t lucy_SnowStop_transform_t
  #define SnowStop_transform lucy_SnowStop_transform
  #define SnowStop_Make Lucy_SnowStop_Make
  #define SnowStop_Get_RefCount Lucy_SnowStop_Get_RefCount
  #define SnowStop_Inc_RefCount Lucy_SnowStop_Inc_RefCount
  #define SnowStop_Dec_RefCount Lucy_SnowStop_Dec_RefCount
  #define SnowStop_To_Host Lucy_SnowStop_To_Host
  #define SnowStop_Clone Lucy_SnowStop_Clone
  #define SnowStop_Destroy Lucy_SnowStop_Destroy
  #define SnowStop_Equals Lucy_SnowStop_Equals
  #define SnowStop_Compare_To Lucy_SnowStop_Compare_To
  #define SnowStop_Hash_Sum Lucy_SnowStop_Hash_Sum
  #define SnowStop_Get_VTable Lucy_SnowStop_Get_VTable
  #define SnowStop_Get_Class_Name Lucy_SnowStop_Get_Class_Name
  #define SnowStop_Is_A Lucy_SnowStop_Is_A
  #define SnowStop_To_String Lucy_SnowStop_To_String
  #define SnowStop_To_I64 Lucy_SnowStop_To_I64
  #define SnowStop_To_F64 Lucy_SnowStop_To_F64
  #define SnowStop_To_Bool Lucy_SnowStop_To_Bool
  #define SnowStop_Serialize Lucy_SnowStop_Serialize
  #define SnowStop_Deserialize Lucy_SnowStop_Deserialize
  #define SnowStop_Dump Lucy_SnowStop_Dump
  #define SnowStop_Load Lucy_SnowStop_Load
  #define SnowStop_Mimic Lucy_SnowStop_Mimic
  #define SnowStop_Transform Lucy_SnowStop_Transform
  #define SnowStop_Transform_Text Lucy_SnowStop_Transform_Text
  #define SnowStop_Split Lucy_SnowStop_Split
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Hash.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_NOCLONEHASH
struct lucy_NoCloneHash {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    void* entries;
    uint32_t capacity;
    uint32_t size;
    uint32_t threshold;
    int32_t iter_tick;
};

#endif /* C_LUCY_NOCLONEHASH */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_NoCloneHash*
lucy_NoCloneHash_new(uint32_t capacity);

lucy_NoCloneHash*
lucy_NoCloneHash_init(lucy_NoCloneHash* self, uint32_t capacity);

lucy_Obj*
lucy_NoCloneHash_make_key(lucy_NoCloneHash* self, lucy_Obj* key, int32_t hash_sum);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_NoCloneHash_make_key_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Obj*
(*lucy_NoCloneHash_make_key_t)(lucy_NoCloneHash* self, lucy_Obj* key, int32_t hash_sum);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_NoCloneHash_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Make(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NoCloneHash_Get_RefCount(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Inc_RefCount(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NoCloneHash_Dec_RefCount(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_NoCloneHash_To_Host(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Clone(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Destroy_OFFSET;
static CHY_INLINE void
Lucy_NoCloneHash_Destroy(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Destroy_OFFSET;
    const lucy_Hash_destroy_t method = *((lucy_Hash_destroy_t*)method_address);
    method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NoCloneHash_Equals(const lucy_NoCloneHash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Equals_OFFSET;
    const lucy_Hash_equals_t method = *((lucy_Hash_equals_t*)method_address);
    return method((lucy_Hash*)self, other);
}

extern size_t Lucy_NoCloneHash_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_NoCloneHash_Compare_To(const lucy_NoCloneHash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NoCloneHash_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_NoCloneHash_Hash_Sum(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_NoCloneHash_Get_VTable(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NoCloneHash_Get_Class_Name(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NoCloneHash_Is_A(const lucy_NoCloneHash *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_NoCloneHash_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NoCloneHash_To_String(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_NoCloneHash_To_I64(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_To_F64_OFFSET;
static CHY_INLINE double
Lucy_NoCloneHash_To_F64(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NoCloneHash_To_Bool(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NoCloneHash_Serialize_OFFSET;
static CHY_INLINE void
Lucy_NoCloneHash_Serialize(const lucy_NoCloneHash *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Serialize_OFFSET;
    const lucy_Hash_serialize_t method = *((lucy_Hash_serialize_t*)method_address);
    method((lucy_Hash*)self, outstream);
}

extern size_t Lucy_NoCloneHash_Deserialize_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_NoCloneHash_Deserialize(const lucy_NoCloneHash *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Deserialize_OFFSET;
    const lucy_Hash_deserialize_t method = *((lucy_Hash_deserialize_t*)method_address);
    return method((lucy_Hash*)self, instream);
}

extern size_t Lucy_NoCloneHash_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_NoCloneHash_Dump(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Dump_OFFSET;
    const lucy_Hash_dump_t method = *((lucy_Hash_dump_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Load(const lucy_NoCloneHash *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Load_OFFSET;
    const lucy_Hash_load_t method = *((lucy_Hash_load_t*)method_address);
    return method((lucy_Hash*)self, dump);
}

extern size_t Lucy_NoCloneHash_Mimic_OFFSET;
static CHY_INLINE void
Lucy_NoCloneHash_Mimic(const lucy_NoCloneHash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_NoCloneHash_Clear_OFFSET;
static CHY_INLINE void
Lucy_NoCloneHash_Clear(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Clear_OFFSET;
    const lucy_Hash_clear_t method = *((lucy_Hash_clear_t*)method_address);
    method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Store_OFFSET;
static CHY_INLINE void
Lucy_NoCloneHash_Store(const lucy_NoCloneHash *self, lucy_Obj* key, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Store_OFFSET;
    const lucy_Hash_store_t method = *((lucy_Hash_store_t*)method_address);
    method((lucy_Hash*)self, key, value);
}

extern size_t Lucy_NoCloneHash_Store_Str_OFFSET;
static CHY_INLINE void
Lucy_NoCloneHash_Store_Str(const lucy_NoCloneHash *self, const char* str, size_t len, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Store_Str_OFFSET;
    const lucy_Hash_store_str_t method = *((lucy_Hash_store_str_t*)method_address);
    method((lucy_Hash*)self, str, len, value);
}

extern size_t Lucy_NoCloneHash_Fetch_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Fetch(const lucy_NoCloneHash *self, const lucy_Obj* key) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Fetch_OFFSET;
    const lucy_Hash_fetch_t method = *((lucy_Hash_fetch_t*)method_address);
    return method((lucy_Hash*)self, key);
}

extern size_t Lucy_NoCloneHash_Fetch_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Fetch_Str(const lucy_NoCloneHash *self, const char* key, size_t key_len) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Fetch_Str_OFFSET;
    const lucy_Hash_fetch_str_t method = *((lucy_Hash_fetch_str_t*)method_address);
    return method((lucy_Hash*)self, key, key_len);
}

extern size_t Lucy_NoCloneHash_Delete_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Delete(const lucy_NoCloneHash *self, const lucy_Obj* key) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Delete_OFFSET;
    const lucy_Hash_delete_t method = *((lucy_Hash_delete_t*)method_address);
    return method((lucy_Hash*)self, key);
}

extern size_t Lucy_NoCloneHash_Delete_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Delete_Str(const lucy_NoCloneHash *self, const char* key, size_t key_ley) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Delete_Str_OFFSET;
    const lucy_Hash_delete_str_t method = *((lucy_Hash_delete_str_t*)method_address);
    return method((lucy_Hash*)self, key, key_ley);
}

extern size_t Lucy_NoCloneHash_Iterate_OFFSET;
static CHY_INLINE uint32_t
Lucy_NoCloneHash_Iterate(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Iterate_OFFSET;
    const lucy_Hash_iterate_t method = *((lucy_Hash_iterate_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NoCloneHash_Next(const lucy_NoCloneHash *self, lucy_Obj** key, lucy_Obj** value) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Next_OFFSET;
    const lucy_Hash_next_t method = *((lucy_Hash_next_t*)method_address);
    return method((lucy_Hash*)self, key, value);
}

extern size_t Lucy_NoCloneHash_Find_Key_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Find_Key(const lucy_NoCloneHash *self, const lucy_Obj* key, int32_t hash_sum) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Find_Key_OFFSET;
    const lucy_Hash_find_key_t method = *((lucy_Hash_find_key_t*)method_address);
    return method((lucy_Hash*)self, key, hash_sum);
}

extern size_t Lucy_NoCloneHash_Keys_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_NoCloneHash_Keys(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Keys_OFFSET;
    const lucy_Hash_keys_t method = *((lucy_Hash_keys_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Values_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_NoCloneHash_Values(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Values_OFFSET;
    const lucy_Hash_values_t method = *((lucy_Hash_values_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Make_Key_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NoCloneHash_Make_Key(const lucy_NoCloneHash *self, lucy_Obj* key, int32_t hash_sum) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Make_Key_OFFSET;
    const lucy_NoCloneHash_make_key_t method = *((lucy_NoCloneHash_make_key_t*)method_address);
    return method((lucy_NoCloneHash*)self, key, hash_sum);
}

extern size_t Lucy_NoCloneHash_Get_Capacity_OFFSET;
static CHY_INLINE uint32_t
Lucy_NoCloneHash_Get_Capacity(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Get_Capacity_OFFSET;
    const lucy_Hash_get_capacity_t method = *((lucy_Hash_get_capacity_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_NoCloneHash_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_NoCloneHash_Get_Size(const lucy_NoCloneHash *self) {
    char *const method_address = *(char**)self + Lucy_NoCloneHash_Get_Size_OFFSET;
    const lucy_Hash_get_size_t method = *((lucy_Hash_get_size_t*)method_address);
    return method((lucy_Hash*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_NOCLONEHASH_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_NOCLONEHASH_VT;
extern struct LUCY_NOCLONEHASH_VT LUCY_NOCLONEHASH_vt;
#define LUCY_NOCLONEHASH ((cfish_VTable*)&LUCY_NOCLONEHASH_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define NoCloneHash lucy_NoCloneHash
  #define NOCLONEHASH LUCY_NOCLONEHASH
  #define NoCloneHash_new lucy_NoCloneHash_new
  #define NoCloneHash_init lucy_NoCloneHash_init
  #define NoCloneHash_make_key_t lucy_NoCloneHash_make_key_t
  #define NoCloneHash_make_key lucy_NoCloneHash_make_key
  #define NoCloneHash_Make Lucy_NoCloneHash_Make
  #define NoCloneHash_Get_RefCount Lucy_NoCloneHash_Get_RefCount
  #define NoCloneHash_Inc_RefCount Lucy_NoCloneHash_Inc_RefCount
  #define NoCloneHash_Dec_RefCount Lucy_NoCloneHash_Dec_RefCount
  #define NoCloneHash_To_Host Lucy_NoCloneHash_To_Host
  #define NoCloneHash_Clone Lucy_NoCloneHash_Clone
  #define NoCloneHash_Destroy Lucy_NoCloneHash_Destroy
  #define NoCloneHash_Equals Lucy_NoCloneHash_Equals
  #define NoCloneHash_Compare_To Lucy_NoCloneHash_Compare_To
  #define NoCloneHash_Hash_Sum Lucy_NoCloneHash_Hash_Sum
  #define NoCloneHash_Get_VTable Lucy_NoCloneHash_Get_VTable
  #define NoCloneHash_Get_Class_Name Lucy_NoCloneHash_Get_Class_Name
  #define NoCloneHash_Is_A Lucy_NoCloneHash_Is_A
  #define NoCloneHash_To_String Lucy_NoCloneHash_To_String
  #define NoCloneHash_To_I64 Lucy_NoCloneHash_To_I64
  #define NoCloneHash_To_F64 Lucy_NoCloneHash_To_F64
  #define NoCloneHash_To_Bool Lucy_NoCloneHash_To_Bool
  #define NoCloneHash_Serialize Lucy_NoCloneHash_Serialize
  #define NoCloneHash_Deserialize Lucy_NoCloneHash_Deserialize
  #define NoCloneHash_Dump Lucy_NoCloneHash_Dump
  #define NoCloneHash_Load Lucy_NoCloneHash_Load
  #define NoCloneHash_Mimic Lucy_NoCloneHash_Mimic
  #define NoCloneHash_Clear Lucy_NoCloneHash_Clear
  #define NoCloneHash_Store Lucy_NoCloneHash_Store
  #define NoCloneHash_Store_Str Lucy_NoCloneHash_Store_Str
  #define NoCloneHash_Fetch Lucy_NoCloneHash_Fetch
  #define NoCloneHash_Fetch_Str Lucy_NoCloneHash_Fetch_Str
  #define NoCloneHash_Delete Lucy_NoCloneHash_Delete
  #define NoCloneHash_Delete_Str Lucy_NoCloneHash_Delete_Str
  #define NoCloneHash_Iterate Lucy_NoCloneHash_Iterate
  #define NoCloneHash_Next Lucy_NoCloneHash_Next
  #define NoCloneHash_Find_Key Lucy_NoCloneHash_Find_Key
  #define NoCloneHash_Keys Lucy_NoCloneHash_Keys
  #define NoCloneHash_Values Lucy_NoCloneHash_Values
  #define NoCloneHash_Make_Key Lucy_NoCloneHash_Make_Key
  #define NoCloneHash_Get_Capacity Lucy_NoCloneHash_Get_Capacity
  #define NoCloneHash_Get_Size Lucy_NoCloneHash_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_SNOWBALLSTOPFILTER */




