/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_STANDARDTOKENIZER
#define H_LUCY_ANALYSIS_STANDARDTOKENIZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_STANDARDTOKENIZER
struct lucy_StandardTokenizer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
};

#endif /* C_LUCY_STANDARDTOKENIZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_StandardTokenizer*
lucy_StandardTokenizer_new();

lucy_StandardTokenizer*
lucy_StandardTokenizer_init(lucy_StandardTokenizer* self);

chy_bool_t
lucy_StandardTokenizer_equals(lucy_StandardTokenizer* self, lucy_Obj* other);

lucy_Inversion*
lucy_StandardTokenizer_transform(lucy_StandardTokenizer* self, lucy_Inversion* inversion);

lucy_Inversion*
lucy_StandardTokenizer_transform_text(lucy_StandardTokenizer* self, lucy_CharBuf* text);

void
lucy_StandardTokenizer_tokenize_str(lucy_StandardTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_StandardTokenizer_equals_CALLBACK;
extern cfish_Callback lucy_StandardTokenizer_transform_CALLBACK;
extern cfish_Callback lucy_StandardTokenizer_transform_text_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_StandardTokenizer_equals_t)(lucy_StandardTokenizer* self, lucy_Obj* other);

typedef lucy_Inversion*
(*lucy_StandardTokenizer_transform_t)(lucy_StandardTokenizer* self, lucy_Inversion* inversion);

typedef lucy_Inversion*
(*lucy_StandardTokenizer_transform_text_t)(lucy_StandardTokenizer* self, lucy_CharBuf* text);

typedef void
(*lucy_StandardTokenizer_tokenize_str_t)(lucy_StandardTokenizer* self, const char* text, size_t len, lucy_Inversion* inversion);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_StandardTokenizer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_StandardTokenizer_Make(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_StandardTokenizer_Get_RefCount(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_StandardTokenizer_Inc_RefCount(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_StandardTokenizer_Dec_RefCount(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_StandardTokenizer_To_Host(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_StandardTokenizer_Clone(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_StandardTokenizer_Destroy(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_StandardTokenizer_Equals(const lucy_StandardTokenizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Equals_OFFSET;
    const lucy_StandardTokenizer_equals_t method = *((lucy_StandardTokenizer_equals_t*)method_address);
    return method((lucy_StandardTokenizer*)self, other);
}

extern size_t Lucy_StandardTokenizer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_StandardTokenizer_Compare_To(const lucy_StandardTokenizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_StandardTokenizer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_StandardTokenizer_Hash_Sum(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_StandardTokenizer_Get_VTable(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_StandardTokenizer_Get_Class_Name(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_StandardTokenizer_Is_A(const lucy_StandardTokenizer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_StandardTokenizer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_StandardTokenizer_To_String(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_StandardTokenizer_To_I64(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_StandardTokenizer_To_F64(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_StandardTokenizer_To_Bool(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_StandardTokenizer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_StandardTokenizer_Serialize(const lucy_StandardTokenizer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_StandardTokenizer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_StandardTokenizer_Deserialize(const lucy_StandardTokenizer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_StandardTokenizer_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_StandardTokenizer_Dump(const lucy_StandardTokenizer *self) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Dump_OFFSET;
    const lucy_Analyzer_dump_t method = *((lucy_Analyzer_dump_t*)method_address);
    return method((lucy_Analyzer*)self);
}

extern size_t Lucy_StandardTokenizer_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_StandardTokenizer_Load(const lucy_StandardTokenizer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Load_OFFSET;
    const lucy_Analyzer_load_t method = *((lucy_Analyzer_load_t*)method_address);
    return method((lucy_Analyzer*)self, dump);
}

extern size_t Lucy_StandardTokenizer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_StandardTokenizer_Mimic(const lucy_StandardTokenizer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_StandardTokenizer_Transform_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_StandardTokenizer_Transform(const lucy_StandardTokenizer *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Transform_OFFSET;
    const lucy_StandardTokenizer_transform_t method = *((lucy_StandardTokenizer_transform_t*)method_address);
    return method((lucy_StandardTokenizer*)self, inversion);
}

extern size_t Lucy_StandardTokenizer_Transform_Text_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_StandardTokenizer_Transform_Text(const lucy_StandardTokenizer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Transform_Text_OFFSET;
    const lucy_StandardTokenizer_transform_text_t method = *((lucy_StandardTokenizer_transform_text_t*)method_address);
    return method((lucy_StandardTokenizer*)self, text);
}

extern size_t Lucy_StandardTokenizer_Split_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_StandardTokenizer_Split(const lucy_StandardTokenizer *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Split_OFFSET;
    const lucy_Analyzer_split_t method = *((lucy_Analyzer_split_t*)method_address);
    return method((lucy_Analyzer*)self, text);
}

extern size_t Lucy_StandardTokenizer_Tokenize_Str_OFFSET;
static CHY_INLINE void
Lucy_StandardTokenizer_Tokenize_Str(const lucy_StandardTokenizer *self, const char* text, size_t len, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_StandardTokenizer_Tokenize_Str_OFFSET;
    const lucy_StandardTokenizer_tokenize_str_t method = *((lucy_StandardTokenizer_tokenize_str_t*)method_address);
    method((lucy_StandardTokenizer*)self, text, len, inversion);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_STANDARDTOKENIZER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[26];
} LUCY_STANDARDTOKENIZER_VT;
extern struct LUCY_STANDARDTOKENIZER_VT LUCY_STANDARDTOKENIZER_vt;
#define LUCY_STANDARDTOKENIZER ((cfish_VTable*)&LUCY_STANDARDTOKENIZER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define StandardTokenizer lucy_StandardTokenizer
  #define STANDARDTOKENIZER LUCY_STANDARDTOKENIZER
  #define StandardTokenizer_new lucy_StandardTokenizer_new
  #define StandardTokenizer_init lucy_StandardTokenizer_init
  #define StandardTokenizer_equals_t lucy_StandardTokenizer_equals_t
  #define StandardTokenizer_equals lucy_StandardTokenizer_equals
  #define StandardTokenizer_transform_t lucy_StandardTokenizer_transform_t
  #define StandardTokenizer_transform lucy_StandardTokenizer_transform
  #define StandardTokenizer_transform_text_t lucy_StandardTokenizer_transform_text_t
  #define StandardTokenizer_transform_text lucy_StandardTokenizer_transform_text
  #define StandardTokenizer_tokenize_str_t lucy_StandardTokenizer_tokenize_str_t
  #define StandardTokenizer_tokenize_str lucy_StandardTokenizer_tokenize_str
  #define StandardTokenizer_Make Lucy_StandardTokenizer_Make
  #define StandardTokenizer_Get_RefCount Lucy_StandardTokenizer_Get_RefCount
  #define StandardTokenizer_Inc_RefCount Lucy_StandardTokenizer_Inc_RefCount
  #define StandardTokenizer_Dec_RefCount Lucy_StandardTokenizer_Dec_RefCount
  #define StandardTokenizer_To_Host Lucy_StandardTokenizer_To_Host
  #define StandardTokenizer_Clone Lucy_StandardTokenizer_Clone
  #define StandardTokenizer_Destroy Lucy_StandardTokenizer_Destroy
  #define StandardTokenizer_Equals Lucy_StandardTokenizer_Equals
  #define StandardTokenizer_Compare_To Lucy_StandardTokenizer_Compare_To
  #define StandardTokenizer_Hash_Sum Lucy_StandardTokenizer_Hash_Sum
  #define StandardTokenizer_Get_VTable Lucy_StandardTokenizer_Get_VTable
  #define StandardTokenizer_Get_Class_Name Lucy_StandardTokenizer_Get_Class_Name
  #define StandardTokenizer_Is_A Lucy_StandardTokenizer_Is_A
  #define StandardTokenizer_To_String Lucy_StandardTokenizer_To_String
  #define StandardTokenizer_To_I64 Lucy_StandardTokenizer_To_I64
  #define StandardTokenizer_To_F64 Lucy_StandardTokenizer_To_F64
  #define StandardTokenizer_To_Bool Lucy_StandardTokenizer_To_Bool
  #define StandardTokenizer_Serialize Lucy_StandardTokenizer_Serialize
  #define StandardTokenizer_Deserialize Lucy_StandardTokenizer_Deserialize
  #define StandardTokenizer_Dump Lucy_StandardTokenizer_Dump
  #define StandardTokenizer_Load Lucy_StandardTokenizer_Load
  #define StandardTokenizer_Mimic Lucy_StandardTokenizer_Mimic
  #define StandardTokenizer_Transform Lucy_StandardTokenizer_Transform
  #define StandardTokenizer_Transform_Text Lucy_StandardTokenizer_Transform_Text
  #define StandardTokenizer_Split Lucy_StandardTokenizer_Split
  #define StandardTokenizer_Tokenize_Str Lucy_StandardTokenizer_Tokenize_Str
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_STANDARDTOKENIZER */




