/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_TOKEN
#define H_LUCY_ANALYSIS_TOKEN 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TOKEN
struct lucy_Token {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* text;
    size_t len;
    uint32_t start_offset;
    uint32_t end_offset;
    float boost;
    int32_t pos_inc;
    int32_t pos;
};

#endif /* C_LUCY_TOKEN */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Token*
lucy_Token_new(const char* text, size_t len, uint32_t start_offset, uint32_t end_offset, float boost, int32_t pos_inc);

lucy_Token*
lucy_Token_init(lucy_Token* self, const char* text, size_t len, uint32_t start_offset, uint32_t end_offset, float boost, int32_t pos_inc);

int
lucy_Token_compare(void* context, const void* va, const void* vb);

void
lucy_Token_destroy(lucy_Token* self);

uint32_t
lucy_Token_get_start_offset(lucy_Token* self);

uint32_t
lucy_Token_get_end_offset(lucy_Token* self);

float
lucy_Token_get_boost(lucy_Token* self);

int32_t
lucy_Token_get_pos_inc(lucy_Token* self);

char*
lucy_Token_get_text(lucy_Token* self);

size_t
lucy_Token_get_len(lucy_Token* self);

void
lucy_Token_set_text(lucy_Token* self, char* text, size_t len);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Token_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Token_destroy_t)(lucy_Token* self);

typedef uint32_t
(*lucy_Token_get_start_offset_t)(lucy_Token* self);

typedef uint32_t
(*lucy_Token_get_end_offset_t)(lucy_Token* self);

typedef float
(*lucy_Token_get_boost_t)(lucy_Token* self);

typedef int32_t
(*lucy_Token_get_pos_inc_t)(lucy_Token* self);

typedef char*
(*lucy_Token_get_text_t)(lucy_Token* self);

typedef size_t
(*lucy_Token_get_len_t)(lucy_Token* self);

typedef void
(*lucy_Token_set_text_t)(lucy_Token* self, char* text, size_t len);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Token_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Token_Make(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Token_Get_RefCount(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Token_Inc_RefCount(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Token_Dec_RefCount(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Token_To_Host(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Token_Clone(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Token_Destroy(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Destroy_OFFSET;
    const lucy_Token_destroy_t method = *((lucy_Token_destroy_t*)method_address);
    method((lucy_Token*)self);
}

extern size_t Lucy_Token_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Token_Equals(const lucy_Token *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Token_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Token_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Token_Compare_To(const lucy_Token *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Token_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Token_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Token_Hash_Sum(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Token_Get_VTable(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Token_Get_Class_Name(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Token_Is_A(const lucy_Token *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Token_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Token_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Token_To_String(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Token_To_I64(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Token_To_F64(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Token_To_Bool(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Token_Serialize(const lucy_Token *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Token_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Token_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Token_Deserialize(const lucy_Token *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Token_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Token_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Token_Dump(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Token_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Token_Load(const lucy_Token *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Token_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Token_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Token_Mimic(const lucy_Token *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Token_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Token_Get_Start_Offset_OFFSET;
static CHY_INLINE uint32_t
Lucy_Token_Get_Start_Offset(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_Start_Offset_OFFSET;
    const lucy_Token_get_start_offset_t method = *((lucy_Token_get_start_offset_t*)method_address);
    return method((lucy_Token*)self);
}

extern size_t Lucy_Token_Get_End_Offset_OFFSET;
static CHY_INLINE uint32_t
Lucy_Token_Get_End_Offset(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_End_Offset_OFFSET;
    const lucy_Token_get_end_offset_t method = *((lucy_Token_get_end_offset_t*)method_address);
    return method((lucy_Token*)self);
}

extern size_t Lucy_Token_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_Token_Get_Boost(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_Boost_OFFSET;
    const lucy_Token_get_boost_t method = *((lucy_Token_get_boost_t*)method_address);
    return method((lucy_Token*)self);
}

extern size_t Lucy_Token_Get_Pos_Inc_OFFSET;
static CHY_INLINE int32_t
Lucy_Token_Get_Pos_Inc(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_Pos_Inc_OFFSET;
    const lucy_Token_get_pos_inc_t method = *((lucy_Token_get_pos_inc_t*)method_address);
    return method((lucy_Token*)self);
}

extern size_t Lucy_Token_Get_Text_OFFSET;
static CHY_INLINE char*
Lucy_Token_Get_Text(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_Text_OFFSET;
    const lucy_Token_get_text_t method = *((lucy_Token_get_text_t*)method_address);
    return method((lucy_Token*)self);
}

extern size_t Lucy_Token_Get_Len_OFFSET;
static CHY_INLINE size_t
Lucy_Token_Get_Len(const lucy_Token *self) {
    char *const method_address = *(char**)self + Lucy_Token_Get_Len_OFFSET;
    const lucy_Token_get_len_t method = *((lucy_Token_get_len_t*)method_address);
    return method((lucy_Token*)self);
}

extern size_t Lucy_Token_Set_Text_OFFSET;
static CHY_INLINE void
Lucy_Token_Set_Text(const lucy_Token *self, char* text, size_t len) {
    char *const method_address = *(char**)self + Lucy_Token_Set_Text_OFFSET;
    const lucy_Token_set_text_t method = *((lucy_Token_set_text_t*)method_address);
    method((lucy_Token*)self, text, len);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_TOKEN_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_TOKEN_VT;
extern struct LUCY_TOKEN_VT LUCY_TOKEN_vt;
#define LUCY_TOKEN ((cfish_VTable*)&LUCY_TOKEN_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Token lucy_Token
  #define TOKEN LUCY_TOKEN
  #define Token_new lucy_Token_new
  #define Token_init lucy_Token_init
  #define Token_compare lucy_Token_compare
  #define Token_destroy_t lucy_Token_destroy_t
  #define Token_destroy lucy_Token_destroy
  #define Token_get_start_offset_t lucy_Token_get_start_offset_t
  #define Token_get_start_offset lucy_Token_get_start_offset
  #define Token_get_end_offset_t lucy_Token_get_end_offset_t
  #define Token_get_end_offset lucy_Token_get_end_offset
  #define Token_get_boost_t lucy_Token_get_boost_t
  #define Token_get_boost lucy_Token_get_boost
  #define Token_get_pos_inc_t lucy_Token_get_pos_inc_t
  #define Token_get_pos_inc lucy_Token_get_pos_inc
  #define Token_get_text_t lucy_Token_get_text_t
  #define Token_get_text lucy_Token_get_text
  #define Token_get_len_t lucy_Token_get_len_t
  #define Token_get_len lucy_Token_get_len
  #define Token_set_text_t lucy_Token_set_text_t
  #define Token_set_text lucy_Token_set_text
  #define Token_Make Lucy_Token_Make
  #define Token_Get_RefCount Lucy_Token_Get_RefCount
  #define Token_Inc_RefCount Lucy_Token_Inc_RefCount
  #define Token_Dec_RefCount Lucy_Token_Dec_RefCount
  #define Token_To_Host Lucy_Token_To_Host
  #define Token_Clone Lucy_Token_Clone
  #define Token_Destroy Lucy_Token_Destroy
  #define Token_Equals Lucy_Token_Equals
  #define Token_Compare_To Lucy_Token_Compare_To
  #define Token_Hash_Sum Lucy_Token_Hash_Sum
  #define Token_Get_VTable Lucy_Token_Get_VTable
  #define Token_Get_Class_Name Lucy_Token_Get_Class_Name
  #define Token_Is_A Lucy_Token_Is_A
  #define Token_To_String Lucy_Token_To_String
  #define Token_To_I64 Lucy_Token_To_I64
  #define Token_To_F64 Lucy_Token_To_F64
  #define Token_To_Bool Lucy_Token_To_Bool
  #define Token_Serialize Lucy_Token_Serialize
  #define Token_Deserialize Lucy_Token_Deserialize
  #define Token_Dump Lucy_Token_Dump
  #define Token_Load Lucy_Token_Load
  #define Token_Mimic Lucy_Token_Mimic
  #define Token_Get_Start_Offset Lucy_Token_Get_Start_Offset
  #define Token_Get_End_Offset Lucy_Token_Get_End_Offset
  #define Token_Get_Boost Lucy_Token_Get_Boost
  #define Token_Get_Pos_Inc Lucy_Token_Get_Pos_Inc
  #define Token_Get_Text Lucy_Token_Get_Text
  #define Token_Get_Len Lucy_Token_Get_Len
  #define Token_Set_Text Lucy_Token_Set_Text
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_TOKEN */




