/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_HIGHLIGHT_HEATMAP
#define H_LUCY_HIGHLIGHT_HEATMAP 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HEATMAP
struct lucy_HeatMap {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* spans;
    uint32_t window;
};

#endif /* C_LUCY_HEATMAP */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_HeatMap*
lucy_HeatMap_new(lucy_VArray* spans, uint32_t window);

lucy_HeatMap*
lucy_HeatMap_init(lucy_HeatMap* self, lucy_VArray* spans, uint32_t window);

void
lucy_HeatMap_destroy(lucy_HeatMap* self);

lucy_VArray*
lucy_HeatMap_flatten_spans(lucy_HeatMap* self, lucy_VArray* spans);

float
lucy_HeatMap_calc_proximity_boost(lucy_HeatMap* self, lucy_Span* span1, lucy_Span* span2);

lucy_VArray*
lucy_HeatMap_generate_proximity_boosts(lucy_HeatMap* self, lucy_VArray* spans);

lucy_VArray*
lucy_HeatMap_get_spans(lucy_HeatMap* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_HeatMap_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_HeatMap_destroy_t)(lucy_HeatMap* self);

typedef lucy_VArray*
(*lucy_HeatMap_flatten_spans_t)(lucy_HeatMap* self, lucy_VArray* spans);

typedef float
(*lucy_HeatMap_calc_proximity_boost_t)(lucy_HeatMap* self, lucy_Span* span1, lucy_Span* span2);

typedef lucy_VArray*
(*lucy_HeatMap_generate_proximity_boosts_t)(lucy_HeatMap* self, lucy_VArray* spans);

typedef lucy_VArray*
(*lucy_HeatMap_get_spans_t)(lucy_HeatMap* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_HeatMap_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HeatMap_Make(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HeatMap_Get_RefCount(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HeatMap_Inc_RefCount(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HeatMap_Dec_RefCount(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_HeatMap_To_Host(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HeatMap_Clone(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Destroy_OFFSET;
static CHY_INLINE void
Lucy_HeatMap_Destroy(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Destroy_OFFSET;
    const lucy_HeatMap_destroy_t method = *((lucy_HeatMap_destroy_t*)method_address);
    method((lucy_HeatMap*)self);
}

extern size_t Lucy_HeatMap_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HeatMap_Equals(const lucy_HeatMap *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HeatMap_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_HeatMap_Compare_To(const lucy_HeatMap *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HeatMap_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_HeatMap_Hash_Sum(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_HeatMap_Get_VTable(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HeatMap_Get_Class_Name(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HeatMap_Is_A(const lucy_HeatMap *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_HeatMap_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HeatMap_To_String(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_HeatMap_To_I64(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_To_F64_OFFSET;
static CHY_INLINE double
Lucy_HeatMap_To_F64(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HeatMap_To_Bool(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Serialize_OFFSET;
static CHY_INLINE void
Lucy_HeatMap_Serialize(const lucy_HeatMap *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_HeatMap_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HeatMap_Deserialize(const lucy_HeatMap *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_HeatMap_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HeatMap_Dump(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HeatMap_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HeatMap_Load(const lucy_HeatMap *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_HeatMap_Mimic_OFFSET;
static CHY_INLINE void
Lucy_HeatMap_Mimic(const lucy_HeatMap *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_HeatMap_Flatten_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_HeatMap_Flatten_Spans(const lucy_HeatMap *self, lucy_VArray* spans) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Flatten_Spans_OFFSET;
    const lucy_HeatMap_flatten_spans_t method = *((lucy_HeatMap_flatten_spans_t*)method_address);
    return method((lucy_HeatMap*)self, spans);
}

extern size_t Lucy_HeatMap_Calc_Proximity_Boost_OFFSET;
static CHY_INLINE float
Lucy_HeatMap_Calc_Proximity_Boost(const lucy_HeatMap *self, lucy_Span* span1, lucy_Span* span2) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Calc_Proximity_Boost_OFFSET;
    const lucy_HeatMap_calc_proximity_boost_t method = *((lucy_HeatMap_calc_proximity_boost_t*)method_address);
    return method((lucy_HeatMap*)self, span1, span2);
}

extern size_t Lucy_HeatMap_Generate_Proximity_Boosts_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_HeatMap_Generate_Proximity_Boosts(const lucy_HeatMap *self, lucy_VArray* spans) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Generate_Proximity_Boosts_OFFSET;
    const lucy_HeatMap_generate_proximity_boosts_t method = *((lucy_HeatMap_generate_proximity_boosts_t*)method_address);
    return method((lucy_HeatMap*)self, spans);
}

extern size_t Lucy_HeatMap_Get_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_HeatMap_Get_Spans(const lucy_HeatMap *self) {
    char *const method_address = *(char**)self + Lucy_HeatMap_Get_Spans_OFFSET;
    const lucy_HeatMap_get_spans_t method = *((lucy_HeatMap_get_spans_t*)method_address);
    return method((lucy_HeatMap*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HEATMAP_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[26];
} LUCY_HEATMAP_VT;
extern struct LUCY_HEATMAP_VT LUCY_HEATMAP_vt;
#define LUCY_HEATMAP ((cfish_VTable*)&LUCY_HEATMAP_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define HeatMap lucy_HeatMap
  #define HEATMAP LUCY_HEATMAP
  #define HeatMap_new lucy_HeatMap_new
  #define HeatMap_init lucy_HeatMap_init
  #define HeatMap_destroy_t lucy_HeatMap_destroy_t
  #define HeatMap_destroy lucy_HeatMap_destroy
  #define HeatMap_flatten_spans_t lucy_HeatMap_flatten_spans_t
  #define HeatMap_flatten_spans lucy_HeatMap_flatten_spans
  #define HeatMap_calc_proximity_boost_t lucy_HeatMap_calc_proximity_boost_t
  #define HeatMap_calc_proximity_boost lucy_HeatMap_calc_proximity_boost
  #define HeatMap_generate_proximity_boosts_t lucy_HeatMap_generate_proximity_boosts_t
  #define HeatMap_generate_proximity_boosts lucy_HeatMap_generate_proximity_boosts
  #define HeatMap_get_spans_t lucy_HeatMap_get_spans_t
  #define HeatMap_get_spans lucy_HeatMap_get_spans
  #define HeatMap_Make Lucy_HeatMap_Make
  #define HeatMap_Get_RefCount Lucy_HeatMap_Get_RefCount
  #define HeatMap_Inc_RefCount Lucy_HeatMap_Inc_RefCount
  #define HeatMap_Dec_RefCount Lucy_HeatMap_Dec_RefCount
  #define HeatMap_To_Host Lucy_HeatMap_To_Host
  #define HeatMap_Clone Lucy_HeatMap_Clone
  #define HeatMap_Destroy Lucy_HeatMap_Destroy
  #define HeatMap_Equals Lucy_HeatMap_Equals
  #define HeatMap_Compare_To Lucy_HeatMap_Compare_To
  #define HeatMap_Hash_Sum Lucy_HeatMap_Hash_Sum
  #define HeatMap_Get_VTable Lucy_HeatMap_Get_VTable
  #define HeatMap_Get_Class_Name Lucy_HeatMap_Get_Class_Name
  #define HeatMap_Is_A Lucy_HeatMap_Is_A
  #define HeatMap_To_String Lucy_HeatMap_To_String
  #define HeatMap_To_I64 Lucy_HeatMap_To_I64
  #define HeatMap_To_F64 Lucy_HeatMap_To_F64
  #define HeatMap_To_Bool Lucy_HeatMap_To_Bool
  #define HeatMap_Serialize Lucy_HeatMap_Serialize
  #define HeatMap_Deserialize Lucy_HeatMap_Deserialize
  #define HeatMap_Dump Lucy_HeatMap_Dump
  #define HeatMap_Load Lucy_HeatMap_Load
  #define HeatMap_Mimic Lucy_HeatMap_Mimic
  #define HeatMap_Flatten_Spans Lucy_HeatMap_Flatten_Spans
  #define HeatMap_Calc_Proximity_Boost Lucy_HeatMap_Calc_Proximity_Boost
  #define HeatMap_Generate_Proximity_Boosts Lucy_HeatMap_Generate_Proximity_Boosts
  #define HeatMap_Get_Spans Lucy_HeatMap_Get_Spans
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_HIGHLIGHT_HEATMAP */




