/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_HIGHLIGHT_HIGHLIGHTER
#define H_LUCY_HIGHLIGHT_HIGHLIGHTER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HIGHLIGHTER
struct lucy_Highlighter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Searcher* searcher;
    lucy_Query* query;
    lucy_CharBuf* field;
    uint32_t excerpt_length;
    uint32_t window_width;
    uint32_t slop;
    lucy_CharBuf* pre_tag;
    lucy_CharBuf* post_tag;
    lucy_Compiler* compiler;
};

#endif /* C_LUCY_HIGHLIGHTER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Highlighter*
lucy_Highlighter_new(lucy_Searcher* searcher, lucy_Obj* query, const lucy_CharBuf* field, uint32_t excerpt_length);

lucy_Highlighter*
lucy_Highlighter_init(lucy_Highlighter* self, lucy_Searcher* searcher, lucy_Obj* query, const lucy_CharBuf* field, uint32_t excerpt_length);

void
lucy_Highlighter_destroy(lucy_Highlighter* self);

lucy_CharBuf*
lucy_Highlighter_create_excerpt(lucy_Highlighter* self, lucy_HitDoc* hit_doc);

lucy_CharBuf*
lucy_Highlighter_encode(lucy_Highlighter* self, lucy_CharBuf* text);

lucy_VArray*
lucy_Highlighter_find_sentences(lucy_Highlighter* self, lucy_CharBuf* text, int32_t offset, int32_t length);

lucy_CharBuf*
lucy_Highlighter_highlight(lucy_Highlighter* self, const lucy_CharBuf* text);

void
lucy_Highlighter_set_pre_tag(lucy_Highlighter* self, const lucy_CharBuf* pre_tag);

void
lucy_Highlighter_set_post_tag(lucy_Highlighter* self, const lucy_CharBuf* post_tag);

lucy_CharBuf*
lucy_Highlighter_get_pre_tag(lucy_Highlighter* self);

lucy_CharBuf*
lucy_Highlighter_get_post_tag(lucy_Highlighter* self);

lucy_CharBuf*
lucy_Highlighter_get_field(lucy_Highlighter* self);

uint32_t
lucy_Highlighter_get_excerpt_length(lucy_Highlighter* self);

lucy_Searcher*
lucy_Highlighter_get_searcher(lucy_Highlighter* self);

lucy_Query*
lucy_Highlighter_get_query(lucy_Highlighter* self);

lucy_Compiler*
lucy_Highlighter_get_compiler(lucy_Highlighter* self);

int32_t
lucy_Highlighter_find_best_fragment(lucy_Highlighter* self, const lucy_CharBuf* field_val, lucy_ViewCharBuf* fragment, lucy_HeatMap* heat_map);

int32_t
lucy_Highlighter_raw_excerpt(lucy_Highlighter* self, const lucy_CharBuf* field_val, const lucy_CharBuf* fragment, lucy_CharBuf* raw_excerpt, int32_t top, lucy_HeatMap* heat_map, lucy_VArray* sentences);

void
lucy_Highlighter_highlight_excerpt(lucy_Highlighter* self, lucy_VArray* spans, lucy_CharBuf* raw_excerpt, lucy_CharBuf* highlighted, int32_t top);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Highlighter_destroy_CALLBACK;
extern cfish_Callback lucy_Highlighter_create_excerpt_CALLBACK;
extern cfish_Callback lucy_Highlighter_encode_CALLBACK;
extern cfish_Callback lucy_Highlighter_highlight_CALLBACK;
extern cfish_Callback lucy_Highlighter_set_pre_tag_CALLBACK;
extern cfish_Callback lucy_Highlighter_set_post_tag_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_pre_tag_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_post_tag_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_field_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_excerpt_length_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_searcher_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_query_CALLBACK;
extern cfish_Callback lucy_Highlighter_get_compiler_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Highlighter_destroy_t)(lucy_Highlighter* self);

typedef lucy_CharBuf*
(*lucy_Highlighter_create_excerpt_t)(lucy_Highlighter* self, lucy_HitDoc* hit_doc);

typedef lucy_CharBuf*
(*lucy_Highlighter_encode_t)(lucy_Highlighter* self, lucy_CharBuf* text);

typedef lucy_VArray*
(*lucy_Highlighter_find_sentences_t)(lucy_Highlighter* self, lucy_CharBuf* text, int32_t offset, int32_t length);

typedef lucy_CharBuf*
(*lucy_Highlighter_highlight_t)(lucy_Highlighter* self, const lucy_CharBuf* text);

typedef void
(*lucy_Highlighter_set_pre_tag_t)(lucy_Highlighter* self, const lucy_CharBuf* pre_tag);

typedef void
(*lucy_Highlighter_set_post_tag_t)(lucy_Highlighter* self, const lucy_CharBuf* post_tag);

typedef lucy_CharBuf*
(*lucy_Highlighter_get_pre_tag_t)(lucy_Highlighter* self);

typedef lucy_CharBuf*
(*lucy_Highlighter_get_post_tag_t)(lucy_Highlighter* self);

typedef lucy_CharBuf*
(*lucy_Highlighter_get_field_t)(lucy_Highlighter* self);

typedef uint32_t
(*lucy_Highlighter_get_excerpt_length_t)(lucy_Highlighter* self);

typedef lucy_Searcher*
(*lucy_Highlighter_get_searcher_t)(lucy_Highlighter* self);

typedef lucy_Query*
(*lucy_Highlighter_get_query_t)(lucy_Highlighter* self);

typedef lucy_Compiler*
(*lucy_Highlighter_get_compiler_t)(lucy_Highlighter* self);

typedef int32_t
(*lucy_Highlighter_find_best_fragment_t)(lucy_Highlighter* self, const lucy_CharBuf* field_val, lucy_ViewCharBuf* fragment, lucy_HeatMap* heat_map);

typedef int32_t
(*lucy_Highlighter_raw_excerpt_t)(lucy_Highlighter* self, const lucy_CharBuf* field_val, const lucy_CharBuf* fragment, lucy_CharBuf* raw_excerpt, int32_t top, lucy_HeatMap* heat_map, lucy_VArray* sentences);

typedef void
(*lucy_Highlighter_highlight_excerpt_t)(lucy_Highlighter* self, lucy_VArray* spans, lucy_CharBuf* raw_excerpt, lucy_CharBuf* highlighted, int32_t top);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Highlighter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Highlighter_Make(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Highlighter_Get_RefCount(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Highlighter_Inc_RefCount(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Highlighter_Dec_RefCount(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Highlighter_To_Host(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Highlighter_Clone(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Highlighter_Destroy(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Destroy_OFFSET;
    const lucy_Highlighter_destroy_t method = *((lucy_Highlighter_destroy_t*)method_address);
    method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Highlighter_Equals(const lucy_Highlighter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Highlighter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Highlighter_Compare_To(const lucy_Highlighter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Highlighter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Highlighter_Hash_Sum(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Highlighter_Get_VTable(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Get_Class_Name(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Highlighter_Is_A(const lucy_Highlighter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Highlighter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_To_String(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Highlighter_To_I64(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Highlighter_To_F64(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Highlighter_To_Bool(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Highlighter_Serialize(const lucy_Highlighter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Highlighter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Highlighter_Deserialize(const lucy_Highlighter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Highlighter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Highlighter_Dump(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Highlighter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Highlighter_Load(const lucy_Highlighter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Highlighter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Highlighter_Mimic(const lucy_Highlighter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Highlighter_Create_Excerpt_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Create_Excerpt(const lucy_Highlighter *self, lucy_HitDoc* hit_doc) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Create_Excerpt_OFFSET;
    const lucy_Highlighter_create_excerpt_t method = *((lucy_Highlighter_create_excerpt_t*)method_address);
    return method((lucy_Highlighter*)self, hit_doc);
}

extern size_t Lucy_Highlighter_Encode_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Encode(const lucy_Highlighter *self, lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Encode_OFFSET;
    const lucy_Highlighter_encode_t method = *((lucy_Highlighter_encode_t*)method_address);
    return method((lucy_Highlighter*)self, text);
}

extern size_t Lucy_Highlighter_Find_Sentences_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Highlighter_Find_Sentences(const lucy_Highlighter *self, lucy_CharBuf* text, int32_t offset, int32_t length) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Find_Sentences_OFFSET;
    const lucy_Highlighter_find_sentences_t method = *((lucy_Highlighter_find_sentences_t*)method_address);
    return method((lucy_Highlighter*)self, text, offset, length);
}

extern size_t Lucy_Highlighter_Highlight_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Highlight(const lucy_Highlighter *self, const lucy_CharBuf* text) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Highlight_OFFSET;
    const lucy_Highlighter_highlight_t method = *((lucy_Highlighter_highlight_t*)method_address);
    return method((lucy_Highlighter*)self, text);
}

extern size_t Lucy_Highlighter_Set_Pre_Tag_OFFSET;
static CHY_INLINE void
Lucy_Highlighter_Set_Pre_Tag(const lucy_Highlighter *self, const lucy_CharBuf* pre_tag) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Set_Pre_Tag_OFFSET;
    const lucy_Highlighter_set_pre_tag_t method = *((lucy_Highlighter_set_pre_tag_t*)method_address);
    method((lucy_Highlighter*)self, pre_tag);
}

extern size_t Lucy_Highlighter_Set_Post_Tag_OFFSET;
static CHY_INLINE void
Lucy_Highlighter_Set_Post_Tag(const lucy_Highlighter *self, const lucy_CharBuf* post_tag) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Set_Post_Tag_OFFSET;
    const lucy_Highlighter_set_post_tag_t method = *((lucy_Highlighter_set_post_tag_t*)method_address);
    method((lucy_Highlighter*)self, post_tag);
}

extern size_t Lucy_Highlighter_Get_Pre_Tag_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Get_Pre_Tag(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Pre_Tag_OFFSET;
    const lucy_Highlighter_get_pre_tag_t method = *((lucy_Highlighter_get_pre_tag_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Get_Post_Tag_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Get_Post_Tag(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Post_Tag_OFFSET;
    const lucy_Highlighter_get_post_tag_t method = *((lucy_Highlighter_get_post_tag_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Highlighter_Get_Field(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Field_OFFSET;
    const lucy_Highlighter_get_field_t method = *((lucy_Highlighter_get_field_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Get_Excerpt_Length_OFFSET;
static CHY_INLINE uint32_t
Lucy_Highlighter_Get_Excerpt_Length(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Excerpt_Length_OFFSET;
    const lucy_Highlighter_get_excerpt_length_t method = *((lucy_Highlighter_get_excerpt_length_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Get_Searcher_OFFSET;
static CHY_INLINE lucy_Searcher*
Lucy_Highlighter_Get_Searcher(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Searcher_OFFSET;
    const lucy_Highlighter_get_searcher_t method = *((lucy_Highlighter_get_searcher_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Get_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_Highlighter_Get_Query(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Query_OFFSET;
    const lucy_Highlighter_get_query_t method = *((lucy_Highlighter_get_query_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Get_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_Highlighter_Get_Compiler(const lucy_Highlighter *self) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Get_Compiler_OFFSET;
    const lucy_Highlighter_get_compiler_t method = *((lucy_Highlighter_get_compiler_t*)method_address);
    return method((lucy_Highlighter*)self);
}

extern size_t Lucy_Highlighter_Find_Best_Fragment_OFFSET;
static CHY_INLINE int32_t
Lucy_Highlighter_Find_Best_Fragment(const lucy_Highlighter *self, const lucy_CharBuf* field_val, lucy_ViewCharBuf* fragment, lucy_HeatMap* heat_map) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Find_Best_Fragment_OFFSET;
    const lucy_Highlighter_find_best_fragment_t method = *((lucy_Highlighter_find_best_fragment_t*)method_address);
    return method((lucy_Highlighter*)self, field_val, fragment, heat_map);
}

extern size_t Lucy_Highlighter_Raw_Excerpt_OFFSET;
static CHY_INLINE int32_t
Lucy_Highlighter_Raw_Excerpt(const lucy_Highlighter *self, const lucy_CharBuf* field_val, const lucy_CharBuf* fragment, lucy_CharBuf* raw_excerpt, int32_t top, lucy_HeatMap* heat_map, lucy_VArray* sentences) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Raw_Excerpt_OFFSET;
    const lucy_Highlighter_raw_excerpt_t method = *((lucy_Highlighter_raw_excerpt_t*)method_address);
    return method((lucy_Highlighter*)self, field_val, fragment, raw_excerpt, top, heat_map, sentences);
}

extern size_t Lucy_Highlighter_Highlight_Excerpt_OFFSET;
static CHY_INLINE void
Lucy_Highlighter_Highlight_Excerpt(const lucy_Highlighter *self, lucy_VArray* spans, lucy_CharBuf* raw_excerpt, lucy_CharBuf* highlighted, int32_t top) {
    char *const method_address = *(char**)self + Lucy_Highlighter_Highlight_Excerpt_OFFSET;
    const lucy_Highlighter_highlight_excerpt_t method = *((lucy_Highlighter_highlight_excerpt_t*)method_address);
    method((lucy_Highlighter*)self, spans, raw_excerpt, highlighted, top);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HIGHLIGHTER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[38];
} LUCY_HIGHLIGHTER_VT;
extern struct LUCY_HIGHLIGHTER_VT LUCY_HIGHLIGHTER_vt;
#define LUCY_HIGHLIGHTER ((cfish_VTable*)&LUCY_HIGHLIGHTER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Highlighter lucy_Highlighter
  #define HIGHLIGHTER LUCY_HIGHLIGHTER
  #define Highlighter_new lucy_Highlighter_new
  #define Highlighter_init lucy_Highlighter_init
  #define Highlighter_destroy_t lucy_Highlighter_destroy_t
  #define Highlighter_destroy lucy_Highlighter_destroy
  #define Highlighter_create_excerpt_t lucy_Highlighter_create_excerpt_t
  #define Highlighter_create_excerpt lucy_Highlighter_create_excerpt
  #define Highlighter_encode_t lucy_Highlighter_encode_t
  #define Highlighter_encode lucy_Highlighter_encode
  #define Highlighter_find_sentences_t lucy_Highlighter_find_sentences_t
  #define Highlighter_find_sentences lucy_Highlighter_find_sentences
  #define Highlighter_highlight_t lucy_Highlighter_highlight_t
  #define Highlighter_highlight lucy_Highlighter_highlight
  #define Highlighter_set_pre_tag_t lucy_Highlighter_set_pre_tag_t
  #define Highlighter_set_pre_tag lucy_Highlighter_set_pre_tag
  #define Highlighter_set_post_tag_t lucy_Highlighter_set_post_tag_t
  #define Highlighter_set_post_tag lucy_Highlighter_set_post_tag
  #define Highlighter_get_pre_tag_t lucy_Highlighter_get_pre_tag_t
  #define Highlighter_get_pre_tag lucy_Highlighter_get_pre_tag
  #define Highlighter_get_post_tag_t lucy_Highlighter_get_post_tag_t
  #define Highlighter_get_post_tag lucy_Highlighter_get_post_tag
  #define Highlighter_get_field_t lucy_Highlighter_get_field_t
  #define Highlighter_get_field lucy_Highlighter_get_field
  #define Highlighter_get_excerpt_length_t lucy_Highlighter_get_excerpt_length_t
  #define Highlighter_get_excerpt_length lucy_Highlighter_get_excerpt_length
  #define Highlighter_get_searcher_t lucy_Highlighter_get_searcher_t
  #define Highlighter_get_searcher lucy_Highlighter_get_searcher
  #define Highlighter_get_query_t lucy_Highlighter_get_query_t
  #define Highlighter_get_query lucy_Highlighter_get_query
  #define Highlighter_get_compiler_t lucy_Highlighter_get_compiler_t
  #define Highlighter_get_compiler lucy_Highlighter_get_compiler
  #define Highlighter_find_best_fragment_t lucy_Highlighter_find_best_fragment_t
  #define Highlighter_find_best_fragment lucy_Highlighter_find_best_fragment
  #define Highlighter_raw_excerpt_t lucy_Highlighter_raw_excerpt_t
  #define Highlighter_raw_excerpt lucy_Highlighter_raw_excerpt
  #define Highlighter_highlight_excerpt_t lucy_Highlighter_highlight_excerpt_t
  #define Highlighter_highlight_excerpt lucy_Highlighter_highlight_excerpt
  #define Highlighter_Make Lucy_Highlighter_Make
  #define Highlighter_Get_RefCount Lucy_Highlighter_Get_RefCount
  #define Highlighter_Inc_RefCount Lucy_Highlighter_Inc_RefCount
  #define Highlighter_Dec_RefCount Lucy_Highlighter_Dec_RefCount
  #define Highlighter_To_Host Lucy_Highlighter_To_Host
  #define Highlighter_Clone Lucy_Highlighter_Clone
  #define Highlighter_Destroy Lucy_Highlighter_Destroy
  #define Highlighter_Equals Lucy_Highlighter_Equals
  #define Highlighter_Compare_To Lucy_Highlighter_Compare_To
  #define Highlighter_Hash_Sum Lucy_Highlighter_Hash_Sum
  #define Highlighter_Get_VTable Lucy_Highlighter_Get_VTable
  #define Highlighter_Get_Class_Name Lucy_Highlighter_Get_Class_Name
  #define Highlighter_Is_A Lucy_Highlighter_Is_A
  #define Highlighter_To_String Lucy_Highlighter_To_String
  #define Highlighter_To_I64 Lucy_Highlighter_To_I64
  #define Highlighter_To_F64 Lucy_Highlighter_To_F64
  #define Highlighter_To_Bool Lucy_Highlighter_To_Bool
  #define Highlighter_Serialize Lucy_Highlighter_Serialize
  #define Highlighter_Deserialize Lucy_Highlighter_Deserialize
  #define Highlighter_Dump Lucy_Highlighter_Dump
  #define Highlighter_Load Lucy_Highlighter_Load
  #define Highlighter_Mimic Lucy_Highlighter_Mimic
  #define Highlighter_Create_Excerpt Lucy_Highlighter_Create_Excerpt
  #define Highlighter_Encode Lucy_Highlighter_Encode
  #define Highlighter_Find_Sentences Lucy_Highlighter_Find_Sentences
  #define Highlighter_Highlight Lucy_Highlighter_Highlight
  #define Highlighter_Set_Pre_Tag Lucy_Highlighter_Set_Pre_Tag
  #define Highlighter_Set_Post_Tag Lucy_Highlighter_Set_Post_Tag
  #define Highlighter_Get_Pre_Tag Lucy_Highlighter_Get_Pre_Tag
  #define Highlighter_Get_Post_Tag Lucy_Highlighter_Get_Post_Tag
  #define Highlighter_Get_Field Lucy_Highlighter_Get_Field
  #define Highlighter_Get_Excerpt_Length Lucy_Highlighter_Get_Excerpt_Length
  #define Highlighter_Get_Searcher Lucy_Highlighter_Get_Searcher
  #define Highlighter_Get_Query Lucy_Highlighter_Get_Query
  #define Highlighter_Get_Compiler Lucy_Highlighter_Get_Compiler
  #define Highlighter_Find_Best_Fragment Lucy_Highlighter_Find_Best_Fragment
  #define Highlighter_Raw_Excerpt Lucy_Highlighter_Raw_Excerpt
  #define Highlighter_Highlight_Excerpt Lucy_Highlighter_Highlight_Excerpt
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_HIGHLIGHT_HIGHLIGHTER */




