/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_BACKGROUNDMERGER
#define H_LUCY_INDEX_BACKGROUNDMERGER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_BACKGROUNDMERGER
struct lucy_BackgroundMerger {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Segment* segment;
    lucy_IndexManager* manager;
    lucy_PolyReader* polyreader;
    lucy_Snapshot* snapshot;
    lucy_SegWriter* seg_writer;
    lucy_DeletionsWriter* del_writer;
    lucy_FilePurger* file_purger;
    lucy_Lock* write_lock;
    lucy_Lock* merge_lock;
    lucy_CharBuf* snapfile;
    lucy_Hash* doc_maps;
    int64_t cutoff;
    chy_bool_t optimize;
    chy_bool_t needs_commit;
    chy_bool_t prepared;
};

#endif /* C_LUCY_BACKGROUNDMERGER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_BackgroundMerger*
lucy_BGMerger_new(lucy_Obj* index, lucy_IndexManager* manager);

lucy_BackgroundMerger*
lucy_BGMerger_init(lucy_BackgroundMerger* self, lucy_Obj* index, lucy_IndexManager* manager);

void
lucy_BGMerger_destroy(lucy_BackgroundMerger* self);

void
lucy_BGMerger_optimize(lucy_BackgroundMerger* self);

void
lucy_BGMerger_commit(lucy_BackgroundMerger* self);

void
lucy_BGMerger_prepare_commit(lucy_BackgroundMerger* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_BGMerger_destroy_CALLBACK;
extern cfish_Callback lucy_BGMerger_optimize_CALLBACK;
extern cfish_Callback lucy_BGMerger_commit_CALLBACK;
extern cfish_Callback lucy_BGMerger_prepare_commit_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_BGMerger_destroy_t)(lucy_BackgroundMerger* self);

typedef void
(*lucy_BGMerger_optimize_t)(lucy_BackgroundMerger* self);

typedef void
(*lucy_BGMerger_commit_t)(lucy_BackgroundMerger* self);

typedef void
(*lucy_BGMerger_prepare_commit_t)(lucy_BackgroundMerger* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_BGMerger_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BGMerger_Make(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BGMerger_Get_RefCount(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BGMerger_Inc_RefCount(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BGMerger_Dec_RefCount(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_BGMerger_To_Host(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BGMerger_Clone(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Destroy_OFFSET;
static CHY_INLINE void
Lucy_BGMerger_Destroy(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Destroy_OFFSET;
    const lucy_BGMerger_destroy_t method = *((lucy_BGMerger_destroy_t*)method_address);
    method((lucy_BackgroundMerger*)self);
}

extern size_t Lucy_BGMerger_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BGMerger_Equals(const lucy_BackgroundMerger *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_BGMerger_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_BGMerger_Compare_To(const lucy_BackgroundMerger *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_BGMerger_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_BGMerger_Hash_Sum(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_BGMerger_Get_VTable(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BGMerger_Get_Class_Name(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BGMerger_Is_A(const lucy_BackgroundMerger *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_BGMerger_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BGMerger_To_String(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_BGMerger_To_I64(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_To_F64_OFFSET;
static CHY_INLINE double
Lucy_BGMerger_To_F64(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BGMerger_To_Bool(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Serialize_OFFSET;
static CHY_INLINE void
Lucy_BGMerger_Serialize(const lucy_BackgroundMerger *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_BGMerger_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BGMerger_Deserialize(const lucy_BackgroundMerger *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_BGMerger_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BGMerger_Dump(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BGMerger_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BGMerger_Load(const lucy_BackgroundMerger *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_BGMerger_Mimic_OFFSET;
static CHY_INLINE void
Lucy_BGMerger_Mimic(const lucy_BackgroundMerger *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_BGMerger_Optimize_OFFSET;
static CHY_INLINE void
Lucy_BGMerger_Optimize(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Optimize_OFFSET;
    const lucy_BGMerger_optimize_t method = *((lucy_BGMerger_optimize_t*)method_address);
    method((lucy_BackgroundMerger*)self);
}

extern size_t Lucy_BGMerger_Commit_OFFSET;
static CHY_INLINE void
Lucy_BGMerger_Commit(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Commit_OFFSET;
    const lucy_BGMerger_commit_t method = *((lucy_BGMerger_commit_t*)method_address);
    method((lucy_BackgroundMerger*)self);
}

extern size_t Lucy_BGMerger_Prepare_Commit_OFFSET;
static CHY_INLINE void
Lucy_BGMerger_Prepare_Commit(const lucy_BackgroundMerger *self) {
    char *const method_address = *(char**)self + Lucy_BGMerger_Prepare_Commit_OFFSET;
    const lucy_BGMerger_prepare_commit_t method = *((lucy_BGMerger_prepare_commit_t*)method_address);
    method((lucy_BackgroundMerger*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_BACKGROUNDMERGER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_BACKGROUNDMERGER_VT;
extern struct LUCY_BACKGROUNDMERGER_VT LUCY_BACKGROUNDMERGER_vt;
#define LUCY_BACKGROUNDMERGER ((cfish_VTable*)&LUCY_BACKGROUNDMERGER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define BackgroundMerger lucy_BackgroundMerger
  #define BACKGROUNDMERGER LUCY_BACKGROUNDMERGER
  #define BGMerger_new lucy_BGMerger_new
  #define BGMerger_init lucy_BGMerger_init
  #define BGMerger_destroy_t lucy_BGMerger_destroy_t
  #define BGMerger_destroy lucy_BGMerger_destroy
  #define BGMerger_optimize_t lucy_BGMerger_optimize_t
  #define BGMerger_optimize lucy_BGMerger_optimize
  #define BGMerger_commit_t lucy_BGMerger_commit_t
  #define BGMerger_commit lucy_BGMerger_commit
  #define BGMerger_prepare_commit_t lucy_BGMerger_prepare_commit_t
  #define BGMerger_prepare_commit lucy_BGMerger_prepare_commit
  #define BGMerger_Make Lucy_BGMerger_Make
  #define BGMerger_Get_RefCount Lucy_BGMerger_Get_RefCount
  #define BGMerger_Inc_RefCount Lucy_BGMerger_Inc_RefCount
  #define BGMerger_Dec_RefCount Lucy_BGMerger_Dec_RefCount
  #define BGMerger_To_Host Lucy_BGMerger_To_Host
  #define BGMerger_Clone Lucy_BGMerger_Clone
  #define BGMerger_Destroy Lucy_BGMerger_Destroy
  #define BGMerger_Equals Lucy_BGMerger_Equals
  #define BGMerger_Compare_To Lucy_BGMerger_Compare_To
  #define BGMerger_Hash_Sum Lucy_BGMerger_Hash_Sum
  #define BGMerger_Get_VTable Lucy_BGMerger_Get_VTable
  #define BGMerger_Get_Class_Name Lucy_BGMerger_Get_Class_Name
  #define BGMerger_Is_A Lucy_BGMerger_Is_A
  #define BGMerger_To_String Lucy_BGMerger_To_String
  #define BGMerger_To_I64 Lucy_BGMerger_To_I64
  #define BGMerger_To_F64 Lucy_BGMerger_To_F64
  #define BGMerger_To_Bool Lucy_BGMerger_To_Bool
  #define BGMerger_Serialize Lucy_BGMerger_Serialize
  #define BGMerger_Deserialize Lucy_BGMerger_Deserialize
  #define BGMerger_Dump Lucy_BGMerger_Dump
  #define BGMerger_Load Lucy_BGMerger_Load
  #define BGMerger_Mimic Lucy_BGMerger_Mimic
  #define BGMerger_Optimize Lucy_BGMerger_Optimize
  #define BGMerger_Commit Lucy_BGMerger_Commit
  #define BGMerger_Prepare_Commit Lucy_BGMerger_Prepare_Commit
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_BACKGROUNDMERGER */




