/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DATAREADER
#define H_LUCY_INDEX_DATAREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DATAREADER
struct lucy_DataReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_DATAREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DataReader*
lucy_DataReader_init(lucy_DataReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_DataReader_destroy(lucy_DataReader* self);

lucy_DataReader*
lucy_DataReader_aggregator(lucy_DataReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

lucy_Schema*
lucy_DataReader_get_schema(lucy_DataReader* self);

lucy_Folder*
lucy_DataReader_get_folder(lucy_DataReader* self);

lucy_Snapshot*
lucy_DataReader_get_snapshot(lucy_DataReader* self);

lucy_VArray*
lucy_DataReader_get_segments(lucy_DataReader* self);

lucy_Segment*
lucy_DataReader_get_segment(lucy_DataReader* self);

int32_t
lucy_DataReader_get_seg_tick(lucy_DataReader* self);

void
lucy_DataReader_close(lucy_DataReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DataReader_destroy_CALLBACK;
extern cfish_Callback lucy_DataReader_aggregator_CALLBACK;
extern cfish_Callback lucy_DataReader_get_schema_CALLBACK;
extern cfish_Callback lucy_DataReader_get_folder_CALLBACK;
extern cfish_Callback lucy_DataReader_get_snapshot_CALLBACK;
extern cfish_Callback lucy_DataReader_get_segments_CALLBACK;
extern cfish_Callback lucy_DataReader_get_segment_CALLBACK;
extern cfish_Callback lucy_DataReader_get_seg_tick_CALLBACK;
extern cfish_Callback lucy_DataReader_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DataReader_destroy_t)(lucy_DataReader* self);

typedef lucy_DataReader*
(*lucy_DataReader_aggregator_t)(lucy_DataReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef lucy_Schema*
(*lucy_DataReader_get_schema_t)(lucy_DataReader* self);

typedef lucy_Folder*
(*lucy_DataReader_get_folder_t)(lucy_DataReader* self);

typedef lucy_Snapshot*
(*lucy_DataReader_get_snapshot_t)(lucy_DataReader* self);

typedef lucy_VArray*
(*lucy_DataReader_get_segments_t)(lucy_DataReader* self);

typedef lucy_Segment*
(*lucy_DataReader_get_segment_t)(lucy_DataReader* self);

typedef int32_t
(*lucy_DataReader_get_seg_tick_t)(lucy_DataReader* self);

typedef void
(*lucy_DataReader_close_t)(lucy_DataReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DataReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataReader_Make(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DataReader_Get_RefCount(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataReader_Inc_RefCount(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DataReader_Dec_RefCount(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DataReader_To_Host(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataReader_Clone(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DataReader_Destroy(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DataReader_Equals(const lucy_DataReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DataReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DataReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DataReader_Compare_To(const lucy_DataReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DataReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DataReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DataReader_Hash_Sum(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DataReader_Get_VTable(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DataReader_Get_Class_Name(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DataReader_Is_A(const lucy_DataReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DataReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DataReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DataReader_To_String(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DataReader_To_I64(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DataReader_To_F64(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DataReader_To_Bool(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DataReader_Serialize(const lucy_DataReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DataReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DataReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataReader_Deserialize(const lucy_DataReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DataReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DataReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataReader_Dump(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataReader_Load(const lucy_DataReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DataReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DataReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DataReader_Mimic(const lucy_DataReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DataReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DataReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_DataReader_Aggregator(const lucy_DataReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DataReader_Aggregator_OFFSET;
    const lucy_DataReader_aggregator_t method = *((lucy_DataReader_aggregator_t*)method_address);
    return method((lucy_DataReader*)self, readers, offsets);
}

extern size_t Lucy_DataReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DataReader_Get_Schema(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DataReader_Get_Folder(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DataReader_Get_Snapshot(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DataReader_Get_Segments(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DataReader_Get_Segment(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DataReader_Get_Seg_Tick(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DataReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DataReader_Close(const lucy_DataReader *self) {
    char *const method_address = *(char**)self + Lucy_DataReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DATAREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[30];
} LUCY_DATAREADER_VT;
extern struct LUCY_DATAREADER_VT LUCY_DATAREADER_vt;
#define LUCY_DATAREADER ((cfish_VTable*)&LUCY_DATAREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DataReader lucy_DataReader
  #define DATAREADER LUCY_DATAREADER
  #define DataReader_init lucy_DataReader_init
  #define DataReader_destroy_t lucy_DataReader_destroy_t
  #define DataReader_destroy lucy_DataReader_destroy
  #define DataReader_aggregator_t lucy_DataReader_aggregator_t
  #define DataReader_aggregator lucy_DataReader_aggregator
  #define DataReader_get_schema_t lucy_DataReader_get_schema_t
  #define DataReader_get_schema lucy_DataReader_get_schema
  #define DataReader_get_folder_t lucy_DataReader_get_folder_t
  #define DataReader_get_folder lucy_DataReader_get_folder
  #define DataReader_get_snapshot_t lucy_DataReader_get_snapshot_t
  #define DataReader_get_snapshot lucy_DataReader_get_snapshot
  #define DataReader_get_segments_t lucy_DataReader_get_segments_t
  #define DataReader_get_segments lucy_DataReader_get_segments
  #define DataReader_get_segment_t lucy_DataReader_get_segment_t
  #define DataReader_get_segment lucy_DataReader_get_segment
  #define DataReader_get_seg_tick_t lucy_DataReader_get_seg_tick_t
  #define DataReader_get_seg_tick lucy_DataReader_get_seg_tick
  #define DataReader_close_t lucy_DataReader_close_t
  #define DataReader_close lucy_DataReader_close
  #define DataReader_Make Lucy_DataReader_Make
  #define DataReader_Get_RefCount Lucy_DataReader_Get_RefCount
  #define DataReader_Inc_RefCount Lucy_DataReader_Inc_RefCount
  #define DataReader_Dec_RefCount Lucy_DataReader_Dec_RefCount
  #define DataReader_To_Host Lucy_DataReader_To_Host
  #define DataReader_Clone Lucy_DataReader_Clone
  #define DataReader_Destroy Lucy_DataReader_Destroy
  #define DataReader_Equals Lucy_DataReader_Equals
  #define DataReader_Compare_To Lucy_DataReader_Compare_To
  #define DataReader_Hash_Sum Lucy_DataReader_Hash_Sum
  #define DataReader_Get_VTable Lucy_DataReader_Get_VTable
  #define DataReader_Get_Class_Name Lucy_DataReader_Get_Class_Name
  #define DataReader_Is_A Lucy_DataReader_Is_A
  #define DataReader_To_String Lucy_DataReader_To_String
  #define DataReader_To_I64 Lucy_DataReader_To_I64
  #define DataReader_To_F64 Lucy_DataReader_To_F64
  #define DataReader_To_Bool Lucy_DataReader_To_Bool
  #define DataReader_Serialize Lucy_DataReader_Serialize
  #define DataReader_Deserialize Lucy_DataReader_Deserialize
  #define DataReader_Dump Lucy_DataReader_Dump
  #define DataReader_Load Lucy_DataReader_Load
  #define DataReader_Mimic Lucy_DataReader_Mimic
  #define DataReader_Aggregator Lucy_DataReader_Aggregator
  #define DataReader_Get_Schema Lucy_DataReader_Get_Schema
  #define DataReader_Get_Folder Lucy_DataReader_Get_Folder
  #define DataReader_Get_Snapshot Lucy_DataReader_Get_Snapshot
  #define DataReader_Get_Segments Lucy_DataReader_Get_Segments
  #define DataReader_Get_Segment Lucy_DataReader_Get_Segment
  #define DataReader_Get_Seg_Tick Lucy_DataReader_Get_Seg_Tick
  #define DataReader_Close Lucy_DataReader_Close
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DATAREADER */




