/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DATAWRITER
#define H_LUCY_INDEX_DATAWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DATAWRITER
struct lucy_DataWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
};

#endif /* C_LUCY_DATAWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DataWriter*
lucy_DataWriter_init(lucy_DataWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_DataWriter_destroy(lucy_DataWriter* self);

void
lucy_DataWriter_add_inverted_doc(lucy_DataWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
lucy_DataWriter_add_segment(lucy_DataWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_DataWriter_delete_segment(lucy_DataWriter* self, lucy_SegReader* reader);

void
lucy_DataWriter_merge_segment(lucy_DataWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_DataWriter_finish(lucy_DataWriter* self);

lucy_Hash*
lucy_DataWriter_metadata(lucy_DataWriter* self);

int32_t
lucy_DataWriter_format(lucy_DataWriter* self);

lucy_Snapshot*
lucy_DataWriter_get_snapshot(lucy_DataWriter* self);

lucy_Segment*
lucy_DataWriter_get_segment(lucy_DataWriter* self);

lucy_PolyReader*
lucy_DataWriter_get_polyreader(lucy_DataWriter* self);

lucy_Schema*
lucy_DataWriter_get_schema(lucy_DataWriter* self);

lucy_Folder*
lucy_DataWriter_get_folder(lucy_DataWriter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DataWriter_destroy_CALLBACK;
extern cfish_Callback lucy_DataWriter_add_inverted_doc_CALLBACK;
extern cfish_Callback lucy_DataWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_DataWriter_delete_segment_CALLBACK;
extern cfish_Callback lucy_DataWriter_merge_segment_CALLBACK;
extern cfish_Callback lucy_DataWriter_finish_CALLBACK;
extern cfish_Callback lucy_DataWriter_metadata_CALLBACK;
extern cfish_Callback lucy_DataWriter_format_CALLBACK;
extern cfish_Callback lucy_DataWriter_get_snapshot_CALLBACK;
extern cfish_Callback lucy_DataWriter_get_segment_CALLBACK;
extern cfish_Callback lucy_DataWriter_get_polyreader_CALLBACK;
extern cfish_Callback lucy_DataWriter_get_schema_CALLBACK;
extern cfish_Callback lucy_DataWriter_get_folder_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DataWriter_destroy_t)(lucy_DataWriter* self);

typedef void
(*lucy_DataWriter_add_inverted_doc_t)(lucy_DataWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*lucy_DataWriter_add_segment_t)(lucy_DataWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_DataWriter_delete_segment_t)(lucy_DataWriter* self, lucy_SegReader* reader);

typedef void
(*lucy_DataWriter_merge_segment_t)(lucy_DataWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_DataWriter_finish_t)(lucy_DataWriter* self);

typedef lucy_Hash*
(*lucy_DataWriter_metadata_t)(lucy_DataWriter* self);

typedef int32_t
(*lucy_DataWriter_format_t)(lucy_DataWriter* self);

typedef lucy_Snapshot*
(*lucy_DataWriter_get_snapshot_t)(lucy_DataWriter* self);

typedef lucy_Segment*
(*lucy_DataWriter_get_segment_t)(lucy_DataWriter* self);

typedef lucy_PolyReader*
(*lucy_DataWriter_get_polyreader_t)(lucy_DataWriter* self);

typedef lucy_Schema*
(*lucy_DataWriter_get_schema_t)(lucy_DataWriter* self);

typedef lucy_Folder*
(*lucy_DataWriter_get_folder_t)(lucy_DataWriter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DataWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataWriter_Make(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DataWriter_Get_RefCount(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataWriter_Inc_RefCount(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DataWriter_Dec_RefCount(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DataWriter_To_Host(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataWriter_Clone(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Destroy(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Destroy_OFFSET;
    const lucy_DataWriter_destroy_t method = *((lucy_DataWriter_destroy_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DataWriter_Equals(const lucy_DataWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DataWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DataWriter_Compare_To(const lucy_DataWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DataWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DataWriter_Hash_Sum(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DataWriter_Get_VTable(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DataWriter_Get_Class_Name(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DataWriter_Is_A(const lucy_DataWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DataWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DataWriter_To_String(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DataWriter_To_I64(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DataWriter_To_F64(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DataWriter_To_Bool(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Serialize(const lucy_DataWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DataWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataWriter_Deserialize(const lucy_DataWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DataWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataWriter_Dump(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DataWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DataWriter_Load(const lucy_DataWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DataWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Mimic(const lucy_DataWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DataWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Add_Inverted_Doc(const lucy_DataWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_DataWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Add_Segment(const lucy_DataWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Add_Segment_OFFSET;
    const lucy_DataWriter_add_segment_t method = *((lucy_DataWriter_add_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_DataWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Delete_Segment(const lucy_DataWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_DataWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Merge_Segment(const lucy_DataWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_DataWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_DataWriter_Finish(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Finish_OFFSET;
    const lucy_DataWriter_finish_t method = *((lucy_DataWriter_finish_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_DataWriter_Metadata(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_DataWriter_Format(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Format_OFFSET;
    const lucy_DataWriter_format_t method = *((lucy_DataWriter_format_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DataWriter_Get_Snapshot(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DataWriter_Get_Segment(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_DataWriter_Get_PolyReader(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DataWriter_Get_Schema(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DataWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DataWriter_Get_Folder(const lucy_DataWriter *self) {
    char *const method_address = *(char**)self + Lucy_DataWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DATAWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[34];
} LUCY_DATAWRITER_VT;
extern struct LUCY_DATAWRITER_VT LUCY_DATAWRITER_vt;
#define LUCY_DATAWRITER ((cfish_VTable*)&LUCY_DATAWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DataWriter lucy_DataWriter
  #define DATAWRITER LUCY_DATAWRITER
  #define DataWriter_init lucy_DataWriter_init
  #define DataWriter_destroy_t lucy_DataWriter_destroy_t
  #define DataWriter_destroy lucy_DataWriter_destroy
  #define DataWriter_add_inverted_doc_t lucy_DataWriter_add_inverted_doc_t
  #define DataWriter_add_inverted_doc lucy_DataWriter_add_inverted_doc
  #define DataWriter_add_segment_t lucy_DataWriter_add_segment_t
  #define DataWriter_add_segment lucy_DataWriter_add_segment
  #define DataWriter_delete_segment_t lucy_DataWriter_delete_segment_t
  #define DataWriter_delete_segment lucy_DataWriter_delete_segment
  #define DataWriter_merge_segment_t lucy_DataWriter_merge_segment_t
  #define DataWriter_merge_segment lucy_DataWriter_merge_segment
  #define DataWriter_finish_t lucy_DataWriter_finish_t
  #define DataWriter_finish lucy_DataWriter_finish
  #define DataWriter_metadata_t lucy_DataWriter_metadata_t
  #define DataWriter_metadata lucy_DataWriter_metadata
  #define DataWriter_format_t lucy_DataWriter_format_t
  #define DataWriter_format lucy_DataWriter_format
  #define DataWriter_get_snapshot_t lucy_DataWriter_get_snapshot_t
  #define DataWriter_get_snapshot lucy_DataWriter_get_snapshot
  #define DataWriter_get_segment_t lucy_DataWriter_get_segment_t
  #define DataWriter_get_segment lucy_DataWriter_get_segment
  #define DataWriter_get_polyreader_t lucy_DataWriter_get_polyreader_t
  #define DataWriter_get_polyreader lucy_DataWriter_get_polyreader
  #define DataWriter_get_schema_t lucy_DataWriter_get_schema_t
  #define DataWriter_get_schema lucy_DataWriter_get_schema
  #define DataWriter_get_folder_t lucy_DataWriter_get_folder_t
  #define DataWriter_get_folder lucy_DataWriter_get_folder
  #define DataWriter_Make Lucy_DataWriter_Make
  #define DataWriter_Get_RefCount Lucy_DataWriter_Get_RefCount
  #define DataWriter_Inc_RefCount Lucy_DataWriter_Inc_RefCount
  #define DataWriter_Dec_RefCount Lucy_DataWriter_Dec_RefCount
  #define DataWriter_To_Host Lucy_DataWriter_To_Host
  #define DataWriter_Clone Lucy_DataWriter_Clone
  #define DataWriter_Destroy Lucy_DataWriter_Destroy
  #define DataWriter_Equals Lucy_DataWriter_Equals
  #define DataWriter_Compare_To Lucy_DataWriter_Compare_To
  #define DataWriter_Hash_Sum Lucy_DataWriter_Hash_Sum
  #define DataWriter_Get_VTable Lucy_DataWriter_Get_VTable
  #define DataWriter_Get_Class_Name Lucy_DataWriter_Get_Class_Name
  #define DataWriter_Is_A Lucy_DataWriter_Is_A
  #define DataWriter_To_String Lucy_DataWriter_To_String
  #define DataWriter_To_I64 Lucy_DataWriter_To_I64
  #define DataWriter_To_F64 Lucy_DataWriter_To_F64
  #define DataWriter_To_Bool Lucy_DataWriter_To_Bool
  #define DataWriter_Serialize Lucy_DataWriter_Serialize
  #define DataWriter_Deserialize Lucy_DataWriter_Deserialize
  #define DataWriter_Dump Lucy_DataWriter_Dump
  #define DataWriter_Load Lucy_DataWriter_Load
  #define DataWriter_Mimic Lucy_DataWriter_Mimic
  #define DataWriter_Add_Inverted_Doc Lucy_DataWriter_Add_Inverted_Doc
  #define DataWriter_Add_Segment Lucy_DataWriter_Add_Segment
  #define DataWriter_Delete_Segment Lucy_DataWriter_Delete_Segment
  #define DataWriter_Merge_Segment Lucy_DataWriter_Merge_Segment
  #define DataWriter_Finish Lucy_DataWriter_Finish
  #define DataWriter_Metadata Lucy_DataWriter_Metadata
  #define DataWriter_Format Lucy_DataWriter_Format
  #define DataWriter_Get_Snapshot Lucy_DataWriter_Get_Snapshot
  #define DataWriter_Get_Segment Lucy_DataWriter_Get_Segment
  #define DataWriter_Get_PolyReader Lucy_DataWriter_Get_PolyReader
  #define DataWriter_Get_Schema Lucy_DataWriter_Get_Schema
  #define DataWriter_Get_Folder Lucy_DataWriter_Get_Folder
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DATAWRITER */




