/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DELETIONSREADER
#define H_LUCY_INDEX_DELETIONSREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DELETIONSREADER
struct lucy_DeletionsReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_DELETIONSREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DeletionsReader*
lucy_DelReader_init(lucy_DeletionsReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DeletionsReader*
lucy_DelReader_aggregator(lucy_DeletionsReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

int32_t
lucy_DelReader_del_count(lucy_DeletionsReader* self);

lucy_Matcher*
lucy_DelReader_iterator(lucy_DeletionsReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DelReader_aggregator_CALLBACK;
extern cfish_Callback lucy_DelReader_del_count_CALLBACK;
extern cfish_Callback lucy_DelReader_iterator_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_DeletionsReader*
(*lucy_DelReader_aggregator_t)(lucy_DeletionsReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef int32_t
(*lucy_DelReader_del_count_t)(lucy_DeletionsReader* self);

typedef lucy_Matcher*
(*lucy_DelReader_iterator_t)(lucy_DeletionsReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DelReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelReader_Make(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DelReader_Get_RefCount(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelReader_Inc_RefCount(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DelReader_Dec_RefCount(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DelReader_To_Host(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelReader_Clone(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DelReader_Destroy(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelReader_Equals(const lucy_DeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DelReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DelReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DelReader_Compare_To(const lucy_DeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DelReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DelReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DelReader_Hash_Sum(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DelReader_Get_VTable(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DelReader_Get_Class_Name(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelReader_Is_A(const lucy_DeletionsReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DelReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DelReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DelReader_To_String(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DelReader_To_I64(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DelReader_To_F64(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelReader_To_Bool(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DelReader_Serialize(const lucy_DeletionsReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DelReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DelReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelReader_Deserialize(const lucy_DeletionsReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DelReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DelReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelReader_Dump(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelReader_Load(const lucy_DeletionsReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DelReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DelReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DelReader_Mimic(const lucy_DeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DelReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DelReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DeletionsReader*
Lucy_DelReader_Aggregator(const lucy_DeletionsReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DelReader_Aggregator_OFFSET;
    const lucy_DelReader_aggregator_t method = *((lucy_DelReader_aggregator_t*)method_address);
    return method((lucy_DeletionsReader*)self, readers, offsets);
}

extern size_t Lucy_DelReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DelReader_Get_Schema(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DelReader_Get_Folder(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DelReader_Get_Snapshot(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DelReader_Get_Segments(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DelReader_Get_Segment(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DelReader_Get_Seg_Tick(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DelReader_Close(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_DelReader_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_DelReader_Del_Count(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Del_Count_OFFSET;
    const lucy_DelReader_del_count_t method = *((lucy_DelReader_del_count_t*)method_address);
    return method((lucy_DeletionsReader*)self);
}

extern size_t Lucy_DelReader_Iterator_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_DelReader_Iterator(const lucy_DeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DelReader_Iterator_OFFSET;
    const lucy_DelReader_iterator_t method = *((lucy_DelReader_iterator_t*)method_address);
    return method((lucy_DeletionsReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DELETIONSREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_DELETIONSREADER_VT;
extern struct LUCY_DELETIONSREADER_VT LUCY_DELETIONSREADER_vt;
#define LUCY_DELETIONSREADER ((cfish_VTable*)&LUCY_DELETIONSREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DeletionsReader lucy_DeletionsReader
  #define DELETIONSREADER LUCY_DELETIONSREADER
  #define DelReader_init lucy_DelReader_init
  #define DelReader_aggregator_t lucy_DelReader_aggregator_t
  #define DelReader_aggregator lucy_DelReader_aggregator
  #define DelReader_del_count_t lucy_DelReader_del_count_t
  #define DelReader_del_count lucy_DelReader_del_count
  #define DelReader_iterator_t lucy_DelReader_iterator_t
  #define DelReader_iterator lucy_DelReader_iterator
  #define DelReader_Make Lucy_DelReader_Make
  #define DelReader_Get_RefCount Lucy_DelReader_Get_RefCount
  #define DelReader_Inc_RefCount Lucy_DelReader_Inc_RefCount
  #define DelReader_Dec_RefCount Lucy_DelReader_Dec_RefCount
  #define DelReader_To_Host Lucy_DelReader_To_Host
  #define DelReader_Clone Lucy_DelReader_Clone
  #define DelReader_Destroy Lucy_DelReader_Destroy
  #define DelReader_Equals Lucy_DelReader_Equals
  #define DelReader_Compare_To Lucy_DelReader_Compare_To
  #define DelReader_Hash_Sum Lucy_DelReader_Hash_Sum
  #define DelReader_Get_VTable Lucy_DelReader_Get_VTable
  #define DelReader_Get_Class_Name Lucy_DelReader_Get_Class_Name
  #define DelReader_Is_A Lucy_DelReader_Is_A
  #define DelReader_To_String Lucy_DelReader_To_String
  #define DelReader_To_I64 Lucy_DelReader_To_I64
  #define DelReader_To_F64 Lucy_DelReader_To_F64
  #define DelReader_To_Bool Lucy_DelReader_To_Bool
  #define DelReader_Serialize Lucy_DelReader_Serialize
  #define DelReader_Deserialize Lucy_DelReader_Deserialize
  #define DelReader_Dump Lucy_DelReader_Dump
  #define DelReader_Load Lucy_DelReader_Load
  #define DelReader_Mimic Lucy_DelReader_Mimic
  #define DelReader_Aggregator Lucy_DelReader_Aggregator
  #define DelReader_Get_Schema Lucy_DelReader_Get_Schema
  #define DelReader_Get_Folder Lucy_DelReader_Get_Folder
  #define DelReader_Get_Snapshot Lucy_DelReader_Get_Snapshot
  #define DelReader_Get_Segments Lucy_DelReader_Get_Segments
  #define DelReader_Get_Segment Lucy_DelReader_Get_Segment
  #define DelReader_Get_Seg_Tick Lucy_DelReader_Get_Seg_Tick
  #define DelReader_Close Lucy_DelReader_Close
  #define DelReader_Del_Count Lucy_DelReader_Del_Count
  #define DelReader_Iterator Lucy_DelReader_Iterator
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DeletionsReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYDELETIONSREADER
struct lucy_PolyDeletionsReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_VArray* readers;
    lucy_I32Array* offsets;
    int32_t del_count;
};

#endif /* C_LUCY_POLYDELETIONSREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyDeletionsReader*
lucy_PolyDelReader_new(lucy_VArray* readers, lucy_I32Array* offsets);

lucy_PolyDeletionsReader*
lucy_PolyDelReader_init(lucy_PolyDeletionsReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

void
lucy_PolyDelReader_destroy(lucy_PolyDeletionsReader* self);

void
lucy_PolyDelReader_close(lucy_PolyDeletionsReader* self);

int32_t
lucy_PolyDelReader_del_count(lucy_PolyDeletionsReader* self);

lucy_Matcher*
lucy_PolyDelReader_iterator(lucy_PolyDeletionsReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyDelReader_destroy_CALLBACK;
extern cfish_Callback lucy_PolyDelReader_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyDelReader_destroy_t)(lucy_PolyDeletionsReader* self);

typedef void
(*lucy_PolyDelReader_close_t)(lucy_PolyDeletionsReader* self);

typedef int32_t
(*lucy_PolyDelReader_del_count_t)(lucy_PolyDeletionsReader* self);

typedef lucy_Matcher*
(*lucy_PolyDelReader_iterator_t)(lucy_PolyDeletionsReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyDelReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDelReader_Make(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyDelReader_Get_RefCount(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDelReader_Inc_RefCount(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyDelReader_Dec_RefCount(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyDelReader_To_Host(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDelReader_Clone(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyDelReader_Destroy(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Destroy_OFFSET;
    const lucy_PolyDelReader_destroy_t method = *((lucy_PolyDelReader_destroy_t*)method_address);
    method((lucy_PolyDeletionsReader*)self);
}

extern size_t Lucy_PolyDelReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyDelReader_Equals(const lucy_PolyDeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyDelReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDelReader_Compare_To(const lucy_PolyDeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyDelReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDelReader_Hash_Sum(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyDelReader_Get_VTable(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyDelReader_Get_Class_Name(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyDelReader_Is_A(const lucy_PolyDeletionsReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyDelReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyDelReader_To_String(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyDelReader_To_I64(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyDelReader_To_F64(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyDelReader_To_Bool(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyDelReader_Serialize(const lucy_PolyDeletionsReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyDelReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDelReader_Deserialize(const lucy_PolyDeletionsReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyDelReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDelReader_Dump(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDelReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDelReader_Load(const lucy_PolyDeletionsReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolyDelReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyDelReader_Mimic(const lucy_PolyDeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyDelReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DeletionsReader*
Lucy_PolyDelReader_Aggregator(const lucy_PolyDeletionsReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Aggregator_OFFSET;
    const lucy_DelReader_aggregator_t method = *((lucy_DelReader_aggregator_t*)method_address);
    return method((lucy_DeletionsReader*)self, readers, offsets);
}

extern size_t Lucy_PolyDelReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PolyDelReader_Get_Schema(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDelReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PolyDelReader_Get_Folder(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDelReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PolyDelReader_Get_Snapshot(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDelReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyDelReader_Get_Segments(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDelReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PolyDelReader_Get_Segment(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDelReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDelReader_Get_Seg_Tick(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDelReader_Close_OFFSET;
static CHY_INLINE void
Lucy_PolyDelReader_Close(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Close_OFFSET;
    const lucy_PolyDelReader_close_t method = *((lucy_PolyDelReader_close_t*)method_address);
    method((lucy_PolyDeletionsReader*)self);
}

extern size_t Lucy_PolyDelReader_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDelReader_Del_Count(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Del_Count_OFFSET;
    const lucy_PolyDelReader_del_count_t method = *((lucy_PolyDelReader_del_count_t*)method_address);
    return method((lucy_PolyDeletionsReader*)self);
}

extern size_t Lucy_PolyDelReader_Iterator_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_PolyDelReader_Iterator(const lucy_PolyDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDelReader_Iterator_OFFSET;
    const lucy_PolyDelReader_iterator_t method = *((lucy_PolyDelReader_iterator_t*)method_address);
    return method((lucy_PolyDeletionsReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYDELETIONSREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_POLYDELETIONSREADER_VT;
extern struct LUCY_POLYDELETIONSREADER_VT LUCY_POLYDELETIONSREADER_vt;
#define LUCY_POLYDELETIONSREADER ((cfish_VTable*)&LUCY_POLYDELETIONSREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyDeletionsReader lucy_PolyDeletionsReader
  #define POLYDELETIONSREADER LUCY_POLYDELETIONSREADER
  #define PolyDelReader_new lucy_PolyDelReader_new
  #define PolyDelReader_init lucy_PolyDelReader_init
  #define PolyDelReader_destroy_t lucy_PolyDelReader_destroy_t
  #define PolyDelReader_destroy lucy_PolyDelReader_destroy
  #define PolyDelReader_close_t lucy_PolyDelReader_close_t
  #define PolyDelReader_close lucy_PolyDelReader_close
  #define PolyDelReader_del_count_t lucy_PolyDelReader_del_count_t
  #define PolyDelReader_del_count lucy_PolyDelReader_del_count
  #define PolyDelReader_iterator_t lucy_PolyDelReader_iterator_t
  #define PolyDelReader_iterator lucy_PolyDelReader_iterator
  #define PolyDelReader_Make Lucy_PolyDelReader_Make
  #define PolyDelReader_Get_RefCount Lucy_PolyDelReader_Get_RefCount
  #define PolyDelReader_Inc_RefCount Lucy_PolyDelReader_Inc_RefCount
  #define PolyDelReader_Dec_RefCount Lucy_PolyDelReader_Dec_RefCount
  #define PolyDelReader_To_Host Lucy_PolyDelReader_To_Host
  #define PolyDelReader_Clone Lucy_PolyDelReader_Clone
  #define PolyDelReader_Destroy Lucy_PolyDelReader_Destroy
  #define PolyDelReader_Equals Lucy_PolyDelReader_Equals
  #define PolyDelReader_Compare_To Lucy_PolyDelReader_Compare_To
  #define PolyDelReader_Hash_Sum Lucy_PolyDelReader_Hash_Sum
  #define PolyDelReader_Get_VTable Lucy_PolyDelReader_Get_VTable
  #define PolyDelReader_Get_Class_Name Lucy_PolyDelReader_Get_Class_Name
  #define PolyDelReader_Is_A Lucy_PolyDelReader_Is_A
  #define PolyDelReader_To_String Lucy_PolyDelReader_To_String
  #define PolyDelReader_To_I64 Lucy_PolyDelReader_To_I64
  #define PolyDelReader_To_F64 Lucy_PolyDelReader_To_F64
  #define PolyDelReader_To_Bool Lucy_PolyDelReader_To_Bool
  #define PolyDelReader_Serialize Lucy_PolyDelReader_Serialize
  #define PolyDelReader_Deserialize Lucy_PolyDelReader_Deserialize
  #define PolyDelReader_Dump Lucy_PolyDelReader_Dump
  #define PolyDelReader_Load Lucy_PolyDelReader_Load
  #define PolyDelReader_Mimic Lucy_PolyDelReader_Mimic
  #define PolyDelReader_Aggregator Lucy_PolyDelReader_Aggregator
  #define PolyDelReader_Get_Schema Lucy_PolyDelReader_Get_Schema
  #define PolyDelReader_Get_Folder Lucy_PolyDelReader_Get_Folder
  #define PolyDelReader_Get_Snapshot Lucy_PolyDelReader_Get_Snapshot
  #define PolyDelReader_Get_Segments Lucy_PolyDelReader_Get_Segments
  #define PolyDelReader_Get_Segment Lucy_PolyDelReader_Get_Segment
  #define PolyDelReader_Get_Seg_Tick Lucy_PolyDelReader_Get_Seg_Tick
  #define PolyDelReader_Close Lucy_PolyDelReader_Close
  #define PolyDelReader_Del_Count Lucy_PolyDelReader_Del_Count
  #define PolyDelReader_Iterator Lucy_PolyDelReader_Iterator
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DeletionsReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTDELETIONSREADER
struct lucy_DefaultDeletionsReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_BitVector* deldocs;
    int32_t del_count;
};

#endif /* C_LUCY_DEFAULTDELETIONSREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultDeletionsReader*
lucy_DefDelReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DefaultDeletionsReader*
lucy_DefDelReader_init(lucy_DefaultDeletionsReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_DefDelReader_destroy(lucy_DefaultDeletionsReader* self);

void
lucy_DefDelReader_close(lucy_DefaultDeletionsReader* self);

int32_t
lucy_DefDelReader_del_count(lucy_DefaultDeletionsReader* self);

lucy_Matcher*
lucy_DefDelReader_iterator(lucy_DefaultDeletionsReader* self);

lucy_BitVector*
lucy_DefDelReader_read_deletions(lucy_DefaultDeletionsReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefDelReader_destroy_CALLBACK;
extern cfish_Callback lucy_DefDelReader_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefDelReader_destroy_t)(lucy_DefaultDeletionsReader* self);

typedef void
(*lucy_DefDelReader_close_t)(lucy_DefaultDeletionsReader* self);

typedef int32_t
(*lucy_DefDelReader_del_count_t)(lucy_DefaultDeletionsReader* self);

typedef lucy_Matcher*
(*lucy_DefDelReader_iterator_t)(lucy_DefaultDeletionsReader* self);

typedef lucy_BitVector*
(*lucy_DefDelReader_read_deletions_t)(lucy_DefaultDeletionsReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefDelReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelReader_Make(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefDelReader_Get_RefCount(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelReader_Inc_RefCount(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefDelReader_Dec_RefCount(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefDelReader_To_Host(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelReader_Clone(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefDelReader_Destroy(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Destroy_OFFSET;
    const lucy_DefDelReader_destroy_t method = *((lucy_DefDelReader_destroy_t*)method_address);
    method((lucy_DefaultDeletionsReader*)self);
}

extern size_t Lucy_DefDelReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelReader_Equals(const lucy_DefaultDeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDelReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelReader_Compare_To(const lucy_DefaultDeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDelReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelReader_Hash_Sum(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefDelReader_Get_VTable(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefDelReader_Get_Class_Name(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelReader_Is_A(const lucy_DefaultDeletionsReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefDelReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefDelReader_To_String(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefDelReader_To_I64(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefDelReader_To_F64(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelReader_To_Bool(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefDelReader_Serialize(const lucy_DefaultDeletionsReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefDelReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelReader_Deserialize(const lucy_DefaultDeletionsReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefDelReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelReader_Dump(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelReader_Load(const lucy_DefaultDeletionsReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefDelReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefDelReader_Mimic(const lucy_DefaultDeletionsReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDelReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DeletionsReader*
Lucy_DefDelReader_Aggregator(const lucy_DefaultDeletionsReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Aggregator_OFFSET;
    const lucy_DelReader_aggregator_t method = *((lucy_DelReader_aggregator_t*)method_address);
    return method((lucy_DeletionsReader*)self, readers, offsets);
}

extern size_t Lucy_DefDelReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefDelReader_Get_Schema(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDelReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefDelReader_Get_Folder(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDelReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefDelReader_Get_Snapshot(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDelReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DefDelReader_Get_Segments(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDelReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefDelReader_Get_Segment(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDelReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelReader_Get_Seg_Tick(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDelReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DefDelReader_Close(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Close_OFFSET;
    const lucy_DefDelReader_close_t method = *((lucy_DefDelReader_close_t*)method_address);
    method((lucy_DefaultDeletionsReader*)self);
}

extern size_t Lucy_DefDelReader_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelReader_Del_Count(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Del_Count_OFFSET;
    const lucy_DefDelReader_del_count_t method = *((lucy_DefDelReader_del_count_t*)method_address);
    return method((lucy_DefaultDeletionsReader*)self);
}

extern size_t Lucy_DefDelReader_Iterator_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_DefDelReader_Iterator(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Iterator_OFFSET;
    const lucy_DefDelReader_iterator_t method = *((lucy_DefDelReader_iterator_t*)method_address);
    return method((lucy_DefaultDeletionsReader*)self);
}

extern size_t Lucy_DefDelReader_Read_Deletions_OFFSET;
static CHY_INLINE lucy_BitVector*
Lucy_DefDelReader_Read_Deletions(const lucy_DefaultDeletionsReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDelReader_Read_Deletions_OFFSET;
    const lucy_DefDelReader_read_deletions_t method = *((lucy_DefDelReader_read_deletions_t*)method_address);
    return method((lucy_DefaultDeletionsReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTDELETIONSREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_DEFAULTDELETIONSREADER_VT;
extern struct LUCY_DEFAULTDELETIONSREADER_VT LUCY_DEFAULTDELETIONSREADER_vt;
#define LUCY_DEFAULTDELETIONSREADER ((cfish_VTable*)&LUCY_DEFAULTDELETIONSREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultDeletionsReader lucy_DefaultDeletionsReader
  #define DEFAULTDELETIONSREADER LUCY_DEFAULTDELETIONSREADER
  #define DefDelReader_new lucy_DefDelReader_new
  #define DefDelReader_init lucy_DefDelReader_init
  #define DefDelReader_destroy_t lucy_DefDelReader_destroy_t
  #define DefDelReader_destroy lucy_DefDelReader_destroy
  #define DefDelReader_close_t lucy_DefDelReader_close_t
  #define DefDelReader_close lucy_DefDelReader_close
  #define DefDelReader_del_count_t lucy_DefDelReader_del_count_t
  #define DefDelReader_del_count lucy_DefDelReader_del_count
  #define DefDelReader_iterator_t lucy_DefDelReader_iterator_t
  #define DefDelReader_iterator lucy_DefDelReader_iterator
  #define DefDelReader_read_deletions_t lucy_DefDelReader_read_deletions_t
  #define DefDelReader_read_deletions lucy_DefDelReader_read_deletions
  #define DefDelReader_Make Lucy_DefDelReader_Make
  #define DefDelReader_Get_RefCount Lucy_DefDelReader_Get_RefCount
  #define DefDelReader_Inc_RefCount Lucy_DefDelReader_Inc_RefCount
  #define DefDelReader_Dec_RefCount Lucy_DefDelReader_Dec_RefCount
  #define DefDelReader_To_Host Lucy_DefDelReader_To_Host
  #define DefDelReader_Clone Lucy_DefDelReader_Clone
  #define DefDelReader_Destroy Lucy_DefDelReader_Destroy
  #define DefDelReader_Equals Lucy_DefDelReader_Equals
  #define DefDelReader_Compare_To Lucy_DefDelReader_Compare_To
  #define DefDelReader_Hash_Sum Lucy_DefDelReader_Hash_Sum
  #define DefDelReader_Get_VTable Lucy_DefDelReader_Get_VTable
  #define DefDelReader_Get_Class_Name Lucy_DefDelReader_Get_Class_Name
  #define DefDelReader_Is_A Lucy_DefDelReader_Is_A
  #define DefDelReader_To_String Lucy_DefDelReader_To_String
  #define DefDelReader_To_I64 Lucy_DefDelReader_To_I64
  #define DefDelReader_To_F64 Lucy_DefDelReader_To_F64
  #define DefDelReader_To_Bool Lucy_DefDelReader_To_Bool
  #define DefDelReader_Serialize Lucy_DefDelReader_Serialize
  #define DefDelReader_Deserialize Lucy_DefDelReader_Deserialize
  #define DefDelReader_Dump Lucy_DefDelReader_Dump
  #define DefDelReader_Load Lucy_DefDelReader_Load
  #define DefDelReader_Mimic Lucy_DefDelReader_Mimic
  #define DefDelReader_Aggregator Lucy_DefDelReader_Aggregator
  #define DefDelReader_Get_Schema Lucy_DefDelReader_Get_Schema
  #define DefDelReader_Get_Folder Lucy_DefDelReader_Get_Folder
  #define DefDelReader_Get_Snapshot Lucy_DefDelReader_Get_Snapshot
  #define DefDelReader_Get_Segments Lucy_DefDelReader_Get_Segments
  #define DefDelReader_Get_Segment Lucy_DefDelReader_Get_Segment
  #define DefDelReader_Get_Seg_Tick Lucy_DefDelReader_Get_Seg_Tick
  #define DefDelReader_Close Lucy_DefDelReader_Close
  #define DefDelReader_Del_Count Lucy_DefDelReader_Del_Count
  #define DefDelReader_Iterator Lucy_DefDelReader_Iterator
  #define DefDelReader_Read_Deletions Lucy_DefDelReader_Read_Deletions
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DELETIONSREADER */




