/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DELETIONSWRITER
#define H_LUCY_INDEX_DELETIONSWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DELETIONSWRITER
struct lucy_DeletionsWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
};

#endif /* C_LUCY_DELETIONSWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DeletionsWriter*
lucy_DelWriter_init(lucy_DeletionsWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_DelWriter_delete_by_term(lucy_DeletionsWriter* self, const lucy_CharBuf* field, lucy_Obj* term);

void
lucy_DelWriter_delete_by_query(lucy_DeletionsWriter* self, lucy_Query* query);

void
lucy_DelWriter_delete_by_doc_id(lucy_DeletionsWriter* self, int32_t doc_id);

chy_bool_t
lucy_DelWriter_updated(lucy_DeletionsWriter* self);

lucy_I32Array*
lucy_DelWriter_generate_doc_map(lucy_DeletionsWriter* self, lucy_Matcher* deletions, int32_t doc_max, int32_t offset);

lucy_Matcher*
lucy_DelWriter_seg_deletions(lucy_DeletionsWriter* self, lucy_SegReader* seg_reader);

int32_t
lucy_DelWriter_seg_del_count(lucy_DeletionsWriter* self, const lucy_CharBuf* seg_name);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DelWriter_delete_by_term_CALLBACK;
extern cfish_Callback lucy_DelWriter_delete_by_query_CALLBACK;
extern cfish_Callback lucy_DelWriter_delete_by_doc_id_CALLBACK;
extern cfish_Callback lucy_DelWriter_updated_CALLBACK;
extern cfish_Callback lucy_DelWriter_generate_doc_map_CALLBACK;
extern cfish_Callback lucy_DelWriter_seg_deletions_CALLBACK;
extern cfish_Callback lucy_DelWriter_seg_del_count_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DelWriter_delete_by_term_t)(lucy_DeletionsWriter* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef void
(*lucy_DelWriter_delete_by_query_t)(lucy_DeletionsWriter* self, lucy_Query* query);

typedef void
(*lucy_DelWriter_delete_by_doc_id_t)(lucy_DeletionsWriter* self, int32_t doc_id);

typedef chy_bool_t
(*lucy_DelWriter_updated_t)(lucy_DeletionsWriter* self);

typedef lucy_I32Array*
(*lucy_DelWriter_generate_doc_map_t)(lucy_DeletionsWriter* self, lucy_Matcher* deletions, int32_t doc_max, int32_t offset);

typedef lucy_Matcher*
(*lucy_DelWriter_seg_deletions_t)(lucy_DeletionsWriter* self, lucy_SegReader* seg_reader);

typedef int32_t
(*lucy_DelWriter_seg_del_count_t)(lucy_DeletionsWriter* self, const lucy_CharBuf* seg_name);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DelWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelWriter_Make(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DelWriter_Get_RefCount(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelWriter_Inc_RefCount(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DelWriter_Dec_RefCount(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DelWriter_To_Host(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelWriter_Clone(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Destroy(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Destroy_OFFSET;
    const lucy_DataWriter_destroy_t method = *((lucy_DataWriter_destroy_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelWriter_Equals(const lucy_DeletionsWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DelWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DelWriter_Compare_To(const lucy_DeletionsWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DelWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DelWriter_Hash_Sum(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DelWriter_Get_VTable(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DelWriter_Get_Class_Name(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelWriter_Is_A(const lucy_DeletionsWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DelWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DelWriter_To_String(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DelWriter_To_I64(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DelWriter_To_F64(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelWriter_To_Bool(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Serialize(const lucy_DeletionsWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DelWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelWriter_Deserialize(const lucy_DeletionsWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DelWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelWriter_Dump(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DelWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DelWriter_Load(const lucy_DeletionsWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DelWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Mimic(const lucy_DeletionsWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DelWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Add_Inverted_Doc(const lucy_DeletionsWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_DelWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Add_Segment(const lucy_DeletionsWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Add_Segment_OFFSET;
    const lucy_DataWriter_add_segment_t method = *((lucy_DataWriter_add_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_DelWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Delete_Segment(const lucy_DeletionsWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_DelWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Merge_Segment(const lucy_DeletionsWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_DelWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Finish(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Finish_OFFSET;
    const lucy_DataWriter_finish_t method = *((lucy_DataWriter_finish_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_DelWriter_Metadata(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_DelWriter_Format(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Format_OFFSET;
    const lucy_DataWriter_format_t method = *((lucy_DataWriter_format_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DelWriter_Get_Snapshot(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DelWriter_Get_Segment(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_DelWriter_Get_PolyReader(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DelWriter_Get_Schema(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DelWriter_Get_Folder(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DelWriter_Delete_By_Term_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Delete_By_Term(const lucy_DeletionsWriter *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Delete_By_Term_OFFSET;
    const lucy_DelWriter_delete_by_term_t method = *((lucy_DelWriter_delete_by_term_t*)method_address);
    method((lucy_DeletionsWriter*)self, field, term);
}

extern size_t Lucy_DelWriter_Delete_By_Query_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Delete_By_Query(const lucy_DeletionsWriter *self, lucy_Query* query) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Delete_By_Query_OFFSET;
    const lucy_DelWriter_delete_by_query_t method = *((lucy_DelWriter_delete_by_query_t*)method_address);
    method((lucy_DeletionsWriter*)self, query);
}

extern size_t Lucy_DelWriter_Delete_By_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_DelWriter_Delete_By_Doc_ID(const lucy_DeletionsWriter *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Delete_By_Doc_ID_OFFSET;
    const lucy_DelWriter_delete_by_doc_id_t method = *((lucy_DelWriter_delete_by_doc_id_t*)method_address);
    method((lucy_DeletionsWriter*)self, doc_id);
}

extern size_t Lucy_DelWriter_Updated_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DelWriter_Updated(const lucy_DeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Updated_OFFSET;
    const lucy_DelWriter_updated_t method = *((lucy_DelWriter_updated_t*)method_address);
    return method((lucy_DeletionsWriter*)self);
}

extern size_t Lucy_DelWriter_Generate_Doc_Map_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_DelWriter_Generate_Doc_Map(const lucy_DeletionsWriter *self, lucy_Matcher* deletions, int32_t doc_max, int32_t offset) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Generate_Doc_Map_OFFSET;
    const lucy_DelWriter_generate_doc_map_t method = *((lucy_DelWriter_generate_doc_map_t*)method_address);
    return method((lucy_DeletionsWriter*)self, deletions, doc_max, offset);
}

extern size_t Lucy_DelWriter_Seg_Deletions_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_DelWriter_Seg_Deletions(const lucy_DeletionsWriter *self, lucy_SegReader* seg_reader) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Seg_Deletions_OFFSET;
    const lucy_DelWriter_seg_deletions_t method = *((lucy_DelWriter_seg_deletions_t*)method_address);
    return method((lucy_DeletionsWriter*)self, seg_reader);
}

extern size_t Lucy_DelWriter_Seg_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_DelWriter_Seg_Del_Count(const lucy_DeletionsWriter *self, const lucy_CharBuf* seg_name) {
    char *const method_address = *(char**)self + Lucy_DelWriter_Seg_Del_Count_OFFSET;
    const lucy_DelWriter_seg_del_count_t method = *((lucy_DelWriter_seg_del_count_t*)method_address);
    return method((lucy_DeletionsWriter*)self, seg_name);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DELETIONSWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[41];
} LUCY_DELETIONSWRITER_VT;
extern struct LUCY_DELETIONSWRITER_VT LUCY_DELETIONSWRITER_vt;
#define LUCY_DELETIONSWRITER ((cfish_VTable*)&LUCY_DELETIONSWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DeletionsWriter lucy_DeletionsWriter
  #define DELETIONSWRITER LUCY_DELETIONSWRITER
  #define DelWriter_init lucy_DelWriter_init
  #define DelWriter_delete_by_term_t lucy_DelWriter_delete_by_term_t
  #define DelWriter_delete_by_term lucy_DelWriter_delete_by_term
  #define DelWriter_delete_by_query_t lucy_DelWriter_delete_by_query_t
  #define DelWriter_delete_by_query lucy_DelWriter_delete_by_query
  #define DelWriter_delete_by_doc_id_t lucy_DelWriter_delete_by_doc_id_t
  #define DelWriter_delete_by_doc_id lucy_DelWriter_delete_by_doc_id
  #define DelWriter_updated_t lucy_DelWriter_updated_t
  #define DelWriter_updated lucy_DelWriter_updated
  #define DelWriter_generate_doc_map_t lucy_DelWriter_generate_doc_map_t
  #define DelWriter_generate_doc_map lucy_DelWriter_generate_doc_map
  #define DelWriter_seg_deletions_t lucy_DelWriter_seg_deletions_t
  #define DelWriter_seg_deletions lucy_DelWriter_seg_deletions
  #define DelWriter_seg_del_count_t lucy_DelWriter_seg_del_count_t
  #define DelWriter_seg_del_count lucy_DelWriter_seg_del_count
  #define DelWriter_Make Lucy_DelWriter_Make
  #define DelWriter_Get_RefCount Lucy_DelWriter_Get_RefCount
  #define DelWriter_Inc_RefCount Lucy_DelWriter_Inc_RefCount
  #define DelWriter_Dec_RefCount Lucy_DelWriter_Dec_RefCount
  #define DelWriter_To_Host Lucy_DelWriter_To_Host
  #define DelWriter_Clone Lucy_DelWriter_Clone
  #define DelWriter_Destroy Lucy_DelWriter_Destroy
  #define DelWriter_Equals Lucy_DelWriter_Equals
  #define DelWriter_Compare_To Lucy_DelWriter_Compare_To
  #define DelWriter_Hash_Sum Lucy_DelWriter_Hash_Sum
  #define DelWriter_Get_VTable Lucy_DelWriter_Get_VTable
  #define DelWriter_Get_Class_Name Lucy_DelWriter_Get_Class_Name
  #define DelWriter_Is_A Lucy_DelWriter_Is_A
  #define DelWriter_To_String Lucy_DelWriter_To_String
  #define DelWriter_To_I64 Lucy_DelWriter_To_I64
  #define DelWriter_To_F64 Lucy_DelWriter_To_F64
  #define DelWriter_To_Bool Lucy_DelWriter_To_Bool
  #define DelWriter_Serialize Lucy_DelWriter_Serialize
  #define DelWriter_Deserialize Lucy_DelWriter_Deserialize
  #define DelWriter_Dump Lucy_DelWriter_Dump
  #define DelWriter_Load Lucy_DelWriter_Load
  #define DelWriter_Mimic Lucy_DelWriter_Mimic
  #define DelWriter_Add_Inverted_Doc Lucy_DelWriter_Add_Inverted_Doc
  #define DelWriter_Add_Segment Lucy_DelWriter_Add_Segment
  #define DelWriter_Delete_Segment Lucy_DelWriter_Delete_Segment
  #define DelWriter_Merge_Segment Lucy_DelWriter_Merge_Segment
  #define DelWriter_Finish Lucy_DelWriter_Finish
  #define DelWriter_Metadata Lucy_DelWriter_Metadata
  #define DelWriter_Format Lucy_DelWriter_Format
  #define DelWriter_Get_Snapshot Lucy_DelWriter_Get_Snapshot
  #define DelWriter_Get_Segment Lucy_DelWriter_Get_Segment
  #define DelWriter_Get_PolyReader Lucy_DelWriter_Get_PolyReader
  #define DelWriter_Get_Schema Lucy_DelWriter_Get_Schema
  #define DelWriter_Get_Folder Lucy_DelWriter_Get_Folder
  #define DelWriter_Delete_By_Term Lucy_DelWriter_Delete_By_Term
  #define DelWriter_Delete_By_Query Lucy_DelWriter_Delete_By_Query
  #define DelWriter_Delete_By_Doc_ID Lucy_DelWriter_Delete_By_Doc_ID
  #define DelWriter_Updated Lucy_DelWriter_Updated
  #define DelWriter_Generate_Doc_Map Lucy_DelWriter_Generate_Doc_Map
  #define DelWriter_Seg_Deletions Lucy_DelWriter_Seg_Deletions
  #define DelWriter_Seg_Del_Count Lucy_DelWriter_Seg_Del_Count
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DeletionsWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTDELETIONSWRITER
struct lucy_DefaultDeletionsWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_VArray* seg_readers;
    lucy_Hash* name_to_tick;
    lucy_I32Array* seg_starts;
    lucy_VArray* bit_vecs;
    chy_bool_t* updated;
    lucy_IndexSearcher* searcher;
};

#endif /* C_LUCY_DEFAULTDELETIONSWRITER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_DefDelWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultDeletionsWriter*
lucy_DefDelWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

lucy_DefaultDeletionsWriter*
lucy_DefDelWriter_init(lucy_DefaultDeletionsWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_DefDelWriter_destroy(lucy_DefaultDeletionsWriter* self);

void
lucy_DefDelWriter_add_segment(lucy_DefaultDeletionsWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_DefDelWriter_merge_segment(lucy_DefaultDeletionsWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_DefDelWriter_finish(lucy_DefaultDeletionsWriter* self);

lucy_Hash*
lucy_DefDelWriter_metadata(lucy_DefaultDeletionsWriter* self);

int32_t
lucy_DefDelWriter_format(lucy_DefaultDeletionsWriter* self);

void
lucy_DefDelWriter_delete_by_term(lucy_DefaultDeletionsWriter* self, const lucy_CharBuf* field, lucy_Obj* term);

void
lucy_DefDelWriter_delete_by_query(lucy_DefaultDeletionsWriter* self, lucy_Query* query);

void
lucy_DefDelWriter_delete_by_doc_id(lucy_DefaultDeletionsWriter* self, int32_t doc_id);

chy_bool_t
lucy_DefDelWriter_updated(lucy_DefaultDeletionsWriter* self);

lucy_Matcher*
lucy_DefDelWriter_seg_deletions(lucy_DefaultDeletionsWriter* self, lucy_SegReader* seg_reader);

int32_t
lucy_DefDelWriter_seg_del_count(lucy_DefaultDeletionsWriter* self, const lucy_CharBuf* seg_name);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefDelWriter_destroy_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_merge_segment_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_finish_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_metadata_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_format_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_delete_by_term_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_delete_by_query_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_delete_by_doc_id_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_updated_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_seg_deletions_CALLBACK;
extern cfish_Callback lucy_DefDelWriter_seg_del_count_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefDelWriter_destroy_t)(lucy_DefaultDeletionsWriter* self);

typedef void
(*lucy_DefDelWriter_add_segment_t)(lucy_DefaultDeletionsWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_DefDelWriter_merge_segment_t)(lucy_DefaultDeletionsWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_DefDelWriter_finish_t)(lucy_DefaultDeletionsWriter* self);

typedef lucy_Hash*
(*lucy_DefDelWriter_metadata_t)(lucy_DefaultDeletionsWriter* self);

typedef int32_t
(*lucy_DefDelWriter_format_t)(lucy_DefaultDeletionsWriter* self);

typedef void
(*lucy_DefDelWriter_delete_by_term_t)(lucy_DefaultDeletionsWriter* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef void
(*lucy_DefDelWriter_delete_by_query_t)(lucy_DefaultDeletionsWriter* self, lucy_Query* query);

typedef void
(*lucy_DefDelWriter_delete_by_doc_id_t)(lucy_DefaultDeletionsWriter* self, int32_t doc_id);

typedef chy_bool_t
(*lucy_DefDelWriter_updated_t)(lucy_DefaultDeletionsWriter* self);

typedef lucy_Matcher*
(*lucy_DefDelWriter_seg_deletions_t)(lucy_DefaultDeletionsWriter* self, lucy_SegReader* seg_reader);

typedef int32_t
(*lucy_DefDelWriter_seg_del_count_t)(lucy_DefaultDeletionsWriter* self, const lucy_CharBuf* seg_name);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefDelWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelWriter_Make(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefDelWriter_Get_RefCount(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelWriter_Inc_RefCount(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefDelWriter_Dec_RefCount(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefDelWriter_To_Host(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelWriter_Clone(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Destroy(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Destroy_OFFSET;
    const lucy_DefDelWriter_destroy_t method = *((lucy_DefDelWriter_destroy_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self);
}

extern size_t Lucy_DefDelWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelWriter_Equals(const lucy_DefaultDeletionsWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDelWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelWriter_Compare_To(const lucy_DefaultDeletionsWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDelWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelWriter_Hash_Sum(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefDelWriter_Get_VTable(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefDelWriter_Get_Class_Name(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelWriter_Is_A(const lucy_DefaultDeletionsWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefDelWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefDelWriter_To_String(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefDelWriter_To_I64(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefDelWriter_To_F64(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelWriter_To_Bool(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Serialize(const lucy_DefaultDeletionsWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefDelWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelWriter_Deserialize(const lucy_DefaultDeletionsWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefDelWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelWriter_Dump(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDelWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDelWriter_Load(const lucy_DefaultDeletionsWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefDelWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Mimic(const lucy_DefaultDeletionsWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDelWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Add_Inverted_Doc(const lucy_DefaultDeletionsWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_DefDelWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Add_Segment(const lucy_DefaultDeletionsWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Add_Segment_OFFSET;
    const lucy_DefDelWriter_add_segment_t method = *((lucy_DefDelWriter_add_segment_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self, reader, doc_map);
}

extern size_t Lucy_DefDelWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Delete_Segment(const lucy_DefaultDeletionsWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_DefDelWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Merge_Segment(const lucy_DefaultDeletionsWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Merge_Segment_OFFSET;
    const lucy_DefDelWriter_merge_segment_t method = *((lucy_DefDelWriter_merge_segment_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self, reader, doc_map);
}

extern size_t Lucy_DefDelWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Finish(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Finish_OFFSET;
    const lucy_DefDelWriter_finish_t method = *((lucy_DefDelWriter_finish_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self);
}

extern size_t Lucy_DefDelWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_DefDelWriter_Metadata(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Metadata_OFFSET;
    const lucy_DefDelWriter_metadata_t method = *((lucy_DefDelWriter_metadata_t*)method_address);
    return method((lucy_DefaultDeletionsWriter*)self);
}

extern size_t Lucy_DefDelWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelWriter_Format(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Format_OFFSET;
    const lucy_DefDelWriter_format_t method = *((lucy_DefDelWriter_format_t*)method_address);
    return method((lucy_DefaultDeletionsWriter*)self);
}

extern size_t Lucy_DefDelWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefDelWriter_Get_Snapshot(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DefDelWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefDelWriter_Get_Segment(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DefDelWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_DefDelWriter_Get_PolyReader(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DefDelWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefDelWriter_Get_Schema(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DefDelWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefDelWriter_Get_Folder(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DefDelWriter_Delete_By_Term_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Delete_By_Term(const lucy_DefaultDeletionsWriter *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Delete_By_Term_OFFSET;
    const lucy_DefDelWriter_delete_by_term_t method = *((lucy_DefDelWriter_delete_by_term_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self, field, term);
}

extern size_t Lucy_DefDelWriter_Delete_By_Query_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Delete_By_Query(const lucy_DefaultDeletionsWriter *self, lucy_Query* query) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Delete_By_Query_OFFSET;
    const lucy_DefDelWriter_delete_by_query_t method = *((lucy_DefDelWriter_delete_by_query_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self, query);
}

extern size_t Lucy_DefDelWriter_Delete_By_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_DefDelWriter_Delete_By_Doc_ID(const lucy_DefaultDeletionsWriter *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Delete_By_Doc_ID_OFFSET;
    const lucy_DefDelWriter_delete_by_doc_id_t method = *((lucy_DefDelWriter_delete_by_doc_id_t*)method_address);
    method((lucy_DefaultDeletionsWriter*)self, doc_id);
}

extern size_t Lucy_DefDelWriter_Updated_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDelWriter_Updated(const lucy_DefaultDeletionsWriter *self) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Updated_OFFSET;
    const lucy_DefDelWriter_updated_t method = *((lucy_DefDelWriter_updated_t*)method_address);
    return method((lucy_DefaultDeletionsWriter*)self);
}

extern size_t Lucy_DefDelWriter_Generate_Doc_Map_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_DefDelWriter_Generate_Doc_Map(const lucy_DefaultDeletionsWriter *self, lucy_Matcher* deletions, int32_t doc_max, int32_t offset) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Generate_Doc_Map_OFFSET;
    const lucy_DelWriter_generate_doc_map_t method = *((lucy_DelWriter_generate_doc_map_t*)method_address);
    return method((lucy_DeletionsWriter*)self, deletions, doc_max, offset);
}

extern size_t Lucy_DefDelWriter_Seg_Deletions_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_DefDelWriter_Seg_Deletions(const lucy_DefaultDeletionsWriter *self, lucy_SegReader* seg_reader) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Seg_Deletions_OFFSET;
    const lucy_DefDelWriter_seg_deletions_t method = *((lucy_DefDelWriter_seg_deletions_t*)method_address);
    return method((lucy_DefaultDeletionsWriter*)self, seg_reader);
}

extern size_t Lucy_DefDelWriter_Seg_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDelWriter_Seg_Del_Count(const lucy_DefaultDeletionsWriter *self, const lucy_CharBuf* seg_name) {
    char *const method_address = *(char**)self + Lucy_DefDelWriter_Seg_Del_Count_OFFSET;
    const lucy_DefDelWriter_seg_del_count_t method = *((lucy_DefDelWriter_seg_del_count_t*)method_address);
    return method((lucy_DefaultDeletionsWriter*)self, seg_name);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTDELETIONSWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[41];
} LUCY_DEFAULTDELETIONSWRITER_VT;
extern struct LUCY_DEFAULTDELETIONSWRITER_VT LUCY_DEFAULTDELETIONSWRITER_vt;
#define LUCY_DEFAULTDELETIONSWRITER ((cfish_VTable*)&LUCY_DEFAULTDELETIONSWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultDeletionsWriter lucy_DefaultDeletionsWriter
  #define DEFAULTDELETIONSWRITER LUCY_DEFAULTDELETIONSWRITER
  #define DefDelWriter_new lucy_DefDelWriter_new
  #define DefDelWriter_init lucy_DefDelWriter_init
  #define DefDelWriter_current_file_format lucy_DefDelWriter_current_file_format
  #define DefDelWriter_destroy_t lucy_DefDelWriter_destroy_t
  #define DefDelWriter_destroy lucy_DefDelWriter_destroy
  #define DefDelWriter_add_segment_t lucy_DefDelWriter_add_segment_t
  #define DefDelWriter_add_segment lucy_DefDelWriter_add_segment
  #define DefDelWriter_merge_segment_t lucy_DefDelWriter_merge_segment_t
  #define DefDelWriter_merge_segment lucy_DefDelWriter_merge_segment
  #define DefDelWriter_finish_t lucy_DefDelWriter_finish_t
  #define DefDelWriter_finish lucy_DefDelWriter_finish
  #define DefDelWriter_metadata_t lucy_DefDelWriter_metadata_t
  #define DefDelWriter_metadata lucy_DefDelWriter_metadata
  #define DefDelWriter_format_t lucy_DefDelWriter_format_t
  #define DefDelWriter_format lucy_DefDelWriter_format
  #define DefDelWriter_delete_by_term_t lucy_DefDelWriter_delete_by_term_t
  #define DefDelWriter_delete_by_term lucy_DefDelWriter_delete_by_term
  #define DefDelWriter_delete_by_query_t lucy_DefDelWriter_delete_by_query_t
  #define DefDelWriter_delete_by_query lucy_DefDelWriter_delete_by_query
  #define DefDelWriter_delete_by_doc_id_t lucy_DefDelWriter_delete_by_doc_id_t
  #define DefDelWriter_delete_by_doc_id lucy_DefDelWriter_delete_by_doc_id
  #define DefDelWriter_updated_t lucy_DefDelWriter_updated_t
  #define DefDelWriter_updated lucy_DefDelWriter_updated
  #define DefDelWriter_seg_deletions_t lucy_DefDelWriter_seg_deletions_t
  #define DefDelWriter_seg_deletions lucy_DefDelWriter_seg_deletions
  #define DefDelWriter_seg_del_count_t lucy_DefDelWriter_seg_del_count_t
  #define DefDelWriter_seg_del_count lucy_DefDelWriter_seg_del_count
  #define DefDelWriter_Make Lucy_DefDelWriter_Make
  #define DefDelWriter_Get_RefCount Lucy_DefDelWriter_Get_RefCount
  #define DefDelWriter_Inc_RefCount Lucy_DefDelWriter_Inc_RefCount
  #define DefDelWriter_Dec_RefCount Lucy_DefDelWriter_Dec_RefCount
  #define DefDelWriter_To_Host Lucy_DefDelWriter_To_Host
  #define DefDelWriter_Clone Lucy_DefDelWriter_Clone
  #define DefDelWriter_Destroy Lucy_DefDelWriter_Destroy
  #define DefDelWriter_Equals Lucy_DefDelWriter_Equals
  #define DefDelWriter_Compare_To Lucy_DefDelWriter_Compare_To
  #define DefDelWriter_Hash_Sum Lucy_DefDelWriter_Hash_Sum
  #define DefDelWriter_Get_VTable Lucy_DefDelWriter_Get_VTable
  #define DefDelWriter_Get_Class_Name Lucy_DefDelWriter_Get_Class_Name
  #define DefDelWriter_Is_A Lucy_DefDelWriter_Is_A
  #define DefDelWriter_To_String Lucy_DefDelWriter_To_String
  #define DefDelWriter_To_I64 Lucy_DefDelWriter_To_I64
  #define DefDelWriter_To_F64 Lucy_DefDelWriter_To_F64
  #define DefDelWriter_To_Bool Lucy_DefDelWriter_To_Bool
  #define DefDelWriter_Serialize Lucy_DefDelWriter_Serialize
  #define DefDelWriter_Deserialize Lucy_DefDelWriter_Deserialize
  #define DefDelWriter_Dump Lucy_DefDelWriter_Dump
  #define DefDelWriter_Load Lucy_DefDelWriter_Load
  #define DefDelWriter_Mimic Lucy_DefDelWriter_Mimic
  #define DefDelWriter_Add_Inverted_Doc Lucy_DefDelWriter_Add_Inverted_Doc
  #define DefDelWriter_Add_Segment Lucy_DefDelWriter_Add_Segment
  #define DefDelWriter_Delete_Segment Lucy_DefDelWriter_Delete_Segment
  #define DefDelWriter_Merge_Segment Lucy_DefDelWriter_Merge_Segment
  #define DefDelWriter_Finish Lucy_DefDelWriter_Finish
  #define DefDelWriter_Metadata Lucy_DefDelWriter_Metadata
  #define DefDelWriter_Format Lucy_DefDelWriter_Format
  #define DefDelWriter_Get_Snapshot Lucy_DefDelWriter_Get_Snapshot
  #define DefDelWriter_Get_Segment Lucy_DefDelWriter_Get_Segment
  #define DefDelWriter_Get_PolyReader Lucy_DefDelWriter_Get_PolyReader
  #define DefDelWriter_Get_Schema Lucy_DefDelWriter_Get_Schema
  #define DefDelWriter_Get_Folder Lucy_DefDelWriter_Get_Folder
  #define DefDelWriter_Delete_By_Term Lucy_DefDelWriter_Delete_By_Term
  #define DefDelWriter_Delete_By_Query Lucy_DefDelWriter_Delete_By_Query
  #define DefDelWriter_Delete_By_Doc_ID Lucy_DefDelWriter_Delete_By_Doc_ID
  #define DefDelWriter_Updated Lucy_DefDelWriter_Updated
  #define DefDelWriter_Generate_Doc_Map Lucy_DefDelWriter_Generate_Doc_Map
  #define DefDelWriter_Seg_Deletions Lucy_DefDelWriter_Seg_Deletions
  #define DefDelWriter_Seg_Del_Count Lucy_DefDelWriter_Seg_Del_Count
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DELETIONSWRITER */




