/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DOCREADER
#define H_LUCY_INDEX_DOCREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DOCREADER
struct lucy_DocReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_DOCREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DocReader*
lucy_DocReader_init(lucy_DocReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DocReader*
lucy_DocReader_aggregator(lucy_DocReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

lucy_HitDoc*
lucy_DocReader_fetch_doc(lucy_DocReader* self, int32_t doc_id);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DocReader_aggregator_CALLBACK;
extern cfish_Callback lucy_DocReader_fetch_doc_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_DocReader*
(*lucy_DocReader_aggregator_t)(lucy_DocReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef lucy_HitDoc*
(*lucy_DocReader_fetch_doc_t)(lucy_DocReader* self, int32_t doc_id);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DocReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocReader_Make(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DocReader_Get_RefCount(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocReader_Inc_RefCount(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DocReader_Dec_RefCount(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DocReader_To_Host(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocReader_Clone(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DocReader_Destroy(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocReader_Equals(const lucy_DocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DocReader_Compare_To(const lucy_DocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DocReader_Hash_Sum(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DocReader_Get_VTable(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DocReader_Get_Class_Name(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocReader_Is_A(const lucy_DocReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DocReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DocReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DocReader_To_String(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DocReader_To_I64(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DocReader_To_F64(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocReader_To_Bool(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DocReader_Serialize(const lucy_DocReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DocReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DocReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocReader_Deserialize(const lucy_DocReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DocReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DocReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocReader_Dump(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocReader_Load(const lucy_DocReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DocReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DocReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DocReader_Mimic(const lucy_DocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DocReader*
Lucy_DocReader_Aggregator(const lucy_DocReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DocReader_Aggregator_OFFSET;
    const lucy_DocReader_aggregator_t method = *((lucy_DocReader_aggregator_t*)method_address);
    return method((lucy_DocReader*)self, readers, offsets);
}

extern size_t Lucy_DocReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DocReader_Get_Schema(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DocReader_Get_Folder(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DocReader_Get_Snapshot(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DocReader_Get_Segments(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DocReader_Get_Segment(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DocReader_Get_Seg_Tick(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DocReader_Close(const lucy_DocReader *self) {
    char *const method_address = *(char**)self + Lucy_DocReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_DocReader_Fetch_Doc_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_DocReader_Fetch_Doc(const lucy_DocReader *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DocReader_Fetch_Doc_OFFSET;
    const lucy_DocReader_fetch_doc_t method = *((lucy_DocReader_fetch_doc_t*)method_address);
    return method((lucy_DocReader*)self, doc_id);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DOCREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_DOCREADER_VT;
extern struct LUCY_DOCREADER_VT LUCY_DOCREADER_vt;
#define LUCY_DOCREADER ((cfish_VTable*)&LUCY_DOCREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DocReader lucy_DocReader
  #define DOCREADER LUCY_DOCREADER
  #define DocReader_init lucy_DocReader_init
  #define DocReader_aggregator_t lucy_DocReader_aggregator_t
  #define DocReader_aggregator lucy_DocReader_aggregator
  #define DocReader_fetch_doc_t lucy_DocReader_fetch_doc_t
  #define DocReader_fetch_doc lucy_DocReader_fetch_doc
  #define DocReader_Make Lucy_DocReader_Make
  #define DocReader_Get_RefCount Lucy_DocReader_Get_RefCount
  #define DocReader_Inc_RefCount Lucy_DocReader_Inc_RefCount
  #define DocReader_Dec_RefCount Lucy_DocReader_Dec_RefCount
  #define DocReader_To_Host Lucy_DocReader_To_Host
  #define DocReader_Clone Lucy_DocReader_Clone
  #define DocReader_Destroy Lucy_DocReader_Destroy
  #define DocReader_Equals Lucy_DocReader_Equals
  #define DocReader_Compare_To Lucy_DocReader_Compare_To
  #define DocReader_Hash_Sum Lucy_DocReader_Hash_Sum
  #define DocReader_Get_VTable Lucy_DocReader_Get_VTable
  #define DocReader_Get_Class_Name Lucy_DocReader_Get_Class_Name
  #define DocReader_Is_A Lucy_DocReader_Is_A
  #define DocReader_To_String Lucy_DocReader_To_String
  #define DocReader_To_I64 Lucy_DocReader_To_I64
  #define DocReader_To_F64 Lucy_DocReader_To_F64
  #define DocReader_To_Bool Lucy_DocReader_To_Bool
  #define DocReader_Serialize Lucy_DocReader_Serialize
  #define DocReader_Deserialize Lucy_DocReader_Deserialize
  #define DocReader_Dump Lucy_DocReader_Dump
  #define DocReader_Load Lucy_DocReader_Load
  #define DocReader_Mimic Lucy_DocReader_Mimic
  #define DocReader_Aggregator Lucy_DocReader_Aggregator
  #define DocReader_Get_Schema Lucy_DocReader_Get_Schema
  #define DocReader_Get_Folder Lucy_DocReader_Get_Folder
  #define DocReader_Get_Snapshot Lucy_DocReader_Get_Snapshot
  #define DocReader_Get_Segments Lucy_DocReader_Get_Segments
  #define DocReader_Get_Segment Lucy_DocReader_Get_Segment
  #define DocReader_Get_Seg_Tick Lucy_DocReader_Get_Seg_Tick
  #define DocReader_Close Lucy_DocReader_Close
  #define DocReader_Fetch_Doc Lucy_DocReader_Fetch_Doc
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DocReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYDOCREADER
struct lucy_PolyDocReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_VArray* readers;
    lucy_I32Array* offsets;
};

#endif /* C_LUCY_POLYDOCREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyDocReader*
lucy_PolyDocReader_new(lucy_VArray* readers, lucy_I32Array* offsets);

lucy_PolyDocReader*
lucy_PolyDocReader_init(lucy_PolyDocReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

void
lucy_PolyDocReader_destroy(lucy_PolyDocReader* self);

void
lucy_PolyDocReader_close(lucy_PolyDocReader* self);

lucy_HitDoc*
lucy_PolyDocReader_fetch_doc(lucy_PolyDocReader* self, int32_t doc_id);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyDocReader_destroy_CALLBACK;
extern cfish_Callback lucy_PolyDocReader_close_CALLBACK;
extern cfish_Callback lucy_PolyDocReader_fetch_doc_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyDocReader_destroy_t)(lucy_PolyDocReader* self);

typedef void
(*lucy_PolyDocReader_close_t)(lucy_PolyDocReader* self);

typedef lucy_HitDoc*
(*lucy_PolyDocReader_fetch_doc_t)(lucy_PolyDocReader* self, int32_t doc_id);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyDocReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDocReader_Make(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyDocReader_Get_RefCount(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDocReader_Inc_RefCount(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyDocReader_Dec_RefCount(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyDocReader_To_Host(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDocReader_Clone(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyDocReader_Destroy(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Destroy_OFFSET;
    const lucy_PolyDocReader_destroy_t method = *((lucy_PolyDocReader_destroy_t*)method_address);
    method((lucy_PolyDocReader*)self);
}

extern size_t Lucy_PolyDocReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyDocReader_Equals(const lucy_PolyDocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyDocReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDocReader_Compare_To(const lucy_PolyDocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyDocReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDocReader_Hash_Sum(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyDocReader_Get_VTable(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyDocReader_Get_Class_Name(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyDocReader_Is_A(const lucy_PolyDocReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyDocReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyDocReader_To_String(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyDocReader_To_I64(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyDocReader_To_F64(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyDocReader_To_Bool(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyDocReader_Serialize(const lucy_PolyDocReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyDocReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDocReader_Deserialize(const lucy_PolyDocReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyDocReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDocReader_Dump(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyDocReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyDocReader_Load(const lucy_PolyDocReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolyDocReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyDocReader_Mimic(const lucy_PolyDocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyDocReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DocReader*
Lucy_PolyDocReader_Aggregator(const lucy_PolyDocReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Aggregator_OFFSET;
    const lucy_DocReader_aggregator_t method = *((lucy_DocReader_aggregator_t*)method_address);
    return method((lucy_DocReader*)self, readers, offsets);
}

extern size_t Lucy_PolyDocReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PolyDocReader_Get_Schema(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDocReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PolyDocReader_Get_Folder(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDocReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PolyDocReader_Get_Snapshot(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDocReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyDocReader_Get_Segments(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDocReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PolyDocReader_Get_Segment(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDocReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyDocReader_Get_Seg_Tick(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyDocReader_Close_OFFSET;
static CHY_INLINE void
Lucy_PolyDocReader_Close(const lucy_PolyDocReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Close_OFFSET;
    const lucy_PolyDocReader_close_t method = *((lucy_PolyDocReader_close_t*)method_address);
    method((lucy_PolyDocReader*)self);
}

extern size_t Lucy_PolyDocReader_Fetch_Doc_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_PolyDocReader_Fetch_Doc(const lucy_PolyDocReader *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_PolyDocReader_Fetch_Doc_OFFSET;
    const lucy_PolyDocReader_fetch_doc_t method = *((lucy_PolyDocReader_fetch_doc_t*)method_address);
    return method((lucy_PolyDocReader*)self, doc_id);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYDOCREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_POLYDOCREADER_VT;
extern struct LUCY_POLYDOCREADER_VT LUCY_POLYDOCREADER_vt;
#define LUCY_POLYDOCREADER ((cfish_VTable*)&LUCY_POLYDOCREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyDocReader lucy_PolyDocReader
  #define POLYDOCREADER LUCY_POLYDOCREADER
  #define PolyDocReader_new lucy_PolyDocReader_new
  #define PolyDocReader_init lucy_PolyDocReader_init
  #define PolyDocReader_destroy_t lucy_PolyDocReader_destroy_t
  #define PolyDocReader_destroy lucy_PolyDocReader_destroy
  #define PolyDocReader_close_t lucy_PolyDocReader_close_t
  #define PolyDocReader_close lucy_PolyDocReader_close
  #define PolyDocReader_fetch_doc_t lucy_PolyDocReader_fetch_doc_t
  #define PolyDocReader_fetch_doc lucy_PolyDocReader_fetch_doc
  #define PolyDocReader_Make Lucy_PolyDocReader_Make
  #define PolyDocReader_Get_RefCount Lucy_PolyDocReader_Get_RefCount
  #define PolyDocReader_Inc_RefCount Lucy_PolyDocReader_Inc_RefCount
  #define PolyDocReader_Dec_RefCount Lucy_PolyDocReader_Dec_RefCount
  #define PolyDocReader_To_Host Lucy_PolyDocReader_To_Host
  #define PolyDocReader_Clone Lucy_PolyDocReader_Clone
  #define PolyDocReader_Destroy Lucy_PolyDocReader_Destroy
  #define PolyDocReader_Equals Lucy_PolyDocReader_Equals
  #define PolyDocReader_Compare_To Lucy_PolyDocReader_Compare_To
  #define PolyDocReader_Hash_Sum Lucy_PolyDocReader_Hash_Sum
  #define PolyDocReader_Get_VTable Lucy_PolyDocReader_Get_VTable
  #define PolyDocReader_Get_Class_Name Lucy_PolyDocReader_Get_Class_Name
  #define PolyDocReader_Is_A Lucy_PolyDocReader_Is_A
  #define PolyDocReader_To_String Lucy_PolyDocReader_To_String
  #define PolyDocReader_To_I64 Lucy_PolyDocReader_To_I64
  #define PolyDocReader_To_F64 Lucy_PolyDocReader_To_F64
  #define PolyDocReader_To_Bool Lucy_PolyDocReader_To_Bool
  #define PolyDocReader_Serialize Lucy_PolyDocReader_Serialize
  #define PolyDocReader_Deserialize Lucy_PolyDocReader_Deserialize
  #define PolyDocReader_Dump Lucy_PolyDocReader_Dump
  #define PolyDocReader_Load Lucy_PolyDocReader_Load
  #define PolyDocReader_Mimic Lucy_PolyDocReader_Mimic
  #define PolyDocReader_Aggregator Lucy_PolyDocReader_Aggregator
  #define PolyDocReader_Get_Schema Lucy_PolyDocReader_Get_Schema
  #define PolyDocReader_Get_Folder Lucy_PolyDocReader_Get_Folder
  #define PolyDocReader_Get_Snapshot Lucy_PolyDocReader_Get_Snapshot
  #define PolyDocReader_Get_Segments Lucy_PolyDocReader_Get_Segments
  #define PolyDocReader_Get_Segment Lucy_PolyDocReader_Get_Segment
  #define PolyDocReader_Get_Seg_Tick Lucy_PolyDocReader_Get_Seg_Tick
  #define PolyDocReader_Close Lucy_PolyDocReader_Close
  #define PolyDocReader_Fetch_Doc Lucy_PolyDocReader_Fetch_Doc
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DocReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTDOCREADER
struct lucy_DefaultDocReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_InStream* dat_in;
    lucy_InStream* ix_in;
};

#endif /* C_LUCY_DEFAULTDOCREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultDocReader*
lucy_DefDocReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DefaultDocReader*
lucy_DefDocReader_init(lucy_DefaultDocReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_DefDocReader_destroy(lucy_DefaultDocReader* self);

void
lucy_DefDocReader_close(lucy_DefaultDocReader* self);

lucy_HitDoc*
lucy_DefDocReader_fetch_doc(lucy_DefaultDocReader* self, int32_t doc_id);

void
lucy_DefDocReader_read_record(lucy_DefaultDocReader* self, lucy_ByteBuf* buffer, int32_t doc_id);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefDocReader_destroy_CALLBACK;
extern cfish_Callback lucy_DefDocReader_close_CALLBACK;
extern cfish_Callback lucy_DefDocReader_fetch_doc_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefDocReader_destroy_t)(lucy_DefaultDocReader* self);

typedef void
(*lucy_DefDocReader_close_t)(lucy_DefaultDocReader* self);

typedef lucy_HitDoc*
(*lucy_DefDocReader_fetch_doc_t)(lucy_DefaultDocReader* self, int32_t doc_id);

typedef void
(*lucy_DefDocReader_read_record_t)(lucy_DefaultDocReader* self, lucy_ByteBuf* buffer, int32_t doc_id);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefDocReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDocReader_Make(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefDocReader_Get_RefCount(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDocReader_Inc_RefCount(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefDocReader_Dec_RefCount(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefDocReader_To_Host(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDocReader_Clone(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefDocReader_Destroy(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Destroy_OFFSET;
    const lucy_DefDocReader_destroy_t method = *((lucy_DefDocReader_destroy_t*)method_address);
    method((lucy_DefaultDocReader*)self);
}

extern size_t Lucy_DefDocReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDocReader_Equals(const lucy_DefaultDocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDocReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDocReader_Compare_To(const lucy_DefaultDocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDocReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDocReader_Hash_Sum(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefDocReader_Get_VTable(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefDocReader_Get_Class_Name(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDocReader_Is_A(const lucy_DefaultDocReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefDocReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefDocReader_To_String(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefDocReader_To_I64(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefDocReader_To_F64(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefDocReader_To_Bool(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefDocReader_Serialize(const lucy_DefaultDocReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefDocReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDocReader_Deserialize(const lucy_DefaultDocReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefDocReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDocReader_Dump(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefDocReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefDocReader_Load(const lucy_DefaultDocReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefDocReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefDocReader_Mimic(const lucy_DefaultDocReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefDocReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DocReader*
Lucy_DefDocReader_Aggregator(const lucy_DefaultDocReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Aggregator_OFFSET;
    const lucy_DocReader_aggregator_t method = *((lucy_DocReader_aggregator_t*)method_address);
    return method((lucy_DocReader*)self, readers, offsets);
}

extern size_t Lucy_DefDocReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefDocReader_Get_Schema(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDocReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefDocReader_Get_Folder(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDocReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefDocReader_Get_Snapshot(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDocReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DefDocReader_Get_Segments(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDocReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefDocReader_Get_Segment(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDocReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DefDocReader_Get_Seg_Tick(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefDocReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DefDocReader_Close(const lucy_DefaultDocReader *self) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Close_OFFSET;
    const lucy_DefDocReader_close_t method = *((lucy_DefDocReader_close_t*)method_address);
    method((lucy_DefaultDocReader*)self);
}

extern size_t Lucy_DefDocReader_Fetch_Doc_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_DefDocReader_Fetch_Doc(const lucy_DefaultDocReader *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Fetch_Doc_OFFSET;
    const lucy_DefDocReader_fetch_doc_t method = *((lucy_DefDocReader_fetch_doc_t*)method_address);
    return method((lucy_DefaultDocReader*)self, doc_id);
}

extern size_t Lucy_DefDocReader_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_DefDocReader_Read_Record(const lucy_DefaultDocReader *self, lucy_ByteBuf* buffer, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DefDocReader_Read_Record_OFFSET;
    const lucy_DefDocReader_read_record_t method = *((lucy_DefDocReader_read_record_t*)method_address);
    method((lucy_DefaultDocReader*)self, buffer, doc_id);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTDOCREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_DEFAULTDOCREADER_VT;
extern struct LUCY_DEFAULTDOCREADER_VT LUCY_DEFAULTDOCREADER_vt;
#define LUCY_DEFAULTDOCREADER ((cfish_VTable*)&LUCY_DEFAULTDOCREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultDocReader lucy_DefaultDocReader
  #define DEFAULTDOCREADER LUCY_DEFAULTDOCREADER
  #define DefDocReader_new lucy_DefDocReader_new
  #define DefDocReader_init lucy_DefDocReader_init
  #define DefDocReader_destroy_t lucy_DefDocReader_destroy_t
  #define DefDocReader_destroy lucy_DefDocReader_destroy
  #define DefDocReader_close_t lucy_DefDocReader_close_t
  #define DefDocReader_close lucy_DefDocReader_close
  #define DefDocReader_fetch_doc_t lucy_DefDocReader_fetch_doc_t
  #define DefDocReader_fetch_doc lucy_DefDocReader_fetch_doc
  #define DefDocReader_read_record_t lucy_DefDocReader_read_record_t
  #define DefDocReader_read_record lucy_DefDocReader_read_record
  #define DefDocReader_Make Lucy_DefDocReader_Make
  #define DefDocReader_Get_RefCount Lucy_DefDocReader_Get_RefCount
  #define DefDocReader_Inc_RefCount Lucy_DefDocReader_Inc_RefCount
  #define DefDocReader_Dec_RefCount Lucy_DefDocReader_Dec_RefCount
  #define DefDocReader_To_Host Lucy_DefDocReader_To_Host
  #define DefDocReader_Clone Lucy_DefDocReader_Clone
  #define DefDocReader_Destroy Lucy_DefDocReader_Destroy
  #define DefDocReader_Equals Lucy_DefDocReader_Equals
  #define DefDocReader_Compare_To Lucy_DefDocReader_Compare_To
  #define DefDocReader_Hash_Sum Lucy_DefDocReader_Hash_Sum
  #define DefDocReader_Get_VTable Lucy_DefDocReader_Get_VTable
  #define DefDocReader_Get_Class_Name Lucy_DefDocReader_Get_Class_Name
  #define DefDocReader_Is_A Lucy_DefDocReader_Is_A
  #define DefDocReader_To_String Lucy_DefDocReader_To_String
  #define DefDocReader_To_I64 Lucy_DefDocReader_To_I64
  #define DefDocReader_To_F64 Lucy_DefDocReader_To_F64
  #define DefDocReader_To_Bool Lucy_DefDocReader_To_Bool
  #define DefDocReader_Serialize Lucy_DefDocReader_Serialize
  #define DefDocReader_Deserialize Lucy_DefDocReader_Deserialize
  #define DefDocReader_Dump Lucy_DefDocReader_Dump
  #define DefDocReader_Load Lucy_DefDocReader_Load
  #define DefDocReader_Mimic Lucy_DefDocReader_Mimic
  #define DefDocReader_Aggregator Lucy_DefDocReader_Aggregator
  #define DefDocReader_Get_Schema Lucy_DefDocReader_Get_Schema
  #define DefDocReader_Get_Folder Lucy_DefDocReader_Get_Folder
  #define DefDocReader_Get_Snapshot Lucy_DefDocReader_Get_Snapshot
  #define DefDocReader_Get_Segments Lucy_DefDocReader_Get_Segments
  #define DefDocReader_Get_Segment Lucy_DefDocReader_Get_Segment
  #define DefDocReader_Get_Seg_Tick Lucy_DefDocReader_Get_Seg_Tick
  #define DefDocReader_Close Lucy_DefDocReader_Close
  #define DefDocReader_Fetch_Doc Lucy_DefDocReader_Fetch_Doc
  #define DefDocReader_Read_Record Lucy_DefDocReader_Read_Record
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DOCREADER */




