/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DOCVECTOR
#define H_LUCY_INDEX_DOCVECTOR 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DOCVECTOR
struct lucy_DocVector {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Hash* field_bufs;
    lucy_Hash* field_vectors;
};

#endif /* C_LUCY_DOCVECTOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DocVector*
lucy_DocVec_new();

lucy_DocVector*
lucy_DocVec_init(lucy_DocVector* self);

void
lucy_DocVec_destroy(lucy_DocVector* self);

void
lucy_DocVec_serialize(lucy_DocVector* self, lucy_OutStream* outstream);

lucy_DocVector*
lucy_DocVec_deserialize(lucy_DocVector* self, lucy_InStream* instream);

lucy_TermVector*
lucy_DocVec_term_vector(lucy_DocVector* self, const lucy_CharBuf* field, const lucy_CharBuf* term);

void
lucy_DocVec_add_field_buf(lucy_DocVector* self, const lucy_CharBuf* field, lucy_ByteBuf* field_buf);

lucy_ByteBuf*
lucy_DocVec_field_buf(lucy_DocVector* self, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DocVec_destroy_CALLBACK;
extern cfish_Callback lucy_DocVec_serialize_CALLBACK;
extern cfish_Callback lucy_DocVec_deserialize_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DocVec_destroy_t)(lucy_DocVector* self);

typedef void
(*lucy_DocVec_serialize_t)(lucy_DocVector* self, lucy_OutStream* outstream);

typedef lucy_DocVector*
(*lucy_DocVec_deserialize_t)(lucy_DocVector* self, lucy_InStream* instream);

typedef lucy_TermVector*
(*lucy_DocVec_term_vector_t)(lucy_DocVector* self, const lucy_CharBuf* field, const lucy_CharBuf* term);

typedef void
(*lucy_DocVec_add_field_buf_t)(lucy_DocVector* self, const lucy_CharBuf* field, lucy_ByteBuf* field_buf);

typedef lucy_ByteBuf*
(*lucy_DocVec_field_buf_t)(lucy_DocVector* self, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DocVec_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocVec_Make(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DocVec_Get_RefCount(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocVec_Inc_RefCount(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DocVec_Dec_RefCount(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DocVec_To_Host(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocVec_Clone(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DocVec_Destroy(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Destroy_OFFSET;
    const lucy_DocVec_destroy_t method = *((lucy_DocVec_destroy_t*)method_address);
    method((lucy_DocVector*)self);
}

extern size_t Lucy_DocVec_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocVec_Equals(const lucy_DocVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocVec_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocVec_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DocVec_Compare_To(const lucy_DocVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocVec_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocVec_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DocVec_Hash_Sum(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DocVec_Get_VTable(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DocVec_Get_Class_Name(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocVec_Is_A(const lucy_DocVector *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DocVec_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DocVec_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DocVec_To_String(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DocVec_To_I64(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DocVec_To_F64(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocVec_To_Bool(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DocVec_Serialize(const lucy_DocVector *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DocVec_Serialize_OFFSET;
    const lucy_DocVec_serialize_t method = *((lucy_DocVec_serialize_t*)method_address);
    method((lucy_DocVector*)self, outstream);
}

extern size_t Lucy_DocVec_Deserialize_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_DocVec_Deserialize(const lucy_DocVector *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DocVec_Deserialize_OFFSET;
    const lucy_DocVec_deserialize_t method = *((lucy_DocVec_deserialize_t*)method_address);
    return method((lucy_DocVector*)self, instream);
}

extern size_t Lucy_DocVec_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocVec_Dump(const lucy_DocVector *self) {
    char *const method_address = *(char**)self + Lucy_DocVec_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocVec_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocVec_Load(const lucy_DocVector *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DocVec_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DocVec_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DocVec_Mimic(const lucy_DocVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocVec_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocVec_Term_Vector_OFFSET;
static CHY_INLINE lucy_TermVector*
Lucy_DocVec_Term_Vector(const lucy_DocVector *self, const lucy_CharBuf* field, const lucy_CharBuf* term) {
    char *const method_address = *(char**)self + Lucy_DocVec_Term_Vector_OFFSET;
    const lucy_DocVec_term_vector_t method = *((lucy_DocVec_term_vector_t*)method_address);
    return method((lucy_DocVector*)self, field, term);
}

extern size_t Lucy_DocVec_Add_Field_Buf_OFFSET;
static CHY_INLINE void
Lucy_DocVec_Add_Field_Buf(const lucy_DocVector *self, const lucy_CharBuf* field, lucy_ByteBuf* field_buf) {
    char *const method_address = *(char**)self + Lucy_DocVec_Add_Field_Buf_OFFSET;
    const lucy_DocVec_add_field_buf_t method = *((lucy_DocVec_add_field_buf_t*)method_address);
    method((lucy_DocVector*)self, field, field_buf);
}

extern size_t Lucy_DocVec_Field_Buf_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_DocVec_Field_Buf(const lucy_DocVector *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_DocVec_Field_Buf_OFFSET;
    const lucy_DocVec_field_buf_t method = *((lucy_DocVec_field_buf_t*)method_address);
    return method((lucy_DocVector*)self, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DOCVECTOR_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_DOCVECTOR_VT;
extern struct LUCY_DOCVECTOR_VT LUCY_DOCVECTOR_vt;
#define LUCY_DOCVECTOR ((cfish_VTable*)&LUCY_DOCVECTOR_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DocVector lucy_DocVector
  #define DOCVECTOR LUCY_DOCVECTOR
  #define DocVec_new lucy_DocVec_new
  #define DocVec_init lucy_DocVec_init
  #define DocVec_destroy_t lucy_DocVec_destroy_t
  #define DocVec_destroy lucy_DocVec_destroy
  #define DocVec_serialize_t lucy_DocVec_serialize_t
  #define DocVec_serialize lucy_DocVec_serialize
  #define DocVec_deserialize_t lucy_DocVec_deserialize_t
  #define DocVec_deserialize lucy_DocVec_deserialize
  #define DocVec_term_vector_t lucy_DocVec_term_vector_t
  #define DocVec_term_vector lucy_DocVec_term_vector
  #define DocVec_add_field_buf_t lucy_DocVec_add_field_buf_t
  #define DocVec_add_field_buf lucy_DocVec_add_field_buf
  #define DocVec_field_buf_t lucy_DocVec_field_buf_t
  #define DocVec_field_buf lucy_DocVec_field_buf
  #define DocVec_Make Lucy_DocVec_Make
  #define DocVec_Get_RefCount Lucy_DocVec_Get_RefCount
  #define DocVec_Inc_RefCount Lucy_DocVec_Inc_RefCount
  #define DocVec_Dec_RefCount Lucy_DocVec_Dec_RefCount
  #define DocVec_To_Host Lucy_DocVec_To_Host
  #define DocVec_Clone Lucy_DocVec_Clone
  #define DocVec_Destroy Lucy_DocVec_Destroy
  #define DocVec_Equals Lucy_DocVec_Equals
  #define DocVec_Compare_To Lucy_DocVec_Compare_To
  #define DocVec_Hash_Sum Lucy_DocVec_Hash_Sum
  #define DocVec_Get_VTable Lucy_DocVec_Get_VTable
  #define DocVec_Get_Class_Name Lucy_DocVec_Get_Class_Name
  #define DocVec_Is_A Lucy_DocVec_Is_A
  #define DocVec_To_String Lucy_DocVec_To_String
  #define DocVec_To_I64 Lucy_DocVec_To_I64
  #define DocVec_To_F64 Lucy_DocVec_To_F64
  #define DocVec_To_Bool Lucy_DocVec_To_Bool
  #define DocVec_Serialize Lucy_DocVec_Serialize
  #define DocVec_Deserialize Lucy_DocVec_Deserialize
  #define DocVec_Dump Lucy_DocVec_Dump
  #define DocVec_Load Lucy_DocVec_Load
  #define DocVec_Mimic Lucy_DocVec_Mimic
  #define DocVec_Term_Vector Lucy_DocVec_Term_Vector
  #define DocVec_Add_Field_Buf Lucy_DocVec_Add_Field_Buf
  #define DocVec_Field_Buf Lucy_DocVec_Field_Buf
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DOCVECTOR */




