/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_DOCWRITER
#define H_LUCY_INDEX_DOCWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DOCWRITER
struct lucy_DocWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_OutStream* ix_out;
    lucy_OutStream* dat_out;
};

#endif /* C_LUCY_DOCWRITER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_DocWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DocWriter*
lucy_DocWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

lucy_DocWriter*
lucy_DocWriter_init(lucy_DocWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_DocWriter_destroy(lucy_DocWriter* self);

void
lucy_DocWriter_add_inverted_doc(lucy_DocWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
lucy_DocWriter_add_segment(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_DocWriter_finish(lucy_DocWriter* self);

int32_t
lucy_DocWriter_format(lucy_DocWriter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DocWriter_destroy_CALLBACK;
extern cfish_Callback lucy_DocWriter_add_inverted_doc_CALLBACK;
extern cfish_Callback lucy_DocWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_DocWriter_finish_CALLBACK;
extern cfish_Callback lucy_DocWriter_format_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DocWriter_destroy_t)(lucy_DocWriter* self);

typedef void
(*lucy_DocWriter_add_inverted_doc_t)(lucy_DocWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*lucy_DocWriter_add_segment_t)(lucy_DocWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_DocWriter_finish_t)(lucy_DocWriter* self);

typedef int32_t
(*lucy_DocWriter_format_t)(lucy_DocWriter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DocWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocWriter_Make(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DocWriter_Get_RefCount(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocWriter_Inc_RefCount(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DocWriter_Dec_RefCount(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DocWriter_To_Host(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocWriter_Clone(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Destroy(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Destroy_OFFSET;
    const lucy_DocWriter_destroy_t method = *((lucy_DocWriter_destroy_t*)method_address);
    method((lucy_DocWriter*)self);
}

extern size_t Lucy_DocWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocWriter_Equals(const lucy_DocWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DocWriter_Compare_To(const lucy_DocWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DocWriter_Hash_Sum(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DocWriter_Get_VTable(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DocWriter_Get_Class_Name(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocWriter_Is_A(const lucy_DocWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DocWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DocWriter_To_String(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DocWriter_To_I64(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DocWriter_To_F64(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DocWriter_To_Bool(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Serialize(const lucy_DocWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DocWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocWriter_Deserialize(const lucy_DocWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DocWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocWriter_Dump(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DocWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DocWriter_Load(const lucy_DocWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DocWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Mimic(const lucy_DocWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DocWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Add_Inverted_Doc(const lucy_DocWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DocWriter_add_inverted_doc_t method = *((lucy_DocWriter_add_inverted_doc_t*)method_address);
    method((lucy_DocWriter*)self, inverter, doc_id);
}

extern size_t Lucy_DocWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Add_Segment(const lucy_DocWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Add_Segment_OFFSET;
    const lucy_DocWriter_add_segment_t method = *((lucy_DocWriter_add_segment_t*)method_address);
    method((lucy_DocWriter*)self, reader, doc_map);
}

extern size_t Lucy_DocWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Delete_Segment(const lucy_DocWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_DocWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Merge_Segment(const lucy_DocWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_DocWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_DocWriter_Finish(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Finish_OFFSET;
    const lucy_DocWriter_finish_t method = *((lucy_DocWriter_finish_t*)method_address);
    method((lucy_DocWriter*)self);
}

extern size_t Lucy_DocWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_DocWriter_Metadata(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DocWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_DocWriter_Format(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Format_OFFSET;
    const lucy_DocWriter_format_t method = *((lucy_DocWriter_format_t*)method_address);
    return method((lucy_DocWriter*)self);
}

extern size_t Lucy_DocWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DocWriter_Get_Snapshot(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DocWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DocWriter_Get_Segment(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DocWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_DocWriter_Get_PolyReader(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DocWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DocWriter_Get_Schema(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_DocWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DocWriter_Get_Folder(const lucy_DocWriter *self) {
    char *const method_address = *(char**)self + Lucy_DocWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DOCWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[34];
} LUCY_DOCWRITER_VT;
extern struct LUCY_DOCWRITER_VT LUCY_DOCWRITER_vt;
#define LUCY_DOCWRITER ((cfish_VTable*)&LUCY_DOCWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DocWriter lucy_DocWriter
  #define DOCWRITER LUCY_DOCWRITER
  #define DocWriter_new lucy_DocWriter_new
  #define DocWriter_init lucy_DocWriter_init
  #define DocWriter_current_file_format lucy_DocWriter_current_file_format
  #define DocWriter_destroy_t lucy_DocWriter_destroy_t
  #define DocWriter_destroy lucy_DocWriter_destroy
  #define DocWriter_add_inverted_doc_t lucy_DocWriter_add_inverted_doc_t
  #define DocWriter_add_inverted_doc lucy_DocWriter_add_inverted_doc
  #define DocWriter_add_segment_t lucy_DocWriter_add_segment_t
  #define DocWriter_add_segment lucy_DocWriter_add_segment
  #define DocWriter_finish_t lucy_DocWriter_finish_t
  #define DocWriter_finish lucy_DocWriter_finish
  #define DocWriter_format_t lucy_DocWriter_format_t
  #define DocWriter_format lucy_DocWriter_format
  #define DocWriter_Make Lucy_DocWriter_Make
  #define DocWriter_Get_RefCount Lucy_DocWriter_Get_RefCount
  #define DocWriter_Inc_RefCount Lucy_DocWriter_Inc_RefCount
  #define DocWriter_Dec_RefCount Lucy_DocWriter_Dec_RefCount
  #define DocWriter_To_Host Lucy_DocWriter_To_Host
  #define DocWriter_Clone Lucy_DocWriter_Clone
  #define DocWriter_Destroy Lucy_DocWriter_Destroy
  #define DocWriter_Equals Lucy_DocWriter_Equals
  #define DocWriter_Compare_To Lucy_DocWriter_Compare_To
  #define DocWriter_Hash_Sum Lucy_DocWriter_Hash_Sum
  #define DocWriter_Get_VTable Lucy_DocWriter_Get_VTable
  #define DocWriter_Get_Class_Name Lucy_DocWriter_Get_Class_Name
  #define DocWriter_Is_A Lucy_DocWriter_Is_A
  #define DocWriter_To_String Lucy_DocWriter_To_String
  #define DocWriter_To_I64 Lucy_DocWriter_To_I64
  #define DocWriter_To_F64 Lucy_DocWriter_To_F64
  #define DocWriter_To_Bool Lucy_DocWriter_To_Bool
  #define DocWriter_Serialize Lucy_DocWriter_Serialize
  #define DocWriter_Deserialize Lucy_DocWriter_Deserialize
  #define DocWriter_Dump Lucy_DocWriter_Dump
  #define DocWriter_Load Lucy_DocWriter_Load
  #define DocWriter_Mimic Lucy_DocWriter_Mimic
  #define DocWriter_Add_Inverted_Doc Lucy_DocWriter_Add_Inverted_Doc
  #define DocWriter_Add_Segment Lucy_DocWriter_Add_Segment
  #define DocWriter_Delete_Segment Lucy_DocWriter_Delete_Segment
  #define DocWriter_Merge_Segment Lucy_DocWriter_Merge_Segment
  #define DocWriter_Finish Lucy_DocWriter_Finish
  #define DocWriter_Metadata Lucy_DocWriter_Metadata
  #define DocWriter_Format Lucy_DocWriter_Format
  #define DocWriter_Get_Snapshot Lucy_DocWriter_Get_Snapshot
  #define DocWriter_Get_Segment Lucy_DocWriter_Get_Segment
  #define DocWriter_Get_PolyReader Lucy_DocWriter_Get_PolyReader
  #define DocWriter_Get_Schema Lucy_DocWriter_Get_Schema
  #define DocWriter_Get_Folder Lucy_DocWriter_Get_Folder
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_DOCWRITER */




