/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_HIGHLIGHTREADER
#define H_LUCY_INDEX_HIGHLIGHTREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HIGHLIGHTREADER
struct lucy_HighlightReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_HIGHLIGHTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_HighlightReader*
lucy_HLReader_init(lucy_HighlightReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_HighlightReader*
lucy_HLReader_aggregator(lucy_HighlightReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

lucy_DocVector*
lucy_HLReader_fetch_doc_vec(lucy_HighlightReader* self, int32_t doc_id);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_HLReader_aggregator_CALLBACK;
extern cfish_Callback lucy_HLReader_fetch_doc_vec_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_HighlightReader*
(*lucy_HLReader_aggregator_t)(lucy_HighlightReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef lucy_DocVector*
(*lucy_HLReader_fetch_doc_vec_t)(lucy_HighlightReader* self, int32_t doc_id);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_HLReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLReader_Make(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HLReader_Get_RefCount(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLReader_Inc_RefCount(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HLReader_Dec_RefCount(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_HLReader_To_Host(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLReader_Clone(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_HLReader_Destroy(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HLReader_Equals(const lucy_HighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HLReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HLReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_HLReader_Compare_To(const lucy_HighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HLReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HLReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_HLReader_Hash_Sum(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_HLReader_Get_VTable(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HLReader_Get_Class_Name(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HLReader_Is_A(const lucy_HighlightReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_HLReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_HLReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HLReader_To_String(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_HLReader_To_I64(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_HLReader_To_F64(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HLReader_To_Bool(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_HLReader_Serialize(const lucy_HighlightReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_HLReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_HLReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLReader_Deserialize(const lucy_HighlightReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_HLReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_HLReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLReader_Dump(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLReader_Load(const lucy_HighlightReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_HLReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_HLReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_HLReader_Mimic(const lucy_HighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HLReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_HLReader_Aggregator_OFFSET;
static CHY_INLINE lucy_HighlightReader*
Lucy_HLReader_Aggregator(const lucy_HighlightReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_HLReader_Aggregator_OFFSET;
    const lucy_HLReader_aggregator_t method = *((lucy_HLReader_aggregator_t*)method_address);
    return method((lucy_HighlightReader*)self, readers, offsets);
}

extern size_t Lucy_HLReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_HLReader_Get_Schema(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_HLReader_Get_Folder(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_HLReader_Get_Snapshot(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_HLReader_Get_Segments(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_HLReader_Get_Segment(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_HLReader_Get_Seg_Tick(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Close_OFFSET;
static CHY_INLINE void
Lucy_HLReader_Close(const lucy_HighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_HLReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_HLReader_Fetch_Doc_Vec_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_HLReader_Fetch_Doc_Vec(const lucy_HighlightReader *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_HLReader_Fetch_Doc_Vec_OFFSET;
    const lucy_HLReader_fetch_doc_vec_t method = *((lucy_HLReader_fetch_doc_vec_t*)method_address);
    return method((lucy_HighlightReader*)self, doc_id);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HIGHLIGHTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_HIGHLIGHTREADER_VT;
extern struct LUCY_HIGHLIGHTREADER_VT LUCY_HIGHLIGHTREADER_vt;
#define LUCY_HIGHLIGHTREADER ((cfish_VTable*)&LUCY_HIGHLIGHTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define HighlightReader lucy_HighlightReader
  #define HIGHLIGHTREADER LUCY_HIGHLIGHTREADER
  #define HLReader_init lucy_HLReader_init
  #define HLReader_aggregator_t lucy_HLReader_aggregator_t
  #define HLReader_aggregator lucy_HLReader_aggregator
  #define HLReader_fetch_doc_vec_t lucy_HLReader_fetch_doc_vec_t
  #define HLReader_fetch_doc_vec lucy_HLReader_fetch_doc_vec
  #define HLReader_Make Lucy_HLReader_Make
  #define HLReader_Get_RefCount Lucy_HLReader_Get_RefCount
  #define HLReader_Inc_RefCount Lucy_HLReader_Inc_RefCount
  #define HLReader_Dec_RefCount Lucy_HLReader_Dec_RefCount
  #define HLReader_To_Host Lucy_HLReader_To_Host
  #define HLReader_Clone Lucy_HLReader_Clone
  #define HLReader_Destroy Lucy_HLReader_Destroy
  #define HLReader_Equals Lucy_HLReader_Equals
  #define HLReader_Compare_To Lucy_HLReader_Compare_To
  #define HLReader_Hash_Sum Lucy_HLReader_Hash_Sum
  #define HLReader_Get_VTable Lucy_HLReader_Get_VTable
  #define HLReader_Get_Class_Name Lucy_HLReader_Get_Class_Name
  #define HLReader_Is_A Lucy_HLReader_Is_A
  #define HLReader_To_String Lucy_HLReader_To_String
  #define HLReader_To_I64 Lucy_HLReader_To_I64
  #define HLReader_To_F64 Lucy_HLReader_To_F64
  #define HLReader_To_Bool Lucy_HLReader_To_Bool
  #define HLReader_Serialize Lucy_HLReader_Serialize
  #define HLReader_Deserialize Lucy_HLReader_Deserialize
  #define HLReader_Dump Lucy_HLReader_Dump
  #define HLReader_Load Lucy_HLReader_Load
  #define HLReader_Mimic Lucy_HLReader_Mimic
  #define HLReader_Aggregator Lucy_HLReader_Aggregator
  #define HLReader_Get_Schema Lucy_HLReader_Get_Schema
  #define HLReader_Get_Folder Lucy_HLReader_Get_Folder
  #define HLReader_Get_Snapshot Lucy_HLReader_Get_Snapshot
  #define HLReader_Get_Segments Lucy_HLReader_Get_Segments
  #define HLReader_Get_Segment Lucy_HLReader_Get_Segment
  #define HLReader_Get_Seg_Tick Lucy_HLReader_Get_Seg_Tick
  #define HLReader_Close Lucy_HLReader_Close
  #define HLReader_Fetch_Doc_Vec Lucy_HLReader_Fetch_Doc_Vec
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/HighlightReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYHIGHLIGHTREADER
struct lucy_PolyHighlightReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_VArray* readers;
    lucy_I32Array* offsets;
};

#endif /* C_LUCY_POLYHIGHLIGHTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyHighlightReader*
lucy_PolyHLReader_new(lucy_VArray* readers, lucy_I32Array* offsets);

lucy_PolyHighlightReader*
lucy_PolyHLReader_init(lucy_PolyHighlightReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

void
lucy_PolyHLReader_destroy(lucy_PolyHighlightReader* self);

void
lucy_PolyHLReader_close(lucy_PolyHighlightReader* self);

lucy_DocVector*
lucy_PolyHLReader_fetch_doc_vec(lucy_PolyHighlightReader* self, int32_t doc_id);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyHLReader_destroy_CALLBACK;
extern cfish_Callback lucy_PolyHLReader_close_CALLBACK;
extern cfish_Callback lucy_PolyHLReader_fetch_doc_vec_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyHLReader_destroy_t)(lucy_PolyHighlightReader* self);

typedef void
(*lucy_PolyHLReader_close_t)(lucy_PolyHighlightReader* self);

typedef lucy_DocVector*
(*lucy_PolyHLReader_fetch_doc_vec_t)(lucy_PolyHighlightReader* self, int32_t doc_id);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyHLReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyHLReader_Make(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyHLReader_Get_RefCount(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyHLReader_Inc_RefCount(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyHLReader_Dec_RefCount(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyHLReader_To_Host(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyHLReader_Clone(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyHLReader_Destroy(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Destroy_OFFSET;
    const lucy_PolyHLReader_destroy_t method = *((lucy_PolyHLReader_destroy_t*)method_address);
    method((lucy_PolyHighlightReader*)self);
}

extern size_t Lucy_PolyHLReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyHLReader_Equals(const lucy_PolyHighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyHLReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyHLReader_Compare_To(const lucy_PolyHighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyHLReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyHLReader_Hash_Sum(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyHLReader_Get_VTable(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyHLReader_Get_Class_Name(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyHLReader_Is_A(const lucy_PolyHighlightReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyHLReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyHLReader_To_String(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyHLReader_To_I64(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyHLReader_To_F64(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyHLReader_To_Bool(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyHLReader_Serialize(const lucy_PolyHighlightReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyHLReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyHLReader_Deserialize(const lucy_PolyHighlightReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyHLReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyHLReader_Dump(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyHLReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyHLReader_Load(const lucy_PolyHighlightReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolyHLReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyHLReader_Mimic(const lucy_PolyHighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyHLReader_Aggregator_OFFSET;
static CHY_INLINE lucy_HighlightReader*
Lucy_PolyHLReader_Aggregator(const lucy_PolyHighlightReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Aggregator_OFFSET;
    const lucy_HLReader_aggregator_t method = *((lucy_HLReader_aggregator_t*)method_address);
    return method((lucy_HighlightReader*)self, readers, offsets);
}

extern size_t Lucy_PolyHLReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PolyHLReader_Get_Schema(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyHLReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PolyHLReader_Get_Folder(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyHLReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PolyHLReader_Get_Snapshot(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyHLReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyHLReader_Get_Segments(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyHLReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PolyHLReader_Get_Segment(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyHLReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyHLReader_Get_Seg_Tick(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyHLReader_Close_OFFSET;
static CHY_INLINE void
Lucy_PolyHLReader_Close(const lucy_PolyHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Close_OFFSET;
    const lucy_PolyHLReader_close_t method = *((lucy_PolyHLReader_close_t*)method_address);
    method((lucy_PolyHighlightReader*)self);
}

extern size_t Lucy_PolyHLReader_Fetch_Doc_Vec_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_PolyHLReader_Fetch_Doc_Vec(const lucy_PolyHighlightReader *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_PolyHLReader_Fetch_Doc_Vec_OFFSET;
    const lucy_PolyHLReader_fetch_doc_vec_t method = *((lucy_PolyHLReader_fetch_doc_vec_t*)method_address);
    return method((lucy_PolyHighlightReader*)self, doc_id);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYHIGHLIGHTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_POLYHIGHLIGHTREADER_VT;
extern struct LUCY_POLYHIGHLIGHTREADER_VT LUCY_POLYHIGHLIGHTREADER_vt;
#define LUCY_POLYHIGHLIGHTREADER ((cfish_VTable*)&LUCY_POLYHIGHLIGHTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyHighlightReader lucy_PolyHighlightReader
  #define POLYHIGHLIGHTREADER LUCY_POLYHIGHLIGHTREADER
  #define PolyHLReader_new lucy_PolyHLReader_new
  #define PolyHLReader_init lucy_PolyHLReader_init
  #define PolyHLReader_destroy_t lucy_PolyHLReader_destroy_t
  #define PolyHLReader_destroy lucy_PolyHLReader_destroy
  #define PolyHLReader_close_t lucy_PolyHLReader_close_t
  #define PolyHLReader_close lucy_PolyHLReader_close
  #define PolyHLReader_fetch_doc_vec_t lucy_PolyHLReader_fetch_doc_vec_t
  #define PolyHLReader_fetch_doc_vec lucy_PolyHLReader_fetch_doc_vec
  #define PolyHLReader_Make Lucy_PolyHLReader_Make
  #define PolyHLReader_Get_RefCount Lucy_PolyHLReader_Get_RefCount
  #define PolyHLReader_Inc_RefCount Lucy_PolyHLReader_Inc_RefCount
  #define PolyHLReader_Dec_RefCount Lucy_PolyHLReader_Dec_RefCount
  #define PolyHLReader_To_Host Lucy_PolyHLReader_To_Host
  #define PolyHLReader_Clone Lucy_PolyHLReader_Clone
  #define PolyHLReader_Destroy Lucy_PolyHLReader_Destroy
  #define PolyHLReader_Equals Lucy_PolyHLReader_Equals
  #define PolyHLReader_Compare_To Lucy_PolyHLReader_Compare_To
  #define PolyHLReader_Hash_Sum Lucy_PolyHLReader_Hash_Sum
  #define PolyHLReader_Get_VTable Lucy_PolyHLReader_Get_VTable
  #define PolyHLReader_Get_Class_Name Lucy_PolyHLReader_Get_Class_Name
  #define PolyHLReader_Is_A Lucy_PolyHLReader_Is_A
  #define PolyHLReader_To_String Lucy_PolyHLReader_To_String
  #define PolyHLReader_To_I64 Lucy_PolyHLReader_To_I64
  #define PolyHLReader_To_F64 Lucy_PolyHLReader_To_F64
  #define PolyHLReader_To_Bool Lucy_PolyHLReader_To_Bool
  #define PolyHLReader_Serialize Lucy_PolyHLReader_Serialize
  #define PolyHLReader_Deserialize Lucy_PolyHLReader_Deserialize
  #define PolyHLReader_Dump Lucy_PolyHLReader_Dump
  #define PolyHLReader_Load Lucy_PolyHLReader_Load
  #define PolyHLReader_Mimic Lucy_PolyHLReader_Mimic
  #define PolyHLReader_Aggregator Lucy_PolyHLReader_Aggregator
  #define PolyHLReader_Get_Schema Lucy_PolyHLReader_Get_Schema
  #define PolyHLReader_Get_Folder Lucy_PolyHLReader_Get_Folder
  #define PolyHLReader_Get_Snapshot Lucy_PolyHLReader_Get_Snapshot
  #define PolyHLReader_Get_Segments Lucy_PolyHLReader_Get_Segments
  #define PolyHLReader_Get_Segment Lucy_PolyHLReader_Get_Segment
  #define PolyHLReader_Get_Seg_Tick Lucy_PolyHLReader_Get_Seg_Tick
  #define PolyHLReader_Close Lucy_PolyHLReader_Close
  #define PolyHLReader_Fetch_Doc_Vec Lucy_PolyHLReader_Fetch_Doc_Vec
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/HighlightReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTHIGHLIGHTREADER
struct lucy_DefaultHighlightReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_InStream* ix_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_DEFAULTHIGHLIGHTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultHighlightReader*
lucy_DefHLReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DefaultHighlightReader*
lucy_DefHLReader_init(lucy_DefaultHighlightReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_DefHLReader_destroy(lucy_DefaultHighlightReader* self);

void
lucy_DefHLReader_close(lucy_DefaultHighlightReader* self);

lucy_DocVector*
lucy_DefHLReader_fetch_doc_vec(lucy_DefaultHighlightReader* self, int32_t doc_id);

void
lucy_DefHLReader_read_record(lucy_DefaultHighlightReader* self, int32_t doc_id, lucy_ByteBuf* buffer);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefHLReader_destroy_CALLBACK;
extern cfish_Callback lucy_DefHLReader_close_CALLBACK;
extern cfish_Callback lucy_DefHLReader_fetch_doc_vec_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefHLReader_destroy_t)(lucy_DefaultHighlightReader* self);

typedef void
(*lucy_DefHLReader_close_t)(lucy_DefaultHighlightReader* self);

typedef lucy_DocVector*
(*lucy_DefHLReader_fetch_doc_vec_t)(lucy_DefaultHighlightReader* self, int32_t doc_id);

typedef void
(*lucy_DefHLReader_read_record_t)(lucy_DefaultHighlightReader* self, int32_t doc_id, lucy_ByteBuf* buffer);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefHLReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefHLReader_Make(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefHLReader_Get_RefCount(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefHLReader_Inc_RefCount(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefHLReader_Dec_RefCount(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefHLReader_To_Host(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefHLReader_Clone(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefHLReader_Destroy(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Destroy_OFFSET;
    const lucy_DefHLReader_destroy_t method = *((lucy_DefHLReader_destroy_t*)method_address);
    method((lucy_DefaultHighlightReader*)self);
}

extern size_t Lucy_DefHLReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefHLReader_Equals(const lucy_DefaultHighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefHLReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefHLReader_Compare_To(const lucy_DefaultHighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefHLReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefHLReader_Hash_Sum(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefHLReader_Get_VTable(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefHLReader_Get_Class_Name(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefHLReader_Is_A(const lucy_DefaultHighlightReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefHLReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefHLReader_To_String(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefHLReader_To_I64(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefHLReader_To_F64(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefHLReader_To_Bool(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefHLReader_Serialize(const lucy_DefaultHighlightReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefHLReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefHLReader_Deserialize(const lucy_DefaultHighlightReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefHLReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefHLReader_Dump(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefHLReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefHLReader_Load(const lucy_DefaultHighlightReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefHLReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefHLReader_Mimic(const lucy_DefaultHighlightReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefHLReader_Aggregator_OFFSET;
static CHY_INLINE lucy_HighlightReader*
Lucy_DefHLReader_Aggregator(const lucy_DefaultHighlightReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Aggregator_OFFSET;
    const lucy_HLReader_aggregator_t method = *((lucy_HLReader_aggregator_t*)method_address);
    return method((lucy_HighlightReader*)self, readers, offsets);
}

extern size_t Lucy_DefHLReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefHLReader_Get_Schema(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefHLReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefHLReader_Get_Folder(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefHLReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefHLReader_Get_Snapshot(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefHLReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DefHLReader_Get_Segments(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefHLReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefHLReader_Get_Segment(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefHLReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DefHLReader_Get_Seg_Tick(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefHLReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DefHLReader_Close(const lucy_DefaultHighlightReader *self) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Close_OFFSET;
    const lucy_DefHLReader_close_t method = *((lucy_DefHLReader_close_t*)method_address);
    method((lucy_DefaultHighlightReader*)self);
}

extern size_t Lucy_DefHLReader_Fetch_Doc_Vec_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_DefHLReader_Fetch_Doc_Vec(const lucy_DefaultHighlightReader *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Fetch_Doc_Vec_OFFSET;
    const lucy_DefHLReader_fetch_doc_vec_t method = *((lucy_DefHLReader_fetch_doc_vec_t*)method_address);
    return method((lucy_DefaultHighlightReader*)self, doc_id);
}

extern size_t Lucy_DefHLReader_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_DefHLReader_Read_Record(const lucy_DefaultHighlightReader *self, int32_t doc_id, lucy_ByteBuf* buffer) {
    char *const method_address = *(char**)self + Lucy_DefHLReader_Read_Record_OFFSET;
    const lucy_DefHLReader_read_record_t method = *((lucy_DefHLReader_read_record_t*)method_address);
    method((lucy_DefaultHighlightReader*)self, doc_id, buffer);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTHIGHLIGHTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_DEFAULTHIGHLIGHTREADER_VT;
extern struct LUCY_DEFAULTHIGHLIGHTREADER_VT LUCY_DEFAULTHIGHLIGHTREADER_vt;
#define LUCY_DEFAULTHIGHLIGHTREADER ((cfish_VTable*)&LUCY_DEFAULTHIGHLIGHTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultHighlightReader lucy_DefaultHighlightReader
  #define DEFAULTHIGHLIGHTREADER LUCY_DEFAULTHIGHLIGHTREADER
  #define DefHLReader_new lucy_DefHLReader_new
  #define DefHLReader_init lucy_DefHLReader_init
  #define DefHLReader_destroy_t lucy_DefHLReader_destroy_t
  #define DefHLReader_destroy lucy_DefHLReader_destroy
  #define DefHLReader_close_t lucy_DefHLReader_close_t
  #define DefHLReader_close lucy_DefHLReader_close
  #define DefHLReader_fetch_doc_vec_t lucy_DefHLReader_fetch_doc_vec_t
  #define DefHLReader_fetch_doc_vec lucy_DefHLReader_fetch_doc_vec
  #define DefHLReader_read_record_t lucy_DefHLReader_read_record_t
  #define DefHLReader_read_record lucy_DefHLReader_read_record
  #define DefHLReader_Make Lucy_DefHLReader_Make
  #define DefHLReader_Get_RefCount Lucy_DefHLReader_Get_RefCount
  #define DefHLReader_Inc_RefCount Lucy_DefHLReader_Inc_RefCount
  #define DefHLReader_Dec_RefCount Lucy_DefHLReader_Dec_RefCount
  #define DefHLReader_To_Host Lucy_DefHLReader_To_Host
  #define DefHLReader_Clone Lucy_DefHLReader_Clone
  #define DefHLReader_Destroy Lucy_DefHLReader_Destroy
  #define DefHLReader_Equals Lucy_DefHLReader_Equals
  #define DefHLReader_Compare_To Lucy_DefHLReader_Compare_To
  #define DefHLReader_Hash_Sum Lucy_DefHLReader_Hash_Sum
  #define DefHLReader_Get_VTable Lucy_DefHLReader_Get_VTable
  #define DefHLReader_Get_Class_Name Lucy_DefHLReader_Get_Class_Name
  #define DefHLReader_Is_A Lucy_DefHLReader_Is_A
  #define DefHLReader_To_String Lucy_DefHLReader_To_String
  #define DefHLReader_To_I64 Lucy_DefHLReader_To_I64
  #define DefHLReader_To_F64 Lucy_DefHLReader_To_F64
  #define DefHLReader_To_Bool Lucy_DefHLReader_To_Bool
  #define DefHLReader_Serialize Lucy_DefHLReader_Serialize
  #define DefHLReader_Deserialize Lucy_DefHLReader_Deserialize
  #define DefHLReader_Dump Lucy_DefHLReader_Dump
  #define DefHLReader_Load Lucy_DefHLReader_Load
  #define DefHLReader_Mimic Lucy_DefHLReader_Mimic
  #define DefHLReader_Aggregator Lucy_DefHLReader_Aggregator
  #define DefHLReader_Get_Schema Lucy_DefHLReader_Get_Schema
  #define DefHLReader_Get_Folder Lucy_DefHLReader_Get_Folder
  #define DefHLReader_Get_Snapshot Lucy_DefHLReader_Get_Snapshot
  #define DefHLReader_Get_Segments Lucy_DefHLReader_Get_Segments
  #define DefHLReader_Get_Segment Lucy_DefHLReader_Get_Segment
  #define DefHLReader_Get_Seg_Tick Lucy_DefHLReader_Get_Seg_Tick
  #define DefHLReader_Close Lucy_DefHLReader_Close
  #define DefHLReader_Fetch_Doc_Vec Lucy_DefHLReader_Fetch_Doc_Vec
  #define DefHLReader_Read_Record Lucy_DefHLReader_Read_Record
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_HIGHLIGHTREADER */




