/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_HIGHLIGHTWRITER
#define H_LUCY_INDEX_HIGHLIGHTWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HIGHLIGHTWRITER
struct lucy_HighlightWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_OutStream* ix_out;
    lucy_OutStream* dat_out;
};

#endif /* C_LUCY_HIGHLIGHTWRITER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_HLWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_HighlightWriter*
lucy_HLWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

lucy_HighlightWriter*
lucy_HLWriter_init(lucy_HighlightWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_HLWriter_destroy(lucy_HighlightWriter* self);

void
lucy_HLWriter_add_inverted_doc(lucy_HighlightWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
lucy_HLWriter_add_segment(lucy_HighlightWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_HLWriter_finish(lucy_HighlightWriter* self);

int32_t
lucy_HLWriter_format(lucy_HighlightWriter* self);

lucy_ByteBuf*
lucy_HLWriter_tv_buf(lucy_HighlightWriter* self, lucy_Inversion* inversion);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_HLWriter_destroy_CALLBACK;
extern cfish_Callback lucy_HLWriter_add_inverted_doc_CALLBACK;
extern cfish_Callback lucy_HLWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_HLWriter_finish_CALLBACK;
extern cfish_Callback lucy_HLWriter_format_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_HLWriter_destroy_t)(lucy_HighlightWriter* self);

typedef void
(*lucy_HLWriter_add_inverted_doc_t)(lucy_HighlightWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*lucy_HLWriter_add_segment_t)(lucy_HighlightWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_HLWriter_finish_t)(lucy_HighlightWriter* self);

typedef int32_t
(*lucy_HLWriter_format_t)(lucy_HighlightWriter* self);

typedef lucy_ByteBuf*
(*lucy_HLWriter_tv_buf_t)(lucy_HighlightWriter* self, lucy_Inversion* inversion);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_HLWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLWriter_Make(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HLWriter_Get_RefCount(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLWriter_Inc_RefCount(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HLWriter_Dec_RefCount(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_HLWriter_To_Host(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLWriter_Clone(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Destroy(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Destroy_OFFSET;
    const lucy_HLWriter_destroy_t method = *((lucy_HLWriter_destroy_t*)method_address);
    method((lucy_HighlightWriter*)self);
}

extern size_t Lucy_HLWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HLWriter_Equals(const lucy_HighlightWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HLWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_HLWriter_Compare_To(const lucy_HighlightWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HLWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_HLWriter_Hash_Sum(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_HLWriter_Get_VTable(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HLWriter_Get_Class_Name(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HLWriter_Is_A(const lucy_HighlightWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_HLWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HLWriter_To_String(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_HLWriter_To_I64(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_HLWriter_To_F64(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HLWriter_To_Bool(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Serialize(const lucy_HighlightWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_HLWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLWriter_Deserialize(const lucy_HighlightWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_HLWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLWriter_Dump(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HLWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HLWriter_Load(const lucy_HighlightWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_HLWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Mimic(const lucy_HighlightWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_HLWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Add_Inverted_Doc(const lucy_HighlightWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Add_Inverted_Doc_OFFSET;
    const lucy_HLWriter_add_inverted_doc_t method = *((lucy_HLWriter_add_inverted_doc_t*)method_address);
    method((lucy_HighlightWriter*)self, inverter, doc_id);
}

extern size_t Lucy_HLWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Add_Segment(const lucy_HighlightWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Add_Segment_OFFSET;
    const lucy_HLWriter_add_segment_t method = *((lucy_HLWriter_add_segment_t*)method_address);
    method((lucy_HighlightWriter*)self, reader, doc_map);
}

extern size_t Lucy_HLWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Delete_Segment(const lucy_HighlightWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_HLWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Merge_Segment(const lucy_HighlightWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_HLWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_HLWriter_Finish(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Finish_OFFSET;
    const lucy_HLWriter_finish_t method = *((lucy_HLWriter_finish_t*)method_address);
    method((lucy_HighlightWriter*)self);
}

extern size_t Lucy_HLWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_HLWriter_Metadata(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_HLWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_HLWriter_Format(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Format_OFFSET;
    const lucy_HLWriter_format_t method = *((lucy_HLWriter_format_t*)method_address);
    return method((lucy_HighlightWriter*)self);
}

extern size_t Lucy_HLWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_HLWriter_Get_Snapshot(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_HLWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_HLWriter_Get_Segment(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_HLWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_HLWriter_Get_PolyReader(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_HLWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_HLWriter_Get_Schema(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_HLWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_HLWriter_Get_Folder(const lucy_HighlightWriter *self) {
    char *const method_address = *(char**)self + Lucy_HLWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_HLWriter_TV_Buf_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_HLWriter_TV_Buf(const lucy_HighlightWriter *self, lucy_Inversion* inversion) {
    char *const method_address = *(char**)self + Lucy_HLWriter_TV_Buf_OFFSET;
    const lucy_HLWriter_tv_buf_t method = *((lucy_HLWriter_tv_buf_t*)method_address);
    return method((lucy_HighlightWriter*)self, inversion);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HIGHLIGHTWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_HIGHLIGHTWRITER_VT;
extern struct LUCY_HIGHLIGHTWRITER_VT LUCY_HIGHLIGHTWRITER_vt;
#define LUCY_HIGHLIGHTWRITER ((cfish_VTable*)&LUCY_HIGHLIGHTWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define HighlightWriter lucy_HighlightWriter
  #define HIGHLIGHTWRITER LUCY_HIGHLIGHTWRITER
  #define HLWriter_new lucy_HLWriter_new
  #define HLWriter_init lucy_HLWriter_init
  #define HLWriter_current_file_format lucy_HLWriter_current_file_format
  #define HLWriter_destroy_t lucy_HLWriter_destroy_t
  #define HLWriter_destroy lucy_HLWriter_destroy
  #define HLWriter_add_inverted_doc_t lucy_HLWriter_add_inverted_doc_t
  #define HLWriter_add_inverted_doc lucy_HLWriter_add_inverted_doc
  #define HLWriter_add_segment_t lucy_HLWriter_add_segment_t
  #define HLWriter_add_segment lucy_HLWriter_add_segment
  #define HLWriter_finish_t lucy_HLWriter_finish_t
  #define HLWriter_finish lucy_HLWriter_finish
  #define HLWriter_format_t lucy_HLWriter_format_t
  #define HLWriter_format lucy_HLWriter_format
  #define HLWriter_tv_buf_t lucy_HLWriter_tv_buf_t
  #define HLWriter_tv_buf lucy_HLWriter_tv_buf
  #define HLWriter_Make Lucy_HLWriter_Make
  #define HLWriter_Get_RefCount Lucy_HLWriter_Get_RefCount
  #define HLWriter_Inc_RefCount Lucy_HLWriter_Inc_RefCount
  #define HLWriter_Dec_RefCount Lucy_HLWriter_Dec_RefCount
  #define HLWriter_To_Host Lucy_HLWriter_To_Host
  #define HLWriter_Clone Lucy_HLWriter_Clone
  #define HLWriter_Destroy Lucy_HLWriter_Destroy
  #define HLWriter_Equals Lucy_HLWriter_Equals
  #define HLWriter_Compare_To Lucy_HLWriter_Compare_To
  #define HLWriter_Hash_Sum Lucy_HLWriter_Hash_Sum
  #define HLWriter_Get_VTable Lucy_HLWriter_Get_VTable
  #define HLWriter_Get_Class_Name Lucy_HLWriter_Get_Class_Name
  #define HLWriter_Is_A Lucy_HLWriter_Is_A
  #define HLWriter_To_String Lucy_HLWriter_To_String
  #define HLWriter_To_I64 Lucy_HLWriter_To_I64
  #define HLWriter_To_F64 Lucy_HLWriter_To_F64
  #define HLWriter_To_Bool Lucy_HLWriter_To_Bool
  #define HLWriter_Serialize Lucy_HLWriter_Serialize
  #define HLWriter_Deserialize Lucy_HLWriter_Deserialize
  #define HLWriter_Dump Lucy_HLWriter_Dump
  #define HLWriter_Load Lucy_HLWriter_Load
  #define HLWriter_Mimic Lucy_HLWriter_Mimic
  #define HLWriter_Add_Inverted_Doc Lucy_HLWriter_Add_Inverted_Doc
  #define HLWriter_Add_Segment Lucy_HLWriter_Add_Segment
  #define HLWriter_Delete_Segment Lucy_HLWriter_Delete_Segment
  #define HLWriter_Merge_Segment Lucy_HLWriter_Merge_Segment
  #define HLWriter_Finish Lucy_HLWriter_Finish
  #define HLWriter_Metadata Lucy_HLWriter_Metadata
  #define HLWriter_Format Lucy_HLWriter_Format
  #define HLWriter_Get_Snapshot Lucy_HLWriter_Get_Snapshot
  #define HLWriter_Get_Segment Lucy_HLWriter_Get_Segment
  #define HLWriter_Get_PolyReader Lucy_HLWriter_Get_PolyReader
  #define HLWriter_Get_Schema Lucy_HLWriter_Get_Schema
  #define HLWriter_Get_Folder Lucy_HLWriter_Get_Folder
  #define HLWriter_TV_Buf Lucy_HLWriter_TV_Buf
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_HIGHLIGHTWRITER */




