/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_INDEXMANAGER
#define H_LUCY_INDEX_INDEXMANAGER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INDEXMANAGER
struct lucy_IndexManager {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Folder* folder;
    lucy_CharBuf* host;
    lucy_LockFactory* lock_factory;
    uint32_t write_lock_timeout;
    uint32_t write_lock_interval;
    uint32_t merge_lock_timeout;
    uint32_t merge_lock_interval;
    uint32_t deletion_lock_timeout;
    uint32_t deletion_lock_interval;
};

#endif /* C_LUCY_INDEXMANAGER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_IndexManager*
lucy_IxManager_new(const lucy_CharBuf* host, lucy_LockFactory* lock_factory);

lucy_IndexManager*
lucy_IxManager_init(lucy_IndexManager* self, const lucy_CharBuf* host, lucy_LockFactory* lock_factory);

void
lucy_IxManager_destroy(lucy_IndexManager* self);

void
lucy_IxManager_set_folder(lucy_IndexManager* self, lucy_Folder* folder);

lucy_Folder*
lucy_IxManager_get_folder(lucy_IndexManager* self);

lucy_CharBuf*
lucy_IxManager_get_host(lucy_IndexManager* self);

lucy_VArray*
lucy_IxManager_recycle(lucy_IndexManager* self, lucy_PolyReader* reader, lucy_DeletionsWriter* del_writer, int64_t cutoff, chy_bool_t optimize);

uint32_t
lucy_IxManager_choose_sparse(lucy_IndexManager* self, lucy_I32Array* doc_counts);

lucy_Lock*
lucy_IxManager_make_write_lock(lucy_IndexManager* self);

lucy_Lock*
lucy_IxManager_make_deletion_lock(lucy_IndexManager* self);

lucy_Lock*
lucy_IxManager_make_merge_lock(lucy_IndexManager* self);

void
lucy_IxManager_write_merge_data(lucy_IndexManager* self, int64_t cutoff);

lucy_Hash*
lucy_IxManager_read_merge_data(lucy_IndexManager* self);

chy_bool_t
lucy_IxManager_remove_merge_data(lucy_IndexManager* self);

lucy_Lock*
lucy_IxManager_make_snapshot_read_lock(lucy_IndexManager* self, const lucy_CharBuf* filename);

int64_t
lucy_IxManager_highest_seg_num(lucy_IndexManager* self, lucy_Snapshot* snapshot);

lucy_CharBuf*
lucy_IxManager_make_snapshot_filename(lucy_IndexManager* self);

void
lucy_IxManager_set_write_lock_timeout(lucy_IndexManager* self, uint32_t timeout);

uint32_t
lucy_IxManager_get_write_lock_timeout(lucy_IndexManager* self);

void
lucy_IxManager_set_write_lock_interval(lucy_IndexManager* self, uint32_t timeout);

uint32_t
lucy_IxManager_get_write_lock_interval(lucy_IndexManager* self);

void
lucy_IxManager_set_merge_lock_timeout(lucy_IndexManager* self, uint32_t timeout);

uint32_t
lucy_IxManager_get_merge_lock_timeout(lucy_IndexManager* self);

void
lucy_IxManager_set_merge_lock_interval(lucy_IndexManager* self, uint32_t timeout);

uint32_t
lucy_IxManager_get_merge_lock_interval(lucy_IndexManager* self);

void
lucy_IxManager_set_deletion_lock_timeout(lucy_IndexManager* self, uint32_t timeout);

uint32_t
lucy_IxManager_get_deletion_lock_timeout(lucy_IndexManager* self);

void
lucy_IxManager_set_deletion_lock_interval(lucy_IndexManager* self, uint32_t timeout);

uint32_t
lucy_IxManager_get_deletion_lock_interval(lucy_IndexManager* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_IxManager_destroy_CALLBACK;
extern cfish_Callback lucy_IxManager_set_folder_CALLBACK;
extern cfish_Callback lucy_IxManager_get_folder_CALLBACK;
extern cfish_Callback lucy_IxManager_get_host_CALLBACK;
extern cfish_Callback lucy_IxManager_recycle_CALLBACK;
extern cfish_Callback lucy_IxManager_make_write_lock_CALLBACK;
extern cfish_Callback lucy_IxManager_make_deletion_lock_CALLBACK;
extern cfish_Callback lucy_IxManager_make_merge_lock_CALLBACK;
extern cfish_Callback lucy_IxManager_write_merge_data_CALLBACK;
extern cfish_Callback lucy_IxManager_read_merge_data_CALLBACK;
extern cfish_Callback lucy_IxManager_remove_merge_data_CALLBACK;
extern cfish_Callback lucy_IxManager_make_snapshot_read_lock_CALLBACK;
extern cfish_Callback lucy_IxManager_highest_seg_num_CALLBACK;
extern cfish_Callback lucy_IxManager_make_snapshot_filename_CALLBACK;
extern cfish_Callback lucy_IxManager_set_write_lock_timeout_CALLBACK;
extern cfish_Callback lucy_IxManager_get_write_lock_timeout_CALLBACK;
extern cfish_Callback lucy_IxManager_set_write_lock_interval_CALLBACK;
extern cfish_Callback lucy_IxManager_get_write_lock_interval_CALLBACK;
extern cfish_Callback lucy_IxManager_set_merge_lock_timeout_CALLBACK;
extern cfish_Callback lucy_IxManager_get_merge_lock_timeout_CALLBACK;
extern cfish_Callback lucy_IxManager_set_merge_lock_interval_CALLBACK;
extern cfish_Callback lucy_IxManager_get_merge_lock_interval_CALLBACK;
extern cfish_Callback lucy_IxManager_set_deletion_lock_timeout_CALLBACK;
extern cfish_Callback lucy_IxManager_get_deletion_lock_timeout_CALLBACK;
extern cfish_Callback lucy_IxManager_set_deletion_lock_interval_CALLBACK;
extern cfish_Callback lucy_IxManager_get_deletion_lock_interval_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_IxManager_destroy_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_folder_t)(lucy_IndexManager* self, lucy_Folder* folder);

typedef lucy_Folder*
(*lucy_IxManager_get_folder_t)(lucy_IndexManager* self);

typedef lucy_CharBuf*
(*lucy_IxManager_get_host_t)(lucy_IndexManager* self);

typedef lucy_VArray*
(*lucy_IxManager_recycle_t)(lucy_IndexManager* self, lucy_PolyReader* reader, lucy_DeletionsWriter* del_writer, int64_t cutoff, chy_bool_t optimize);

typedef uint32_t
(*lucy_IxManager_choose_sparse_t)(lucy_IndexManager* self, lucy_I32Array* doc_counts);

typedef lucy_Lock*
(*lucy_IxManager_make_write_lock_t)(lucy_IndexManager* self);

typedef lucy_Lock*
(*lucy_IxManager_make_deletion_lock_t)(lucy_IndexManager* self);

typedef lucy_Lock*
(*lucy_IxManager_make_merge_lock_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_write_merge_data_t)(lucy_IndexManager* self, int64_t cutoff);

typedef lucy_Hash*
(*lucy_IxManager_read_merge_data_t)(lucy_IndexManager* self);

typedef chy_bool_t
(*lucy_IxManager_remove_merge_data_t)(lucy_IndexManager* self);

typedef lucy_Lock*
(*lucy_IxManager_make_snapshot_read_lock_t)(lucy_IndexManager* self, const lucy_CharBuf* filename);

typedef int64_t
(*lucy_IxManager_highest_seg_num_t)(lucy_IndexManager* self, lucy_Snapshot* snapshot);

typedef lucy_CharBuf*
(*lucy_IxManager_make_snapshot_filename_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_write_lock_timeout_t)(lucy_IndexManager* self, uint32_t timeout);

typedef uint32_t
(*lucy_IxManager_get_write_lock_timeout_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_write_lock_interval_t)(lucy_IndexManager* self, uint32_t timeout);

typedef uint32_t
(*lucy_IxManager_get_write_lock_interval_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_merge_lock_timeout_t)(lucy_IndexManager* self, uint32_t timeout);

typedef uint32_t
(*lucy_IxManager_get_merge_lock_timeout_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_merge_lock_interval_t)(lucy_IndexManager* self, uint32_t timeout);

typedef uint32_t
(*lucy_IxManager_get_merge_lock_interval_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_deletion_lock_timeout_t)(lucy_IndexManager* self, uint32_t timeout);

typedef uint32_t
(*lucy_IxManager_get_deletion_lock_timeout_t)(lucy_IndexManager* self);

typedef void
(*lucy_IxManager_set_deletion_lock_interval_t)(lucy_IndexManager* self, uint32_t timeout);

typedef uint32_t
(*lucy_IxManager_get_deletion_lock_interval_t)(lucy_IndexManager* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_IxManager_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxManager_Make(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_RefCount(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxManager_Inc_RefCount(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Dec_RefCount(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_IxManager_To_Host(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxManager_Clone(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Destroy_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Destroy(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Destroy_OFFSET;
    const lucy_IxManager_destroy_t method = *((lucy_IxManager_destroy_t*)method_address);
    method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxManager_Equals(const lucy_IndexManager *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxManager_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxManager_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_IxManager_Compare_To(const lucy_IndexManager *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxManager_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxManager_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_IxManager_Hash_Sum(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_IxManager_Get_VTable(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxManager_Get_Class_Name(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxManager_Is_A(const lucy_IndexManager *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_IxManager_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_IxManager_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxManager_To_String(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_IxManager_To_I64(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_To_F64_OFFSET;
static CHY_INLINE double
Lucy_IxManager_To_F64(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxManager_To_Bool(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Serialize_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Serialize(const lucy_IndexManager *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_IxManager_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_IxManager_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxManager_Deserialize(const lucy_IndexManager *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_IxManager_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_IxManager_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxManager_Dump(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxManager_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxManager_Load(const lucy_IndexManager *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_IxManager_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_IxManager_Mimic_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Mimic(const lucy_IndexManager *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxManager_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxManager_Set_Folder_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Folder(const lucy_IndexManager *self, lucy_Folder* folder) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Folder_OFFSET;
    const lucy_IxManager_set_folder_t method = *((lucy_IxManager_set_folder_t*)method_address);
    method((lucy_IndexManager*)self, folder);
}

extern size_t Lucy_IxManager_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_IxManager_Get_Folder(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Folder_OFFSET;
    const lucy_IxManager_get_folder_t method = *((lucy_IxManager_get_folder_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Get_Host_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxManager_Get_Host(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Host_OFFSET;
    const lucy_IxManager_get_host_t method = *((lucy_IxManager_get_host_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Recycle_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_IxManager_Recycle(const lucy_IndexManager *self, lucy_PolyReader* reader, lucy_DeletionsWriter* del_writer, int64_t cutoff, chy_bool_t optimize) {
    char *const method_address = *(char**)self + Lucy_IxManager_Recycle_OFFSET;
    const lucy_IxManager_recycle_t method = *((lucy_IxManager_recycle_t*)method_address);
    return method((lucy_IndexManager*)self, reader, del_writer, cutoff, optimize);
}

extern size_t Lucy_IxManager_Choose_Sparse_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Choose_Sparse(const lucy_IndexManager *self, lucy_I32Array* doc_counts) {
    char *const method_address = *(char**)self + Lucy_IxManager_Choose_Sparse_OFFSET;
    const lucy_IxManager_choose_sparse_t method = *((lucy_IxManager_choose_sparse_t*)method_address);
    return method((lucy_IndexManager*)self, doc_counts);
}

extern size_t Lucy_IxManager_Make_Write_Lock_OFFSET;
static CHY_INLINE lucy_Lock*
Lucy_IxManager_Make_Write_Lock(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Make_Write_Lock_OFFSET;
    const lucy_IxManager_make_write_lock_t method = *((lucy_IxManager_make_write_lock_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Make_Deletion_Lock_OFFSET;
static CHY_INLINE lucy_Lock*
Lucy_IxManager_Make_Deletion_Lock(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Make_Deletion_Lock_OFFSET;
    const lucy_IxManager_make_deletion_lock_t method = *((lucy_IxManager_make_deletion_lock_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Make_Merge_Lock_OFFSET;
static CHY_INLINE lucy_Lock*
Lucy_IxManager_Make_Merge_Lock(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Make_Merge_Lock_OFFSET;
    const lucy_IxManager_make_merge_lock_t method = *((lucy_IxManager_make_merge_lock_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Write_Merge_Data_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Write_Merge_Data(const lucy_IndexManager *self, int64_t cutoff) {
    char *const method_address = *(char**)self + Lucy_IxManager_Write_Merge_Data_OFFSET;
    const lucy_IxManager_write_merge_data_t method = *((lucy_IxManager_write_merge_data_t*)method_address);
    method((lucy_IndexManager*)self, cutoff);
}

extern size_t Lucy_IxManager_Read_Merge_Data_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_IxManager_Read_Merge_Data(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Read_Merge_Data_OFFSET;
    const lucy_IxManager_read_merge_data_t method = *((lucy_IxManager_read_merge_data_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Remove_Merge_Data_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxManager_Remove_Merge_Data(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Remove_Merge_Data_OFFSET;
    const lucy_IxManager_remove_merge_data_t method = *((lucy_IxManager_remove_merge_data_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Make_Snapshot_Read_Lock_OFFSET;
static CHY_INLINE lucy_Lock*
Lucy_IxManager_Make_Snapshot_Read_Lock(const lucy_IndexManager *self, const lucy_CharBuf* filename) {
    char *const method_address = *(char**)self + Lucy_IxManager_Make_Snapshot_Read_Lock_OFFSET;
    const lucy_IxManager_make_snapshot_read_lock_t method = *((lucy_IxManager_make_snapshot_read_lock_t*)method_address);
    return method((lucy_IndexManager*)self, filename);
}

extern size_t Lucy_IxManager_Highest_Seg_Num_OFFSET;
static CHY_INLINE int64_t
Lucy_IxManager_Highest_Seg_Num(const lucy_IndexManager *self, lucy_Snapshot* snapshot) {
    char *const method_address = *(char**)self + Lucy_IxManager_Highest_Seg_Num_OFFSET;
    const lucy_IxManager_highest_seg_num_t method = *((lucy_IxManager_highest_seg_num_t*)method_address);
    return method((lucy_IndexManager*)self, snapshot);
}

extern size_t Lucy_IxManager_Make_Snapshot_Filename_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxManager_Make_Snapshot_Filename(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Make_Snapshot_Filename_OFFSET;
    const lucy_IxManager_make_snapshot_filename_t method = *((lucy_IxManager_make_snapshot_filename_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Set_Write_Lock_Timeout_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Write_Lock_Timeout(const lucy_IndexManager *self, uint32_t timeout) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Write_Lock_Timeout_OFFSET;
    const lucy_IxManager_set_write_lock_timeout_t method = *((lucy_IxManager_set_write_lock_timeout_t*)method_address);
    method((lucy_IndexManager*)self, timeout);
}

extern size_t Lucy_IxManager_Get_Write_Lock_Timeout_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_Write_Lock_Timeout(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Write_Lock_Timeout_OFFSET;
    const lucy_IxManager_get_write_lock_timeout_t method = *((lucy_IxManager_get_write_lock_timeout_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Set_Write_Lock_Interval_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Write_Lock_Interval(const lucy_IndexManager *self, uint32_t timeout) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Write_Lock_Interval_OFFSET;
    const lucy_IxManager_set_write_lock_interval_t method = *((lucy_IxManager_set_write_lock_interval_t*)method_address);
    method((lucy_IndexManager*)self, timeout);
}

extern size_t Lucy_IxManager_Get_Write_Lock_Interval_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_Write_Lock_Interval(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Write_Lock_Interval_OFFSET;
    const lucy_IxManager_get_write_lock_interval_t method = *((lucy_IxManager_get_write_lock_interval_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Set_Merge_Lock_Timeout_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Merge_Lock_Timeout(const lucy_IndexManager *self, uint32_t timeout) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Merge_Lock_Timeout_OFFSET;
    const lucy_IxManager_set_merge_lock_timeout_t method = *((lucy_IxManager_set_merge_lock_timeout_t*)method_address);
    method((lucy_IndexManager*)self, timeout);
}

extern size_t Lucy_IxManager_Get_Merge_Lock_Timeout_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_Merge_Lock_Timeout(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Merge_Lock_Timeout_OFFSET;
    const lucy_IxManager_get_merge_lock_timeout_t method = *((lucy_IxManager_get_merge_lock_timeout_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Set_Merge_Lock_Interval_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Merge_Lock_Interval(const lucy_IndexManager *self, uint32_t timeout) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Merge_Lock_Interval_OFFSET;
    const lucy_IxManager_set_merge_lock_interval_t method = *((lucy_IxManager_set_merge_lock_interval_t*)method_address);
    method((lucy_IndexManager*)self, timeout);
}

extern size_t Lucy_IxManager_Get_Merge_Lock_Interval_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_Merge_Lock_Interval(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Merge_Lock_Interval_OFFSET;
    const lucy_IxManager_get_merge_lock_interval_t method = *((lucy_IxManager_get_merge_lock_interval_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Set_Deletion_Lock_Timeout_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Deletion_Lock_Timeout(const lucy_IndexManager *self, uint32_t timeout) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Deletion_Lock_Timeout_OFFSET;
    const lucy_IxManager_set_deletion_lock_timeout_t method = *((lucy_IxManager_set_deletion_lock_timeout_t*)method_address);
    method((lucy_IndexManager*)self, timeout);
}

extern size_t Lucy_IxManager_Get_Deletion_Lock_Timeout_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_Deletion_Lock_Timeout(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Deletion_Lock_Timeout_OFFSET;
    const lucy_IxManager_get_deletion_lock_timeout_t method = *((lucy_IxManager_get_deletion_lock_timeout_t*)method_address);
    return method((lucy_IndexManager*)self);
}

extern size_t Lucy_IxManager_Set_Deletion_Lock_Interval_OFFSET;
static CHY_INLINE void
Lucy_IxManager_Set_Deletion_Lock_Interval(const lucy_IndexManager *self, uint32_t timeout) {
    char *const method_address = *(char**)self + Lucy_IxManager_Set_Deletion_Lock_Interval_OFFSET;
    const lucy_IxManager_set_deletion_lock_interval_t method = *((lucy_IxManager_set_deletion_lock_interval_t*)method_address);
    method((lucy_IndexManager*)self, timeout);
}

extern size_t Lucy_IxManager_Get_Deletion_Lock_Interval_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxManager_Get_Deletion_Lock_Interval(const lucy_IndexManager *self) {
    char *const method_address = *(char**)self + Lucy_IxManager_Get_Deletion_Lock_Interval_OFFSET;
    const lucy_IxManager_get_deletion_lock_interval_t method = *((lucy_IxManager_get_deletion_lock_interval_t*)method_address);
    return method((lucy_IndexManager*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INDEXMANAGER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[48];
} LUCY_INDEXMANAGER_VT;
extern struct LUCY_INDEXMANAGER_VT LUCY_INDEXMANAGER_vt;
#define LUCY_INDEXMANAGER ((cfish_VTable*)&LUCY_INDEXMANAGER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define IndexManager lucy_IndexManager
  #define INDEXMANAGER LUCY_INDEXMANAGER
  #define IxManager_new lucy_IxManager_new
  #define IxManager_init lucy_IxManager_init
  #define IxManager_destroy_t lucy_IxManager_destroy_t
  #define IxManager_destroy lucy_IxManager_destroy
  #define IxManager_set_folder_t lucy_IxManager_set_folder_t
  #define IxManager_set_folder lucy_IxManager_set_folder
  #define IxManager_get_folder_t lucy_IxManager_get_folder_t
  #define IxManager_get_folder lucy_IxManager_get_folder
  #define IxManager_get_host_t lucy_IxManager_get_host_t
  #define IxManager_get_host lucy_IxManager_get_host
  #define IxManager_recycle_t lucy_IxManager_recycle_t
  #define IxManager_recycle lucy_IxManager_recycle
  #define IxManager_choose_sparse_t lucy_IxManager_choose_sparse_t
  #define IxManager_choose_sparse lucy_IxManager_choose_sparse
  #define IxManager_make_write_lock_t lucy_IxManager_make_write_lock_t
  #define IxManager_make_write_lock lucy_IxManager_make_write_lock
  #define IxManager_make_deletion_lock_t lucy_IxManager_make_deletion_lock_t
  #define IxManager_make_deletion_lock lucy_IxManager_make_deletion_lock
  #define IxManager_make_merge_lock_t lucy_IxManager_make_merge_lock_t
  #define IxManager_make_merge_lock lucy_IxManager_make_merge_lock
  #define IxManager_write_merge_data_t lucy_IxManager_write_merge_data_t
  #define IxManager_write_merge_data lucy_IxManager_write_merge_data
  #define IxManager_read_merge_data_t lucy_IxManager_read_merge_data_t
  #define IxManager_read_merge_data lucy_IxManager_read_merge_data
  #define IxManager_remove_merge_data_t lucy_IxManager_remove_merge_data_t
  #define IxManager_remove_merge_data lucy_IxManager_remove_merge_data
  #define IxManager_make_snapshot_read_lock_t lucy_IxManager_make_snapshot_read_lock_t
  #define IxManager_make_snapshot_read_lock lucy_IxManager_make_snapshot_read_lock
  #define IxManager_highest_seg_num_t lucy_IxManager_highest_seg_num_t
  #define IxManager_highest_seg_num lucy_IxManager_highest_seg_num
  #define IxManager_make_snapshot_filename_t lucy_IxManager_make_snapshot_filename_t
  #define IxManager_make_snapshot_filename lucy_IxManager_make_snapshot_filename
  #define IxManager_set_write_lock_timeout_t lucy_IxManager_set_write_lock_timeout_t
  #define IxManager_set_write_lock_timeout lucy_IxManager_set_write_lock_timeout
  #define IxManager_get_write_lock_timeout_t lucy_IxManager_get_write_lock_timeout_t
  #define IxManager_get_write_lock_timeout lucy_IxManager_get_write_lock_timeout
  #define IxManager_set_write_lock_interval_t lucy_IxManager_set_write_lock_interval_t
  #define IxManager_set_write_lock_interval lucy_IxManager_set_write_lock_interval
  #define IxManager_get_write_lock_interval_t lucy_IxManager_get_write_lock_interval_t
  #define IxManager_get_write_lock_interval lucy_IxManager_get_write_lock_interval
  #define IxManager_set_merge_lock_timeout_t lucy_IxManager_set_merge_lock_timeout_t
  #define IxManager_set_merge_lock_timeout lucy_IxManager_set_merge_lock_timeout
  #define IxManager_get_merge_lock_timeout_t lucy_IxManager_get_merge_lock_timeout_t
  #define IxManager_get_merge_lock_timeout lucy_IxManager_get_merge_lock_timeout
  #define IxManager_set_merge_lock_interval_t lucy_IxManager_set_merge_lock_interval_t
  #define IxManager_set_merge_lock_interval lucy_IxManager_set_merge_lock_interval
  #define IxManager_get_merge_lock_interval_t lucy_IxManager_get_merge_lock_interval_t
  #define IxManager_get_merge_lock_interval lucy_IxManager_get_merge_lock_interval
  #define IxManager_set_deletion_lock_timeout_t lucy_IxManager_set_deletion_lock_timeout_t
  #define IxManager_set_deletion_lock_timeout lucy_IxManager_set_deletion_lock_timeout
  #define IxManager_get_deletion_lock_timeout_t lucy_IxManager_get_deletion_lock_timeout_t
  #define IxManager_get_deletion_lock_timeout lucy_IxManager_get_deletion_lock_timeout
  #define IxManager_set_deletion_lock_interval_t lucy_IxManager_set_deletion_lock_interval_t
  #define IxManager_set_deletion_lock_interval lucy_IxManager_set_deletion_lock_interval
  #define IxManager_get_deletion_lock_interval_t lucy_IxManager_get_deletion_lock_interval_t
  #define IxManager_get_deletion_lock_interval lucy_IxManager_get_deletion_lock_interval
  #define IxManager_Make Lucy_IxManager_Make
  #define IxManager_Get_RefCount Lucy_IxManager_Get_RefCount
  #define IxManager_Inc_RefCount Lucy_IxManager_Inc_RefCount
  #define IxManager_Dec_RefCount Lucy_IxManager_Dec_RefCount
  #define IxManager_To_Host Lucy_IxManager_To_Host
  #define IxManager_Clone Lucy_IxManager_Clone
  #define IxManager_Destroy Lucy_IxManager_Destroy
  #define IxManager_Equals Lucy_IxManager_Equals
  #define IxManager_Compare_To Lucy_IxManager_Compare_To
  #define IxManager_Hash_Sum Lucy_IxManager_Hash_Sum
  #define IxManager_Get_VTable Lucy_IxManager_Get_VTable
  #define IxManager_Get_Class_Name Lucy_IxManager_Get_Class_Name
  #define IxManager_Is_A Lucy_IxManager_Is_A
  #define IxManager_To_String Lucy_IxManager_To_String
  #define IxManager_To_I64 Lucy_IxManager_To_I64
  #define IxManager_To_F64 Lucy_IxManager_To_F64
  #define IxManager_To_Bool Lucy_IxManager_To_Bool
  #define IxManager_Serialize Lucy_IxManager_Serialize
  #define IxManager_Deserialize Lucy_IxManager_Deserialize
  #define IxManager_Dump Lucy_IxManager_Dump
  #define IxManager_Load Lucy_IxManager_Load
  #define IxManager_Mimic Lucy_IxManager_Mimic
  #define IxManager_Set_Folder Lucy_IxManager_Set_Folder
  #define IxManager_Get_Folder Lucy_IxManager_Get_Folder
  #define IxManager_Get_Host Lucy_IxManager_Get_Host
  #define IxManager_Recycle Lucy_IxManager_Recycle
  #define IxManager_Choose_Sparse Lucy_IxManager_Choose_Sparse
  #define IxManager_Make_Write_Lock Lucy_IxManager_Make_Write_Lock
  #define IxManager_Make_Deletion_Lock Lucy_IxManager_Make_Deletion_Lock
  #define IxManager_Make_Merge_Lock Lucy_IxManager_Make_Merge_Lock
  #define IxManager_Write_Merge_Data Lucy_IxManager_Write_Merge_Data
  #define IxManager_Read_Merge_Data Lucy_IxManager_Read_Merge_Data
  #define IxManager_Remove_Merge_Data Lucy_IxManager_Remove_Merge_Data
  #define IxManager_Make_Snapshot_Read_Lock Lucy_IxManager_Make_Snapshot_Read_Lock
  #define IxManager_Highest_Seg_Num Lucy_IxManager_Highest_Seg_Num
  #define IxManager_Make_Snapshot_Filename Lucy_IxManager_Make_Snapshot_Filename
  #define IxManager_Set_Write_Lock_Timeout Lucy_IxManager_Set_Write_Lock_Timeout
  #define IxManager_Get_Write_Lock_Timeout Lucy_IxManager_Get_Write_Lock_Timeout
  #define IxManager_Set_Write_Lock_Interval Lucy_IxManager_Set_Write_Lock_Interval
  #define IxManager_Get_Write_Lock_Interval Lucy_IxManager_Get_Write_Lock_Interval
  #define IxManager_Set_Merge_Lock_Timeout Lucy_IxManager_Set_Merge_Lock_Timeout
  #define IxManager_Get_Merge_Lock_Timeout Lucy_IxManager_Get_Merge_Lock_Timeout
  #define IxManager_Set_Merge_Lock_Interval Lucy_IxManager_Set_Merge_Lock_Interval
  #define IxManager_Get_Merge_Lock_Interval Lucy_IxManager_Get_Merge_Lock_Interval
  #define IxManager_Set_Deletion_Lock_Timeout Lucy_IxManager_Set_Deletion_Lock_Timeout
  #define IxManager_Get_Deletion_Lock_Timeout Lucy_IxManager_Get_Deletion_Lock_Timeout
  #define IxManager_Set_Deletion_Lock_Interval Lucy_IxManager_Set_Deletion_Lock_Interval
  #define IxManager_Get_Deletion_Lock_Interval Lucy_IxManager_Get_Deletion_Lock_Interval
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_INDEXMANAGER */




