/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_INDEXREADER
#define H_LUCY_INDEX_INDEXREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INDEXREADER
struct lucy_IndexReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_Hash* components;
    lucy_IndexManager* manager;
    lucy_Lock* read_lock;
    lucy_Lock* deletion_lock;
};

#endif /* C_LUCY_INDEXREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_IndexReader*
lucy_IxReader_init(lucy_IndexReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick, lucy_IndexManager* manager);

lucy_IndexReader*
lucy_IxReader_open(lucy_Obj* index, lucy_Snapshot* snapshot, lucy_IndexManager* manager);

lucy_IndexReader*
lucy_IxReader_do_open(lucy_IndexReader* self, lucy_Obj* index, lucy_Snapshot* snapshot, lucy_IndexManager* manager);

void
lucy_IxReader_destroy(lucy_IndexReader* self);

void
lucy_IxReader_close(lucy_IndexReader* self);

int32_t
lucy_IxReader_doc_max(lucy_IndexReader* self);

int32_t
lucy_IxReader_doc_count(lucy_IndexReader* self);

int32_t
lucy_IxReader_del_count(lucy_IndexReader* self);

lucy_I32Array*
lucy_IxReader_offsets(lucy_IndexReader* self);

lucy_VArray*
lucy_IxReader_seg_readers(lucy_IndexReader* self);

lucy_DataReader*
lucy_IxReader_obtain(lucy_IndexReader* self, const lucy_CharBuf* api);

lucy_DataReader*
lucy_IxReader_fetch(lucy_IndexReader* self, const lucy_CharBuf* api);

lucy_Hash*
lucy_IxReader_get_components(lucy_IndexReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_IxReader_destroy_CALLBACK;
extern cfish_Callback lucy_IxReader_close_CALLBACK;
extern cfish_Callback lucy_IxReader_doc_max_CALLBACK;
extern cfish_Callback lucy_IxReader_doc_count_CALLBACK;
extern cfish_Callback lucy_IxReader_del_count_CALLBACK;
extern cfish_Callback lucy_IxReader_offsets_CALLBACK;
extern cfish_Callback lucy_IxReader_seg_readers_CALLBACK;
extern cfish_Callback lucy_IxReader_obtain_CALLBACK;
extern cfish_Callback lucy_IxReader_fetch_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_IxReader_destroy_t)(lucy_IndexReader* self);

typedef void
(*lucy_IxReader_close_t)(lucy_IndexReader* self);

typedef int32_t
(*lucy_IxReader_doc_max_t)(lucy_IndexReader* self);

typedef int32_t
(*lucy_IxReader_doc_count_t)(lucy_IndexReader* self);

typedef int32_t
(*lucy_IxReader_del_count_t)(lucy_IndexReader* self);

typedef lucy_I32Array*
(*lucy_IxReader_offsets_t)(lucy_IndexReader* self);

typedef lucy_VArray*
(*lucy_IxReader_seg_readers_t)(lucy_IndexReader* self);

typedef lucy_DataReader*
(*lucy_IxReader_obtain_t)(lucy_IndexReader* self, const lucy_CharBuf* api);

typedef lucy_DataReader*
(*lucy_IxReader_fetch_t)(lucy_IndexReader* self, const lucy_CharBuf* api);

typedef lucy_Hash*
(*lucy_IxReader_get_components_t)(lucy_IndexReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_IxReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxReader_Make(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxReader_Get_RefCount(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxReader_Inc_RefCount(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxReader_Dec_RefCount(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_IxReader_To_Host(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxReader_Clone(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_IxReader_Destroy(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Destroy_OFFSET;
    const lucy_IxReader_destroy_t method = *((lucy_IxReader_destroy_t*)method_address);
    method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxReader_Equals(const lucy_IndexReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_IxReader_Compare_To(const lucy_IndexReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_IxReader_Hash_Sum(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_IxReader_Get_VTable(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxReader_Get_Class_Name(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxReader_Is_A(const lucy_IndexReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_IxReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_IxReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxReader_To_String(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_IxReader_To_I64(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_IxReader_To_F64(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxReader_To_Bool(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_IxReader_Serialize(const lucy_IndexReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_IxReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_IxReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxReader_Deserialize(const lucy_IndexReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_IxReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_IxReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxReader_Dump(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxReader_Load(const lucy_IndexReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_IxReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_IxReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_IxReader_Mimic(const lucy_IndexReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_IxReader_Aggregator(const lucy_IndexReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_IxReader_Aggregator_OFFSET;
    const lucy_DataReader_aggregator_t method = *((lucy_DataReader_aggregator_t*)method_address);
    return method((lucy_DataReader*)self, readers, offsets);
}

extern size_t Lucy_IxReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_IxReader_Get_Schema(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_IxReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_IxReader_Get_Folder(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_IxReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_IxReader_Get_Snapshot(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_IxReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_IxReader_Get_Segments(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_IxReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_IxReader_Get_Segment(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_IxReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_IxReader_Get_Seg_Tick(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_IxReader_Close_OFFSET;
static CHY_INLINE void
Lucy_IxReader_Close(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Close_OFFSET;
    const lucy_IxReader_close_t method = *((lucy_IxReader_close_t*)method_address);
    method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Doc_Max_OFFSET;
static CHY_INLINE int32_t
Lucy_IxReader_Doc_Max(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Doc_Max_OFFSET;
    const lucy_IxReader_doc_max_t method = *((lucy_IxReader_doc_max_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Doc_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_IxReader_Doc_Count(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Doc_Count_OFFSET;
    const lucy_IxReader_doc_count_t method = *((lucy_IxReader_doc_count_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_IxReader_Del_Count(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Del_Count_OFFSET;
    const lucy_IxReader_del_count_t method = *((lucy_IxReader_del_count_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Offsets_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_IxReader_Offsets(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Offsets_OFFSET;
    const lucy_IxReader_offsets_t method = *((lucy_IxReader_offsets_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Seg_Readers_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_IxReader_Seg_Readers(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Seg_Readers_OFFSET;
    const lucy_IxReader_seg_readers_t method = *((lucy_IxReader_seg_readers_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_IxReader_Obtain_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_IxReader_Obtain(const lucy_IndexReader *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_IxReader_Obtain_OFFSET;
    const lucy_IxReader_obtain_t method = *((lucy_IxReader_obtain_t*)method_address);
    return method((lucy_IndexReader*)self, api);
}

extern size_t Lucy_IxReader_Fetch_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_IxReader_Fetch(const lucy_IndexReader *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_IxReader_Fetch_OFFSET;
    const lucy_IxReader_fetch_t method = *((lucy_IxReader_fetch_t*)method_address);
    return method((lucy_IndexReader*)self, api);
}

extern size_t Lucy_IxReader_Get_Components_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_IxReader_Get_Components(const lucy_IndexReader *self) {
    char *const method_address = *(char**)self + Lucy_IxReader_Get_Components_OFFSET;
    const lucy_IxReader_get_components_t method = *((lucy_IxReader_get_components_t*)method_address);
    return method((lucy_IndexReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INDEXREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[38];
} LUCY_INDEXREADER_VT;
extern struct LUCY_INDEXREADER_VT LUCY_INDEXREADER_vt;
#define LUCY_INDEXREADER ((cfish_VTable*)&LUCY_INDEXREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define IndexReader lucy_IndexReader
  #define INDEXREADER LUCY_INDEXREADER
  #define IxReader_init lucy_IxReader_init
  #define IxReader_open lucy_IxReader_open
  #define IxReader_do_open lucy_IxReader_do_open
  #define IxReader_destroy_t lucy_IxReader_destroy_t
  #define IxReader_destroy lucy_IxReader_destroy
  #define IxReader_close_t lucy_IxReader_close_t
  #define IxReader_close lucy_IxReader_close
  #define IxReader_doc_max_t lucy_IxReader_doc_max_t
  #define IxReader_doc_max lucy_IxReader_doc_max
  #define IxReader_doc_count_t lucy_IxReader_doc_count_t
  #define IxReader_doc_count lucy_IxReader_doc_count
  #define IxReader_del_count_t lucy_IxReader_del_count_t
  #define IxReader_del_count lucy_IxReader_del_count
  #define IxReader_offsets_t lucy_IxReader_offsets_t
  #define IxReader_offsets lucy_IxReader_offsets
  #define IxReader_seg_readers_t lucy_IxReader_seg_readers_t
  #define IxReader_seg_readers lucy_IxReader_seg_readers
  #define IxReader_obtain_t lucy_IxReader_obtain_t
  #define IxReader_obtain lucy_IxReader_obtain
  #define IxReader_fetch_t lucy_IxReader_fetch_t
  #define IxReader_fetch lucy_IxReader_fetch
  #define IxReader_get_components_t lucy_IxReader_get_components_t
  #define IxReader_get_components lucy_IxReader_get_components
  #define IxReader_Make Lucy_IxReader_Make
  #define IxReader_Get_RefCount Lucy_IxReader_Get_RefCount
  #define IxReader_Inc_RefCount Lucy_IxReader_Inc_RefCount
  #define IxReader_Dec_RefCount Lucy_IxReader_Dec_RefCount
  #define IxReader_To_Host Lucy_IxReader_To_Host
  #define IxReader_Clone Lucy_IxReader_Clone
  #define IxReader_Destroy Lucy_IxReader_Destroy
  #define IxReader_Equals Lucy_IxReader_Equals
  #define IxReader_Compare_To Lucy_IxReader_Compare_To
  #define IxReader_Hash_Sum Lucy_IxReader_Hash_Sum
  #define IxReader_Get_VTable Lucy_IxReader_Get_VTable
  #define IxReader_Get_Class_Name Lucy_IxReader_Get_Class_Name
  #define IxReader_Is_A Lucy_IxReader_Is_A
  #define IxReader_To_String Lucy_IxReader_To_String
  #define IxReader_To_I64 Lucy_IxReader_To_I64
  #define IxReader_To_F64 Lucy_IxReader_To_F64
  #define IxReader_To_Bool Lucy_IxReader_To_Bool
  #define IxReader_Serialize Lucy_IxReader_Serialize
  #define IxReader_Deserialize Lucy_IxReader_Deserialize
  #define IxReader_Dump Lucy_IxReader_Dump
  #define IxReader_Load Lucy_IxReader_Load
  #define IxReader_Mimic Lucy_IxReader_Mimic
  #define IxReader_Aggregator Lucy_IxReader_Aggregator
  #define IxReader_Get_Schema Lucy_IxReader_Get_Schema
  #define IxReader_Get_Folder Lucy_IxReader_Get_Folder
  #define IxReader_Get_Snapshot Lucy_IxReader_Get_Snapshot
  #define IxReader_Get_Segments Lucy_IxReader_Get_Segments
  #define IxReader_Get_Segment Lucy_IxReader_Get_Segment
  #define IxReader_Get_Seg_Tick Lucy_IxReader_Get_Seg_Tick
  #define IxReader_Close Lucy_IxReader_Close
  #define IxReader_Doc_Max Lucy_IxReader_Doc_Max
  #define IxReader_Doc_Count Lucy_IxReader_Doc_Count
  #define IxReader_Del_Count Lucy_IxReader_Del_Count
  #define IxReader_Offsets Lucy_IxReader_Offsets
  #define IxReader_Seg_Readers Lucy_IxReader_Seg_Readers
  #define IxReader_Obtain Lucy_IxReader_Obtain
  #define IxReader_Fetch Lucy_IxReader_Fetch
  #define IxReader_Get_Components Lucy_IxReader_Get_Components
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_INDEXREADER */




