/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_INDEXER
#define H_LUCY_INDEX_INDEXER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INDEXER
struct lucy_Indexer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Segment* segment;
    lucy_IndexManager* manager;
    lucy_PolyReader* polyreader;
    lucy_Snapshot* snapshot;
    lucy_SegWriter* seg_writer;
    lucy_DeletionsWriter* del_writer;
    lucy_FilePurger* file_purger;
    lucy_Lock* write_lock;
    lucy_Lock* merge_lock;
    lucy_Doc* stock_doc;
    lucy_CharBuf* snapfile;
    chy_bool_t truncate;
    chy_bool_t optimize;
    chy_bool_t needs_commit;
    chy_bool_t prepared;
};

#endif /* C_LUCY_INDEXER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_Indexer_TRUNCATE;
extern int32_t lucy_Indexer_CREATE;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Indexer*
lucy_Indexer_new(lucy_Schema* schema, lucy_Obj* index, lucy_IndexManager* manager, int32_t flags);

lucy_Indexer*
lucy_Indexer_init(lucy_Indexer* self, lucy_Schema* schema, lucy_Obj* index, lucy_IndexManager* manager, int32_t flags);

void
lucy_Indexer_destroy(lucy_Indexer* self);

void
lucy_Indexer_add_doc(lucy_Indexer* self, lucy_Doc* doc, float boost);

void
lucy_Indexer_add_index(lucy_Indexer* self, lucy_Obj* index);

void
lucy_Indexer_delete_by_term(lucy_Indexer* self, lucy_CharBuf* field, lucy_Obj* term);

void
lucy_Indexer_delete_by_query(lucy_Indexer* self, lucy_Query* query);

void
lucy_Indexer_optimize(lucy_Indexer* self);

void
lucy_Indexer_commit(lucy_Indexer* self);

void
lucy_Indexer_prepare_commit(lucy_Indexer* self);

lucy_SegWriter*
lucy_Indexer_get_seg_writer(lucy_Indexer* self);

lucy_Doc*
lucy_Indexer_get_stock_doc(lucy_Indexer* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Indexer_destroy_CALLBACK;
extern cfish_Callback lucy_Indexer_add_doc_CALLBACK;
extern cfish_Callback lucy_Indexer_add_index_CALLBACK;
extern cfish_Callback lucy_Indexer_delete_by_term_CALLBACK;
extern cfish_Callback lucy_Indexer_delete_by_query_CALLBACK;
extern cfish_Callback lucy_Indexer_optimize_CALLBACK;
extern cfish_Callback lucy_Indexer_commit_CALLBACK;
extern cfish_Callback lucy_Indexer_prepare_commit_CALLBACK;
extern cfish_Callback lucy_Indexer_get_seg_writer_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Indexer_destroy_t)(lucy_Indexer* self);

typedef void
(*lucy_Indexer_add_doc_t)(lucy_Indexer* self, lucy_Doc* doc, float boost);

typedef void
(*lucy_Indexer_add_index_t)(lucy_Indexer* self, lucy_Obj* index);

typedef void
(*lucy_Indexer_delete_by_term_t)(lucy_Indexer* self, lucy_CharBuf* field, lucy_Obj* term);

typedef void
(*lucy_Indexer_delete_by_query_t)(lucy_Indexer* self, lucy_Query* query);

typedef void
(*lucy_Indexer_optimize_t)(lucy_Indexer* self);

typedef void
(*lucy_Indexer_commit_t)(lucy_Indexer* self);

typedef void
(*lucy_Indexer_prepare_commit_t)(lucy_Indexer* self);

typedef lucy_SegWriter*
(*lucy_Indexer_get_seg_writer_t)(lucy_Indexer* self);

typedef lucy_Doc*
(*lucy_Indexer_get_stock_doc_t)(lucy_Indexer* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Indexer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Indexer_Make(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Indexer_Get_RefCount(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Indexer_Inc_RefCount(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Indexer_Dec_RefCount(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Indexer_To_Host(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Indexer_Clone(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Destroy(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Destroy_OFFSET;
    const lucy_Indexer_destroy_t method = *((lucy_Indexer_destroy_t*)method_address);
    method((lucy_Indexer*)self);
}

extern size_t Lucy_Indexer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Indexer_Equals(const lucy_Indexer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Indexer_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Indexer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Indexer_Compare_To(const lucy_Indexer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Indexer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Indexer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Indexer_Hash_Sum(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Indexer_Get_VTable(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Indexer_Get_Class_Name(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Indexer_Is_A(const lucy_Indexer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Indexer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Indexer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Indexer_To_String(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Indexer_To_I64(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Indexer_To_F64(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Indexer_To_Bool(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Serialize(const lucy_Indexer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Indexer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Indexer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Indexer_Deserialize(const lucy_Indexer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Indexer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Indexer_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Indexer_Dump(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Indexer_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Indexer_Load(const lucy_Indexer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Indexer_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Indexer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Mimic(const lucy_Indexer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Indexer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Indexer_Add_Doc_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Add_Doc(const lucy_Indexer *self, lucy_Doc* doc, float boost) {
    char *const method_address = *(char**)self + Lucy_Indexer_Add_Doc_OFFSET;
    const lucy_Indexer_add_doc_t method = *((lucy_Indexer_add_doc_t*)method_address);
    method((lucy_Indexer*)self, doc, boost);
}

extern size_t Lucy_Indexer_Add_Index_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Add_Index(const lucy_Indexer *self, lucy_Obj* index) {
    char *const method_address = *(char**)self + Lucy_Indexer_Add_Index_OFFSET;
    const lucy_Indexer_add_index_t method = *((lucy_Indexer_add_index_t*)method_address);
    method((lucy_Indexer*)self, index);
}

extern size_t Lucy_Indexer_Delete_By_Term_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Delete_By_Term(const lucy_Indexer *self, lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_Indexer_Delete_By_Term_OFFSET;
    const lucy_Indexer_delete_by_term_t method = *((lucy_Indexer_delete_by_term_t*)method_address);
    method((lucy_Indexer*)self, field, term);
}

extern size_t Lucy_Indexer_Delete_By_Query_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Delete_By_Query(const lucy_Indexer *self, lucy_Query* query) {
    char *const method_address = *(char**)self + Lucy_Indexer_Delete_By_Query_OFFSET;
    const lucy_Indexer_delete_by_query_t method = *((lucy_Indexer_delete_by_query_t*)method_address);
    method((lucy_Indexer*)self, query);
}

extern size_t Lucy_Indexer_Optimize_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Optimize(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Optimize_OFFSET;
    const lucy_Indexer_optimize_t method = *((lucy_Indexer_optimize_t*)method_address);
    method((lucy_Indexer*)self);
}

extern size_t Lucy_Indexer_Commit_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Commit(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Commit_OFFSET;
    const lucy_Indexer_commit_t method = *((lucy_Indexer_commit_t*)method_address);
    method((lucy_Indexer*)self);
}

extern size_t Lucy_Indexer_Prepare_Commit_OFFSET;
static CHY_INLINE void
Lucy_Indexer_Prepare_Commit(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Prepare_Commit_OFFSET;
    const lucy_Indexer_prepare_commit_t method = *((lucy_Indexer_prepare_commit_t*)method_address);
    method((lucy_Indexer*)self);
}

extern size_t Lucy_Indexer_Get_Seg_Writer_OFFSET;
static CHY_INLINE lucy_SegWriter*
Lucy_Indexer_Get_Seg_Writer(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Get_Seg_Writer_OFFSET;
    const lucy_Indexer_get_seg_writer_t method = *((lucy_Indexer_get_seg_writer_t*)method_address);
    return method((lucy_Indexer*)self);
}

extern size_t Lucy_Indexer_Get_Stock_Doc_OFFSET;
static CHY_INLINE lucy_Doc*
Lucy_Indexer_Get_Stock_Doc(const lucy_Indexer *self) {
    char *const method_address = *(char**)self + Lucy_Indexer_Get_Stock_Doc_OFFSET;
    const lucy_Indexer_get_stock_doc_t method = *((lucy_Indexer_get_stock_doc_t*)method_address);
    return method((lucy_Indexer*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INDEXER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_INDEXER_VT;
extern struct LUCY_INDEXER_VT LUCY_INDEXER_vt;
#define LUCY_INDEXER ((cfish_VTable*)&LUCY_INDEXER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Indexer lucy_Indexer
  #define INDEXER LUCY_INDEXER
  #define Indexer_new lucy_Indexer_new
  #define Indexer_init lucy_Indexer_init
  #define Indexer_TRUNCATE lucy_Indexer_TRUNCATE
  #define Indexer_CREATE lucy_Indexer_CREATE
  #define Indexer_destroy_t lucy_Indexer_destroy_t
  #define Indexer_destroy lucy_Indexer_destroy
  #define Indexer_add_doc_t lucy_Indexer_add_doc_t
  #define Indexer_add_doc lucy_Indexer_add_doc
  #define Indexer_add_index_t lucy_Indexer_add_index_t
  #define Indexer_add_index lucy_Indexer_add_index
  #define Indexer_delete_by_term_t lucy_Indexer_delete_by_term_t
  #define Indexer_delete_by_term lucy_Indexer_delete_by_term
  #define Indexer_delete_by_query_t lucy_Indexer_delete_by_query_t
  #define Indexer_delete_by_query lucy_Indexer_delete_by_query
  #define Indexer_optimize_t lucy_Indexer_optimize_t
  #define Indexer_optimize lucy_Indexer_optimize
  #define Indexer_commit_t lucy_Indexer_commit_t
  #define Indexer_commit lucy_Indexer_commit
  #define Indexer_prepare_commit_t lucy_Indexer_prepare_commit_t
  #define Indexer_prepare_commit lucy_Indexer_prepare_commit
  #define Indexer_get_seg_writer_t lucy_Indexer_get_seg_writer_t
  #define Indexer_get_seg_writer lucy_Indexer_get_seg_writer
  #define Indexer_get_stock_doc_t lucy_Indexer_get_stock_doc_t
  #define Indexer_get_stock_doc lucy_Indexer_get_stock_doc
  #define Indexer_Make Lucy_Indexer_Make
  #define Indexer_Get_RefCount Lucy_Indexer_Get_RefCount
  #define Indexer_Inc_RefCount Lucy_Indexer_Inc_RefCount
  #define Indexer_Dec_RefCount Lucy_Indexer_Dec_RefCount
  #define Indexer_To_Host Lucy_Indexer_To_Host
  #define Indexer_Clone Lucy_Indexer_Clone
  #define Indexer_Destroy Lucy_Indexer_Destroy
  #define Indexer_Equals Lucy_Indexer_Equals
  #define Indexer_Compare_To Lucy_Indexer_Compare_To
  #define Indexer_Hash_Sum Lucy_Indexer_Hash_Sum
  #define Indexer_Get_VTable Lucy_Indexer_Get_VTable
  #define Indexer_Get_Class_Name Lucy_Indexer_Get_Class_Name
  #define Indexer_Is_A Lucy_Indexer_Is_A
  #define Indexer_To_String Lucy_Indexer_To_String
  #define Indexer_To_I64 Lucy_Indexer_To_I64
  #define Indexer_To_F64 Lucy_Indexer_To_F64
  #define Indexer_To_Bool Lucy_Indexer_To_Bool
  #define Indexer_Serialize Lucy_Indexer_Serialize
  #define Indexer_Deserialize Lucy_Indexer_Deserialize
  #define Indexer_Dump Lucy_Indexer_Dump
  #define Indexer_Load Lucy_Indexer_Load
  #define Indexer_Mimic Lucy_Indexer_Mimic
  #define Indexer_Add_Doc Lucy_Indexer_Add_Doc
  #define Indexer_Add_Index Lucy_Indexer_Add_Index
  #define Indexer_Delete_By_Term Lucy_Indexer_Delete_By_Term
  #define Indexer_Delete_By_Query Lucy_Indexer_Delete_By_Query
  #define Indexer_Optimize Lucy_Indexer_Optimize
  #define Indexer_Commit Lucy_Indexer_Commit
  #define Indexer_Prepare_Commit Lucy_Indexer_Prepare_Commit
  #define Indexer_Get_Seg_Writer Lucy_Indexer_Get_Seg_Writer
  #define Indexer_Get_Stock_Doc Lucy_Indexer_Get_Stock_Doc
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_INDEXER */




