/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_INVERTER
#define H_LUCY_INDEX_INVERTER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INVERTER
struct lucy_Inverter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Segment* segment;
    lucy_Doc* doc;
    lucy_VArray* entries;
    lucy_VArray* entry_pool;
    lucy_InverterEntry* current;
    lucy_InverterEntry* blank;
    float boost;
    int32_t tick;
    chy_bool_t sorted;
};

#endif /* C_LUCY_INVERTER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Inverter*
lucy_Inverter_new(lucy_Schema* schema, lucy_Segment* segment);

lucy_Inverter*
lucy_Inverter_init(lucy_Inverter* self, lucy_Schema* schema, lucy_Segment* segment);

void
lucy_Inverter_destroy(lucy_Inverter* self);

void
lucy_Inverter_invert_doc(lucy_Inverter* self, lucy_Doc* doc);

void
lucy_Inverter_set_doc(lucy_Inverter* self, lucy_Doc* doc);

void
lucy_Inverter_set_boost(lucy_Inverter* self, float boost);

void
lucy_Inverter_add_field(lucy_Inverter* self, lucy_InverterEntry* entry);

void
lucy_Inverter_clear(lucy_Inverter* self);

uint32_t
lucy_Inverter_iterate(lucy_Inverter* self);

int32_t
lucy_Inverter_next(lucy_Inverter* self);

lucy_Doc*
lucy_Inverter_get_doc(lucy_Inverter* self);

float
lucy_Inverter_get_boost(lucy_Inverter* self);

lucy_CharBuf*
lucy_Inverter_get_field_name(lucy_Inverter* self);

lucy_Obj*
lucy_Inverter_get_value(lucy_Inverter* self);

lucy_FieldType*
lucy_Inverter_get_type(lucy_Inverter* self);

lucy_Analyzer*
lucy_Inverter_get_analyzer(lucy_Inverter* self);

lucy_Similarity*
lucy_Inverter_get_similarity(lucy_Inverter* self);

lucy_Inversion*
lucy_Inverter_get_inversion(lucy_Inverter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Inverter_destroy_CALLBACK;
extern cfish_Callback lucy_Inverter_invert_doc_CALLBACK;
extern cfish_Callback lucy_Inverter_set_doc_CALLBACK;
extern cfish_Callback lucy_Inverter_set_boost_CALLBACK;
extern cfish_Callback lucy_Inverter_clear_CALLBACK;
extern cfish_Callback lucy_Inverter_iterate_CALLBACK;
extern cfish_Callback lucy_Inverter_next_CALLBACK;
extern cfish_Callback lucy_Inverter_get_doc_CALLBACK;
extern cfish_Callback lucy_Inverter_get_boost_CALLBACK;
extern cfish_Callback lucy_Inverter_get_field_name_CALLBACK;
extern cfish_Callback lucy_Inverter_get_value_CALLBACK;
extern cfish_Callback lucy_Inverter_get_type_CALLBACK;
extern cfish_Callback lucy_Inverter_get_analyzer_CALLBACK;
extern cfish_Callback lucy_Inverter_get_similarity_CALLBACK;
extern cfish_Callback lucy_Inverter_get_inversion_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Inverter_destroy_t)(lucy_Inverter* self);

typedef void
(*lucy_Inverter_invert_doc_t)(lucy_Inverter* self, lucy_Doc* doc);

typedef void
(*lucy_Inverter_set_doc_t)(lucy_Inverter* self, lucy_Doc* doc);

typedef void
(*lucy_Inverter_set_boost_t)(lucy_Inverter* self, float boost);

typedef void
(*lucy_Inverter_add_field_t)(lucy_Inverter* self, lucy_InverterEntry* entry);

typedef void
(*lucy_Inverter_clear_t)(lucy_Inverter* self);

typedef uint32_t
(*lucy_Inverter_iterate_t)(lucy_Inverter* self);

typedef int32_t
(*lucy_Inverter_next_t)(lucy_Inverter* self);

typedef lucy_Doc*
(*lucy_Inverter_get_doc_t)(lucy_Inverter* self);

typedef float
(*lucy_Inverter_get_boost_t)(lucy_Inverter* self);

typedef lucy_CharBuf*
(*lucy_Inverter_get_field_name_t)(lucy_Inverter* self);

typedef lucy_Obj*
(*lucy_Inverter_get_value_t)(lucy_Inverter* self);

typedef lucy_FieldType*
(*lucy_Inverter_get_type_t)(lucy_Inverter* self);

typedef lucy_Analyzer*
(*lucy_Inverter_get_analyzer_t)(lucy_Inverter* self);

typedef lucy_Similarity*
(*lucy_Inverter_get_similarity_t)(lucy_Inverter* self);

typedef lucy_Inversion*
(*lucy_Inverter_get_inversion_t)(lucy_Inverter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Inverter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Make(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Inverter_Get_RefCount(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Inc_RefCount(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Inverter_Dec_RefCount(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Inverter_To_Host(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Clone(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Destroy(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Destroy_OFFSET;
    const lucy_Inverter_destroy_t method = *((lucy_Inverter_destroy_t*)method_address);
    method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Inverter_Equals(const lucy_Inverter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Inverter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Inverter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Inverter_Compare_To(const lucy_Inverter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Inverter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Inverter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Inverter_Hash_Sum(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Inverter_Get_VTable(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Inverter_Get_Class_Name(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Inverter_Is_A(const lucy_Inverter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Inverter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Inverter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Inverter_To_String(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Inverter_To_I64(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Inverter_To_F64(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Inverter_To_Bool(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Serialize(const lucy_Inverter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Inverter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Inverter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Deserialize(const lucy_Inverter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Inverter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Inverter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Dump(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Inverter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Load(const lucy_Inverter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Inverter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Inverter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Mimic(const lucy_Inverter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Inverter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Inverter_Invert_Doc_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Invert_Doc(const lucy_Inverter *self, lucy_Doc* doc) {
    char *const method_address = *(char**)self + Lucy_Inverter_Invert_Doc_OFFSET;
    const lucy_Inverter_invert_doc_t method = *((lucy_Inverter_invert_doc_t*)method_address);
    method((lucy_Inverter*)self, doc);
}

extern size_t Lucy_Inverter_Set_Doc_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Set_Doc(const lucy_Inverter *self, lucy_Doc* doc) {
    char *const method_address = *(char**)self + Lucy_Inverter_Set_Doc_OFFSET;
    const lucy_Inverter_set_doc_t method = *((lucy_Inverter_set_doc_t*)method_address);
    method((lucy_Inverter*)self, doc);
}

extern size_t Lucy_Inverter_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Set_Boost(const lucy_Inverter *self, float boost) {
    char *const method_address = *(char**)self + Lucy_Inverter_Set_Boost_OFFSET;
    const lucy_Inverter_set_boost_t method = *((lucy_Inverter_set_boost_t*)method_address);
    method((lucy_Inverter*)self, boost);
}

extern size_t Lucy_Inverter_Add_Field_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Add_Field(const lucy_Inverter *self, lucy_InverterEntry* entry) {
    char *const method_address = *(char**)self + Lucy_Inverter_Add_Field_OFFSET;
    const lucy_Inverter_add_field_t method = *((lucy_Inverter_add_field_t*)method_address);
    method((lucy_Inverter*)self, entry);
}

extern size_t Lucy_Inverter_Clear_OFFSET;
static CHY_INLINE void
Lucy_Inverter_Clear(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Clear_OFFSET;
    const lucy_Inverter_clear_t method = *((lucy_Inverter_clear_t*)method_address);
    method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Iterate_OFFSET;
static CHY_INLINE uint32_t
Lucy_Inverter_Iterate(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Iterate_OFFSET;
    const lucy_Inverter_iterate_t method = *((lucy_Inverter_iterate_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_Inverter_Next(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Next_OFFSET;
    const lucy_Inverter_next_t method = *((lucy_Inverter_next_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Doc_OFFSET;
static CHY_INLINE lucy_Doc*
Lucy_Inverter_Get_Doc(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Doc_OFFSET;
    const lucy_Inverter_get_doc_t method = *((lucy_Inverter_get_doc_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_Inverter_Get_Boost(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Boost_OFFSET;
    const lucy_Inverter_get_boost_t method = *((lucy_Inverter_get_boost_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Field_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Inverter_Get_Field_Name(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Field_Name_OFFSET;
    const lucy_Inverter_get_field_name_t method = *((lucy_Inverter_get_field_name_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Inverter_Get_Value(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Value_OFFSET;
    const lucy_Inverter_get_value_t method = *((lucy_Inverter_get_value_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Type_OFFSET;
static CHY_INLINE lucy_FieldType*
Lucy_Inverter_Get_Type(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Type_OFFSET;
    const lucy_Inverter_get_type_t method = *((lucy_Inverter_get_type_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Analyzer_OFFSET;
static CHY_INLINE lucy_Analyzer*
Lucy_Inverter_Get_Analyzer(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Analyzer_OFFSET;
    const lucy_Inverter_get_analyzer_t method = *((lucy_Inverter_get_analyzer_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_Inverter_Get_Similarity(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Similarity_OFFSET;
    const lucy_Inverter_get_similarity_t method = *((lucy_Inverter_get_similarity_t*)method_address);
    return method((lucy_Inverter*)self);
}

extern size_t Lucy_Inverter_Get_Inversion_OFFSET;
static CHY_INLINE lucy_Inversion*
Lucy_Inverter_Get_Inversion(const lucy_Inverter *self) {
    char *const method_address = *(char**)self + Lucy_Inverter_Get_Inversion_OFFSET;
    const lucy_Inverter_get_inversion_t method = *((lucy_Inverter_get_inversion_t*)method_address);
    return method((lucy_Inverter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INVERTER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_INVERTER_VT;
extern struct LUCY_INVERTER_VT LUCY_INVERTER_vt;
#define LUCY_INVERTER ((cfish_VTable*)&LUCY_INVERTER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Inverter lucy_Inverter
  #define INVERTER LUCY_INVERTER
  #define Inverter_new lucy_Inverter_new
  #define Inverter_init lucy_Inverter_init
  #define Inverter_destroy_t lucy_Inverter_destroy_t
  #define Inverter_destroy lucy_Inverter_destroy
  #define Inverter_invert_doc_t lucy_Inverter_invert_doc_t
  #define Inverter_invert_doc lucy_Inverter_invert_doc
  #define Inverter_set_doc_t lucy_Inverter_set_doc_t
  #define Inverter_set_doc lucy_Inverter_set_doc
  #define Inverter_set_boost_t lucy_Inverter_set_boost_t
  #define Inverter_set_boost lucy_Inverter_set_boost
  #define Inverter_add_field_t lucy_Inverter_add_field_t
  #define Inverter_add_field lucy_Inverter_add_field
  #define Inverter_clear_t lucy_Inverter_clear_t
  #define Inverter_clear lucy_Inverter_clear
  #define Inverter_iterate_t lucy_Inverter_iterate_t
  #define Inverter_iterate lucy_Inverter_iterate
  #define Inverter_next_t lucy_Inverter_next_t
  #define Inverter_next lucy_Inverter_next
  #define Inverter_get_doc_t lucy_Inverter_get_doc_t
  #define Inverter_get_doc lucy_Inverter_get_doc
  #define Inverter_get_boost_t lucy_Inverter_get_boost_t
  #define Inverter_get_boost lucy_Inverter_get_boost
  #define Inverter_get_field_name_t lucy_Inverter_get_field_name_t
  #define Inverter_get_field_name lucy_Inverter_get_field_name
  #define Inverter_get_value_t lucy_Inverter_get_value_t
  #define Inverter_get_value lucy_Inverter_get_value
  #define Inverter_get_type_t lucy_Inverter_get_type_t
  #define Inverter_get_type lucy_Inverter_get_type
  #define Inverter_get_analyzer_t lucy_Inverter_get_analyzer_t
  #define Inverter_get_analyzer lucy_Inverter_get_analyzer
  #define Inverter_get_similarity_t lucy_Inverter_get_similarity_t
  #define Inverter_get_similarity lucy_Inverter_get_similarity
  #define Inverter_get_inversion_t lucy_Inverter_get_inversion_t
  #define Inverter_get_inversion lucy_Inverter_get_inversion
  #define Inverter_Make Lucy_Inverter_Make
  #define Inverter_Get_RefCount Lucy_Inverter_Get_RefCount
  #define Inverter_Inc_RefCount Lucy_Inverter_Inc_RefCount
  #define Inverter_Dec_RefCount Lucy_Inverter_Dec_RefCount
  #define Inverter_To_Host Lucy_Inverter_To_Host
  #define Inverter_Clone Lucy_Inverter_Clone
  #define Inverter_Destroy Lucy_Inverter_Destroy
  #define Inverter_Equals Lucy_Inverter_Equals
  #define Inverter_Compare_To Lucy_Inverter_Compare_To
  #define Inverter_Hash_Sum Lucy_Inverter_Hash_Sum
  #define Inverter_Get_VTable Lucy_Inverter_Get_VTable
  #define Inverter_Get_Class_Name Lucy_Inverter_Get_Class_Name
  #define Inverter_Is_A Lucy_Inverter_Is_A
  #define Inverter_To_String Lucy_Inverter_To_String
  #define Inverter_To_I64 Lucy_Inverter_To_I64
  #define Inverter_To_F64 Lucy_Inverter_To_F64
  #define Inverter_To_Bool Lucy_Inverter_To_Bool
  #define Inverter_Serialize Lucy_Inverter_Serialize
  #define Inverter_Deserialize Lucy_Inverter_Deserialize
  #define Inverter_Dump Lucy_Inverter_Dump
  #define Inverter_Load Lucy_Inverter_Load
  #define Inverter_Mimic Lucy_Inverter_Mimic
  #define Inverter_Invert_Doc Lucy_Inverter_Invert_Doc
  #define Inverter_Set_Doc Lucy_Inverter_Set_Doc
  #define Inverter_Set_Boost Lucy_Inverter_Set_Boost
  #define Inverter_Add_Field Lucy_Inverter_Add_Field
  #define Inverter_Clear Lucy_Inverter_Clear
  #define Inverter_Iterate Lucy_Inverter_Iterate
  #define Inverter_Next Lucy_Inverter_Next
  #define Inverter_Get_Doc Lucy_Inverter_Get_Doc
  #define Inverter_Get_Boost Lucy_Inverter_Get_Boost
  #define Inverter_Get_Field_Name Lucy_Inverter_Get_Field_Name
  #define Inverter_Get_Value Lucy_Inverter_Get_Value
  #define Inverter_Get_Type Lucy_Inverter_Get_Type
  #define Inverter_Get_Analyzer Lucy_Inverter_Get_Analyzer
  #define Inverter_Get_Similarity Lucy_Inverter_Get_Similarity
  #define Inverter_Get_Inversion Lucy_Inverter_Get_Inversion
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INVERTERENTRY
struct lucy_InverterEntry {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t field_num;
    lucy_CharBuf* field;
    lucy_Obj* value;
    lucy_Inversion* inversion;
    lucy_FieldType* type;
    lucy_Analyzer* analyzer;
    lucy_Similarity* sim;
    chy_bool_t indexed;
    chy_bool_t highlightable;
};

#endif /* C_LUCY_INVERTERENTRY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_InverterEntry*
lucy_InvEntry_new(lucy_Schema* schema, const lucy_CharBuf* field_name, int32_t field_num);

lucy_InverterEntry*
lucy_InvEntry_init(lucy_InverterEntry* self, lucy_Schema* schema, const lucy_CharBuf* field_name, int32_t field_num);

void
lucy_InvEntry_destroy(lucy_InverterEntry* self);

int32_t
lucy_InvEntry_compare_to(lucy_InverterEntry* self, lucy_Obj* other);

void
lucy_InvEntry_clear(lucy_InverterEntry* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_InvEntry_destroy_CALLBACK;
extern cfish_Callback lucy_InvEntry_compare_to_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_InvEntry_destroy_t)(lucy_InverterEntry* self);

typedef int32_t
(*lucy_InvEntry_compare_to_t)(lucy_InverterEntry* self, lucy_Obj* other);

typedef void
(*lucy_InvEntry_clear_t)(lucy_InverterEntry* self);



/* Define the inline functions which implement this class's virtual methods.
 */

#define Lucy_InvEntry_Make(self) \
    lucy_Obj_make((lucy_Obj*)self)

#define Lucy_InvEntry_Get_RefCount(self) \
    lucy_Obj_get_refcount((lucy_Obj*)self)

#define Lucy_InvEntry_Inc_RefCount(self) \
    lucy_Obj_inc_refcount((lucy_Obj*)self)

#define Lucy_InvEntry_Dec_RefCount(self) \
    lucy_Obj_dec_refcount((lucy_Obj*)self)

#define Lucy_InvEntry_To_Host(self) \
    lucy_Obj_to_host((lucy_Obj*)self)

#define Lucy_InvEntry_Clone(self) \
    lucy_Obj_clone((lucy_Obj*)self)

#define Lucy_InvEntry_Destroy(self) \
    lucy_InvEntry_destroy((lucy_InverterEntry*)self)

#define Lucy_InvEntry_Equals(self, other) \
    lucy_Obj_equals((lucy_Obj*)self, other)

#define Lucy_InvEntry_Compare_To(self, other) \
    lucy_InvEntry_compare_to((lucy_InverterEntry*)self, other)

#define Lucy_InvEntry_Hash_Sum(self) \
    lucy_Obj_hash_sum((lucy_Obj*)self)

#define Lucy_InvEntry_Get_VTable(self) \
    lucy_Obj_get_vtable((lucy_Obj*)self)

#define Lucy_InvEntry_Get_Class_Name(self) \
    lucy_Obj_get_class_name((lucy_Obj*)self)

#define Lucy_InvEntry_Is_A(self, ancestor) \
    lucy_Obj_is_a((lucy_Obj*)self, ancestor)

#define Lucy_InvEntry_To_String(self) \
    lucy_Obj_to_string((lucy_Obj*)self)

#define Lucy_InvEntry_To_I64(self) \
    lucy_Obj_to_i64((lucy_Obj*)self)

#define Lucy_InvEntry_To_F64(self) \
    lucy_Obj_to_f64((lucy_Obj*)self)

#define Lucy_InvEntry_To_Bool(self) \
    lucy_Obj_to_bool((lucy_Obj*)self)

#define Lucy_InvEntry_Serialize(self, outstream) \
    lucy_Obj_serialize((lucy_Obj*)self, outstream)

#define Lucy_InvEntry_Deserialize(self, instream) \
    lucy_Obj_deserialize((lucy_Obj*)self, instream)

#define Lucy_InvEntry_Dump(self) \
    lucy_Obj_dump((lucy_Obj*)self)

#define Lucy_InvEntry_Load(self, dump) \
    lucy_Obj_load((lucy_Obj*)self, dump)

#define Lucy_InvEntry_Mimic(self, other) \
    lucy_Obj_mimic((lucy_Obj*)self, other)

#define Lucy_InvEntry_Clear(self) \
    lucy_InvEntry_clear((lucy_InverterEntry*)self)



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INVERTERENTRY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[23];
} LUCY_INVERTERENTRY_VT;
extern struct LUCY_INVERTERENTRY_VT LUCY_INVERTERENTRY_vt;
#define LUCY_INVERTERENTRY ((cfish_VTable*)&LUCY_INVERTERENTRY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define InverterEntry lucy_InverterEntry
  #define INVERTERENTRY LUCY_INVERTERENTRY
  #define InvEntry_new lucy_InvEntry_new
  #define InvEntry_init lucy_InvEntry_init
  #define InvEntry_destroy_t lucy_InvEntry_destroy_t
  #define InvEntry_destroy lucy_InvEntry_destroy
  #define InvEntry_compare_to_t lucy_InvEntry_compare_to_t
  #define InvEntry_compare_to lucy_InvEntry_compare_to
  #define InvEntry_clear_t lucy_InvEntry_clear_t
  #define InvEntry_clear lucy_InvEntry_clear
  #define InvEntry_Make Lucy_InvEntry_Make
  #define InvEntry_Get_RefCount Lucy_InvEntry_Get_RefCount
  #define InvEntry_Inc_RefCount Lucy_InvEntry_Inc_RefCount
  #define InvEntry_Dec_RefCount Lucy_InvEntry_Dec_RefCount
  #define InvEntry_To_Host Lucy_InvEntry_To_Host
  #define InvEntry_Clone Lucy_InvEntry_Clone
  #define InvEntry_Destroy Lucy_InvEntry_Destroy
  #define InvEntry_Equals Lucy_InvEntry_Equals
  #define InvEntry_Compare_To Lucy_InvEntry_Compare_To
  #define InvEntry_Hash_Sum Lucy_InvEntry_Hash_Sum
  #define InvEntry_Get_VTable Lucy_InvEntry_Get_VTable
  #define InvEntry_Get_Class_Name Lucy_InvEntry_Get_Class_Name
  #define InvEntry_Is_A Lucy_InvEntry_Is_A
  #define InvEntry_To_String Lucy_InvEntry_To_String
  #define InvEntry_To_I64 Lucy_InvEntry_To_I64
  #define InvEntry_To_F64 Lucy_InvEntry_To_F64
  #define InvEntry_To_Bool Lucy_InvEntry_To_Bool
  #define InvEntry_Serialize Lucy_InvEntry_Serialize
  #define InvEntry_Deserialize Lucy_InvEntry_Deserialize
  #define InvEntry_Dump Lucy_InvEntry_Dump
  #define InvEntry_Load Lucy_InvEntry_Load
  #define InvEntry_Mimic Lucy_InvEntry_Mimic
  #define InvEntry_Clear Lucy_InvEntry_Clear
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_INVERTER */




