/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_LEXINDEX
#define H_LUCY_INDEX_LEXINDEX 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Lexicon.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LEXINDEX
struct lucy_LexIndex {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* field_type;
    lucy_InStream* ixix_in;
    lucy_InStream* ix_in;
    int64_t* offsets;
    int32_t tick;
    int32_t size;
    int32_t index_interval;
    int32_t skip_interval;
    lucy_TermStepper* term_stepper;
    lucy_TermInfo* tinfo;
};

#endif /* C_LUCY_LEXINDEX */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LexIndex*
lucy_LexIndex_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Segment* segment, const lucy_CharBuf* field);

lucy_LexIndex*
lucy_LexIndex_init(lucy_LexIndex* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Segment* segment, const lucy_CharBuf* field);

void
lucy_LexIndex_destroy(lucy_LexIndex* self);

void
lucy_LexIndex_seek(lucy_LexIndex* self, lucy_Obj* target);

lucy_Obj*
lucy_LexIndex_get_term(lucy_LexIndex* self);

int32_t
lucy_LexIndex_get_term_num(lucy_LexIndex* self);

lucy_TermInfo*
lucy_LexIndex_get_term_info(lucy_LexIndex* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LexIndex_destroy_CALLBACK;
extern cfish_Callback lucy_LexIndex_seek_CALLBACK;
extern cfish_Callback lucy_LexIndex_get_term_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_LexIndex_destroy_t)(lucy_LexIndex* self);

typedef void
(*lucy_LexIndex_seek_t)(lucy_LexIndex* self, lucy_Obj* target);

typedef lucy_Obj*
(*lucy_LexIndex_get_term_t)(lucy_LexIndex* self);

typedef int32_t
(*lucy_LexIndex_get_term_num_t)(lucy_LexIndex* self);

typedef lucy_TermInfo*
(*lucy_LexIndex_get_term_info_t)(lucy_LexIndex* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LexIndex_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Make(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexIndex_Get_RefCount(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Inc_RefCount(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexIndex_Dec_RefCount(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LexIndex_To_Host(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Clone(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LexIndex_Destroy(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Destroy_OFFSET;
    const lucy_LexIndex_destroy_t method = *((lucy_LexIndex_destroy_t*)method_address);
    method((lucy_LexIndex*)self);
}

extern size_t Lucy_LexIndex_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexIndex_Equals(const lucy_LexIndex *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexIndex_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LexIndex_Compare_To(const lucy_LexIndex *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexIndex_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LexIndex_Hash_Sum(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LexIndex_Get_VTable(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexIndex_Get_Class_Name(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexIndex_Is_A(const lucy_LexIndex *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LexIndex_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexIndex_To_String(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LexIndex_To_I64(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LexIndex_To_F64(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexIndex_To_Bool(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LexIndex_Serialize(const lucy_LexIndex *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_LexIndex_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Deserialize(const lucy_LexIndex *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_LexIndex_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Dump(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexIndex_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Load(const lucy_LexIndex *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_LexIndex_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LexIndex_Mimic(const lucy_LexIndex *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexIndex_Seek_OFFSET;
static CHY_INLINE void
Lucy_LexIndex_Seek(const lucy_LexIndex *self, lucy_Obj* target) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Seek_OFFSET;
    const lucy_LexIndex_seek_t method = *((lucy_LexIndex_seek_t*)method_address);
    method((lucy_LexIndex*)self, target);
}

extern size_t Lucy_LexIndex_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexIndex_Next(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Next_OFFSET;
    const lucy_Lex_next_t method = *((lucy_Lex_next_t*)method_address);
    return method((lucy_Lexicon*)self);
}

extern size_t Lucy_LexIndex_Reset_OFFSET;
static CHY_INLINE void
Lucy_LexIndex_Reset(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Reset_OFFSET;
    const lucy_Lex_reset_t method = *((lucy_Lex_reset_t*)method_address);
    method((lucy_Lexicon*)self);
}

extern size_t Lucy_LexIndex_Doc_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_LexIndex_Doc_Freq(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Doc_Freq_OFFSET;
    const lucy_Lex_doc_freq_t method = *((lucy_Lex_doc_freq_t*)method_address);
    return method((lucy_Lexicon*)self);
}

extern size_t Lucy_LexIndex_Get_Term_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexIndex_Get_Term(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_Term_OFFSET;
    const lucy_LexIndex_get_term_t method = *((lucy_LexIndex_get_term_t*)method_address);
    return method((lucy_LexIndex*)self);
}

extern size_t Lucy_LexIndex_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexIndex_Get_Field(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_Field_OFFSET;
    const lucy_Lex_get_field_t method = *((lucy_Lex_get_field_t*)method_address);
    return method((lucy_Lexicon*)self);
}

extern size_t Lucy_LexIndex_Get_Term_Num_OFFSET;
static CHY_INLINE int32_t
Lucy_LexIndex_Get_Term_Num(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_Term_Num_OFFSET;
    const lucy_LexIndex_get_term_num_t method = *((lucy_LexIndex_get_term_num_t*)method_address);
    return method((lucy_LexIndex*)self);
}

extern size_t Lucy_LexIndex_Get_Term_Info_OFFSET;
static CHY_INLINE lucy_TermInfo*
Lucy_LexIndex_Get_Term_Info(const lucy_LexIndex *self) {
    char *const method_address = *(char**)self + Lucy_LexIndex_Get_Term_Info_OFFSET;
    const lucy_LexIndex_get_term_info_t method = *((lucy_LexIndex_get_term_info_t*)method_address);
    return method((lucy_LexIndex*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LEXINDEX_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[30];
} LUCY_LEXINDEX_VT;
extern struct LUCY_LEXINDEX_VT LUCY_LEXINDEX_vt;
#define LUCY_LEXINDEX ((cfish_VTable*)&LUCY_LEXINDEX_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LexIndex lucy_LexIndex
  #define LEXINDEX LUCY_LEXINDEX
  #define LexIndex_new lucy_LexIndex_new
  #define LexIndex_init lucy_LexIndex_init
  #define LexIndex_destroy_t lucy_LexIndex_destroy_t
  #define LexIndex_destroy lucy_LexIndex_destroy
  #define LexIndex_seek_t lucy_LexIndex_seek_t
  #define LexIndex_seek lucy_LexIndex_seek
  #define LexIndex_get_term_t lucy_LexIndex_get_term_t
  #define LexIndex_get_term lucy_LexIndex_get_term
  #define LexIndex_get_term_num_t lucy_LexIndex_get_term_num_t
  #define LexIndex_get_term_num lucy_LexIndex_get_term_num
  #define LexIndex_get_term_info_t lucy_LexIndex_get_term_info_t
  #define LexIndex_get_term_info lucy_LexIndex_get_term_info
  #define LexIndex_Make Lucy_LexIndex_Make
  #define LexIndex_Get_RefCount Lucy_LexIndex_Get_RefCount
  #define LexIndex_Inc_RefCount Lucy_LexIndex_Inc_RefCount
  #define LexIndex_Dec_RefCount Lucy_LexIndex_Dec_RefCount
  #define LexIndex_To_Host Lucy_LexIndex_To_Host
  #define LexIndex_Clone Lucy_LexIndex_Clone
  #define LexIndex_Destroy Lucy_LexIndex_Destroy
  #define LexIndex_Equals Lucy_LexIndex_Equals
  #define LexIndex_Compare_To Lucy_LexIndex_Compare_To
  #define LexIndex_Hash_Sum Lucy_LexIndex_Hash_Sum
  #define LexIndex_Get_VTable Lucy_LexIndex_Get_VTable
  #define LexIndex_Get_Class_Name Lucy_LexIndex_Get_Class_Name
  #define LexIndex_Is_A Lucy_LexIndex_Is_A
  #define LexIndex_To_String Lucy_LexIndex_To_String
  #define LexIndex_To_I64 Lucy_LexIndex_To_I64
  #define LexIndex_To_F64 Lucy_LexIndex_To_F64
  #define LexIndex_To_Bool Lucy_LexIndex_To_Bool
  #define LexIndex_Serialize Lucy_LexIndex_Serialize
  #define LexIndex_Deserialize Lucy_LexIndex_Deserialize
  #define LexIndex_Dump Lucy_LexIndex_Dump
  #define LexIndex_Load Lucy_LexIndex_Load
  #define LexIndex_Mimic Lucy_LexIndex_Mimic
  #define LexIndex_Seek Lucy_LexIndex_Seek
  #define LexIndex_Next Lucy_LexIndex_Next
  #define LexIndex_Reset Lucy_LexIndex_Reset
  #define LexIndex_Doc_Freq Lucy_LexIndex_Doc_Freq
  #define LexIndex_Get_Term Lucy_LexIndex_Get_Term
  #define LexIndex_Get_Field Lucy_LexIndex_Get_Field
  #define LexIndex_Get_Term_Num Lucy_LexIndex_Get_Term_Num
  #define LexIndex_Get_Term_Info Lucy_LexIndex_Get_Term_Info
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_LEXINDEX */




