/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_LEXICONREADER
#define H_LUCY_INDEX_LEXICONREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LEXICONREADER
struct lucy_LexiconReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_LEXICONREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LexiconReader*
lucy_LexReader_init(lucy_LexiconReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_LexiconReader*
lucy_LexReader_aggregator(lucy_LexiconReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

lucy_Lexicon*
lucy_LexReader_lexicon(lucy_LexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

uint32_t
lucy_LexReader_doc_freq(lucy_LexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

lucy_TermInfo*
lucy_LexReader_fetch_term_info(lucy_LexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LexReader_aggregator_CALLBACK;
extern cfish_Callback lucy_LexReader_lexicon_CALLBACK;
extern cfish_Callback lucy_LexReader_doc_freq_CALLBACK;
extern cfish_Callback lucy_LexReader_fetch_term_info_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_LexiconReader*
(*lucy_LexReader_aggregator_t)(lucy_LexiconReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef lucy_Lexicon*
(*lucy_LexReader_lexicon_t)(lucy_LexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef uint32_t
(*lucy_LexReader_doc_freq_t)(lucy_LexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef lucy_TermInfo*
(*lucy_LexReader_fetch_term_info_t)(lucy_LexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LexReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexReader_Make(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexReader_Get_RefCount(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexReader_Inc_RefCount(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexReader_Dec_RefCount(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LexReader_To_Host(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexReader_Clone(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LexReader_Destroy(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexReader_Equals(const lucy_LexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LexReader_Compare_To(const lucy_LexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LexReader_Hash_Sum(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LexReader_Get_VTable(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexReader_Get_Class_Name(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexReader_Is_A(const lucy_LexiconReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LexReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LexReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexReader_To_String(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LexReader_To_I64(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LexReader_To_F64(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexReader_To_Bool(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LexReader_Serialize(const lucy_LexiconReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LexReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_LexReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexReader_Deserialize(const lucy_LexiconReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LexReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_LexReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexReader_Dump(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexReader_Load(const lucy_LexiconReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LexReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_LexReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LexReader_Mimic(const lucy_LexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexReader_Aggregator_OFFSET;
static CHY_INLINE lucy_LexiconReader*
Lucy_LexReader_Aggregator(const lucy_LexiconReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_LexReader_Aggregator_OFFSET;
    const lucy_LexReader_aggregator_t method = *((lucy_LexReader_aggregator_t*)method_address);
    return method((lucy_LexiconReader*)self, readers, offsets);
}

extern size_t Lucy_LexReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_LexReader_Get_Schema(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_LexReader_Get_Folder(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_LexReader_Get_Snapshot(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_LexReader_Get_Segments(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_LexReader_Get_Segment(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_LexReader_Get_Seg_Tick(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Close_OFFSET;
static CHY_INLINE void
Lucy_LexReader_Close(const lucy_LexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_LexReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_LexReader_Lexicon_OFFSET;
static CHY_INLINE lucy_Lexicon*
Lucy_LexReader_Lexicon(const lucy_LexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_LexReader_Lexicon_OFFSET;
    const lucy_LexReader_lexicon_t method = *((lucy_LexReader_lexicon_t*)method_address);
    return method((lucy_LexiconReader*)self, field, term);
}

extern size_t Lucy_LexReader_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexReader_Doc_Freq(const lucy_LexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_LexReader_Doc_Freq_OFFSET;
    const lucy_LexReader_doc_freq_t method = *((lucy_LexReader_doc_freq_t*)method_address);
    return method((lucy_LexiconReader*)self, field, term);
}

extern size_t Lucy_LexReader_Fetch_Term_Info_OFFSET;
static CHY_INLINE lucy_TermInfo*
Lucy_LexReader_Fetch_Term_Info(const lucy_LexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_LexReader_Fetch_Term_Info_OFFSET;
    const lucy_LexReader_fetch_term_info_t method = *((lucy_LexReader_fetch_term_info_t*)method_address);
    return method((lucy_LexiconReader*)self, field, term);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LEXICONREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_LEXICONREADER_VT;
extern struct LUCY_LEXICONREADER_VT LUCY_LEXICONREADER_vt;
#define LUCY_LEXICONREADER ((cfish_VTable*)&LUCY_LEXICONREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LexiconReader lucy_LexiconReader
  #define LEXICONREADER LUCY_LEXICONREADER
  #define LexReader_init lucy_LexReader_init
  #define LexReader_aggregator_t lucy_LexReader_aggregator_t
  #define LexReader_aggregator lucy_LexReader_aggregator
  #define LexReader_lexicon_t lucy_LexReader_lexicon_t
  #define LexReader_lexicon lucy_LexReader_lexicon
  #define LexReader_doc_freq_t lucy_LexReader_doc_freq_t
  #define LexReader_doc_freq lucy_LexReader_doc_freq
  #define LexReader_fetch_term_info_t lucy_LexReader_fetch_term_info_t
  #define LexReader_fetch_term_info lucy_LexReader_fetch_term_info
  #define LexReader_Make Lucy_LexReader_Make
  #define LexReader_Get_RefCount Lucy_LexReader_Get_RefCount
  #define LexReader_Inc_RefCount Lucy_LexReader_Inc_RefCount
  #define LexReader_Dec_RefCount Lucy_LexReader_Dec_RefCount
  #define LexReader_To_Host Lucy_LexReader_To_Host
  #define LexReader_Clone Lucy_LexReader_Clone
  #define LexReader_Destroy Lucy_LexReader_Destroy
  #define LexReader_Equals Lucy_LexReader_Equals
  #define LexReader_Compare_To Lucy_LexReader_Compare_To
  #define LexReader_Hash_Sum Lucy_LexReader_Hash_Sum
  #define LexReader_Get_VTable Lucy_LexReader_Get_VTable
  #define LexReader_Get_Class_Name Lucy_LexReader_Get_Class_Name
  #define LexReader_Is_A Lucy_LexReader_Is_A
  #define LexReader_To_String Lucy_LexReader_To_String
  #define LexReader_To_I64 Lucy_LexReader_To_I64
  #define LexReader_To_F64 Lucy_LexReader_To_F64
  #define LexReader_To_Bool Lucy_LexReader_To_Bool
  #define LexReader_Serialize Lucy_LexReader_Serialize
  #define LexReader_Deserialize Lucy_LexReader_Deserialize
  #define LexReader_Dump Lucy_LexReader_Dump
  #define LexReader_Load Lucy_LexReader_Load
  #define LexReader_Mimic Lucy_LexReader_Mimic
  #define LexReader_Aggregator Lucy_LexReader_Aggregator
  #define LexReader_Get_Schema Lucy_LexReader_Get_Schema
  #define LexReader_Get_Folder Lucy_LexReader_Get_Folder
  #define LexReader_Get_Snapshot Lucy_LexReader_Get_Snapshot
  #define LexReader_Get_Segments Lucy_LexReader_Get_Segments
  #define LexReader_Get_Segment Lucy_LexReader_Get_Segment
  #define LexReader_Get_Seg_Tick Lucy_LexReader_Get_Seg_Tick
  #define LexReader_Close Lucy_LexReader_Close
  #define LexReader_Lexicon Lucy_LexReader_Lexicon
  #define LexReader_Doc_Freq Lucy_LexReader_Doc_Freq
  #define LexReader_Fetch_Term_Info Lucy_LexReader_Fetch_Term_Info
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/LexiconReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYLEXICONREADER
struct lucy_PolyLexiconReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_VArray* readers;
    lucy_I32Array* offsets;
};

#endif /* C_LUCY_POLYLEXICONREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyLexiconReader*
lucy_PolyLexReader_new(lucy_VArray* readers, lucy_I32Array* offsets);

lucy_PolyLexiconReader*
lucy_PolyLexReader_init(lucy_PolyLexiconReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

void
lucy_PolyLexReader_destroy(lucy_PolyLexiconReader* self);

void
lucy_PolyLexReader_close(lucy_PolyLexiconReader* self);

lucy_Lexicon*
lucy_PolyLexReader_lexicon(lucy_PolyLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

uint32_t
lucy_PolyLexReader_doc_freq(lucy_PolyLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyLexReader_destroy_CALLBACK;
extern cfish_Callback lucy_PolyLexReader_close_CALLBACK;
extern cfish_Callback lucy_PolyLexReader_lexicon_CALLBACK;
extern cfish_Callback lucy_PolyLexReader_doc_freq_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyLexReader_destroy_t)(lucy_PolyLexiconReader* self);

typedef void
(*lucy_PolyLexReader_close_t)(lucy_PolyLexiconReader* self);

typedef lucy_Lexicon*
(*lucy_PolyLexReader_lexicon_t)(lucy_PolyLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef uint32_t
(*lucy_PolyLexReader_doc_freq_t)(lucy_PolyLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyLexReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLexReader_Make(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyLexReader_Get_RefCount(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLexReader_Inc_RefCount(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyLexReader_Dec_RefCount(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyLexReader_To_Host(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLexReader_Clone(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyLexReader_Destroy(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Destroy_OFFSET;
    const lucy_PolyLexReader_destroy_t method = *((lucy_PolyLexReader_destroy_t*)method_address);
    method((lucy_PolyLexiconReader*)self);
}

extern size_t Lucy_PolyLexReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLexReader_Equals(const lucy_PolyLexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyLexReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyLexReader_Compare_To(const lucy_PolyLexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyLexReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyLexReader_Hash_Sum(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyLexReader_Get_VTable(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyLexReader_Get_Class_Name(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLexReader_Is_A(const lucy_PolyLexiconReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyLexReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyLexReader_To_String(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyLexReader_To_I64(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyLexReader_To_F64(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLexReader_To_Bool(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyLexReader_Serialize(const lucy_PolyLexiconReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyLexReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLexReader_Deserialize(const lucy_PolyLexiconReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyLexReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLexReader_Dump(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLexReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLexReader_Load(const lucy_PolyLexiconReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolyLexReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyLexReader_Mimic(const lucy_PolyLexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyLexReader_Aggregator_OFFSET;
static CHY_INLINE lucy_LexiconReader*
Lucy_PolyLexReader_Aggregator(const lucy_PolyLexiconReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Aggregator_OFFSET;
    const lucy_LexReader_aggregator_t method = *((lucy_LexReader_aggregator_t*)method_address);
    return method((lucy_LexiconReader*)self, readers, offsets);
}

extern size_t Lucy_PolyLexReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PolyLexReader_Get_Schema(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyLexReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PolyLexReader_Get_Folder(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyLexReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PolyLexReader_Get_Snapshot(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyLexReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyLexReader_Get_Segments(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyLexReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PolyLexReader_Get_Segment(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyLexReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyLexReader_Get_Seg_Tick(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyLexReader_Close_OFFSET;
static CHY_INLINE void
Lucy_PolyLexReader_Close(const lucy_PolyLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Close_OFFSET;
    const lucy_PolyLexReader_close_t method = *((lucy_PolyLexReader_close_t*)method_address);
    method((lucy_PolyLexiconReader*)self);
}

extern size_t Lucy_PolyLexReader_Lexicon_OFFSET;
static CHY_INLINE lucy_Lexicon*
Lucy_PolyLexReader_Lexicon(const lucy_PolyLexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Lexicon_OFFSET;
    const lucy_PolyLexReader_lexicon_t method = *((lucy_PolyLexReader_lexicon_t*)method_address);
    return method((lucy_PolyLexiconReader*)self, field, term);
}

extern size_t Lucy_PolyLexReader_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyLexReader_Doc_Freq(const lucy_PolyLexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Doc_Freq_OFFSET;
    const lucy_PolyLexReader_doc_freq_t method = *((lucy_PolyLexReader_doc_freq_t*)method_address);
    return method((lucy_PolyLexiconReader*)self, field, term);
}

extern size_t Lucy_PolyLexReader_Fetch_Term_Info_OFFSET;
static CHY_INLINE lucy_TermInfo*
Lucy_PolyLexReader_Fetch_Term_Info(const lucy_PolyLexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_PolyLexReader_Fetch_Term_Info_OFFSET;
    const lucy_LexReader_fetch_term_info_t method = *((lucy_LexReader_fetch_term_info_t*)method_address);
    return method((lucy_LexiconReader*)self, field, term);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYLEXICONREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_POLYLEXICONREADER_VT;
extern struct LUCY_POLYLEXICONREADER_VT LUCY_POLYLEXICONREADER_vt;
#define LUCY_POLYLEXICONREADER ((cfish_VTable*)&LUCY_POLYLEXICONREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyLexiconReader lucy_PolyLexiconReader
  #define POLYLEXICONREADER LUCY_POLYLEXICONREADER
  #define PolyLexReader_new lucy_PolyLexReader_new
  #define PolyLexReader_init lucy_PolyLexReader_init
  #define PolyLexReader_destroy_t lucy_PolyLexReader_destroy_t
  #define PolyLexReader_destroy lucy_PolyLexReader_destroy
  #define PolyLexReader_close_t lucy_PolyLexReader_close_t
  #define PolyLexReader_close lucy_PolyLexReader_close
  #define PolyLexReader_lexicon_t lucy_PolyLexReader_lexicon_t
  #define PolyLexReader_lexicon lucy_PolyLexReader_lexicon
  #define PolyLexReader_doc_freq_t lucy_PolyLexReader_doc_freq_t
  #define PolyLexReader_doc_freq lucy_PolyLexReader_doc_freq
  #define PolyLexReader_Make Lucy_PolyLexReader_Make
  #define PolyLexReader_Get_RefCount Lucy_PolyLexReader_Get_RefCount
  #define PolyLexReader_Inc_RefCount Lucy_PolyLexReader_Inc_RefCount
  #define PolyLexReader_Dec_RefCount Lucy_PolyLexReader_Dec_RefCount
  #define PolyLexReader_To_Host Lucy_PolyLexReader_To_Host
  #define PolyLexReader_Clone Lucy_PolyLexReader_Clone
  #define PolyLexReader_Destroy Lucy_PolyLexReader_Destroy
  #define PolyLexReader_Equals Lucy_PolyLexReader_Equals
  #define PolyLexReader_Compare_To Lucy_PolyLexReader_Compare_To
  #define PolyLexReader_Hash_Sum Lucy_PolyLexReader_Hash_Sum
  #define PolyLexReader_Get_VTable Lucy_PolyLexReader_Get_VTable
  #define PolyLexReader_Get_Class_Name Lucy_PolyLexReader_Get_Class_Name
  #define PolyLexReader_Is_A Lucy_PolyLexReader_Is_A
  #define PolyLexReader_To_String Lucy_PolyLexReader_To_String
  #define PolyLexReader_To_I64 Lucy_PolyLexReader_To_I64
  #define PolyLexReader_To_F64 Lucy_PolyLexReader_To_F64
  #define PolyLexReader_To_Bool Lucy_PolyLexReader_To_Bool
  #define PolyLexReader_Serialize Lucy_PolyLexReader_Serialize
  #define PolyLexReader_Deserialize Lucy_PolyLexReader_Deserialize
  #define PolyLexReader_Dump Lucy_PolyLexReader_Dump
  #define PolyLexReader_Load Lucy_PolyLexReader_Load
  #define PolyLexReader_Mimic Lucy_PolyLexReader_Mimic
  #define PolyLexReader_Aggregator Lucy_PolyLexReader_Aggregator
  #define PolyLexReader_Get_Schema Lucy_PolyLexReader_Get_Schema
  #define PolyLexReader_Get_Folder Lucy_PolyLexReader_Get_Folder
  #define PolyLexReader_Get_Snapshot Lucy_PolyLexReader_Get_Snapshot
  #define PolyLexReader_Get_Segments Lucy_PolyLexReader_Get_Segments
  #define PolyLexReader_Get_Segment Lucy_PolyLexReader_Get_Segment
  #define PolyLexReader_Get_Seg_Tick Lucy_PolyLexReader_Get_Seg_Tick
  #define PolyLexReader_Close Lucy_PolyLexReader_Close
  #define PolyLexReader_Lexicon Lucy_PolyLexReader_Lexicon
  #define PolyLexReader_Doc_Freq Lucy_PolyLexReader_Doc_Freq
  #define PolyLexReader_Fetch_Term_Info Lucy_PolyLexReader_Fetch_Term_Info
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/LexiconReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTLEXICONREADER
struct lucy_DefaultLexiconReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_VArray* lexicons;
};

#endif /* C_LUCY_DEFAULTLEXICONREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultLexiconReader*
lucy_DefLexReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DefaultLexiconReader*
lucy_DefLexReader_init(lucy_DefaultLexiconReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_DefLexReader_destroy(lucy_DefaultLexiconReader* self);

void
lucy_DefLexReader_close(lucy_DefaultLexiconReader* self);

lucy_Lexicon*
lucy_DefLexReader_lexicon(lucy_DefaultLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

uint32_t
lucy_DefLexReader_doc_freq(lucy_DefaultLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

lucy_TermInfo*
lucy_DefLexReader_fetch_term_info(lucy_DefaultLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefLexReader_destroy_CALLBACK;
extern cfish_Callback lucy_DefLexReader_close_CALLBACK;
extern cfish_Callback lucy_DefLexReader_lexicon_CALLBACK;
extern cfish_Callback lucy_DefLexReader_doc_freq_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefLexReader_destroy_t)(lucy_DefaultLexiconReader* self);

typedef void
(*lucy_DefLexReader_close_t)(lucy_DefaultLexiconReader* self);

typedef lucy_Lexicon*
(*lucy_DefLexReader_lexicon_t)(lucy_DefaultLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef uint32_t
(*lucy_DefLexReader_doc_freq_t)(lucy_DefaultLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef lucy_TermInfo*
(*lucy_DefLexReader_fetch_term_info_t)(lucy_DefaultLexiconReader* self, const lucy_CharBuf* field, lucy_Obj* term);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefLexReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefLexReader_Make(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefLexReader_Get_RefCount(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefLexReader_Inc_RefCount(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefLexReader_Dec_RefCount(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefLexReader_To_Host(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefLexReader_Clone(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefLexReader_Destroy(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Destroy_OFFSET;
    const lucy_DefLexReader_destroy_t method = *((lucy_DefLexReader_destroy_t*)method_address);
    method((lucy_DefaultLexiconReader*)self);
}

extern size_t Lucy_DefLexReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefLexReader_Equals(const lucy_DefaultLexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefLexReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefLexReader_Compare_To(const lucy_DefaultLexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefLexReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefLexReader_Hash_Sum(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefLexReader_Get_VTable(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefLexReader_Get_Class_Name(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefLexReader_Is_A(const lucy_DefaultLexiconReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefLexReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefLexReader_To_String(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefLexReader_To_I64(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefLexReader_To_F64(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefLexReader_To_Bool(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefLexReader_Serialize(const lucy_DefaultLexiconReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefLexReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefLexReader_Deserialize(const lucy_DefaultLexiconReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefLexReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefLexReader_Dump(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefLexReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefLexReader_Load(const lucy_DefaultLexiconReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefLexReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefLexReader_Mimic(const lucy_DefaultLexiconReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefLexReader_Aggregator_OFFSET;
static CHY_INLINE lucy_LexiconReader*
Lucy_DefLexReader_Aggregator(const lucy_DefaultLexiconReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Aggregator_OFFSET;
    const lucy_LexReader_aggregator_t method = *((lucy_LexReader_aggregator_t*)method_address);
    return method((lucy_LexiconReader*)self, readers, offsets);
}

extern size_t Lucy_DefLexReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefLexReader_Get_Schema(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefLexReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefLexReader_Get_Folder(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefLexReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefLexReader_Get_Snapshot(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefLexReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DefLexReader_Get_Segments(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefLexReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefLexReader_Get_Segment(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefLexReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DefLexReader_Get_Seg_Tick(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefLexReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DefLexReader_Close(const lucy_DefaultLexiconReader *self) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Close_OFFSET;
    const lucy_DefLexReader_close_t method = *((lucy_DefLexReader_close_t*)method_address);
    method((lucy_DefaultLexiconReader*)self);
}

extern size_t Lucy_DefLexReader_Lexicon_OFFSET;
static CHY_INLINE lucy_Lexicon*
Lucy_DefLexReader_Lexicon(const lucy_DefaultLexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Lexicon_OFFSET;
    const lucy_DefLexReader_lexicon_t method = *((lucy_DefLexReader_lexicon_t*)method_address);
    return method((lucy_DefaultLexiconReader*)self, field, term);
}

extern size_t Lucy_DefLexReader_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefLexReader_Doc_Freq(const lucy_DefaultLexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Doc_Freq_OFFSET;
    const lucy_DefLexReader_doc_freq_t method = *((lucy_DefLexReader_doc_freq_t*)method_address);
    return method((lucy_DefaultLexiconReader*)self, field, term);
}

extern size_t Lucy_DefLexReader_Fetch_Term_Info_OFFSET;
static CHY_INLINE lucy_TermInfo*
Lucy_DefLexReader_Fetch_Term_Info(const lucy_DefaultLexiconReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_DefLexReader_Fetch_Term_Info_OFFSET;
    const lucy_DefLexReader_fetch_term_info_t method = *((lucy_DefLexReader_fetch_term_info_t*)method_address);
    return method((lucy_DefaultLexiconReader*)self, field, term);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTLEXICONREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_DEFAULTLEXICONREADER_VT;
extern struct LUCY_DEFAULTLEXICONREADER_VT LUCY_DEFAULTLEXICONREADER_vt;
#define LUCY_DEFAULTLEXICONREADER ((cfish_VTable*)&LUCY_DEFAULTLEXICONREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultLexiconReader lucy_DefaultLexiconReader
  #define DEFAULTLEXICONREADER LUCY_DEFAULTLEXICONREADER
  #define DefLexReader_new lucy_DefLexReader_new
  #define DefLexReader_init lucy_DefLexReader_init
  #define DefLexReader_destroy_t lucy_DefLexReader_destroy_t
  #define DefLexReader_destroy lucy_DefLexReader_destroy
  #define DefLexReader_close_t lucy_DefLexReader_close_t
  #define DefLexReader_close lucy_DefLexReader_close
  #define DefLexReader_lexicon_t lucy_DefLexReader_lexicon_t
  #define DefLexReader_lexicon lucy_DefLexReader_lexicon
  #define DefLexReader_doc_freq_t lucy_DefLexReader_doc_freq_t
  #define DefLexReader_doc_freq lucy_DefLexReader_doc_freq
  #define DefLexReader_fetch_term_info_t lucy_DefLexReader_fetch_term_info_t
  #define DefLexReader_fetch_term_info lucy_DefLexReader_fetch_term_info
  #define DefLexReader_Make Lucy_DefLexReader_Make
  #define DefLexReader_Get_RefCount Lucy_DefLexReader_Get_RefCount
  #define DefLexReader_Inc_RefCount Lucy_DefLexReader_Inc_RefCount
  #define DefLexReader_Dec_RefCount Lucy_DefLexReader_Dec_RefCount
  #define DefLexReader_To_Host Lucy_DefLexReader_To_Host
  #define DefLexReader_Clone Lucy_DefLexReader_Clone
  #define DefLexReader_Destroy Lucy_DefLexReader_Destroy
  #define DefLexReader_Equals Lucy_DefLexReader_Equals
  #define DefLexReader_Compare_To Lucy_DefLexReader_Compare_To
  #define DefLexReader_Hash_Sum Lucy_DefLexReader_Hash_Sum
  #define DefLexReader_Get_VTable Lucy_DefLexReader_Get_VTable
  #define DefLexReader_Get_Class_Name Lucy_DefLexReader_Get_Class_Name
  #define DefLexReader_Is_A Lucy_DefLexReader_Is_A
  #define DefLexReader_To_String Lucy_DefLexReader_To_String
  #define DefLexReader_To_I64 Lucy_DefLexReader_To_I64
  #define DefLexReader_To_F64 Lucy_DefLexReader_To_F64
  #define DefLexReader_To_Bool Lucy_DefLexReader_To_Bool
  #define DefLexReader_Serialize Lucy_DefLexReader_Serialize
  #define DefLexReader_Deserialize Lucy_DefLexReader_Deserialize
  #define DefLexReader_Dump Lucy_DefLexReader_Dump
  #define DefLexReader_Load Lucy_DefLexReader_Load
  #define DefLexReader_Mimic Lucy_DefLexReader_Mimic
  #define DefLexReader_Aggregator Lucy_DefLexReader_Aggregator
  #define DefLexReader_Get_Schema Lucy_DefLexReader_Get_Schema
  #define DefLexReader_Get_Folder Lucy_DefLexReader_Get_Folder
  #define DefLexReader_Get_Snapshot Lucy_DefLexReader_Get_Snapshot
  #define DefLexReader_Get_Segments Lucy_DefLexReader_Get_Segments
  #define DefLexReader_Get_Segment Lucy_DefLexReader_Get_Segment
  #define DefLexReader_Get_Seg_Tick Lucy_DefLexReader_Get_Seg_Tick
  #define DefLexReader_Close Lucy_DefLexReader_Close
  #define DefLexReader_Lexicon Lucy_DefLexReader_Lexicon
  #define DefLexReader_Doc_Freq Lucy_DefLexReader_Doc_Freq
  #define DefLexReader_Fetch_Term_Info Lucy_DefLexReader_Fetch_Term_Info
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_LEXICONREADER */




