/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_LEXICONWRITER
#define H_LUCY_INDEX_LEXICONWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LEXICONWRITER
struct lucy_LexiconWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_TermStepper* term_stepper;
    lucy_TermStepper* tinfo_stepper;
    lucy_CharBuf* dat_file;
    lucy_CharBuf* ix_file;
    lucy_CharBuf* ixix_file;
    lucy_OutStream* dat_out;
    lucy_OutStream* ix_out;
    lucy_OutStream* ixix_out;
    lucy_Hash* counts;
    lucy_Hash* ix_counts;
    chy_bool_t temp_mode;
    int32_t index_interval;
    int32_t skip_interval;
    int32_t count;
    int32_t ix_count;
};

#endif /* C_LUCY_LEXICONWRITER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_LexWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LexiconWriter*
lucy_LexWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

lucy_LexiconWriter*
lucy_LexWriter_init(lucy_LexiconWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_LexWriter_destroy(lucy_LexiconWriter* self);

void
lucy_LexWriter_add_segment(lucy_LexiconWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_LexWriter_finish(lucy_LexiconWriter* self);

lucy_Hash*
lucy_LexWriter_metadata(lucy_LexiconWriter* self);

int32_t
lucy_LexWriter_format(lucy_LexiconWriter* self);

void
lucy_LexWriter_start_field(lucy_LexiconWriter* self, int32_t field_num);

void
lucy_LexWriter_finish_field(lucy_LexiconWriter* self, int32_t field_num);

void
lucy_LexWriter_enter_temp_mode(lucy_LexiconWriter* self, const lucy_CharBuf* field, lucy_OutStream* temp_outstream);

void
lucy_LexWriter_leave_temp_mode(lucy_LexiconWriter* self);

void
lucy_LexWriter_add_term(lucy_LexiconWriter* self, lucy_CharBuf* term_text, lucy_TermInfo* tinfo);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LexWriter_destroy_CALLBACK;
extern cfish_Callback lucy_LexWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_LexWriter_finish_CALLBACK;
extern cfish_Callback lucy_LexWriter_metadata_CALLBACK;
extern cfish_Callback lucy_LexWriter_format_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_LexWriter_destroy_t)(lucy_LexiconWriter* self);

typedef void
(*lucy_LexWriter_add_segment_t)(lucy_LexiconWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_LexWriter_finish_t)(lucy_LexiconWriter* self);

typedef lucy_Hash*
(*lucy_LexWriter_metadata_t)(lucy_LexiconWriter* self);

typedef int32_t
(*lucy_LexWriter_format_t)(lucy_LexiconWriter* self);

typedef void
(*lucy_LexWriter_start_field_t)(lucy_LexiconWriter* self, int32_t field_num);

typedef void
(*lucy_LexWriter_finish_field_t)(lucy_LexiconWriter* self, int32_t field_num);

typedef void
(*lucy_LexWriter_enter_temp_mode_t)(lucy_LexiconWriter* self, const lucy_CharBuf* field, lucy_OutStream* temp_outstream);

typedef void
(*lucy_LexWriter_leave_temp_mode_t)(lucy_LexiconWriter* self);

typedef void
(*lucy_LexWriter_add_term_t)(lucy_LexiconWriter* self, lucy_CharBuf* term_text, lucy_TermInfo* tinfo);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LexWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexWriter_Make(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexWriter_Get_RefCount(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexWriter_Inc_RefCount(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LexWriter_Dec_RefCount(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LexWriter_To_Host(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexWriter_Clone(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Destroy(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Destroy_OFFSET;
    const lucy_LexWriter_destroy_t method = *((lucy_LexWriter_destroy_t*)method_address);
    method((lucy_LexiconWriter*)self);
}

extern size_t Lucy_LexWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexWriter_Equals(const lucy_LexiconWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LexWriter_Compare_To(const lucy_LexiconWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LexWriter_Hash_Sum(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LexWriter_Get_VTable(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexWriter_Get_Class_Name(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexWriter_Is_A(const lucy_LexiconWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LexWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LexWriter_To_String(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LexWriter_To_I64(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LexWriter_To_F64(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LexWriter_To_Bool(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Serialize(const lucy_LexiconWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_LexWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexWriter_Deserialize(const lucy_LexiconWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_LexWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexWriter_Dump(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LexWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LexWriter_Load(const lucy_LexiconWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_LexWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Mimic(const lucy_LexiconWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LexWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Add_Inverted_Doc(const lucy_LexiconWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_LexWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Add_Segment(const lucy_LexiconWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Add_Segment_OFFSET;
    const lucy_LexWriter_add_segment_t method = *((lucy_LexWriter_add_segment_t*)method_address);
    method((lucy_LexiconWriter*)self, reader, doc_map);
}

extern size_t Lucy_LexWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Delete_Segment(const lucy_LexiconWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_LexWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Merge_Segment(const lucy_LexiconWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_LexWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Finish(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Finish_OFFSET;
    const lucy_LexWriter_finish_t method = *((lucy_LexWriter_finish_t*)method_address);
    method((lucy_LexiconWriter*)self);
}

extern size_t Lucy_LexWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_LexWriter_Metadata(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Metadata_OFFSET;
    const lucy_LexWriter_metadata_t method = *((lucy_LexWriter_metadata_t*)method_address);
    return method((lucy_LexiconWriter*)self);
}

extern size_t Lucy_LexWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_LexWriter_Format(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Format_OFFSET;
    const lucy_LexWriter_format_t method = *((lucy_LexWriter_format_t*)method_address);
    return method((lucy_LexiconWriter*)self);
}

extern size_t Lucy_LexWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_LexWriter_Get_Snapshot(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_LexWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_LexWriter_Get_Segment(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_LexWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_LexWriter_Get_PolyReader(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_LexWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_LexWriter_Get_Schema(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_LexWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_LexWriter_Get_Folder(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_LexWriter_Start_Field_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Start_Field(const lucy_LexiconWriter *self, int32_t field_num) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Start_Field_OFFSET;
    const lucy_LexWriter_start_field_t method = *((lucy_LexWriter_start_field_t*)method_address);
    method((lucy_LexiconWriter*)self, field_num);
}

extern size_t Lucy_LexWriter_Finish_Field_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Finish_Field(const lucy_LexiconWriter *self, int32_t field_num) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Finish_Field_OFFSET;
    const lucy_LexWriter_finish_field_t method = *((lucy_LexWriter_finish_field_t*)method_address);
    method((lucy_LexiconWriter*)self, field_num);
}

extern size_t Lucy_LexWriter_Enter_Temp_Mode_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Enter_Temp_Mode(const lucy_LexiconWriter *self, const lucy_CharBuf* field, lucy_OutStream* temp_outstream) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Enter_Temp_Mode_OFFSET;
    const lucy_LexWriter_enter_temp_mode_t method = *((lucy_LexWriter_enter_temp_mode_t*)method_address);
    method((lucy_LexiconWriter*)self, field, temp_outstream);
}

extern size_t Lucy_LexWriter_Leave_Temp_Mode_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Leave_Temp_Mode(const lucy_LexiconWriter *self) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Leave_Temp_Mode_OFFSET;
    const lucy_LexWriter_leave_temp_mode_t method = *((lucy_LexWriter_leave_temp_mode_t*)method_address);
    method((lucy_LexiconWriter*)self);
}

extern size_t Lucy_LexWriter_Add_Term_OFFSET;
static CHY_INLINE void
Lucy_LexWriter_Add_Term(const lucy_LexiconWriter *self, lucy_CharBuf* term_text, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_LexWriter_Add_Term_OFFSET;
    const lucy_LexWriter_add_term_t method = *((lucy_LexWriter_add_term_t*)method_address);
    method((lucy_LexiconWriter*)self, term_text, tinfo);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LEXICONWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[39];
} LUCY_LEXICONWRITER_VT;
extern struct LUCY_LEXICONWRITER_VT LUCY_LEXICONWRITER_vt;
#define LUCY_LEXICONWRITER ((cfish_VTable*)&LUCY_LEXICONWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LexiconWriter lucy_LexiconWriter
  #define LEXICONWRITER LUCY_LEXICONWRITER
  #define LexWriter_new lucy_LexWriter_new
  #define LexWriter_init lucy_LexWriter_init
  #define LexWriter_current_file_format lucy_LexWriter_current_file_format
  #define LexWriter_destroy_t lucy_LexWriter_destroy_t
  #define LexWriter_destroy lucy_LexWriter_destroy
  #define LexWriter_add_segment_t lucy_LexWriter_add_segment_t
  #define LexWriter_add_segment lucy_LexWriter_add_segment
  #define LexWriter_finish_t lucy_LexWriter_finish_t
  #define LexWriter_finish lucy_LexWriter_finish
  #define LexWriter_metadata_t lucy_LexWriter_metadata_t
  #define LexWriter_metadata lucy_LexWriter_metadata
  #define LexWriter_format_t lucy_LexWriter_format_t
  #define LexWriter_format lucy_LexWriter_format
  #define LexWriter_start_field_t lucy_LexWriter_start_field_t
  #define LexWriter_start_field lucy_LexWriter_start_field
  #define LexWriter_finish_field_t lucy_LexWriter_finish_field_t
  #define LexWriter_finish_field lucy_LexWriter_finish_field
  #define LexWriter_enter_temp_mode_t lucy_LexWriter_enter_temp_mode_t
  #define LexWriter_enter_temp_mode lucy_LexWriter_enter_temp_mode
  #define LexWriter_leave_temp_mode_t lucy_LexWriter_leave_temp_mode_t
  #define LexWriter_leave_temp_mode lucy_LexWriter_leave_temp_mode
  #define LexWriter_add_term_t lucy_LexWriter_add_term_t
  #define LexWriter_add_term lucy_LexWriter_add_term
  #define LexWriter_Make Lucy_LexWriter_Make
  #define LexWriter_Get_RefCount Lucy_LexWriter_Get_RefCount
  #define LexWriter_Inc_RefCount Lucy_LexWriter_Inc_RefCount
  #define LexWriter_Dec_RefCount Lucy_LexWriter_Dec_RefCount
  #define LexWriter_To_Host Lucy_LexWriter_To_Host
  #define LexWriter_Clone Lucy_LexWriter_Clone
  #define LexWriter_Destroy Lucy_LexWriter_Destroy
  #define LexWriter_Equals Lucy_LexWriter_Equals
  #define LexWriter_Compare_To Lucy_LexWriter_Compare_To
  #define LexWriter_Hash_Sum Lucy_LexWriter_Hash_Sum
  #define LexWriter_Get_VTable Lucy_LexWriter_Get_VTable
  #define LexWriter_Get_Class_Name Lucy_LexWriter_Get_Class_Name
  #define LexWriter_Is_A Lucy_LexWriter_Is_A
  #define LexWriter_To_String Lucy_LexWriter_To_String
  #define LexWriter_To_I64 Lucy_LexWriter_To_I64
  #define LexWriter_To_F64 Lucy_LexWriter_To_F64
  #define LexWriter_To_Bool Lucy_LexWriter_To_Bool
  #define LexWriter_Serialize Lucy_LexWriter_Serialize
  #define LexWriter_Deserialize Lucy_LexWriter_Deserialize
  #define LexWriter_Dump Lucy_LexWriter_Dump
  #define LexWriter_Load Lucy_LexWriter_Load
  #define LexWriter_Mimic Lucy_LexWriter_Mimic
  #define LexWriter_Add_Inverted_Doc Lucy_LexWriter_Add_Inverted_Doc
  #define LexWriter_Add_Segment Lucy_LexWriter_Add_Segment
  #define LexWriter_Delete_Segment Lucy_LexWriter_Delete_Segment
  #define LexWriter_Merge_Segment Lucy_LexWriter_Merge_Segment
  #define LexWriter_Finish Lucy_LexWriter_Finish
  #define LexWriter_Metadata Lucy_LexWriter_Metadata
  #define LexWriter_Format Lucy_LexWriter_Format
  #define LexWriter_Get_Snapshot Lucy_LexWriter_Get_Snapshot
  #define LexWriter_Get_Segment Lucy_LexWriter_Get_Segment
  #define LexWriter_Get_PolyReader Lucy_LexWriter_Get_PolyReader
  #define LexWriter_Get_Schema Lucy_LexWriter_Get_Schema
  #define LexWriter_Get_Folder Lucy_LexWriter_Get_Folder
  #define LexWriter_Start_Field Lucy_LexWriter_Start_Field
  #define LexWriter_Finish_Field Lucy_LexWriter_Finish_Field
  #define LexWriter_Enter_Temp_Mode Lucy_LexWriter_Enter_Temp_Mode
  #define LexWriter_Leave_Temp_Mode Lucy_LexWriter_Leave_Temp_Mode
  #define LexWriter_Add_Term Lucy_LexWriter_Add_Term
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_LEXICONWRITER */




