/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POLYLEXICON
#define H_LUCY_INDEX_POLYLEXICON 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Lexicon.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYLEXICON
struct lucy_PolyLexicon {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_Obj* term;
    lucy_SegLexQueue* lex_q;
    lucy_VArray* seg_lexicons;
    int32_t size;
};

#endif /* C_LUCY_POLYLEXICON */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyLexicon*
lucy_PolyLex_new(const lucy_CharBuf* field, lucy_VArray* sub_readers);

lucy_PolyLexicon*
lucy_PolyLex_init(lucy_PolyLexicon* self, const lucy_CharBuf* field, lucy_VArray* sub_readers);

void
lucy_PolyLex_destroy(lucy_PolyLexicon* self);

void
lucy_PolyLex_seek(lucy_PolyLexicon* self, lucy_Obj* target);

chy_bool_t
lucy_PolyLex_next(lucy_PolyLexicon* self);

void
lucy_PolyLex_reset(lucy_PolyLexicon* self);

lucy_Obj*
lucy_PolyLex_get_term(lucy_PolyLexicon* self);

uint32_t
lucy_PolyLex_get_num_seg_lexicons(lucy_PolyLexicon* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyLex_destroy_CALLBACK;
extern cfish_Callback lucy_PolyLex_seek_CALLBACK;
extern cfish_Callback lucy_PolyLex_next_CALLBACK;
extern cfish_Callback lucy_PolyLex_reset_CALLBACK;
extern cfish_Callback lucy_PolyLex_get_term_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyLex_destroy_t)(lucy_PolyLexicon* self);

typedef void
(*lucy_PolyLex_seek_t)(lucy_PolyLexicon* self, lucy_Obj* target);

typedef chy_bool_t
(*lucy_PolyLex_next_t)(lucy_PolyLexicon* self);

typedef void
(*lucy_PolyLex_reset_t)(lucy_PolyLexicon* self);

typedef lucy_Obj*
(*lucy_PolyLex_get_term_t)(lucy_PolyLexicon* self);

typedef uint32_t
(*lucy_PolyLex_get_num_seg_lexicons_t)(lucy_PolyLexicon* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyLex_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Make(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyLex_Get_RefCount(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Inc_RefCount(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyLex_Dec_RefCount(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyLex_To_Host(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Clone(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyLex_Destroy(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Destroy_OFFSET;
    const lucy_PolyLex_destroy_t method = *((lucy_PolyLex_destroy_t*)method_address);
    method((lucy_PolyLexicon*)self);
}

extern size_t Lucy_PolyLex_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLex_Equals(const lucy_PolyLexicon *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyLex_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyLex_Compare_To(const lucy_PolyLexicon *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyLex_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyLex_Hash_Sum(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyLex_Get_VTable(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyLex_Get_Class_Name(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLex_Is_A(const lucy_PolyLexicon *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyLex_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyLex_To_String(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyLex_To_I64(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyLex_To_F64(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLex_To_Bool(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyLex_Serialize(const lucy_PolyLexicon *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyLex_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Deserialize(const lucy_PolyLexicon *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyLex_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Dump(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyLex_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Load(const lucy_PolyLexicon *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolyLex_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyLex_Mimic(const lucy_PolyLexicon *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyLex_Seek_OFFSET;
static CHY_INLINE void
Lucy_PolyLex_Seek(const lucy_PolyLexicon *self, lucy_Obj* target) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Seek_OFFSET;
    const lucy_PolyLex_seek_t method = *((lucy_PolyLex_seek_t*)method_address);
    method((lucy_PolyLexicon*)self, target);
}

extern size_t Lucy_PolyLex_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyLex_Next(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Next_OFFSET;
    const lucy_PolyLex_next_t method = *((lucy_PolyLex_next_t*)method_address);
    return method((lucy_PolyLexicon*)self);
}

extern size_t Lucy_PolyLex_Reset_OFFSET;
static CHY_INLINE void
Lucy_PolyLex_Reset(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Reset_OFFSET;
    const lucy_PolyLex_reset_t method = *((lucy_PolyLex_reset_t*)method_address);
    method((lucy_PolyLexicon*)self);
}

extern size_t Lucy_PolyLex_Doc_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyLex_Doc_Freq(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Doc_Freq_OFFSET;
    const lucy_Lex_doc_freq_t method = *((lucy_Lex_doc_freq_t*)method_address);
    return method((lucy_Lexicon*)self);
}

extern size_t Lucy_PolyLex_Get_Term_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyLex_Get_Term(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Get_Term_OFFSET;
    const lucy_PolyLex_get_term_t method = *((lucy_PolyLex_get_term_t*)method_address);
    return method((lucy_PolyLexicon*)self);
}

extern size_t Lucy_PolyLex_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyLex_Get_Field(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Get_Field_OFFSET;
    const lucy_Lex_get_field_t method = *((lucy_Lex_get_field_t*)method_address);
    return method((lucy_Lexicon*)self);
}

extern size_t Lucy_PolyLex_Get_Num_Seg_Lexicons_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyLex_Get_Num_Seg_Lexicons(const lucy_PolyLexicon *self) {
    char *const method_address = *(char**)self + Lucy_PolyLex_Get_Num_Seg_Lexicons_OFFSET;
    const lucy_PolyLex_get_num_seg_lexicons_t method = *((lucy_PolyLex_get_num_seg_lexicons_t*)method_address);
    return method((lucy_PolyLexicon*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYLEXICON_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_POLYLEXICON_VT;
extern struct LUCY_POLYLEXICON_VT LUCY_POLYLEXICON_vt;
#define LUCY_POLYLEXICON ((cfish_VTable*)&LUCY_POLYLEXICON_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyLexicon lucy_PolyLexicon
  #define POLYLEXICON LUCY_POLYLEXICON
  #define PolyLex_new lucy_PolyLex_new
  #define PolyLex_init lucy_PolyLex_init
  #define PolyLex_destroy_t lucy_PolyLex_destroy_t
  #define PolyLex_destroy lucy_PolyLex_destroy
  #define PolyLex_seek_t lucy_PolyLex_seek_t
  #define PolyLex_seek lucy_PolyLex_seek
  #define PolyLex_next_t lucy_PolyLex_next_t
  #define PolyLex_next lucy_PolyLex_next
  #define PolyLex_reset_t lucy_PolyLex_reset_t
  #define PolyLex_reset lucy_PolyLex_reset
  #define PolyLex_get_term_t lucy_PolyLex_get_term_t
  #define PolyLex_get_term lucy_PolyLex_get_term
  #define PolyLex_get_num_seg_lexicons_t lucy_PolyLex_get_num_seg_lexicons_t
  #define PolyLex_get_num_seg_lexicons lucy_PolyLex_get_num_seg_lexicons
  #define PolyLex_Make Lucy_PolyLex_Make
  #define PolyLex_Get_RefCount Lucy_PolyLex_Get_RefCount
  #define PolyLex_Inc_RefCount Lucy_PolyLex_Inc_RefCount
  #define PolyLex_Dec_RefCount Lucy_PolyLex_Dec_RefCount
  #define PolyLex_To_Host Lucy_PolyLex_To_Host
  #define PolyLex_Clone Lucy_PolyLex_Clone
  #define PolyLex_Destroy Lucy_PolyLex_Destroy
  #define PolyLex_Equals Lucy_PolyLex_Equals
  #define PolyLex_Compare_To Lucy_PolyLex_Compare_To
  #define PolyLex_Hash_Sum Lucy_PolyLex_Hash_Sum
  #define PolyLex_Get_VTable Lucy_PolyLex_Get_VTable
  #define PolyLex_Get_Class_Name Lucy_PolyLex_Get_Class_Name
  #define PolyLex_Is_A Lucy_PolyLex_Is_A
  #define PolyLex_To_String Lucy_PolyLex_To_String
  #define PolyLex_To_I64 Lucy_PolyLex_To_I64
  #define PolyLex_To_F64 Lucy_PolyLex_To_F64
  #define PolyLex_To_Bool Lucy_PolyLex_To_Bool
  #define PolyLex_Serialize Lucy_PolyLex_Serialize
  #define PolyLex_Deserialize Lucy_PolyLex_Deserialize
  #define PolyLex_Dump Lucy_PolyLex_Dump
  #define PolyLex_Load Lucy_PolyLex_Load
  #define PolyLex_Mimic Lucy_PolyLex_Mimic
  #define PolyLex_Seek Lucy_PolyLex_Seek
  #define PolyLex_Next Lucy_PolyLex_Next
  #define PolyLex_Reset Lucy_PolyLex_Reset
  #define PolyLex_Doc_Freq Lucy_PolyLex_Doc_Freq
  #define PolyLex_Get_Term Lucy_PolyLex_Get_Term
  #define PolyLex_Get_Field Lucy_PolyLex_Get_Field
  #define PolyLex_Get_Num_Seg_Lexicons Lucy_PolyLex_Get_Num_Seg_Lexicons
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/PriorityQueue.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGLEXQUEUE
struct lucy_SegLexQueue {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t size;
    uint32_t max_size;
    lucy_Obj** heap;
};

#endif /* C_LUCY_SEGLEXQUEUE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SegLexQueue*
lucy_SegLexQ_new(uint32_t max_size);

chy_bool_t
lucy_SegLexQ_less_than(lucy_SegLexQueue* self, lucy_Obj* a, lucy_Obj* b);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_SegLexQ_less_than_t)(lucy_SegLexQueue* self, lucy_Obj* a, lucy_Obj* b);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SegLexQ_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Make(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegLexQ_Get_RefCount(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Inc_RefCount(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegLexQ_Dec_RefCount(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SegLexQ_To_Host(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Clone(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SegLexQ_Destroy(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Destroy_OFFSET;
    const lucy_PriQ_destroy_t method = *((lucy_PriQ_destroy_t*)method_address);
    method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_SegLexQ_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLexQ_Equals(const lucy_SegLexQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegLexQ_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SegLexQ_Compare_To(const lucy_SegLexQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegLexQ_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SegLexQ_Hash_Sum(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SegLexQ_Get_VTable(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegLexQ_Get_Class_Name(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLexQ_Is_A(const lucy_SegLexQueue *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SegLexQ_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegLexQ_To_String(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SegLexQ_To_I64(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SegLexQ_To_F64(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLexQ_To_Bool(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SegLexQ_Serialize(const lucy_SegLexQueue *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SegLexQ_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Deserialize(const lucy_SegLexQueue *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SegLexQ_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Dump(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLexQ_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Load(const lucy_SegLexQueue *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SegLexQ_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SegLexQ_Mimic(const lucy_SegLexQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegLexQ_Less_Than_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLexQ_Less_Than(const lucy_SegLexQueue *self, lucy_Obj* a, lucy_Obj* b) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Less_Than_OFFSET;
    const lucy_SegLexQ_less_than_t method = *((lucy_SegLexQ_less_than_t*)method_address);
    return method((lucy_SegLexQueue*)self, a, b);
}

extern size_t Lucy_SegLexQ_Insert_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLexQ_Insert(const lucy_SegLexQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Insert_OFFSET;
    const lucy_PriQ_insert_t method = *((lucy_PriQ_insert_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_SegLexQ_Jostle_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Jostle(const lucy_SegLexQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Jostle_OFFSET;
    const lucy_PriQ_jostle_t method = *((lucy_PriQ_jostle_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_SegLexQ_Pop_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Pop(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Pop_OFFSET;
    const lucy_PriQ_pop_t method = *((lucy_PriQ_pop_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_SegLexQ_Pop_All_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SegLexQ_Pop_All(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Pop_All_OFFSET;
    const lucy_PriQ_pop_all_t method = *((lucy_PriQ_pop_all_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_SegLexQ_Peek_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLexQ_Peek(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Peek_OFFSET;
    const lucy_PriQ_peek_t method = *((lucy_PriQ_peek_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_SegLexQ_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegLexQ_Get_Size(const lucy_SegLexQueue *self) {
    char *const method_address = *(char**)self + Lucy_SegLexQ_Get_Size_OFFSET;
    const lucy_PriQ_get_size_t method = *((lucy_PriQ_get_size_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEGLEXQUEUE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_SEGLEXQUEUE_VT;
extern struct LUCY_SEGLEXQUEUE_VT LUCY_SEGLEXQUEUE_vt;
#define LUCY_SEGLEXQUEUE ((cfish_VTable*)&LUCY_SEGLEXQUEUE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SegLexQueue lucy_SegLexQueue
  #define SEGLEXQUEUE LUCY_SEGLEXQUEUE
  #define SegLexQ_new lucy_SegLexQ_new
  #define SegLexQ_less_than_t lucy_SegLexQ_less_than_t
  #define SegLexQ_less_than lucy_SegLexQ_less_than
  #define SegLexQ_Make Lucy_SegLexQ_Make
  #define SegLexQ_Get_RefCount Lucy_SegLexQ_Get_RefCount
  #define SegLexQ_Inc_RefCount Lucy_SegLexQ_Inc_RefCount
  #define SegLexQ_Dec_RefCount Lucy_SegLexQ_Dec_RefCount
  #define SegLexQ_To_Host Lucy_SegLexQ_To_Host
  #define SegLexQ_Clone Lucy_SegLexQ_Clone
  #define SegLexQ_Destroy Lucy_SegLexQ_Destroy
  #define SegLexQ_Equals Lucy_SegLexQ_Equals
  #define SegLexQ_Compare_To Lucy_SegLexQ_Compare_To
  #define SegLexQ_Hash_Sum Lucy_SegLexQ_Hash_Sum
  #define SegLexQ_Get_VTable Lucy_SegLexQ_Get_VTable
  #define SegLexQ_Get_Class_Name Lucy_SegLexQ_Get_Class_Name
  #define SegLexQ_Is_A Lucy_SegLexQ_Is_A
  #define SegLexQ_To_String Lucy_SegLexQ_To_String
  #define SegLexQ_To_I64 Lucy_SegLexQ_To_I64
  #define SegLexQ_To_F64 Lucy_SegLexQ_To_F64
  #define SegLexQ_To_Bool Lucy_SegLexQ_To_Bool
  #define SegLexQ_Serialize Lucy_SegLexQ_Serialize
  #define SegLexQ_Deserialize Lucy_SegLexQ_Deserialize
  #define SegLexQ_Dump Lucy_SegLexQ_Dump
  #define SegLexQ_Load Lucy_SegLexQ_Load
  #define SegLexQ_Mimic Lucy_SegLexQ_Mimic
  #define SegLexQ_Less_Than Lucy_SegLexQ_Less_Than
  #define SegLexQ_Insert Lucy_SegLexQ_Insert
  #define SegLexQ_Jostle Lucy_SegLexQ_Jostle
  #define SegLexQ_Pop Lucy_SegLexQ_Pop
  #define SegLexQ_Pop_All Lucy_SegLexQ_Pop_All
  #define SegLexQ_Peek Lucy_SegLexQ_Peek
  #define SegLexQ_Get_Size Lucy_SegLexQ_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POLYLEXICON */




