/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POLYREADER
#define H_LUCY_INDEX_POLYREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/IndexReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYREADER
struct lucy_PolyReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_Hash* components;
    lucy_IndexManager* manager;
    lucy_Lock* read_lock;
    lucy_Lock* deletion_lock;
    lucy_VArray* sub_readers;
    int32_t doc_max;
    int32_t del_count;
    lucy_I32Array* offsets;
};

#endif /* C_LUCY_POLYREADER */

/* Declare this class's inert variables.
 */

extern lucy_CharBuf* lucy_PolyReader_race_condition_debug1;
extern int32_t lucy_PolyReader_debug1_num_passes;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolyReader*
lucy_PolyReader_open(lucy_Obj* index, lucy_Snapshot* snapshot, lucy_IndexManager* manager);

lucy_PolyReader*
lucy_PolyReader_do_open(lucy_PolyReader* self, lucy_Obj* index, lucy_Snapshot* snapshot, lucy_IndexManager* manager);

lucy_PolyReader*
lucy_PolyReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_IndexManager* manager, lucy_VArray* sub_readers);

lucy_PolyReader*
lucy_PolyReader_init(lucy_PolyReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_IndexManager* manager, lucy_VArray* sub_readers);

lucy_CharBuf*
lucy_PolyReader_try_read_snapshot(lucy_Snapshot* snapshot, lucy_Folder* folder, const lucy_CharBuf* path);

uint32_t
lucy_PolyReader_sub_tick(lucy_I32Array* offsets, int32_t doc_id);

void
lucy_PolyReader_destroy(lucy_PolyReader* self);

void
lucy_PolyReader_close(lucy_PolyReader* self);

int32_t
lucy_PolyReader_doc_max(lucy_PolyReader* self);

int32_t
lucy_PolyReader_doc_count(lucy_PolyReader* self);

int32_t
lucy_PolyReader_del_count(lucy_PolyReader* self);

lucy_I32Array*
lucy_PolyReader_offsets(lucy_PolyReader* self);

lucy_VArray*
lucy_PolyReader_seg_readers(lucy_PolyReader* self);

lucy_Obj*
lucy_PolyReader_try_open_segreaders(lucy_PolyReader* self, lucy_VArray* segments);

lucy_VArray*
lucy_PolyReader_get_seg_readers(lucy_PolyReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolyReader_destroy_CALLBACK;
extern cfish_Callback lucy_PolyReader_close_CALLBACK;
extern cfish_Callback lucy_PolyReader_doc_max_CALLBACK;
extern cfish_Callback lucy_PolyReader_doc_count_CALLBACK;
extern cfish_Callback lucy_PolyReader_del_count_CALLBACK;
extern cfish_Callback lucy_PolyReader_offsets_CALLBACK;
extern cfish_Callback lucy_PolyReader_seg_readers_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolyReader_destroy_t)(lucy_PolyReader* self);

typedef void
(*lucy_PolyReader_close_t)(lucy_PolyReader* self);

typedef int32_t
(*lucy_PolyReader_doc_max_t)(lucy_PolyReader* self);

typedef int32_t
(*lucy_PolyReader_doc_count_t)(lucy_PolyReader* self);

typedef int32_t
(*lucy_PolyReader_del_count_t)(lucy_PolyReader* self);

typedef lucy_I32Array*
(*lucy_PolyReader_offsets_t)(lucy_PolyReader* self);

typedef lucy_VArray*
(*lucy_PolyReader_seg_readers_t)(lucy_PolyReader* self);

typedef lucy_Obj*
(*lucy_PolyReader_try_open_segreaders_t)(lucy_PolyReader* self, lucy_VArray* segments);

typedef lucy_VArray*
(*lucy_PolyReader_get_seg_readers_t)(lucy_PolyReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolyReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Make(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyReader_Get_RefCount(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Inc_RefCount(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolyReader_Dec_RefCount(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolyReader_To_Host(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Clone(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolyReader_Destroy(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Destroy_OFFSET;
    const lucy_PolyReader_destroy_t method = *((lucy_PolyReader_destroy_t*)method_address);
    method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyReader_Equals(const lucy_PolyReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyReader_Compare_To(const lucy_PolyReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyReader_Hash_Sum(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolyReader_Get_VTable(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyReader_Get_Class_Name(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyReader_Is_A(const lucy_PolyReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolyReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolyReader_To_String(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolyReader_To_I64(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolyReader_To_F64(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolyReader_To_Bool(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolyReader_Serialize(const lucy_PolyReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolyReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Deserialize(const lucy_PolyReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolyReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Dump(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolyReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Load(const lucy_PolyReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolyReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolyReader_Mimic(const lucy_PolyReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolyReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_PolyReader_Aggregator(const lucy_PolyReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Aggregator_OFFSET;
    const lucy_DataReader_aggregator_t method = *((lucy_DataReader_aggregator_t*)method_address);
    return method((lucy_DataReader*)self, readers, offsets);
}

extern size_t Lucy_PolyReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PolyReader_Get_Schema(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PolyReader_Get_Folder(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PolyReader_Get_Snapshot(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyReader_Get_Segments(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PolyReader_Get_Segment(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyReader_Get_Seg_Tick(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PolyReader_Close_OFFSET;
static CHY_INLINE void
Lucy_PolyReader_Close(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Close_OFFSET;
    const lucy_PolyReader_close_t method = *((lucy_PolyReader_close_t*)method_address);
    method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Doc_Max_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyReader_Doc_Max(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Doc_Max_OFFSET;
    const lucy_PolyReader_doc_max_t method = *((lucy_PolyReader_doc_max_t*)method_address);
    return method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Doc_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyReader_Doc_Count(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Doc_Count_OFFSET;
    const lucy_PolyReader_doc_count_t method = *((lucy_PolyReader_doc_count_t*)method_address);
    return method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_PolyReader_Del_Count(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Del_Count_OFFSET;
    const lucy_PolyReader_del_count_t method = *((lucy_PolyReader_del_count_t*)method_address);
    return method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Offsets_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_PolyReader_Offsets(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Offsets_OFFSET;
    const lucy_PolyReader_offsets_t method = *((lucy_PolyReader_offsets_t*)method_address);
    return method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Seg_Readers_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyReader_Seg_Readers(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Seg_Readers_OFFSET;
    const lucy_PolyReader_seg_readers_t method = *((lucy_PolyReader_seg_readers_t*)method_address);
    return method((lucy_PolyReader*)self);
}

extern size_t Lucy_PolyReader_Obtain_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_PolyReader_Obtain(const lucy_PolyReader *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Obtain_OFFSET;
    const lucy_IxReader_obtain_t method = *((lucy_IxReader_obtain_t*)method_address);
    return method((lucy_IndexReader*)self, api);
}

extern size_t Lucy_PolyReader_Fetch_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_PolyReader_Fetch(const lucy_PolyReader *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Fetch_OFFSET;
    const lucy_IxReader_fetch_t method = *((lucy_IxReader_fetch_t*)method_address);
    return method((lucy_IndexReader*)self, api);
}

extern size_t Lucy_PolyReader_Get_Components_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_PolyReader_Get_Components(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Components_OFFSET;
    const lucy_IxReader_get_components_t method = *((lucy_IxReader_get_components_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_PolyReader_Try_Open_SegReaders_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolyReader_Try_Open_SegReaders(const lucy_PolyReader *self, lucy_VArray* segments) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Try_Open_SegReaders_OFFSET;
    const lucy_PolyReader_try_open_segreaders_t method = *((lucy_PolyReader_try_open_segreaders_t*)method_address);
    return method((lucy_PolyReader*)self, segments);
}

extern size_t Lucy_PolyReader_Get_Seg_Readers_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PolyReader_Get_Seg_Readers(const lucy_PolyReader *self) {
    char *const method_address = *(char**)self + Lucy_PolyReader_Get_Seg_Readers_OFFSET;
    const lucy_PolyReader_get_seg_readers_t method = *((lucy_PolyReader_get_seg_readers_t*)method_address);
    return method((lucy_PolyReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[40];
} LUCY_POLYREADER_VT;
extern struct LUCY_POLYREADER_VT LUCY_POLYREADER_vt;
#define LUCY_POLYREADER ((cfish_VTable*)&LUCY_POLYREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyReader lucy_PolyReader
  #define POLYREADER LUCY_POLYREADER
  #define PolyReader_open lucy_PolyReader_open
  #define PolyReader_do_open lucy_PolyReader_do_open
  #define PolyReader_new lucy_PolyReader_new
  #define PolyReader_init lucy_PolyReader_init
  #define PolyReader_try_read_snapshot lucy_PolyReader_try_read_snapshot
  #define PolyReader_sub_tick lucy_PolyReader_sub_tick
  #define PolyReader_race_condition_debug1 lucy_PolyReader_race_condition_debug1
  #define PolyReader_debug1_num_passes lucy_PolyReader_debug1_num_passes
  #define PolyReader_destroy_t lucy_PolyReader_destroy_t
  #define PolyReader_destroy lucy_PolyReader_destroy
  #define PolyReader_close_t lucy_PolyReader_close_t
  #define PolyReader_close lucy_PolyReader_close
  #define PolyReader_doc_max_t lucy_PolyReader_doc_max_t
  #define PolyReader_doc_max lucy_PolyReader_doc_max
  #define PolyReader_doc_count_t lucy_PolyReader_doc_count_t
  #define PolyReader_doc_count lucy_PolyReader_doc_count
  #define PolyReader_del_count_t lucy_PolyReader_del_count_t
  #define PolyReader_del_count lucy_PolyReader_del_count
  #define PolyReader_offsets_t lucy_PolyReader_offsets_t
  #define PolyReader_offsets lucy_PolyReader_offsets
  #define PolyReader_seg_readers_t lucy_PolyReader_seg_readers_t
  #define PolyReader_seg_readers lucy_PolyReader_seg_readers
  #define PolyReader_try_open_segreaders_t lucy_PolyReader_try_open_segreaders_t
  #define PolyReader_try_open_segreaders lucy_PolyReader_try_open_segreaders
  #define PolyReader_get_seg_readers_t lucy_PolyReader_get_seg_readers_t
  #define PolyReader_get_seg_readers lucy_PolyReader_get_seg_readers
  #define PolyReader_Make Lucy_PolyReader_Make
  #define PolyReader_Get_RefCount Lucy_PolyReader_Get_RefCount
  #define PolyReader_Inc_RefCount Lucy_PolyReader_Inc_RefCount
  #define PolyReader_Dec_RefCount Lucy_PolyReader_Dec_RefCount
  #define PolyReader_To_Host Lucy_PolyReader_To_Host
  #define PolyReader_Clone Lucy_PolyReader_Clone
  #define PolyReader_Destroy Lucy_PolyReader_Destroy
  #define PolyReader_Equals Lucy_PolyReader_Equals
  #define PolyReader_Compare_To Lucy_PolyReader_Compare_To
  #define PolyReader_Hash_Sum Lucy_PolyReader_Hash_Sum
  #define PolyReader_Get_VTable Lucy_PolyReader_Get_VTable
  #define PolyReader_Get_Class_Name Lucy_PolyReader_Get_Class_Name
  #define PolyReader_Is_A Lucy_PolyReader_Is_A
  #define PolyReader_To_String Lucy_PolyReader_To_String
  #define PolyReader_To_I64 Lucy_PolyReader_To_I64
  #define PolyReader_To_F64 Lucy_PolyReader_To_F64
  #define PolyReader_To_Bool Lucy_PolyReader_To_Bool
  #define PolyReader_Serialize Lucy_PolyReader_Serialize
  #define PolyReader_Deserialize Lucy_PolyReader_Deserialize
  #define PolyReader_Dump Lucy_PolyReader_Dump
  #define PolyReader_Load Lucy_PolyReader_Load
  #define PolyReader_Mimic Lucy_PolyReader_Mimic
  #define PolyReader_Aggregator Lucy_PolyReader_Aggregator
  #define PolyReader_Get_Schema Lucy_PolyReader_Get_Schema
  #define PolyReader_Get_Folder Lucy_PolyReader_Get_Folder
  #define PolyReader_Get_Snapshot Lucy_PolyReader_Get_Snapshot
  #define PolyReader_Get_Segments Lucy_PolyReader_Get_Segments
  #define PolyReader_Get_Segment Lucy_PolyReader_Get_Segment
  #define PolyReader_Get_Seg_Tick Lucy_PolyReader_Get_Seg_Tick
  #define PolyReader_Close Lucy_PolyReader_Close
  #define PolyReader_Doc_Max Lucy_PolyReader_Doc_Max
  #define PolyReader_Doc_Count Lucy_PolyReader_Doc_Count
  #define PolyReader_Del_Count Lucy_PolyReader_Del_Count
  #define PolyReader_Offsets Lucy_PolyReader_Offsets
  #define PolyReader_Seg_Readers Lucy_PolyReader_Seg_Readers
  #define PolyReader_Obtain Lucy_PolyReader_Obtain
  #define PolyReader_Fetch Lucy_PolyReader_Fetch
  #define PolyReader_Get_Components Lucy_PolyReader_Get_Components
  #define PolyReader_Try_Open_SegReaders Lucy_PolyReader_Try_Open_SegReaders
  #define PolyReader_Get_Seg_Readers Lucy_PolyReader_Get_Seg_Readers
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POLYREADER */




