/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTING
#define H_LUCY_INDEX_POSTING 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/Stepper.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTING
struct lucy_Posting {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
};

#endif /* C_LUCY_POSTING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Posting*
lucy_Post_init(lucy_Posting* self);

lucy_RawPosting*
lucy_Post_read_raw(lucy_Posting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

void
lucy_Post_add_inversion_to_pool(lucy_Posting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

void
lucy_Post_set_doc_id(lucy_Posting* self, int32_t doc_id);

int32_t
lucy_Post_get_doc_id(lucy_Posting* self);

lucy_Matcher*
lucy_Post_make_matcher(lucy_Posting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Post_read_raw_CALLBACK;
extern cfish_Callback lucy_Post_add_inversion_to_pool_CALLBACK;
extern cfish_Callback lucy_Post_set_doc_id_CALLBACK;
extern cfish_Callback lucy_Post_get_doc_id_CALLBACK;
extern cfish_Callback lucy_Post_make_matcher_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_RawPosting*
(*lucy_Post_read_raw_t)(lucy_Posting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

typedef void
(*lucy_Post_add_inversion_to_pool_t)(lucy_Posting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

typedef void
(*lucy_Post_set_doc_id_t)(lucy_Posting* self, int32_t doc_id);

typedef int32_t
(*lucy_Post_get_doc_id_t)(lucy_Posting* self);

typedef lucy_Matcher*
(*lucy_Post_make_matcher_t)(lucy_Posting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Post_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Post_Make(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Post_Get_RefCount(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Post_Inc_RefCount(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Post_Dec_RefCount(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Post_To_Host(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Post_Clone(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Post_Destroy(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Post_Equals(const lucy_Posting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Post_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Post_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Post_Compare_To(const lucy_Posting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Post_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Post_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Post_Hash_Sum(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Post_Get_VTable(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Post_Get_Class_Name(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Post_Is_A(const lucy_Posting *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Post_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Post_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Post_To_String(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Post_To_I64(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Post_To_F64(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Post_To_Bool(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Post_Serialize(const lucy_Posting *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Post_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Post_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Post_Deserialize(const lucy_Posting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Post_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Post_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Post_Dump(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Post_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Post_Load(const lucy_Posting *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Post_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Post_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Post_Mimic(const lucy_Posting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Post_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Post_Reset_OFFSET;
static CHY_INLINE void
Lucy_Post_Reset(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Reset_OFFSET;
    const lucy_Stepper_reset_t method = *((lucy_Stepper_reset_t*)method_address);
    method((lucy_Stepper*)self);
}

extern size_t Lucy_Post_Write_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_Post_Write_Key_Frame(const lucy_Posting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_Post_Write_Key_Frame_OFFSET;
    const lucy_Stepper_write_key_frame_t method = *((lucy_Stepper_write_key_frame_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_Post_Write_Delta_OFFSET;
static CHY_INLINE void
Lucy_Post_Write_Delta(const lucy_Posting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_Post_Write_Delta_OFFSET;
    const lucy_Stepper_write_delta_t method = *((lucy_Stepper_write_delta_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_Post_Read_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_Post_Read_Key_Frame(const lucy_Posting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Post_Read_Key_Frame_OFFSET;
    const lucy_Stepper_read_key_frame_t method = *((lucy_Stepper_read_key_frame_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_Post_Read_Delta_OFFSET;
static CHY_INLINE void
Lucy_Post_Read_Delta(const lucy_Posting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Post_Read_Delta_OFFSET;
    const lucy_Stepper_read_delta_t method = *((lucy_Stepper_read_delta_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_Post_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_Post_Read_Record(const lucy_Posting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Post_Read_Record_OFFSET;
    const lucy_Stepper_read_record_t method = *((lucy_Stepper_read_record_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_Post_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_Post_Read_Raw(const lucy_Posting *self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_Post_Read_Raw_OFFSET;
    const lucy_Post_read_raw_t method = *((lucy_Post_read_raw_t*)method_address);
    return method((lucy_Posting*)self, instream, last_doc_id, term_text, mem_pool);
}

extern size_t Lucy_Post_Add_Inversion_To_Pool_OFFSET;
static CHY_INLINE void
Lucy_Post_Add_Inversion_To_Pool(const lucy_Posting *self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm) {
    char *const method_address = *(char**)self + Lucy_Post_Add_Inversion_To_Pool_OFFSET;
    const lucy_Post_add_inversion_to_pool_t method = *((lucy_Post_add_inversion_to_pool_t*)method_address);
    method((lucy_Posting*)self, post_pool, inversion, type, doc_id, doc_boost, length_norm);
}

extern size_t Lucy_Post_Set_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_Post_Set_Doc_ID(const lucy_Posting *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_Post_Set_Doc_ID_OFFSET;
    const lucy_Post_set_doc_id_t method = *((lucy_Post_set_doc_id_t*)method_address);
    method((lucy_Posting*)self, doc_id);
}

extern size_t Lucy_Post_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_Post_Get_Doc_ID(const lucy_Posting *self) {
    char *const method_address = *(char**)self + Lucy_Post_Get_Doc_ID_OFFSET;
    const lucy_Post_get_doc_id_t method = *((lucy_Post_get_doc_id_t*)method_address);
    return method((lucy_Posting*)self);
}

extern size_t Lucy_Post_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_Post_Make_Matcher(const lucy_Posting *self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_Post_Make_Matcher_OFFSET;
    const lucy_Post_make_matcher_t method = *((lucy_Post_make_matcher_t*)method_address);
    return method((lucy_Posting*)self, sim, plist, compiler, need_score);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POSTING_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_POSTING_VT;
extern struct LUCY_POSTING_VT LUCY_POSTING_vt;
#define LUCY_POSTING ((cfish_VTable*)&LUCY_POSTING_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Posting lucy_Posting
  #define POSTING LUCY_POSTING
  #define Post_init lucy_Post_init
  #define Post_read_raw_t lucy_Post_read_raw_t
  #define Post_read_raw lucy_Post_read_raw
  #define Post_add_inversion_to_pool_t lucy_Post_add_inversion_to_pool_t
  #define Post_add_inversion_to_pool lucy_Post_add_inversion_to_pool
  #define Post_set_doc_id_t lucy_Post_set_doc_id_t
  #define Post_set_doc_id lucy_Post_set_doc_id
  #define Post_get_doc_id_t lucy_Post_get_doc_id_t
  #define Post_get_doc_id lucy_Post_get_doc_id
  #define Post_make_matcher_t lucy_Post_make_matcher_t
  #define Post_make_matcher lucy_Post_make_matcher
  #define Post_Make Lucy_Post_Make
  #define Post_Get_RefCount Lucy_Post_Get_RefCount
  #define Post_Inc_RefCount Lucy_Post_Inc_RefCount
  #define Post_Dec_RefCount Lucy_Post_Dec_RefCount
  #define Post_To_Host Lucy_Post_To_Host
  #define Post_Clone Lucy_Post_Clone
  #define Post_Destroy Lucy_Post_Destroy
  #define Post_Equals Lucy_Post_Equals
  #define Post_Compare_To Lucy_Post_Compare_To
  #define Post_Hash_Sum Lucy_Post_Hash_Sum
  #define Post_Get_VTable Lucy_Post_Get_VTable
  #define Post_Get_Class_Name Lucy_Post_Get_Class_Name
  #define Post_Is_A Lucy_Post_Is_A
  #define Post_To_String Lucy_Post_To_String
  #define Post_To_I64 Lucy_Post_To_I64
  #define Post_To_F64 Lucy_Post_To_F64
  #define Post_To_Bool Lucy_Post_To_Bool
  #define Post_Serialize Lucy_Post_Serialize
  #define Post_Deserialize Lucy_Post_Deserialize
  #define Post_Dump Lucy_Post_Dump
  #define Post_Load Lucy_Post_Load
  #define Post_Mimic Lucy_Post_Mimic
  #define Post_Reset Lucy_Post_Reset
  #define Post_Write_Key_Frame Lucy_Post_Write_Key_Frame
  #define Post_Write_Delta Lucy_Post_Write_Delta
  #define Post_Read_Key_Frame Lucy_Post_Read_Key_Frame
  #define Post_Read_Delta Lucy_Post_Read_Delta
  #define Post_Read_Record Lucy_Post_Read_Record
  #define Post_Read_Raw Lucy_Post_Read_Raw
  #define Post_Add_Inversion_To_Pool Lucy_Post_Add_Inversion_To_Pool
  #define Post_Set_Doc_ID Lucy_Post_Set_Doc_ID
  #define Post_Get_Doc_ID Lucy_Post_Get_Doc_ID
  #define Post_Make_Matcher Lucy_Post_Make_Matcher
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTINGWRITER
struct lucy_PostingWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    int32_t field_num;
};

#endif /* C_LUCY_POSTINGWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PostingWriter*
lucy_PostWriter_init(lucy_PostingWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, int32_t field_num);

void
lucy_PostWriter_write_posting(lucy_PostingWriter* self, lucy_RawPosting* posting);

void
lucy_PostWriter_start_term(lucy_PostingWriter* self, lucy_TermInfo* tinfo);

void
lucy_PostWriter_update_skip_info(lucy_PostingWriter* self, lucy_TermInfo* tinfo);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PostWriter_write_posting_CALLBACK;
extern cfish_Callback lucy_PostWriter_start_term_CALLBACK;
extern cfish_Callback lucy_PostWriter_update_skip_info_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PostWriter_write_posting_t)(lucy_PostingWriter* self, lucy_RawPosting* posting);

typedef void
(*lucy_PostWriter_start_term_t)(lucy_PostingWriter* self, lucy_TermInfo* tinfo);

typedef void
(*lucy_PostWriter_update_skip_info_t)(lucy_PostingWriter* self, lucy_TermInfo* tinfo);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PostWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostWriter_Make(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PostWriter_Get_RefCount(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostWriter_Inc_RefCount(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PostWriter_Dec_RefCount(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PostWriter_To_Host(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostWriter_Clone(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Destroy(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Destroy_OFFSET;
    const lucy_DataWriter_destroy_t method = *((lucy_DataWriter_destroy_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PostWriter_Equals(const lucy_PostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PostWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PostWriter_Compare_To(const lucy_PostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PostWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PostWriter_Hash_Sum(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PostWriter_Get_VTable(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PostWriter_Get_Class_Name(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PostWriter_Is_A(const lucy_PostingWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PostWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PostWriter_To_String(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PostWriter_To_I64(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PostWriter_To_F64(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PostWriter_To_Bool(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Serialize(const lucy_PostingWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PostWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostWriter_Deserialize(const lucy_PostingWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PostWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostWriter_Dump(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostWriter_Load(const lucy_PostingWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PostWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Mimic(const lucy_PostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PostWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Add_Inverted_Doc(const lucy_PostingWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_PostWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Add_Segment(const lucy_PostingWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Add_Segment_OFFSET;
    const lucy_DataWriter_add_segment_t method = *((lucy_DataWriter_add_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_PostWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Delete_Segment(const lucy_PostingWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_PostWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Merge_Segment(const lucy_PostingWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_PostWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Finish(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Finish_OFFSET;
    const lucy_DataWriter_finish_t method = *((lucy_DataWriter_finish_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_PostWriter_Metadata(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_PostWriter_Format(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Format_OFFSET;
    const lucy_DataWriter_format_t method = *((lucy_DataWriter_format_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PostWriter_Get_Snapshot(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PostWriter_Get_Segment(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_PostWriter_Get_PolyReader(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PostWriter_Get_Schema(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PostWriter_Get_Folder(const lucy_PostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PostWriter_Write_Posting_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Write_Posting(const lucy_PostingWriter *self, lucy_RawPosting* posting) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Write_Posting_OFFSET;
    const lucy_PostWriter_write_posting_t method = *((lucy_PostWriter_write_posting_t*)method_address);
    method((lucy_PostingWriter*)self, posting);
}

extern size_t Lucy_PostWriter_Start_Term_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Start_Term(const lucy_PostingWriter *self, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Start_Term_OFFSET;
    const lucy_PostWriter_start_term_t method = *((lucy_PostWriter_start_term_t*)method_address);
    method((lucy_PostingWriter*)self, tinfo);
}

extern size_t Lucy_PostWriter_Update_Skip_Info_OFFSET;
static CHY_INLINE void
Lucy_PostWriter_Update_Skip_Info(const lucy_PostingWriter *self, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_PostWriter_Update_Skip_Info_OFFSET;
    const lucy_PostWriter_update_skip_info_t method = *((lucy_PostWriter_update_skip_info_t*)method_address);
    method((lucy_PostingWriter*)self, tinfo);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POSTINGWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_POSTINGWRITER_VT;
extern struct LUCY_POSTINGWRITER_VT LUCY_POSTINGWRITER_vt;
#define LUCY_POSTINGWRITER ((cfish_VTable*)&LUCY_POSTINGWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PostingWriter lucy_PostingWriter
  #define POSTINGWRITER LUCY_POSTINGWRITER
  #define PostWriter_init lucy_PostWriter_init
  #define PostWriter_write_posting_t lucy_PostWriter_write_posting_t
  #define PostWriter_write_posting lucy_PostWriter_write_posting
  #define PostWriter_start_term_t lucy_PostWriter_start_term_t
  #define PostWriter_start_term lucy_PostWriter_start_term
  #define PostWriter_update_skip_info_t lucy_PostWriter_update_skip_info_t
  #define PostWriter_update_skip_info lucy_PostWriter_update_skip_info
  #define PostWriter_Make Lucy_PostWriter_Make
  #define PostWriter_Get_RefCount Lucy_PostWriter_Get_RefCount
  #define PostWriter_Inc_RefCount Lucy_PostWriter_Inc_RefCount
  #define PostWriter_Dec_RefCount Lucy_PostWriter_Dec_RefCount
  #define PostWriter_To_Host Lucy_PostWriter_To_Host
  #define PostWriter_Clone Lucy_PostWriter_Clone
  #define PostWriter_Destroy Lucy_PostWriter_Destroy
  #define PostWriter_Equals Lucy_PostWriter_Equals
  #define PostWriter_Compare_To Lucy_PostWriter_Compare_To
  #define PostWriter_Hash_Sum Lucy_PostWriter_Hash_Sum
  #define PostWriter_Get_VTable Lucy_PostWriter_Get_VTable
  #define PostWriter_Get_Class_Name Lucy_PostWriter_Get_Class_Name
  #define PostWriter_Is_A Lucy_PostWriter_Is_A
  #define PostWriter_To_String Lucy_PostWriter_To_String
  #define PostWriter_To_I64 Lucy_PostWriter_To_I64
  #define PostWriter_To_F64 Lucy_PostWriter_To_F64
  #define PostWriter_To_Bool Lucy_PostWriter_To_Bool
  #define PostWriter_Serialize Lucy_PostWriter_Serialize
  #define PostWriter_Deserialize Lucy_PostWriter_Deserialize
  #define PostWriter_Dump Lucy_PostWriter_Dump
  #define PostWriter_Load Lucy_PostWriter_Load
  #define PostWriter_Mimic Lucy_PostWriter_Mimic
  #define PostWriter_Add_Inverted_Doc Lucy_PostWriter_Add_Inverted_Doc
  #define PostWriter_Add_Segment Lucy_PostWriter_Add_Segment
  #define PostWriter_Delete_Segment Lucy_PostWriter_Delete_Segment
  #define PostWriter_Merge_Segment Lucy_PostWriter_Merge_Segment
  #define PostWriter_Finish Lucy_PostWriter_Finish
  #define PostWriter_Metadata Lucy_PostWriter_Metadata
  #define PostWriter_Format Lucy_PostWriter_Format
  #define PostWriter_Get_Snapshot Lucy_PostWriter_Get_Snapshot
  #define PostWriter_Get_Segment Lucy_PostWriter_Get_Segment
  #define PostWriter_Get_PolyReader Lucy_PostWriter_Get_PolyReader
  #define PostWriter_Get_Schema Lucy_PostWriter_Get_Schema
  #define PostWriter_Get_Folder Lucy_PostWriter_Get_Folder
  #define PostWriter_Write_Posting Lucy_PostWriter_Write_Posting
  #define PostWriter_Start_Term Lucy_PostWriter_Start_Term
  #define PostWriter_Update_Skip_Info Lucy_PostWriter_Update_Skip_Info
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTING */




