/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTING_MATCHPOSTING
#define H_LUCY_INDEX_POSTING_MATCHPOSTING 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_MATCHPOSTING
struct lucy_MatchPosting {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    lucy_Similarity* sim;
    uint32_t freq;
};

#endif /* C_LUCY_MATCHPOSTING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_MatchPosting*
lucy_MatchPost_new(lucy_Similarity* similarity);

lucy_MatchPosting*
lucy_MatchPost_init(lucy_MatchPosting* self, lucy_Similarity* similarity);

void
lucy_MatchPost_destroy(lucy_MatchPosting* self);

void
lucy_MatchPost_reset(lucy_MatchPosting* self);

void
lucy_MatchPost_read_record(lucy_MatchPosting* self, lucy_InStream* instream);

lucy_RawPosting*
lucy_MatchPost_read_raw(lucy_MatchPosting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

void
lucy_MatchPost_add_inversion_to_pool(lucy_MatchPosting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

lucy_MatchPostingMatcher*
lucy_MatchPost_make_matcher(lucy_MatchPosting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);

int32_t
lucy_MatchPost_get_freq(lucy_MatchPosting* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_MatchPost_destroy_CALLBACK;
extern cfish_Callback lucy_MatchPost_reset_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_MatchPost_destroy_t)(lucy_MatchPosting* self);

typedef void
(*lucy_MatchPost_reset_t)(lucy_MatchPosting* self);

typedef void
(*lucy_MatchPost_read_record_t)(lucy_MatchPosting* self, lucy_InStream* instream);

typedef lucy_RawPosting*
(*lucy_MatchPost_read_raw_t)(lucy_MatchPosting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

typedef void
(*lucy_MatchPost_add_inversion_to_pool_t)(lucy_MatchPosting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

typedef lucy_MatchPostingMatcher*
(*lucy_MatchPost_make_matcher_t)(lucy_MatchPosting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);

typedef int32_t
(*lucy_MatchPost_get_freq_t)(lucy_MatchPosting* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_MatchPost_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPost_Make(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchPost_Get_RefCount(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPost_Inc_RefCount(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchPost_Dec_RefCount(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_MatchPost_To_Host(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPost_Clone(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Destroy_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Destroy(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Destroy_OFFSET;
    const lucy_MatchPost_destroy_t method = *((lucy_MatchPost_destroy_t*)method_address);
    method((lucy_MatchPosting*)self);
}

extern size_t Lucy_MatchPost_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPost_Equals(const lucy_MatchPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPost_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPost_Compare_To(const lucy_MatchPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPost_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPost_Hash_Sum(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_MatchPost_Get_VTable(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchPost_Get_Class_Name(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPost_Is_A(const lucy_MatchPosting *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_MatchPost_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchPost_To_String(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_MatchPost_To_I64(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_To_F64_OFFSET;
static CHY_INLINE double
Lucy_MatchPost_To_F64(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPost_To_Bool(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Serialize_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Serialize(const lucy_MatchPosting *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_MatchPost_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPost_Deserialize(const lucy_MatchPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_MatchPost_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPost_Dump(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPost_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPost_Load(const lucy_MatchPosting *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_MatchPost_Mimic_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Mimic(const lucy_MatchPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPost_Reset_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Reset(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Reset_OFFSET;
    const lucy_MatchPost_reset_t method = *((lucy_MatchPost_reset_t*)method_address);
    method((lucy_MatchPosting*)self);
}

extern size_t Lucy_MatchPost_Write_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Write_Key_Frame(const lucy_MatchPosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Write_Key_Frame_OFFSET;
    const lucy_Stepper_write_key_frame_t method = *((lucy_Stepper_write_key_frame_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_MatchPost_Write_Delta_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Write_Delta(const lucy_MatchPosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Write_Delta_OFFSET;
    const lucy_Stepper_write_delta_t method = *((lucy_Stepper_write_delta_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_MatchPost_Read_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Read_Key_Frame(const lucy_MatchPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Read_Key_Frame_OFFSET;
    const lucy_Stepper_read_key_frame_t method = *((lucy_Stepper_read_key_frame_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_MatchPost_Read_Delta_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Read_Delta(const lucy_MatchPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Read_Delta_OFFSET;
    const lucy_Stepper_read_delta_t method = *((lucy_Stepper_read_delta_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_MatchPost_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Read_Record(const lucy_MatchPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Read_Record_OFFSET;
    const lucy_MatchPost_read_record_t method = *((lucy_MatchPost_read_record_t*)method_address);
    method((lucy_MatchPosting*)self, instream);
}

extern size_t Lucy_MatchPost_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_MatchPost_Read_Raw(const lucy_MatchPosting *self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Read_Raw_OFFSET;
    const lucy_MatchPost_read_raw_t method = *((lucy_MatchPost_read_raw_t*)method_address);
    return method((lucy_MatchPosting*)self, instream, last_doc_id, term_text, mem_pool);
}

extern size_t Lucy_MatchPost_Add_Inversion_To_Pool_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Add_Inversion_To_Pool(const lucy_MatchPosting *self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Add_Inversion_To_Pool_OFFSET;
    const lucy_MatchPost_add_inversion_to_pool_t method = *((lucy_MatchPost_add_inversion_to_pool_t*)method_address);
    method((lucy_MatchPosting*)self, post_pool, inversion, type, doc_id, doc_boost, length_norm);
}

extern size_t Lucy_MatchPost_Set_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_MatchPost_Set_Doc_ID(const lucy_MatchPosting *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Set_Doc_ID_OFFSET;
    const lucy_Post_set_doc_id_t method = *((lucy_Post_set_doc_id_t*)method_address);
    method((lucy_Posting*)self, doc_id);
}

extern size_t Lucy_MatchPost_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPost_Get_Doc_ID(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Get_Doc_ID_OFFSET;
    const lucy_Post_get_doc_id_t method = *((lucy_Post_get_doc_id_t*)method_address);
    return method((lucy_Posting*)self);
}

extern size_t Lucy_MatchPost_Make_Matcher_OFFSET;
static CHY_INLINE lucy_MatchPostingMatcher*
Lucy_MatchPost_Make_Matcher(const lucy_MatchPosting *self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Make_Matcher_OFFSET;
    const lucy_MatchPost_make_matcher_t method = *((lucy_MatchPost_make_matcher_t*)method_address);
    return method((lucy_MatchPosting*)self, sim, plist, compiler, need_score);
}

extern size_t Lucy_MatchPost_Get_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPost_Get_Freq(const lucy_MatchPosting *self) {
    char *const method_address = *(char**)self + Lucy_MatchPost_Get_Freq_OFFSET;
    const lucy_MatchPost_get_freq_t method = *((lucy_MatchPost_get_freq_t*)method_address);
    return method((lucy_MatchPosting*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_MATCHPOSTING_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[34];
} LUCY_MATCHPOSTING_VT;
extern struct LUCY_MATCHPOSTING_VT LUCY_MATCHPOSTING_vt;
#define LUCY_MATCHPOSTING ((cfish_VTable*)&LUCY_MATCHPOSTING_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define MatchPosting lucy_MatchPosting
  #define MATCHPOSTING LUCY_MATCHPOSTING
  #define MatchPost_new lucy_MatchPost_new
  #define MatchPost_init lucy_MatchPost_init
  #define MatchPost_destroy_t lucy_MatchPost_destroy_t
  #define MatchPost_destroy lucy_MatchPost_destroy
  #define MatchPost_reset_t lucy_MatchPost_reset_t
  #define MatchPost_reset lucy_MatchPost_reset
  #define MatchPost_read_record_t lucy_MatchPost_read_record_t
  #define MatchPost_read_record lucy_MatchPost_read_record
  #define MatchPost_read_raw_t lucy_MatchPost_read_raw_t
  #define MatchPost_read_raw lucy_MatchPost_read_raw
  #define MatchPost_add_inversion_to_pool_t lucy_MatchPost_add_inversion_to_pool_t
  #define MatchPost_add_inversion_to_pool lucy_MatchPost_add_inversion_to_pool
  #define MatchPost_make_matcher_t lucy_MatchPost_make_matcher_t
  #define MatchPost_make_matcher lucy_MatchPost_make_matcher
  #define MatchPost_get_freq_t lucy_MatchPost_get_freq_t
  #define MatchPost_get_freq lucy_MatchPost_get_freq
  #define MatchPost_Make Lucy_MatchPost_Make
  #define MatchPost_Get_RefCount Lucy_MatchPost_Get_RefCount
  #define MatchPost_Inc_RefCount Lucy_MatchPost_Inc_RefCount
  #define MatchPost_Dec_RefCount Lucy_MatchPost_Dec_RefCount
  #define MatchPost_To_Host Lucy_MatchPost_To_Host
  #define MatchPost_Clone Lucy_MatchPost_Clone
  #define MatchPost_Destroy Lucy_MatchPost_Destroy
  #define MatchPost_Equals Lucy_MatchPost_Equals
  #define MatchPost_Compare_To Lucy_MatchPost_Compare_To
  #define MatchPost_Hash_Sum Lucy_MatchPost_Hash_Sum
  #define MatchPost_Get_VTable Lucy_MatchPost_Get_VTable
  #define MatchPost_Get_Class_Name Lucy_MatchPost_Get_Class_Name
  #define MatchPost_Is_A Lucy_MatchPost_Is_A
  #define MatchPost_To_String Lucy_MatchPost_To_String
  #define MatchPost_To_I64 Lucy_MatchPost_To_I64
  #define MatchPost_To_F64 Lucy_MatchPost_To_F64
  #define MatchPost_To_Bool Lucy_MatchPost_To_Bool
  #define MatchPost_Serialize Lucy_MatchPost_Serialize
  #define MatchPost_Deserialize Lucy_MatchPost_Deserialize
  #define MatchPost_Dump Lucy_MatchPost_Dump
  #define MatchPost_Load Lucy_MatchPost_Load
  #define MatchPost_Mimic Lucy_MatchPost_Mimic
  #define MatchPost_Reset Lucy_MatchPost_Reset
  #define MatchPost_Write_Key_Frame Lucy_MatchPost_Write_Key_Frame
  #define MatchPost_Write_Delta Lucy_MatchPost_Write_Delta
  #define MatchPost_Read_Key_Frame Lucy_MatchPost_Read_Key_Frame
  #define MatchPost_Read_Delta Lucy_MatchPost_Read_Delta
  #define MatchPost_Read_Record Lucy_MatchPost_Read_Record
  #define MatchPost_Read_Raw Lucy_MatchPost_Read_Raw
  #define MatchPost_Add_Inversion_To_Pool Lucy_MatchPost_Add_Inversion_To_Pool
  #define MatchPost_Set_Doc_ID Lucy_MatchPost_Set_Doc_ID
  #define MatchPost_Get_Doc_ID Lucy_MatchPost_Get_Doc_ID
  #define MatchPost_Make_Matcher Lucy_MatchPost_Make_Matcher
  #define MatchPost_Get_Freq Lucy_MatchPost_Get_Freq
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/TermMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_MATCHPOSTINGMATCHER
struct lucy_MatchPostingMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float weight;
    lucy_Compiler* compiler;
    lucy_Similarity* sim;
    lucy_PostingList* plist;
    lucy_Posting* posting;
};

#endif /* C_LUCY_MATCHPOSTINGMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_MatchPostingMatcher*
lucy_MatchPostMatcher_init(lucy_MatchPostingMatcher* self, lucy_Similarity* similarity, lucy_PostingList* posting_list, lucy_Compiler* compiler);

float
lucy_MatchPostMatcher_score(lucy_MatchPostingMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_MatchPostMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef float
(*lucy_MatchPostMatcher_score_t)(lucy_MatchPostingMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_MatchPostMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostMatcher_Make(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchPostMatcher_Get_RefCount(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostMatcher_Inc_RefCount(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchPostMatcher_Dec_RefCount(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_MatchPostMatcher_To_Host(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostMatcher_Clone(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_MatchPostMatcher_Destroy(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Destroy_OFFSET;
    const lucy_TermMatcher_destroy_t method = *((lucy_TermMatcher_destroy_t*)method_address);
    method((lucy_TermMatcher*)self);
}

extern size_t Lucy_MatchPostMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPostMatcher_Equals(const lucy_MatchPostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPostMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostMatcher_Compare_To(const lucy_MatchPostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPostMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostMatcher_Hash_Sum(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_MatchPostMatcher_Get_VTable(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchPostMatcher_Get_Class_Name(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPostMatcher_Is_A(const lucy_MatchPostingMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_MatchPostMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchPostMatcher_To_String(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_MatchPostMatcher_To_I64(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_MatchPostMatcher_To_F64(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPostMatcher_To_Bool(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_MatchPostMatcher_Serialize(const lucy_MatchPostingMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_MatchPostMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostMatcher_Deserialize(const lucy_MatchPostingMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_MatchPostMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostMatcher_Dump(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostMatcher_Load(const lucy_MatchPostingMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_MatchPostMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_MatchPostMatcher_Mimic(const lucy_MatchPostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPostMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostMatcher_Next(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Next_OFFSET;
    const lucy_TermMatcher_next_t method = *((lucy_TermMatcher_next_t*)method_address);
    return method((lucy_TermMatcher*)self);
}

extern size_t Lucy_MatchPostMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostMatcher_Advance(const lucy_MatchPostingMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Advance_OFFSET;
    const lucy_TermMatcher_advance_t method = *((lucy_TermMatcher_advance_t*)method_address);
    return method((lucy_TermMatcher*)self, target);
}

extern size_t Lucy_MatchPostMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostMatcher_Get_Doc_ID(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Get_Doc_ID_OFFSET;
    const lucy_TermMatcher_get_doc_id_t method = *((lucy_TermMatcher_get_doc_id_t*)method_address);
    return method((lucy_TermMatcher*)self);
}

extern size_t Lucy_MatchPostMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_MatchPostMatcher_Score(const lucy_MatchPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Score_OFFSET;
    const lucy_MatchPostMatcher_score_t method = *((lucy_MatchPostMatcher_score_t*)method_address);
    return method((lucy_MatchPostingMatcher*)self);
}

extern size_t Lucy_MatchPostMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_MatchPostMatcher_Collect(const lucy_MatchPostingMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_MatchPostMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_MATCHPOSTINGMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_MATCHPOSTINGMATCHER_VT;
extern struct LUCY_MATCHPOSTINGMATCHER_VT LUCY_MATCHPOSTINGMATCHER_vt;
#define LUCY_MATCHPOSTINGMATCHER ((cfish_VTable*)&LUCY_MATCHPOSTINGMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define MatchPostingMatcher lucy_MatchPostingMatcher
  #define MATCHPOSTINGMATCHER LUCY_MATCHPOSTINGMATCHER
  #define MatchPostMatcher_init lucy_MatchPostMatcher_init
  #define MatchPostMatcher_score_t lucy_MatchPostMatcher_score_t
  #define MatchPostMatcher_score lucy_MatchPostMatcher_score
  #define MatchPostMatcher_Make Lucy_MatchPostMatcher_Make
  #define MatchPostMatcher_Get_RefCount Lucy_MatchPostMatcher_Get_RefCount
  #define MatchPostMatcher_Inc_RefCount Lucy_MatchPostMatcher_Inc_RefCount
  #define MatchPostMatcher_Dec_RefCount Lucy_MatchPostMatcher_Dec_RefCount
  #define MatchPostMatcher_To_Host Lucy_MatchPostMatcher_To_Host
  #define MatchPostMatcher_Clone Lucy_MatchPostMatcher_Clone
  #define MatchPostMatcher_Destroy Lucy_MatchPostMatcher_Destroy
  #define MatchPostMatcher_Equals Lucy_MatchPostMatcher_Equals
  #define MatchPostMatcher_Compare_To Lucy_MatchPostMatcher_Compare_To
  #define MatchPostMatcher_Hash_Sum Lucy_MatchPostMatcher_Hash_Sum
  #define MatchPostMatcher_Get_VTable Lucy_MatchPostMatcher_Get_VTable
  #define MatchPostMatcher_Get_Class_Name Lucy_MatchPostMatcher_Get_Class_Name
  #define MatchPostMatcher_Is_A Lucy_MatchPostMatcher_Is_A
  #define MatchPostMatcher_To_String Lucy_MatchPostMatcher_To_String
  #define MatchPostMatcher_To_I64 Lucy_MatchPostMatcher_To_I64
  #define MatchPostMatcher_To_F64 Lucy_MatchPostMatcher_To_F64
  #define MatchPostMatcher_To_Bool Lucy_MatchPostMatcher_To_Bool
  #define MatchPostMatcher_Serialize Lucy_MatchPostMatcher_Serialize
  #define MatchPostMatcher_Deserialize Lucy_MatchPostMatcher_Deserialize
  #define MatchPostMatcher_Dump Lucy_MatchPostMatcher_Dump
  #define MatchPostMatcher_Load Lucy_MatchPostMatcher_Load
  #define MatchPostMatcher_Mimic Lucy_MatchPostMatcher_Mimic
  #define MatchPostMatcher_Next Lucy_MatchPostMatcher_Next
  #define MatchPostMatcher_Advance Lucy_MatchPostMatcher_Advance
  #define MatchPostMatcher_Get_Doc_ID Lucy_MatchPostMatcher_Get_Doc_ID
  #define MatchPostMatcher_Score Lucy_MatchPostMatcher_Score
  #define MatchPostMatcher_Collect Lucy_MatchPostMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_MATCHPOSTINGWRITER
struct lucy_MatchPostingWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    int32_t field_num;
    lucy_OutStream* outstream;
    int32_t last_doc_id;
};

#endif /* C_LUCY_MATCHPOSTINGWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_MatchPostingWriter*
lucy_MatchPostWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, int32_t field_num);

lucy_MatchPostingWriter*
lucy_MatchPostWriter_init(lucy_MatchPostingWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, int32_t field_num);

void
lucy_MatchPostWriter_destroy(lucy_MatchPostingWriter* self);

void
lucy_MatchPostWriter_write_posting(lucy_MatchPostingWriter* self, lucy_RawPosting* posting);

void
lucy_MatchPostWriter_start_term(lucy_MatchPostingWriter* self, lucy_TermInfo* tinfo);

void
lucy_MatchPostWriter_update_skip_info(lucy_MatchPostingWriter* self, lucy_TermInfo* tinfo);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_MatchPostWriter_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_MatchPostWriter_destroy_t)(lucy_MatchPostingWriter* self);

typedef void
(*lucy_MatchPostWriter_write_posting_t)(lucy_MatchPostingWriter* self, lucy_RawPosting* posting);

typedef void
(*lucy_MatchPostWriter_start_term_t)(lucy_MatchPostingWriter* self, lucy_TermInfo* tinfo);

typedef void
(*lucy_MatchPostWriter_update_skip_info_t)(lucy_MatchPostingWriter* self, lucy_TermInfo* tinfo);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_MatchPostWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostWriter_Make(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchPostWriter_Get_RefCount(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostWriter_Inc_RefCount(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchPostWriter_Dec_RefCount(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_MatchPostWriter_To_Host(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostWriter_Clone(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Destroy(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Destroy_OFFSET;
    const lucy_MatchPostWriter_destroy_t method = *((lucy_MatchPostWriter_destroy_t*)method_address);
    method((lucy_MatchPostingWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPostWriter_Equals(const lucy_MatchPostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPostWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostWriter_Compare_To(const lucy_MatchPostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPostWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostWriter_Hash_Sum(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_MatchPostWriter_Get_VTable(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchPostWriter_Get_Class_Name(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPostWriter_Is_A(const lucy_MatchPostingWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_MatchPostWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchPostWriter_To_String(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_MatchPostWriter_To_I64(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_MatchPostWriter_To_F64(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchPostWriter_To_Bool(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Serialize(const lucy_MatchPostingWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_MatchPostWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostWriter_Deserialize(const lucy_MatchPostingWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_MatchPostWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostWriter_Dump(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchPostWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchPostWriter_Load(const lucy_MatchPostingWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_MatchPostWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Mimic(const lucy_MatchPostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchPostWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Add_Inverted_Doc(const lucy_MatchPostingWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_MatchPostWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Add_Segment(const lucy_MatchPostingWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Add_Segment_OFFSET;
    const lucy_DataWriter_add_segment_t method = *((lucy_DataWriter_add_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_MatchPostWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Delete_Segment(const lucy_MatchPostingWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_MatchPostWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Merge_Segment(const lucy_MatchPostingWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_MatchPostWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Finish(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Finish_OFFSET;
    const lucy_DataWriter_finish_t method = *((lucy_DataWriter_finish_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_MatchPostWriter_Metadata(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchPostWriter_Format(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Format_OFFSET;
    const lucy_DataWriter_format_t method = *((lucy_DataWriter_format_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_MatchPostWriter_Get_Snapshot(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_MatchPostWriter_Get_Segment(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_MatchPostWriter_Get_PolyReader(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_MatchPostWriter_Get_Schema(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_MatchPostWriter_Get_Folder(const lucy_MatchPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_MatchPostWriter_Write_Posting_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Write_Posting(const lucy_MatchPostingWriter *self, lucy_RawPosting* posting) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Write_Posting_OFFSET;
    const lucy_MatchPostWriter_write_posting_t method = *((lucy_MatchPostWriter_write_posting_t*)method_address);
    method((lucy_MatchPostingWriter*)self, posting);
}

extern size_t Lucy_MatchPostWriter_Start_Term_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Start_Term(const lucy_MatchPostingWriter *self, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Start_Term_OFFSET;
    const lucy_MatchPostWriter_start_term_t method = *((lucy_MatchPostWriter_start_term_t*)method_address);
    method((lucy_MatchPostingWriter*)self, tinfo);
}

extern size_t Lucy_MatchPostWriter_Update_Skip_Info_OFFSET;
static CHY_INLINE void
Lucy_MatchPostWriter_Update_Skip_Info(const lucy_MatchPostingWriter *self, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_MatchPostWriter_Update_Skip_Info_OFFSET;
    const lucy_MatchPostWriter_update_skip_info_t method = *((lucy_MatchPostWriter_update_skip_info_t*)method_address);
    method((lucy_MatchPostingWriter*)self, tinfo);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_MATCHPOSTINGWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_MATCHPOSTINGWRITER_VT;
extern struct LUCY_MATCHPOSTINGWRITER_VT LUCY_MATCHPOSTINGWRITER_vt;
#define LUCY_MATCHPOSTINGWRITER ((cfish_VTable*)&LUCY_MATCHPOSTINGWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define MatchPostingWriter lucy_MatchPostingWriter
  #define MATCHPOSTINGWRITER LUCY_MATCHPOSTINGWRITER
  #define MatchPostWriter_new lucy_MatchPostWriter_new
  #define MatchPostWriter_init lucy_MatchPostWriter_init
  #define MatchPostWriter_destroy_t lucy_MatchPostWriter_destroy_t
  #define MatchPostWriter_destroy lucy_MatchPostWriter_destroy
  #define MatchPostWriter_write_posting_t lucy_MatchPostWriter_write_posting_t
  #define MatchPostWriter_write_posting lucy_MatchPostWriter_write_posting
  #define MatchPostWriter_start_term_t lucy_MatchPostWriter_start_term_t
  #define MatchPostWriter_start_term lucy_MatchPostWriter_start_term
  #define MatchPostWriter_update_skip_info_t lucy_MatchPostWriter_update_skip_info_t
  #define MatchPostWriter_update_skip_info lucy_MatchPostWriter_update_skip_info
  #define MatchPostWriter_Make Lucy_MatchPostWriter_Make
  #define MatchPostWriter_Get_RefCount Lucy_MatchPostWriter_Get_RefCount
  #define MatchPostWriter_Inc_RefCount Lucy_MatchPostWriter_Inc_RefCount
  #define MatchPostWriter_Dec_RefCount Lucy_MatchPostWriter_Dec_RefCount
  #define MatchPostWriter_To_Host Lucy_MatchPostWriter_To_Host
  #define MatchPostWriter_Clone Lucy_MatchPostWriter_Clone
  #define MatchPostWriter_Destroy Lucy_MatchPostWriter_Destroy
  #define MatchPostWriter_Equals Lucy_MatchPostWriter_Equals
  #define MatchPostWriter_Compare_To Lucy_MatchPostWriter_Compare_To
  #define MatchPostWriter_Hash_Sum Lucy_MatchPostWriter_Hash_Sum
  #define MatchPostWriter_Get_VTable Lucy_MatchPostWriter_Get_VTable
  #define MatchPostWriter_Get_Class_Name Lucy_MatchPostWriter_Get_Class_Name
  #define MatchPostWriter_Is_A Lucy_MatchPostWriter_Is_A
  #define MatchPostWriter_To_String Lucy_MatchPostWriter_To_String
  #define MatchPostWriter_To_I64 Lucy_MatchPostWriter_To_I64
  #define MatchPostWriter_To_F64 Lucy_MatchPostWriter_To_F64
  #define MatchPostWriter_To_Bool Lucy_MatchPostWriter_To_Bool
  #define MatchPostWriter_Serialize Lucy_MatchPostWriter_Serialize
  #define MatchPostWriter_Deserialize Lucy_MatchPostWriter_Deserialize
  #define MatchPostWriter_Dump Lucy_MatchPostWriter_Dump
  #define MatchPostWriter_Load Lucy_MatchPostWriter_Load
  #define MatchPostWriter_Mimic Lucy_MatchPostWriter_Mimic
  #define MatchPostWriter_Add_Inverted_Doc Lucy_MatchPostWriter_Add_Inverted_Doc
  #define MatchPostWriter_Add_Segment Lucy_MatchPostWriter_Add_Segment
  #define MatchPostWriter_Delete_Segment Lucy_MatchPostWriter_Delete_Segment
  #define MatchPostWriter_Merge_Segment Lucy_MatchPostWriter_Merge_Segment
  #define MatchPostWriter_Finish Lucy_MatchPostWriter_Finish
  #define MatchPostWriter_Metadata Lucy_MatchPostWriter_Metadata
  #define MatchPostWriter_Format Lucy_MatchPostWriter_Format
  #define MatchPostWriter_Get_Snapshot Lucy_MatchPostWriter_Get_Snapshot
  #define MatchPostWriter_Get_Segment Lucy_MatchPostWriter_Get_Segment
  #define MatchPostWriter_Get_PolyReader Lucy_MatchPostWriter_Get_PolyReader
  #define MatchPostWriter_Get_Schema Lucy_MatchPostWriter_Get_Schema
  #define MatchPostWriter_Get_Folder Lucy_MatchPostWriter_Get_Folder
  #define MatchPostWriter_Write_Posting Lucy_MatchPostWriter_Write_Posting
  #define MatchPostWriter_Start_Term Lucy_MatchPostWriter_Start_Term
  #define MatchPostWriter_Update_Skip_Info Lucy_MatchPostWriter_Update_Skip_Info
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/TermStepper.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_MATCHTERMINFOSTEPPER
struct lucy_MatchTermInfoStepper {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Obj* value;
    int32_t skip_interval;
};

#endif /* C_LUCY_MATCHTERMINFOSTEPPER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_MatchTermInfoStepper*
lucy_MatchTInfoStepper_new(lucy_Schema* schema);

lucy_MatchTermInfoStepper*
lucy_MatchTInfoStepper_init(lucy_MatchTermInfoStepper* self, lucy_Schema* schema);

void
lucy_MatchTInfoStepper_reset(lucy_MatchTermInfoStepper* self);

void
lucy_MatchTInfoStepper_write_key_frame(lucy_MatchTermInfoStepper* self, lucy_OutStream* outstream, lucy_Obj* value);

void
lucy_MatchTInfoStepper_write_delta(lucy_MatchTermInfoStepper* self, lucy_OutStream* outstream, lucy_Obj* value);

void
lucy_MatchTInfoStepper_read_key_frame(lucy_MatchTermInfoStepper* self, lucy_InStream* instream);

void
lucy_MatchTInfoStepper_read_delta(lucy_MatchTermInfoStepper* self, lucy_InStream* instream);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_MatchTInfoStepper_reset_CALLBACK;
extern cfish_Callback lucy_MatchTInfoStepper_write_key_frame_CALLBACK;
extern cfish_Callback lucy_MatchTInfoStepper_write_delta_CALLBACK;
extern cfish_Callback lucy_MatchTInfoStepper_read_key_frame_CALLBACK;
extern cfish_Callback lucy_MatchTInfoStepper_read_delta_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_MatchTInfoStepper_reset_t)(lucy_MatchTermInfoStepper* self);

typedef void
(*lucy_MatchTInfoStepper_write_key_frame_t)(lucy_MatchTermInfoStepper* self, lucy_OutStream* outstream, lucy_Obj* value);

typedef void
(*lucy_MatchTInfoStepper_write_delta_t)(lucy_MatchTermInfoStepper* self, lucy_OutStream* outstream, lucy_Obj* value);

typedef void
(*lucy_MatchTInfoStepper_read_key_frame_t)(lucy_MatchTermInfoStepper* self, lucy_InStream* instream);

typedef void
(*lucy_MatchTInfoStepper_read_delta_t)(lucy_MatchTermInfoStepper* self, lucy_InStream* instream);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_MatchTInfoStepper_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Make(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchTInfoStepper_Get_RefCount(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Inc_RefCount(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MatchTInfoStepper_Dec_RefCount(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_MatchTInfoStepper_To_Host(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Clone(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Destroy_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Destroy(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Destroy_OFFSET;
    const lucy_TermStepper_destroy_t method = *((lucy_TermStepper_destroy_t*)method_address);
    method((lucy_TermStepper*)self);
}

extern size_t Lucy_MatchTInfoStepper_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchTInfoStepper_Equals(const lucy_MatchTermInfoStepper *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchTInfoStepper_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchTInfoStepper_Compare_To(const lucy_MatchTermInfoStepper *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchTInfoStepper_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_MatchTInfoStepper_Hash_Sum(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_MatchTInfoStepper_Get_VTable(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchTInfoStepper_Get_Class_Name(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchTInfoStepper_Is_A(const lucy_MatchTermInfoStepper *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_MatchTInfoStepper_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MatchTInfoStepper_To_String(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_MatchTInfoStepper_To_I64(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_To_F64_OFFSET;
static CHY_INLINE double
Lucy_MatchTInfoStepper_To_F64(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MatchTInfoStepper_To_Bool(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Serialize_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Serialize(const lucy_MatchTermInfoStepper *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_MatchTInfoStepper_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Deserialize(const lucy_MatchTermInfoStepper *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_MatchTInfoStepper_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Dump(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MatchTInfoStepper_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Load(const lucy_MatchTermInfoStepper *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_MatchTInfoStepper_Mimic_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Mimic(const lucy_MatchTermInfoStepper *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_MatchTInfoStepper_Reset_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Reset(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Reset_OFFSET;
    const lucy_MatchTInfoStepper_reset_t method = *((lucy_MatchTInfoStepper_reset_t*)method_address);
    method((lucy_MatchTermInfoStepper*)self);
}

extern size_t Lucy_MatchTInfoStepper_Write_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Write_Key_Frame(const lucy_MatchTermInfoStepper *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Write_Key_Frame_OFFSET;
    const lucy_MatchTInfoStepper_write_key_frame_t method = *((lucy_MatchTInfoStepper_write_key_frame_t*)method_address);
    method((lucy_MatchTermInfoStepper*)self, outstream, value);
}

extern size_t Lucy_MatchTInfoStepper_Write_Delta_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Write_Delta(const lucy_MatchTermInfoStepper *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Write_Delta_OFFSET;
    const lucy_MatchTInfoStepper_write_delta_t method = *((lucy_MatchTInfoStepper_write_delta_t*)method_address);
    method((lucy_MatchTermInfoStepper*)self, outstream, value);
}

extern size_t Lucy_MatchTInfoStepper_Read_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Read_Key_Frame(const lucy_MatchTermInfoStepper *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Read_Key_Frame_OFFSET;
    const lucy_MatchTInfoStepper_read_key_frame_t method = *((lucy_MatchTInfoStepper_read_key_frame_t*)method_address);
    method((lucy_MatchTermInfoStepper*)self, instream);
}

extern size_t Lucy_MatchTInfoStepper_Read_Delta_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Read_Delta(const lucy_MatchTermInfoStepper *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Read_Delta_OFFSET;
    const lucy_MatchTInfoStepper_read_delta_t method = *((lucy_MatchTInfoStepper_read_delta_t*)method_address);
    method((lucy_MatchTermInfoStepper*)self, instream);
}

extern size_t Lucy_MatchTInfoStepper_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Read_Record(const lucy_MatchTermInfoStepper *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Read_Record_OFFSET;
    const lucy_Stepper_read_record_t method = *((lucy_Stepper_read_record_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_MatchTInfoStepper_Set_Value_OFFSET;
static CHY_INLINE void
Lucy_MatchTInfoStepper_Set_Value(const lucy_MatchTermInfoStepper *self, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Set_Value_OFFSET;
    const lucy_TermStepper_set_value_t method = *((lucy_TermStepper_set_value_t*)method_address);
    method((lucy_TermStepper*)self, value);
}

extern size_t Lucy_MatchTInfoStepper_Get_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MatchTInfoStepper_Get_Value(const lucy_MatchTermInfoStepper *self) {
    char *const method_address = *(char**)self + Lucy_MatchTInfoStepper_Get_Value_OFFSET;
    const lucy_TermStepper_get_value_t method = *((lucy_TermStepper_get_value_t*)method_address);
    return method((lucy_TermStepper*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_MATCHTERMINFOSTEPPER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[30];
} LUCY_MATCHTERMINFOSTEPPER_VT;
extern struct LUCY_MATCHTERMINFOSTEPPER_VT LUCY_MATCHTERMINFOSTEPPER_vt;
#define LUCY_MATCHTERMINFOSTEPPER ((cfish_VTable*)&LUCY_MATCHTERMINFOSTEPPER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define MatchTermInfoStepper lucy_MatchTermInfoStepper
  #define MATCHTERMINFOSTEPPER LUCY_MATCHTERMINFOSTEPPER
  #define MatchTInfoStepper_new lucy_MatchTInfoStepper_new
  #define MatchTInfoStepper_init lucy_MatchTInfoStepper_init
  #define MatchTInfoStepper_reset_t lucy_MatchTInfoStepper_reset_t
  #define MatchTInfoStepper_reset lucy_MatchTInfoStepper_reset
  #define MatchTInfoStepper_write_key_frame_t lucy_MatchTInfoStepper_write_key_frame_t
  #define MatchTInfoStepper_write_key_frame lucy_MatchTInfoStepper_write_key_frame
  #define MatchTInfoStepper_write_delta_t lucy_MatchTInfoStepper_write_delta_t
  #define MatchTInfoStepper_write_delta lucy_MatchTInfoStepper_write_delta
  #define MatchTInfoStepper_read_key_frame_t lucy_MatchTInfoStepper_read_key_frame_t
  #define MatchTInfoStepper_read_key_frame lucy_MatchTInfoStepper_read_key_frame
  #define MatchTInfoStepper_read_delta_t lucy_MatchTInfoStepper_read_delta_t
  #define MatchTInfoStepper_read_delta lucy_MatchTInfoStepper_read_delta
  #define MatchTInfoStepper_Make Lucy_MatchTInfoStepper_Make
  #define MatchTInfoStepper_Get_RefCount Lucy_MatchTInfoStepper_Get_RefCount
  #define MatchTInfoStepper_Inc_RefCount Lucy_MatchTInfoStepper_Inc_RefCount
  #define MatchTInfoStepper_Dec_RefCount Lucy_MatchTInfoStepper_Dec_RefCount
  #define MatchTInfoStepper_To_Host Lucy_MatchTInfoStepper_To_Host
  #define MatchTInfoStepper_Clone Lucy_MatchTInfoStepper_Clone
  #define MatchTInfoStepper_Destroy Lucy_MatchTInfoStepper_Destroy
  #define MatchTInfoStepper_Equals Lucy_MatchTInfoStepper_Equals
  #define MatchTInfoStepper_Compare_To Lucy_MatchTInfoStepper_Compare_To
  #define MatchTInfoStepper_Hash_Sum Lucy_MatchTInfoStepper_Hash_Sum
  #define MatchTInfoStepper_Get_VTable Lucy_MatchTInfoStepper_Get_VTable
  #define MatchTInfoStepper_Get_Class_Name Lucy_MatchTInfoStepper_Get_Class_Name
  #define MatchTInfoStepper_Is_A Lucy_MatchTInfoStepper_Is_A
  #define MatchTInfoStepper_To_String Lucy_MatchTInfoStepper_To_String
  #define MatchTInfoStepper_To_I64 Lucy_MatchTInfoStepper_To_I64
  #define MatchTInfoStepper_To_F64 Lucy_MatchTInfoStepper_To_F64
  #define MatchTInfoStepper_To_Bool Lucy_MatchTInfoStepper_To_Bool
  #define MatchTInfoStepper_Serialize Lucy_MatchTInfoStepper_Serialize
  #define MatchTInfoStepper_Deserialize Lucy_MatchTInfoStepper_Deserialize
  #define MatchTInfoStepper_Dump Lucy_MatchTInfoStepper_Dump
  #define MatchTInfoStepper_Load Lucy_MatchTInfoStepper_Load
  #define MatchTInfoStepper_Mimic Lucy_MatchTInfoStepper_Mimic
  #define MatchTInfoStepper_Reset Lucy_MatchTInfoStepper_Reset
  #define MatchTInfoStepper_Write_Key_Frame Lucy_MatchTInfoStepper_Write_Key_Frame
  #define MatchTInfoStepper_Write_Delta Lucy_MatchTInfoStepper_Write_Delta
  #define MatchTInfoStepper_Read_Key_Frame Lucy_MatchTInfoStepper_Read_Key_Frame
  #define MatchTInfoStepper_Read_Delta Lucy_MatchTInfoStepper_Read_Delta
  #define MatchTInfoStepper_Read_Record Lucy_MatchTInfoStepper_Read_Record
  #define MatchTInfoStepper_Set_Value Lucy_MatchTInfoStepper_Set_Value
  #define MatchTInfoStepper_Get_Value Lucy_MatchTInfoStepper_Get_Value
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTING_MATCHPOSTING */




