/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTING_RAWPOSTING
#define H_LUCY_INDEX_POSTING_RAWPOSTING 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAWPOSTING
struct lucy_RawPosting {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    uint32_t freq;
    uint32_t content_len;
    uint32_t aux_len;
    char blob[1];
};

#endif /* C_LUCY_RAWPOSTING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RawPosting*
lucy_RawPost_new(void* pre_allocated_memory, int32_t doc_id, uint32_t freq, char* term_text, size_t term_text_len);

uint32_t
lucy_RawPost_get_refcount(lucy_RawPosting* self);

lucy_RawPosting*
lucy_RawPost_inc_refcount(lucy_RawPosting* self);

uint32_t
lucy_RawPost_dec_refcount(lucy_RawPosting* self);

void
lucy_RawPost_destroy(lucy_RawPosting* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RawPost_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*lucy_RawPost_get_refcount_t)(lucy_RawPosting* self);

typedef lucy_RawPosting*
(*lucy_RawPost_inc_refcount_t)(lucy_RawPosting* self);

typedef uint32_t
(*lucy_RawPost_dec_refcount_t)(lucy_RawPosting* self);

typedef void
(*lucy_RawPost_destroy_t)(lucy_RawPosting* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RawPost_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPost_Make(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPost_Get_RefCount(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Get_RefCount_OFFSET;
    const lucy_RawPost_get_refcount_t method = *((lucy_RawPost_get_refcount_t*)method_address);
    return method((lucy_RawPosting*)self);
}

extern size_t Lucy_RawPost_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_RawPost_Inc_RefCount(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Inc_RefCount_OFFSET;
    const lucy_RawPost_inc_refcount_t method = *((lucy_RawPost_inc_refcount_t*)method_address);
    return method((lucy_RawPosting*)self);
}

extern size_t Lucy_RawPost_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPost_Dec_RefCount(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Dec_RefCount_OFFSET;
    const lucy_RawPost_dec_refcount_t method = *((lucy_RawPost_dec_refcount_t*)method_address);
    return method((lucy_RawPosting*)self);
}

extern size_t Lucy_RawPost_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RawPost_To_Host(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPost_Clone(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Destroy(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Destroy_OFFSET;
    const lucy_RawPost_destroy_t method = *((lucy_RawPost_destroy_t*)method_address);
    method((lucy_RawPosting*)self);
}

extern size_t Lucy_RawPost_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPost_Equals(const lucy_RawPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPost_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPost_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPost_Compare_To(const lucy_RawPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPost_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPost_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPost_Hash_Sum(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RawPost_Get_VTable(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RawPost_Get_Class_Name(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPost_Is_A(const lucy_RawPosting *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RawPost_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RawPost_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RawPost_To_String(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RawPost_To_I64(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RawPost_To_F64(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPost_To_Bool(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Serialize(const lucy_RawPosting *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RawPost_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RawPost_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPost_Deserialize(const lucy_RawPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RawPost_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RawPost_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPost_Dump(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPost_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPost_Load(const lucy_RawPosting *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RawPost_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RawPost_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Mimic(const lucy_RawPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPost_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPost_Reset_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Reset(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Reset_OFFSET;
    const lucy_Stepper_reset_t method = *((lucy_Stepper_reset_t*)method_address);
    method((lucy_Stepper*)self);
}

extern size_t Lucy_RawPost_Write_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Write_Key_Frame(const lucy_RawPosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_RawPost_Write_Key_Frame_OFFSET;
    const lucy_Stepper_write_key_frame_t method = *((lucy_Stepper_write_key_frame_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_RawPost_Write_Delta_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Write_Delta(const lucy_RawPosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_RawPost_Write_Delta_OFFSET;
    const lucy_Stepper_write_delta_t method = *((lucy_Stepper_write_delta_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_RawPost_Read_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Read_Key_Frame(const lucy_RawPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RawPost_Read_Key_Frame_OFFSET;
    const lucy_Stepper_read_key_frame_t method = *((lucy_Stepper_read_key_frame_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_RawPost_Read_Delta_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Read_Delta(const lucy_RawPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RawPost_Read_Delta_OFFSET;
    const lucy_Stepper_read_delta_t method = *((lucy_Stepper_read_delta_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_RawPost_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Read_Record(const lucy_RawPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RawPost_Read_Record_OFFSET;
    const lucy_Stepper_read_record_t method = *((lucy_Stepper_read_record_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_RawPost_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_RawPost_Read_Raw(const lucy_RawPosting *self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_RawPost_Read_Raw_OFFSET;
    const lucy_Post_read_raw_t method = *((lucy_Post_read_raw_t*)method_address);
    return method((lucy_Posting*)self, instream, last_doc_id, term_text, mem_pool);
}

extern size_t Lucy_RawPost_Add_Inversion_To_Pool_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Add_Inversion_To_Pool(const lucy_RawPosting *self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm) {
    char *const method_address = *(char**)self + Lucy_RawPost_Add_Inversion_To_Pool_OFFSET;
    const lucy_Post_add_inversion_to_pool_t method = *((lucy_Post_add_inversion_to_pool_t*)method_address);
    method((lucy_Posting*)self, post_pool, inversion, type, doc_id, doc_boost, length_norm);
}

extern size_t Lucy_RawPost_Set_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_RawPost_Set_Doc_ID(const lucy_RawPosting *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_RawPost_Set_Doc_ID_OFFSET;
    const lucy_Post_set_doc_id_t method = *((lucy_Post_set_doc_id_t*)method_address);
    method((lucy_Posting*)self, doc_id);
}

extern size_t Lucy_RawPost_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPost_Get_Doc_ID(const lucy_RawPosting *self) {
    char *const method_address = *(char**)self + Lucy_RawPost_Get_Doc_ID_OFFSET;
    const lucy_Post_get_doc_id_t method = *((lucy_Post_get_doc_id_t*)method_address);
    return method((lucy_Posting*)self);
}

extern size_t Lucy_RawPost_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_RawPost_Make_Matcher(const lucy_RawPosting *self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_RawPost_Make_Matcher_OFFSET;
    const lucy_Post_make_matcher_t method = *((lucy_Post_make_matcher_t*)method_address);
    return method((lucy_Posting*)self, sim, plist, compiler, need_score);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RAWPOSTING_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_RAWPOSTING_VT;
extern struct LUCY_RAWPOSTING_VT LUCY_RAWPOSTING_vt;
#define LUCY_RAWPOSTING ((cfish_VTable*)&LUCY_RAWPOSTING_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RawPosting lucy_RawPosting
  #define RAWPOSTING LUCY_RAWPOSTING
  #define RawPost_new lucy_RawPost_new
  #define RawPost_get_refcount_t lucy_RawPost_get_refcount_t
  #define RawPost_get_refcount lucy_RawPost_get_refcount
  #define RawPost_inc_refcount_t lucy_RawPost_inc_refcount_t
  #define RawPost_inc_refcount lucy_RawPost_inc_refcount
  #define RawPost_dec_refcount_t lucy_RawPost_dec_refcount_t
  #define RawPost_dec_refcount lucy_RawPost_dec_refcount
  #define RawPost_destroy_t lucy_RawPost_destroy_t
  #define RawPost_destroy lucy_RawPost_destroy
  #define RawPost_Make Lucy_RawPost_Make
  #define RawPost_Get_RefCount Lucy_RawPost_Get_RefCount
  #define RawPost_Inc_RefCount Lucy_RawPost_Inc_RefCount
  #define RawPost_Dec_RefCount Lucy_RawPost_Dec_RefCount
  #define RawPost_To_Host Lucy_RawPost_To_Host
  #define RawPost_Clone Lucy_RawPost_Clone
  #define RawPost_Destroy Lucy_RawPost_Destroy
  #define RawPost_Equals Lucy_RawPost_Equals
  #define RawPost_Compare_To Lucy_RawPost_Compare_To
  #define RawPost_Hash_Sum Lucy_RawPost_Hash_Sum
  #define RawPost_Get_VTable Lucy_RawPost_Get_VTable
  #define RawPost_Get_Class_Name Lucy_RawPost_Get_Class_Name
  #define RawPost_Is_A Lucy_RawPost_Is_A
  #define RawPost_To_String Lucy_RawPost_To_String
  #define RawPost_To_I64 Lucy_RawPost_To_I64
  #define RawPost_To_F64 Lucy_RawPost_To_F64
  #define RawPost_To_Bool Lucy_RawPost_To_Bool
  #define RawPost_Serialize Lucy_RawPost_Serialize
  #define RawPost_Deserialize Lucy_RawPost_Deserialize
  #define RawPost_Dump Lucy_RawPost_Dump
  #define RawPost_Load Lucy_RawPost_Load
  #define RawPost_Mimic Lucy_RawPost_Mimic
  #define RawPost_Reset Lucy_RawPost_Reset
  #define RawPost_Write_Key_Frame Lucy_RawPost_Write_Key_Frame
  #define RawPost_Write_Delta Lucy_RawPost_Write_Delta
  #define RawPost_Read_Key_Frame Lucy_RawPost_Read_Key_Frame
  #define RawPost_Read_Delta Lucy_RawPost_Read_Delta
  #define RawPost_Read_Record Lucy_RawPost_Read_Record
  #define RawPost_Read_Raw Lucy_RawPost_Read_Raw
  #define RawPost_Add_Inversion_To_Pool Lucy_RawPost_Add_Inversion_To_Pool
  #define RawPost_Set_Doc_ID Lucy_RawPost_Set_Doc_ID
  #define RawPost_Get_Doc_ID Lucy_RawPost_Get_Doc_ID
  #define RawPost_Make_Matcher Lucy_RawPost_Make_Matcher
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAWPOSTINGWRITER
struct lucy_RawPostingWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    int32_t field_num;
    lucy_OutStream* outstream;
    int32_t last_doc_id;
};

#endif /* C_LUCY_RAWPOSTINGWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RawPostingWriter*
lucy_RawPostWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, lucy_OutStream* outstream);

lucy_RawPostingWriter*
lucy_RawPostWriter_init(lucy_RawPostingWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, lucy_OutStream* outstream);

void
lucy_RawPostWriter_destroy(lucy_RawPostingWriter* self);

void
lucy_RawPostWriter_write_posting(lucy_RawPostingWriter* self, lucy_RawPosting* posting);

void
lucy_RawPostWriter_start_term(lucy_RawPostingWriter* self, lucy_TermInfo* tinfo);

void
lucy_RawPostWriter_update_skip_info(lucy_RawPostingWriter* self, lucy_TermInfo* tinfo);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RawPostWriter_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RawPostWriter_destroy_t)(lucy_RawPostingWriter* self);

typedef void
(*lucy_RawPostWriter_write_posting_t)(lucy_RawPostingWriter* self, lucy_RawPosting* posting);

typedef void
(*lucy_RawPostWriter_start_term_t)(lucy_RawPostingWriter* self, lucy_TermInfo* tinfo);

typedef void
(*lucy_RawPostWriter_update_skip_info_t)(lucy_RawPostingWriter* self, lucy_TermInfo* tinfo);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RawPostWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPostWriter_Make(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPostWriter_Get_RefCount(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPostWriter_Inc_RefCount(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPostWriter_Dec_RefCount(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RawPostWriter_To_Host(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPostWriter_Clone(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Destroy(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Destroy_OFFSET;
    const lucy_RawPostWriter_destroy_t method = *((lucy_RawPostWriter_destroy_t*)method_address);
    method((lucy_RawPostingWriter*)self);
}

extern size_t Lucy_RawPostWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPostWriter_Equals(const lucy_RawPostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPostWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPostWriter_Compare_To(const lucy_RawPostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPostWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPostWriter_Hash_Sum(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RawPostWriter_Get_VTable(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RawPostWriter_Get_Class_Name(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPostWriter_Is_A(const lucy_RawPostingWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RawPostWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RawPostWriter_To_String(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RawPostWriter_To_I64(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RawPostWriter_To_F64(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPostWriter_To_Bool(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Serialize(const lucy_RawPostingWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RawPostWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPostWriter_Deserialize(const lucy_RawPostingWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RawPostWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPostWriter_Dump(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPostWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPostWriter_Load(const lucy_RawPostingWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RawPostWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Mimic(const lucy_RawPostingWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPostWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Add_Inverted_Doc(const lucy_RawPostingWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Add_Inverted_Doc_OFFSET;
    const lucy_DataWriter_add_inverted_doc_t method = *((lucy_DataWriter_add_inverted_doc_t*)method_address);
    method((lucy_DataWriter*)self, inverter, doc_id);
}

extern size_t Lucy_RawPostWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Add_Segment(const lucy_RawPostingWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Add_Segment_OFFSET;
    const lucy_DataWriter_add_segment_t method = *((lucy_DataWriter_add_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_RawPostWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Delete_Segment(const lucy_RawPostingWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_RawPostWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Merge_Segment(const lucy_RawPostingWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_RawPostWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Finish(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Finish_OFFSET;
    const lucy_DataWriter_finish_t method = *((lucy_DataWriter_finish_t*)method_address);
    method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_RawPostWriter_Metadata(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPostWriter_Format(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Format_OFFSET;
    const lucy_DataWriter_format_t method = *((lucy_DataWriter_format_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_RawPostWriter_Get_Snapshot(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_RawPostWriter_Get_Segment(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_RawPostWriter_Get_PolyReader(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_RawPostWriter_Get_Schema(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_RawPostWriter_Get_Folder(const lucy_RawPostingWriter *self) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_RawPostWriter_Write_Posting_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Write_Posting(const lucy_RawPostingWriter *self, lucy_RawPosting* posting) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Write_Posting_OFFSET;
    const lucy_RawPostWriter_write_posting_t method = *((lucy_RawPostWriter_write_posting_t*)method_address);
    method((lucy_RawPostingWriter*)self, posting);
}

extern size_t Lucy_RawPostWriter_Start_Term_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Start_Term(const lucy_RawPostingWriter *self, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Start_Term_OFFSET;
    const lucy_RawPostWriter_start_term_t method = *((lucy_RawPostWriter_start_term_t*)method_address);
    method((lucy_RawPostingWriter*)self, tinfo);
}

extern size_t Lucy_RawPostWriter_Update_Skip_Info_OFFSET;
static CHY_INLINE void
Lucy_RawPostWriter_Update_Skip_Info(const lucy_RawPostingWriter *self, lucy_TermInfo* tinfo) {
    char *const method_address = *(char**)self + Lucy_RawPostWriter_Update_Skip_Info_OFFSET;
    const lucy_RawPostWriter_update_skip_info_t method = *((lucy_RawPostWriter_update_skip_info_t*)method_address);
    method((lucy_RawPostingWriter*)self, tinfo);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RAWPOSTINGWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_RAWPOSTINGWRITER_VT;
extern struct LUCY_RAWPOSTINGWRITER_VT LUCY_RAWPOSTINGWRITER_vt;
#define LUCY_RAWPOSTINGWRITER ((cfish_VTable*)&LUCY_RAWPOSTINGWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RawPostingWriter lucy_RawPostingWriter
  #define RAWPOSTINGWRITER LUCY_RAWPOSTINGWRITER
  #define RawPostWriter_new lucy_RawPostWriter_new
  #define RawPostWriter_init lucy_RawPostWriter_init
  #define RawPostWriter_destroy_t lucy_RawPostWriter_destroy_t
  #define RawPostWriter_destroy lucy_RawPostWriter_destroy
  #define RawPostWriter_write_posting_t lucy_RawPostWriter_write_posting_t
  #define RawPostWriter_write_posting lucy_RawPostWriter_write_posting
  #define RawPostWriter_start_term_t lucy_RawPostWriter_start_term_t
  #define RawPostWriter_start_term lucy_RawPostWriter_start_term
  #define RawPostWriter_update_skip_info_t lucy_RawPostWriter_update_skip_info_t
  #define RawPostWriter_update_skip_info lucy_RawPostWriter_update_skip_info
  #define RawPostWriter_Make Lucy_RawPostWriter_Make
  #define RawPostWriter_Get_RefCount Lucy_RawPostWriter_Get_RefCount
  #define RawPostWriter_Inc_RefCount Lucy_RawPostWriter_Inc_RefCount
  #define RawPostWriter_Dec_RefCount Lucy_RawPostWriter_Dec_RefCount
  #define RawPostWriter_To_Host Lucy_RawPostWriter_To_Host
  #define RawPostWriter_Clone Lucy_RawPostWriter_Clone
  #define RawPostWriter_Destroy Lucy_RawPostWriter_Destroy
  #define RawPostWriter_Equals Lucy_RawPostWriter_Equals
  #define RawPostWriter_Compare_To Lucy_RawPostWriter_Compare_To
  #define RawPostWriter_Hash_Sum Lucy_RawPostWriter_Hash_Sum
  #define RawPostWriter_Get_VTable Lucy_RawPostWriter_Get_VTable
  #define RawPostWriter_Get_Class_Name Lucy_RawPostWriter_Get_Class_Name
  #define RawPostWriter_Is_A Lucy_RawPostWriter_Is_A
  #define RawPostWriter_To_String Lucy_RawPostWriter_To_String
  #define RawPostWriter_To_I64 Lucy_RawPostWriter_To_I64
  #define RawPostWriter_To_F64 Lucy_RawPostWriter_To_F64
  #define RawPostWriter_To_Bool Lucy_RawPostWriter_To_Bool
  #define RawPostWriter_Serialize Lucy_RawPostWriter_Serialize
  #define RawPostWriter_Deserialize Lucy_RawPostWriter_Deserialize
  #define RawPostWriter_Dump Lucy_RawPostWriter_Dump
  #define RawPostWriter_Load Lucy_RawPostWriter_Load
  #define RawPostWriter_Mimic Lucy_RawPostWriter_Mimic
  #define RawPostWriter_Add_Inverted_Doc Lucy_RawPostWriter_Add_Inverted_Doc
  #define RawPostWriter_Add_Segment Lucy_RawPostWriter_Add_Segment
  #define RawPostWriter_Delete_Segment Lucy_RawPostWriter_Delete_Segment
  #define RawPostWriter_Merge_Segment Lucy_RawPostWriter_Merge_Segment
  #define RawPostWriter_Finish Lucy_RawPostWriter_Finish
  #define RawPostWriter_Metadata Lucy_RawPostWriter_Metadata
  #define RawPostWriter_Format Lucy_RawPostWriter_Format
  #define RawPostWriter_Get_Snapshot Lucy_RawPostWriter_Get_Snapshot
  #define RawPostWriter_Get_Segment Lucy_RawPostWriter_Get_Segment
  #define RawPostWriter_Get_PolyReader Lucy_RawPostWriter_Get_PolyReader
  #define RawPostWriter_Get_Schema Lucy_RawPostWriter_Get_Schema
  #define RawPostWriter_Get_Folder Lucy_RawPostWriter_Get_Folder
  #define RawPostWriter_Write_Posting Lucy_RawPostWriter_Write_Posting
  #define RawPostWriter_Start_Term Lucy_RawPostWriter_Start_Term
  #define RawPostWriter_Update_Skip_Info Lucy_RawPostWriter_Update_Skip_Info
#endif /* LUCY_USE_SHORT_NAMES */



extern lucy_RawPosting LUCY_RAWPOSTING_BLANK;

#ifdef LUCY_USE_SHORT_NAMES
  #define RAWPOSTING_BLANK         LUCY_RAWPOSTING_BLANK
#endif



#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTING_RAWPOSTING */




