/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTING_RICHPOSTING
#define H_LUCY_INDEX_POSTING_RICHPOSTING 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting/ScorePosting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RICHPOSTING
struct lucy_RichPosting {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    lucy_Similarity* sim;
    uint32_t freq;
    float weight;
    float* norm_decoder;
    uint32_t* prox;
    uint32_t prox_cap;
    float* prox_boosts;
};

#endif /* C_LUCY_RICHPOSTING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RichPosting*
lucy_RichPost_new(lucy_Similarity* similarity);

lucy_RichPosting*
lucy_RichPost_init(lucy_RichPosting* self, lucy_Similarity* similarity);

void
lucy_RichPost_destroy(lucy_RichPosting* self);

void
lucy_RichPost_read_record(lucy_RichPosting* self, lucy_InStream* instream);

lucy_RawPosting*
lucy_RichPost_read_raw(lucy_RichPosting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

void
lucy_RichPost_add_inversion_to_pool(lucy_RichPosting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

lucy_RichPostingMatcher*
lucy_RichPost_make_matcher(lucy_RichPosting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RichPost_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RichPost_destroy_t)(lucy_RichPosting* self);

typedef void
(*lucy_RichPost_read_record_t)(lucy_RichPosting* self, lucy_InStream* instream);

typedef lucy_RawPosting*
(*lucy_RichPost_read_raw_t)(lucy_RichPosting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

typedef void
(*lucy_RichPost_add_inversion_to_pool_t)(lucy_RichPosting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

typedef lucy_RichPostingMatcher*
(*lucy_RichPost_make_matcher_t)(lucy_RichPosting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RichPost_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPost_Make(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RichPost_Get_RefCount(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPost_Inc_RefCount(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RichPost_Dec_RefCount(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RichPost_To_Host(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPost_Clone(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Destroy(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Destroy_OFFSET;
    const lucy_RichPost_destroy_t method = *((lucy_RichPost_destroy_t*)method_address);
    method((lucy_RichPosting*)self);
}

extern size_t Lucy_RichPost_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RichPost_Equals(const lucy_RichPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RichPost_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RichPost_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPost_Compare_To(const lucy_RichPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RichPost_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RichPost_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPost_Hash_Sum(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RichPost_Get_VTable(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RichPost_Get_Class_Name(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RichPost_Is_A(const lucy_RichPosting *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RichPost_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RichPost_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RichPost_To_String(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RichPost_To_I64(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RichPost_To_F64(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RichPost_To_Bool(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Serialize(const lucy_RichPosting *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RichPost_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RichPost_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPost_Deserialize(const lucy_RichPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RichPost_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RichPost_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPost_Dump(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPost_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPost_Load(const lucy_RichPosting *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RichPost_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RichPost_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Mimic(const lucy_RichPosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RichPost_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RichPost_Reset_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Reset(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Reset_OFFSET;
    const lucy_ScorePost_reset_t method = *((lucy_ScorePost_reset_t*)method_address);
    method((lucy_ScorePosting*)self);
}

extern size_t Lucy_RichPost_Write_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Write_Key_Frame(const lucy_RichPosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_RichPost_Write_Key_Frame_OFFSET;
    const lucy_Stepper_write_key_frame_t method = *((lucy_Stepper_write_key_frame_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_RichPost_Write_Delta_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Write_Delta(const lucy_RichPosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_RichPost_Write_Delta_OFFSET;
    const lucy_Stepper_write_delta_t method = *((lucy_Stepper_write_delta_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_RichPost_Read_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Read_Key_Frame(const lucy_RichPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RichPost_Read_Key_Frame_OFFSET;
    const lucy_Stepper_read_key_frame_t method = *((lucy_Stepper_read_key_frame_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_RichPost_Read_Delta_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Read_Delta(const lucy_RichPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RichPost_Read_Delta_OFFSET;
    const lucy_Stepper_read_delta_t method = *((lucy_Stepper_read_delta_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_RichPost_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Read_Record(const lucy_RichPosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RichPost_Read_Record_OFFSET;
    const lucy_RichPost_read_record_t method = *((lucy_RichPost_read_record_t*)method_address);
    method((lucy_RichPosting*)self, instream);
}

extern size_t Lucy_RichPost_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_RichPost_Read_Raw(const lucy_RichPosting *self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_RichPost_Read_Raw_OFFSET;
    const lucy_RichPost_read_raw_t method = *((lucy_RichPost_read_raw_t*)method_address);
    return method((lucy_RichPosting*)self, instream, last_doc_id, term_text, mem_pool);
}

extern size_t Lucy_RichPost_Add_Inversion_To_Pool_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Add_Inversion_To_Pool(const lucy_RichPosting *self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm) {
    char *const method_address = *(char**)self + Lucy_RichPost_Add_Inversion_To_Pool_OFFSET;
    const lucy_RichPost_add_inversion_to_pool_t method = *((lucy_RichPost_add_inversion_to_pool_t*)method_address);
    method((lucy_RichPosting*)self, post_pool, inversion, type, doc_id, doc_boost, length_norm);
}

extern size_t Lucy_RichPost_Set_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_RichPost_Set_Doc_ID(const lucy_RichPosting *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_RichPost_Set_Doc_ID_OFFSET;
    const lucy_Post_set_doc_id_t method = *((lucy_Post_set_doc_id_t*)method_address);
    method((lucy_Posting*)self, doc_id);
}

extern size_t Lucy_RichPost_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPost_Get_Doc_ID(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Get_Doc_ID_OFFSET;
    const lucy_Post_get_doc_id_t method = *((lucy_Post_get_doc_id_t*)method_address);
    return method((lucy_Posting*)self);
}

extern size_t Lucy_RichPost_Make_Matcher_OFFSET;
static CHY_INLINE lucy_RichPostingMatcher*
Lucy_RichPost_Make_Matcher(const lucy_RichPosting *self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_RichPost_Make_Matcher_OFFSET;
    const lucy_RichPost_make_matcher_t method = *((lucy_RichPost_make_matcher_t*)method_address);
    return method((lucy_RichPosting*)self, sim, plist, compiler, need_score);
}

extern size_t Lucy_RichPost_Get_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPost_Get_Freq(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Get_Freq_OFFSET;
    const lucy_MatchPost_get_freq_t method = *((lucy_MatchPost_get_freq_t*)method_address);
    return method((lucy_MatchPosting*)self);
}

extern size_t Lucy_RichPost_Get_Prox_OFFSET;
static CHY_INLINE uint32_t*
Lucy_RichPost_Get_Prox(const lucy_RichPosting *self) {
    char *const method_address = *(char**)self + Lucy_RichPost_Get_Prox_OFFSET;
    const lucy_ScorePost_get_prox_t method = *((lucy_ScorePost_get_prox_t*)method_address);
    return method((lucy_ScorePosting*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RICHPOSTING_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_RICHPOSTING_VT;
extern struct LUCY_RICHPOSTING_VT LUCY_RICHPOSTING_vt;
#define LUCY_RICHPOSTING ((cfish_VTable*)&LUCY_RICHPOSTING_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RichPosting lucy_RichPosting
  #define RICHPOSTING LUCY_RICHPOSTING
  #define RichPost_new lucy_RichPost_new
  #define RichPost_init lucy_RichPost_init
  #define RichPost_destroy_t lucy_RichPost_destroy_t
  #define RichPost_destroy lucy_RichPost_destroy
  #define RichPost_read_record_t lucy_RichPost_read_record_t
  #define RichPost_read_record lucy_RichPost_read_record
  #define RichPost_read_raw_t lucy_RichPost_read_raw_t
  #define RichPost_read_raw lucy_RichPost_read_raw
  #define RichPost_add_inversion_to_pool_t lucy_RichPost_add_inversion_to_pool_t
  #define RichPost_add_inversion_to_pool lucy_RichPost_add_inversion_to_pool
  #define RichPost_make_matcher_t lucy_RichPost_make_matcher_t
  #define RichPost_make_matcher lucy_RichPost_make_matcher
  #define RichPost_Make Lucy_RichPost_Make
  #define RichPost_Get_RefCount Lucy_RichPost_Get_RefCount
  #define RichPost_Inc_RefCount Lucy_RichPost_Inc_RefCount
  #define RichPost_Dec_RefCount Lucy_RichPost_Dec_RefCount
  #define RichPost_To_Host Lucy_RichPost_To_Host
  #define RichPost_Clone Lucy_RichPost_Clone
  #define RichPost_Destroy Lucy_RichPost_Destroy
  #define RichPost_Equals Lucy_RichPost_Equals
  #define RichPost_Compare_To Lucy_RichPost_Compare_To
  #define RichPost_Hash_Sum Lucy_RichPost_Hash_Sum
  #define RichPost_Get_VTable Lucy_RichPost_Get_VTable
  #define RichPost_Get_Class_Name Lucy_RichPost_Get_Class_Name
  #define RichPost_Is_A Lucy_RichPost_Is_A
  #define RichPost_To_String Lucy_RichPost_To_String
  #define RichPost_To_I64 Lucy_RichPost_To_I64
  #define RichPost_To_F64 Lucy_RichPost_To_F64
  #define RichPost_To_Bool Lucy_RichPost_To_Bool
  #define RichPost_Serialize Lucy_RichPost_Serialize
  #define RichPost_Deserialize Lucy_RichPost_Deserialize
  #define RichPost_Dump Lucy_RichPost_Dump
  #define RichPost_Load Lucy_RichPost_Load
  #define RichPost_Mimic Lucy_RichPost_Mimic
  #define RichPost_Reset Lucy_RichPost_Reset
  #define RichPost_Write_Key_Frame Lucy_RichPost_Write_Key_Frame
  #define RichPost_Write_Delta Lucy_RichPost_Write_Delta
  #define RichPost_Read_Key_Frame Lucy_RichPost_Read_Key_Frame
  #define RichPost_Read_Delta Lucy_RichPost_Read_Delta
  #define RichPost_Read_Record Lucy_RichPost_Read_Record
  #define RichPost_Read_Raw Lucy_RichPost_Read_Raw
  #define RichPost_Add_Inversion_To_Pool Lucy_RichPost_Add_Inversion_To_Pool
  #define RichPost_Set_Doc_ID Lucy_RichPost_Set_Doc_ID
  #define RichPost_Get_Doc_ID Lucy_RichPost_Get_Doc_ID
  #define RichPost_Make_Matcher Lucy_RichPost_Make_Matcher
  #define RichPost_Get_Freq Lucy_RichPost_Get_Freq
  #define RichPost_Get_Prox Lucy_RichPost_Get_Prox
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting/ScorePosting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RICHPOSTINGMATCHER
struct lucy_RichPostingMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float weight;
    lucy_Compiler* compiler;
    lucy_Similarity* sim;
    lucy_PostingList* plist;
    lucy_Posting* posting;
    float* score_cache;
};

#endif /* C_LUCY_RICHPOSTINGMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RichPostingMatcher*
lucy_RichPostMatcher_init(lucy_RichPostingMatcher* self, lucy_Similarity* similarity, lucy_PostingList* posting_list, lucy_Compiler* compiler);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RichPostMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPostMatcher_Make(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RichPostMatcher_Get_RefCount(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPostMatcher_Inc_RefCount(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RichPostMatcher_Dec_RefCount(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RichPostMatcher_To_Host(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPostMatcher_Clone(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RichPostMatcher_Destroy(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Destroy_OFFSET;
    const lucy_ScorePostMatcher_destroy_t method = *((lucy_ScorePostMatcher_destroy_t*)method_address);
    method((lucy_ScorePostingMatcher*)self);
}

extern size_t Lucy_RichPostMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RichPostMatcher_Equals(const lucy_RichPostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RichPostMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPostMatcher_Compare_To(const lucy_RichPostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RichPostMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPostMatcher_Hash_Sum(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RichPostMatcher_Get_VTable(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RichPostMatcher_Get_Class_Name(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RichPostMatcher_Is_A(const lucy_RichPostingMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RichPostMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RichPostMatcher_To_String(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RichPostMatcher_To_I64(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RichPostMatcher_To_F64(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RichPostMatcher_To_Bool(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RichPostMatcher_Serialize(const lucy_RichPostingMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RichPostMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPostMatcher_Deserialize(const lucy_RichPostingMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RichPostMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPostMatcher_Dump(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RichPostMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RichPostMatcher_Load(const lucy_RichPostingMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RichPostMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RichPostMatcher_Mimic(const lucy_RichPostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RichPostMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPostMatcher_Next(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Next_OFFSET;
    const lucy_TermMatcher_next_t method = *((lucy_TermMatcher_next_t*)method_address);
    return method((lucy_TermMatcher*)self);
}

extern size_t Lucy_RichPostMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPostMatcher_Advance(const lucy_RichPostingMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Advance_OFFSET;
    const lucy_TermMatcher_advance_t method = *((lucy_TermMatcher_advance_t*)method_address);
    return method((lucy_TermMatcher*)self, target);
}

extern size_t Lucy_RichPostMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_RichPostMatcher_Get_Doc_ID(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Get_Doc_ID_OFFSET;
    const lucy_TermMatcher_get_doc_id_t method = *((lucy_TermMatcher_get_doc_id_t*)method_address);
    return method((lucy_TermMatcher*)self);
}

extern size_t Lucy_RichPostMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_RichPostMatcher_Score(const lucy_RichPostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Score_OFFSET;
    const lucy_ScorePostMatcher_score_t method = *((lucy_ScorePostMatcher_score_t*)method_address);
    return method((lucy_ScorePostingMatcher*)self);
}

extern size_t Lucy_RichPostMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_RichPostMatcher_Collect(const lucy_RichPostingMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_RichPostMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RICHPOSTINGMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_RICHPOSTINGMATCHER_VT;
extern struct LUCY_RICHPOSTINGMATCHER_VT LUCY_RICHPOSTINGMATCHER_vt;
#define LUCY_RICHPOSTINGMATCHER ((cfish_VTable*)&LUCY_RICHPOSTINGMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RichPostingMatcher lucy_RichPostingMatcher
  #define RICHPOSTINGMATCHER LUCY_RICHPOSTINGMATCHER
  #define RichPostMatcher_init lucy_RichPostMatcher_init
  #define RichPostMatcher_Make Lucy_RichPostMatcher_Make
  #define RichPostMatcher_Get_RefCount Lucy_RichPostMatcher_Get_RefCount
  #define RichPostMatcher_Inc_RefCount Lucy_RichPostMatcher_Inc_RefCount
  #define RichPostMatcher_Dec_RefCount Lucy_RichPostMatcher_Dec_RefCount
  #define RichPostMatcher_To_Host Lucy_RichPostMatcher_To_Host
  #define RichPostMatcher_Clone Lucy_RichPostMatcher_Clone
  #define RichPostMatcher_Destroy Lucy_RichPostMatcher_Destroy
  #define RichPostMatcher_Equals Lucy_RichPostMatcher_Equals
  #define RichPostMatcher_Compare_To Lucy_RichPostMatcher_Compare_To
  #define RichPostMatcher_Hash_Sum Lucy_RichPostMatcher_Hash_Sum
  #define RichPostMatcher_Get_VTable Lucy_RichPostMatcher_Get_VTable
  #define RichPostMatcher_Get_Class_Name Lucy_RichPostMatcher_Get_Class_Name
  #define RichPostMatcher_Is_A Lucy_RichPostMatcher_Is_A
  #define RichPostMatcher_To_String Lucy_RichPostMatcher_To_String
  #define RichPostMatcher_To_I64 Lucy_RichPostMatcher_To_I64
  #define RichPostMatcher_To_F64 Lucy_RichPostMatcher_To_F64
  #define RichPostMatcher_To_Bool Lucy_RichPostMatcher_To_Bool
  #define RichPostMatcher_Serialize Lucy_RichPostMatcher_Serialize
  #define RichPostMatcher_Deserialize Lucy_RichPostMatcher_Deserialize
  #define RichPostMatcher_Dump Lucy_RichPostMatcher_Dump
  #define RichPostMatcher_Load Lucy_RichPostMatcher_Load
  #define RichPostMatcher_Mimic Lucy_RichPostMatcher_Mimic
  #define RichPostMatcher_Next Lucy_RichPostMatcher_Next
  #define RichPostMatcher_Advance Lucy_RichPostMatcher_Advance
  #define RichPostMatcher_Get_Doc_ID Lucy_RichPostMatcher_Get_Doc_ID
  #define RichPostMatcher_Score Lucy_RichPostMatcher_Score
  #define RichPostMatcher_Collect Lucy_RichPostMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTING_RICHPOSTING */




