/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTING_SCOREPOSTING
#define H_LUCY_INDEX_POSTING_SCOREPOSTING 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Posting/MatchPosting.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SCOREPOSTING
struct lucy_ScorePosting {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    lucy_Similarity* sim;
    uint32_t freq;
    float weight;
    float* norm_decoder;
    uint32_t* prox;
    uint32_t prox_cap;
};

#endif /* C_LUCY_SCOREPOSTING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ScorePosting*
lucy_ScorePost_new(lucy_Similarity* similarity);

lucy_ScorePosting*
lucy_ScorePost_init(lucy_ScorePosting* self, lucy_Similarity* similarity);

void
lucy_ScorePost_destroy(lucy_ScorePosting* self);

void
lucy_ScorePost_reset(lucy_ScorePosting* self);

void
lucy_ScorePost_read_record(lucy_ScorePosting* self, lucy_InStream* instream);

lucy_RawPosting*
lucy_ScorePost_read_raw(lucy_ScorePosting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

void
lucy_ScorePost_add_inversion_to_pool(lucy_ScorePosting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

lucy_ScorePostingMatcher*
lucy_ScorePost_make_matcher(lucy_ScorePosting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);

uint32_t*
lucy_ScorePost_get_prox(lucy_ScorePosting* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ScorePost_destroy_CALLBACK;
extern cfish_Callback lucy_ScorePost_reset_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ScorePost_destroy_t)(lucy_ScorePosting* self);

typedef void
(*lucy_ScorePost_reset_t)(lucy_ScorePosting* self);

typedef void
(*lucy_ScorePost_read_record_t)(lucy_ScorePosting* self, lucy_InStream* instream);

typedef lucy_RawPosting*
(*lucy_ScorePost_read_raw_t)(lucy_ScorePosting* self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

typedef void
(*lucy_ScorePost_add_inversion_to_pool_t)(lucy_ScorePosting* self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm);

typedef lucy_ScorePostingMatcher*
(*lucy_ScorePost_make_matcher_t)(lucy_ScorePosting* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score);

typedef uint32_t*
(*lucy_ScorePost_get_prox_t)(lucy_ScorePosting* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ScorePost_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePost_Make(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ScorePost_Get_RefCount(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePost_Inc_RefCount(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ScorePost_Dec_RefCount(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ScorePost_To_Host(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePost_Clone(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Destroy(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Destroy_OFFSET;
    const lucy_ScorePost_destroy_t method = *((lucy_ScorePost_destroy_t*)method_address);
    method((lucy_ScorePosting*)self);
}

extern size_t Lucy_ScorePost_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ScorePost_Equals(const lucy_ScorePosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ScorePost_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePost_Compare_To(const lucy_ScorePosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ScorePost_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePost_Hash_Sum(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ScorePost_Get_VTable(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ScorePost_Get_Class_Name(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ScorePost_Is_A(const lucy_ScorePosting *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ScorePost_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ScorePost_To_String(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ScorePost_To_I64(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ScorePost_To_F64(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ScorePost_To_Bool(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Serialize(const lucy_ScorePosting *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ScorePost_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePost_Deserialize(const lucy_ScorePosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ScorePost_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePost_Dump(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePost_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePost_Load(const lucy_ScorePosting *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ScorePost_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Mimic(const lucy_ScorePosting *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ScorePost_Reset_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Reset(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Reset_OFFSET;
    const lucy_ScorePost_reset_t method = *((lucy_ScorePost_reset_t*)method_address);
    method((lucy_ScorePosting*)self);
}

extern size_t Lucy_ScorePost_Write_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Write_Key_Frame(const lucy_ScorePosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Write_Key_Frame_OFFSET;
    const lucy_Stepper_write_key_frame_t method = *((lucy_Stepper_write_key_frame_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_ScorePost_Write_Delta_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Write_Delta(const lucy_ScorePosting *self, lucy_OutStream* outstream, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Write_Delta_OFFSET;
    const lucy_Stepper_write_delta_t method = *((lucy_Stepper_write_delta_t*)method_address);
    method((lucy_Stepper*)self, outstream, value);
}

extern size_t Lucy_ScorePost_Read_Key_Frame_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Read_Key_Frame(const lucy_ScorePosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Read_Key_Frame_OFFSET;
    const lucy_Stepper_read_key_frame_t method = *((lucy_Stepper_read_key_frame_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_ScorePost_Read_Delta_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Read_Delta(const lucy_ScorePosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Read_Delta_OFFSET;
    const lucy_Stepper_read_delta_t method = *((lucy_Stepper_read_delta_t*)method_address);
    method((lucy_Stepper*)self, instream);
}

extern size_t Lucy_ScorePost_Read_Record_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Read_Record(const lucy_ScorePosting *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Read_Record_OFFSET;
    const lucy_ScorePost_read_record_t method = *((lucy_ScorePost_read_record_t*)method_address);
    method((lucy_ScorePosting*)self, instream);
}

extern size_t Lucy_ScorePost_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_ScorePost_Read_Raw(const lucy_ScorePosting *self, lucy_InStream* instream, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Read_Raw_OFFSET;
    const lucy_ScorePost_read_raw_t method = *((lucy_ScorePost_read_raw_t*)method_address);
    return method((lucy_ScorePosting*)self, instream, last_doc_id, term_text, mem_pool);
}

extern size_t Lucy_ScorePost_Add_Inversion_To_Pool_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Add_Inversion_To_Pool(const lucy_ScorePosting *self, lucy_PostingPool* post_pool, lucy_Inversion* inversion, lucy_FieldType* type, int32_t doc_id, float doc_boost, float length_norm) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Add_Inversion_To_Pool_OFFSET;
    const lucy_ScorePost_add_inversion_to_pool_t method = *((lucy_ScorePost_add_inversion_to_pool_t*)method_address);
    method((lucy_ScorePosting*)self, post_pool, inversion, type, doc_id, doc_boost, length_norm);
}

extern size_t Lucy_ScorePost_Set_Doc_ID_OFFSET;
static CHY_INLINE void
Lucy_ScorePost_Set_Doc_ID(const lucy_ScorePosting *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Set_Doc_ID_OFFSET;
    const lucy_Post_set_doc_id_t method = *((lucy_Post_set_doc_id_t*)method_address);
    method((lucy_Posting*)self, doc_id);
}

extern size_t Lucy_ScorePost_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePost_Get_Doc_ID(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Get_Doc_ID_OFFSET;
    const lucy_Post_get_doc_id_t method = *((lucy_Post_get_doc_id_t*)method_address);
    return method((lucy_Posting*)self);
}

extern size_t Lucy_ScorePost_Make_Matcher_OFFSET;
static CHY_INLINE lucy_ScorePostingMatcher*
Lucy_ScorePost_Make_Matcher(const lucy_ScorePosting *self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Make_Matcher_OFFSET;
    const lucy_ScorePost_make_matcher_t method = *((lucy_ScorePost_make_matcher_t*)method_address);
    return method((lucy_ScorePosting*)self, sim, plist, compiler, need_score);
}

extern size_t Lucy_ScorePost_Get_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePost_Get_Freq(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Get_Freq_OFFSET;
    const lucy_MatchPost_get_freq_t method = *((lucy_MatchPost_get_freq_t*)method_address);
    return method((lucy_MatchPosting*)self);
}

extern size_t Lucy_ScorePost_Get_Prox_OFFSET;
static CHY_INLINE uint32_t*
Lucy_ScorePost_Get_Prox(const lucy_ScorePosting *self) {
    char *const method_address = *(char**)self + Lucy_ScorePost_Get_Prox_OFFSET;
    const lucy_ScorePost_get_prox_t method = *((lucy_ScorePost_get_prox_t*)method_address);
    return method((lucy_ScorePosting*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SCOREPOSTING_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_SCOREPOSTING_VT;
extern struct LUCY_SCOREPOSTING_VT LUCY_SCOREPOSTING_vt;
#define LUCY_SCOREPOSTING ((cfish_VTable*)&LUCY_SCOREPOSTING_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ScorePosting lucy_ScorePosting
  #define SCOREPOSTING LUCY_SCOREPOSTING
  #define ScorePost_new lucy_ScorePost_new
  #define ScorePost_init lucy_ScorePost_init
  #define ScorePost_destroy_t lucy_ScorePost_destroy_t
  #define ScorePost_destroy lucy_ScorePost_destroy
  #define ScorePost_reset_t lucy_ScorePost_reset_t
  #define ScorePost_reset lucy_ScorePost_reset
  #define ScorePost_read_record_t lucy_ScorePost_read_record_t
  #define ScorePost_read_record lucy_ScorePost_read_record
  #define ScorePost_read_raw_t lucy_ScorePost_read_raw_t
  #define ScorePost_read_raw lucy_ScorePost_read_raw
  #define ScorePost_add_inversion_to_pool_t lucy_ScorePost_add_inversion_to_pool_t
  #define ScorePost_add_inversion_to_pool lucy_ScorePost_add_inversion_to_pool
  #define ScorePost_make_matcher_t lucy_ScorePost_make_matcher_t
  #define ScorePost_make_matcher lucy_ScorePost_make_matcher
  #define ScorePost_get_prox_t lucy_ScorePost_get_prox_t
  #define ScorePost_get_prox lucy_ScorePost_get_prox
  #define ScorePost_Make Lucy_ScorePost_Make
  #define ScorePost_Get_RefCount Lucy_ScorePost_Get_RefCount
  #define ScorePost_Inc_RefCount Lucy_ScorePost_Inc_RefCount
  #define ScorePost_Dec_RefCount Lucy_ScorePost_Dec_RefCount
  #define ScorePost_To_Host Lucy_ScorePost_To_Host
  #define ScorePost_Clone Lucy_ScorePost_Clone
  #define ScorePost_Destroy Lucy_ScorePost_Destroy
  #define ScorePost_Equals Lucy_ScorePost_Equals
  #define ScorePost_Compare_To Lucy_ScorePost_Compare_To
  #define ScorePost_Hash_Sum Lucy_ScorePost_Hash_Sum
  #define ScorePost_Get_VTable Lucy_ScorePost_Get_VTable
  #define ScorePost_Get_Class_Name Lucy_ScorePost_Get_Class_Name
  #define ScorePost_Is_A Lucy_ScorePost_Is_A
  #define ScorePost_To_String Lucy_ScorePost_To_String
  #define ScorePost_To_I64 Lucy_ScorePost_To_I64
  #define ScorePost_To_F64 Lucy_ScorePost_To_F64
  #define ScorePost_To_Bool Lucy_ScorePost_To_Bool
  #define ScorePost_Serialize Lucy_ScorePost_Serialize
  #define ScorePost_Deserialize Lucy_ScorePost_Deserialize
  #define ScorePost_Dump Lucy_ScorePost_Dump
  #define ScorePost_Load Lucy_ScorePost_Load
  #define ScorePost_Mimic Lucy_ScorePost_Mimic
  #define ScorePost_Reset Lucy_ScorePost_Reset
  #define ScorePost_Write_Key_Frame Lucy_ScorePost_Write_Key_Frame
  #define ScorePost_Write_Delta Lucy_ScorePost_Write_Delta
  #define ScorePost_Read_Key_Frame Lucy_ScorePost_Read_Key_Frame
  #define ScorePost_Read_Delta Lucy_ScorePost_Read_Delta
  #define ScorePost_Read_Record Lucy_ScorePost_Read_Record
  #define ScorePost_Read_Raw Lucy_ScorePost_Read_Raw
  #define ScorePost_Add_Inversion_To_Pool Lucy_ScorePost_Add_Inversion_To_Pool
  #define ScorePost_Set_Doc_ID Lucy_ScorePost_Set_Doc_ID
  #define ScorePost_Get_Doc_ID Lucy_ScorePost_Get_Doc_ID
  #define ScorePost_Make_Matcher Lucy_ScorePost_Make_Matcher
  #define ScorePost_Get_Freq Lucy_ScorePost_Get_Freq
  #define ScorePost_Get_Prox Lucy_ScorePost_Get_Prox
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/TermMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SCOREPOSTINGMATCHER
struct lucy_ScorePostingMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float weight;
    lucy_Compiler* compiler;
    lucy_Similarity* sim;
    lucy_PostingList* plist;
    lucy_Posting* posting;
    float* score_cache;
};

#endif /* C_LUCY_SCOREPOSTINGMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ScorePostingMatcher*
lucy_ScorePostMatcher_init(lucy_ScorePostingMatcher* self, lucy_Similarity* sim, lucy_PostingList* plist, lucy_Compiler* compiler);

void
lucy_ScorePostMatcher_destroy(lucy_ScorePostingMatcher* self);

float
lucy_ScorePostMatcher_score(lucy_ScorePostingMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ScorePostMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_ScorePostMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ScorePostMatcher_destroy_t)(lucy_ScorePostingMatcher* self);

typedef float
(*lucy_ScorePostMatcher_score_t)(lucy_ScorePostingMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ScorePostMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePostMatcher_Make(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ScorePostMatcher_Get_RefCount(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePostMatcher_Inc_RefCount(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ScorePostMatcher_Dec_RefCount(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ScorePostMatcher_To_Host(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePostMatcher_Clone(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ScorePostMatcher_Destroy(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Destroy_OFFSET;
    const lucy_ScorePostMatcher_destroy_t method = *((lucy_ScorePostMatcher_destroy_t*)method_address);
    method((lucy_ScorePostingMatcher*)self);
}

extern size_t Lucy_ScorePostMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ScorePostMatcher_Equals(const lucy_ScorePostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ScorePostMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePostMatcher_Compare_To(const lucy_ScorePostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ScorePostMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePostMatcher_Hash_Sum(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ScorePostMatcher_Get_VTable(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ScorePostMatcher_Get_Class_Name(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ScorePostMatcher_Is_A(const lucy_ScorePostingMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ScorePostMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ScorePostMatcher_To_String(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ScorePostMatcher_To_I64(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ScorePostMatcher_To_F64(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ScorePostMatcher_To_Bool(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ScorePostMatcher_Serialize(const lucy_ScorePostingMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ScorePostMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePostMatcher_Deserialize(const lucy_ScorePostingMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ScorePostMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePostMatcher_Dump(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ScorePostMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ScorePostMatcher_Load(const lucy_ScorePostingMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ScorePostMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ScorePostMatcher_Mimic(const lucy_ScorePostingMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ScorePostMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePostMatcher_Next(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Next_OFFSET;
    const lucy_TermMatcher_next_t method = *((lucy_TermMatcher_next_t*)method_address);
    return method((lucy_TermMatcher*)self);
}

extern size_t Lucy_ScorePostMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePostMatcher_Advance(const lucy_ScorePostingMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Advance_OFFSET;
    const lucy_TermMatcher_advance_t method = *((lucy_TermMatcher_advance_t*)method_address);
    return method((lucy_TermMatcher*)self, target);
}

extern size_t Lucy_ScorePostMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ScorePostMatcher_Get_Doc_ID(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Get_Doc_ID_OFFSET;
    const lucy_TermMatcher_get_doc_id_t method = *((lucy_TermMatcher_get_doc_id_t*)method_address);
    return method((lucy_TermMatcher*)self);
}

extern size_t Lucy_ScorePostMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_ScorePostMatcher_Score(const lucy_ScorePostingMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Score_OFFSET;
    const lucy_ScorePostMatcher_score_t method = *((lucy_ScorePostMatcher_score_t*)method_address);
    return method((lucy_ScorePostingMatcher*)self);
}

extern size_t Lucy_ScorePostMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_ScorePostMatcher_Collect(const lucy_ScorePostingMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_ScorePostMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SCOREPOSTINGMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_SCOREPOSTINGMATCHER_VT;
extern struct LUCY_SCOREPOSTINGMATCHER_VT LUCY_SCOREPOSTINGMATCHER_vt;
#define LUCY_SCOREPOSTINGMATCHER ((cfish_VTable*)&LUCY_SCOREPOSTINGMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ScorePostingMatcher lucy_ScorePostingMatcher
  #define SCOREPOSTINGMATCHER LUCY_SCOREPOSTINGMATCHER
  #define ScorePostMatcher_init lucy_ScorePostMatcher_init
  #define ScorePostMatcher_destroy_t lucy_ScorePostMatcher_destroy_t
  #define ScorePostMatcher_destroy lucy_ScorePostMatcher_destroy
  #define ScorePostMatcher_score_t lucy_ScorePostMatcher_score_t
  #define ScorePostMatcher_score lucy_ScorePostMatcher_score
  #define ScorePostMatcher_Make Lucy_ScorePostMatcher_Make
  #define ScorePostMatcher_Get_RefCount Lucy_ScorePostMatcher_Get_RefCount
  #define ScorePostMatcher_Inc_RefCount Lucy_ScorePostMatcher_Inc_RefCount
  #define ScorePostMatcher_Dec_RefCount Lucy_ScorePostMatcher_Dec_RefCount
  #define ScorePostMatcher_To_Host Lucy_ScorePostMatcher_To_Host
  #define ScorePostMatcher_Clone Lucy_ScorePostMatcher_Clone
  #define ScorePostMatcher_Destroy Lucy_ScorePostMatcher_Destroy
  #define ScorePostMatcher_Equals Lucy_ScorePostMatcher_Equals
  #define ScorePostMatcher_Compare_To Lucy_ScorePostMatcher_Compare_To
  #define ScorePostMatcher_Hash_Sum Lucy_ScorePostMatcher_Hash_Sum
  #define ScorePostMatcher_Get_VTable Lucy_ScorePostMatcher_Get_VTable
  #define ScorePostMatcher_Get_Class_Name Lucy_ScorePostMatcher_Get_Class_Name
  #define ScorePostMatcher_Is_A Lucy_ScorePostMatcher_Is_A
  #define ScorePostMatcher_To_String Lucy_ScorePostMatcher_To_String
  #define ScorePostMatcher_To_I64 Lucy_ScorePostMatcher_To_I64
  #define ScorePostMatcher_To_F64 Lucy_ScorePostMatcher_To_F64
  #define ScorePostMatcher_To_Bool Lucy_ScorePostMatcher_To_Bool
  #define ScorePostMatcher_Serialize Lucy_ScorePostMatcher_Serialize
  #define ScorePostMatcher_Deserialize Lucy_ScorePostMatcher_Deserialize
  #define ScorePostMatcher_Dump Lucy_ScorePostMatcher_Dump
  #define ScorePostMatcher_Load Lucy_ScorePostMatcher_Load
  #define ScorePostMatcher_Mimic Lucy_ScorePostMatcher_Mimic
  #define ScorePostMatcher_Next Lucy_ScorePostMatcher_Next
  #define ScorePostMatcher_Advance Lucy_ScorePostMatcher_Advance
  #define ScorePostMatcher_Get_Doc_ID Lucy_ScorePostMatcher_Get_Doc_ID
  #define ScorePostMatcher_Score Lucy_ScorePostMatcher_Score
  #define ScorePostMatcher_Collect Lucy_ScorePostMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTING_SCOREPOSTING */




