/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTINGLIST
#define H_LUCY_INDEX_POSTINGLIST 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTINGLIST
struct lucy_PostingList {
    lucy_VTable* vtable;
    lucy_ref_t ref;
};

#endif /* C_LUCY_POSTINGLIST */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PostingList*
lucy_PList_init(lucy_PostingList* self);

lucy_Posting*
lucy_PList_get_posting(lucy_PostingList* self);

uint32_t
lucy_PList_get_doc_freq(lucy_PostingList* self);

void
lucy_PList_seek(lucy_PostingList* self, lucy_Obj* target);

void
lucy_PList_seek_lex(lucy_PostingList* self, lucy_Lexicon* lexicon);

lucy_Matcher*
lucy_PList_make_matcher(lucy_PostingList* self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score);

lucy_RawPosting*
lucy_PList_read_raw(lucy_PostingList* self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PList_get_posting_CALLBACK;
extern cfish_Callback lucy_PList_get_doc_freq_CALLBACK;
extern cfish_Callback lucy_PList_seek_CALLBACK;
extern cfish_Callback lucy_PList_seek_lex_CALLBACK;
extern cfish_Callback lucy_PList_make_matcher_CALLBACK;
extern cfish_Callback lucy_PList_read_raw_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Posting*
(*lucy_PList_get_posting_t)(lucy_PostingList* self);

typedef uint32_t
(*lucy_PList_get_doc_freq_t)(lucy_PostingList* self);

typedef void
(*lucy_PList_seek_t)(lucy_PostingList* self, lucy_Obj* target);

typedef void
(*lucy_PList_seek_lex_t)(lucy_PostingList* self, lucy_Lexicon* lexicon);

typedef lucy_Matcher*
(*lucy_PList_make_matcher_t)(lucy_PostingList* self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score);

typedef lucy_RawPosting*
(*lucy_PList_read_raw_t)(lucy_PostingList* self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PList_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PList_Make(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PList_Get_RefCount(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PList_Inc_RefCount(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PList_Dec_RefCount(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PList_To_Host(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PList_Clone(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PList_Destroy(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PList_Equals(const lucy_PostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PList_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PList_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PList_Compare_To(const lucy_PostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PList_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PList_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PList_Hash_Sum(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PList_Get_VTable(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PList_Get_Class_Name(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PList_Is_A(const lucy_PostingList *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PList_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PList_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PList_To_String(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PList_To_I64(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PList_To_F64(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PList_To_Bool(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PList_Serialize(const lucy_PostingList *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PList_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PList_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PList_Deserialize(const lucy_PostingList *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PList_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PList_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PList_Dump(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PList_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PList_Load(const lucy_PostingList *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PList_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PList_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PList_Mimic(const lucy_PostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PList_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PList_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_PList_Next(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Next_OFFSET;
    const lucy_Matcher_next_t method = *((lucy_Matcher_next_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_PList_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_PList_Advance(const lucy_PostingList *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_PList_Advance_OFFSET;
    const lucy_Matcher_advance_t method = *((lucy_Matcher_advance_t*)method_address);
    return method((lucy_Matcher*)self, target);
}

extern size_t Lucy_PList_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_PList_Get_Doc_ID(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Get_Doc_ID_OFFSET;
    const lucy_Matcher_get_doc_id_t method = *((lucy_Matcher_get_doc_id_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_PList_Score_OFFSET;
static CHY_INLINE float
Lucy_PList_Score(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Score_OFFSET;
    const lucy_Matcher_score_t method = *((lucy_Matcher_score_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_PList_Collect_OFFSET;
static CHY_INLINE void
Lucy_PList_Collect(const lucy_PostingList *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_PList_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}

extern size_t Lucy_PList_Get_Posting_OFFSET;
static CHY_INLINE lucy_Posting*
Lucy_PList_Get_Posting(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Get_Posting_OFFSET;
    const lucy_PList_get_posting_t method = *((lucy_PList_get_posting_t*)method_address);
    return method((lucy_PostingList*)self);
}

extern size_t Lucy_PList_Get_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_PList_Get_Doc_Freq(const lucy_PostingList *self) {
    char *const method_address = *(char**)self + Lucy_PList_Get_Doc_Freq_OFFSET;
    const lucy_PList_get_doc_freq_t method = *((lucy_PList_get_doc_freq_t*)method_address);
    return method((lucy_PostingList*)self);
}

extern size_t Lucy_PList_Seek_OFFSET;
static CHY_INLINE void
Lucy_PList_Seek(const lucy_PostingList *self, lucy_Obj* target) {
    char *const method_address = *(char**)self + Lucy_PList_Seek_OFFSET;
    const lucy_PList_seek_t method = *((lucy_PList_seek_t*)method_address);
    method((lucy_PostingList*)self, target);
}

extern size_t Lucy_PList_Seek_Lex_OFFSET;
static CHY_INLINE void
Lucy_PList_Seek_Lex(const lucy_PostingList *self, lucy_Lexicon* lexicon) {
    char *const method_address = *(char**)self + Lucy_PList_Seek_Lex_OFFSET;
    const lucy_PList_seek_lex_t method = *((lucy_PList_seek_lex_t*)method_address);
    method((lucy_PostingList*)self, lexicon);
}

extern size_t Lucy_PList_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_PList_Make_Matcher(const lucy_PostingList *self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_PList_Make_Matcher_OFFSET;
    const lucy_PList_make_matcher_t method = *((lucy_PList_make_matcher_t*)method_address);
    return method((lucy_PostingList*)self, similarity, compiler, need_score);
}

extern size_t Lucy_PList_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_PList_Read_Raw(const lucy_PostingList *self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_PList_Read_Raw_OFFSET;
    const lucy_PList_read_raw_t method = *((lucy_PList_read_raw_t*)method_address);
    return method((lucy_PostingList*)self, last_doc_id, term_text, mem_pool);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POSTINGLIST_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_POSTINGLIST_VT;
extern struct LUCY_POSTINGLIST_VT LUCY_POSTINGLIST_vt;
#define LUCY_POSTINGLIST ((cfish_VTable*)&LUCY_POSTINGLIST_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PostingList lucy_PostingList
  #define POSTINGLIST LUCY_POSTINGLIST
  #define PList_init lucy_PList_init
  #define PList_get_posting_t lucy_PList_get_posting_t
  #define PList_get_posting lucy_PList_get_posting
  #define PList_get_doc_freq_t lucy_PList_get_doc_freq_t
  #define PList_get_doc_freq lucy_PList_get_doc_freq
  #define PList_seek_t lucy_PList_seek_t
  #define PList_seek lucy_PList_seek
  #define PList_seek_lex_t lucy_PList_seek_lex_t
  #define PList_seek_lex lucy_PList_seek_lex
  #define PList_make_matcher_t lucy_PList_make_matcher_t
  #define PList_make_matcher lucy_PList_make_matcher
  #define PList_read_raw_t lucy_PList_read_raw_t
  #define PList_read_raw lucy_PList_read_raw
  #define PList_Make Lucy_PList_Make
  #define PList_Get_RefCount Lucy_PList_Get_RefCount
  #define PList_Inc_RefCount Lucy_PList_Inc_RefCount
  #define PList_Dec_RefCount Lucy_PList_Dec_RefCount
  #define PList_To_Host Lucy_PList_To_Host
  #define PList_Clone Lucy_PList_Clone
  #define PList_Destroy Lucy_PList_Destroy
  #define PList_Equals Lucy_PList_Equals
  #define PList_Compare_To Lucy_PList_Compare_To
  #define PList_Hash_Sum Lucy_PList_Hash_Sum
  #define PList_Get_VTable Lucy_PList_Get_VTable
  #define PList_Get_Class_Name Lucy_PList_Get_Class_Name
  #define PList_Is_A Lucy_PList_Is_A
  #define PList_To_String Lucy_PList_To_String
  #define PList_To_I64 Lucy_PList_To_I64
  #define PList_To_F64 Lucy_PList_To_F64
  #define PList_To_Bool Lucy_PList_To_Bool
  #define PList_Serialize Lucy_PList_Serialize
  #define PList_Deserialize Lucy_PList_Deserialize
  #define PList_Dump Lucy_PList_Dump
  #define PList_Load Lucy_PList_Load
  #define PList_Mimic Lucy_PList_Mimic
  #define PList_Next Lucy_PList_Next
  #define PList_Advance Lucy_PList_Advance
  #define PList_Get_Doc_ID Lucy_PList_Get_Doc_ID
  #define PList_Score Lucy_PList_Score
  #define PList_Collect Lucy_PList_Collect
  #define PList_Get_Posting Lucy_PList_Get_Posting
  #define PList_Get_Doc_Freq Lucy_PList_Get_Doc_Freq
  #define PList_Seek Lucy_PList_Seek
  #define PList_Seek_Lex Lucy_PList_Seek_Lex
  #define PList_Make_Matcher Lucy_PList_Make_Matcher
  #define PList_Read_Raw Lucy_PList_Read_Raw
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTINGLIST */




