/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTINGLISTREADER
#define H_LUCY_INDEX_POSTINGLISTREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTINGLISTREADER
struct lucy_PostingListReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_POSTINGLISTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PostingListReader*
lucy_PListReader_init(lucy_PostingListReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_PostingListReader*
lucy_PListReader_aggregator(lucy_PostingListReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

lucy_PostingList*
lucy_PListReader_posting_list(lucy_PostingListReader* self, const lucy_CharBuf* field, lucy_Obj* term);

lucy_LexiconReader*
lucy_PListReader_get_lex_reader(lucy_PostingListReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PListReader_aggregator_CALLBACK;
extern cfish_Callback lucy_PListReader_posting_list_CALLBACK;
extern cfish_Callback lucy_PListReader_get_lex_reader_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_PostingListReader*
(*lucy_PListReader_aggregator_t)(lucy_PostingListReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef lucy_PostingList*
(*lucy_PListReader_posting_list_t)(lucy_PostingListReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef lucy_LexiconReader*
(*lucy_PListReader_get_lex_reader_t)(lucy_PostingListReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PListReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListReader_Make(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PListReader_Get_RefCount(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListReader_Inc_RefCount(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PListReader_Dec_RefCount(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PListReader_To_Host(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListReader_Clone(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PListReader_Destroy(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PListReader_Equals(const lucy_PostingListReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PListReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PListReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PListReader_Compare_To(const lucy_PostingListReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PListReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PListReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PListReader_Hash_Sum(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PListReader_Get_VTable(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PListReader_Get_Class_Name(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PListReader_Is_A(const lucy_PostingListReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PListReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PListReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PListReader_To_String(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PListReader_To_I64(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PListReader_To_F64(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PListReader_To_Bool(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PListReader_Serialize(const lucy_PostingListReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PListReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PListReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListReader_Deserialize(const lucy_PostingListReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PListReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PListReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListReader_Dump(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListReader_Load(const lucy_PostingListReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PListReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PListReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PListReader_Mimic(const lucy_PostingListReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PListReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PListReader_Aggregator_OFFSET;
static CHY_INLINE lucy_PostingListReader*
Lucy_PListReader_Aggregator(const lucy_PostingListReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_PListReader_Aggregator_OFFSET;
    const lucy_PListReader_aggregator_t method = *((lucy_PListReader_aggregator_t*)method_address);
    return method((lucy_PostingListReader*)self, readers, offsets);
}

extern size_t Lucy_PListReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PListReader_Get_Schema(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PListReader_Get_Folder(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PListReader_Get_Snapshot(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PListReader_Get_Segments(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PListReader_Get_Segment(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_PListReader_Get_Seg_Tick(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Close_OFFSET;
static CHY_INLINE void
Lucy_PListReader_Close(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_PListReader_Posting_List_OFFSET;
static CHY_INLINE lucy_PostingList*
Lucy_PListReader_Posting_List(const lucy_PostingListReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_PListReader_Posting_List_OFFSET;
    const lucy_PListReader_posting_list_t method = *((lucy_PListReader_posting_list_t*)method_address);
    return method((lucy_PostingListReader*)self, field, term);
}

extern size_t Lucy_PListReader_Get_Lex_Reader_OFFSET;
static CHY_INLINE lucy_LexiconReader*
Lucy_PListReader_Get_Lex_Reader(const lucy_PostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_PListReader_Get_Lex_Reader_OFFSET;
    const lucy_PListReader_get_lex_reader_t method = *((lucy_PListReader_get_lex_reader_t*)method_address);
    return method((lucy_PostingListReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POSTINGLISTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_POSTINGLISTREADER_VT;
extern struct LUCY_POSTINGLISTREADER_VT LUCY_POSTINGLISTREADER_vt;
#define LUCY_POSTINGLISTREADER ((cfish_VTable*)&LUCY_POSTINGLISTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PostingListReader lucy_PostingListReader
  #define POSTINGLISTREADER LUCY_POSTINGLISTREADER
  #define PListReader_init lucy_PListReader_init
  #define PListReader_aggregator_t lucy_PListReader_aggregator_t
  #define PListReader_aggregator lucy_PListReader_aggregator
  #define PListReader_posting_list_t lucy_PListReader_posting_list_t
  #define PListReader_posting_list lucy_PListReader_posting_list
  #define PListReader_get_lex_reader_t lucy_PListReader_get_lex_reader_t
  #define PListReader_get_lex_reader lucy_PListReader_get_lex_reader
  #define PListReader_Make Lucy_PListReader_Make
  #define PListReader_Get_RefCount Lucy_PListReader_Get_RefCount
  #define PListReader_Inc_RefCount Lucy_PListReader_Inc_RefCount
  #define PListReader_Dec_RefCount Lucy_PListReader_Dec_RefCount
  #define PListReader_To_Host Lucy_PListReader_To_Host
  #define PListReader_Clone Lucy_PListReader_Clone
  #define PListReader_Destroy Lucy_PListReader_Destroy
  #define PListReader_Equals Lucy_PListReader_Equals
  #define PListReader_Compare_To Lucy_PListReader_Compare_To
  #define PListReader_Hash_Sum Lucy_PListReader_Hash_Sum
  #define PListReader_Get_VTable Lucy_PListReader_Get_VTable
  #define PListReader_Get_Class_Name Lucy_PListReader_Get_Class_Name
  #define PListReader_Is_A Lucy_PListReader_Is_A
  #define PListReader_To_String Lucy_PListReader_To_String
  #define PListReader_To_I64 Lucy_PListReader_To_I64
  #define PListReader_To_F64 Lucy_PListReader_To_F64
  #define PListReader_To_Bool Lucy_PListReader_To_Bool
  #define PListReader_Serialize Lucy_PListReader_Serialize
  #define PListReader_Deserialize Lucy_PListReader_Deserialize
  #define PListReader_Dump Lucy_PListReader_Dump
  #define PListReader_Load Lucy_PListReader_Load
  #define PListReader_Mimic Lucy_PListReader_Mimic
  #define PListReader_Aggregator Lucy_PListReader_Aggregator
  #define PListReader_Get_Schema Lucy_PListReader_Get_Schema
  #define PListReader_Get_Folder Lucy_PListReader_Get_Folder
  #define PListReader_Get_Snapshot Lucy_PListReader_Get_Snapshot
  #define PListReader_Get_Segments Lucy_PListReader_Get_Segments
  #define PListReader_Get_Segment Lucy_PListReader_Get_Segment
  #define PListReader_Get_Seg_Tick Lucy_PListReader_Get_Seg_Tick
  #define PListReader_Close Lucy_PListReader_Close
  #define PListReader_Posting_List Lucy_PListReader_Posting_List
  #define PListReader_Get_Lex_Reader Lucy_PListReader_Get_Lex_Reader
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/PostingListReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTPOSTINGLISTREADER
struct lucy_DefaultPostingListReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_LexiconReader* lex_reader;
};

#endif /* C_LUCY_DEFAULTPOSTINGLISTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultPostingListReader*
lucy_DefPListReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick, lucy_LexiconReader* lex_reader);

lucy_DefaultPostingListReader*
lucy_DefPListReader_init(lucy_DefaultPostingListReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick, lucy_LexiconReader* lex_reader);

void
lucy_DefPListReader_destroy(lucy_DefaultPostingListReader* self);

void
lucy_DefPListReader_close(lucy_DefaultPostingListReader* self);

lucy_SegPostingList*
lucy_DefPListReader_posting_list(lucy_DefaultPostingListReader* self, const lucy_CharBuf* field, lucy_Obj* term);

lucy_LexiconReader*
lucy_DefPListReader_get_lex_reader(lucy_DefaultPostingListReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefPListReader_destroy_CALLBACK;
extern cfish_Callback lucy_DefPListReader_close_CALLBACK;
extern cfish_Callback lucy_DefPListReader_posting_list_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefPListReader_destroy_t)(lucy_DefaultPostingListReader* self);

typedef void
(*lucy_DefPListReader_close_t)(lucy_DefaultPostingListReader* self);

typedef lucy_SegPostingList*
(*lucy_DefPListReader_posting_list_t)(lucy_DefaultPostingListReader* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef lucy_LexiconReader*
(*lucy_DefPListReader_get_lex_reader_t)(lucy_DefaultPostingListReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefPListReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefPListReader_Make(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefPListReader_Get_RefCount(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefPListReader_Inc_RefCount(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefPListReader_Dec_RefCount(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefPListReader_To_Host(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefPListReader_Clone(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefPListReader_Destroy(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Destroy_OFFSET;
    const lucy_DefPListReader_destroy_t method = *((lucy_DefPListReader_destroy_t*)method_address);
    method((lucy_DefaultPostingListReader*)self);
}

extern size_t Lucy_DefPListReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefPListReader_Equals(const lucy_DefaultPostingListReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefPListReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefPListReader_Compare_To(const lucy_DefaultPostingListReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefPListReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefPListReader_Hash_Sum(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefPListReader_Get_VTable(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefPListReader_Get_Class_Name(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefPListReader_Is_A(const lucy_DefaultPostingListReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefPListReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefPListReader_To_String(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefPListReader_To_I64(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefPListReader_To_F64(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefPListReader_To_Bool(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefPListReader_Serialize(const lucy_DefaultPostingListReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefPListReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefPListReader_Deserialize(const lucy_DefaultPostingListReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefPListReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefPListReader_Dump(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefPListReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefPListReader_Load(const lucy_DefaultPostingListReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefPListReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefPListReader_Mimic(const lucy_DefaultPostingListReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefPListReader_Aggregator_OFFSET;
static CHY_INLINE lucy_PostingListReader*
Lucy_DefPListReader_Aggregator(const lucy_DefaultPostingListReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Aggregator_OFFSET;
    const lucy_PListReader_aggregator_t method = *((lucy_PListReader_aggregator_t*)method_address);
    return method((lucy_PostingListReader*)self, readers, offsets);
}

extern size_t Lucy_DefPListReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefPListReader_Get_Schema(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefPListReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefPListReader_Get_Folder(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefPListReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefPListReader_Get_Snapshot(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefPListReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DefPListReader_Get_Segments(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefPListReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefPListReader_Get_Segment(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefPListReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DefPListReader_Get_Seg_Tick(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefPListReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DefPListReader_Close(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Close_OFFSET;
    const lucy_DefPListReader_close_t method = *((lucy_DefPListReader_close_t*)method_address);
    method((lucy_DefaultPostingListReader*)self);
}

extern size_t Lucy_DefPListReader_Posting_List_OFFSET;
static CHY_INLINE lucy_SegPostingList*
Lucy_DefPListReader_Posting_List(const lucy_DefaultPostingListReader *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Posting_List_OFFSET;
    const lucy_DefPListReader_posting_list_t method = *((lucy_DefPListReader_posting_list_t*)method_address);
    return method((lucy_DefaultPostingListReader*)self, field, term);
}

extern size_t Lucy_DefPListReader_Get_Lex_Reader_OFFSET;
static CHY_INLINE lucy_LexiconReader*
Lucy_DefPListReader_Get_Lex_Reader(const lucy_DefaultPostingListReader *self) {
    char *const method_address = *(char**)self + Lucy_DefPListReader_Get_Lex_Reader_OFFSET;
    const lucy_DefPListReader_get_lex_reader_t method = *((lucy_DefPListReader_get_lex_reader_t*)method_address);
    return method((lucy_DefaultPostingListReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTPOSTINGLISTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_DEFAULTPOSTINGLISTREADER_VT;
extern struct LUCY_DEFAULTPOSTINGLISTREADER_VT LUCY_DEFAULTPOSTINGLISTREADER_vt;
#define LUCY_DEFAULTPOSTINGLISTREADER ((cfish_VTable*)&LUCY_DEFAULTPOSTINGLISTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultPostingListReader lucy_DefaultPostingListReader
  #define DEFAULTPOSTINGLISTREADER LUCY_DEFAULTPOSTINGLISTREADER
  #define DefPListReader_new lucy_DefPListReader_new
  #define DefPListReader_init lucy_DefPListReader_init
  #define DefPListReader_destroy_t lucy_DefPListReader_destroy_t
  #define DefPListReader_destroy lucy_DefPListReader_destroy
  #define DefPListReader_close_t lucy_DefPListReader_close_t
  #define DefPListReader_close lucy_DefPListReader_close
  #define DefPListReader_posting_list_t lucy_DefPListReader_posting_list_t
  #define DefPListReader_posting_list lucy_DefPListReader_posting_list
  #define DefPListReader_get_lex_reader_t lucy_DefPListReader_get_lex_reader_t
  #define DefPListReader_get_lex_reader lucy_DefPListReader_get_lex_reader
  #define DefPListReader_Make Lucy_DefPListReader_Make
  #define DefPListReader_Get_RefCount Lucy_DefPListReader_Get_RefCount
  #define DefPListReader_Inc_RefCount Lucy_DefPListReader_Inc_RefCount
  #define DefPListReader_Dec_RefCount Lucy_DefPListReader_Dec_RefCount
  #define DefPListReader_To_Host Lucy_DefPListReader_To_Host
  #define DefPListReader_Clone Lucy_DefPListReader_Clone
  #define DefPListReader_Destroy Lucy_DefPListReader_Destroy
  #define DefPListReader_Equals Lucy_DefPListReader_Equals
  #define DefPListReader_Compare_To Lucy_DefPListReader_Compare_To
  #define DefPListReader_Hash_Sum Lucy_DefPListReader_Hash_Sum
  #define DefPListReader_Get_VTable Lucy_DefPListReader_Get_VTable
  #define DefPListReader_Get_Class_Name Lucy_DefPListReader_Get_Class_Name
  #define DefPListReader_Is_A Lucy_DefPListReader_Is_A
  #define DefPListReader_To_String Lucy_DefPListReader_To_String
  #define DefPListReader_To_I64 Lucy_DefPListReader_To_I64
  #define DefPListReader_To_F64 Lucy_DefPListReader_To_F64
  #define DefPListReader_To_Bool Lucy_DefPListReader_To_Bool
  #define DefPListReader_Serialize Lucy_DefPListReader_Serialize
  #define DefPListReader_Deserialize Lucy_DefPListReader_Deserialize
  #define DefPListReader_Dump Lucy_DefPListReader_Dump
  #define DefPListReader_Load Lucy_DefPListReader_Load
  #define DefPListReader_Mimic Lucy_DefPListReader_Mimic
  #define DefPListReader_Aggregator Lucy_DefPListReader_Aggregator
  #define DefPListReader_Get_Schema Lucy_DefPListReader_Get_Schema
  #define DefPListReader_Get_Folder Lucy_DefPListReader_Get_Folder
  #define DefPListReader_Get_Snapshot Lucy_DefPListReader_Get_Snapshot
  #define DefPListReader_Get_Segments Lucy_DefPListReader_Get_Segments
  #define DefPListReader_Get_Segment Lucy_DefPListReader_Get_Segment
  #define DefPListReader_Get_Seg_Tick Lucy_DefPListReader_Get_Seg_Tick
  #define DefPListReader_Close Lucy_DefPListReader_Close
  #define DefPListReader_Posting_List Lucy_DefPListReader_Posting_List
  #define DefPListReader_Get_Lex_Reader Lucy_DefPListReader_Get_Lex_Reader
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTINGLISTREADER */




