/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTINGLISTWRITER
#define H_LUCY_INDEX_POSTINGLISTWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTINGLISTWRITER
struct lucy_PostingListWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_LexiconWriter* lex_writer;
    lucy_VArray* pools;
    lucy_MemoryPool* mem_pool;
    lucy_OutStream* lex_temp_out;
    lucy_OutStream* post_temp_out;
    lucy_OutStream* skip_out;
    uint32_t mem_thresh;
};

#endif /* C_LUCY_POSTINGLISTWRITER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_PListWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PostingListWriter*
lucy_PListWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, lucy_LexiconWriter* lex_writer);

lucy_PostingListWriter*
lucy_PListWriter_init(lucy_PostingListWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, lucy_LexiconWriter* lex_writer);

void
lucy_PListWriter_set_default_mem_thresh(size_t mem_thresh);

void
lucy_PListWriter_destroy(lucy_PostingListWriter* self);

void
lucy_PListWriter_add_inverted_doc(lucy_PostingListWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
lucy_PListWriter_add_segment(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_PListWriter_finish(lucy_PostingListWriter* self);

int32_t
lucy_PListWriter_format(lucy_PostingListWriter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PListWriter_destroy_CALLBACK;
extern cfish_Callback lucy_PListWriter_add_inverted_doc_CALLBACK;
extern cfish_Callback lucy_PListWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_PListWriter_finish_CALLBACK;
extern cfish_Callback lucy_PListWriter_format_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PListWriter_destroy_t)(lucy_PostingListWriter* self);

typedef void
(*lucy_PListWriter_add_inverted_doc_t)(lucy_PostingListWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*lucy_PListWriter_add_segment_t)(lucy_PostingListWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_PListWriter_finish_t)(lucy_PostingListWriter* self);

typedef int32_t
(*lucy_PListWriter_format_t)(lucy_PostingListWriter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PListWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListWriter_Make(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PListWriter_Get_RefCount(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListWriter_Inc_RefCount(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PListWriter_Dec_RefCount(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PListWriter_To_Host(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListWriter_Clone(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Destroy(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Destroy_OFFSET;
    const lucy_PListWriter_destroy_t method = *((lucy_PListWriter_destroy_t*)method_address);
    method((lucy_PostingListWriter*)self);
}

extern size_t Lucy_PListWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PListWriter_Equals(const lucy_PostingListWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PListWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PListWriter_Compare_To(const lucy_PostingListWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PListWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PListWriter_Hash_Sum(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PListWriter_Get_VTable(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PListWriter_Get_Class_Name(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PListWriter_Is_A(const lucy_PostingListWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PListWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PListWriter_To_String(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PListWriter_To_I64(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PListWriter_To_F64(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PListWriter_To_Bool(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Serialize(const lucy_PostingListWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PListWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListWriter_Deserialize(const lucy_PostingListWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PListWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListWriter_Dump(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PListWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PListWriter_Load(const lucy_PostingListWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PListWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Mimic(const lucy_PostingListWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PListWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Add_Inverted_Doc(const lucy_PostingListWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Add_Inverted_Doc_OFFSET;
    const lucy_PListWriter_add_inverted_doc_t method = *((lucy_PListWriter_add_inverted_doc_t*)method_address);
    method((lucy_PostingListWriter*)self, inverter, doc_id);
}

extern size_t Lucy_PListWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Add_Segment(const lucy_PostingListWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Add_Segment_OFFSET;
    const lucy_PListWriter_add_segment_t method = *((lucy_PListWriter_add_segment_t*)method_address);
    method((lucy_PostingListWriter*)self, reader, doc_map);
}

extern size_t Lucy_PListWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Delete_Segment(const lucy_PostingListWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_PListWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Merge_Segment(const lucy_PostingListWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_PListWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_PListWriter_Finish(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Finish_OFFSET;
    const lucy_PListWriter_finish_t method = *((lucy_PListWriter_finish_t*)method_address);
    method((lucy_PostingListWriter*)self);
}

extern size_t Lucy_PListWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_PListWriter_Metadata(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PListWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_PListWriter_Format(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Format_OFFSET;
    const lucy_PListWriter_format_t method = *((lucy_PListWriter_format_t*)method_address);
    return method((lucy_PostingListWriter*)self);
}

extern size_t Lucy_PListWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_PListWriter_Get_Snapshot(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PListWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_PListWriter_Get_Segment(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PListWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_PListWriter_Get_PolyReader(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PListWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PListWriter_Get_Schema(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_PListWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_PListWriter_Get_Folder(const lucy_PostingListWriter *self) {
    char *const method_address = *(char**)self + Lucy_PListWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POSTINGLISTWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[34];
} LUCY_POSTINGLISTWRITER_VT;
extern struct LUCY_POSTINGLISTWRITER_VT LUCY_POSTINGLISTWRITER_vt;
#define LUCY_POSTINGLISTWRITER ((cfish_VTable*)&LUCY_POSTINGLISTWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PostingListWriter lucy_PostingListWriter
  #define POSTINGLISTWRITER LUCY_POSTINGLISTWRITER
  #define PListWriter_new lucy_PListWriter_new
  #define PListWriter_init lucy_PListWriter_init
  #define PListWriter_set_default_mem_thresh lucy_PListWriter_set_default_mem_thresh
  #define PListWriter_current_file_format lucy_PListWriter_current_file_format
  #define PListWriter_destroy_t lucy_PListWriter_destroy_t
  #define PListWriter_destroy lucy_PListWriter_destroy
  #define PListWriter_add_inverted_doc_t lucy_PListWriter_add_inverted_doc_t
  #define PListWriter_add_inverted_doc lucy_PListWriter_add_inverted_doc
  #define PListWriter_add_segment_t lucy_PListWriter_add_segment_t
  #define PListWriter_add_segment lucy_PListWriter_add_segment
  #define PListWriter_finish_t lucy_PListWriter_finish_t
  #define PListWriter_finish lucy_PListWriter_finish
  #define PListWriter_format_t lucy_PListWriter_format_t
  #define PListWriter_format lucy_PListWriter_format
  #define PListWriter_Make Lucy_PListWriter_Make
  #define PListWriter_Get_RefCount Lucy_PListWriter_Get_RefCount
  #define PListWriter_Inc_RefCount Lucy_PListWriter_Inc_RefCount
  #define PListWriter_Dec_RefCount Lucy_PListWriter_Dec_RefCount
  #define PListWriter_To_Host Lucy_PListWriter_To_Host
  #define PListWriter_Clone Lucy_PListWriter_Clone
  #define PListWriter_Destroy Lucy_PListWriter_Destroy
  #define PListWriter_Equals Lucy_PListWriter_Equals
  #define PListWriter_Compare_To Lucy_PListWriter_Compare_To
  #define PListWriter_Hash_Sum Lucy_PListWriter_Hash_Sum
  #define PListWriter_Get_VTable Lucy_PListWriter_Get_VTable
  #define PListWriter_Get_Class_Name Lucy_PListWriter_Get_Class_Name
  #define PListWriter_Is_A Lucy_PListWriter_Is_A
  #define PListWriter_To_String Lucy_PListWriter_To_String
  #define PListWriter_To_I64 Lucy_PListWriter_To_I64
  #define PListWriter_To_F64 Lucy_PListWriter_To_F64
  #define PListWriter_To_Bool Lucy_PListWriter_To_Bool
  #define PListWriter_Serialize Lucy_PListWriter_Serialize
  #define PListWriter_Deserialize Lucy_PListWriter_Deserialize
  #define PListWriter_Dump Lucy_PListWriter_Dump
  #define PListWriter_Load Lucy_PListWriter_Load
  #define PListWriter_Mimic Lucy_PListWriter_Mimic
  #define PListWriter_Add_Inverted_Doc Lucy_PListWriter_Add_Inverted_Doc
  #define PListWriter_Add_Segment Lucy_PListWriter_Add_Segment
  #define PListWriter_Delete_Segment Lucy_PListWriter_Delete_Segment
  #define PListWriter_Merge_Segment Lucy_PListWriter_Merge_Segment
  #define PListWriter_Finish Lucy_PListWriter_Finish
  #define PListWriter_Metadata Lucy_PListWriter_Metadata
  #define PListWriter_Format Lucy_PListWriter_Format
  #define PListWriter_Get_Snapshot Lucy_PListWriter_Get_Snapshot
  #define PListWriter_Get_Segment Lucy_PListWriter_Get_Segment
  #define PListWriter_Get_PolyReader Lucy_PListWriter_Get_PolyReader
  #define PListWriter_Get_Schema Lucy_PListWriter_Get_Schema
  #define PListWriter_Get_Folder Lucy_PListWriter_Get_Folder
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTINGLISTWRITER */




