/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_POSTINGPOOL
#define H_LUCY_INDEX_POSTINGPOOL 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/SortExternal.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POSTINGPOOL
struct lucy_PostingPool {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint8_t* cache;
    uint32_t cache_cap;
    uint32_t cache_max;
    uint32_t cache_tick;
    uint8_t* scratch;
    uint32_t scratch_cap;
    lucy_VArray* runs;
    uint32_t num_slices;
    uint8_t** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    size_t width;
    chy_bool_t flipped;
    lucy_Schema* schema;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_CharBuf* field;
    lucy_LexiconWriter* lex_writer;
    lucy_Lexicon* lexicon;
    lucy_PostingList* plist;
    lucy_MemoryPool* mem_pool;
    lucy_I32Array* doc_map;
    int32_t field_num;
    int32_t doc_base;
    int32_t last_doc_id;
    uint32_t post_count;
    lucy_OutStream* lex_temp_out;
    lucy_OutStream* post_temp_out;
    lucy_OutStream* skip_out;
    lucy_InStream* lex_temp_in;
    lucy_InStream* post_temp_in;
    lucy_FieldType* type;
    lucy_Posting* posting;
    lucy_SkipStepper* skip_stepper;
    int64_t lex_start;
    int64_t post_start;
    int64_t lex_end;
    int64_t post_end;
};

#endif /* C_LUCY_POSTINGPOOL */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PostingPool*
lucy_PostPool_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, const lucy_CharBuf* field, lucy_LexiconWriter* lex_writer, lucy_MemoryPool* mem_pool, lucy_OutStream* lex_temp_out, lucy_OutStream* post_temp_out, lucy_OutStream* skip_out);

lucy_PostingPool*
lucy_PostPool_init(lucy_PostingPool* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, const lucy_CharBuf* field, lucy_LexiconWriter* lex_writer, lucy_MemoryPool* mem_pool, lucy_OutStream* lex_temp_out, lucy_OutStream* post_temp_out, lucy_OutStream* skip_out);

void
lucy_PostPool_destroy(lucy_PostingPool* self);

int
lucy_PostPool_compare(lucy_PostingPool* self, void* va, void* vb);

void
lucy_PostPool_flush(lucy_PostingPool* self);

void
lucy_PostPool_flip(lucy_PostingPool* self);

uint32_t
lucy_PostPool_refill(lucy_PostingPool* self);

void
lucy_PostPool_add_inversion(lucy_PostingPool* self, lucy_Inversion* inversion, int32_t doc_id, float doc_boost, float length_norm);

void
lucy_PostPool_shrink(lucy_PostingPool* self);

lucy_MemoryPool*
lucy_PostPool_get_mem_pool(lucy_PostingPool* self);

void
lucy_PostPool_add_segment(lucy_PostingPool* self, lucy_SegReader* reader, lucy_I32Array* doc_map, int32_t doc_base);

void
lucy_PostPool_finish(lucy_PostingPool* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PostPool_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PostPool_destroy_t)(lucy_PostingPool* self);

typedef int
(*lucy_PostPool_compare_t)(lucy_PostingPool* self, void* va, void* vb);

typedef void
(*lucy_PostPool_flush_t)(lucy_PostingPool* self);

typedef void
(*lucy_PostPool_flip_t)(lucy_PostingPool* self);

typedef uint32_t
(*lucy_PostPool_refill_t)(lucy_PostingPool* self);

typedef void
(*lucy_PostPool_add_inversion_t)(lucy_PostingPool* self, lucy_Inversion* inversion, int32_t doc_id, float doc_boost, float length_norm);

typedef void
(*lucy_PostPool_shrink_t)(lucy_PostingPool* self);

typedef lucy_MemoryPool*
(*lucy_PostPool_get_mem_pool_t)(lucy_PostingPool* self);

typedef void
(*lucy_PostPool_add_segment_t)(lucy_PostingPool* self, lucy_SegReader* reader, lucy_I32Array* doc_map, int32_t doc_base);

typedef void
(*lucy_PostPool_finish_t)(lucy_PostingPool* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PostPool_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostPool_Make(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PostPool_Get_RefCount(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostPool_Inc_RefCount(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PostPool_Dec_RefCount(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PostPool_To_Host(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostPool_Clone(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Destroy(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Destroy_OFFSET;
    const lucy_PostPool_destroy_t method = *((lucy_PostPool_destroy_t*)method_address);
    method((lucy_PostingPool*)self);
}

extern size_t Lucy_PostPool_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PostPool_Equals(const lucy_PostingPool *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PostPool_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PostPool_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PostPool_Compare_To(const lucy_PostingPool *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PostPool_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PostPool_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PostPool_Hash_Sum(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PostPool_Get_VTable(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PostPool_Get_Class_Name(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PostPool_Is_A(const lucy_PostingPool *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PostPool_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PostPool_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PostPool_To_String(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PostPool_To_I64(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PostPool_To_F64(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PostPool_To_Bool(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Serialize(const lucy_PostingPool *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PostPool_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PostPool_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostPool_Deserialize(const lucy_PostingPool *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PostPool_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PostPool_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostPool_Dump(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PostPool_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PostPool_Load(const lucy_PostingPool *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PostPool_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PostPool_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Mimic(const lucy_PostingPool *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PostPool_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PostPool_Compare_OFFSET;
static CHY_INLINE int
Lucy_PostPool_Compare(const lucy_PostingPool *self, void* va, void* vb) {
    char *const method_address = *(char**)self + Lucy_PostPool_Compare_OFFSET;
    const lucy_PostPool_compare_t method = *((lucy_PostPool_compare_t*)method_address);
    return method((lucy_PostingPool*)self, va, vb);
}

extern size_t Lucy_PostPool_Flush_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Flush(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Flush_OFFSET;
    const lucy_PostPool_flush_t method = *((lucy_PostPool_flush_t*)method_address);
    method((lucy_PostingPool*)self);
}

extern size_t Lucy_PostPool_Feed_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Feed(const lucy_PostingPool *self, void* data) {
    char *const method_address = *(char**)self + Lucy_PostPool_Feed_OFFSET;
    const lucy_SortEx_feed_t method = *((lucy_SortEx_feed_t*)method_address);
    method((lucy_SortExternal*)self, data);
}

extern size_t Lucy_PostPool_Flip_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Flip(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Flip_OFFSET;
    const lucy_PostPool_flip_t method = *((lucy_PostPool_flip_t*)method_address);
    method((lucy_PostingPool*)self);
}

extern size_t Lucy_PostPool_Fetch_OFFSET;
static CHY_INLINE void*
Lucy_PostPool_Fetch(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Fetch_OFFSET;
    const lucy_SortEx_fetch_t method = *((lucy_SortEx_fetch_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_PostPool_Peek_OFFSET;
static CHY_INLINE void*
Lucy_PostPool_Peek(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Peek_OFFSET;
    const lucy_SortEx_peek_t method = *((lucy_SortEx_peek_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_PostPool_Add_Run_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Add_Run(const lucy_PostingPool *self, lucy_SortExternal* run) {
    char *const method_address = *(char**)self + Lucy_PostPool_Add_Run_OFFSET;
    const lucy_SortEx_add_run_t method = *((lucy_SortEx_add_run_t*)method_address);
    method((lucy_SortExternal*)self, run);
}

extern size_t Lucy_PostPool_Refill_OFFSET;
static CHY_INLINE uint32_t
Lucy_PostPool_Refill(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Refill_OFFSET;
    const lucy_PostPool_refill_t method = *((lucy_PostPool_refill_t*)method_address);
    return method((lucy_PostingPool*)self);
}

extern size_t Lucy_PostPool_Sort_Cache_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Sort_Cache(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Sort_Cache_OFFSET;
    const lucy_SortEx_sort_cache_t method = *((lucy_SortEx_sort_cache_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_PostPool_Clear_Cache_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Clear_Cache(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Clear_Cache_OFFSET;
    const lucy_SortEx_clear_cache_t method = *((lucy_SortEx_clear_cache_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_PostPool_Cache_Count_OFFSET;
static CHY_INLINE uint32_t
Lucy_PostPool_Cache_Count(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Cache_Count_OFFSET;
    const lucy_SortEx_cache_count_t method = *((lucy_SortEx_cache_count_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_PostPool_Grow_Cache_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Grow_Cache(const lucy_PostingPool *self, uint32_t new_cache_cap) {
    char *const method_address = *(char**)self + Lucy_PostPool_Grow_Cache_OFFSET;
    const lucy_SortEx_grow_cache_t method = *((lucy_SortEx_grow_cache_t*)method_address);
    method((lucy_SortExternal*)self, new_cache_cap);
}

extern size_t Lucy_PostPool_Set_Mem_Thresh_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Set_Mem_Thresh(const lucy_PostingPool *self, uint32_t mem_thresh) {
    char *const method_address = *(char**)self + Lucy_PostPool_Set_Mem_Thresh_OFFSET;
    const lucy_SortEx_set_mem_thresh_t method = *((lucy_SortEx_set_mem_thresh_t*)method_address);
    method((lucy_SortExternal*)self, mem_thresh);
}

extern size_t Lucy_PostPool_Add_Inversion_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Add_Inversion(const lucy_PostingPool *self, lucy_Inversion* inversion, int32_t doc_id, float doc_boost, float length_norm) {
    char *const method_address = *(char**)self + Lucy_PostPool_Add_Inversion_OFFSET;
    const lucy_PostPool_add_inversion_t method = *((lucy_PostPool_add_inversion_t*)method_address);
    method((lucy_PostingPool*)self, inversion, doc_id, doc_boost, length_norm);
}

extern size_t Lucy_PostPool_Shrink_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Shrink(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Shrink_OFFSET;
    const lucy_PostPool_shrink_t method = *((lucy_PostPool_shrink_t*)method_address);
    method((lucy_PostingPool*)self);
}

extern size_t Lucy_PostPool_Get_Mem_Pool_OFFSET;
static CHY_INLINE lucy_MemoryPool*
Lucy_PostPool_Get_Mem_Pool(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Get_Mem_Pool_OFFSET;
    const lucy_PostPool_get_mem_pool_t method = *((lucy_PostPool_get_mem_pool_t*)method_address);
    return method((lucy_PostingPool*)self);
}

extern size_t Lucy_PostPool_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Add_Segment(const lucy_PostingPool *self, lucy_SegReader* reader, lucy_I32Array* doc_map, int32_t doc_base) {
    char *const method_address = *(char**)self + Lucy_PostPool_Add_Segment_OFFSET;
    const lucy_PostPool_add_segment_t method = *((lucy_PostPool_add_segment_t*)method_address);
    method((lucy_PostingPool*)self, reader, doc_map, doc_base);
}

extern size_t Lucy_PostPool_Finish_OFFSET;
static CHY_INLINE void
Lucy_PostPool_Finish(const lucy_PostingPool *self) {
    char *const method_address = *(char**)self + Lucy_PostPool_Finish_OFFSET;
    const lucy_PostPool_finish_t method = *((lucy_PostPool_finish_t*)method_address);
    method((lucy_PostingPool*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POSTINGPOOL_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[40];
} LUCY_POSTINGPOOL_VT;
extern struct LUCY_POSTINGPOOL_VT LUCY_POSTINGPOOL_vt;
#define LUCY_POSTINGPOOL ((cfish_VTable*)&LUCY_POSTINGPOOL_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PostingPool lucy_PostingPool
  #define POSTINGPOOL LUCY_POSTINGPOOL
  #define PostPool_new lucy_PostPool_new
  #define PostPool_init lucy_PostPool_init
  #define PostPool_destroy_t lucy_PostPool_destroy_t
  #define PostPool_destroy lucy_PostPool_destroy
  #define PostPool_compare_t lucy_PostPool_compare_t
  #define PostPool_compare lucy_PostPool_compare
  #define PostPool_flush_t lucy_PostPool_flush_t
  #define PostPool_flush lucy_PostPool_flush
  #define PostPool_flip_t lucy_PostPool_flip_t
  #define PostPool_flip lucy_PostPool_flip
  #define PostPool_refill_t lucy_PostPool_refill_t
  #define PostPool_refill lucy_PostPool_refill
  #define PostPool_add_inversion_t lucy_PostPool_add_inversion_t
  #define PostPool_add_inversion lucy_PostPool_add_inversion
  #define PostPool_shrink_t lucy_PostPool_shrink_t
  #define PostPool_shrink lucy_PostPool_shrink
  #define PostPool_get_mem_pool_t lucy_PostPool_get_mem_pool_t
  #define PostPool_get_mem_pool lucy_PostPool_get_mem_pool
  #define PostPool_add_segment_t lucy_PostPool_add_segment_t
  #define PostPool_add_segment lucy_PostPool_add_segment
  #define PostPool_finish_t lucy_PostPool_finish_t
  #define PostPool_finish lucy_PostPool_finish
  #define PostPool_Make Lucy_PostPool_Make
  #define PostPool_Get_RefCount Lucy_PostPool_Get_RefCount
  #define PostPool_Inc_RefCount Lucy_PostPool_Inc_RefCount
  #define PostPool_Dec_RefCount Lucy_PostPool_Dec_RefCount
  #define PostPool_To_Host Lucy_PostPool_To_Host
  #define PostPool_Clone Lucy_PostPool_Clone
  #define PostPool_Destroy Lucy_PostPool_Destroy
  #define PostPool_Equals Lucy_PostPool_Equals
  #define PostPool_Compare_To Lucy_PostPool_Compare_To
  #define PostPool_Hash_Sum Lucy_PostPool_Hash_Sum
  #define PostPool_Get_VTable Lucy_PostPool_Get_VTable
  #define PostPool_Get_Class_Name Lucy_PostPool_Get_Class_Name
  #define PostPool_Is_A Lucy_PostPool_Is_A
  #define PostPool_To_String Lucy_PostPool_To_String
  #define PostPool_To_I64 Lucy_PostPool_To_I64
  #define PostPool_To_F64 Lucy_PostPool_To_F64
  #define PostPool_To_Bool Lucy_PostPool_To_Bool
  #define PostPool_Serialize Lucy_PostPool_Serialize
  #define PostPool_Deserialize Lucy_PostPool_Deserialize
  #define PostPool_Dump Lucy_PostPool_Dump
  #define PostPool_Load Lucy_PostPool_Load
  #define PostPool_Mimic Lucy_PostPool_Mimic
  #define PostPool_Compare Lucy_PostPool_Compare
  #define PostPool_Flush Lucy_PostPool_Flush
  #define PostPool_Feed Lucy_PostPool_Feed
  #define PostPool_Flip Lucy_PostPool_Flip
  #define PostPool_Fetch Lucy_PostPool_Fetch
  #define PostPool_Peek Lucy_PostPool_Peek
  #define PostPool_Add_Run Lucy_PostPool_Add_Run
  #define PostPool_Refill Lucy_PostPool_Refill
  #define PostPool_Sort_Cache Lucy_PostPool_Sort_Cache
  #define PostPool_Clear_Cache Lucy_PostPool_Clear_Cache
  #define PostPool_Cache_Count Lucy_PostPool_Cache_Count
  #define PostPool_Grow_Cache Lucy_PostPool_Grow_Cache
  #define PostPool_Set_Mem_Thresh Lucy_PostPool_Set_Mem_Thresh
  #define PostPool_Add_Inversion Lucy_PostPool_Add_Inversion
  #define PostPool_Shrink Lucy_PostPool_Shrink
  #define PostPool_Get_Mem_Pool Lucy_PostPool_Get_Mem_Pool
  #define PostPool_Add_Segment Lucy_PostPool_Add_Segment
  #define PostPool_Finish Lucy_PostPool_Finish
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_POSTINGPOOL */




