/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_RAWPOSTINGLIST
#define H_LUCY_INDEX_RAWPOSTINGLIST 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/PostingList.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAWPOSTINGLIST
struct lucy_RawPostingList {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Posting* posting;
    lucy_InStream* instream;
    int64_t start;
    int64_t end;
    int64_t len;
};

#endif /* C_LUCY_RAWPOSTINGLIST */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RawPostingList*
lucy_RawPList_new(lucy_Schema* schema, const lucy_CharBuf* field, lucy_InStream* instream, int64_t start, int64_t end);

lucy_RawPostingList*
lucy_RawPList_init(lucy_RawPostingList* self, lucy_Schema* schema, const lucy_CharBuf* field, lucy_InStream* instream, int64_t lex_start, int64_t lex_end);

void
lucy_RawPList_destroy(lucy_RawPostingList* self);

lucy_Posting*
lucy_RawPList_get_posting(lucy_RawPostingList* self);

lucy_RawPosting*
lucy_RawPList_read_raw(lucy_RawPostingList* self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RawPList_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RawPList_destroy_t)(lucy_RawPostingList* self);

typedef lucy_Posting*
(*lucy_RawPList_get_posting_t)(lucy_RawPostingList* self);

typedef lucy_RawPosting*
(*lucy_RawPList_read_raw_t)(lucy_RawPostingList* self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RawPList_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPList_Make(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPList_Get_RefCount(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPList_Inc_RefCount(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPList_Dec_RefCount(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RawPList_To_Host(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPList_Clone(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RawPList_Destroy(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Destroy_OFFSET;
    const lucy_RawPList_destroy_t method = *((lucy_RawPList_destroy_t*)method_address);
    method((lucy_RawPostingList*)self);
}

extern size_t Lucy_RawPList_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPList_Equals(const lucy_RawPostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPList_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPList_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPList_Compare_To(const lucy_RawPostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPList_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPList_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPList_Hash_Sum(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RawPList_Get_VTable(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RawPList_Get_Class_Name(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPList_Is_A(const lucy_RawPostingList *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RawPList_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RawPList_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RawPList_To_String(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RawPList_To_I64(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RawPList_To_F64(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RawPList_To_Bool(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RawPList_Serialize(const lucy_RawPostingList *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RawPList_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RawPList_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPList_Deserialize(const lucy_RawPostingList *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RawPList_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RawPList_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPList_Dump(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RawPList_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RawPList_Load(const lucy_RawPostingList *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RawPList_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RawPList_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RawPList_Mimic(const lucy_RawPostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RawPList_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RawPList_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPList_Next(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Next_OFFSET;
    const lucy_Matcher_next_t method = *((lucy_Matcher_next_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_RawPList_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPList_Advance(const lucy_RawPostingList *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_RawPList_Advance_OFFSET;
    const lucy_Matcher_advance_t method = *((lucy_Matcher_advance_t*)method_address);
    return method((lucy_Matcher*)self, target);
}

extern size_t Lucy_RawPList_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_RawPList_Get_Doc_ID(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Get_Doc_ID_OFFSET;
    const lucy_Matcher_get_doc_id_t method = *((lucy_Matcher_get_doc_id_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_RawPList_Score_OFFSET;
static CHY_INLINE float
Lucy_RawPList_Score(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Score_OFFSET;
    const lucy_Matcher_score_t method = *((lucy_Matcher_score_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_RawPList_Collect_OFFSET;
static CHY_INLINE void
Lucy_RawPList_Collect(const lucy_RawPostingList *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_RawPList_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}

extern size_t Lucy_RawPList_Get_Posting_OFFSET;
static CHY_INLINE lucy_Posting*
Lucy_RawPList_Get_Posting(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Get_Posting_OFFSET;
    const lucy_RawPList_get_posting_t method = *((lucy_RawPList_get_posting_t*)method_address);
    return method((lucy_RawPostingList*)self);
}

extern size_t Lucy_RawPList_Get_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_RawPList_Get_Doc_Freq(const lucy_RawPostingList *self) {
    char *const method_address = *(char**)self + Lucy_RawPList_Get_Doc_Freq_OFFSET;
    const lucy_PList_get_doc_freq_t method = *((lucy_PList_get_doc_freq_t*)method_address);
    return method((lucy_PostingList*)self);
}

extern size_t Lucy_RawPList_Seek_OFFSET;
static CHY_INLINE void
Lucy_RawPList_Seek(const lucy_RawPostingList *self, lucy_Obj* target) {
    char *const method_address = *(char**)self + Lucy_RawPList_Seek_OFFSET;
    const lucy_PList_seek_t method = *((lucy_PList_seek_t*)method_address);
    method((lucy_PostingList*)self, target);
}

extern size_t Lucy_RawPList_Seek_Lex_OFFSET;
static CHY_INLINE void
Lucy_RawPList_Seek_Lex(const lucy_RawPostingList *self, lucy_Lexicon* lexicon) {
    char *const method_address = *(char**)self + Lucy_RawPList_Seek_Lex_OFFSET;
    const lucy_PList_seek_lex_t method = *((lucy_PList_seek_lex_t*)method_address);
    method((lucy_PostingList*)self, lexicon);
}

extern size_t Lucy_RawPList_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_RawPList_Make_Matcher(const lucy_RawPostingList *self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_RawPList_Make_Matcher_OFFSET;
    const lucy_PList_make_matcher_t method = *((lucy_PList_make_matcher_t*)method_address);
    return method((lucy_PostingList*)self, similarity, compiler, need_score);
}

extern size_t Lucy_RawPList_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_RawPList_Read_Raw(const lucy_RawPostingList *self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_RawPList_Read_Raw_OFFSET;
    const lucy_RawPList_read_raw_t method = *((lucy_RawPList_read_raw_t*)method_address);
    return method((lucy_RawPostingList*)self, last_doc_id, term_text, mem_pool);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RAWPOSTINGLIST_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_RAWPOSTINGLIST_VT;
extern struct LUCY_RAWPOSTINGLIST_VT LUCY_RAWPOSTINGLIST_vt;
#define LUCY_RAWPOSTINGLIST ((cfish_VTable*)&LUCY_RAWPOSTINGLIST_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RawPostingList lucy_RawPostingList
  #define RAWPOSTINGLIST LUCY_RAWPOSTINGLIST
  #define RawPList_new lucy_RawPList_new
  #define RawPList_init lucy_RawPList_init
  #define RawPList_destroy_t lucy_RawPList_destroy_t
  #define RawPList_destroy lucy_RawPList_destroy
  #define RawPList_get_posting_t lucy_RawPList_get_posting_t
  #define RawPList_get_posting lucy_RawPList_get_posting
  #define RawPList_read_raw_t lucy_RawPList_read_raw_t
  #define RawPList_read_raw lucy_RawPList_read_raw
  #define RawPList_Make Lucy_RawPList_Make
  #define RawPList_Get_RefCount Lucy_RawPList_Get_RefCount
  #define RawPList_Inc_RefCount Lucy_RawPList_Inc_RefCount
  #define RawPList_Dec_RefCount Lucy_RawPList_Dec_RefCount
  #define RawPList_To_Host Lucy_RawPList_To_Host
  #define RawPList_Clone Lucy_RawPList_Clone
  #define RawPList_Destroy Lucy_RawPList_Destroy
  #define RawPList_Equals Lucy_RawPList_Equals
  #define RawPList_Compare_To Lucy_RawPList_Compare_To
  #define RawPList_Hash_Sum Lucy_RawPList_Hash_Sum
  #define RawPList_Get_VTable Lucy_RawPList_Get_VTable
  #define RawPList_Get_Class_Name Lucy_RawPList_Get_Class_Name
  #define RawPList_Is_A Lucy_RawPList_Is_A
  #define RawPList_To_String Lucy_RawPList_To_String
  #define RawPList_To_I64 Lucy_RawPList_To_I64
  #define RawPList_To_F64 Lucy_RawPList_To_F64
  #define RawPList_To_Bool Lucy_RawPList_To_Bool
  #define RawPList_Serialize Lucy_RawPList_Serialize
  #define RawPList_Deserialize Lucy_RawPList_Deserialize
  #define RawPList_Dump Lucy_RawPList_Dump
  #define RawPList_Load Lucy_RawPList_Load
  #define RawPList_Mimic Lucy_RawPList_Mimic
  #define RawPList_Next Lucy_RawPList_Next
  #define RawPList_Advance Lucy_RawPList_Advance
  #define RawPList_Get_Doc_ID Lucy_RawPList_Get_Doc_ID
  #define RawPList_Score Lucy_RawPList_Score
  #define RawPList_Collect Lucy_RawPList_Collect
  #define RawPList_Get_Posting Lucy_RawPList_Get_Posting
  #define RawPList_Get_Doc_Freq Lucy_RawPList_Get_Doc_Freq
  #define RawPList_Seek Lucy_RawPList_Seek
  #define RawPList_Seek_Lex Lucy_RawPList_Seek_Lex
  #define RawPList_Make_Matcher Lucy_RawPList_Make_Matcher
  #define RawPList_Read_Raw Lucy_RawPList_Read_Raw
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_RAWPOSTINGLIST */




