/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SEGLEXICON
#define H_LUCY_INDEX_SEGLEXICON 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/Lexicon.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGLEXICON
struct lucy_SegLexicon {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_Segment* segment;
    lucy_TermStepper* term_stepper;
    lucy_TermStepper* tinfo_stepper;
    lucy_InStream* instream;
    lucy_LexIndex* lex_index;
    int32_t field_num;
    int32_t size;
    int32_t term_num;
    int32_t skip_interval;
    int32_t index_interval;
};

#endif /* C_LUCY_SEGLEXICON */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SegLexicon*
lucy_SegLex_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Segment* segment, const lucy_CharBuf* field);

lucy_SegLexicon*
lucy_SegLex_init(lucy_SegLexicon* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Segment* segment, const lucy_CharBuf* field);

void
lucy_SegLex_destroy(lucy_SegLexicon* self);

void
lucy_SegLex_seek(lucy_SegLexicon* self, lucy_Obj* target);

chy_bool_t
lucy_SegLex_next(lucy_SegLexicon* self);

void
lucy_SegLex_reset(lucy_SegLexicon* self);

int32_t
lucy_SegLex_doc_freq(lucy_SegLexicon* self);

lucy_Obj*
lucy_SegLex_get_term(lucy_SegLexicon* self);

lucy_TermInfo*
lucy_SegLex_get_term_info(lucy_SegLexicon* self);

int32_t
lucy_SegLex_get_field_num(lucy_SegLexicon* self);

lucy_Segment*
lucy_SegLex_get_segment(lucy_SegLexicon* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SegLex_destroy_CALLBACK;
extern cfish_Callback lucy_SegLex_seek_CALLBACK;
extern cfish_Callback lucy_SegLex_next_CALLBACK;
extern cfish_Callback lucy_SegLex_reset_CALLBACK;
extern cfish_Callback lucy_SegLex_doc_freq_CALLBACK;
extern cfish_Callback lucy_SegLex_get_term_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SegLex_destroy_t)(lucy_SegLexicon* self);

typedef void
(*lucy_SegLex_seek_t)(lucy_SegLexicon* self, lucy_Obj* target);

typedef chy_bool_t
(*lucy_SegLex_next_t)(lucy_SegLexicon* self);

typedef void
(*lucy_SegLex_reset_t)(lucy_SegLexicon* self);

typedef int32_t
(*lucy_SegLex_doc_freq_t)(lucy_SegLexicon* self);

typedef lucy_Obj*
(*lucy_SegLex_get_term_t)(lucy_SegLexicon* self);

typedef lucy_TermInfo*
(*lucy_SegLex_get_term_info_t)(lucy_SegLexicon* self);

typedef int32_t
(*lucy_SegLex_get_field_num_t)(lucy_SegLexicon* self);

typedef lucy_Segment*
(*lucy_SegLex_get_segment_t)(lucy_SegLexicon* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SegLex_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Make(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegLex_Get_RefCount(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Inc_RefCount(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegLex_Dec_RefCount(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SegLex_To_Host(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Clone(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SegLex_Destroy(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Destroy_OFFSET;
    const lucy_SegLex_destroy_t method = *((lucy_SegLex_destroy_t*)method_address);
    method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLex_Equals(const lucy_SegLexicon *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegLex_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegLex_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SegLex_Compare_To(const lucy_SegLexicon *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegLex_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegLex_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SegLex_Hash_Sum(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SegLex_Get_VTable(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegLex_Get_Class_Name(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLex_Is_A(const lucy_SegLexicon *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SegLex_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SegLex_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegLex_To_String(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SegLex_To_I64(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SegLex_To_F64(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLex_To_Bool(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SegLex_Serialize(const lucy_SegLexicon *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SegLex_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SegLex_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Deserialize(const lucy_SegLexicon *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SegLex_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SegLex_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Dump(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegLex_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Load(const lucy_SegLexicon *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SegLex_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SegLex_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SegLex_Mimic(const lucy_SegLexicon *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegLex_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegLex_Seek_OFFSET;
static CHY_INLINE void
Lucy_SegLex_Seek(const lucy_SegLexicon *self, lucy_Obj* target) {
    char *const method_address = *(char**)self + Lucy_SegLex_Seek_OFFSET;
    const lucy_SegLex_seek_t method = *((lucy_SegLex_seek_t*)method_address);
    method((lucy_SegLexicon*)self, target);
}

extern size_t Lucy_SegLex_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegLex_Next(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Next_OFFSET;
    const lucy_SegLex_next_t method = *((lucy_SegLex_next_t*)method_address);
    return method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Reset_OFFSET;
static CHY_INLINE void
Lucy_SegLex_Reset(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Reset_OFFSET;
    const lucy_SegLex_reset_t method = *((lucy_SegLex_reset_t*)method_address);
    method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Doc_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_SegLex_Doc_Freq(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Doc_Freq_OFFSET;
    const lucy_SegLex_doc_freq_t method = *((lucy_SegLex_doc_freq_t*)method_address);
    return method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Get_Term_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegLex_Get_Term(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_Term_OFFSET;
    const lucy_SegLex_get_term_t method = *((lucy_SegLex_get_term_t*)method_address);
    return method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegLex_Get_Field(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_Field_OFFSET;
    const lucy_Lex_get_field_t method = *((lucy_Lex_get_field_t*)method_address);
    return method((lucy_Lexicon*)self);
}

extern size_t Lucy_SegLex_Get_Term_Info_OFFSET;
static CHY_INLINE lucy_TermInfo*
Lucy_SegLex_Get_Term_Info(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_Term_Info_OFFSET;
    const lucy_SegLex_get_term_info_t method = *((lucy_SegLex_get_term_info_t*)method_address);
    return method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Get_Field_Num_OFFSET;
static CHY_INLINE int32_t
Lucy_SegLex_Get_Field_Num(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_Field_Num_OFFSET;
    const lucy_SegLex_get_field_num_t method = *((lucy_SegLex_get_field_num_t*)method_address);
    return method((lucy_SegLexicon*)self);
}

extern size_t Lucy_SegLex_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_SegLex_Get_Segment(const lucy_SegLexicon *self) {
    char *const method_address = *(char**)self + Lucy_SegLex_Get_Segment_OFFSET;
    const lucy_SegLex_get_segment_t method = *((lucy_SegLex_get_segment_t*)method_address);
    return method((lucy_SegLexicon*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEGLEXICON_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_SEGLEXICON_VT;
extern struct LUCY_SEGLEXICON_VT LUCY_SEGLEXICON_vt;
#define LUCY_SEGLEXICON ((cfish_VTable*)&LUCY_SEGLEXICON_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SegLexicon lucy_SegLexicon
  #define SEGLEXICON LUCY_SEGLEXICON
  #define SegLex_new lucy_SegLex_new
  #define SegLex_init lucy_SegLex_init
  #define SegLex_destroy_t lucy_SegLex_destroy_t
  #define SegLex_destroy lucy_SegLex_destroy
  #define SegLex_seek_t lucy_SegLex_seek_t
  #define SegLex_seek lucy_SegLex_seek
  #define SegLex_next_t lucy_SegLex_next_t
  #define SegLex_next lucy_SegLex_next
  #define SegLex_reset_t lucy_SegLex_reset_t
  #define SegLex_reset lucy_SegLex_reset
  #define SegLex_doc_freq_t lucy_SegLex_doc_freq_t
  #define SegLex_doc_freq lucy_SegLex_doc_freq
  #define SegLex_get_term_t lucy_SegLex_get_term_t
  #define SegLex_get_term lucy_SegLex_get_term
  #define SegLex_get_term_info_t lucy_SegLex_get_term_info_t
  #define SegLex_get_term_info lucy_SegLex_get_term_info
  #define SegLex_get_field_num_t lucy_SegLex_get_field_num_t
  #define SegLex_get_field_num lucy_SegLex_get_field_num
  #define SegLex_get_segment_t lucy_SegLex_get_segment_t
  #define SegLex_get_segment lucy_SegLex_get_segment
  #define SegLex_Make Lucy_SegLex_Make
  #define SegLex_Get_RefCount Lucy_SegLex_Get_RefCount
  #define SegLex_Inc_RefCount Lucy_SegLex_Inc_RefCount
  #define SegLex_Dec_RefCount Lucy_SegLex_Dec_RefCount
  #define SegLex_To_Host Lucy_SegLex_To_Host
  #define SegLex_Clone Lucy_SegLex_Clone
  #define SegLex_Destroy Lucy_SegLex_Destroy
  #define SegLex_Equals Lucy_SegLex_Equals
  #define SegLex_Compare_To Lucy_SegLex_Compare_To
  #define SegLex_Hash_Sum Lucy_SegLex_Hash_Sum
  #define SegLex_Get_VTable Lucy_SegLex_Get_VTable
  #define SegLex_Get_Class_Name Lucy_SegLex_Get_Class_Name
  #define SegLex_Is_A Lucy_SegLex_Is_A
  #define SegLex_To_String Lucy_SegLex_To_String
  #define SegLex_To_I64 Lucy_SegLex_To_I64
  #define SegLex_To_F64 Lucy_SegLex_To_F64
  #define SegLex_To_Bool Lucy_SegLex_To_Bool
  #define SegLex_Serialize Lucy_SegLex_Serialize
  #define SegLex_Deserialize Lucy_SegLex_Deserialize
  #define SegLex_Dump Lucy_SegLex_Dump
  #define SegLex_Load Lucy_SegLex_Load
  #define SegLex_Mimic Lucy_SegLex_Mimic
  #define SegLex_Seek Lucy_SegLex_Seek
  #define SegLex_Next Lucy_SegLex_Next
  #define SegLex_Reset Lucy_SegLex_Reset
  #define SegLex_Doc_Freq Lucy_SegLex_Doc_Freq
  #define SegLex_Get_Term Lucy_SegLex_Get_Term
  #define SegLex_Get_Field Lucy_SegLex_Get_Field
  #define SegLex_Get_Term_Info Lucy_SegLex_Get_Term_Info
  #define SegLex_Get_Field_Num Lucy_SegLex_Get_Field_Num
  #define SegLex_Get_Segment Lucy_SegLex_Get_Segment
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGLEXICON */




