/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SEGPOSTINGLIST
#define H_LUCY_INDEX_SEGPOSTINGLIST 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/PostingList.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGPOSTINGLIST
struct lucy_SegPostingList {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_PostingListReader* plist_reader;
    lucy_CharBuf* field;
    lucy_Posting* posting;
    lucy_InStream* post_stream;
    lucy_InStream* skip_stream;
    lucy_SkipStepper* skip_stepper;
    int32_t skip_interval;
    uint32_t count;
    uint32_t doc_freq;
    uint32_t skip_count;
    uint32_t num_skips;
    int32_t field_num;
};

#endif /* C_LUCY_SEGPOSTINGLIST */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SegPostingList*
lucy_SegPList_new(lucy_PostingListReader* plist_reader, const lucy_CharBuf* field);

lucy_SegPostingList*
lucy_SegPList_init(lucy_SegPostingList* self, lucy_PostingListReader* plist_reader, const lucy_CharBuf* field);

void
lucy_SegPList_destroy(lucy_SegPostingList* self);

int32_t
lucy_SegPList_next(lucy_SegPostingList* self);

int32_t
lucy_SegPList_advance(lucy_SegPostingList* self, int32_t target);

int32_t
lucy_SegPList_get_doc_id(lucy_SegPostingList* self);

lucy_Posting*
lucy_SegPList_get_posting(lucy_SegPostingList* self);

uint32_t
lucy_SegPList_get_doc_freq(lucy_SegPostingList* self);

void
lucy_SegPList_seek(lucy_SegPostingList* self, lucy_Obj* target);

void
lucy_SegPList_seek_lex(lucy_SegPostingList* self, lucy_Lexicon* lexicon);

lucy_Matcher*
lucy_SegPList_make_matcher(lucy_SegPostingList* self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score);

lucy_RawPosting*
lucy_SegPList_read_raw(lucy_SegPostingList* self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

lucy_InStream*
lucy_SegPList_get_post_stream(lucy_SegPostingList* self);

uint32_t
lucy_SegPList_get_count(lucy_SegPostingList* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SegPList_destroy_CALLBACK;
extern cfish_Callback lucy_SegPList_next_CALLBACK;
extern cfish_Callback lucy_SegPList_advance_CALLBACK;
extern cfish_Callback lucy_SegPList_get_doc_id_CALLBACK;
extern cfish_Callback lucy_SegPList_get_doc_freq_CALLBACK;
extern cfish_Callback lucy_SegPList_seek_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SegPList_destroy_t)(lucy_SegPostingList* self);

typedef int32_t
(*lucy_SegPList_next_t)(lucy_SegPostingList* self);

typedef int32_t
(*lucy_SegPList_advance_t)(lucy_SegPostingList* self, int32_t target);

typedef int32_t
(*lucy_SegPList_get_doc_id_t)(lucy_SegPostingList* self);

typedef lucy_Posting*
(*lucy_SegPList_get_posting_t)(lucy_SegPostingList* self);

typedef uint32_t
(*lucy_SegPList_get_doc_freq_t)(lucy_SegPostingList* self);

typedef void
(*lucy_SegPList_seek_t)(lucy_SegPostingList* self, lucy_Obj* target);

typedef void
(*lucy_SegPList_seek_lex_t)(lucy_SegPostingList* self, lucy_Lexicon* lexicon);

typedef lucy_Matcher*
(*lucy_SegPList_make_matcher_t)(lucy_SegPostingList* self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score);

typedef lucy_RawPosting*
(*lucy_SegPList_read_raw_t)(lucy_SegPostingList* self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool);

typedef lucy_InStream*
(*lucy_SegPList_get_post_stream_t)(lucy_SegPostingList* self);

typedef uint32_t
(*lucy_SegPList_get_count_t)(lucy_SegPostingList* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SegPList_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegPList_Make(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegPList_Get_RefCount(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegPList_Inc_RefCount(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegPList_Dec_RefCount(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SegPList_To_Host(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegPList_Clone(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SegPList_Destroy(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Destroy_OFFSET;
    const lucy_SegPList_destroy_t method = *((lucy_SegPList_destroy_t*)method_address);
    method((lucy_SegPostingList*)self);
}

extern size_t Lucy_SegPList_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegPList_Equals(const lucy_SegPostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegPList_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegPList_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SegPList_Compare_To(const lucy_SegPostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegPList_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegPList_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SegPList_Hash_Sum(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SegPList_Get_VTable(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegPList_Get_Class_Name(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegPList_Is_A(const lucy_SegPostingList *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SegPList_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SegPList_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegPList_To_String(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SegPList_To_I64(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SegPList_To_F64(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegPList_To_Bool(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SegPList_Serialize(const lucy_SegPostingList *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SegPList_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SegPList_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegPList_Deserialize(const lucy_SegPostingList *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SegPList_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SegPList_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegPList_Dump(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegPList_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegPList_Load(const lucy_SegPostingList *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SegPList_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SegPList_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SegPList_Mimic(const lucy_SegPostingList *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegPList_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegPList_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_SegPList_Next(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Next_OFFSET;
    const lucy_SegPList_next_t method = *((lucy_SegPList_next_t*)method_address);
    return method((lucy_SegPostingList*)self);
}

extern size_t Lucy_SegPList_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_SegPList_Advance(const lucy_SegPostingList *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_SegPList_Advance_OFFSET;
    const lucy_SegPList_advance_t method = *((lucy_SegPList_advance_t*)method_address);
    return method((lucy_SegPostingList*)self, target);
}

extern size_t Lucy_SegPList_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_SegPList_Get_Doc_ID(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_Doc_ID_OFFSET;
    const lucy_SegPList_get_doc_id_t method = *((lucy_SegPList_get_doc_id_t*)method_address);
    return method((lucy_SegPostingList*)self);
}

extern size_t Lucy_SegPList_Score_OFFSET;
static CHY_INLINE float
Lucy_SegPList_Score(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Score_OFFSET;
    const lucy_Matcher_score_t method = *((lucy_Matcher_score_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_SegPList_Collect_OFFSET;
static CHY_INLINE void
Lucy_SegPList_Collect(const lucy_SegPostingList *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_SegPList_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}

extern size_t Lucy_SegPList_Get_Posting_OFFSET;
static CHY_INLINE lucy_Posting*
Lucy_SegPList_Get_Posting(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_Posting_OFFSET;
    const lucy_SegPList_get_posting_t method = *((lucy_SegPList_get_posting_t*)method_address);
    return method((lucy_SegPostingList*)self);
}

extern size_t Lucy_SegPList_Get_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegPList_Get_Doc_Freq(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_Doc_Freq_OFFSET;
    const lucy_SegPList_get_doc_freq_t method = *((lucy_SegPList_get_doc_freq_t*)method_address);
    return method((lucy_SegPostingList*)self);
}

extern size_t Lucy_SegPList_Seek_OFFSET;
static CHY_INLINE void
Lucy_SegPList_Seek(const lucy_SegPostingList *self, lucy_Obj* target) {
    char *const method_address = *(char**)self + Lucy_SegPList_Seek_OFFSET;
    const lucy_SegPList_seek_t method = *((lucy_SegPList_seek_t*)method_address);
    method((lucy_SegPostingList*)self, target);
}

extern size_t Lucy_SegPList_Seek_Lex_OFFSET;
static CHY_INLINE void
Lucy_SegPList_Seek_Lex(const lucy_SegPostingList *self, lucy_Lexicon* lexicon) {
    char *const method_address = *(char**)self + Lucy_SegPList_Seek_Lex_OFFSET;
    const lucy_SegPList_seek_lex_t method = *((lucy_SegPList_seek_lex_t*)method_address);
    method((lucy_SegPostingList*)self, lexicon);
}

extern size_t Lucy_SegPList_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_SegPList_Make_Matcher(const lucy_SegPostingList *self, lucy_Similarity* similarity, lucy_Compiler* compiler, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_SegPList_Make_Matcher_OFFSET;
    const lucy_SegPList_make_matcher_t method = *((lucy_SegPList_make_matcher_t*)method_address);
    return method((lucy_SegPostingList*)self, similarity, compiler, need_score);
}

extern size_t Lucy_SegPList_Read_Raw_OFFSET;
static CHY_INLINE lucy_RawPosting*
Lucy_SegPList_Read_Raw(const lucy_SegPostingList *self, int32_t last_doc_id, lucy_CharBuf* term_text, lucy_MemoryPool* mem_pool) {
    char *const method_address = *(char**)self + Lucy_SegPList_Read_Raw_OFFSET;
    const lucy_SegPList_read_raw_t method = *((lucy_SegPList_read_raw_t*)method_address);
    return method((lucy_SegPostingList*)self, last_doc_id, term_text, mem_pool);
}

extern size_t Lucy_SegPList_Get_Post_Stream_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_SegPList_Get_Post_Stream(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_Post_Stream_OFFSET;
    const lucy_SegPList_get_post_stream_t method = *((lucy_SegPList_get_post_stream_t*)method_address);
    return method((lucy_SegPostingList*)self);
}

extern size_t Lucy_SegPList_Get_Count_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegPList_Get_Count(const lucy_SegPostingList *self) {
    char *const method_address = *(char**)self + Lucy_SegPList_Get_Count_OFFSET;
    const lucy_SegPList_get_count_t method = *((lucy_SegPList_get_count_t*)method_address);
    return method((lucy_SegPostingList*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEGPOSTINGLIST_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_SEGPOSTINGLIST_VT;
extern struct LUCY_SEGPOSTINGLIST_VT LUCY_SEGPOSTINGLIST_vt;
#define LUCY_SEGPOSTINGLIST ((cfish_VTable*)&LUCY_SEGPOSTINGLIST_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SegPostingList lucy_SegPostingList
  #define SEGPOSTINGLIST LUCY_SEGPOSTINGLIST
  #define SegPList_new lucy_SegPList_new
  #define SegPList_init lucy_SegPList_init
  #define SegPList_destroy_t lucy_SegPList_destroy_t
  #define SegPList_destroy lucy_SegPList_destroy
  #define SegPList_next_t lucy_SegPList_next_t
  #define SegPList_next lucy_SegPList_next
  #define SegPList_advance_t lucy_SegPList_advance_t
  #define SegPList_advance lucy_SegPList_advance
  #define SegPList_get_doc_id_t lucy_SegPList_get_doc_id_t
  #define SegPList_get_doc_id lucy_SegPList_get_doc_id
  #define SegPList_get_posting_t lucy_SegPList_get_posting_t
  #define SegPList_get_posting lucy_SegPList_get_posting
  #define SegPList_get_doc_freq_t lucy_SegPList_get_doc_freq_t
  #define SegPList_get_doc_freq lucy_SegPList_get_doc_freq
  #define SegPList_seek_t lucy_SegPList_seek_t
  #define SegPList_seek lucy_SegPList_seek
  #define SegPList_seek_lex_t lucy_SegPList_seek_lex_t
  #define SegPList_seek_lex lucy_SegPList_seek_lex
  #define SegPList_make_matcher_t lucy_SegPList_make_matcher_t
  #define SegPList_make_matcher lucy_SegPList_make_matcher
  #define SegPList_read_raw_t lucy_SegPList_read_raw_t
  #define SegPList_read_raw lucy_SegPList_read_raw
  #define SegPList_get_post_stream_t lucy_SegPList_get_post_stream_t
  #define SegPList_get_post_stream lucy_SegPList_get_post_stream
  #define SegPList_get_count_t lucy_SegPList_get_count_t
  #define SegPList_get_count lucy_SegPList_get_count
  #define SegPList_Make Lucy_SegPList_Make
  #define SegPList_Get_RefCount Lucy_SegPList_Get_RefCount
  #define SegPList_Inc_RefCount Lucy_SegPList_Inc_RefCount
  #define SegPList_Dec_RefCount Lucy_SegPList_Dec_RefCount
  #define SegPList_To_Host Lucy_SegPList_To_Host
  #define SegPList_Clone Lucy_SegPList_Clone
  #define SegPList_Destroy Lucy_SegPList_Destroy
  #define SegPList_Equals Lucy_SegPList_Equals
  #define SegPList_Compare_To Lucy_SegPList_Compare_To
  #define SegPList_Hash_Sum Lucy_SegPList_Hash_Sum
  #define SegPList_Get_VTable Lucy_SegPList_Get_VTable
  #define SegPList_Get_Class_Name Lucy_SegPList_Get_Class_Name
  #define SegPList_Is_A Lucy_SegPList_Is_A
  #define SegPList_To_String Lucy_SegPList_To_String
  #define SegPList_To_I64 Lucy_SegPList_To_I64
  #define SegPList_To_F64 Lucy_SegPList_To_F64
  #define SegPList_To_Bool Lucy_SegPList_To_Bool
  #define SegPList_Serialize Lucy_SegPList_Serialize
  #define SegPList_Deserialize Lucy_SegPList_Deserialize
  #define SegPList_Dump Lucy_SegPList_Dump
  #define SegPList_Load Lucy_SegPList_Load
  #define SegPList_Mimic Lucy_SegPList_Mimic
  #define SegPList_Next Lucy_SegPList_Next
  #define SegPList_Advance Lucy_SegPList_Advance
  #define SegPList_Get_Doc_ID Lucy_SegPList_Get_Doc_ID
  #define SegPList_Score Lucy_SegPList_Score
  #define SegPList_Collect Lucy_SegPList_Collect
  #define SegPList_Get_Posting Lucy_SegPList_Get_Posting
  #define SegPList_Get_Doc_Freq Lucy_SegPList_Get_Doc_Freq
  #define SegPList_Seek Lucy_SegPList_Seek
  #define SegPList_Seek_Lex Lucy_SegPList_Seek_Lex
  #define SegPList_Make_Matcher Lucy_SegPList_Make_Matcher
  #define SegPList_Read_Raw Lucy_SegPList_Read_Raw
  #define SegPList_Get_Post_Stream Lucy_SegPList_Get_Post_Stream
  #define SegPList_Get_Count Lucy_SegPList_Get_Count
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGPOSTINGLIST */




