/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SEGREADER
#define H_LUCY_INDEX_SEGREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/IndexReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGREADER
struct lucy_SegReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_Hash* components;
    lucy_IndexManager* manager;
    lucy_Lock* read_lock;
    lucy_Lock* deletion_lock;
    int32_t doc_max;
    int32_t del_count;
    int64_t seg_num;
    lucy_CharBuf* seg_name;
};

#endif /* C_LUCY_SEGREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SegReader*
lucy_SegReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_SegReader*
lucy_SegReader_init(lucy_SegReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_SegReader_destroy(lucy_SegReader* self);

int32_t
lucy_SegReader_doc_max(lucy_SegReader* self);

int32_t
lucy_SegReader_doc_count(lucy_SegReader* self);

int32_t
lucy_SegReader_del_count(lucy_SegReader* self);

lucy_I32Array*
lucy_SegReader_offsets(lucy_SegReader* self);

lucy_VArray*
lucy_SegReader_seg_readers(lucy_SegReader* self);

lucy_CharBuf*
lucy_SegReader_try_init_components(lucy_SegReader* self);

void
lucy_SegReader_register(lucy_SegReader* self, const lucy_CharBuf* api, lucy_DataReader* component);

lucy_CharBuf*
lucy_SegReader_get_seg_name(lucy_SegReader* self);

int64_t
lucy_SegReader_get_seg_num(lucy_SegReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SegReader_destroy_CALLBACK;
extern cfish_Callback lucy_SegReader_doc_max_CALLBACK;
extern cfish_Callback lucy_SegReader_doc_count_CALLBACK;
extern cfish_Callback lucy_SegReader_del_count_CALLBACK;
extern cfish_Callback lucy_SegReader_offsets_CALLBACK;
extern cfish_Callback lucy_SegReader_seg_readers_CALLBACK;
extern cfish_Callback lucy_SegReader_register_CALLBACK;
extern cfish_Callback lucy_SegReader_get_seg_name_CALLBACK;
extern cfish_Callback lucy_SegReader_get_seg_num_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SegReader_destroy_t)(lucy_SegReader* self);

typedef int32_t
(*lucy_SegReader_doc_max_t)(lucy_SegReader* self);

typedef int32_t
(*lucy_SegReader_doc_count_t)(lucy_SegReader* self);

typedef int32_t
(*lucy_SegReader_del_count_t)(lucy_SegReader* self);

typedef lucy_I32Array*
(*lucy_SegReader_offsets_t)(lucy_SegReader* self);

typedef lucy_VArray*
(*lucy_SegReader_seg_readers_t)(lucy_SegReader* self);

typedef lucy_CharBuf*
(*lucy_SegReader_try_init_components_t)(lucy_SegReader* self);

typedef void
(*lucy_SegReader_register_t)(lucy_SegReader* self, const lucy_CharBuf* api, lucy_DataReader* component);

typedef lucy_CharBuf*
(*lucy_SegReader_get_seg_name_t)(lucy_SegReader* self);

typedef int64_t
(*lucy_SegReader_get_seg_num_t)(lucy_SegReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SegReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegReader_Make(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegReader_Get_RefCount(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegReader_Inc_RefCount(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegReader_Dec_RefCount(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SegReader_To_Host(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegReader_Clone(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SegReader_Destroy(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Destroy_OFFSET;
    const lucy_SegReader_destroy_t method = *((lucy_SegReader_destroy_t*)method_address);
    method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegReader_Equals(const lucy_SegReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SegReader_Compare_To(const lucy_SegReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SegReader_Hash_Sum(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SegReader_Get_VTable(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegReader_Get_Class_Name(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegReader_Is_A(const lucy_SegReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SegReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SegReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegReader_To_String(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SegReader_To_I64(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SegReader_To_F64(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegReader_To_Bool(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SegReader_Serialize(const lucy_SegReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SegReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SegReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegReader_Deserialize(const lucy_SegReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SegReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SegReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegReader_Dump(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegReader_Load(const lucy_SegReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SegReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SegReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SegReader_Mimic(const lucy_SegReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_SegReader_Aggregator(const lucy_SegReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_SegReader_Aggregator_OFFSET;
    const lucy_DataReader_aggregator_t method = *((lucy_DataReader_aggregator_t*)method_address);
    return method((lucy_DataReader*)self, readers, offsets);
}

extern size_t Lucy_SegReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_SegReader_Get_Schema(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SegReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_SegReader_Get_Folder(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SegReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_SegReader_Get_Snapshot(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SegReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SegReader_Get_Segments(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SegReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_SegReader_Get_Segment(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SegReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_SegReader_Get_Seg_Tick(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SegReader_Close_OFFSET;
static CHY_INLINE void
Lucy_SegReader_Close(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Close_OFFSET;
    const lucy_IxReader_close_t method = *((lucy_IxReader_close_t*)method_address);
    method((lucy_IndexReader*)self);
}

extern size_t Lucy_SegReader_Doc_Max_OFFSET;
static CHY_INLINE int32_t
Lucy_SegReader_Doc_Max(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Doc_Max_OFFSET;
    const lucy_SegReader_doc_max_t method = *((lucy_SegReader_doc_max_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Doc_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_SegReader_Doc_Count(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Doc_Count_OFFSET;
    const lucy_SegReader_doc_count_t method = *((lucy_SegReader_doc_count_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Del_Count_OFFSET;
static CHY_INLINE int32_t
Lucy_SegReader_Del_Count(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Del_Count_OFFSET;
    const lucy_SegReader_del_count_t method = *((lucy_SegReader_del_count_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Offsets_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_SegReader_Offsets(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Offsets_OFFSET;
    const lucy_SegReader_offsets_t method = *((lucy_SegReader_offsets_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Seg_Readers_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SegReader_Seg_Readers(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Seg_Readers_OFFSET;
    const lucy_SegReader_seg_readers_t method = *((lucy_SegReader_seg_readers_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Obtain_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_SegReader_Obtain(const lucy_SegReader *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_SegReader_Obtain_OFFSET;
    const lucy_IxReader_obtain_t method = *((lucy_IxReader_obtain_t*)method_address);
    return method((lucy_IndexReader*)self, api);
}

extern size_t Lucy_SegReader_Fetch_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_SegReader_Fetch(const lucy_SegReader *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_SegReader_Fetch_OFFSET;
    const lucy_IxReader_fetch_t method = *((lucy_IxReader_fetch_t*)method_address);
    return method((lucy_IndexReader*)self, api);
}

extern size_t Lucy_SegReader_Get_Components_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_SegReader_Get_Components(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Components_OFFSET;
    const lucy_IxReader_get_components_t method = *((lucy_IxReader_get_components_t*)method_address);
    return method((lucy_IndexReader*)self);
}

extern size_t Lucy_SegReader_Try_Init_Components_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegReader_Try_Init_Components(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Try_Init_Components_OFFSET;
    const lucy_SegReader_try_init_components_t method = *((lucy_SegReader_try_init_components_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Register_OFFSET;
static CHY_INLINE void
Lucy_SegReader_Register(const lucy_SegReader *self, const lucy_CharBuf* api, lucy_DataReader* component) {
    char *const method_address = *(char**)self + Lucy_SegReader_Register_OFFSET;
    const lucy_SegReader_register_t method = *((lucy_SegReader_register_t*)method_address);
    method((lucy_SegReader*)self, api, component);
}

extern size_t Lucy_SegReader_Get_Seg_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegReader_Get_Seg_Name(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Seg_Name_OFFSET;
    const lucy_SegReader_get_seg_name_t method = *((lucy_SegReader_get_seg_name_t*)method_address);
    return method((lucy_SegReader*)self);
}

extern size_t Lucy_SegReader_Get_Seg_Num_OFFSET;
static CHY_INLINE int64_t
Lucy_SegReader_Get_Seg_Num(const lucy_SegReader *self) {
    char *const method_address = *(char**)self + Lucy_SegReader_Get_Seg_Num_OFFSET;
    const lucy_SegReader_get_seg_num_t method = *((lucy_SegReader_get_seg_num_t*)method_address);
    return method((lucy_SegReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEGREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[42];
} LUCY_SEGREADER_VT;
extern struct LUCY_SEGREADER_VT LUCY_SEGREADER_vt;
#define LUCY_SEGREADER ((cfish_VTable*)&LUCY_SEGREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SegReader lucy_SegReader
  #define SEGREADER LUCY_SEGREADER
  #define SegReader_new lucy_SegReader_new
  #define SegReader_init lucy_SegReader_init
  #define SegReader_destroy_t lucy_SegReader_destroy_t
  #define SegReader_destroy lucy_SegReader_destroy
  #define SegReader_doc_max_t lucy_SegReader_doc_max_t
  #define SegReader_doc_max lucy_SegReader_doc_max
  #define SegReader_doc_count_t lucy_SegReader_doc_count_t
  #define SegReader_doc_count lucy_SegReader_doc_count
  #define SegReader_del_count_t lucy_SegReader_del_count_t
  #define SegReader_del_count lucy_SegReader_del_count
  #define SegReader_offsets_t lucy_SegReader_offsets_t
  #define SegReader_offsets lucy_SegReader_offsets
  #define SegReader_seg_readers_t lucy_SegReader_seg_readers_t
  #define SegReader_seg_readers lucy_SegReader_seg_readers
  #define SegReader_try_init_components_t lucy_SegReader_try_init_components_t
  #define SegReader_try_init_components lucy_SegReader_try_init_components
  #define SegReader_register_t lucy_SegReader_register_t
  #define SegReader_register lucy_SegReader_register
  #define SegReader_get_seg_name_t lucy_SegReader_get_seg_name_t
  #define SegReader_get_seg_name lucy_SegReader_get_seg_name
  #define SegReader_get_seg_num_t lucy_SegReader_get_seg_num_t
  #define SegReader_get_seg_num lucy_SegReader_get_seg_num
  #define SegReader_Make Lucy_SegReader_Make
  #define SegReader_Get_RefCount Lucy_SegReader_Get_RefCount
  #define SegReader_Inc_RefCount Lucy_SegReader_Inc_RefCount
  #define SegReader_Dec_RefCount Lucy_SegReader_Dec_RefCount
  #define SegReader_To_Host Lucy_SegReader_To_Host
  #define SegReader_Clone Lucy_SegReader_Clone
  #define SegReader_Destroy Lucy_SegReader_Destroy
  #define SegReader_Equals Lucy_SegReader_Equals
  #define SegReader_Compare_To Lucy_SegReader_Compare_To
  #define SegReader_Hash_Sum Lucy_SegReader_Hash_Sum
  #define SegReader_Get_VTable Lucy_SegReader_Get_VTable
  #define SegReader_Get_Class_Name Lucy_SegReader_Get_Class_Name
  #define SegReader_Is_A Lucy_SegReader_Is_A
  #define SegReader_To_String Lucy_SegReader_To_String
  #define SegReader_To_I64 Lucy_SegReader_To_I64
  #define SegReader_To_F64 Lucy_SegReader_To_F64
  #define SegReader_To_Bool Lucy_SegReader_To_Bool
  #define SegReader_Serialize Lucy_SegReader_Serialize
  #define SegReader_Deserialize Lucy_SegReader_Deserialize
  #define SegReader_Dump Lucy_SegReader_Dump
  #define SegReader_Load Lucy_SegReader_Load
  #define SegReader_Mimic Lucy_SegReader_Mimic
  #define SegReader_Aggregator Lucy_SegReader_Aggregator
  #define SegReader_Get_Schema Lucy_SegReader_Get_Schema
  #define SegReader_Get_Folder Lucy_SegReader_Get_Folder
  #define SegReader_Get_Snapshot Lucy_SegReader_Get_Snapshot
  #define SegReader_Get_Segments Lucy_SegReader_Get_Segments
  #define SegReader_Get_Segment Lucy_SegReader_Get_Segment
  #define SegReader_Get_Seg_Tick Lucy_SegReader_Get_Seg_Tick
  #define SegReader_Close Lucy_SegReader_Close
  #define SegReader_Doc_Max Lucy_SegReader_Doc_Max
  #define SegReader_Doc_Count Lucy_SegReader_Doc_Count
  #define SegReader_Del_Count Lucy_SegReader_Del_Count
  #define SegReader_Offsets Lucy_SegReader_Offsets
  #define SegReader_Seg_Readers Lucy_SegReader_Seg_Readers
  #define SegReader_Obtain Lucy_SegReader_Obtain
  #define SegReader_Fetch Lucy_SegReader_Fetch
  #define SegReader_Get_Components Lucy_SegReader_Get_Components
  #define SegReader_Try_Init_Components Lucy_SegReader_Try_Init_Components
  #define SegReader_Register Lucy_SegReader_Register
  #define SegReader_Get_Seg_Name Lucy_SegReader_Get_Seg_Name
  #define SegReader_Get_Seg_Num Lucy_SegReader_Get_Seg_Num
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGREADER */




