/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SEGWRITER
#define H_LUCY_INDEX_SEGWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGWRITER
struct lucy_SegWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Inverter* inverter;
    lucy_VArray* writers;
    lucy_Hash* by_api;
    lucy_DeletionsWriter* del_writer;
};

#endif /* C_LUCY_SEGWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SegWriter*
lucy_SegWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

lucy_SegWriter*
lucy_SegWriter_init(lucy_SegWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_SegWriter_destroy(lucy_SegWriter* self);

void
lucy_SegWriter_add_inverted_doc(lucy_SegWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
lucy_SegWriter_add_segment(lucy_SegWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_SegWriter_delete_segment(lucy_SegWriter* self, lucy_SegReader* reader);

void
lucy_SegWriter_merge_segment(lucy_SegWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_SegWriter_finish(lucy_SegWriter* self);

void
lucy_SegWriter_register(lucy_SegWriter* self, const lucy_CharBuf* api, lucy_DataWriter* component);

lucy_Obj*
lucy_SegWriter_fetch(lucy_SegWriter* self, const lucy_CharBuf* api);

void
lucy_SegWriter_add_writer(lucy_SegWriter* self, lucy_DataWriter* writer);

void
lucy_SegWriter_prep_seg_dir(lucy_SegWriter* self);

void
lucy_SegWriter_add_doc(lucy_SegWriter* self, lucy_Doc* doc, float boost);

void
lucy_SegWriter_set_del_writer(lucy_SegWriter* self, lucy_DeletionsWriter* del_writer);

lucy_DeletionsWriter*
lucy_SegWriter_get_del_writer(lucy_SegWriter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SegWriter_destroy_CALLBACK;
extern cfish_Callback lucy_SegWriter_add_inverted_doc_CALLBACK;
extern cfish_Callback lucy_SegWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_SegWriter_delete_segment_CALLBACK;
extern cfish_Callback lucy_SegWriter_merge_segment_CALLBACK;
extern cfish_Callback lucy_SegWriter_finish_CALLBACK;
extern cfish_Callback lucy_SegWriter_register_CALLBACK;
extern cfish_Callback lucy_SegWriter_fetch_CALLBACK;
extern cfish_Callback lucy_SegWriter_add_writer_CALLBACK;
extern cfish_Callback lucy_SegWriter_add_doc_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SegWriter_destroy_t)(lucy_SegWriter* self);

typedef void
(*lucy_SegWriter_add_inverted_doc_t)(lucy_SegWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*lucy_SegWriter_add_segment_t)(lucy_SegWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_SegWriter_delete_segment_t)(lucy_SegWriter* self, lucy_SegReader* reader);

typedef void
(*lucy_SegWriter_merge_segment_t)(lucy_SegWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_SegWriter_finish_t)(lucy_SegWriter* self);

typedef void
(*lucy_SegWriter_register_t)(lucy_SegWriter* self, const lucy_CharBuf* api, lucy_DataWriter* component);

typedef lucy_Obj*
(*lucy_SegWriter_fetch_t)(lucy_SegWriter* self, const lucy_CharBuf* api);

typedef void
(*lucy_SegWriter_add_writer_t)(lucy_SegWriter* self, lucy_DataWriter* writer);

typedef void
(*lucy_SegWriter_prep_seg_dir_t)(lucy_SegWriter* self);

typedef void
(*lucy_SegWriter_add_doc_t)(lucy_SegWriter* self, lucy_Doc* doc, float boost);

typedef void
(*lucy_SegWriter_set_del_writer_t)(lucy_SegWriter* self, lucy_DeletionsWriter* del_writer);

typedef lucy_DeletionsWriter*
(*lucy_SegWriter_get_del_writer_t)(lucy_SegWriter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SegWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Make(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegWriter_Get_RefCount(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Inc_RefCount(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SegWriter_Dec_RefCount(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SegWriter_To_Host(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Clone(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Destroy(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Destroy_OFFSET;
    const lucy_SegWriter_destroy_t method = *((lucy_SegWriter_destroy_t*)method_address);
    method((lucy_SegWriter*)self);
}

extern size_t Lucy_SegWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegWriter_Equals(const lucy_SegWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SegWriter_Compare_To(const lucy_SegWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SegWriter_Hash_Sum(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SegWriter_Get_VTable(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegWriter_Get_Class_Name(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegWriter_Is_A(const lucy_SegWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SegWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SegWriter_To_String(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SegWriter_To_I64(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SegWriter_To_F64(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SegWriter_To_Bool(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Serialize(const lucy_SegWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SegWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Deserialize(const lucy_SegWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SegWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Dump(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SegWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Load(const lucy_SegWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SegWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Mimic(const lucy_SegWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SegWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Add_Inverted_Doc(const lucy_SegWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Add_Inverted_Doc_OFFSET;
    const lucy_SegWriter_add_inverted_doc_t method = *((lucy_SegWriter_add_inverted_doc_t*)method_address);
    method((lucy_SegWriter*)self, inverter, doc_id);
}

extern size_t Lucy_SegWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Add_Segment(const lucy_SegWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Add_Segment_OFFSET;
    const lucy_SegWriter_add_segment_t method = *((lucy_SegWriter_add_segment_t*)method_address);
    method((lucy_SegWriter*)self, reader, doc_map);
}

extern size_t Lucy_SegWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Delete_Segment(const lucy_SegWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Delete_Segment_OFFSET;
    const lucy_SegWriter_delete_segment_t method = *((lucy_SegWriter_delete_segment_t*)method_address);
    method((lucy_SegWriter*)self, reader);
}

extern size_t Lucy_SegWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Merge_Segment(const lucy_SegWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Merge_Segment_OFFSET;
    const lucy_SegWriter_merge_segment_t method = *((lucy_SegWriter_merge_segment_t*)method_address);
    method((lucy_SegWriter*)self, reader, doc_map);
}

extern size_t Lucy_SegWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Finish(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Finish_OFFSET;
    const lucy_SegWriter_finish_t method = *((lucy_SegWriter_finish_t*)method_address);
    method((lucy_SegWriter*)self);
}

extern size_t Lucy_SegWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_SegWriter_Metadata(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Metadata_OFFSET;
    const lucy_DataWriter_metadata_t method = *((lucy_DataWriter_metadata_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_SegWriter_Format(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Format_OFFSET;
    const lucy_DataWriter_format_t method = *((lucy_DataWriter_format_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_SegWriter_Get_Snapshot(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_SegWriter_Get_Segment(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_SegWriter_Get_PolyReader(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_SegWriter_Get_Schema(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_SegWriter_Get_Folder(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SegWriter_Register_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Register(const lucy_SegWriter *self, const lucy_CharBuf* api, lucy_DataWriter* component) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Register_OFFSET;
    const lucy_SegWriter_register_t method = *((lucy_SegWriter_register_t*)method_address);
    method((lucy_SegWriter*)self, api, component);
}

extern size_t Lucy_SegWriter_Fetch_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SegWriter_Fetch(const lucy_SegWriter *self, const lucy_CharBuf* api) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Fetch_OFFSET;
    const lucy_SegWriter_fetch_t method = *((lucy_SegWriter_fetch_t*)method_address);
    return method((lucy_SegWriter*)self, api);
}

extern size_t Lucy_SegWriter_Add_Writer_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Add_Writer(const lucy_SegWriter *self, lucy_DataWriter* writer) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Add_Writer_OFFSET;
    const lucy_SegWriter_add_writer_t method = *((lucy_SegWriter_add_writer_t*)method_address);
    method((lucy_SegWriter*)self, writer);
}

extern size_t Lucy_SegWriter_Prep_Seg_Dir_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Prep_Seg_Dir(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Prep_Seg_Dir_OFFSET;
    const lucy_SegWriter_prep_seg_dir_t method = *((lucy_SegWriter_prep_seg_dir_t*)method_address);
    method((lucy_SegWriter*)self);
}

extern size_t Lucy_SegWriter_Add_Doc_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Add_Doc(const lucy_SegWriter *self, lucy_Doc* doc, float boost) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Add_Doc_OFFSET;
    const lucy_SegWriter_add_doc_t method = *((lucy_SegWriter_add_doc_t*)method_address);
    method((lucy_SegWriter*)self, doc, boost);
}

extern size_t Lucy_SegWriter_Set_Del_Writer_OFFSET;
static CHY_INLINE void
Lucy_SegWriter_Set_Del_Writer(const lucy_SegWriter *self, lucy_DeletionsWriter* del_writer) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Set_Del_Writer_OFFSET;
    const lucy_SegWriter_set_del_writer_t method = *((lucy_SegWriter_set_del_writer_t*)method_address);
    method((lucy_SegWriter*)self, del_writer);
}

extern size_t Lucy_SegWriter_Get_Del_Writer_OFFSET;
static CHY_INLINE lucy_DeletionsWriter*
Lucy_SegWriter_Get_Del_Writer(const lucy_SegWriter *self) {
    char *const method_address = *(char**)self + Lucy_SegWriter_Get_Del_Writer_OFFSET;
    const lucy_SegWriter_get_del_writer_t method = *((lucy_SegWriter_get_del_writer_t*)method_address);
    return method((lucy_SegWriter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEGWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[41];
} LUCY_SEGWRITER_VT;
extern struct LUCY_SEGWRITER_VT LUCY_SEGWRITER_vt;
#define LUCY_SEGWRITER ((cfish_VTable*)&LUCY_SEGWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SegWriter lucy_SegWriter
  #define SEGWRITER LUCY_SEGWRITER
  #define SegWriter_new lucy_SegWriter_new
  #define SegWriter_init lucy_SegWriter_init
  #define SegWriter_destroy_t lucy_SegWriter_destroy_t
  #define SegWriter_destroy lucy_SegWriter_destroy
  #define SegWriter_add_inverted_doc_t lucy_SegWriter_add_inverted_doc_t
  #define SegWriter_add_inverted_doc lucy_SegWriter_add_inverted_doc
  #define SegWriter_add_segment_t lucy_SegWriter_add_segment_t
  #define SegWriter_add_segment lucy_SegWriter_add_segment
  #define SegWriter_delete_segment_t lucy_SegWriter_delete_segment_t
  #define SegWriter_delete_segment lucy_SegWriter_delete_segment
  #define SegWriter_merge_segment_t lucy_SegWriter_merge_segment_t
  #define SegWriter_merge_segment lucy_SegWriter_merge_segment
  #define SegWriter_finish_t lucy_SegWriter_finish_t
  #define SegWriter_finish lucy_SegWriter_finish
  #define SegWriter_register_t lucy_SegWriter_register_t
  #define SegWriter_register lucy_SegWriter_register
  #define SegWriter_fetch_t lucy_SegWriter_fetch_t
  #define SegWriter_fetch lucy_SegWriter_fetch
  #define SegWriter_add_writer_t lucy_SegWriter_add_writer_t
  #define SegWriter_add_writer lucy_SegWriter_add_writer
  #define SegWriter_prep_seg_dir_t lucy_SegWriter_prep_seg_dir_t
  #define SegWriter_prep_seg_dir lucy_SegWriter_prep_seg_dir
  #define SegWriter_add_doc_t lucy_SegWriter_add_doc_t
  #define SegWriter_add_doc lucy_SegWriter_add_doc
  #define SegWriter_set_del_writer_t lucy_SegWriter_set_del_writer_t
  #define SegWriter_set_del_writer lucy_SegWriter_set_del_writer
  #define SegWriter_get_del_writer_t lucy_SegWriter_get_del_writer_t
  #define SegWriter_get_del_writer lucy_SegWriter_get_del_writer
  #define SegWriter_Make Lucy_SegWriter_Make
  #define SegWriter_Get_RefCount Lucy_SegWriter_Get_RefCount
  #define SegWriter_Inc_RefCount Lucy_SegWriter_Inc_RefCount
  #define SegWriter_Dec_RefCount Lucy_SegWriter_Dec_RefCount
  #define SegWriter_To_Host Lucy_SegWriter_To_Host
  #define SegWriter_Clone Lucy_SegWriter_Clone
  #define SegWriter_Destroy Lucy_SegWriter_Destroy
  #define SegWriter_Equals Lucy_SegWriter_Equals
  #define SegWriter_Compare_To Lucy_SegWriter_Compare_To
  #define SegWriter_Hash_Sum Lucy_SegWriter_Hash_Sum
  #define SegWriter_Get_VTable Lucy_SegWriter_Get_VTable
  #define SegWriter_Get_Class_Name Lucy_SegWriter_Get_Class_Name
  #define SegWriter_Is_A Lucy_SegWriter_Is_A
  #define SegWriter_To_String Lucy_SegWriter_To_String
  #define SegWriter_To_I64 Lucy_SegWriter_To_I64
  #define SegWriter_To_F64 Lucy_SegWriter_To_F64
  #define SegWriter_To_Bool Lucy_SegWriter_To_Bool
  #define SegWriter_Serialize Lucy_SegWriter_Serialize
  #define SegWriter_Deserialize Lucy_SegWriter_Deserialize
  #define SegWriter_Dump Lucy_SegWriter_Dump
  #define SegWriter_Load Lucy_SegWriter_Load
  #define SegWriter_Mimic Lucy_SegWriter_Mimic
  #define SegWriter_Add_Inverted_Doc Lucy_SegWriter_Add_Inverted_Doc
  #define SegWriter_Add_Segment Lucy_SegWriter_Add_Segment
  #define SegWriter_Delete_Segment Lucy_SegWriter_Delete_Segment
  #define SegWriter_Merge_Segment Lucy_SegWriter_Merge_Segment
  #define SegWriter_Finish Lucy_SegWriter_Finish
  #define SegWriter_Metadata Lucy_SegWriter_Metadata
  #define SegWriter_Format Lucy_SegWriter_Format
  #define SegWriter_Get_Snapshot Lucy_SegWriter_Get_Snapshot
  #define SegWriter_Get_Segment Lucy_SegWriter_Get_Segment
  #define SegWriter_Get_PolyReader Lucy_SegWriter_Get_PolyReader
  #define SegWriter_Get_Schema Lucy_SegWriter_Get_Schema
  #define SegWriter_Get_Folder Lucy_SegWriter_Get_Folder
  #define SegWriter_Register Lucy_SegWriter_Register
  #define SegWriter_Fetch Lucy_SegWriter_Fetch
  #define SegWriter_Add_Writer Lucy_SegWriter_Add_Writer
  #define SegWriter_Prep_Seg_Dir Lucy_SegWriter_Prep_Seg_Dir
  #define SegWriter_Add_Doc Lucy_SegWriter_Add_Doc
  #define SegWriter_Set_Del_Writer Lucy_SegWriter_Set_Del_Writer
  #define SegWriter_Get_Del_Writer Lucy_SegWriter_Get_Del_Writer
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGWRITER */




