/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SEGMENT
#define H_LUCY_INDEX_SEGMENT 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGMENT
struct lucy_Segment {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* name;
    int64_t count;
    int64_t number;
    lucy_Hash* by_name;
    lucy_VArray* by_num;
    lucy_Hash* metadata;
};

#endif /* C_LUCY_SEGMENT */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Segment*
lucy_Seg_new(int64_t number);

lucy_Segment*
lucy_Seg_init(lucy_Segment* self, int64_t number);

lucy_CharBuf*
lucy_Seg_num_to_name(int64_t number);

chy_bool_t
lucy_Seg_valid_seg_name(const lucy_CharBuf* name);

void
lucy_Seg_destroy(lucy_Segment* self);

int32_t
lucy_Seg_compare_to(lucy_Segment* self, lucy_Obj* other);

int32_t
lucy_Seg_add_field(lucy_Segment* self, const lucy_CharBuf* field);

void
lucy_Seg_store_metadata(lucy_Segment* self, const lucy_CharBuf* key, lucy_Obj* metadata);

void
lucy_Seg_store_metadata_str(lucy_Segment* self, const char* key, size_t len, lucy_Obj* value);

lucy_Obj*
lucy_Seg_fetch_metadata(lucy_Segment* self, const lucy_CharBuf* key);

lucy_Obj*
lucy_Seg_fetch_metadata_str(lucy_Segment* self, const char* key, size_t len);

int32_t
lucy_Seg_field_num(lucy_Segment* self, const lucy_CharBuf* field);

lucy_CharBuf*
lucy_Seg_field_name(lucy_Segment* self, int32_t field_num);

lucy_CharBuf*
lucy_Seg_get_name(lucy_Segment* self);

int64_t
lucy_Seg_get_number(lucy_Segment* self);

void
lucy_Seg_set_count(lucy_Segment* self, int64_t count);

int64_t
lucy_Seg_get_count(lucy_Segment* self);

int64_t
lucy_Seg_increment_count(lucy_Segment* self, int64_t increment);

lucy_Hash*
lucy_Seg_get_metadata(lucy_Segment* self);

void
lucy_Seg_write_file(lucy_Segment* self, lucy_Folder* folder);

chy_bool_t
lucy_Seg_read_file(lucy_Segment* self, lucy_Folder* folder);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Seg_destroy_CALLBACK;
extern cfish_Callback lucy_Seg_compare_to_CALLBACK;
extern cfish_Callback lucy_Seg_add_field_CALLBACK;
extern cfish_Callback lucy_Seg_store_metadata_CALLBACK;
extern cfish_Callback lucy_Seg_fetch_metadata_CALLBACK;
extern cfish_Callback lucy_Seg_field_num_CALLBACK;
extern cfish_Callback lucy_Seg_field_name_CALLBACK;
extern cfish_Callback lucy_Seg_get_name_CALLBACK;
extern cfish_Callback lucy_Seg_get_number_CALLBACK;
extern cfish_Callback lucy_Seg_set_count_CALLBACK;
extern cfish_Callback lucy_Seg_get_count_CALLBACK;
extern cfish_Callback lucy_Seg_write_file_CALLBACK;
extern cfish_Callback lucy_Seg_read_file_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Seg_destroy_t)(lucy_Segment* self);

typedef int32_t
(*lucy_Seg_compare_to_t)(lucy_Segment* self, lucy_Obj* other);

typedef int32_t
(*lucy_Seg_add_field_t)(lucy_Segment* self, const lucy_CharBuf* field);

typedef void
(*lucy_Seg_store_metadata_t)(lucy_Segment* self, const lucy_CharBuf* key, lucy_Obj* metadata);

typedef void
(*lucy_Seg_store_metadata_str_t)(lucy_Segment* self, const char* key, size_t len, lucy_Obj* value);

typedef lucy_Obj*
(*lucy_Seg_fetch_metadata_t)(lucy_Segment* self, const lucy_CharBuf* key);

typedef lucy_Obj*
(*lucy_Seg_fetch_metadata_str_t)(lucy_Segment* self, const char* key, size_t len);

typedef int32_t
(*lucy_Seg_field_num_t)(lucy_Segment* self, const lucy_CharBuf* field);

typedef lucy_CharBuf*
(*lucy_Seg_field_name_t)(lucy_Segment* self, int32_t field_num);

typedef lucy_CharBuf*
(*lucy_Seg_get_name_t)(lucy_Segment* self);

typedef int64_t
(*lucy_Seg_get_number_t)(lucy_Segment* self);

typedef void
(*lucy_Seg_set_count_t)(lucy_Segment* self, int64_t count);

typedef int64_t
(*lucy_Seg_get_count_t)(lucy_Segment* self);

typedef int64_t
(*lucy_Seg_increment_count_t)(lucy_Segment* self, int64_t increment);

typedef lucy_Hash*
(*lucy_Seg_get_metadata_t)(lucy_Segment* self);

typedef void
(*lucy_Seg_write_file_t)(lucy_Segment* self, lucy_Folder* folder);

typedef chy_bool_t
(*lucy_Seg_read_file_t)(lucy_Segment* self, lucy_Folder* folder);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Seg_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Make(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Seg_Get_RefCount(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Inc_RefCount(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Seg_Dec_RefCount(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Seg_To_Host(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Clone(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Seg_Destroy(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Destroy_OFFSET;
    const lucy_Seg_destroy_t method = *((lucy_Seg_destroy_t*)method_address);
    method((lucy_Segment*)self);
}

extern size_t Lucy_Seg_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Seg_Equals(const lucy_Segment *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Seg_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Seg_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Seg_Compare_To(const lucy_Segment *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Seg_Compare_To_OFFSET;
    const lucy_Seg_compare_to_t method = *((lucy_Seg_compare_to_t*)method_address);
    return method((lucy_Segment*)self, other);
}

extern size_t Lucy_Seg_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Seg_Hash_Sum(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Seg_Get_VTable(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Seg_Get_Class_Name(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Seg_Is_A(const lucy_Segment *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Seg_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Seg_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Seg_To_String(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Seg_To_I64(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Seg_To_F64(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Seg_To_Bool(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Seg_Serialize(const lucy_Segment *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Seg_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Seg_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Deserialize(const lucy_Segment *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Seg_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Seg_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Dump(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Seg_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Load(const lucy_Segment *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Seg_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Seg_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Seg_Mimic(const lucy_Segment *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Seg_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Seg_Add_Field_OFFSET;
static CHY_INLINE int32_t
Lucy_Seg_Add_Field(const lucy_Segment *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_Seg_Add_Field_OFFSET;
    const lucy_Seg_add_field_t method = *((lucy_Seg_add_field_t*)method_address);
    return method((lucy_Segment*)self, field);
}

extern size_t Lucy_Seg_Store_Metadata_OFFSET;
static CHY_INLINE void
Lucy_Seg_Store_Metadata(const lucy_Segment *self, const lucy_CharBuf* key, lucy_Obj* metadata) {
    char *const method_address = *(char**)self + Lucy_Seg_Store_Metadata_OFFSET;
    const lucy_Seg_store_metadata_t method = *((lucy_Seg_store_metadata_t*)method_address);
    method((lucy_Segment*)self, key, metadata);
}

extern size_t Lucy_Seg_Store_Metadata_Str_OFFSET;
static CHY_INLINE void
Lucy_Seg_Store_Metadata_Str(const lucy_Segment *self, const char* key, size_t len, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_Seg_Store_Metadata_Str_OFFSET;
    const lucy_Seg_store_metadata_str_t method = *((lucy_Seg_store_metadata_str_t*)method_address);
    method((lucy_Segment*)self, key, len, value);
}

extern size_t Lucy_Seg_Fetch_Metadata_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Fetch_Metadata(const lucy_Segment *self, const lucy_CharBuf* key) {
    char *const method_address = *(char**)self + Lucy_Seg_Fetch_Metadata_OFFSET;
    const lucy_Seg_fetch_metadata_t method = *((lucy_Seg_fetch_metadata_t*)method_address);
    return method((lucy_Segment*)self, key);
}

extern size_t Lucy_Seg_Fetch_Metadata_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Seg_Fetch_Metadata_Str(const lucy_Segment *self, const char* key, size_t len) {
    char *const method_address = *(char**)self + Lucy_Seg_Fetch_Metadata_Str_OFFSET;
    const lucy_Seg_fetch_metadata_str_t method = *((lucy_Seg_fetch_metadata_str_t*)method_address);
    return method((lucy_Segment*)self, key, len);
}

extern size_t Lucy_Seg_Field_Num_OFFSET;
static CHY_INLINE int32_t
Lucy_Seg_Field_Num(const lucy_Segment *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_Seg_Field_Num_OFFSET;
    const lucy_Seg_field_num_t method = *((lucy_Seg_field_num_t*)method_address);
    return method((lucy_Segment*)self, field);
}

extern size_t Lucy_Seg_Field_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Seg_Field_Name(const lucy_Segment *self, int32_t field_num) {
    char *const method_address = *(char**)self + Lucy_Seg_Field_Name_OFFSET;
    const lucy_Seg_field_name_t method = *((lucy_Seg_field_name_t*)method_address);
    return method((lucy_Segment*)self, field_num);
}

extern size_t Lucy_Seg_Get_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Seg_Get_Name(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_Name_OFFSET;
    const lucy_Seg_get_name_t method = *((lucy_Seg_get_name_t*)method_address);
    return method((lucy_Segment*)self);
}

extern size_t Lucy_Seg_Get_Number_OFFSET;
static CHY_INLINE int64_t
Lucy_Seg_Get_Number(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_Number_OFFSET;
    const lucy_Seg_get_number_t method = *((lucy_Seg_get_number_t*)method_address);
    return method((lucy_Segment*)self);
}

extern size_t Lucy_Seg_Set_Count_OFFSET;
static CHY_INLINE void
Lucy_Seg_Set_Count(const lucy_Segment *self, int64_t count) {
    char *const method_address = *(char**)self + Lucy_Seg_Set_Count_OFFSET;
    const lucy_Seg_set_count_t method = *((lucy_Seg_set_count_t*)method_address);
    method((lucy_Segment*)self, count);
}

extern size_t Lucy_Seg_Get_Count_OFFSET;
static CHY_INLINE int64_t
Lucy_Seg_Get_Count(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_Count_OFFSET;
    const lucy_Seg_get_count_t method = *((lucy_Seg_get_count_t*)method_address);
    return method((lucy_Segment*)self);
}

extern size_t Lucy_Seg_Increment_Count_OFFSET;
static CHY_INLINE int64_t
Lucy_Seg_Increment_Count(const lucy_Segment *self, int64_t increment) {
    char *const method_address = *(char**)self + Lucy_Seg_Increment_Count_OFFSET;
    const lucy_Seg_increment_count_t method = *((lucy_Seg_increment_count_t*)method_address);
    return method((lucy_Segment*)self, increment);
}

extern size_t Lucy_Seg_Get_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_Seg_Get_Metadata(const lucy_Segment *self) {
    char *const method_address = *(char**)self + Lucy_Seg_Get_Metadata_OFFSET;
    const lucy_Seg_get_metadata_t method = *((lucy_Seg_get_metadata_t*)method_address);
    return method((lucy_Segment*)self);
}

extern size_t Lucy_Seg_Write_File_OFFSET;
static CHY_INLINE void
Lucy_Seg_Write_File(const lucy_Segment *self, lucy_Folder* folder) {
    char *const method_address = *(char**)self + Lucy_Seg_Write_File_OFFSET;
    const lucy_Seg_write_file_t method = *((lucy_Seg_write_file_t*)method_address);
    method((lucy_Segment*)self, folder);
}

extern size_t Lucy_Seg_Read_File_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Seg_Read_File(const lucy_Segment *self, lucy_Folder* folder) {
    char *const method_address = *(char**)self + Lucy_Seg_Read_File_OFFSET;
    const lucy_Seg_read_file_t method = *((lucy_Seg_read_file_t*)method_address);
    return method((lucy_Segment*)self, folder);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEGMENT_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_SEGMENT_VT;
extern struct LUCY_SEGMENT_VT LUCY_SEGMENT_vt;
#define LUCY_SEGMENT ((cfish_VTable*)&LUCY_SEGMENT_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Segment lucy_Segment
  #define SEGMENT LUCY_SEGMENT
  #define Seg_new lucy_Seg_new
  #define Seg_init lucy_Seg_init
  #define Seg_num_to_name lucy_Seg_num_to_name
  #define Seg_valid_seg_name lucy_Seg_valid_seg_name
  #define Seg_destroy_t lucy_Seg_destroy_t
  #define Seg_destroy lucy_Seg_destroy
  #define Seg_compare_to_t lucy_Seg_compare_to_t
  #define Seg_compare_to lucy_Seg_compare_to
  #define Seg_add_field_t lucy_Seg_add_field_t
  #define Seg_add_field lucy_Seg_add_field
  #define Seg_store_metadata_t lucy_Seg_store_metadata_t
  #define Seg_store_metadata lucy_Seg_store_metadata
  #define Seg_store_metadata_str_t lucy_Seg_store_metadata_str_t
  #define Seg_store_metadata_str lucy_Seg_store_metadata_str
  #define Seg_fetch_metadata_t lucy_Seg_fetch_metadata_t
  #define Seg_fetch_metadata lucy_Seg_fetch_metadata
  #define Seg_fetch_metadata_str_t lucy_Seg_fetch_metadata_str_t
  #define Seg_fetch_metadata_str lucy_Seg_fetch_metadata_str
  #define Seg_field_num_t lucy_Seg_field_num_t
  #define Seg_field_num lucy_Seg_field_num
  #define Seg_field_name_t lucy_Seg_field_name_t
  #define Seg_field_name lucy_Seg_field_name
  #define Seg_get_name_t lucy_Seg_get_name_t
  #define Seg_get_name lucy_Seg_get_name
  #define Seg_get_number_t lucy_Seg_get_number_t
  #define Seg_get_number lucy_Seg_get_number
  #define Seg_set_count_t lucy_Seg_set_count_t
  #define Seg_set_count lucy_Seg_set_count
  #define Seg_get_count_t lucy_Seg_get_count_t
  #define Seg_get_count lucy_Seg_get_count
  #define Seg_increment_count_t lucy_Seg_increment_count_t
  #define Seg_increment_count lucy_Seg_increment_count
  #define Seg_get_metadata_t lucy_Seg_get_metadata_t
  #define Seg_get_metadata lucy_Seg_get_metadata
  #define Seg_write_file_t lucy_Seg_write_file_t
  #define Seg_write_file lucy_Seg_write_file
  #define Seg_read_file_t lucy_Seg_read_file_t
  #define Seg_read_file lucy_Seg_read_file
  #define Seg_Make Lucy_Seg_Make
  #define Seg_Get_RefCount Lucy_Seg_Get_RefCount
  #define Seg_Inc_RefCount Lucy_Seg_Inc_RefCount
  #define Seg_Dec_RefCount Lucy_Seg_Dec_RefCount
  #define Seg_To_Host Lucy_Seg_To_Host
  #define Seg_Clone Lucy_Seg_Clone
  #define Seg_Destroy Lucy_Seg_Destroy
  #define Seg_Equals Lucy_Seg_Equals
  #define Seg_Compare_To Lucy_Seg_Compare_To
  #define Seg_Hash_Sum Lucy_Seg_Hash_Sum
  #define Seg_Get_VTable Lucy_Seg_Get_VTable
  #define Seg_Get_Class_Name Lucy_Seg_Get_Class_Name
  #define Seg_Is_A Lucy_Seg_Is_A
  #define Seg_To_String Lucy_Seg_To_String
  #define Seg_To_I64 Lucy_Seg_To_I64
  #define Seg_To_F64 Lucy_Seg_To_F64
  #define Seg_To_Bool Lucy_Seg_To_Bool
  #define Seg_Serialize Lucy_Seg_Serialize
  #define Seg_Deserialize Lucy_Seg_Deserialize
  #define Seg_Dump Lucy_Seg_Dump
  #define Seg_Load Lucy_Seg_Load
  #define Seg_Mimic Lucy_Seg_Mimic
  #define Seg_Add_Field Lucy_Seg_Add_Field
  #define Seg_Store_Metadata Lucy_Seg_Store_Metadata
  #define Seg_Store_Metadata_Str Lucy_Seg_Store_Metadata_Str
  #define Seg_Fetch_Metadata Lucy_Seg_Fetch_Metadata
  #define Seg_Fetch_Metadata_Str Lucy_Seg_Fetch_Metadata_Str
  #define Seg_Field_Num Lucy_Seg_Field_Num
  #define Seg_Field_Name Lucy_Seg_Field_Name
  #define Seg_Get_Name Lucy_Seg_Get_Name
  #define Seg_Get_Number Lucy_Seg_Get_Number
  #define Seg_Set_Count Lucy_Seg_Set_Count
  #define Seg_Get_Count Lucy_Seg_Get_Count
  #define Seg_Increment_Count Lucy_Seg_Increment_Count
  #define Seg_Get_Metadata Lucy_Seg_Get_Metadata
  #define Seg_Write_File Lucy_Seg_Write_File
  #define Seg_Read_File Lucy_Seg_Read_File
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGMENT */




