/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SIMILARITY
#define H_LUCY_INDEX_SIMILARITY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SIMILARITY
struct lucy_Similarity {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float* norm_decoder;
};

#endif /* C_LUCY_SIMILARITY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Similarity*
lucy_Sim_new();

lucy_Similarity*
lucy_Sim_init(lucy_Similarity* self);

void
lucy_Sim_destroy(lucy_Similarity* self);

chy_bool_t
lucy_Sim_equals(lucy_Similarity* self, lucy_Obj* other);

void
lucy_Sim_serialize(lucy_Similarity* self, lucy_OutStream* outstream);

lucy_Similarity*
lucy_Sim_deserialize(lucy_Similarity* self, lucy_InStream* instream);

lucy_Obj*
lucy_Sim_dump(lucy_Similarity* self);

lucy_Similarity*
lucy_Sim_load(lucy_Similarity* self, lucy_Obj* dump);

lucy_Posting*
lucy_Sim_make_posting(lucy_Similarity* self);

lucy_PostingWriter*
lucy_Sim_make_posting_writer(lucy_Similarity* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, int32_t field_num);

float
lucy_Sim_tf(lucy_Similarity* self, float freq);

float
lucy_Sim_idf(lucy_Similarity* self, int64_t doc_freq, int64_t total_docs);

float
lucy_Sim_coord(lucy_Similarity* self, uint32_t overlap, uint32_t max_overlap);

float
lucy_Sim_length_norm(lucy_Similarity* self, uint32_t num_tokens);

float
lucy_Sim_query_norm(lucy_Similarity* self, float sum_of_squared_weights);

uint32_t
lucy_Sim_encode_norm(lucy_Similarity* self, float f);

float
lucy_Sim_decode_norm(lucy_Similarity* self, uint32_t input);

float*
lucy_Sim_get_norm_decoder(lucy_Similarity* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Sim_destroy_CALLBACK;
extern cfish_Callback lucy_Sim_equals_CALLBACK;
extern cfish_Callback lucy_Sim_serialize_CALLBACK;
extern cfish_Callback lucy_Sim_deserialize_CALLBACK;
extern cfish_Callback lucy_Sim_dump_CALLBACK;
extern cfish_Callback lucy_Sim_load_CALLBACK;
extern cfish_Callback lucy_Sim_make_posting_CALLBACK;
extern cfish_Callback lucy_Sim_tf_CALLBACK;
extern cfish_Callback lucy_Sim_idf_CALLBACK;
extern cfish_Callback lucy_Sim_coord_CALLBACK;
extern cfish_Callback lucy_Sim_length_norm_CALLBACK;
extern cfish_Callback lucy_Sim_query_norm_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Sim_destroy_t)(lucy_Similarity* self);

typedef chy_bool_t
(*lucy_Sim_equals_t)(lucy_Similarity* self, lucy_Obj* other);

typedef void
(*lucy_Sim_serialize_t)(lucy_Similarity* self, lucy_OutStream* outstream);

typedef lucy_Similarity*
(*lucy_Sim_deserialize_t)(lucy_Similarity* self, lucy_InStream* instream);

typedef lucy_Obj*
(*lucy_Sim_dump_t)(lucy_Similarity* self);

typedef lucy_Similarity*
(*lucy_Sim_load_t)(lucy_Similarity* self, lucy_Obj* dump);

typedef lucy_Posting*
(*lucy_Sim_make_posting_t)(lucy_Similarity* self);

typedef lucy_PostingWriter*
(*lucy_Sim_make_posting_writer_t)(lucy_Similarity* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, int32_t field_num);

typedef float
(*lucy_Sim_tf_t)(lucy_Similarity* self, float freq);

typedef float
(*lucy_Sim_idf_t)(lucy_Similarity* self, int64_t doc_freq, int64_t total_docs);

typedef float
(*lucy_Sim_coord_t)(lucy_Similarity* self, uint32_t overlap, uint32_t max_overlap);

typedef float
(*lucy_Sim_length_norm_t)(lucy_Similarity* self, uint32_t num_tokens);

typedef float
(*lucy_Sim_query_norm_t)(lucy_Similarity* self, float sum_of_squared_weights);

typedef uint32_t
(*lucy_Sim_encode_norm_t)(lucy_Similarity* self, float f);

typedef float
(*lucy_Sim_decode_norm_t)(lucy_Similarity* self, uint32_t input);

typedef float*
(*lucy_Sim_get_norm_decoder_t)(lucy_Similarity* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Sim_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Sim_Make(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Sim_Get_RefCount(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Sim_Inc_RefCount(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Sim_Dec_RefCount(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Sim_To_Host(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Sim_Clone(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Sim_Destroy(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Destroy_OFFSET;
    const lucy_Sim_destroy_t method = *((lucy_Sim_destroy_t*)method_address);
    method((lucy_Similarity*)self);
}

extern size_t Lucy_Sim_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Sim_Equals(const lucy_Similarity *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Sim_Equals_OFFSET;
    const lucy_Sim_equals_t method = *((lucy_Sim_equals_t*)method_address);
    return method((lucy_Similarity*)self, other);
}

extern size_t Lucy_Sim_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Sim_Compare_To(const lucy_Similarity *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Sim_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Sim_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Sim_Hash_Sum(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Sim_Get_VTable(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Sim_Get_Class_Name(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Sim_Is_A(const lucy_Similarity *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Sim_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Sim_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Sim_To_String(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Sim_To_I64(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Sim_To_F64(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Sim_To_Bool(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Sim_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Sim_Serialize(const lucy_Similarity *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Sim_Serialize_OFFSET;
    const lucy_Sim_serialize_t method = *((lucy_Sim_serialize_t*)method_address);
    method((lucy_Similarity*)self, outstream);
}

extern size_t Lucy_Sim_Deserialize_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_Sim_Deserialize(const lucy_Similarity *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Sim_Deserialize_OFFSET;
    const lucy_Sim_deserialize_t method = *((lucy_Sim_deserialize_t*)method_address);
    return method((lucy_Similarity*)self, instream);
}

extern size_t Lucy_Sim_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Sim_Dump(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Dump_OFFSET;
    const lucy_Sim_dump_t method = *((lucy_Sim_dump_t*)method_address);
    return method((lucy_Similarity*)self);
}

extern size_t Lucy_Sim_Load_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_Sim_Load(const lucy_Similarity *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Sim_Load_OFFSET;
    const lucy_Sim_load_t method = *((lucy_Sim_load_t*)method_address);
    return method((lucy_Similarity*)self, dump);
}

extern size_t Lucy_Sim_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Sim_Mimic(const lucy_Similarity *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Sim_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Sim_Make_Posting_OFFSET;
static CHY_INLINE lucy_Posting*
Lucy_Sim_Make_Posting(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Make_Posting_OFFSET;
    const lucy_Sim_make_posting_t method = *((lucy_Sim_make_posting_t*)method_address);
    return method((lucy_Similarity*)self);
}

extern size_t Lucy_Sim_Make_Posting_Writer_OFFSET;
static CHY_INLINE lucy_PostingWriter*
Lucy_Sim_Make_Posting_Writer(const lucy_Similarity *self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, int32_t field_num) {
    char *const method_address = *(char**)self + Lucy_Sim_Make_Posting_Writer_OFFSET;
    const lucy_Sim_make_posting_writer_t method = *((lucy_Sim_make_posting_writer_t*)method_address);
    return method((lucy_Similarity*)self, schema, snapshot, segment, polyreader, field_num);
}

extern size_t Lucy_Sim_TF_OFFSET;
static CHY_INLINE float
Lucy_Sim_TF(const lucy_Similarity *self, float freq) {
    char *const method_address = *(char**)self + Lucy_Sim_TF_OFFSET;
    const lucy_Sim_tf_t method = *((lucy_Sim_tf_t*)method_address);
    return method((lucy_Similarity*)self, freq);
}

extern size_t Lucy_Sim_IDF_OFFSET;
static CHY_INLINE float
Lucy_Sim_IDF(const lucy_Similarity *self, int64_t doc_freq, int64_t total_docs) {
    char *const method_address = *(char**)self + Lucy_Sim_IDF_OFFSET;
    const lucy_Sim_idf_t method = *((lucy_Sim_idf_t*)method_address);
    return method((lucy_Similarity*)self, doc_freq, total_docs);
}

extern size_t Lucy_Sim_Coord_OFFSET;
static CHY_INLINE float
Lucy_Sim_Coord(const lucy_Similarity *self, uint32_t overlap, uint32_t max_overlap) {
    char *const method_address = *(char**)self + Lucy_Sim_Coord_OFFSET;
    const lucy_Sim_coord_t method = *((lucy_Sim_coord_t*)method_address);
    return method((lucy_Similarity*)self, overlap, max_overlap);
}

extern size_t Lucy_Sim_Length_Norm_OFFSET;
static CHY_INLINE float
Lucy_Sim_Length_Norm(const lucy_Similarity *self, uint32_t num_tokens) {
    char *const method_address = *(char**)self + Lucy_Sim_Length_Norm_OFFSET;
    const lucy_Sim_length_norm_t method = *((lucy_Sim_length_norm_t*)method_address);
    return method((lucy_Similarity*)self, num_tokens);
}

extern size_t Lucy_Sim_Query_Norm_OFFSET;
static CHY_INLINE float
Lucy_Sim_Query_Norm(const lucy_Similarity *self, float sum_of_squared_weights) {
    char *const method_address = *(char**)self + Lucy_Sim_Query_Norm_OFFSET;
    const lucy_Sim_query_norm_t method = *((lucy_Sim_query_norm_t*)method_address);
    return method((lucy_Similarity*)self, sum_of_squared_weights);
}

extern size_t Lucy_Sim_Encode_Norm_OFFSET;
static CHY_INLINE uint32_t
Lucy_Sim_Encode_Norm(const lucy_Similarity *self, float f) {
    char *const method_address = *(char**)self + Lucy_Sim_Encode_Norm_OFFSET;
    const lucy_Sim_encode_norm_t method = *((lucy_Sim_encode_norm_t*)method_address);
    return method((lucy_Similarity*)self, f);
}

extern size_t Lucy_Sim_Decode_Norm_OFFSET;
static CHY_INLINE float
Lucy_Sim_Decode_Norm(const lucy_Similarity *self, uint32_t input) {
    char *const method_address = *(char**)self + Lucy_Sim_Decode_Norm_OFFSET;
    const lucy_Sim_decode_norm_t method = *((lucy_Sim_decode_norm_t*)method_address);
    return method((lucy_Similarity*)self, input);
}

extern size_t Lucy_Sim_Get_Norm_Decoder_OFFSET;
static CHY_INLINE float*
Lucy_Sim_Get_Norm_Decoder(const lucy_Similarity *self) {
    char *const method_address = *(char**)self + Lucy_Sim_Get_Norm_Decoder_OFFSET;
    const lucy_Sim_get_norm_decoder_t method = *((lucy_Sim_get_norm_decoder_t*)method_address);
    return method((lucy_Similarity*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SIMILARITY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_SIMILARITY_VT;
extern struct LUCY_SIMILARITY_VT LUCY_SIMILARITY_vt;
#define LUCY_SIMILARITY ((cfish_VTable*)&LUCY_SIMILARITY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Similarity lucy_Similarity
  #define SIMILARITY LUCY_SIMILARITY
  #define Sim_new lucy_Sim_new
  #define Sim_init lucy_Sim_init
  #define Sim_destroy_t lucy_Sim_destroy_t
  #define Sim_destroy lucy_Sim_destroy
  #define Sim_equals_t lucy_Sim_equals_t
  #define Sim_equals lucy_Sim_equals
  #define Sim_serialize_t lucy_Sim_serialize_t
  #define Sim_serialize lucy_Sim_serialize
  #define Sim_deserialize_t lucy_Sim_deserialize_t
  #define Sim_deserialize lucy_Sim_deserialize
  #define Sim_dump_t lucy_Sim_dump_t
  #define Sim_dump lucy_Sim_dump
  #define Sim_load_t lucy_Sim_load_t
  #define Sim_load lucy_Sim_load
  #define Sim_make_posting_t lucy_Sim_make_posting_t
  #define Sim_make_posting lucy_Sim_make_posting
  #define Sim_make_posting_writer_t lucy_Sim_make_posting_writer_t
  #define Sim_make_posting_writer lucy_Sim_make_posting_writer
  #define Sim_tf_t lucy_Sim_tf_t
  #define Sim_tf lucy_Sim_tf
  #define Sim_idf_t lucy_Sim_idf_t
  #define Sim_idf lucy_Sim_idf
  #define Sim_coord_t lucy_Sim_coord_t
  #define Sim_coord lucy_Sim_coord
  #define Sim_length_norm_t lucy_Sim_length_norm_t
  #define Sim_length_norm lucy_Sim_length_norm
  #define Sim_query_norm_t lucy_Sim_query_norm_t
  #define Sim_query_norm lucy_Sim_query_norm
  #define Sim_encode_norm_t lucy_Sim_encode_norm_t
  #define Sim_encode_norm lucy_Sim_encode_norm
  #define Sim_decode_norm_t lucy_Sim_decode_norm_t
  #define Sim_decode_norm lucy_Sim_decode_norm
  #define Sim_get_norm_decoder_t lucy_Sim_get_norm_decoder_t
  #define Sim_get_norm_decoder lucy_Sim_get_norm_decoder
  #define Sim_Make Lucy_Sim_Make
  #define Sim_Get_RefCount Lucy_Sim_Get_RefCount
  #define Sim_Inc_RefCount Lucy_Sim_Inc_RefCount
  #define Sim_Dec_RefCount Lucy_Sim_Dec_RefCount
  #define Sim_To_Host Lucy_Sim_To_Host
  #define Sim_Clone Lucy_Sim_Clone
  #define Sim_Destroy Lucy_Sim_Destroy
  #define Sim_Equals Lucy_Sim_Equals
  #define Sim_Compare_To Lucy_Sim_Compare_To
  #define Sim_Hash_Sum Lucy_Sim_Hash_Sum
  #define Sim_Get_VTable Lucy_Sim_Get_VTable
  #define Sim_Get_Class_Name Lucy_Sim_Get_Class_Name
  #define Sim_Is_A Lucy_Sim_Is_A
  #define Sim_To_String Lucy_Sim_To_String
  #define Sim_To_I64 Lucy_Sim_To_I64
  #define Sim_To_F64 Lucy_Sim_To_F64
  #define Sim_To_Bool Lucy_Sim_To_Bool
  #define Sim_Serialize Lucy_Sim_Serialize
  #define Sim_Deserialize Lucy_Sim_Deserialize
  #define Sim_Dump Lucy_Sim_Dump
  #define Sim_Load Lucy_Sim_Load
  #define Sim_Mimic Lucy_Sim_Mimic
  #define Sim_Make_Posting Lucy_Sim_Make_Posting
  #define Sim_Make_Posting_Writer Lucy_Sim_Make_Posting_Writer
  #define Sim_TF Lucy_Sim_TF
  #define Sim_IDF Lucy_Sim_IDF
  #define Sim_Coord Lucy_Sim_Coord
  #define Sim_Length_Norm Lucy_Sim_Length_Norm
  #define Sim_Query_Norm Lucy_Sim_Query_Norm
  #define Sim_Encode_Norm Lucy_Sim_Encode_Norm
  #define Sim_Decode_Norm Lucy_Sim_Decode_Norm
  #define Sim_Get_Norm_Decoder Lucy_Sim_Get_Norm_Decoder
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SIMILARITY */




