/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SNAPSHOT
#define H_LUCY_INDEX_SNAPSHOT 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SNAPSHOT
struct lucy_Snapshot {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Hash* entries;
    lucy_CharBuf* path;
};

#endif /* C_LUCY_SNAPSHOT */

/* Declare this class's inert variables.
 */

extern int32_t lucy_Snapshot_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Snapshot*
lucy_Snapshot_new();

lucy_Snapshot*
lucy_Snapshot_init(lucy_Snapshot* self);

void
lucy_Snapshot_destroy(lucy_Snapshot* self);

lucy_Obj*
lucy_Snapshot_dump(lucy_Snapshot* self);

lucy_Obj*
lucy_Snapshot_load(lucy_Snapshot* self, lucy_Obj* dump);

lucy_VArray*
lucy_Snapshot_list(lucy_Snapshot* self);

uint32_t
lucy_Snapshot_num_entries(lucy_Snapshot* self);

void
lucy_Snapshot_add_entry(lucy_Snapshot* self, const lucy_CharBuf* entry);

chy_bool_t
lucy_Snapshot_delete_entry(lucy_Snapshot* self, const lucy_CharBuf* entry);

lucy_Snapshot*
lucy_Snapshot_read_file(lucy_Snapshot* self, lucy_Folder* folder, const lucy_CharBuf* path);

void
lucy_Snapshot_write_file(lucy_Snapshot* self, lucy_Folder* folder, const lucy_CharBuf* path);

void
lucy_Snapshot_set_path(lucy_Snapshot* self, const lucy_CharBuf* path);

lucy_CharBuf*
lucy_Snapshot_get_path(lucy_Snapshot* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Snapshot_destroy_CALLBACK;
extern cfish_Callback lucy_Snapshot_dump_CALLBACK;
extern cfish_Callback lucy_Snapshot_load_CALLBACK;
extern cfish_Callback lucy_Snapshot_list_CALLBACK;
extern cfish_Callback lucy_Snapshot_num_entries_CALLBACK;
extern cfish_Callback lucy_Snapshot_add_entry_CALLBACK;
extern cfish_Callback lucy_Snapshot_delete_entry_CALLBACK;
extern cfish_Callback lucy_Snapshot_read_file_CALLBACK;
extern cfish_Callback lucy_Snapshot_write_file_CALLBACK;
extern cfish_Callback lucy_Snapshot_set_path_CALLBACK;
extern cfish_Callback lucy_Snapshot_get_path_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Snapshot_destroy_t)(lucy_Snapshot* self);

typedef lucy_Obj*
(*lucy_Snapshot_dump_t)(lucy_Snapshot* self);

typedef lucy_Obj*
(*lucy_Snapshot_load_t)(lucy_Snapshot* self, lucy_Obj* dump);

typedef lucy_VArray*
(*lucy_Snapshot_list_t)(lucy_Snapshot* self);

typedef uint32_t
(*lucy_Snapshot_num_entries_t)(lucy_Snapshot* self);

typedef void
(*lucy_Snapshot_add_entry_t)(lucy_Snapshot* self, const lucy_CharBuf* entry);

typedef chy_bool_t
(*lucy_Snapshot_delete_entry_t)(lucy_Snapshot* self, const lucy_CharBuf* entry);

typedef lucy_Snapshot*
(*lucy_Snapshot_read_file_t)(lucy_Snapshot* self, lucy_Folder* folder, const lucy_CharBuf* path);

typedef void
(*lucy_Snapshot_write_file_t)(lucy_Snapshot* self, lucy_Folder* folder, const lucy_CharBuf* path);

typedef void
(*lucy_Snapshot_set_path_t)(lucy_Snapshot* self, const lucy_CharBuf* path);

typedef lucy_CharBuf*
(*lucy_Snapshot_get_path_t)(lucy_Snapshot* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Snapshot_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Snapshot_Make(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Snapshot_Get_RefCount(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Snapshot_Inc_RefCount(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Snapshot_Dec_RefCount(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Snapshot_To_Host(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Snapshot_Clone(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Snapshot_Destroy(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Destroy_OFFSET;
    const lucy_Snapshot_destroy_t method = *((lucy_Snapshot_destroy_t*)method_address);
    method((lucy_Snapshot*)self);
}

extern size_t Lucy_Snapshot_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Snapshot_Equals(const lucy_Snapshot *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Snapshot_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Snapshot_Compare_To(const lucy_Snapshot *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Snapshot_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Snapshot_Hash_Sum(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Snapshot_Get_VTable(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Snapshot_Get_Class_Name(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Snapshot_Is_A(const lucy_Snapshot *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Snapshot_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Snapshot_To_String(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Snapshot_To_I64(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Snapshot_To_F64(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Snapshot_To_Bool(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Snapshot_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Snapshot_Serialize(const lucy_Snapshot *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Snapshot_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Snapshot_Deserialize(const lucy_Snapshot *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Snapshot_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Snapshot_Dump(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Dump_OFFSET;
    const lucy_Snapshot_dump_t method = *((lucy_Snapshot_dump_t*)method_address);
    return method((lucy_Snapshot*)self);
}

extern size_t Lucy_Snapshot_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Snapshot_Load(const lucy_Snapshot *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Load_OFFSET;
    const lucy_Snapshot_load_t method = *((lucy_Snapshot_load_t*)method_address);
    return method((lucy_Snapshot*)self, dump);
}

extern size_t Lucy_Snapshot_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Snapshot_Mimic(const lucy_Snapshot *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Snapshot_List_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Snapshot_List(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_List_OFFSET;
    const lucy_Snapshot_list_t method = *((lucy_Snapshot_list_t*)method_address);
    return method((lucy_Snapshot*)self);
}

extern size_t Lucy_Snapshot_Num_Entries_OFFSET;
static CHY_INLINE uint32_t
Lucy_Snapshot_Num_Entries(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Num_Entries_OFFSET;
    const lucy_Snapshot_num_entries_t method = *((lucy_Snapshot_num_entries_t*)method_address);
    return method((lucy_Snapshot*)self);
}

extern size_t Lucy_Snapshot_Add_Entry_OFFSET;
static CHY_INLINE void
Lucy_Snapshot_Add_Entry(const lucy_Snapshot *self, const lucy_CharBuf* entry) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Add_Entry_OFFSET;
    const lucy_Snapshot_add_entry_t method = *((lucy_Snapshot_add_entry_t*)method_address);
    method((lucy_Snapshot*)self, entry);
}

extern size_t Lucy_Snapshot_Delete_Entry_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Snapshot_Delete_Entry(const lucy_Snapshot *self, const lucy_CharBuf* entry) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Delete_Entry_OFFSET;
    const lucy_Snapshot_delete_entry_t method = *((lucy_Snapshot_delete_entry_t*)method_address);
    return method((lucy_Snapshot*)self, entry);
}

extern size_t Lucy_Snapshot_Read_File_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_Snapshot_Read_File(const lucy_Snapshot *self, lucy_Folder* folder, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Read_File_OFFSET;
    const lucy_Snapshot_read_file_t method = *((lucy_Snapshot_read_file_t*)method_address);
    return method((lucy_Snapshot*)self, folder, path);
}

extern size_t Lucy_Snapshot_Write_File_OFFSET;
static CHY_INLINE void
Lucy_Snapshot_Write_File(const lucy_Snapshot *self, lucy_Folder* folder, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Write_File_OFFSET;
    const lucy_Snapshot_write_file_t method = *((lucy_Snapshot_write_file_t*)method_address);
    method((lucy_Snapshot*)self, folder, path);
}

extern size_t Lucy_Snapshot_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_Snapshot_Set_Path(const lucy_Snapshot *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Set_Path_OFFSET;
    const lucy_Snapshot_set_path_t method = *((lucy_Snapshot_set_path_t*)method_address);
    method((lucy_Snapshot*)self, path);
}

extern size_t Lucy_Snapshot_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Snapshot_Get_Path(const lucy_Snapshot *self) {
    char *const method_address = *(char**)self + Lucy_Snapshot_Get_Path_OFFSET;
    const lucy_Snapshot_get_path_t method = *((lucy_Snapshot_get_path_t*)method_address);
    return method((lucy_Snapshot*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SNAPSHOT_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[30];
} LUCY_SNAPSHOT_VT;
extern struct LUCY_SNAPSHOT_VT LUCY_SNAPSHOT_vt;
#define LUCY_SNAPSHOT ((cfish_VTable*)&LUCY_SNAPSHOT_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Snapshot lucy_Snapshot
  #define SNAPSHOT LUCY_SNAPSHOT
  #define Snapshot_new lucy_Snapshot_new
  #define Snapshot_init lucy_Snapshot_init
  #define Snapshot_current_file_format lucy_Snapshot_current_file_format
  #define Snapshot_destroy_t lucy_Snapshot_destroy_t
  #define Snapshot_destroy lucy_Snapshot_destroy
  #define Snapshot_dump_t lucy_Snapshot_dump_t
  #define Snapshot_dump lucy_Snapshot_dump
  #define Snapshot_load_t lucy_Snapshot_load_t
  #define Snapshot_load lucy_Snapshot_load
  #define Snapshot_list_t lucy_Snapshot_list_t
  #define Snapshot_list lucy_Snapshot_list
  #define Snapshot_num_entries_t lucy_Snapshot_num_entries_t
  #define Snapshot_num_entries lucy_Snapshot_num_entries
  #define Snapshot_add_entry_t lucy_Snapshot_add_entry_t
  #define Snapshot_add_entry lucy_Snapshot_add_entry
  #define Snapshot_delete_entry_t lucy_Snapshot_delete_entry_t
  #define Snapshot_delete_entry lucy_Snapshot_delete_entry
  #define Snapshot_read_file_t lucy_Snapshot_read_file_t
  #define Snapshot_read_file lucy_Snapshot_read_file
  #define Snapshot_write_file_t lucy_Snapshot_write_file_t
  #define Snapshot_write_file lucy_Snapshot_write_file
  #define Snapshot_set_path_t lucy_Snapshot_set_path_t
  #define Snapshot_set_path lucy_Snapshot_set_path
  #define Snapshot_get_path_t lucy_Snapshot_get_path_t
  #define Snapshot_get_path lucy_Snapshot_get_path
  #define Snapshot_Make Lucy_Snapshot_Make
  #define Snapshot_Get_RefCount Lucy_Snapshot_Get_RefCount
  #define Snapshot_Inc_RefCount Lucy_Snapshot_Inc_RefCount
  #define Snapshot_Dec_RefCount Lucy_Snapshot_Dec_RefCount
  #define Snapshot_To_Host Lucy_Snapshot_To_Host
  #define Snapshot_Clone Lucy_Snapshot_Clone
  #define Snapshot_Destroy Lucy_Snapshot_Destroy
  #define Snapshot_Equals Lucy_Snapshot_Equals
  #define Snapshot_Compare_To Lucy_Snapshot_Compare_To
  #define Snapshot_Hash_Sum Lucy_Snapshot_Hash_Sum
  #define Snapshot_Get_VTable Lucy_Snapshot_Get_VTable
  #define Snapshot_Get_Class_Name Lucy_Snapshot_Get_Class_Name
  #define Snapshot_Is_A Lucy_Snapshot_Is_A
  #define Snapshot_To_String Lucy_Snapshot_To_String
  #define Snapshot_To_I64 Lucy_Snapshot_To_I64
  #define Snapshot_To_F64 Lucy_Snapshot_To_F64
  #define Snapshot_To_Bool Lucy_Snapshot_To_Bool
  #define Snapshot_Serialize Lucy_Snapshot_Serialize
  #define Snapshot_Deserialize Lucy_Snapshot_Deserialize
  #define Snapshot_Dump Lucy_Snapshot_Dump
  #define Snapshot_Load Lucy_Snapshot_Load
  #define Snapshot_Mimic Lucy_Snapshot_Mimic
  #define Snapshot_List Lucy_Snapshot_List
  #define Snapshot_Num_Entries Lucy_Snapshot_Num_Entries
  #define Snapshot_Add_Entry Lucy_Snapshot_Add_Entry
  #define Snapshot_Delete_Entry Lucy_Snapshot_Delete_Entry
  #define Snapshot_Read_File Lucy_Snapshot_Read_File
  #define Snapshot_Write_File Lucy_Snapshot_Write_File
  #define Snapshot_Set_Path Lucy_Snapshot_Set_Path
  #define Snapshot_Get_Path Lucy_Snapshot_Get_Path
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SNAPSHOT */




