/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTCACHE
#define H_LUCY_INDEX_SORTCACHE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTCACHE
struct lucy_SortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
};

#endif /* C_LUCY_SORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SortCache*
lucy_SortCache_init(lucy_SortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, void* ords, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width);

void
lucy_SortCache_destroy(lucy_SortCache* self);

lucy_Obj*
lucy_SortCache_value(lucy_SortCache* self, int32_t ord, lucy_Obj* blank);

lucy_Obj*
lucy_SortCache_make_blank(lucy_SortCache* self);

void*
lucy_SortCache_get_ords(lucy_SortCache* self);

int32_t
lucy_SortCache_get_cardinality(lucy_SortCache* self);

int32_t
lucy_SortCache_get_ord_width(lucy_SortCache* self);

int32_t
lucy_SortCache_get_null_ord(lucy_SortCache* self);

int32_t
lucy_SortCache_ordinal(lucy_SortCache* self, int32_t doc_id);

int32_t
lucy_SortCache_find(lucy_SortCache* self, lucy_Obj* term);

void
lucy_SortCache_set_native_ords(lucy_SortCache* self, chy_bool_t native_ords);

chy_bool_t
lucy_SortCache_get_native_ords(lucy_SortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SortCache_destroy_CALLBACK;
extern cfish_Callback lucy_SortCache_value_CALLBACK;
extern cfish_Callback lucy_SortCache_make_blank_CALLBACK;
extern cfish_Callback lucy_SortCache_get_ords_CALLBACK;
extern cfish_Callback lucy_SortCache_get_cardinality_CALLBACK;
extern cfish_Callback lucy_SortCache_get_ord_width_CALLBACK;
extern cfish_Callback lucy_SortCache_get_null_ord_CALLBACK;
extern cfish_Callback lucy_SortCache_ordinal_CALLBACK;
extern cfish_Callback lucy_SortCache_find_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SortCache_destroy_t)(lucy_SortCache* self);

typedef lucy_Obj*
(*lucy_SortCache_value_t)(lucy_SortCache* self, int32_t ord, lucy_Obj* blank);

typedef lucy_Obj*
(*lucy_SortCache_make_blank_t)(lucy_SortCache* self);

typedef void*
(*lucy_SortCache_get_ords_t)(lucy_SortCache* self);

typedef int32_t
(*lucy_SortCache_get_cardinality_t)(lucy_SortCache* self);

typedef int32_t
(*lucy_SortCache_get_ord_width_t)(lucy_SortCache* self);

typedef int32_t
(*lucy_SortCache_get_null_ord_t)(lucy_SortCache* self);

typedef int32_t
(*lucy_SortCache_ordinal_t)(lucy_SortCache* self, int32_t doc_id);

typedef int32_t
(*lucy_SortCache_find_t)(lucy_SortCache* self, lucy_Obj* term);

typedef void
(*lucy_SortCache_set_native_ords_t)(lucy_SortCache* self, chy_bool_t native_ords);

typedef chy_bool_t
(*lucy_SortCache_get_native_ords_t)(lucy_SortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Make(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortCache_Get_RefCount(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Inc_RefCount(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortCache_Dec_RefCount(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SortCache_To_Host(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Clone(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SortCache_Destroy(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Destroy_OFFSET;
    const lucy_SortCache_destroy_t method = *((lucy_SortCache_destroy_t*)method_address);
    method((lucy_SortCache*)self);
}

extern size_t Lucy_SortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortCache_Equals(const lucy_SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Compare_To(const lucy_SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Hash_Sum(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SortCache_Get_VTable(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortCache_Get_Class_Name(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortCache_Is_A(const lucy_SortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortCache_To_String(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SortCache_To_I64(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SortCache_To_F64(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortCache_To_Bool(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SortCache_Serialize(const lucy_SortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Deserialize(const lucy_SortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Dump(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Load(const lucy_SortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SortCache_Mimic(const lucy_SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Value(const lucy_SortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_SortCache_Value_OFFSET;
    const lucy_SortCache_value_t method = *((lucy_SortCache_value_t*)method_address);
    return method((lucy_SortCache*)self, ord, blank);
}

extern size_t Lucy_SortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortCache_Make_Blank(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Make_Blank_OFFSET;
    const lucy_SortCache_make_blank_t method = *((lucy_SortCache_make_blank_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_SortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_SortCache_Get_Ords(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_SortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Get_Cardinality(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_SortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Get_Ord_Width(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_SortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Get_Null_Ord(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_SortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Ordinal(const lucy_SortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_SortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_SortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_SortCache_Find(const lucy_SortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_SortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_SortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_SortCache_Set_Native_Ords(const lucy_SortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_SortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_SortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortCache_Get_Native_Ords(const lucy_SortCache *self) {
    char *const method_address = *(char**)self + Lucy_SortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_SORTCACHE_VT;
extern struct LUCY_SORTCACHE_VT LUCY_SORTCACHE_vt;
#define LUCY_SORTCACHE ((cfish_VTable*)&LUCY_SORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortCache lucy_SortCache
  #define SORTCACHE LUCY_SORTCACHE
  #define SortCache_init lucy_SortCache_init
  #define SortCache_destroy_t lucy_SortCache_destroy_t
  #define SortCache_destroy lucy_SortCache_destroy
  #define SortCache_value_t lucy_SortCache_value_t
  #define SortCache_value lucy_SortCache_value
  #define SortCache_make_blank_t lucy_SortCache_make_blank_t
  #define SortCache_make_blank lucy_SortCache_make_blank
  #define SortCache_get_ords_t lucy_SortCache_get_ords_t
  #define SortCache_get_ords lucy_SortCache_get_ords
  #define SortCache_get_cardinality_t lucy_SortCache_get_cardinality_t
  #define SortCache_get_cardinality lucy_SortCache_get_cardinality
  #define SortCache_get_ord_width_t lucy_SortCache_get_ord_width_t
  #define SortCache_get_ord_width lucy_SortCache_get_ord_width
  #define SortCache_get_null_ord_t lucy_SortCache_get_null_ord_t
  #define SortCache_get_null_ord lucy_SortCache_get_null_ord
  #define SortCache_ordinal_t lucy_SortCache_ordinal_t
  #define SortCache_ordinal lucy_SortCache_ordinal
  #define SortCache_find_t lucy_SortCache_find_t
  #define SortCache_find lucy_SortCache_find
  #define SortCache_set_native_ords_t lucy_SortCache_set_native_ords_t
  #define SortCache_set_native_ords lucy_SortCache_set_native_ords
  #define SortCache_get_native_ords_t lucy_SortCache_get_native_ords_t
  #define SortCache_get_native_ords lucy_SortCache_get_native_ords
  #define SortCache_Make Lucy_SortCache_Make
  #define SortCache_Get_RefCount Lucy_SortCache_Get_RefCount
  #define SortCache_Inc_RefCount Lucy_SortCache_Inc_RefCount
  #define SortCache_Dec_RefCount Lucy_SortCache_Dec_RefCount
  #define SortCache_To_Host Lucy_SortCache_To_Host
  #define SortCache_Clone Lucy_SortCache_Clone
  #define SortCache_Destroy Lucy_SortCache_Destroy
  #define SortCache_Equals Lucy_SortCache_Equals
  #define SortCache_Compare_To Lucy_SortCache_Compare_To
  #define SortCache_Hash_Sum Lucy_SortCache_Hash_Sum
  #define SortCache_Get_VTable Lucy_SortCache_Get_VTable
  #define SortCache_Get_Class_Name Lucy_SortCache_Get_Class_Name
  #define SortCache_Is_A Lucy_SortCache_Is_A
  #define SortCache_To_String Lucy_SortCache_To_String
  #define SortCache_To_I64 Lucy_SortCache_To_I64
  #define SortCache_To_F64 Lucy_SortCache_To_F64
  #define SortCache_To_Bool Lucy_SortCache_To_Bool
  #define SortCache_Serialize Lucy_SortCache_Serialize
  #define SortCache_Deserialize Lucy_SortCache_Deserialize
  #define SortCache_Dump Lucy_SortCache_Dump
  #define SortCache_Load Lucy_SortCache_Load
  #define SortCache_Mimic Lucy_SortCache_Mimic
  #define SortCache_Value Lucy_SortCache_Value
  #define SortCache_Make_Blank Lucy_SortCache_Make_Blank
  #define SortCache_Get_Ords Lucy_SortCache_Get_Ords
  #define SortCache_Get_Cardinality Lucy_SortCache_Get_Cardinality
  #define SortCache_Get_Ord_Width Lucy_SortCache_Get_Ord_Width
  #define SortCache_Get_Null_Ord Lucy_SortCache_Get_Null_Ord
  #define SortCache_Ordinal Lucy_SortCache_Ordinal
  #define SortCache_Find Lucy_SortCache_Find
  #define SortCache_Set_Native_Ords Lucy_SortCache_Set_Native_Ords
  #define SortCache_Get_Native_Ords Lucy_SortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTCACHE */




