/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTCACHE_NUMERICSORTCACHE
#define H_LUCY_INDEX_SORTCACHE_NUMERICSORTCACHE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortCache.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_NUMERICSORTCACHE
struct lucy_NumericSortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
    lucy_InStream* ord_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_NUMERICSORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_NumericSortCache*
lucy_NumSortCache_init(lucy_NumericSortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

void
lucy_NumSortCache_destroy(lucy_NumericSortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_NumSortCache_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_NumSortCache_destroy_t)(lucy_NumericSortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_NumSortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Make(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NumSortCache_Get_RefCount(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Inc_RefCount(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NumSortCache_Dec_RefCount(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_NumSortCache_To_Host(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Clone(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_NumSortCache_Destroy(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Destroy_OFFSET;
    const lucy_NumSortCache_destroy_t method = *((lucy_NumSortCache_destroy_t*)method_address);
    method((lucy_NumericSortCache*)self);
}

extern size_t Lucy_NumSortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumSortCache_Equals(const lucy_NumericSortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NumSortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Compare_To(const lucy_NumericSortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NumSortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Hash_Sum(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_NumSortCache_Get_VTable(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NumSortCache_Get_Class_Name(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumSortCache_Is_A(const lucy_NumericSortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_NumSortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NumSortCache_To_String(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_NumSortCache_To_I64(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_NumSortCache_To_F64(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumSortCache_To_Bool(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_NumSortCache_Serialize(const lucy_NumericSortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_NumSortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Deserialize(const lucy_NumericSortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_NumSortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Dump(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumSortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Load(const lucy_NumericSortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_NumSortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_NumSortCache_Mimic(const lucy_NumericSortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_NumSortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Value(const lucy_NumericSortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Value_OFFSET;
    const lucy_SortCache_value_t method = *((lucy_SortCache_value_t*)method_address);
    return method((lucy_SortCache*)self, ord, blank);
}

extern size_t Lucy_NumSortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumSortCache_Make_Blank(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Make_Blank_OFFSET;
    const lucy_SortCache_make_blank_t method = *((lucy_SortCache_make_blank_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_NumSortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_NumSortCache_Get_Ords(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_NumSortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Get_Cardinality(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_NumSortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Get_Ord_Width(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_NumSortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Get_Null_Ord(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_NumSortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Ordinal(const lucy_NumericSortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_NumSortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_NumSortCache_Find(const lucy_NumericSortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_NumSortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_NumSortCache_Set_Native_Ords(const lucy_NumericSortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_NumSortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumSortCache_Get_Native_Ords(const lucy_NumericSortCache *self) {
    char *const method_address = *(char**)self + Lucy_NumSortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_NUMERICSORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_NUMERICSORTCACHE_VT;
extern struct LUCY_NUMERICSORTCACHE_VT LUCY_NUMERICSORTCACHE_vt;
#define LUCY_NUMERICSORTCACHE ((cfish_VTable*)&LUCY_NUMERICSORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define NumericSortCache lucy_NumericSortCache
  #define NUMERICSORTCACHE LUCY_NUMERICSORTCACHE
  #define NumSortCache_init lucy_NumSortCache_init
  #define NumSortCache_destroy_t lucy_NumSortCache_destroy_t
  #define NumSortCache_destroy lucy_NumSortCache_destroy
  #define NumSortCache_Make Lucy_NumSortCache_Make
  #define NumSortCache_Get_RefCount Lucy_NumSortCache_Get_RefCount
  #define NumSortCache_Inc_RefCount Lucy_NumSortCache_Inc_RefCount
  #define NumSortCache_Dec_RefCount Lucy_NumSortCache_Dec_RefCount
  #define NumSortCache_To_Host Lucy_NumSortCache_To_Host
  #define NumSortCache_Clone Lucy_NumSortCache_Clone
  #define NumSortCache_Destroy Lucy_NumSortCache_Destroy
  #define NumSortCache_Equals Lucy_NumSortCache_Equals
  #define NumSortCache_Compare_To Lucy_NumSortCache_Compare_To
  #define NumSortCache_Hash_Sum Lucy_NumSortCache_Hash_Sum
  #define NumSortCache_Get_VTable Lucy_NumSortCache_Get_VTable
  #define NumSortCache_Get_Class_Name Lucy_NumSortCache_Get_Class_Name
  #define NumSortCache_Is_A Lucy_NumSortCache_Is_A
  #define NumSortCache_To_String Lucy_NumSortCache_To_String
  #define NumSortCache_To_I64 Lucy_NumSortCache_To_I64
  #define NumSortCache_To_F64 Lucy_NumSortCache_To_F64
  #define NumSortCache_To_Bool Lucy_NumSortCache_To_Bool
  #define NumSortCache_Serialize Lucy_NumSortCache_Serialize
  #define NumSortCache_Deserialize Lucy_NumSortCache_Deserialize
  #define NumSortCache_Dump Lucy_NumSortCache_Dump
  #define NumSortCache_Load Lucy_NumSortCache_Load
  #define NumSortCache_Mimic Lucy_NumSortCache_Mimic
  #define NumSortCache_Value Lucy_NumSortCache_Value
  #define NumSortCache_Make_Blank Lucy_NumSortCache_Make_Blank
  #define NumSortCache_Get_Ords Lucy_NumSortCache_Get_Ords
  #define NumSortCache_Get_Cardinality Lucy_NumSortCache_Get_Cardinality
  #define NumSortCache_Get_Ord_Width Lucy_NumSortCache_Get_Ord_Width
  #define NumSortCache_Get_Null_Ord Lucy_NumSortCache_Get_Null_Ord
  #define NumSortCache_Ordinal Lucy_NumSortCache_Ordinal
  #define NumSortCache_Find Lucy_NumSortCache_Find
  #define NumSortCache_Set_Native_Ords Lucy_NumSortCache_Set_Native_Ords
  #define NumSortCache_Get_Native_Ords Lucy_NumSortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortCache/NumericSortCache.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FLOAT64SORTCACHE
struct lucy_Float64SortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
    lucy_InStream* ord_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_FLOAT64SORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Float64SortCache*
lucy_F64SortCache_new(const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Float64SortCache*
lucy_F64SortCache_init(lucy_Float64SortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Obj*
lucy_F64SortCache_value(lucy_Float64SortCache* self, int32_t ord, lucy_Obj* blank);

lucy_Float64*
lucy_F64SortCache_make_blank(lucy_Float64SortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_F64SortCache_value_CALLBACK;
extern cfish_Callback lucy_F64SortCache_make_blank_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Obj*
(*lucy_F64SortCache_value_t)(lucy_Float64SortCache* self, int32_t ord, lucy_Obj* blank);

typedef lucy_Float64*
(*lucy_F64SortCache_make_blank_t)(lucy_Float64SortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_F64SortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Make(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_F64SortCache_Get_RefCount(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Inc_RefCount(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_F64SortCache_Dec_RefCount(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_F64SortCache_To_Host(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Clone(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_F64SortCache_Destroy(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Destroy_OFFSET;
    const lucy_NumSortCache_destroy_t method = *((lucy_NumSortCache_destroy_t*)method_address);
    method((lucy_NumericSortCache*)self);
}

extern size_t Lucy_F64SortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F64SortCache_Equals(const lucy_Float64SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_F64SortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Compare_To(const lucy_Float64SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_F64SortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Hash_Sum(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_F64SortCache_Get_VTable(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_F64SortCache_Get_Class_Name(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F64SortCache_Is_A(const lucy_Float64SortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_F64SortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_F64SortCache_To_String(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_F64SortCache_To_I64(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_F64SortCache_To_F64(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F64SortCache_To_Bool(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_F64SortCache_Serialize(const lucy_Float64SortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_F64SortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Deserialize(const lucy_Float64SortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_F64SortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Dump(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F64SortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Load(const lucy_Float64SortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_F64SortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_F64SortCache_Mimic(const lucy_Float64SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_F64SortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F64SortCache_Value(const lucy_Float64SortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Value_OFFSET;
    const lucy_F64SortCache_value_t method = *((lucy_F64SortCache_value_t*)method_address);
    return method((lucy_Float64SortCache*)self, ord, blank);
}

extern size_t Lucy_F64SortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_Float64*
Lucy_F64SortCache_Make_Blank(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Make_Blank_OFFSET;
    const lucy_F64SortCache_make_blank_t method = *((lucy_F64SortCache_make_blank_t*)method_address);
    return method((lucy_Float64SortCache*)self);
}

extern size_t Lucy_F64SortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_F64SortCache_Get_Ords(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F64SortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Get_Cardinality(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F64SortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Get_Ord_Width(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F64SortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Get_Null_Ord(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F64SortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Ordinal(const lucy_Float64SortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_F64SortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_F64SortCache_Find(const lucy_Float64SortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_F64SortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_F64SortCache_Set_Native_Ords(const lucy_Float64SortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_F64SortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F64SortCache_Get_Native_Ords(const lucy_Float64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F64SortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FLOAT64SORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_FLOAT64SORTCACHE_VT;
extern struct LUCY_FLOAT64SORTCACHE_VT LUCY_FLOAT64SORTCACHE_vt;
#define LUCY_FLOAT64SORTCACHE ((cfish_VTable*)&LUCY_FLOAT64SORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Float64SortCache lucy_Float64SortCache
  #define FLOAT64SORTCACHE LUCY_FLOAT64SORTCACHE
  #define F64SortCache_new lucy_F64SortCache_new
  #define F64SortCache_init lucy_F64SortCache_init
  #define F64SortCache_value_t lucy_F64SortCache_value_t
  #define F64SortCache_value lucy_F64SortCache_value
  #define F64SortCache_make_blank_t lucy_F64SortCache_make_blank_t
  #define F64SortCache_make_blank lucy_F64SortCache_make_blank
  #define F64SortCache_Make Lucy_F64SortCache_Make
  #define F64SortCache_Get_RefCount Lucy_F64SortCache_Get_RefCount
  #define F64SortCache_Inc_RefCount Lucy_F64SortCache_Inc_RefCount
  #define F64SortCache_Dec_RefCount Lucy_F64SortCache_Dec_RefCount
  #define F64SortCache_To_Host Lucy_F64SortCache_To_Host
  #define F64SortCache_Clone Lucy_F64SortCache_Clone
  #define F64SortCache_Destroy Lucy_F64SortCache_Destroy
  #define F64SortCache_Equals Lucy_F64SortCache_Equals
  #define F64SortCache_Compare_To Lucy_F64SortCache_Compare_To
  #define F64SortCache_Hash_Sum Lucy_F64SortCache_Hash_Sum
  #define F64SortCache_Get_VTable Lucy_F64SortCache_Get_VTable
  #define F64SortCache_Get_Class_Name Lucy_F64SortCache_Get_Class_Name
  #define F64SortCache_Is_A Lucy_F64SortCache_Is_A
  #define F64SortCache_To_String Lucy_F64SortCache_To_String
  #define F64SortCache_To_I64 Lucy_F64SortCache_To_I64
  #define F64SortCache_To_F64 Lucy_F64SortCache_To_F64
  #define F64SortCache_To_Bool Lucy_F64SortCache_To_Bool
  #define F64SortCache_Serialize Lucy_F64SortCache_Serialize
  #define F64SortCache_Deserialize Lucy_F64SortCache_Deserialize
  #define F64SortCache_Dump Lucy_F64SortCache_Dump
  #define F64SortCache_Load Lucy_F64SortCache_Load
  #define F64SortCache_Mimic Lucy_F64SortCache_Mimic
  #define F64SortCache_Value Lucy_F64SortCache_Value
  #define F64SortCache_Make_Blank Lucy_F64SortCache_Make_Blank
  #define F64SortCache_Get_Ords Lucy_F64SortCache_Get_Ords
  #define F64SortCache_Get_Cardinality Lucy_F64SortCache_Get_Cardinality
  #define F64SortCache_Get_Ord_Width Lucy_F64SortCache_Get_Ord_Width
  #define F64SortCache_Get_Null_Ord Lucy_F64SortCache_Get_Null_Ord
  #define F64SortCache_Ordinal Lucy_F64SortCache_Ordinal
  #define F64SortCache_Find Lucy_F64SortCache_Find
  #define F64SortCache_Set_Native_Ords Lucy_F64SortCache_Set_Native_Ords
  #define F64SortCache_Get_Native_Ords Lucy_F64SortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortCache/NumericSortCache.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FLOAT32SORTCACHE
struct lucy_Float32SortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
    lucy_InStream* ord_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_FLOAT32SORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Float32SortCache*
lucy_F32SortCache_new(const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Float32SortCache*
lucy_F32SortCache_init(lucy_Float32SortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Obj*
lucy_F32SortCache_value(lucy_Float32SortCache* self, int32_t ord, lucy_Obj* blank);

lucy_Float32*
lucy_F32SortCache_make_blank(lucy_Float32SortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_F32SortCache_value_CALLBACK;
extern cfish_Callback lucy_F32SortCache_make_blank_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Obj*
(*lucy_F32SortCache_value_t)(lucy_Float32SortCache* self, int32_t ord, lucy_Obj* blank);

typedef lucy_Float32*
(*lucy_F32SortCache_make_blank_t)(lucy_Float32SortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_F32SortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Make(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_F32SortCache_Get_RefCount(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Inc_RefCount(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_F32SortCache_Dec_RefCount(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_F32SortCache_To_Host(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Clone(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_F32SortCache_Destroy(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Destroy_OFFSET;
    const lucy_NumSortCache_destroy_t method = *((lucy_NumSortCache_destroy_t*)method_address);
    method((lucy_NumericSortCache*)self);
}

extern size_t Lucy_F32SortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F32SortCache_Equals(const lucy_Float32SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_F32SortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Compare_To(const lucy_Float32SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_F32SortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Hash_Sum(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_F32SortCache_Get_VTable(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_F32SortCache_Get_Class_Name(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F32SortCache_Is_A(const lucy_Float32SortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_F32SortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_F32SortCache_To_String(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_F32SortCache_To_I64(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_F32SortCache_To_F64(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F32SortCache_To_Bool(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_F32SortCache_Serialize(const lucy_Float32SortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_F32SortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Deserialize(const lucy_Float32SortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_F32SortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Dump(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_F32SortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Load(const lucy_Float32SortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_F32SortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_F32SortCache_Mimic(const lucy_Float32SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_F32SortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_F32SortCache_Value(const lucy_Float32SortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Value_OFFSET;
    const lucy_F32SortCache_value_t method = *((lucy_F32SortCache_value_t*)method_address);
    return method((lucy_Float32SortCache*)self, ord, blank);
}

extern size_t Lucy_F32SortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_Float32*
Lucy_F32SortCache_Make_Blank(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Make_Blank_OFFSET;
    const lucy_F32SortCache_make_blank_t method = *((lucy_F32SortCache_make_blank_t*)method_address);
    return method((lucy_Float32SortCache*)self);
}

extern size_t Lucy_F32SortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_F32SortCache_Get_Ords(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F32SortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Get_Cardinality(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F32SortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Get_Ord_Width(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F32SortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Get_Null_Ord(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_F32SortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Ordinal(const lucy_Float32SortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_F32SortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_F32SortCache_Find(const lucy_Float32SortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_F32SortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_F32SortCache_Set_Native_Ords(const lucy_Float32SortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_F32SortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_F32SortCache_Get_Native_Ords(const lucy_Float32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_F32SortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FLOAT32SORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_FLOAT32SORTCACHE_VT;
extern struct LUCY_FLOAT32SORTCACHE_VT LUCY_FLOAT32SORTCACHE_vt;
#define LUCY_FLOAT32SORTCACHE ((cfish_VTable*)&LUCY_FLOAT32SORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Float32SortCache lucy_Float32SortCache
  #define FLOAT32SORTCACHE LUCY_FLOAT32SORTCACHE
  #define F32SortCache_new lucy_F32SortCache_new
  #define F32SortCache_init lucy_F32SortCache_init
  #define F32SortCache_value_t lucy_F32SortCache_value_t
  #define F32SortCache_value lucy_F32SortCache_value
  #define F32SortCache_make_blank_t lucy_F32SortCache_make_blank_t
  #define F32SortCache_make_blank lucy_F32SortCache_make_blank
  #define F32SortCache_Make Lucy_F32SortCache_Make
  #define F32SortCache_Get_RefCount Lucy_F32SortCache_Get_RefCount
  #define F32SortCache_Inc_RefCount Lucy_F32SortCache_Inc_RefCount
  #define F32SortCache_Dec_RefCount Lucy_F32SortCache_Dec_RefCount
  #define F32SortCache_To_Host Lucy_F32SortCache_To_Host
  #define F32SortCache_Clone Lucy_F32SortCache_Clone
  #define F32SortCache_Destroy Lucy_F32SortCache_Destroy
  #define F32SortCache_Equals Lucy_F32SortCache_Equals
  #define F32SortCache_Compare_To Lucy_F32SortCache_Compare_To
  #define F32SortCache_Hash_Sum Lucy_F32SortCache_Hash_Sum
  #define F32SortCache_Get_VTable Lucy_F32SortCache_Get_VTable
  #define F32SortCache_Get_Class_Name Lucy_F32SortCache_Get_Class_Name
  #define F32SortCache_Is_A Lucy_F32SortCache_Is_A
  #define F32SortCache_To_String Lucy_F32SortCache_To_String
  #define F32SortCache_To_I64 Lucy_F32SortCache_To_I64
  #define F32SortCache_To_F64 Lucy_F32SortCache_To_F64
  #define F32SortCache_To_Bool Lucy_F32SortCache_To_Bool
  #define F32SortCache_Serialize Lucy_F32SortCache_Serialize
  #define F32SortCache_Deserialize Lucy_F32SortCache_Deserialize
  #define F32SortCache_Dump Lucy_F32SortCache_Dump
  #define F32SortCache_Load Lucy_F32SortCache_Load
  #define F32SortCache_Mimic Lucy_F32SortCache_Mimic
  #define F32SortCache_Value Lucy_F32SortCache_Value
  #define F32SortCache_Make_Blank Lucy_F32SortCache_Make_Blank
  #define F32SortCache_Get_Ords Lucy_F32SortCache_Get_Ords
  #define F32SortCache_Get_Cardinality Lucy_F32SortCache_Get_Cardinality
  #define F32SortCache_Get_Ord_Width Lucy_F32SortCache_Get_Ord_Width
  #define F32SortCache_Get_Null_Ord Lucy_F32SortCache_Get_Null_Ord
  #define F32SortCache_Ordinal Lucy_F32SortCache_Ordinal
  #define F32SortCache_Find Lucy_F32SortCache_Find
  #define F32SortCache_Set_Native_Ords Lucy_F32SortCache_Set_Native_Ords
  #define F32SortCache_Get_Native_Ords Lucy_F32SortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortCache/NumericSortCache.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INT32SORTCACHE
struct lucy_Int32SortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
    lucy_InStream* ord_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_INT32SORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Int32SortCache*
lucy_I32SortCache_new(const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Int32SortCache*
lucy_I32SortCache_init(lucy_Int32SortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Obj*
lucy_I32SortCache_value(lucy_Int32SortCache* self, int32_t ord, lucy_Obj* blank);

lucy_Integer32*
lucy_I32SortCache_make_blank(lucy_Int32SortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_I32SortCache_value_CALLBACK;
extern cfish_Callback lucy_I32SortCache_make_blank_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Obj*
(*lucy_I32SortCache_value_t)(lucy_Int32SortCache* self, int32_t ord, lucy_Obj* blank);

typedef lucy_Integer32*
(*lucy_I32SortCache_make_blank_t)(lucy_Int32SortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_I32SortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Make(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_I32SortCache_Get_RefCount(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Inc_RefCount(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_I32SortCache_Dec_RefCount(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_I32SortCache_To_Host(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Clone(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_I32SortCache_Destroy(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Destroy_OFFSET;
    const lucy_NumSortCache_destroy_t method = *((lucy_NumSortCache_destroy_t*)method_address);
    method((lucy_NumericSortCache*)self);
}

extern size_t Lucy_I32SortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I32SortCache_Equals(const lucy_Int32SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_I32SortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Compare_To(const lucy_Int32SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_I32SortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Hash_Sum(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_I32SortCache_Get_VTable(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_I32SortCache_Get_Class_Name(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I32SortCache_Is_A(const lucy_Int32SortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_I32SortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_I32SortCache_To_String(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_I32SortCache_To_I64(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_I32SortCache_To_F64(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I32SortCache_To_Bool(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_I32SortCache_Serialize(const lucy_Int32SortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_I32SortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Deserialize(const lucy_Int32SortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_I32SortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Dump(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I32SortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Load(const lucy_Int32SortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_I32SortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_I32SortCache_Mimic(const lucy_Int32SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_I32SortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I32SortCache_Value(const lucy_Int32SortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Value_OFFSET;
    const lucy_I32SortCache_value_t method = *((lucy_I32SortCache_value_t*)method_address);
    return method((lucy_Int32SortCache*)self, ord, blank);
}

extern size_t Lucy_I32SortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_Integer32*
Lucy_I32SortCache_Make_Blank(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Make_Blank_OFFSET;
    const lucy_I32SortCache_make_blank_t method = *((lucy_I32SortCache_make_blank_t*)method_address);
    return method((lucy_Int32SortCache*)self);
}

extern size_t Lucy_I32SortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_I32SortCache_Get_Ords(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I32SortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Get_Cardinality(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I32SortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Get_Ord_Width(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I32SortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Get_Null_Ord(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I32SortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Ordinal(const lucy_Int32SortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_I32SortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_I32SortCache_Find(const lucy_Int32SortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_I32SortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_I32SortCache_Set_Native_Ords(const lucy_Int32SortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_I32SortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I32SortCache_Get_Native_Ords(const lucy_Int32SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I32SortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INT32SORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_INT32SORTCACHE_VT;
extern struct LUCY_INT32SORTCACHE_VT LUCY_INT32SORTCACHE_vt;
#define LUCY_INT32SORTCACHE ((cfish_VTable*)&LUCY_INT32SORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Int32SortCache lucy_Int32SortCache
  #define INT32SORTCACHE LUCY_INT32SORTCACHE
  #define I32SortCache_new lucy_I32SortCache_new
  #define I32SortCache_init lucy_I32SortCache_init
  #define I32SortCache_value_t lucy_I32SortCache_value_t
  #define I32SortCache_value lucy_I32SortCache_value
  #define I32SortCache_make_blank_t lucy_I32SortCache_make_blank_t
  #define I32SortCache_make_blank lucy_I32SortCache_make_blank
  #define I32SortCache_Make Lucy_I32SortCache_Make
  #define I32SortCache_Get_RefCount Lucy_I32SortCache_Get_RefCount
  #define I32SortCache_Inc_RefCount Lucy_I32SortCache_Inc_RefCount
  #define I32SortCache_Dec_RefCount Lucy_I32SortCache_Dec_RefCount
  #define I32SortCache_To_Host Lucy_I32SortCache_To_Host
  #define I32SortCache_Clone Lucy_I32SortCache_Clone
  #define I32SortCache_Destroy Lucy_I32SortCache_Destroy
  #define I32SortCache_Equals Lucy_I32SortCache_Equals
  #define I32SortCache_Compare_To Lucy_I32SortCache_Compare_To
  #define I32SortCache_Hash_Sum Lucy_I32SortCache_Hash_Sum
  #define I32SortCache_Get_VTable Lucy_I32SortCache_Get_VTable
  #define I32SortCache_Get_Class_Name Lucy_I32SortCache_Get_Class_Name
  #define I32SortCache_Is_A Lucy_I32SortCache_Is_A
  #define I32SortCache_To_String Lucy_I32SortCache_To_String
  #define I32SortCache_To_I64 Lucy_I32SortCache_To_I64
  #define I32SortCache_To_F64 Lucy_I32SortCache_To_F64
  #define I32SortCache_To_Bool Lucy_I32SortCache_To_Bool
  #define I32SortCache_Serialize Lucy_I32SortCache_Serialize
  #define I32SortCache_Deserialize Lucy_I32SortCache_Deserialize
  #define I32SortCache_Dump Lucy_I32SortCache_Dump
  #define I32SortCache_Load Lucy_I32SortCache_Load
  #define I32SortCache_Mimic Lucy_I32SortCache_Mimic
  #define I32SortCache_Value Lucy_I32SortCache_Value
  #define I32SortCache_Make_Blank Lucy_I32SortCache_Make_Blank
  #define I32SortCache_Get_Ords Lucy_I32SortCache_Get_Ords
  #define I32SortCache_Get_Cardinality Lucy_I32SortCache_Get_Cardinality
  #define I32SortCache_Get_Ord_Width Lucy_I32SortCache_Get_Ord_Width
  #define I32SortCache_Get_Null_Ord Lucy_I32SortCache_Get_Null_Ord
  #define I32SortCache_Ordinal Lucy_I32SortCache_Ordinal
  #define I32SortCache_Find Lucy_I32SortCache_Find
  #define I32SortCache_Set_Native_Ords Lucy_I32SortCache_Set_Native_Ords
  #define I32SortCache_Get_Native_Ords Lucy_I32SortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortCache/NumericSortCache.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INT64SORTCACHE
struct lucy_Int64SortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
    lucy_InStream* ord_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_INT64SORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Int64SortCache*
lucy_I64SortCache_new(const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Int64SortCache*
lucy_I64SortCache_init(lucy_Int64SortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* dat_in);

lucy_Obj*
lucy_I64SortCache_value(lucy_Int64SortCache* self, int32_t ord, lucy_Obj* blank);

lucy_Integer64*
lucy_I64SortCache_make_blank(lucy_Int64SortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_I64SortCache_value_CALLBACK;
extern cfish_Callback lucy_I64SortCache_make_blank_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Obj*
(*lucy_I64SortCache_value_t)(lucy_Int64SortCache* self, int32_t ord, lucy_Obj* blank);

typedef lucy_Integer64*
(*lucy_I64SortCache_make_blank_t)(lucy_Int64SortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_I64SortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Make(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_I64SortCache_Get_RefCount(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Inc_RefCount(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_I64SortCache_Dec_RefCount(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_I64SortCache_To_Host(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Clone(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_I64SortCache_Destroy(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Destroy_OFFSET;
    const lucy_NumSortCache_destroy_t method = *((lucy_NumSortCache_destroy_t*)method_address);
    method((lucy_NumericSortCache*)self);
}

extern size_t Lucy_I64SortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I64SortCache_Equals(const lucy_Int64SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_I64SortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Compare_To(const lucy_Int64SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_I64SortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Hash_Sum(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_I64SortCache_Get_VTable(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_I64SortCache_Get_Class_Name(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I64SortCache_Is_A(const lucy_Int64SortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_I64SortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_I64SortCache_To_String(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_I64SortCache_To_I64(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_I64SortCache_To_F64(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I64SortCache_To_Bool(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_I64SortCache_Serialize(const lucy_Int64SortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_I64SortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Deserialize(const lucy_Int64SortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_I64SortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Dump(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_I64SortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Load(const lucy_Int64SortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_I64SortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_I64SortCache_Mimic(const lucy_Int64SortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_I64SortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_I64SortCache_Value(const lucy_Int64SortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Value_OFFSET;
    const lucy_I64SortCache_value_t method = *((lucy_I64SortCache_value_t*)method_address);
    return method((lucy_Int64SortCache*)self, ord, blank);
}

extern size_t Lucy_I64SortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_Integer64*
Lucy_I64SortCache_Make_Blank(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Make_Blank_OFFSET;
    const lucy_I64SortCache_make_blank_t method = *((lucy_I64SortCache_make_blank_t*)method_address);
    return method((lucy_Int64SortCache*)self);
}

extern size_t Lucy_I64SortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_I64SortCache_Get_Ords(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I64SortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Get_Cardinality(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I64SortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Get_Ord_Width(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I64SortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Get_Null_Ord(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_I64SortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Ordinal(const lucy_Int64SortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_I64SortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_I64SortCache_Find(const lucy_Int64SortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_I64SortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_I64SortCache_Set_Native_Ords(const lucy_Int64SortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_I64SortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_I64SortCache_Get_Native_Ords(const lucy_Int64SortCache *self) {
    char *const method_address = *(char**)self + Lucy_I64SortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INT64SORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_INT64SORTCACHE_VT;
extern struct LUCY_INT64SORTCACHE_VT LUCY_INT64SORTCACHE_vt;
#define LUCY_INT64SORTCACHE ((cfish_VTable*)&LUCY_INT64SORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Int64SortCache lucy_Int64SortCache
  #define INT64SORTCACHE LUCY_INT64SORTCACHE
  #define I64SortCache_new lucy_I64SortCache_new
  #define I64SortCache_init lucy_I64SortCache_init
  #define I64SortCache_value_t lucy_I64SortCache_value_t
  #define I64SortCache_value lucy_I64SortCache_value
  #define I64SortCache_make_blank_t lucy_I64SortCache_make_blank_t
  #define I64SortCache_make_blank lucy_I64SortCache_make_blank
  #define I64SortCache_Make Lucy_I64SortCache_Make
  #define I64SortCache_Get_RefCount Lucy_I64SortCache_Get_RefCount
  #define I64SortCache_Inc_RefCount Lucy_I64SortCache_Inc_RefCount
  #define I64SortCache_Dec_RefCount Lucy_I64SortCache_Dec_RefCount
  #define I64SortCache_To_Host Lucy_I64SortCache_To_Host
  #define I64SortCache_Clone Lucy_I64SortCache_Clone
  #define I64SortCache_Destroy Lucy_I64SortCache_Destroy
  #define I64SortCache_Equals Lucy_I64SortCache_Equals
  #define I64SortCache_Compare_To Lucy_I64SortCache_Compare_To
  #define I64SortCache_Hash_Sum Lucy_I64SortCache_Hash_Sum
  #define I64SortCache_Get_VTable Lucy_I64SortCache_Get_VTable
  #define I64SortCache_Get_Class_Name Lucy_I64SortCache_Get_Class_Name
  #define I64SortCache_Is_A Lucy_I64SortCache_Is_A
  #define I64SortCache_To_String Lucy_I64SortCache_To_String
  #define I64SortCache_To_I64 Lucy_I64SortCache_To_I64
  #define I64SortCache_To_F64 Lucy_I64SortCache_To_F64
  #define I64SortCache_To_Bool Lucy_I64SortCache_To_Bool
  #define I64SortCache_Serialize Lucy_I64SortCache_Serialize
  #define I64SortCache_Deserialize Lucy_I64SortCache_Deserialize
  #define I64SortCache_Dump Lucy_I64SortCache_Dump
  #define I64SortCache_Load Lucy_I64SortCache_Load
  #define I64SortCache_Mimic Lucy_I64SortCache_Mimic
  #define I64SortCache_Value Lucy_I64SortCache_Value
  #define I64SortCache_Make_Blank Lucy_I64SortCache_Make_Blank
  #define I64SortCache_Get_Ords Lucy_I64SortCache_Get_Ords
  #define I64SortCache_Get_Cardinality Lucy_I64SortCache_Get_Cardinality
  #define I64SortCache_Get_Ord_Width Lucy_I64SortCache_Get_Ord_Width
  #define I64SortCache_Get_Null_Ord Lucy_I64SortCache_Get_Null_Ord
  #define I64SortCache_Ordinal Lucy_I64SortCache_Ordinal
  #define I64SortCache_Find Lucy_I64SortCache_Find
  #define I64SortCache_Set_Native_Ords Lucy_I64SortCache_Set_Native_Ords
  #define I64SortCache_Get_Native_Ords Lucy_I64SortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTCACHE_NUMERICSORTCACHE */




