/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTCACHE_TEXTSORTCACHE
#define H_LUCY_INDEX_SORTCACHE_TEXTSORTCACHE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortCache.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TEXTSORTCACHE
struct lucy_TextSortCache {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_FieldType* type;
    void* ords;
    int32_t doc_max;
    int32_t cardinality;
    int32_t ord_width;
    int32_t null_ord;
    chy_bool_t native_ords;
    lucy_InStream* ord_in;
    lucy_InStream* ix_in;
    lucy_InStream* dat_in;
};

#endif /* C_LUCY_TEXTSORTCACHE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_TextSortCache*
lucy_TextSortCache_new(const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* ix_in, lucy_InStream* dat_in);

lucy_TextSortCache*
lucy_TextSortCache_init(lucy_TextSortCache* self, const lucy_CharBuf* field, lucy_FieldType* type, int32_t cardinality, int32_t doc_max, int32_t null_ord, int32_t ord_width, lucy_InStream* ord_in, lucy_InStream* ix_in, lucy_InStream* dat_in);

void
lucy_TextSortCache_destroy(lucy_TextSortCache* self);

lucy_Obj*
lucy_TextSortCache_value(lucy_TextSortCache* self, int32_t ord, lucy_Obj* blank);

lucy_CharBuf*
lucy_TextSortCache_make_blank(lucy_TextSortCache* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_TextSortCache_destroy_CALLBACK;
extern cfish_Callback lucy_TextSortCache_value_CALLBACK;
extern cfish_Callback lucy_TextSortCache_make_blank_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_TextSortCache_destroy_t)(lucy_TextSortCache* self);

typedef lucy_Obj*
(*lucy_TextSortCache_value_t)(lucy_TextSortCache* self, int32_t ord, lucy_Obj* blank);

typedef lucy_CharBuf*
(*lucy_TextSortCache_make_blank_t)(lucy_TextSortCache* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_TextSortCache_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Make(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TextSortCache_Get_RefCount(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Inc_RefCount(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TextSortCache_Dec_RefCount(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_TextSortCache_To_Host(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Clone(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Destroy_OFFSET;
static CHY_INLINE void
Lucy_TextSortCache_Destroy(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Destroy_OFFSET;
    const lucy_TextSortCache_destroy_t method = *((lucy_TextSortCache_destroy_t*)method_address);
    method((lucy_TextSortCache*)self);
}

extern size_t Lucy_TextSortCache_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TextSortCache_Equals(const lucy_TextSortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TextSortCache_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Compare_To(const lucy_TextSortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TextSortCache_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Hash_Sum(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_TextSortCache_Get_VTable(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TextSortCache_Get_Class_Name(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TextSortCache_Is_A(const lucy_TextSortCache *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_TextSortCache_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TextSortCache_To_String(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_TextSortCache_To_I64(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_To_F64_OFFSET;
static CHY_INLINE double
Lucy_TextSortCache_To_F64(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TextSortCache_To_Bool(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Serialize_OFFSET;
static CHY_INLINE void
Lucy_TextSortCache_Serialize(const lucy_TextSortCache *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_TextSortCache_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Deserialize(const lucy_TextSortCache *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_TextSortCache_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Dump(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TextSortCache_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Load(const lucy_TextSortCache *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_TextSortCache_Mimic_OFFSET;
static CHY_INLINE void
Lucy_TextSortCache_Mimic(const lucy_TextSortCache *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_TextSortCache_Value_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TextSortCache_Value(const lucy_TextSortCache *self, int32_t ord, lucy_Obj* blank) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Value_OFFSET;
    const lucy_TextSortCache_value_t method = *((lucy_TextSortCache_value_t*)method_address);
    return method((lucy_TextSortCache*)self, ord, blank);
}

extern size_t Lucy_TextSortCache_Make_Blank_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TextSortCache_Make_Blank(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Make_Blank_OFFSET;
    const lucy_TextSortCache_make_blank_t method = *((lucy_TextSortCache_make_blank_t*)method_address);
    return method((lucy_TextSortCache*)self);
}

extern size_t Lucy_TextSortCache_Get_Ords_OFFSET;
static CHY_INLINE void*
Lucy_TextSortCache_Get_Ords(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_Ords_OFFSET;
    const lucy_SortCache_get_ords_t method = *((lucy_SortCache_get_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_TextSortCache_Get_Cardinality_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Get_Cardinality(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_Cardinality_OFFSET;
    const lucy_SortCache_get_cardinality_t method = *((lucy_SortCache_get_cardinality_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_TextSortCache_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Get_Ord_Width(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_Ord_Width_OFFSET;
    const lucy_SortCache_get_ord_width_t method = *((lucy_SortCache_get_ord_width_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_TextSortCache_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Get_Null_Ord(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_Null_Ord_OFFSET;
    const lucy_SortCache_get_null_ord_t method = *((lucy_SortCache_get_null_ord_t*)method_address);
    return method((lucy_SortCache*)self);
}

extern size_t Lucy_TextSortCache_Ordinal_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Ordinal(const lucy_TextSortCache *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Ordinal_OFFSET;
    const lucy_SortCache_ordinal_t method = *((lucy_SortCache_ordinal_t*)method_address);
    return method((lucy_SortCache*)self, doc_id);
}

extern size_t Lucy_TextSortCache_Find_OFFSET;
static CHY_INLINE int32_t
Lucy_TextSortCache_Find(const lucy_TextSortCache *self, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Find_OFFSET;
    const lucy_SortCache_find_t method = *((lucy_SortCache_find_t*)method_address);
    return method((lucy_SortCache*)self, term);
}

extern size_t Lucy_TextSortCache_Set_Native_Ords_OFFSET;
static CHY_INLINE void
Lucy_TextSortCache_Set_Native_Ords(const lucy_TextSortCache *self, chy_bool_t native_ords) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Set_Native_Ords_OFFSET;
    const lucy_SortCache_set_native_ords_t method = *((lucy_SortCache_set_native_ords_t*)method_address);
    method((lucy_SortCache*)self, native_ords);
}

extern size_t Lucy_TextSortCache_Get_Native_Ords_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TextSortCache_Get_Native_Ords(const lucy_TextSortCache *self) {
    char *const method_address = *(char**)self + Lucy_TextSortCache_Get_Native_Ords_OFFSET;
    const lucy_SortCache_get_native_ords_t method = *((lucy_SortCache_get_native_ords_t*)method_address);
    return method((lucy_SortCache*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_TEXTSORTCACHE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_TEXTSORTCACHE_VT;
extern struct LUCY_TEXTSORTCACHE_VT LUCY_TEXTSORTCACHE_vt;
#define LUCY_TEXTSORTCACHE ((cfish_VTable*)&LUCY_TEXTSORTCACHE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TextSortCache lucy_TextSortCache
  #define TEXTSORTCACHE LUCY_TEXTSORTCACHE
  #define TextSortCache_new lucy_TextSortCache_new
  #define TextSortCache_init lucy_TextSortCache_init
  #define TextSortCache_destroy_t lucy_TextSortCache_destroy_t
  #define TextSortCache_destroy lucy_TextSortCache_destroy
  #define TextSortCache_value_t lucy_TextSortCache_value_t
  #define TextSortCache_value lucy_TextSortCache_value
  #define TextSortCache_make_blank_t lucy_TextSortCache_make_blank_t
  #define TextSortCache_make_blank lucy_TextSortCache_make_blank
  #define TextSortCache_Make Lucy_TextSortCache_Make
  #define TextSortCache_Get_RefCount Lucy_TextSortCache_Get_RefCount
  #define TextSortCache_Inc_RefCount Lucy_TextSortCache_Inc_RefCount
  #define TextSortCache_Dec_RefCount Lucy_TextSortCache_Dec_RefCount
  #define TextSortCache_To_Host Lucy_TextSortCache_To_Host
  #define TextSortCache_Clone Lucy_TextSortCache_Clone
  #define TextSortCache_Destroy Lucy_TextSortCache_Destroy
  #define TextSortCache_Equals Lucy_TextSortCache_Equals
  #define TextSortCache_Compare_To Lucy_TextSortCache_Compare_To
  #define TextSortCache_Hash_Sum Lucy_TextSortCache_Hash_Sum
  #define TextSortCache_Get_VTable Lucy_TextSortCache_Get_VTable
  #define TextSortCache_Get_Class_Name Lucy_TextSortCache_Get_Class_Name
  #define TextSortCache_Is_A Lucy_TextSortCache_Is_A
  #define TextSortCache_To_String Lucy_TextSortCache_To_String
  #define TextSortCache_To_I64 Lucy_TextSortCache_To_I64
  #define TextSortCache_To_F64 Lucy_TextSortCache_To_F64
  #define TextSortCache_To_Bool Lucy_TextSortCache_To_Bool
  #define TextSortCache_Serialize Lucy_TextSortCache_Serialize
  #define TextSortCache_Deserialize Lucy_TextSortCache_Deserialize
  #define TextSortCache_Dump Lucy_TextSortCache_Dump
  #define TextSortCache_Load Lucy_TextSortCache_Load
  #define TextSortCache_Mimic Lucy_TextSortCache_Mimic
  #define TextSortCache_Value Lucy_TextSortCache_Value
  #define TextSortCache_Make_Blank Lucy_TextSortCache_Make_Blank
  #define TextSortCache_Get_Ords Lucy_TextSortCache_Get_Ords
  #define TextSortCache_Get_Cardinality Lucy_TextSortCache_Get_Cardinality
  #define TextSortCache_Get_Ord_Width Lucy_TextSortCache_Get_Ord_Width
  #define TextSortCache_Get_Null_Ord Lucy_TextSortCache_Get_Null_Ord
  #define TextSortCache_Ordinal Lucy_TextSortCache_Ordinal
  #define TextSortCache_Find Lucy_TextSortCache_Find
  #define TextSortCache_Set_Native_Ords Lucy_TextSortCache_Set_Native_Ords
  #define TextSortCache_Get_Native_Ords Lucy_TextSortCache_Get_Native_Ords
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTCACHE_TEXTSORTCACHE */




