/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTFIELDWRITER
#define H_LUCY_INDEX_SORTFIELDWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/SortExternal.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTFIELDWRITER
struct lucy_SortFieldWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint8_t* cache;
    uint32_t cache_cap;
    uint32_t cache_max;
    uint32_t cache_tick;
    uint8_t* scratch;
    uint32_t scratch_cap;
    lucy_VArray* runs;
    uint32_t num_slices;
    uint8_t** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    size_t width;
    chy_bool_t flipped;
    lucy_CharBuf* field;
    lucy_Hash* uniq_vals;
    lucy_Schema* schema;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_FieldType* type;
    lucy_I32Array* doc_map;
    lucy_MemoryPool* mem_pool;
    int32_t field_num;
    int32_t null_ord;
    int8_t prim_id;
    int32_t count;
    lucy_OutStream* temp_ord_out;
    lucy_OutStream* temp_ix_out;
    lucy_OutStream* temp_dat_out;
    lucy_InStream* ord_in;
    lucy_InStream* ix_in;
    lucy_InStream* dat_in;
    lucy_SortCache* sort_cache;
    int64_t ord_start;
    int64_t ord_end;
    int64_t ix_start;
    int64_t ix_end;
    int64_t dat_start;
    int64_t dat_end;
    int32_t run_cardinality;
    int32_t run_max;
    chy_bool_t var_width;
    int32_t* sorted_ids;
    int32_t run_ord;
    int32_t run_tick;
    int32_t ord_width;
};

#endif /* C_LUCY_SORTFIELDWRITER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SortFieldWriter*
lucy_SortFieldWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, const lucy_CharBuf* field, lucy_MemoryPool* memory_pool, size_t mem_thresh, lucy_OutStream* temp_ord_out, lucy_OutStream* temp_ix_out, lucy_OutStream* temp_dat_out);

lucy_SortFieldWriter*
lucy_SortFieldWriter_init(lucy_SortFieldWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader, const lucy_CharBuf* field, lucy_MemoryPool* memory_pool, size_t mem_thresh, lucy_OutStream* temp_ord_out, lucy_OutStream* temp_ix_out, lucy_OutStream* temp_dat_out);

void
lucy_SortFieldWriter_destroy(lucy_SortFieldWriter* self);

int
lucy_SortFieldWriter_compare(lucy_SortFieldWriter* self, void* va, void* vb);

void
lucy_SortFieldWriter_flush(lucy_SortFieldWriter* self);

void
lucy_SortFieldWriter_flip(lucy_SortFieldWriter* self);

uint32_t
lucy_SortFieldWriter_refill(lucy_SortFieldWriter* self);

void
lucy_SortFieldWriter_clear_cache(lucy_SortFieldWriter* self);

void
lucy_SortFieldWriter_add(lucy_SortFieldWriter* self, int32_t doc_id, lucy_Obj* value);

void
lucy_SortFieldWriter_add_segment(lucy_SortFieldWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map, lucy_SortCache* sort_cache);

int32_t
lucy_SortFieldWriter_finish(lucy_SortFieldWriter* self);

int32_t
lucy_SortFieldWriter_get_null_ord(lucy_SortFieldWriter* self);

int32_t
lucy_SortFieldWriter_get_ord_width(lucy_SortFieldWriter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SortFieldWriter_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SortFieldWriter_destroy_t)(lucy_SortFieldWriter* self);

typedef int
(*lucy_SortFieldWriter_compare_t)(lucy_SortFieldWriter* self, void* va, void* vb);

typedef void
(*lucy_SortFieldWriter_flush_t)(lucy_SortFieldWriter* self);

typedef void
(*lucy_SortFieldWriter_flip_t)(lucy_SortFieldWriter* self);

typedef uint32_t
(*lucy_SortFieldWriter_refill_t)(lucy_SortFieldWriter* self);

typedef void
(*lucy_SortFieldWriter_clear_cache_t)(lucy_SortFieldWriter* self);

typedef void
(*lucy_SortFieldWriter_add_t)(lucy_SortFieldWriter* self, int32_t doc_id, lucy_Obj* value);

typedef void
(*lucy_SortFieldWriter_add_segment_t)(lucy_SortFieldWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map, lucy_SortCache* sort_cache);

typedef int32_t
(*lucy_SortFieldWriter_finish_t)(lucy_SortFieldWriter* self);

typedef int32_t
(*lucy_SortFieldWriter_get_null_ord_t)(lucy_SortFieldWriter* self);

typedef int32_t
(*lucy_SortFieldWriter_get_ord_width_t)(lucy_SortFieldWriter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SortFieldWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortFieldWriter_Make(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortFieldWriter_Get_RefCount(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortFieldWriter_Inc_RefCount(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortFieldWriter_Dec_RefCount(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SortFieldWriter_To_Host(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortFieldWriter_Clone(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Destroy(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Destroy_OFFSET;
    const lucy_SortFieldWriter_destroy_t method = *((lucy_SortFieldWriter_destroy_t*)method_address);
    method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortFieldWriter_Equals(const lucy_SortFieldWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortFieldWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SortFieldWriter_Compare_To(const lucy_SortFieldWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortFieldWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SortFieldWriter_Hash_Sum(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SortFieldWriter_Get_VTable(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortFieldWriter_Get_Class_Name(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortFieldWriter_Is_A(const lucy_SortFieldWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SortFieldWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortFieldWriter_To_String(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SortFieldWriter_To_I64(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SortFieldWriter_To_F64(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortFieldWriter_To_Bool(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Serialize(const lucy_SortFieldWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SortFieldWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortFieldWriter_Deserialize(const lucy_SortFieldWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SortFieldWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortFieldWriter_Dump(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortFieldWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortFieldWriter_Load(const lucy_SortFieldWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SortFieldWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Mimic(const lucy_SortFieldWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortFieldWriter_Compare_OFFSET;
static CHY_INLINE int
Lucy_SortFieldWriter_Compare(const lucy_SortFieldWriter *self, void* va, void* vb) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Compare_OFFSET;
    const lucy_SortFieldWriter_compare_t method = *((lucy_SortFieldWriter_compare_t*)method_address);
    return method((lucy_SortFieldWriter*)self, va, vb);
}

extern size_t Lucy_SortFieldWriter_Flush_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Flush(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Flush_OFFSET;
    const lucy_SortFieldWriter_flush_t method = *((lucy_SortFieldWriter_flush_t*)method_address);
    method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Feed_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Feed(const lucy_SortFieldWriter *self, void* data) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Feed_OFFSET;
    const lucy_SortEx_feed_t method = *((lucy_SortEx_feed_t*)method_address);
    method((lucy_SortExternal*)self, data);
}

extern size_t Lucy_SortFieldWriter_Flip_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Flip(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Flip_OFFSET;
    const lucy_SortFieldWriter_flip_t method = *((lucy_SortFieldWriter_flip_t*)method_address);
    method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Fetch_OFFSET;
static CHY_INLINE void*
Lucy_SortFieldWriter_Fetch(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Fetch_OFFSET;
    const lucy_SortEx_fetch_t method = *((lucy_SortEx_fetch_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortFieldWriter_Peek_OFFSET;
static CHY_INLINE void*
Lucy_SortFieldWriter_Peek(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Peek_OFFSET;
    const lucy_SortEx_peek_t method = *((lucy_SortEx_peek_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortFieldWriter_Add_Run_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Add_Run(const lucy_SortFieldWriter *self, lucy_SortExternal* run) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Add_Run_OFFSET;
    const lucy_SortEx_add_run_t method = *((lucy_SortEx_add_run_t*)method_address);
    method((lucy_SortExternal*)self, run);
}

extern size_t Lucy_SortFieldWriter_Refill_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortFieldWriter_Refill(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Refill_OFFSET;
    const lucy_SortFieldWriter_refill_t method = *((lucy_SortFieldWriter_refill_t*)method_address);
    return method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Sort_Cache_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Sort_Cache(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Sort_Cache_OFFSET;
    const lucy_SortEx_sort_cache_t method = *((lucy_SortEx_sort_cache_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortFieldWriter_Clear_Cache_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Clear_Cache(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Clear_Cache_OFFSET;
    const lucy_SortFieldWriter_clear_cache_t method = *((lucy_SortFieldWriter_clear_cache_t*)method_address);
    method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Cache_Count_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortFieldWriter_Cache_Count(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Cache_Count_OFFSET;
    const lucy_SortEx_cache_count_t method = *((lucy_SortEx_cache_count_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortFieldWriter_Grow_Cache_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Grow_Cache(const lucy_SortFieldWriter *self, uint32_t new_cache_cap) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Grow_Cache_OFFSET;
    const lucy_SortEx_grow_cache_t method = *((lucy_SortEx_grow_cache_t*)method_address);
    method((lucy_SortExternal*)self, new_cache_cap);
}

extern size_t Lucy_SortFieldWriter_Set_Mem_Thresh_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Set_Mem_Thresh(const lucy_SortFieldWriter *self, uint32_t mem_thresh) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Set_Mem_Thresh_OFFSET;
    const lucy_SortEx_set_mem_thresh_t method = *((lucy_SortEx_set_mem_thresh_t*)method_address);
    method((lucy_SortExternal*)self, mem_thresh);
}

extern size_t Lucy_SortFieldWriter_Add_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Add(const lucy_SortFieldWriter *self, int32_t doc_id, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Add_OFFSET;
    const lucy_SortFieldWriter_add_t method = *((lucy_SortFieldWriter_add_t*)method_address);
    method((lucy_SortFieldWriter*)self, doc_id, value);
}

extern size_t Lucy_SortFieldWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_SortFieldWriter_Add_Segment(const lucy_SortFieldWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map, lucy_SortCache* sort_cache) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Add_Segment_OFFSET;
    const lucy_SortFieldWriter_add_segment_t method = *((lucy_SortFieldWriter_add_segment_t*)method_address);
    method((lucy_SortFieldWriter*)self, reader, doc_map, sort_cache);
}

extern size_t Lucy_SortFieldWriter_Finish_OFFSET;
static CHY_INLINE int32_t
Lucy_SortFieldWriter_Finish(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Finish_OFFSET;
    const lucy_SortFieldWriter_finish_t method = *((lucy_SortFieldWriter_finish_t*)method_address);
    return method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Get_Null_Ord_OFFSET;
static CHY_INLINE int32_t
Lucy_SortFieldWriter_Get_Null_Ord(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Get_Null_Ord_OFFSET;
    const lucy_SortFieldWriter_get_null_ord_t method = *((lucy_SortFieldWriter_get_null_ord_t*)method_address);
    return method((lucy_SortFieldWriter*)self);
}

extern size_t Lucy_SortFieldWriter_Get_Ord_Width_OFFSET;
static CHY_INLINE int32_t
Lucy_SortFieldWriter_Get_Ord_Width(const lucy_SortFieldWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortFieldWriter_Get_Ord_Width_OFFSET;
    const lucy_SortFieldWriter_get_ord_width_t method = *((lucy_SortFieldWriter_get_ord_width_t*)method_address);
    return method((lucy_SortFieldWriter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SORTFIELDWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[40];
} LUCY_SORTFIELDWRITER_VT;
extern struct LUCY_SORTFIELDWRITER_VT LUCY_SORTFIELDWRITER_vt;
#define LUCY_SORTFIELDWRITER ((cfish_VTable*)&LUCY_SORTFIELDWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortFieldWriter lucy_SortFieldWriter
  #define SORTFIELDWRITER LUCY_SORTFIELDWRITER
  #define SortFieldWriter_new lucy_SortFieldWriter_new
  #define SortFieldWriter_init lucy_SortFieldWriter_init
  #define SortFieldWriter_destroy_t lucy_SortFieldWriter_destroy_t
  #define SortFieldWriter_destroy lucy_SortFieldWriter_destroy
  #define SortFieldWriter_compare_t lucy_SortFieldWriter_compare_t
  #define SortFieldWriter_compare lucy_SortFieldWriter_compare
  #define SortFieldWriter_flush_t lucy_SortFieldWriter_flush_t
  #define SortFieldWriter_flush lucy_SortFieldWriter_flush
  #define SortFieldWriter_flip_t lucy_SortFieldWriter_flip_t
  #define SortFieldWriter_flip lucy_SortFieldWriter_flip
  #define SortFieldWriter_refill_t lucy_SortFieldWriter_refill_t
  #define SortFieldWriter_refill lucy_SortFieldWriter_refill
  #define SortFieldWriter_clear_cache_t lucy_SortFieldWriter_clear_cache_t
  #define SortFieldWriter_clear_cache lucy_SortFieldWriter_clear_cache
  #define SortFieldWriter_add_t lucy_SortFieldWriter_add_t
  #define SortFieldWriter_add lucy_SortFieldWriter_add
  #define SortFieldWriter_add_segment_t lucy_SortFieldWriter_add_segment_t
  #define SortFieldWriter_add_segment lucy_SortFieldWriter_add_segment
  #define SortFieldWriter_finish_t lucy_SortFieldWriter_finish_t
  #define SortFieldWriter_finish lucy_SortFieldWriter_finish
  #define SortFieldWriter_get_null_ord_t lucy_SortFieldWriter_get_null_ord_t
  #define SortFieldWriter_get_null_ord lucy_SortFieldWriter_get_null_ord
  #define SortFieldWriter_get_ord_width_t lucy_SortFieldWriter_get_ord_width_t
  #define SortFieldWriter_get_ord_width lucy_SortFieldWriter_get_ord_width
  #define SortFieldWriter_Make Lucy_SortFieldWriter_Make
  #define SortFieldWriter_Get_RefCount Lucy_SortFieldWriter_Get_RefCount
  #define SortFieldWriter_Inc_RefCount Lucy_SortFieldWriter_Inc_RefCount
  #define SortFieldWriter_Dec_RefCount Lucy_SortFieldWriter_Dec_RefCount
  #define SortFieldWriter_To_Host Lucy_SortFieldWriter_To_Host
  #define SortFieldWriter_Clone Lucy_SortFieldWriter_Clone
  #define SortFieldWriter_Destroy Lucy_SortFieldWriter_Destroy
  #define SortFieldWriter_Equals Lucy_SortFieldWriter_Equals
  #define SortFieldWriter_Compare_To Lucy_SortFieldWriter_Compare_To
  #define SortFieldWriter_Hash_Sum Lucy_SortFieldWriter_Hash_Sum
  #define SortFieldWriter_Get_VTable Lucy_SortFieldWriter_Get_VTable
  #define SortFieldWriter_Get_Class_Name Lucy_SortFieldWriter_Get_Class_Name
  #define SortFieldWriter_Is_A Lucy_SortFieldWriter_Is_A
  #define SortFieldWriter_To_String Lucy_SortFieldWriter_To_String
  #define SortFieldWriter_To_I64 Lucy_SortFieldWriter_To_I64
  #define SortFieldWriter_To_F64 Lucy_SortFieldWriter_To_F64
  #define SortFieldWriter_To_Bool Lucy_SortFieldWriter_To_Bool
  #define SortFieldWriter_Serialize Lucy_SortFieldWriter_Serialize
  #define SortFieldWriter_Deserialize Lucy_SortFieldWriter_Deserialize
  #define SortFieldWriter_Dump Lucy_SortFieldWriter_Dump
  #define SortFieldWriter_Load Lucy_SortFieldWriter_Load
  #define SortFieldWriter_Mimic Lucy_SortFieldWriter_Mimic
  #define SortFieldWriter_Compare Lucy_SortFieldWriter_Compare
  #define SortFieldWriter_Flush Lucy_SortFieldWriter_Flush
  #define SortFieldWriter_Feed Lucy_SortFieldWriter_Feed
  #define SortFieldWriter_Flip Lucy_SortFieldWriter_Flip
  #define SortFieldWriter_Fetch Lucy_SortFieldWriter_Fetch
  #define SortFieldWriter_Peek Lucy_SortFieldWriter_Peek
  #define SortFieldWriter_Add_Run Lucy_SortFieldWriter_Add_Run
  #define SortFieldWriter_Refill Lucy_SortFieldWriter_Refill
  #define SortFieldWriter_Sort_Cache Lucy_SortFieldWriter_Sort_Cache
  #define SortFieldWriter_Clear_Cache Lucy_SortFieldWriter_Clear_Cache
  #define SortFieldWriter_Cache_Count Lucy_SortFieldWriter_Cache_Count
  #define SortFieldWriter_Grow_Cache Lucy_SortFieldWriter_Grow_Cache
  #define SortFieldWriter_Set_Mem_Thresh Lucy_SortFieldWriter_Set_Mem_Thresh
  #define SortFieldWriter_Add Lucy_SortFieldWriter_Add
  #define SortFieldWriter_Add_Segment Lucy_SortFieldWriter_Add_Segment
  #define SortFieldWriter_Finish Lucy_SortFieldWriter_Finish
  #define SortFieldWriter_Get_Null_Ord Lucy_SortFieldWriter_Get_Null_Ord
  #define SortFieldWriter_Get_Ord_Width Lucy_SortFieldWriter_Get_Ord_Width
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTFIELDWRITER */




