/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTREADER
#define H_LUCY_INDEX_SORTREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTREADER
struct lucy_SortReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_SORTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SortReader*
lucy_SortReader_init(lucy_SortReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DataReader*
lucy_SortReader_aggregator(lucy_SortReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

lucy_SortCache*
lucy_SortReader_fetch_sort_cache(lucy_SortReader* self, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SortReader_aggregator_CALLBACK;
extern cfish_Callback lucy_SortReader_fetch_sort_cache_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_DataReader*
(*lucy_SortReader_aggregator_t)(lucy_SortReader* self, lucy_VArray* readers, lucy_I32Array* offsets);

typedef lucy_SortCache*
(*lucy_SortReader_fetch_sort_cache_t)(lucy_SortReader* self, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SortReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortReader_Make(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortReader_Get_RefCount(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortReader_Inc_RefCount(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortReader_Dec_RefCount(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SortReader_To_Host(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortReader_Clone(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SortReader_Destroy(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Destroy_OFFSET;
    const lucy_DataReader_destroy_t method = *((lucy_DataReader_destroy_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortReader_Equals(const lucy_SortReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SortReader_Compare_To(const lucy_SortReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SortReader_Hash_Sum(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SortReader_Get_VTable(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortReader_Get_Class_Name(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortReader_Is_A(const lucy_SortReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SortReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SortReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortReader_To_String(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SortReader_To_I64(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SortReader_To_F64(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortReader_To_Bool(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SortReader_Serialize(const lucy_SortReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SortReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SortReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortReader_Deserialize(const lucy_SortReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SortReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SortReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortReader_Dump(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortReader_Load(const lucy_SortReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SortReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SortReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SortReader_Mimic(const lucy_SortReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_SortReader_Aggregator(const lucy_SortReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_SortReader_Aggregator_OFFSET;
    const lucy_SortReader_aggregator_t method = *((lucy_SortReader_aggregator_t*)method_address);
    return method((lucy_SortReader*)self, readers, offsets);
}

extern size_t Lucy_SortReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_SortReader_Get_Schema(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_SortReader_Get_Folder(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_SortReader_Get_Snapshot(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SortReader_Get_Segments(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_SortReader_Get_Segment(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_SortReader_Get_Seg_Tick(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Close_OFFSET;
static CHY_INLINE void
Lucy_SortReader_Close(const lucy_SortReader *self) {
    char *const method_address = *(char**)self + Lucy_SortReader_Close_OFFSET;
    const lucy_DataReader_close_t method = *((lucy_DataReader_close_t*)method_address);
    method((lucy_DataReader*)self);
}

extern size_t Lucy_SortReader_Fetch_Sort_Cache_OFFSET;
static CHY_INLINE lucy_SortCache*
Lucy_SortReader_Fetch_Sort_Cache(const lucy_SortReader *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_SortReader_Fetch_Sort_Cache_OFFSET;
    const lucy_SortReader_fetch_sort_cache_t method = *((lucy_SortReader_fetch_sort_cache_t*)method_address);
    return method((lucy_SortReader*)self, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SORTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_SORTREADER_VT;
extern struct LUCY_SORTREADER_VT LUCY_SORTREADER_vt;
#define LUCY_SORTREADER ((cfish_VTable*)&LUCY_SORTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortReader lucy_SortReader
  #define SORTREADER LUCY_SORTREADER
  #define SortReader_init lucy_SortReader_init
  #define SortReader_aggregator_t lucy_SortReader_aggregator_t
  #define SortReader_aggregator lucy_SortReader_aggregator
  #define SortReader_fetch_sort_cache_t lucy_SortReader_fetch_sort_cache_t
  #define SortReader_fetch_sort_cache lucy_SortReader_fetch_sort_cache
  #define SortReader_Make Lucy_SortReader_Make
  #define SortReader_Get_RefCount Lucy_SortReader_Get_RefCount
  #define SortReader_Inc_RefCount Lucy_SortReader_Inc_RefCount
  #define SortReader_Dec_RefCount Lucy_SortReader_Dec_RefCount
  #define SortReader_To_Host Lucy_SortReader_To_Host
  #define SortReader_Clone Lucy_SortReader_Clone
  #define SortReader_Destroy Lucy_SortReader_Destroy
  #define SortReader_Equals Lucy_SortReader_Equals
  #define SortReader_Compare_To Lucy_SortReader_Compare_To
  #define SortReader_Hash_Sum Lucy_SortReader_Hash_Sum
  #define SortReader_Get_VTable Lucy_SortReader_Get_VTable
  #define SortReader_Get_Class_Name Lucy_SortReader_Get_Class_Name
  #define SortReader_Is_A Lucy_SortReader_Is_A
  #define SortReader_To_String Lucy_SortReader_To_String
  #define SortReader_To_I64 Lucy_SortReader_To_I64
  #define SortReader_To_F64 Lucy_SortReader_To_F64
  #define SortReader_To_Bool Lucy_SortReader_To_Bool
  #define SortReader_Serialize Lucy_SortReader_Serialize
  #define SortReader_Deserialize Lucy_SortReader_Deserialize
  #define SortReader_Dump Lucy_SortReader_Dump
  #define SortReader_Load Lucy_SortReader_Load
  #define SortReader_Mimic Lucy_SortReader_Mimic
  #define SortReader_Aggregator Lucy_SortReader_Aggregator
  #define SortReader_Get_Schema Lucy_SortReader_Get_Schema
  #define SortReader_Get_Folder Lucy_SortReader_Get_Folder
  #define SortReader_Get_Snapshot Lucy_SortReader_Get_Snapshot
  #define SortReader_Get_Segments Lucy_SortReader_Get_Segments
  #define SortReader_Get_Segment Lucy_SortReader_Get_Segment
  #define SortReader_Get_Seg_Tick Lucy_SortReader_Get_Seg_Tick
  #define SortReader_Close Lucy_SortReader_Close
  #define SortReader_Fetch_Sort_Cache Lucy_SortReader_Fetch_Sort_Cache
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/SortReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTSORTREADER
struct lucy_DefaultSortReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    lucy_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    lucy_Hash* caches;
    lucy_Hash* counts;
    lucy_Hash* null_ords;
    lucy_Hash* ord_widths;
    int32_t format;
};

#endif /* C_LUCY_DEFAULTSORTREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DefaultSortReader*
lucy_DefSortReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

lucy_DefaultSortReader*
lucy_DefSortReader_init(lucy_DefaultSortReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, lucy_VArray* segments, int32_t seg_tick);

void
lucy_DefSortReader_destroy(lucy_DefaultSortReader* self);

void
lucy_DefSortReader_close(lucy_DefaultSortReader* self);

lucy_SortCache*
lucy_DefSortReader_fetch_sort_cache(lucy_DefaultSortReader* self, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DefSortReader_destroy_CALLBACK;
extern cfish_Callback lucy_DefSortReader_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DefSortReader_destroy_t)(lucy_DefaultSortReader* self);

typedef void
(*lucy_DefSortReader_close_t)(lucy_DefaultSortReader* self);

typedef lucy_SortCache*
(*lucy_DefSortReader_fetch_sort_cache_t)(lucy_DefaultSortReader* self, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DefSortReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefSortReader_Make(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefSortReader_Get_RefCount(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefSortReader_Inc_RefCount(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DefSortReader_Dec_RefCount(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DefSortReader_To_Host(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefSortReader_Clone(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DefSortReader_Destroy(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Destroy_OFFSET;
    const lucy_DefSortReader_destroy_t method = *((lucy_DefSortReader_destroy_t*)method_address);
    method((lucy_DefaultSortReader*)self);
}

extern size_t Lucy_DefSortReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefSortReader_Equals(const lucy_DefaultSortReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefSortReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DefSortReader_Compare_To(const lucy_DefaultSortReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefSortReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DefSortReader_Hash_Sum(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DefSortReader_Get_VTable(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefSortReader_Get_Class_Name(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefSortReader_Is_A(const lucy_DefaultSortReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DefSortReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DefSortReader_To_String(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DefSortReader_To_I64(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DefSortReader_To_F64(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DefSortReader_To_Bool(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DefSortReader_Serialize(const lucy_DefaultSortReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DefSortReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefSortReader_Deserialize(const lucy_DefaultSortReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DefSortReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefSortReader_Dump(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DefSortReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DefSortReader_Load(const lucy_DefaultSortReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DefSortReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DefSortReader_Mimic(const lucy_DefaultSortReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DefSortReader_Aggregator_OFFSET;
static CHY_INLINE lucy_DataReader*
Lucy_DefSortReader_Aggregator(const lucy_DefaultSortReader *self, lucy_VArray* readers, lucy_I32Array* offsets) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Aggregator_OFFSET;
    const lucy_SortReader_aggregator_t method = *((lucy_SortReader_aggregator_t*)method_address);
    return method((lucy_SortReader*)self, readers, offsets);
}

extern size_t Lucy_DefSortReader_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_DefSortReader_Get_Schema(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Schema_OFFSET;
    const lucy_DataReader_get_schema_t method = *((lucy_DataReader_get_schema_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefSortReader_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_DefSortReader_Get_Folder(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Folder_OFFSET;
    const lucy_DataReader_get_folder_t method = *((lucy_DataReader_get_folder_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefSortReader_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_DefSortReader_Get_Snapshot(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Snapshot_OFFSET;
    const lucy_DataReader_get_snapshot_t method = *((lucy_DataReader_get_snapshot_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefSortReader_Get_Segments_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_DefSortReader_Get_Segments(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Segments_OFFSET;
    const lucy_DataReader_get_segments_t method = *((lucy_DataReader_get_segments_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefSortReader_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_DefSortReader_Get_Segment(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Segment_OFFSET;
    const lucy_DataReader_get_segment_t method = *((lucy_DataReader_get_segment_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefSortReader_Get_Seg_Tick_OFFSET;
static CHY_INLINE int32_t
Lucy_DefSortReader_Get_Seg_Tick(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Get_Seg_Tick_OFFSET;
    const lucy_DataReader_get_seg_tick_t method = *((lucy_DataReader_get_seg_tick_t*)method_address);
    return method((lucy_DataReader*)self);
}

extern size_t Lucy_DefSortReader_Close_OFFSET;
static CHY_INLINE void
Lucy_DefSortReader_Close(const lucy_DefaultSortReader *self) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Close_OFFSET;
    const lucy_DefSortReader_close_t method = *((lucy_DefSortReader_close_t*)method_address);
    method((lucy_DefaultSortReader*)self);
}

extern size_t Lucy_DefSortReader_Fetch_Sort_Cache_OFFSET;
static CHY_INLINE lucy_SortCache*
Lucy_DefSortReader_Fetch_Sort_Cache(const lucy_DefaultSortReader *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_DefSortReader_Fetch_Sort_Cache_OFFSET;
    const lucy_DefSortReader_fetch_sort_cache_t method = *((lucy_DefSortReader_fetch_sort_cache_t*)method_address);
    return method((lucy_DefaultSortReader*)self, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DEFAULTSORTREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_DEFAULTSORTREADER_VT;
extern struct LUCY_DEFAULTSORTREADER_VT LUCY_DEFAULTSORTREADER_vt;
#define LUCY_DEFAULTSORTREADER ((cfish_VTable*)&LUCY_DEFAULTSORTREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultSortReader lucy_DefaultSortReader
  #define DEFAULTSORTREADER LUCY_DEFAULTSORTREADER
  #define DefSortReader_new lucy_DefSortReader_new
  #define DefSortReader_init lucy_DefSortReader_init
  #define DefSortReader_destroy_t lucy_DefSortReader_destroy_t
  #define DefSortReader_destroy lucy_DefSortReader_destroy
  #define DefSortReader_close_t lucy_DefSortReader_close_t
  #define DefSortReader_close lucy_DefSortReader_close
  #define DefSortReader_fetch_sort_cache_t lucy_DefSortReader_fetch_sort_cache_t
  #define DefSortReader_fetch_sort_cache lucy_DefSortReader_fetch_sort_cache
  #define DefSortReader_Make Lucy_DefSortReader_Make
  #define DefSortReader_Get_RefCount Lucy_DefSortReader_Get_RefCount
  #define DefSortReader_Inc_RefCount Lucy_DefSortReader_Inc_RefCount
  #define DefSortReader_Dec_RefCount Lucy_DefSortReader_Dec_RefCount
  #define DefSortReader_To_Host Lucy_DefSortReader_To_Host
  #define DefSortReader_Clone Lucy_DefSortReader_Clone
  #define DefSortReader_Destroy Lucy_DefSortReader_Destroy
  #define DefSortReader_Equals Lucy_DefSortReader_Equals
  #define DefSortReader_Compare_To Lucy_DefSortReader_Compare_To
  #define DefSortReader_Hash_Sum Lucy_DefSortReader_Hash_Sum
  #define DefSortReader_Get_VTable Lucy_DefSortReader_Get_VTable
  #define DefSortReader_Get_Class_Name Lucy_DefSortReader_Get_Class_Name
  #define DefSortReader_Is_A Lucy_DefSortReader_Is_A
  #define DefSortReader_To_String Lucy_DefSortReader_To_String
  #define DefSortReader_To_I64 Lucy_DefSortReader_To_I64
  #define DefSortReader_To_F64 Lucy_DefSortReader_To_F64
  #define DefSortReader_To_Bool Lucy_DefSortReader_To_Bool
  #define DefSortReader_Serialize Lucy_DefSortReader_Serialize
  #define DefSortReader_Deserialize Lucy_DefSortReader_Deserialize
  #define DefSortReader_Dump Lucy_DefSortReader_Dump
  #define DefSortReader_Load Lucy_DefSortReader_Load
  #define DefSortReader_Mimic Lucy_DefSortReader_Mimic
  #define DefSortReader_Aggregator Lucy_DefSortReader_Aggregator
  #define DefSortReader_Get_Schema Lucy_DefSortReader_Get_Schema
  #define DefSortReader_Get_Folder Lucy_DefSortReader_Get_Folder
  #define DefSortReader_Get_Snapshot Lucy_DefSortReader_Get_Snapshot
  #define DefSortReader_Get_Segments Lucy_DefSortReader_Get_Segments
  #define DefSortReader_Get_Segment Lucy_DefSortReader_Get_Segment
  #define DefSortReader_Get_Seg_Tick Lucy_DefSortReader_Get_Seg_Tick
  #define DefSortReader_Close Lucy_DefSortReader_Close
  #define DefSortReader_Fetch_Sort_Cache Lucy_DefSortReader_Fetch_Sort_Cache
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTREADER */




