/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTWRITER
#define H_LUCY_INDEX_SORTWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTWRITER
struct lucy_SortWriter {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_VArray* field_writers;
    lucy_Hash* counts;
    lucy_Hash* null_ords;
    lucy_Hash* ord_widths;
    lucy_OutStream* temp_ord_out;
    lucy_OutStream* temp_ix_out;
    lucy_OutStream* temp_dat_out;
    lucy_MemoryPool* mem_pool;
    size_t mem_thresh;
    chy_bool_t flush_at_finish;
};

#endif /* C_LUCY_SORTWRITER */

/* Declare this class's inert variables.
 */

extern int32_t lucy_SortWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SortWriter*
lucy_SortWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

lucy_SortWriter*
lucy_SortWriter_init(lucy_SortWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

void
lucy_SortWriter_set_default_mem_thresh(size_t mem_thresh);

void
lucy_SortWriter_destroy(lucy_SortWriter* self);

void
lucy_SortWriter_add_inverted_doc(lucy_SortWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
lucy_SortWriter_add_segment(lucy_SortWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
lucy_SortWriter_finish(lucy_SortWriter* self);

lucy_Hash*
lucy_SortWriter_metadata(lucy_SortWriter* self);

int32_t
lucy_SortWriter_format(lucy_SortWriter* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SortWriter_destroy_CALLBACK;
extern cfish_Callback lucy_SortWriter_add_inverted_doc_CALLBACK;
extern cfish_Callback lucy_SortWriter_add_segment_CALLBACK;
extern cfish_Callback lucy_SortWriter_finish_CALLBACK;
extern cfish_Callback lucy_SortWriter_metadata_CALLBACK;
extern cfish_Callback lucy_SortWriter_format_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SortWriter_destroy_t)(lucy_SortWriter* self);

typedef void
(*lucy_SortWriter_add_inverted_doc_t)(lucy_SortWriter* self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*lucy_SortWriter_add_segment_t)(lucy_SortWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*lucy_SortWriter_finish_t)(lucy_SortWriter* self);

typedef lucy_Hash*
(*lucy_SortWriter_metadata_t)(lucy_SortWriter* self);

typedef int32_t
(*lucy_SortWriter_format_t)(lucy_SortWriter* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SortWriter_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortWriter_Make(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortWriter_Get_RefCount(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortWriter_Inc_RefCount(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortWriter_Dec_RefCount(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SortWriter_To_Host(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortWriter_Clone(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Destroy(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Destroy_OFFSET;
    const lucy_SortWriter_destroy_t method = *((lucy_SortWriter_destroy_t*)method_address);
    method((lucy_SortWriter*)self);
}

extern size_t Lucy_SortWriter_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortWriter_Equals(const lucy_SortWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortWriter_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SortWriter_Compare_To(const lucy_SortWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortWriter_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SortWriter_Hash_Sum(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SortWriter_Get_VTable(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortWriter_Get_Class_Name(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortWriter_Is_A(const lucy_SortWriter *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SortWriter_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortWriter_To_String(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SortWriter_To_I64(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SortWriter_To_F64(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortWriter_To_Bool(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Serialize(const lucy_SortWriter *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SortWriter_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortWriter_Deserialize(const lucy_SortWriter *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SortWriter_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortWriter_Dump(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortWriter_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortWriter_Load(const lucy_SortWriter *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SortWriter_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Mimic(const lucy_SortWriter *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortWriter_Add_Inverted_Doc_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Add_Inverted_Doc(const lucy_SortWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Add_Inverted_Doc_OFFSET;
    const lucy_SortWriter_add_inverted_doc_t method = *((lucy_SortWriter_add_inverted_doc_t*)method_address);
    method((lucy_SortWriter*)self, inverter, doc_id);
}

extern size_t Lucy_SortWriter_Add_Segment_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Add_Segment(const lucy_SortWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Add_Segment_OFFSET;
    const lucy_SortWriter_add_segment_t method = *((lucy_SortWriter_add_segment_t*)method_address);
    method((lucy_SortWriter*)self, reader, doc_map);
}

extern size_t Lucy_SortWriter_Delete_Segment_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Delete_Segment(const lucy_SortWriter *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Delete_Segment_OFFSET;
    const lucy_DataWriter_delete_segment_t method = *((lucy_DataWriter_delete_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader);
}

extern size_t Lucy_SortWriter_Merge_Segment_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Merge_Segment(const lucy_SortWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Merge_Segment_OFFSET;
    const lucy_DataWriter_merge_segment_t method = *((lucy_DataWriter_merge_segment_t*)method_address);
    method((lucy_DataWriter*)self, reader, doc_map);
}

extern size_t Lucy_SortWriter_Finish_OFFSET;
static CHY_INLINE void
Lucy_SortWriter_Finish(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Finish_OFFSET;
    const lucy_SortWriter_finish_t method = *((lucy_SortWriter_finish_t*)method_address);
    method((lucy_SortWriter*)self);
}

extern size_t Lucy_SortWriter_Metadata_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_SortWriter_Metadata(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Metadata_OFFSET;
    const lucy_SortWriter_metadata_t method = *((lucy_SortWriter_metadata_t*)method_address);
    return method((lucy_SortWriter*)self);
}

extern size_t Lucy_SortWriter_Format_OFFSET;
static CHY_INLINE int32_t
Lucy_SortWriter_Format(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Format_OFFSET;
    const lucy_SortWriter_format_t method = *((lucy_SortWriter_format_t*)method_address);
    return method((lucy_SortWriter*)self);
}

extern size_t Lucy_SortWriter_Get_Snapshot_OFFSET;
static CHY_INLINE lucy_Snapshot*
Lucy_SortWriter_Get_Snapshot(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_Snapshot_OFFSET;
    const lucy_DataWriter_get_snapshot_t method = *((lucy_DataWriter_get_snapshot_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SortWriter_Get_Segment_OFFSET;
static CHY_INLINE lucy_Segment*
Lucy_SortWriter_Get_Segment(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_Segment_OFFSET;
    const lucy_DataWriter_get_segment_t method = *((lucy_DataWriter_get_segment_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SortWriter_Get_PolyReader_OFFSET;
static CHY_INLINE lucy_PolyReader*
Lucy_SortWriter_Get_PolyReader(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_PolyReader_OFFSET;
    const lucy_DataWriter_get_polyreader_t method = *((lucy_DataWriter_get_polyreader_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SortWriter_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_SortWriter_Get_Schema(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_Schema_OFFSET;
    const lucy_DataWriter_get_schema_t method = *((lucy_DataWriter_get_schema_t*)method_address);
    return method((lucy_DataWriter*)self);
}

extern size_t Lucy_SortWriter_Get_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_SortWriter_Get_Folder(const lucy_SortWriter *self) {
    char *const method_address = *(char**)self + Lucy_SortWriter_Get_Folder_OFFSET;
    const lucy_DataWriter_get_folder_t method = *((lucy_DataWriter_get_folder_t*)method_address);
    return method((lucy_DataWriter*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SORTWRITER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[34];
} LUCY_SORTWRITER_VT;
extern struct LUCY_SORTWRITER_VT LUCY_SORTWRITER_vt;
#define LUCY_SORTWRITER ((cfish_VTable*)&LUCY_SORTWRITER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortWriter lucy_SortWriter
  #define SORTWRITER LUCY_SORTWRITER
  #define SortWriter_new lucy_SortWriter_new
  #define SortWriter_init lucy_SortWriter_init
  #define SortWriter_set_default_mem_thresh lucy_SortWriter_set_default_mem_thresh
  #define SortWriter_current_file_format lucy_SortWriter_current_file_format
  #define SortWriter_destroy_t lucy_SortWriter_destroy_t
  #define SortWriter_destroy lucy_SortWriter_destroy
  #define SortWriter_add_inverted_doc_t lucy_SortWriter_add_inverted_doc_t
  #define SortWriter_add_inverted_doc lucy_SortWriter_add_inverted_doc
  #define SortWriter_add_segment_t lucy_SortWriter_add_segment_t
  #define SortWriter_add_segment lucy_SortWriter_add_segment
  #define SortWriter_finish_t lucy_SortWriter_finish_t
  #define SortWriter_finish lucy_SortWriter_finish
  #define SortWriter_metadata_t lucy_SortWriter_metadata_t
  #define SortWriter_metadata lucy_SortWriter_metadata
  #define SortWriter_format_t lucy_SortWriter_format_t
  #define SortWriter_format lucy_SortWriter_format
  #define SortWriter_Make Lucy_SortWriter_Make
  #define SortWriter_Get_RefCount Lucy_SortWriter_Get_RefCount
  #define SortWriter_Inc_RefCount Lucy_SortWriter_Inc_RefCount
  #define SortWriter_Dec_RefCount Lucy_SortWriter_Dec_RefCount
  #define SortWriter_To_Host Lucy_SortWriter_To_Host
  #define SortWriter_Clone Lucy_SortWriter_Clone
  #define SortWriter_Destroy Lucy_SortWriter_Destroy
  #define SortWriter_Equals Lucy_SortWriter_Equals
  #define SortWriter_Compare_To Lucy_SortWriter_Compare_To
  #define SortWriter_Hash_Sum Lucy_SortWriter_Hash_Sum
  #define SortWriter_Get_VTable Lucy_SortWriter_Get_VTable
  #define SortWriter_Get_Class_Name Lucy_SortWriter_Get_Class_Name
  #define SortWriter_Is_A Lucy_SortWriter_Is_A
  #define SortWriter_To_String Lucy_SortWriter_To_String
  #define SortWriter_To_I64 Lucy_SortWriter_To_I64
  #define SortWriter_To_F64 Lucy_SortWriter_To_F64
  #define SortWriter_To_Bool Lucy_SortWriter_To_Bool
  #define SortWriter_Serialize Lucy_SortWriter_Serialize
  #define SortWriter_Deserialize Lucy_SortWriter_Deserialize
  #define SortWriter_Dump Lucy_SortWriter_Dump
  #define SortWriter_Load Lucy_SortWriter_Load
  #define SortWriter_Mimic Lucy_SortWriter_Mimic
  #define SortWriter_Add_Inverted_Doc Lucy_SortWriter_Add_Inverted_Doc
  #define SortWriter_Add_Segment Lucy_SortWriter_Add_Segment
  #define SortWriter_Delete_Segment Lucy_SortWriter_Delete_Segment
  #define SortWriter_Merge_Segment Lucy_SortWriter_Merge_Segment
  #define SortWriter_Finish Lucy_SortWriter_Finish
  #define SortWriter_Metadata Lucy_SortWriter_Metadata
  #define SortWriter_Format Lucy_SortWriter_Format
  #define SortWriter_Get_Snapshot Lucy_SortWriter_Get_Snapshot
  #define SortWriter_Get_Segment Lucy_SortWriter_Get_Segment
  #define SortWriter_Get_PolyReader Lucy_SortWriter_Get_PolyReader
  #define SortWriter_Get_Schema Lucy_SortWriter_Get_Schema
  #define SortWriter_Get_Folder Lucy_SortWriter_Get_Folder
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTWRITER */




