/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_TERMINFO
#define H_LUCY_INDEX_TERMINFO 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TERMINFO
struct lucy_TermInfo {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_freq;
    int64_t post_filepos;
    int64_t skip_filepos;
    int64_t lex_filepos;
};

#endif /* C_LUCY_TERMINFO */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_TermInfo*
lucy_TInfo_new(int32_t doc_freq);

lucy_TermInfo*
lucy_TInfo_init(lucy_TermInfo* self, int32_t doc_freq);

lucy_TermInfo*
lucy_TInfo_clone(lucy_TermInfo* self);

lucy_CharBuf*
lucy_TInfo_to_string(lucy_TermInfo* self);

void
lucy_TInfo_mimic(lucy_TermInfo* self, lucy_Obj* other);

int32_t
lucy_TInfo_get_doc_freq(lucy_TermInfo* self);

int64_t
lucy_TInfo_get_lex_filepos(lucy_TermInfo* self);

int64_t
lucy_TInfo_get_post_filepos(lucy_TermInfo* self);

int64_t
lucy_TInfo_get_skip_filepos(lucy_TermInfo* self);

void
lucy_TInfo_set_doc_freq(lucy_TermInfo* self, int32_t doc_freq);

void
lucy_TInfo_set_lex_filepos(lucy_TermInfo* self, int64_t filepos);

void
lucy_TInfo_set_post_filepos(lucy_TermInfo* self, int64_t filepos);

void
lucy_TInfo_set_skip_filepos(lucy_TermInfo* self, int64_t filepos);

void
lucy_TInfo_reset(lucy_TermInfo* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_TInfo_clone_CALLBACK;
extern cfish_Callback lucy_TInfo_to_string_CALLBACK;
extern cfish_Callback lucy_TInfo_mimic_CALLBACK;
extern cfish_Callback lucy_TInfo_get_doc_freq_CALLBACK;
extern cfish_Callback lucy_TInfo_get_lex_filepos_CALLBACK;
extern cfish_Callback lucy_TInfo_get_post_filepos_CALLBACK;
extern cfish_Callback lucy_TInfo_get_skip_filepos_CALLBACK;
extern cfish_Callback lucy_TInfo_set_doc_freq_CALLBACK;
extern cfish_Callback lucy_TInfo_set_lex_filepos_CALLBACK;
extern cfish_Callback lucy_TInfo_set_post_filepos_CALLBACK;
extern cfish_Callback lucy_TInfo_set_skip_filepos_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_TermInfo*
(*lucy_TInfo_clone_t)(lucy_TermInfo* self);

typedef lucy_CharBuf*
(*lucy_TInfo_to_string_t)(lucy_TermInfo* self);

typedef void
(*lucy_TInfo_mimic_t)(lucy_TermInfo* self, lucy_Obj* other);

typedef int32_t
(*lucy_TInfo_get_doc_freq_t)(lucy_TermInfo* self);

typedef int64_t
(*lucy_TInfo_get_lex_filepos_t)(lucy_TermInfo* self);

typedef int64_t
(*lucy_TInfo_get_post_filepos_t)(lucy_TermInfo* self);

typedef int64_t
(*lucy_TInfo_get_skip_filepos_t)(lucy_TermInfo* self);

typedef void
(*lucy_TInfo_set_doc_freq_t)(lucy_TermInfo* self, int32_t doc_freq);

typedef void
(*lucy_TInfo_set_lex_filepos_t)(lucy_TermInfo* self, int64_t filepos);

typedef void
(*lucy_TInfo_set_post_filepos_t)(lucy_TermInfo* self, int64_t filepos);

typedef void
(*lucy_TInfo_set_skip_filepos_t)(lucy_TermInfo* self, int64_t filepos);

typedef void
(*lucy_TInfo_reset_t)(lucy_TermInfo* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_TInfo_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TInfo_Make(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TInfo_Get_RefCount(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TInfo_Inc_RefCount(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TInfo_Dec_RefCount(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_TInfo_To_Host(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Clone_OFFSET;
static CHY_INLINE lucy_TermInfo*
Lucy_TInfo_Clone(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Clone_OFFSET;
    const lucy_TInfo_clone_t method = *((lucy_TInfo_clone_t*)method_address);
    return method((lucy_TermInfo*)self);
}

extern size_t Lucy_TInfo_Destroy_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Destroy(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TInfo_Equals(const lucy_TermInfo *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TInfo_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TInfo_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_TInfo_Compare_To(const lucy_TermInfo *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TInfo_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TInfo_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_TInfo_Hash_Sum(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_TInfo_Get_VTable(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TInfo_Get_Class_Name(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TInfo_Is_A(const lucy_TermInfo *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_TInfo_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_TInfo_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TInfo_To_String(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_To_String_OFFSET;
    const lucy_TInfo_to_string_t method = *((lucy_TInfo_to_string_t*)method_address);
    return method((lucy_TermInfo*)self);
}

extern size_t Lucy_TInfo_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_TInfo_To_I64(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_To_F64_OFFSET;
static CHY_INLINE double
Lucy_TInfo_To_F64(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TInfo_To_Bool(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Serialize_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Serialize(const lucy_TermInfo *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_TInfo_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_TInfo_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TInfo_Deserialize(const lucy_TermInfo *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_TInfo_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_TInfo_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TInfo_Dump(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TInfo_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TInfo_Load(const lucy_TermInfo *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_TInfo_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_TInfo_Mimic_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Mimic(const lucy_TermInfo *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TInfo_Mimic_OFFSET;
    const lucy_TInfo_mimic_t method = *((lucy_TInfo_mimic_t*)method_address);
    method((lucy_TermInfo*)self, other);
}

extern size_t Lucy_TInfo_Get_Doc_Freq_OFFSET;
static CHY_INLINE int32_t
Lucy_TInfo_Get_Doc_Freq(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_Doc_Freq_OFFSET;
    const lucy_TInfo_get_doc_freq_t method = *((lucy_TInfo_get_doc_freq_t*)method_address);
    return method((lucy_TermInfo*)self);
}

extern size_t Lucy_TInfo_Get_Lex_FilePos_OFFSET;
static CHY_INLINE int64_t
Lucy_TInfo_Get_Lex_FilePos(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_Lex_FilePos_OFFSET;
    const lucy_TInfo_get_lex_filepos_t method = *((lucy_TInfo_get_lex_filepos_t*)method_address);
    return method((lucy_TermInfo*)self);
}

extern size_t Lucy_TInfo_Get_Post_FilePos_OFFSET;
static CHY_INLINE int64_t
Lucy_TInfo_Get_Post_FilePos(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_Post_FilePos_OFFSET;
    const lucy_TInfo_get_post_filepos_t method = *((lucy_TInfo_get_post_filepos_t*)method_address);
    return method((lucy_TermInfo*)self);
}

extern size_t Lucy_TInfo_Get_Skip_FilePos_OFFSET;
static CHY_INLINE int64_t
Lucy_TInfo_Get_Skip_FilePos(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Get_Skip_FilePos_OFFSET;
    const lucy_TInfo_get_skip_filepos_t method = *((lucy_TInfo_get_skip_filepos_t*)method_address);
    return method((lucy_TermInfo*)self);
}

extern size_t Lucy_TInfo_Set_Doc_Freq_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Set_Doc_Freq(const lucy_TermInfo *self, int32_t doc_freq) {
    char *const method_address = *(char**)self + Lucy_TInfo_Set_Doc_Freq_OFFSET;
    const lucy_TInfo_set_doc_freq_t method = *((lucy_TInfo_set_doc_freq_t*)method_address);
    method((lucy_TermInfo*)self, doc_freq);
}

extern size_t Lucy_TInfo_Set_Lex_FilePos_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Set_Lex_FilePos(const lucy_TermInfo *self, int64_t filepos) {
    char *const method_address = *(char**)self + Lucy_TInfo_Set_Lex_FilePos_OFFSET;
    const lucy_TInfo_set_lex_filepos_t method = *((lucy_TInfo_set_lex_filepos_t*)method_address);
    method((lucy_TermInfo*)self, filepos);
}

extern size_t Lucy_TInfo_Set_Post_FilePos_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Set_Post_FilePos(const lucy_TermInfo *self, int64_t filepos) {
    char *const method_address = *(char**)self + Lucy_TInfo_Set_Post_FilePos_OFFSET;
    const lucy_TInfo_set_post_filepos_t method = *((lucy_TInfo_set_post_filepos_t*)method_address);
    method((lucy_TermInfo*)self, filepos);
}

extern size_t Lucy_TInfo_Set_Skip_FilePos_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Set_Skip_FilePos(const lucy_TermInfo *self, int64_t filepos) {
    char *const method_address = *(char**)self + Lucy_TInfo_Set_Skip_FilePos_OFFSET;
    const lucy_TInfo_set_skip_filepos_t method = *((lucy_TInfo_set_skip_filepos_t*)method_address);
    method((lucy_TermInfo*)self, filepos);
}

extern size_t Lucy_TInfo_Reset_OFFSET;
static CHY_INLINE void
Lucy_TInfo_Reset(const lucy_TermInfo *self) {
    char *const method_address = *(char**)self + Lucy_TInfo_Reset_OFFSET;
    const lucy_TInfo_reset_t method = *((lucy_TInfo_reset_t*)method_address);
    method((lucy_TermInfo*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_TERMINFO_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_TERMINFO_VT;
extern struct LUCY_TERMINFO_VT LUCY_TERMINFO_vt;
#define LUCY_TERMINFO ((cfish_VTable*)&LUCY_TERMINFO_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TermInfo lucy_TermInfo
  #define TERMINFO LUCY_TERMINFO
  #define TInfo_new lucy_TInfo_new
  #define TInfo_init lucy_TInfo_init
  #define TInfo_clone_t lucy_TInfo_clone_t
  #define TInfo_clone lucy_TInfo_clone
  #define TInfo_to_string_t lucy_TInfo_to_string_t
  #define TInfo_to_string lucy_TInfo_to_string
  #define TInfo_mimic_t lucy_TInfo_mimic_t
  #define TInfo_mimic lucy_TInfo_mimic
  #define TInfo_get_doc_freq_t lucy_TInfo_get_doc_freq_t
  #define TInfo_get_doc_freq lucy_TInfo_get_doc_freq
  #define TInfo_get_lex_filepos_t lucy_TInfo_get_lex_filepos_t
  #define TInfo_get_lex_filepos lucy_TInfo_get_lex_filepos
  #define TInfo_get_post_filepos_t lucy_TInfo_get_post_filepos_t
  #define TInfo_get_post_filepos lucy_TInfo_get_post_filepos
  #define TInfo_get_skip_filepos_t lucy_TInfo_get_skip_filepos_t
  #define TInfo_get_skip_filepos lucy_TInfo_get_skip_filepos
  #define TInfo_set_doc_freq_t lucy_TInfo_set_doc_freq_t
  #define TInfo_set_doc_freq lucy_TInfo_set_doc_freq
  #define TInfo_set_lex_filepos_t lucy_TInfo_set_lex_filepos_t
  #define TInfo_set_lex_filepos lucy_TInfo_set_lex_filepos
  #define TInfo_set_post_filepos_t lucy_TInfo_set_post_filepos_t
  #define TInfo_set_post_filepos lucy_TInfo_set_post_filepos
  #define TInfo_set_skip_filepos_t lucy_TInfo_set_skip_filepos_t
  #define TInfo_set_skip_filepos lucy_TInfo_set_skip_filepos
  #define TInfo_reset_t lucy_TInfo_reset_t
  #define TInfo_reset lucy_TInfo_reset
  #define TInfo_Make Lucy_TInfo_Make
  #define TInfo_Get_RefCount Lucy_TInfo_Get_RefCount
  #define TInfo_Inc_RefCount Lucy_TInfo_Inc_RefCount
  #define TInfo_Dec_RefCount Lucy_TInfo_Dec_RefCount
  #define TInfo_To_Host Lucy_TInfo_To_Host
  #define TInfo_Clone Lucy_TInfo_Clone
  #define TInfo_Destroy Lucy_TInfo_Destroy
  #define TInfo_Equals Lucy_TInfo_Equals
  #define TInfo_Compare_To Lucy_TInfo_Compare_To
  #define TInfo_Hash_Sum Lucy_TInfo_Hash_Sum
  #define TInfo_Get_VTable Lucy_TInfo_Get_VTable
  #define TInfo_Get_Class_Name Lucy_TInfo_Get_Class_Name
  #define TInfo_Is_A Lucy_TInfo_Is_A
  #define TInfo_To_String Lucy_TInfo_To_String
  #define TInfo_To_I64 Lucy_TInfo_To_I64
  #define TInfo_To_F64 Lucy_TInfo_To_F64
  #define TInfo_To_Bool Lucy_TInfo_To_Bool
  #define TInfo_Serialize Lucy_TInfo_Serialize
  #define TInfo_Deserialize Lucy_TInfo_Deserialize
  #define TInfo_Dump Lucy_TInfo_Dump
  #define TInfo_Load Lucy_TInfo_Load
  #define TInfo_Mimic Lucy_TInfo_Mimic
  #define TInfo_Get_Doc_Freq Lucy_TInfo_Get_Doc_Freq
  #define TInfo_Get_Lex_FilePos Lucy_TInfo_Get_Lex_FilePos
  #define TInfo_Get_Post_FilePos Lucy_TInfo_Get_Post_FilePos
  #define TInfo_Get_Skip_FilePos Lucy_TInfo_Get_Skip_FilePos
  #define TInfo_Set_Doc_Freq Lucy_TInfo_Set_Doc_Freq
  #define TInfo_Set_Lex_FilePos Lucy_TInfo_Set_Lex_FilePos
  #define TInfo_Set_Post_FilePos Lucy_TInfo_Set_Post_FilePos
  #define TInfo_Set_Skip_FilePos Lucy_TInfo_Set_Skip_FilePos
  #define TInfo_Reset Lucy_TInfo_Reset
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_TERMINFO */




