/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_TERMVECTOR
#define H_LUCY_INDEX_TERMVECTOR 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TERMVECTOR
struct lucy_TermVector {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* field;
    lucy_CharBuf* text;
    uint32_t num_pos;
    lucy_I32Array* positions;
    lucy_I32Array* start_offsets;
    lucy_I32Array* end_offsets;
};

#endif /* C_LUCY_TERMVECTOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_TermVector*
lucy_TV_new(const lucy_CharBuf* field, const lucy_CharBuf* text, lucy_I32Array* positions, lucy_I32Array* start_offsets, lucy_I32Array* end_offsets);

lucy_TermVector*
lucy_TV_init(lucy_TermVector* self, const lucy_CharBuf* field, const lucy_CharBuf* text, lucy_I32Array* positions, lucy_I32Array* start_offsets, lucy_I32Array* end_offsets);

void
lucy_TV_destroy(lucy_TermVector* self);

chy_bool_t
lucy_TV_equals(lucy_TermVector* self, lucy_Obj* other);

void
lucy_TV_serialize(lucy_TermVector* self, lucy_OutStream* outstream);

lucy_TermVector*
lucy_TV_deserialize(lucy_TermVector* self, lucy_InStream* instream);

lucy_I32Array*
lucy_TV_get_positions(lucy_TermVector* self);

lucy_I32Array*
lucy_TV_get_start_offsets(lucy_TermVector* self);

lucy_I32Array*
lucy_TV_get_end_offsets(lucy_TermVector* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_TV_destroy_CALLBACK;
extern cfish_Callback lucy_TV_equals_CALLBACK;
extern cfish_Callback lucy_TV_serialize_CALLBACK;
extern cfish_Callback lucy_TV_deserialize_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_TV_destroy_t)(lucy_TermVector* self);

typedef chy_bool_t
(*lucy_TV_equals_t)(lucy_TermVector* self, lucy_Obj* other);

typedef void
(*lucy_TV_serialize_t)(lucy_TermVector* self, lucy_OutStream* outstream);

typedef lucy_TermVector*
(*lucy_TV_deserialize_t)(lucy_TermVector* self, lucy_InStream* instream);

typedef lucy_I32Array*
(*lucy_TV_get_positions_t)(lucy_TermVector* self);

typedef lucy_I32Array*
(*lucy_TV_get_start_offsets_t)(lucy_TermVector* self);

typedef lucy_I32Array*
(*lucy_TV_get_end_offsets_t)(lucy_TermVector* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_TV_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TV_Make(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TV_Get_RefCount(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TV_Inc_RefCount(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TV_Dec_RefCount(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_TV_To_Host(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TV_Clone(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Destroy_OFFSET;
static CHY_INLINE void
Lucy_TV_Destroy(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Destroy_OFFSET;
    const lucy_TV_destroy_t method = *((lucy_TV_destroy_t*)method_address);
    method((lucy_TermVector*)self);
}

extern size_t Lucy_TV_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TV_Equals(const lucy_TermVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TV_Equals_OFFSET;
    const lucy_TV_equals_t method = *((lucy_TV_equals_t*)method_address);
    return method((lucy_TermVector*)self, other);
}

extern size_t Lucy_TV_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_TV_Compare_To(const lucy_TermVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TV_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TV_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_TV_Hash_Sum(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_TV_Get_VTable(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TV_Get_Class_Name(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TV_Is_A(const lucy_TermVector *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_TV_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_TV_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TV_To_String(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_TV_To_I64(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_To_F64_OFFSET;
static CHY_INLINE double
Lucy_TV_To_F64(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TV_To_Bool(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Serialize_OFFSET;
static CHY_INLINE void
Lucy_TV_Serialize(const lucy_TermVector *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_TV_Serialize_OFFSET;
    const lucy_TV_serialize_t method = *((lucy_TV_serialize_t*)method_address);
    method((lucy_TermVector*)self, outstream);
}

extern size_t Lucy_TV_Deserialize_OFFSET;
static CHY_INLINE lucy_TermVector*
Lucy_TV_Deserialize(const lucy_TermVector *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_TV_Deserialize_OFFSET;
    const lucy_TV_deserialize_t method = *((lucy_TV_deserialize_t*)method_address);
    return method((lucy_TermVector*)self, instream);
}

extern size_t Lucy_TV_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TV_Dump(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TV_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TV_Load(const lucy_TermVector *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_TV_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_TV_Mimic_OFFSET;
static CHY_INLINE void
Lucy_TV_Mimic(const lucy_TermVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TV_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_TV_Get_Positions_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_TV_Get_Positions(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Get_Positions_OFFSET;
    const lucy_TV_get_positions_t method = *((lucy_TV_get_positions_t*)method_address);
    return method((lucy_TermVector*)self);
}

extern size_t Lucy_TV_Get_Start_Offsets_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_TV_Get_Start_Offsets(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Get_Start_Offsets_OFFSET;
    const lucy_TV_get_start_offsets_t method = *((lucy_TV_get_start_offsets_t*)method_address);
    return method((lucy_TermVector*)self);
}

extern size_t Lucy_TV_Get_End_Offsets_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_TV_Get_End_Offsets(const lucy_TermVector *self) {
    char *const method_address = *(char**)self + Lucy_TV_Get_End_Offsets_OFFSET;
    const lucy_TV_get_end_offsets_t method = *((lucy_TV_get_end_offsets_t*)method_address);
    return method((lucy_TermVector*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_TERMVECTOR_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_TERMVECTOR_VT;
extern struct LUCY_TERMVECTOR_VT LUCY_TERMVECTOR_vt;
#define LUCY_TERMVECTOR ((cfish_VTable*)&LUCY_TERMVECTOR_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TermVector lucy_TermVector
  #define TERMVECTOR LUCY_TERMVECTOR
  #define TV_new lucy_TV_new
  #define TV_init lucy_TV_init
  #define TV_destroy_t lucy_TV_destroy_t
  #define TV_destroy lucy_TV_destroy
  #define TV_equals_t lucy_TV_equals_t
  #define TV_equals lucy_TV_equals
  #define TV_serialize_t lucy_TV_serialize_t
  #define TV_serialize lucy_TV_serialize
  #define TV_deserialize_t lucy_TV_deserialize_t
  #define TV_deserialize lucy_TV_deserialize
  #define TV_get_positions_t lucy_TV_get_positions_t
  #define TV_get_positions lucy_TV_get_positions
  #define TV_get_start_offsets_t lucy_TV_get_start_offsets_t
  #define TV_get_start_offsets lucy_TV_get_start_offsets
  #define TV_get_end_offsets_t lucy_TV_get_end_offsets_t
  #define TV_get_end_offsets lucy_TV_get_end_offsets
  #define TV_Make Lucy_TV_Make
  #define TV_Get_RefCount Lucy_TV_Get_RefCount
  #define TV_Inc_RefCount Lucy_TV_Inc_RefCount
  #define TV_Dec_RefCount Lucy_TV_Dec_RefCount
  #define TV_To_Host Lucy_TV_To_Host
  #define TV_Clone Lucy_TV_Clone
  #define TV_Destroy Lucy_TV_Destroy
  #define TV_Equals Lucy_TV_Equals
  #define TV_Compare_To Lucy_TV_Compare_To
  #define TV_Hash_Sum Lucy_TV_Hash_Sum
  #define TV_Get_VTable Lucy_TV_Get_VTable
  #define TV_Get_Class_Name Lucy_TV_Get_Class_Name
  #define TV_Is_A Lucy_TV_Is_A
  #define TV_To_String Lucy_TV_To_String
  #define TV_To_I64 Lucy_TV_To_I64
  #define TV_To_F64 Lucy_TV_To_F64
  #define TV_To_Bool Lucy_TV_To_Bool
  #define TV_Serialize Lucy_TV_Serialize
  #define TV_Deserialize Lucy_TV_Deserialize
  #define TV_Dump Lucy_TV_Dump
  #define TV_Load Lucy_TV_Load
  #define TV_Mimic Lucy_TV_Mimic
  #define TV_Get_Positions Lucy_TV_Get_Positions
  #define TV_Get_Start_Offsets Lucy_TV_Get_Start_Offsets
  #define TV_Get_End_Offsets Lucy_TV_Get_End_Offsets
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_TERMVECTOR */




