/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_ZOMBIEKEYEDHASH
#define H_LUCY_INDEX_ZOMBIEKEYEDHASH 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Hash.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ZOMBIEKEYEDHASH
struct lucy_ZombieKeyedHash {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    void* entries;
    uint32_t capacity;
    uint32_t size;
    uint32_t threshold;
    int32_t iter_tick;
    lucy_MemoryPool* mem_pool;
    uint8_t prim_id;
};

#endif /* C_LUCY_ZOMBIEKEYEDHASH */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ZombieKeyedHash*
lucy_ZKHash_new(lucy_MemoryPool* memory_pool, uint8_t primitive_id);

void
lucy_ZKHash_destroy(lucy_ZombieKeyedHash* self);

lucy_Obj*
lucy_ZKHash_make_key(lucy_ZombieKeyedHash* self, lucy_Obj* key, int32_t hash_sum);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ZKHash_destroy_CALLBACK;
extern cfish_Callback lucy_ZKHash_make_key_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ZKHash_destroy_t)(lucy_ZombieKeyedHash* self);

typedef lucy_Obj*
(*lucy_ZKHash_make_key_t)(lucy_ZombieKeyedHash* self, lucy_Obj* key, int32_t hash_sum);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ZKHash_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Make(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZKHash_Get_RefCount(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Inc_RefCount(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZKHash_Dec_RefCount(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ZKHash_To_Host(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Clone(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ZKHash_Destroy(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Destroy_OFFSET;
    const lucy_ZKHash_destroy_t method = *((lucy_ZKHash_destroy_t*)method_address);
    method((lucy_ZombieKeyedHash*)self);
}

extern size_t Lucy_ZKHash_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZKHash_Equals(const lucy_ZombieKeyedHash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Equals_OFFSET;
    const lucy_Hash_equals_t method = *((lucy_Hash_equals_t*)method_address);
    return method((lucy_Hash*)self, other);
}

extern size_t Lucy_ZKHash_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ZKHash_Compare_To(const lucy_ZombieKeyedHash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ZKHash_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ZKHash_Hash_Sum(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ZKHash_Get_VTable(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZKHash_Get_Class_Name(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZKHash_Is_A(const lucy_ZombieKeyedHash *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ZKHash_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZKHash_To_String(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ZKHash_To_I64(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ZKHash_To_F64(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZKHash_To_Bool(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZKHash_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ZKHash_Serialize(const lucy_ZombieKeyedHash *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Serialize_OFFSET;
    const lucy_Hash_serialize_t method = *((lucy_Hash_serialize_t*)method_address);
    method((lucy_Hash*)self, outstream);
}

extern size_t Lucy_ZKHash_Deserialize_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_ZKHash_Deserialize(const lucy_ZombieKeyedHash *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Deserialize_OFFSET;
    const lucy_Hash_deserialize_t method = *((lucy_Hash_deserialize_t*)method_address);
    return method((lucy_Hash*)self, instream);
}

extern size_t Lucy_ZKHash_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_ZKHash_Dump(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Dump_OFFSET;
    const lucy_Hash_dump_t method = *((lucy_Hash_dump_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_ZKHash_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Load(const lucy_ZombieKeyedHash *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Load_OFFSET;
    const lucy_Hash_load_t method = *((lucy_Hash_load_t*)method_address);
    return method((lucy_Hash*)self, dump);
}

extern size_t Lucy_ZKHash_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ZKHash_Mimic(const lucy_ZombieKeyedHash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ZKHash_Clear_OFFSET;
static CHY_INLINE void
Lucy_ZKHash_Clear(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Clear_OFFSET;
    const lucy_Hash_clear_t method = *((lucy_Hash_clear_t*)method_address);
    method((lucy_Hash*)self);
}

extern size_t Lucy_ZKHash_Store_OFFSET;
static CHY_INLINE void
Lucy_ZKHash_Store(const lucy_ZombieKeyedHash *self, lucy_Obj* key, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Store_OFFSET;
    const lucy_Hash_store_t method = *((lucy_Hash_store_t*)method_address);
    method((lucy_Hash*)self, key, value);
}

extern size_t Lucy_ZKHash_Store_Str_OFFSET;
static CHY_INLINE void
Lucy_ZKHash_Store_Str(const lucy_ZombieKeyedHash *self, const char* str, size_t len, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Store_Str_OFFSET;
    const lucy_Hash_store_str_t method = *((lucy_Hash_store_str_t*)method_address);
    method((lucy_Hash*)self, str, len, value);
}

extern size_t Lucy_ZKHash_Fetch_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Fetch(const lucy_ZombieKeyedHash *self, const lucy_Obj* key) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Fetch_OFFSET;
    const lucy_Hash_fetch_t method = *((lucy_Hash_fetch_t*)method_address);
    return method((lucy_Hash*)self, key);
}

extern size_t Lucy_ZKHash_Fetch_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Fetch_Str(const lucy_ZombieKeyedHash *self, const char* key, size_t key_len) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Fetch_Str_OFFSET;
    const lucy_Hash_fetch_str_t method = *((lucy_Hash_fetch_str_t*)method_address);
    return method((lucy_Hash*)self, key, key_len);
}

extern size_t Lucy_ZKHash_Delete_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Delete(const lucy_ZombieKeyedHash *self, const lucy_Obj* key) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Delete_OFFSET;
    const lucy_Hash_delete_t method = *((lucy_Hash_delete_t*)method_address);
    return method((lucy_Hash*)self, key);
}

extern size_t Lucy_ZKHash_Delete_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Delete_Str(const lucy_ZombieKeyedHash *self, const char* key, size_t key_ley) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Delete_Str_OFFSET;
    const lucy_Hash_delete_str_t method = *((lucy_Hash_delete_str_t*)method_address);
    return method((lucy_Hash*)self, key, key_ley);
}

extern size_t Lucy_ZKHash_Iterate_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZKHash_Iterate(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Iterate_OFFSET;
    const lucy_Hash_iterate_t method = *((lucy_Hash_iterate_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_ZKHash_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZKHash_Next(const lucy_ZombieKeyedHash *self, lucy_Obj** key, lucy_Obj** value) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Next_OFFSET;
    const lucy_Hash_next_t method = *((lucy_Hash_next_t*)method_address);
    return method((lucy_Hash*)self, key, value);
}

extern size_t Lucy_ZKHash_Find_Key_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Find_Key(const lucy_ZombieKeyedHash *self, const lucy_Obj* key, int32_t hash_sum) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Find_Key_OFFSET;
    const lucy_Hash_find_key_t method = *((lucy_Hash_find_key_t*)method_address);
    return method((lucy_Hash*)self, key, hash_sum);
}

extern size_t Lucy_ZKHash_Keys_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_ZKHash_Keys(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Keys_OFFSET;
    const lucy_Hash_keys_t method = *((lucy_Hash_keys_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_ZKHash_Values_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_ZKHash_Values(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Values_OFFSET;
    const lucy_Hash_values_t method = *((lucy_Hash_values_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_ZKHash_Make_Key_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZKHash_Make_Key(const lucy_ZombieKeyedHash *self, lucy_Obj* key, int32_t hash_sum) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Make_Key_OFFSET;
    const lucy_ZKHash_make_key_t method = *((lucy_ZKHash_make_key_t*)method_address);
    return method((lucy_ZombieKeyedHash*)self, key, hash_sum);
}

extern size_t Lucy_ZKHash_Get_Capacity_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZKHash_Get_Capacity(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Get_Capacity_OFFSET;
    const lucy_Hash_get_capacity_t method = *((lucy_Hash_get_capacity_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_ZKHash_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZKHash_Get_Size(const lucy_ZombieKeyedHash *self) {
    char *const method_address = *(char**)self + Lucy_ZKHash_Get_Size_OFFSET;
    const lucy_Hash_get_size_t method = *((lucy_Hash_get_size_t*)method_address);
    return method((lucy_Hash*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_ZOMBIEKEYEDHASH_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_ZOMBIEKEYEDHASH_VT;
extern struct LUCY_ZOMBIEKEYEDHASH_VT LUCY_ZOMBIEKEYEDHASH_vt;
#define LUCY_ZOMBIEKEYEDHASH ((cfish_VTable*)&LUCY_ZOMBIEKEYEDHASH_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ZombieKeyedHash lucy_ZombieKeyedHash
  #define ZOMBIEKEYEDHASH LUCY_ZOMBIEKEYEDHASH
  #define ZKHash_new lucy_ZKHash_new
  #define ZKHash_destroy_t lucy_ZKHash_destroy_t
  #define ZKHash_destroy lucy_ZKHash_destroy
  #define ZKHash_make_key_t lucy_ZKHash_make_key_t
  #define ZKHash_make_key lucy_ZKHash_make_key
  #define ZKHash_Make Lucy_ZKHash_Make
  #define ZKHash_Get_RefCount Lucy_ZKHash_Get_RefCount
  #define ZKHash_Inc_RefCount Lucy_ZKHash_Inc_RefCount
  #define ZKHash_Dec_RefCount Lucy_ZKHash_Dec_RefCount
  #define ZKHash_To_Host Lucy_ZKHash_To_Host
  #define ZKHash_Clone Lucy_ZKHash_Clone
  #define ZKHash_Destroy Lucy_ZKHash_Destroy
  #define ZKHash_Equals Lucy_ZKHash_Equals
  #define ZKHash_Compare_To Lucy_ZKHash_Compare_To
  #define ZKHash_Hash_Sum Lucy_ZKHash_Hash_Sum
  #define ZKHash_Get_VTable Lucy_ZKHash_Get_VTable
  #define ZKHash_Get_Class_Name Lucy_ZKHash_Get_Class_Name
  #define ZKHash_Is_A Lucy_ZKHash_Is_A
  #define ZKHash_To_String Lucy_ZKHash_To_String
  #define ZKHash_To_I64 Lucy_ZKHash_To_I64
  #define ZKHash_To_F64 Lucy_ZKHash_To_F64
  #define ZKHash_To_Bool Lucy_ZKHash_To_Bool
  #define ZKHash_Serialize Lucy_ZKHash_Serialize
  #define ZKHash_Deserialize Lucy_ZKHash_Deserialize
  #define ZKHash_Dump Lucy_ZKHash_Dump
  #define ZKHash_Load Lucy_ZKHash_Load
  #define ZKHash_Mimic Lucy_ZKHash_Mimic
  #define ZKHash_Clear Lucy_ZKHash_Clear
  #define ZKHash_Store Lucy_ZKHash_Store
  #define ZKHash_Store_Str Lucy_ZKHash_Store_Str
  #define ZKHash_Fetch Lucy_ZKHash_Fetch
  #define ZKHash_Fetch_Str Lucy_ZKHash_Fetch_Str
  #define ZKHash_Delete Lucy_ZKHash_Delete
  #define ZKHash_Delete_Str Lucy_ZKHash_Delete_Str
  #define ZKHash_Iterate Lucy_ZKHash_Iterate
  #define ZKHash_Next Lucy_ZKHash_Next
  #define ZKHash_Find_Key Lucy_ZKHash_Find_Key
  #define ZKHash_Keys Lucy_ZKHash_Keys
  #define ZKHash_Values Lucy_ZKHash_Values
  #define ZKHash_Make_Key Lucy_ZKHash_Make_Key
  #define ZKHash_Get_Capacity Lucy_ZKHash_Get_Capacity
  #define ZKHash_Get_Size Lucy_ZKHash_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_ZOMBIEKEYEDHASH */




