/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_BITVECTOR
#define H_LUCY_OBJECT_BITVECTOR 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_BITVECTOR
struct lucy_BitVector {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t cap;
    uint8_t* bits;
};

#endif /* C_LUCY_BITVECTOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_BitVector*
lucy_BitVec_new(uint32_t capacity);

lucy_BitVector*
lucy_BitVec_init(lucy_BitVector* self, uint32_t capacity);

lucy_BitVector*
lucy_BitVec_clone(lucy_BitVector* self);

void
lucy_BitVec_destroy(lucy_BitVector* self);

void
lucy_BitVec_mimic(lucy_BitVector* self, lucy_Obj* other);

chy_bool_t
lucy_BitVec_get(lucy_BitVector* self, uint32_t tick);

void
lucy_BitVec_set(lucy_BitVector* self, uint32_t tick);

uint8_t*
lucy_BitVec_get_raw_bits(lucy_BitVector* self);

uint32_t
lucy_BitVec_get_capacity(lucy_BitVector* self);

int32_t
lucy_BitVec_next_hit(lucy_BitVector* self, uint32_t tick);

void
lucy_BitVec_clear(lucy_BitVector* self, uint32_t tick);

void
lucy_BitVec_clear_all(lucy_BitVector* self);

void
lucy_BitVec_grow(lucy_BitVector* self, uint32_t capacity);

void
lucy_BitVec_and(lucy_BitVector* self, const lucy_BitVector* other);

void
lucy_BitVec_or(lucy_BitVector* self, const lucy_BitVector* other);

void
lucy_BitVec_xor(lucy_BitVector* self, const lucy_BitVector* other);

void
lucy_BitVec_and_not(lucy_BitVector* self, const lucy_BitVector* other);

void
lucy_BitVec_flip(lucy_BitVector* self, uint32_t tick);

void
lucy_BitVec_flip_block(lucy_BitVector* self, uint32_t offset, uint32_t length);

uint32_t
lucy_BitVec_count(lucy_BitVector* self);

lucy_I32Array*
lucy_BitVec_to_array(lucy_BitVector* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_BitVec_clone_CALLBACK;
extern cfish_Callback lucy_BitVec_destroy_CALLBACK;
extern cfish_Callback lucy_BitVec_mimic_CALLBACK;
extern cfish_Callback lucy_BitVec_get_CALLBACK;
extern cfish_Callback lucy_BitVec_set_CALLBACK;
extern cfish_Callback lucy_BitVec_next_hit_CALLBACK;
extern cfish_Callback lucy_BitVec_clear_CALLBACK;
extern cfish_Callback lucy_BitVec_clear_all_CALLBACK;
extern cfish_Callback lucy_BitVec_grow_CALLBACK;
extern cfish_Callback lucy_BitVec_and_CALLBACK;
extern cfish_Callback lucy_BitVec_or_CALLBACK;
extern cfish_Callback lucy_BitVec_xor_CALLBACK;
extern cfish_Callback lucy_BitVec_and_not_CALLBACK;
extern cfish_Callback lucy_BitVec_flip_CALLBACK;
extern cfish_Callback lucy_BitVec_flip_block_CALLBACK;
extern cfish_Callback lucy_BitVec_count_CALLBACK;
extern cfish_Callback lucy_BitVec_to_array_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_BitVector*
(*lucy_BitVec_clone_t)(lucy_BitVector* self);

typedef void
(*lucy_BitVec_destroy_t)(lucy_BitVector* self);

typedef void
(*lucy_BitVec_mimic_t)(lucy_BitVector* self, lucy_Obj* other);

typedef chy_bool_t
(*lucy_BitVec_get_t)(lucy_BitVector* self, uint32_t tick);

typedef void
(*lucy_BitVec_set_t)(lucy_BitVector* self, uint32_t tick);

typedef uint8_t*
(*lucy_BitVec_get_raw_bits_t)(lucy_BitVector* self);

typedef uint32_t
(*lucy_BitVec_get_capacity_t)(lucy_BitVector* self);

typedef int32_t
(*lucy_BitVec_next_hit_t)(lucy_BitVector* self, uint32_t tick);

typedef void
(*lucy_BitVec_clear_t)(lucy_BitVector* self, uint32_t tick);

typedef void
(*lucy_BitVec_clear_all_t)(lucy_BitVector* self);

typedef void
(*lucy_BitVec_grow_t)(lucy_BitVector* self, uint32_t capacity);

typedef void
(*lucy_BitVec_and_t)(lucy_BitVector* self, const lucy_BitVector* other);

typedef void
(*lucy_BitVec_or_t)(lucy_BitVector* self, const lucy_BitVector* other);

typedef void
(*lucy_BitVec_xor_t)(lucy_BitVector* self, const lucy_BitVector* other);

typedef void
(*lucy_BitVec_and_not_t)(lucy_BitVector* self, const lucy_BitVector* other);

typedef void
(*lucy_BitVec_flip_t)(lucy_BitVector* self, uint32_t tick);

typedef void
(*lucy_BitVec_flip_block_t)(lucy_BitVector* self, uint32_t offset, uint32_t length);

typedef uint32_t
(*lucy_BitVec_count_t)(lucy_BitVector* self);

typedef lucy_I32Array*
(*lucy_BitVec_to_array_t)(lucy_BitVector* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_BitVec_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BitVec_Make(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BitVec_Get_RefCount(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BitVec_Inc_RefCount(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BitVec_Dec_RefCount(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_BitVec_To_Host(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Clone_OFFSET;
static CHY_INLINE lucy_BitVector*
Lucy_BitVec_Clone(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Clone_OFFSET;
    const lucy_BitVec_clone_t method = *((lucy_BitVec_clone_t*)method_address);
    return method((lucy_BitVector*)self);
}

extern size_t Lucy_BitVec_Destroy_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Destroy(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Destroy_OFFSET;
    const lucy_BitVec_destroy_t method = *((lucy_BitVec_destroy_t*)method_address);
    method((lucy_BitVector*)self);
}

extern size_t Lucy_BitVec_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BitVec_Equals(const lucy_BitVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_BitVec_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_BitVec_Compare_To(const lucy_BitVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_BitVec_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_BitVec_Hash_Sum(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_BitVec_Get_VTable(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BitVec_Get_Class_Name(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BitVec_Is_A(const lucy_BitVector *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_BitVec_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_BitVec_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BitVec_To_String(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_BitVec_To_I64(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_To_F64_OFFSET;
static CHY_INLINE double
Lucy_BitVec_To_F64(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BitVec_To_Bool(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Serialize_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Serialize(const lucy_BitVector *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_BitVec_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_BitVec_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BitVec_Deserialize(const lucy_BitVector *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_BitVec_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_BitVec_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BitVec_Dump(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BitVec_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BitVec_Load(const lucy_BitVector *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_BitVec_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_BitVec_Mimic_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Mimic(const lucy_BitVector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_Mimic_OFFSET;
    const lucy_BitVec_mimic_t method = *((lucy_BitVec_mimic_t*)method_address);
    method((lucy_BitVector*)self, other);
}

extern size_t Lucy_BitVec_Get_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BitVec_Get(const lucy_BitVector *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_BitVec_Get_OFFSET;
    const lucy_BitVec_get_t method = *((lucy_BitVec_get_t*)method_address);
    return method((lucy_BitVector*)self, tick);
}

extern size_t Lucy_BitVec_Set_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Set(const lucy_BitVector *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_BitVec_Set_OFFSET;
    const lucy_BitVec_set_t method = *((lucy_BitVec_set_t*)method_address);
    method((lucy_BitVector*)self, tick);
}

extern size_t Lucy_BitVec_Get_Raw_Bits_OFFSET;
static CHY_INLINE uint8_t*
Lucy_BitVec_Get_Raw_Bits(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Get_Raw_Bits_OFFSET;
    const lucy_BitVec_get_raw_bits_t method = *((lucy_BitVec_get_raw_bits_t*)method_address);
    return method((lucy_BitVector*)self);
}

extern size_t Lucy_BitVec_Get_Capacity_OFFSET;
static CHY_INLINE uint32_t
Lucy_BitVec_Get_Capacity(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Get_Capacity_OFFSET;
    const lucy_BitVec_get_capacity_t method = *((lucy_BitVec_get_capacity_t*)method_address);
    return method((lucy_BitVector*)self);
}

extern size_t Lucy_BitVec_Next_Hit_OFFSET;
static CHY_INLINE int32_t
Lucy_BitVec_Next_Hit(const lucy_BitVector *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_BitVec_Next_Hit_OFFSET;
    const lucy_BitVec_next_hit_t method = *((lucy_BitVec_next_hit_t*)method_address);
    return method((lucy_BitVector*)self, tick);
}

extern size_t Lucy_BitVec_Clear_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Clear(const lucy_BitVector *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_BitVec_Clear_OFFSET;
    const lucy_BitVec_clear_t method = *((lucy_BitVec_clear_t*)method_address);
    method((lucy_BitVector*)self, tick);
}

extern size_t Lucy_BitVec_Clear_All_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Clear_All(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Clear_All_OFFSET;
    const lucy_BitVec_clear_all_t method = *((lucy_BitVec_clear_all_t*)method_address);
    method((lucy_BitVector*)self);
}

extern size_t Lucy_BitVec_Grow_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Grow(const lucy_BitVector *self, uint32_t capacity) {
    char *const method_address = *(char**)self + Lucy_BitVec_Grow_OFFSET;
    const lucy_BitVec_grow_t method = *((lucy_BitVec_grow_t*)method_address);
    method((lucy_BitVector*)self, capacity);
}

extern size_t Lucy_BitVec_And_OFFSET;
static CHY_INLINE void
Lucy_BitVec_And(const lucy_BitVector *self, const lucy_BitVector* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_And_OFFSET;
    const lucy_BitVec_and_t method = *((lucy_BitVec_and_t*)method_address);
    method((lucy_BitVector*)self, other);
}

extern size_t Lucy_BitVec_Or_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Or(const lucy_BitVector *self, const lucy_BitVector* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_Or_OFFSET;
    const lucy_BitVec_or_t method = *((lucy_BitVec_or_t*)method_address);
    method((lucy_BitVector*)self, other);
}

extern size_t Lucy_BitVec_Xor_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Xor(const lucy_BitVector *self, const lucy_BitVector* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_Xor_OFFSET;
    const lucy_BitVec_xor_t method = *((lucy_BitVec_xor_t*)method_address);
    method((lucy_BitVector*)self, other);
}

extern size_t Lucy_BitVec_And_Not_OFFSET;
static CHY_INLINE void
Lucy_BitVec_And_Not(const lucy_BitVector *self, const lucy_BitVector* other) {
    char *const method_address = *(char**)self + Lucy_BitVec_And_Not_OFFSET;
    const lucy_BitVec_and_not_t method = *((lucy_BitVec_and_not_t*)method_address);
    method((lucy_BitVector*)self, other);
}

extern size_t Lucy_BitVec_Flip_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Flip(const lucy_BitVector *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_BitVec_Flip_OFFSET;
    const lucy_BitVec_flip_t method = *((lucy_BitVec_flip_t*)method_address);
    method((lucy_BitVector*)self, tick);
}

extern size_t Lucy_BitVec_Flip_Block_OFFSET;
static CHY_INLINE void
Lucy_BitVec_Flip_Block(const lucy_BitVector *self, uint32_t offset, uint32_t length) {
    char *const method_address = *(char**)self + Lucy_BitVec_Flip_Block_OFFSET;
    const lucy_BitVec_flip_block_t method = *((lucy_BitVec_flip_block_t*)method_address);
    method((lucy_BitVector*)self, offset, length);
}

extern size_t Lucy_BitVec_Count_OFFSET;
static CHY_INLINE uint32_t
Lucy_BitVec_Count(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_Count_OFFSET;
    const lucy_BitVec_count_t method = *((lucy_BitVec_count_t*)method_address);
    return method((lucy_BitVector*)self);
}

extern size_t Lucy_BitVec_To_Array_OFFSET;
static CHY_INLINE lucy_I32Array*
Lucy_BitVec_To_Array(const lucy_BitVector *self) {
    char *const method_address = *(char**)self + Lucy_BitVec_To_Array_OFFSET;
    const lucy_BitVec_to_array_t method = *((lucy_BitVec_to_array_t*)method_address);
    return method((lucy_BitVector*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_BITVECTOR_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[38];
} LUCY_BITVECTOR_VT;
extern struct LUCY_BITVECTOR_VT LUCY_BITVECTOR_vt;
#define LUCY_BITVECTOR ((cfish_VTable*)&LUCY_BITVECTOR_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define BitVector lucy_BitVector
  #define BITVECTOR LUCY_BITVECTOR
  #define BitVec_new lucy_BitVec_new
  #define BitVec_init lucy_BitVec_init
  #define BitVec_clone_t lucy_BitVec_clone_t
  #define BitVec_clone lucy_BitVec_clone
  #define BitVec_destroy_t lucy_BitVec_destroy_t
  #define BitVec_destroy lucy_BitVec_destroy
  #define BitVec_mimic_t lucy_BitVec_mimic_t
  #define BitVec_mimic lucy_BitVec_mimic
  #define BitVec_get_t lucy_BitVec_get_t
  #define BitVec_get lucy_BitVec_get
  #define BitVec_set_t lucy_BitVec_set_t
  #define BitVec_set lucy_BitVec_set
  #define BitVec_get_raw_bits_t lucy_BitVec_get_raw_bits_t
  #define BitVec_get_raw_bits lucy_BitVec_get_raw_bits
  #define BitVec_get_capacity_t lucy_BitVec_get_capacity_t
  #define BitVec_get_capacity lucy_BitVec_get_capacity
  #define BitVec_next_hit_t lucy_BitVec_next_hit_t
  #define BitVec_next_hit lucy_BitVec_next_hit
  #define BitVec_clear_t lucy_BitVec_clear_t
  #define BitVec_clear lucy_BitVec_clear
  #define BitVec_clear_all_t lucy_BitVec_clear_all_t
  #define BitVec_clear_all lucy_BitVec_clear_all
  #define BitVec_grow_t lucy_BitVec_grow_t
  #define BitVec_grow lucy_BitVec_grow
  #define BitVec_and_t lucy_BitVec_and_t
  #define BitVec_and lucy_BitVec_and
  #define BitVec_or_t lucy_BitVec_or_t
  #define BitVec_or lucy_BitVec_or
  #define BitVec_xor_t lucy_BitVec_xor_t
  #define BitVec_xor lucy_BitVec_xor
  #define BitVec_and_not_t lucy_BitVec_and_not_t
  #define BitVec_and_not lucy_BitVec_and_not
  #define BitVec_flip_t lucy_BitVec_flip_t
  #define BitVec_flip lucy_BitVec_flip
  #define BitVec_flip_block_t lucy_BitVec_flip_block_t
  #define BitVec_flip_block lucy_BitVec_flip_block
  #define BitVec_count_t lucy_BitVec_count_t
  #define BitVec_count lucy_BitVec_count
  #define BitVec_to_array_t lucy_BitVec_to_array_t
  #define BitVec_to_array lucy_BitVec_to_array
  #define BitVec_Make Lucy_BitVec_Make
  #define BitVec_Get_RefCount Lucy_BitVec_Get_RefCount
  #define BitVec_Inc_RefCount Lucy_BitVec_Inc_RefCount
  #define BitVec_Dec_RefCount Lucy_BitVec_Dec_RefCount
  #define BitVec_To_Host Lucy_BitVec_To_Host
  #define BitVec_Clone Lucy_BitVec_Clone
  #define BitVec_Destroy Lucy_BitVec_Destroy
  #define BitVec_Equals Lucy_BitVec_Equals
  #define BitVec_Compare_To Lucy_BitVec_Compare_To
  #define BitVec_Hash_Sum Lucy_BitVec_Hash_Sum
  #define BitVec_Get_VTable Lucy_BitVec_Get_VTable
  #define BitVec_Get_Class_Name Lucy_BitVec_Get_Class_Name
  #define BitVec_Is_A Lucy_BitVec_Is_A
  #define BitVec_To_String Lucy_BitVec_To_String
  #define BitVec_To_I64 Lucy_BitVec_To_I64
  #define BitVec_To_F64 Lucy_BitVec_To_F64
  #define BitVec_To_Bool Lucy_BitVec_To_Bool
  #define BitVec_Serialize Lucy_BitVec_Serialize
  #define BitVec_Deserialize Lucy_BitVec_Deserialize
  #define BitVec_Dump Lucy_BitVec_Dump
  #define BitVec_Load Lucy_BitVec_Load
  #define BitVec_Mimic Lucy_BitVec_Mimic
  #define BitVec_Get Lucy_BitVec_Get
  #define BitVec_Set Lucy_BitVec_Set
  #define BitVec_Get_Raw_Bits Lucy_BitVec_Get_Raw_Bits
  #define BitVec_Get_Capacity Lucy_BitVec_Get_Capacity
  #define BitVec_Next_Hit Lucy_BitVec_Next_Hit
  #define BitVec_Clear Lucy_BitVec_Clear
  #define BitVec_Clear_All Lucy_BitVec_Clear_All
  #define BitVec_Grow Lucy_BitVec_Grow
  #define BitVec_And Lucy_BitVec_And
  #define BitVec_Or Lucy_BitVec_Or
  #define BitVec_Xor Lucy_BitVec_Xor
  #define BitVec_And_Not Lucy_BitVec_And_Not
  #define BitVec_Flip Lucy_BitVec_Flip
  #define BitVec_Flip_Block Lucy_BitVec_Flip_Block
  #define BitVec_Count Lucy_BitVec_Count
  #define BitVec_To_Array Lucy_BitVec_To_Array
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_BITVECTOR */




