/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_BYTEBUF
#define H_LUCY_OBJECT_BYTEBUF 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_BYTEBUF
struct lucy_ByteBuf {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* buf;
    size_t size;
    size_t cap;
};

#endif /* C_LUCY_BYTEBUF */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ByteBuf*
lucy_BB_new(size_t capacity);

lucy_ByteBuf*
lucy_BB_init(lucy_ByteBuf* self, size_t capacity);

lucy_ByteBuf*
lucy_BB_new_bytes(const void* bytes, size_t size);

lucy_ByteBuf*
lucy_BB_new_steal_bytes(void* bytes, size_t size, size_t capacity);

int
lucy_BB_compare(const void* va, const void* vb);

lucy_ByteBuf*
lucy_BB_clone(lucy_ByteBuf* self);

void
lucy_BB_destroy(lucy_ByteBuf* self);

chy_bool_t
lucy_BB_equals(lucy_ByteBuf* self, lucy_Obj* other);

int32_t
lucy_BB_compare_to(lucy_ByteBuf* self, lucy_Obj* other);

int32_t
lucy_BB_hash_sum(lucy_ByteBuf* self);

void
lucy_BB_serialize(lucy_ByteBuf* self, lucy_OutStream* outstream);

lucy_ByteBuf*
lucy_BB_deserialize(lucy_ByteBuf* self, lucy_InStream* instream);

void
lucy_BB_mimic(lucy_ByteBuf* self, lucy_Obj* other);

void
lucy_BB_set_size(lucy_ByteBuf* self, size_t size);

size_t
lucy_BB_get_size(lucy_ByteBuf* self);

char*
lucy_BB_get_buf(lucy_ByteBuf* self);

size_t
lucy_BB_get_capacity(lucy_ByteBuf* self);

void
lucy_BB_mimic_bytes(lucy_ByteBuf* self, const void* bytes, size_t size);

void
lucy_BB_cat_bytes(lucy_ByteBuf* self, const void* bytes, size_t size);

void
lucy_BB_cat(lucy_ByteBuf* self, const lucy_ByteBuf* other);

char*
lucy_BB_grow(lucy_ByteBuf* self, size_t size);

chy_bool_t
lucy_BB_equals_bytes(lucy_ByteBuf* self, const void* bytes, size_t size);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_BB_clone_CALLBACK;
extern cfish_Callback lucy_BB_destroy_CALLBACK;
extern cfish_Callback lucy_BB_equals_CALLBACK;
extern cfish_Callback lucy_BB_compare_to_CALLBACK;
extern cfish_Callback lucy_BB_hash_sum_CALLBACK;
extern cfish_Callback lucy_BB_serialize_CALLBACK;
extern cfish_Callback lucy_BB_deserialize_CALLBACK;
extern cfish_Callback lucy_BB_mimic_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_ByteBuf*
(*lucy_BB_clone_t)(lucy_ByteBuf* self);

typedef void
(*lucy_BB_destroy_t)(lucy_ByteBuf* self);

typedef chy_bool_t
(*lucy_BB_equals_t)(lucy_ByteBuf* self, lucy_Obj* other);

typedef int32_t
(*lucy_BB_compare_to_t)(lucy_ByteBuf* self, lucy_Obj* other);

typedef int32_t
(*lucy_BB_hash_sum_t)(lucy_ByteBuf* self);

typedef void
(*lucy_BB_serialize_t)(lucy_ByteBuf* self, lucy_OutStream* outstream);

typedef lucy_ByteBuf*
(*lucy_BB_deserialize_t)(lucy_ByteBuf* self, lucy_InStream* instream);

typedef void
(*lucy_BB_mimic_t)(lucy_ByteBuf* self, lucy_Obj* other);

typedef void
(*lucy_BB_set_size_t)(lucy_ByteBuf* self, size_t size);

typedef size_t
(*lucy_BB_get_size_t)(lucy_ByteBuf* self);

typedef char*
(*lucy_BB_get_buf_t)(lucy_ByteBuf* self);

typedef size_t
(*lucy_BB_get_capacity_t)(lucy_ByteBuf* self);

typedef void
(*lucy_BB_mimic_bytes_t)(lucy_ByteBuf* self, const void* bytes, size_t size);

typedef void
(*lucy_BB_cat_bytes_t)(lucy_ByteBuf* self, const void* bytes, size_t size);

typedef void
(*lucy_BB_cat_t)(lucy_ByteBuf* self, const lucy_ByteBuf* other);

typedef char*
(*lucy_BB_grow_t)(lucy_ByteBuf* self, size_t size);

typedef chy_bool_t
(*lucy_BB_equals_bytes_t)(lucy_ByteBuf* self, const void* bytes, size_t size);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_BB_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BB_Make(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BB_Get_RefCount(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BB_Inc_RefCount(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BB_Dec_RefCount(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_BB_To_Host(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Clone_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_BB_Clone(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Clone_OFFSET;
    const lucy_BB_clone_t method = *((lucy_BB_clone_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_BB_Destroy_OFFSET;
static CHY_INLINE void
Lucy_BB_Destroy(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Destroy_OFFSET;
    const lucy_BB_destroy_t method = *((lucy_BB_destroy_t*)method_address);
    method((lucy_ByteBuf*)self);
}

extern size_t Lucy_BB_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BB_Equals(const lucy_ByteBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BB_Equals_OFFSET;
    const lucy_BB_equals_t method = *((lucy_BB_equals_t*)method_address);
    return method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_BB_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_BB_Compare_To(const lucy_ByteBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BB_Compare_To_OFFSET;
    const lucy_BB_compare_to_t method = *((lucy_BB_compare_to_t*)method_address);
    return method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_BB_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_BB_Hash_Sum(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Hash_Sum_OFFSET;
    const lucy_BB_hash_sum_t method = *((lucy_BB_hash_sum_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_BB_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_BB_Get_VTable(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BB_Get_Class_Name(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BB_Is_A(const lucy_ByteBuf *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_BB_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_BB_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BB_To_String(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_BB_To_I64(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_To_F64_OFFSET;
static CHY_INLINE double
Lucy_BB_To_F64(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BB_To_Bool(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Serialize_OFFSET;
static CHY_INLINE void
Lucy_BB_Serialize(const lucy_ByteBuf *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_BB_Serialize_OFFSET;
    const lucy_BB_serialize_t method = *((lucy_BB_serialize_t*)method_address);
    method((lucy_ByteBuf*)self, outstream);
}

extern size_t Lucy_BB_Deserialize_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_BB_Deserialize(const lucy_ByteBuf *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_BB_Deserialize_OFFSET;
    const lucy_BB_deserialize_t method = *((lucy_BB_deserialize_t*)method_address);
    return method((lucy_ByteBuf*)self, instream);
}

extern size_t Lucy_BB_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BB_Dump(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BB_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BB_Load(const lucy_ByteBuf *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_BB_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_BB_Mimic_OFFSET;
static CHY_INLINE void
Lucy_BB_Mimic(const lucy_ByteBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BB_Mimic_OFFSET;
    const lucy_BB_mimic_t method = *((lucy_BB_mimic_t*)method_address);
    method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_BB_Set_Size_OFFSET;
static CHY_INLINE void
Lucy_BB_Set_Size(const lucy_ByteBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_BB_Set_Size_OFFSET;
    const lucy_BB_set_size_t method = *((lucy_BB_set_size_t*)method_address);
    method((lucy_ByteBuf*)self, size);
}

extern size_t Lucy_BB_Get_Size_OFFSET;
static CHY_INLINE size_t
Lucy_BB_Get_Size(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Get_Size_OFFSET;
    const lucy_BB_get_size_t method = *((lucy_BB_get_size_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_BB_Get_Buf_OFFSET;
static CHY_INLINE char*
Lucy_BB_Get_Buf(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Get_Buf_OFFSET;
    const lucy_BB_get_buf_t method = *((lucy_BB_get_buf_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_BB_Get_Capacity_OFFSET;
static CHY_INLINE size_t
Lucy_BB_Get_Capacity(const lucy_ByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_BB_Get_Capacity_OFFSET;
    const lucy_BB_get_capacity_t method = *((lucy_BB_get_capacity_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_BB_Mimic_Bytes_OFFSET;
static CHY_INLINE void
Lucy_BB_Mimic_Bytes(const lucy_ByteBuf *self, const void* bytes, size_t size) {
    char *const method_address = *(char**)self + Lucy_BB_Mimic_Bytes_OFFSET;
    const lucy_BB_mimic_bytes_t method = *((lucy_BB_mimic_bytes_t*)method_address);
    method((lucy_ByteBuf*)self, bytes, size);
}

extern size_t Lucy_BB_Cat_Bytes_OFFSET;
static CHY_INLINE void
Lucy_BB_Cat_Bytes(const lucy_ByteBuf *self, const void* bytes, size_t size) {
    char *const method_address = *(char**)self + Lucy_BB_Cat_Bytes_OFFSET;
    const lucy_BB_cat_bytes_t method = *((lucy_BB_cat_bytes_t*)method_address);
    method((lucy_ByteBuf*)self, bytes, size);
}

extern size_t Lucy_BB_Cat_OFFSET;
static CHY_INLINE void
Lucy_BB_Cat(const lucy_ByteBuf *self, const lucy_ByteBuf* other) {
    char *const method_address = *(char**)self + Lucy_BB_Cat_OFFSET;
    const lucy_BB_cat_t method = *((lucy_BB_cat_t*)method_address);
    method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_BB_Grow_OFFSET;
static CHY_INLINE char*
Lucy_BB_Grow(const lucy_ByteBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_BB_Grow_OFFSET;
    const lucy_BB_grow_t method = *((lucy_BB_grow_t*)method_address);
    return method((lucy_ByteBuf*)self, size);
}

extern size_t Lucy_BB_Equals_Bytes_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BB_Equals_Bytes(const lucy_ByteBuf *self, const void* bytes, size_t size) {
    char *const method_address = *(char**)self + Lucy_BB_Equals_Bytes_OFFSET;
    const lucy_BB_equals_bytes_t method = *((lucy_BB_equals_bytes_t*)method_address);
    return method((lucy_ByteBuf*)self, bytes, size);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_BYTEBUF_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_BYTEBUF_VT;
extern struct LUCY_BYTEBUF_VT LUCY_BYTEBUF_vt;
#define LUCY_BYTEBUF ((cfish_VTable*)&LUCY_BYTEBUF_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ByteBuf lucy_ByteBuf
  #define BYTEBUF LUCY_BYTEBUF
  #define BB_new lucy_BB_new
  #define BB_init lucy_BB_init
  #define BB_new_bytes lucy_BB_new_bytes
  #define BB_new_steal_bytes lucy_BB_new_steal_bytes
  #define BB_compare lucy_BB_compare
  #define BB_clone_t lucy_BB_clone_t
  #define BB_clone lucy_BB_clone
  #define BB_destroy_t lucy_BB_destroy_t
  #define BB_destroy lucy_BB_destroy
  #define BB_equals_t lucy_BB_equals_t
  #define BB_equals lucy_BB_equals
  #define BB_compare_to_t lucy_BB_compare_to_t
  #define BB_compare_to lucy_BB_compare_to
  #define BB_hash_sum_t lucy_BB_hash_sum_t
  #define BB_hash_sum lucy_BB_hash_sum
  #define BB_serialize_t lucy_BB_serialize_t
  #define BB_serialize lucy_BB_serialize
  #define BB_deserialize_t lucy_BB_deserialize_t
  #define BB_deserialize lucy_BB_deserialize
  #define BB_mimic_t lucy_BB_mimic_t
  #define BB_mimic lucy_BB_mimic
  #define BB_set_size_t lucy_BB_set_size_t
  #define BB_set_size lucy_BB_set_size
  #define BB_get_size_t lucy_BB_get_size_t
  #define BB_get_size lucy_BB_get_size
  #define BB_get_buf_t lucy_BB_get_buf_t
  #define BB_get_buf lucy_BB_get_buf
  #define BB_get_capacity_t lucy_BB_get_capacity_t
  #define BB_get_capacity lucy_BB_get_capacity
  #define BB_mimic_bytes_t lucy_BB_mimic_bytes_t
  #define BB_mimic_bytes lucy_BB_mimic_bytes
  #define BB_cat_bytes_t lucy_BB_cat_bytes_t
  #define BB_cat_bytes lucy_BB_cat_bytes
  #define BB_cat_t lucy_BB_cat_t
  #define BB_cat lucy_BB_cat
  #define BB_grow_t lucy_BB_grow_t
  #define BB_grow lucy_BB_grow
  #define BB_equals_bytes_t lucy_BB_equals_bytes_t
  #define BB_equals_bytes lucy_BB_equals_bytes
  #define BB_Make Lucy_BB_Make
  #define BB_Get_RefCount Lucy_BB_Get_RefCount
  #define BB_Inc_RefCount Lucy_BB_Inc_RefCount
  #define BB_Dec_RefCount Lucy_BB_Dec_RefCount
  #define BB_To_Host Lucy_BB_To_Host
  #define BB_Clone Lucy_BB_Clone
  #define BB_Destroy Lucy_BB_Destroy
  #define BB_Equals Lucy_BB_Equals
  #define BB_Compare_To Lucy_BB_Compare_To
  #define BB_Hash_Sum Lucy_BB_Hash_Sum
  #define BB_Get_VTable Lucy_BB_Get_VTable
  #define BB_Get_Class_Name Lucy_BB_Get_Class_Name
  #define BB_Is_A Lucy_BB_Is_A
  #define BB_To_String Lucy_BB_To_String
  #define BB_To_I64 Lucy_BB_To_I64
  #define BB_To_F64 Lucy_BB_To_F64
  #define BB_To_Bool Lucy_BB_To_Bool
  #define BB_Serialize Lucy_BB_Serialize
  #define BB_Deserialize Lucy_BB_Deserialize
  #define BB_Dump Lucy_BB_Dump
  #define BB_Load Lucy_BB_Load
  #define BB_Mimic Lucy_BB_Mimic
  #define BB_Set_Size Lucy_BB_Set_Size
  #define BB_Get_Size Lucy_BB_Get_Size
  #define BB_Get_Buf Lucy_BB_Get_Buf
  #define BB_Get_Capacity Lucy_BB_Get_Capacity
  #define BB_Mimic_Bytes Lucy_BB_Mimic_Bytes
  #define BB_Cat_Bytes Lucy_BB_Cat_Bytes
  #define BB_Cat Lucy_BB_Cat
  #define BB_Grow Lucy_BB_Grow
  #define BB_Equals_Bytes Lucy_BB_Equals_Bytes
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/ByteBuf.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_VIEWBYTEBUF
struct lucy_ViewByteBuf {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* buf;
    size_t size;
    size_t cap;
};

#endif /* C_LUCY_VIEWBYTEBUF */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ViewByteBuf*
lucy_ViewBB_new(char* buf, size_t size);

lucy_ViewByteBuf*
lucy_ViewBB_init(lucy_ViewByteBuf* self, char* buf, size_t size);

void
lucy_ViewBB_destroy(lucy_ViewByteBuf* self);

void
lucy_ViewBB_assign_bytes(lucy_ViewByteBuf* self, char* buf, size_t size);

void
lucy_ViewBB_assign(lucy_ViewByteBuf* self, const lucy_ByteBuf* other);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ViewBB_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ViewBB_destroy_t)(lucy_ViewByteBuf* self);

typedef void
(*lucy_ViewBB_assign_bytes_t)(lucy_ViewByteBuf* self, char* buf, size_t size);

typedef void
(*lucy_ViewBB_assign_t)(lucy_ViewByteBuf* self, const lucy_ByteBuf* other);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ViewBB_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewBB_Make(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewBB_Get_RefCount(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewBB_Inc_RefCount(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewBB_Dec_RefCount(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ViewBB_To_Host(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Clone_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_ViewBB_Clone(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Clone_OFFSET;
    const lucy_BB_clone_t method = *((lucy_BB_clone_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_ViewBB_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Destroy(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Destroy_OFFSET;
    const lucy_ViewBB_destroy_t method = *((lucy_ViewBB_destroy_t*)method_address);
    method((lucy_ViewByteBuf*)self);
}

extern size_t Lucy_ViewBB_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewBB_Equals(const lucy_ViewByteBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Equals_OFFSET;
    const lucy_BB_equals_t method = *((lucy_BB_equals_t*)method_address);
    return method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_ViewBB_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ViewBB_Compare_To(const lucy_ViewByteBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Compare_To_OFFSET;
    const lucy_BB_compare_to_t method = *((lucy_BB_compare_to_t*)method_address);
    return method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_ViewBB_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ViewBB_Hash_Sum(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Hash_Sum_OFFSET;
    const lucy_BB_hash_sum_t method = *((lucy_BB_hash_sum_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_ViewBB_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ViewBB_Get_VTable(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewBB_Get_Class_Name(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewBB_Is_A(const lucy_ViewByteBuf *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ViewBB_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewBB_To_String(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ViewBB_To_I64(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ViewBB_To_F64(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewBB_To_Bool(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Serialize(const lucy_ViewByteBuf *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Serialize_OFFSET;
    const lucy_BB_serialize_t method = *((lucy_BB_serialize_t*)method_address);
    method((lucy_ByteBuf*)self, outstream);
}

extern size_t Lucy_ViewBB_Deserialize_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_ViewBB_Deserialize(const lucy_ViewByteBuf *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Deserialize_OFFSET;
    const lucy_BB_deserialize_t method = *((lucy_BB_deserialize_t*)method_address);
    return method((lucy_ByteBuf*)self, instream);
}

extern size_t Lucy_ViewBB_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewBB_Dump(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewBB_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewBB_Load(const lucy_ViewByteBuf *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ViewBB_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Mimic(const lucy_ViewByteBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Mimic_OFFSET;
    const lucy_BB_mimic_t method = *((lucy_BB_mimic_t*)method_address);
    method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_ViewBB_Set_Size_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Set_Size(const lucy_ViewByteBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Set_Size_OFFSET;
    const lucy_BB_set_size_t method = *((lucy_BB_set_size_t*)method_address);
    method((lucy_ByteBuf*)self, size);
}

extern size_t Lucy_ViewBB_Get_Size_OFFSET;
static CHY_INLINE size_t
Lucy_ViewBB_Get_Size(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Get_Size_OFFSET;
    const lucy_BB_get_size_t method = *((lucy_BB_get_size_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_ViewBB_Get_Buf_OFFSET;
static CHY_INLINE char*
Lucy_ViewBB_Get_Buf(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Get_Buf_OFFSET;
    const lucy_BB_get_buf_t method = *((lucy_BB_get_buf_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_ViewBB_Get_Capacity_OFFSET;
static CHY_INLINE size_t
Lucy_ViewBB_Get_Capacity(const lucy_ViewByteBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Get_Capacity_OFFSET;
    const lucy_BB_get_capacity_t method = *((lucy_BB_get_capacity_t*)method_address);
    return method((lucy_ByteBuf*)self);
}

extern size_t Lucy_ViewBB_Mimic_Bytes_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Mimic_Bytes(const lucy_ViewByteBuf *self, const void* bytes, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Mimic_Bytes_OFFSET;
    const lucy_BB_mimic_bytes_t method = *((lucy_BB_mimic_bytes_t*)method_address);
    method((lucy_ByteBuf*)self, bytes, size);
}

extern size_t Lucy_ViewBB_Cat_Bytes_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Cat_Bytes(const lucy_ViewByteBuf *self, const void* bytes, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Cat_Bytes_OFFSET;
    const lucy_BB_cat_bytes_t method = *((lucy_BB_cat_bytes_t*)method_address);
    method((lucy_ByteBuf*)self, bytes, size);
}

extern size_t Lucy_ViewBB_Cat_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Cat(const lucy_ViewByteBuf *self, const lucy_ByteBuf* other) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Cat_OFFSET;
    const lucy_BB_cat_t method = *((lucy_BB_cat_t*)method_address);
    method((lucy_ByteBuf*)self, other);
}

extern size_t Lucy_ViewBB_Grow_OFFSET;
static CHY_INLINE char*
Lucy_ViewBB_Grow(const lucy_ViewByteBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Grow_OFFSET;
    const lucy_BB_grow_t method = *((lucy_BB_grow_t*)method_address);
    return method((lucy_ByteBuf*)self, size);
}

extern size_t Lucy_ViewBB_Equals_Bytes_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewBB_Equals_Bytes(const lucy_ViewByteBuf *self, const void* bytes, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Equals_Bytes_OFFSET;
    const lucy_BB_equals_bytes_t method = *((lucy_BB_equals_bytes_t*)method_address);
    return method((lucy_ByteBuf*)self, bytes, size);
}

extern size_t Lucy_ViewBB_Assign_Bytes_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Assign_Bytes(const lucy_ViewByteBuf *self, char* buf, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Assign_Bytes_OFFSET;
    const lucy_ViewBB_assign_bytes_t method = *((lucy_ViewBB_assign_bytes_t*)method_address);
    method((lucy_ViewByteBuf*)self, buf, size);
}

extern size_t Lucy_ViewBB_Assign_OFFSET;
static CHY_INLINE void
Lucy_ViewBB_Assign(const lucy_ViewByteBuf *self, const lucy_ByteBuf* other) {
    char *const method_address = *(char**)self + Lucy_ViewBB_Assign_OFFSET;
    const lucy_ViewBB_assign_t method = *((lucy_ViewBB_assign_t*)method_address);
    method((lucy_ViewByteBuf*)self, other);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_VIEWBYTEBUF_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_VIEWBYTEBUF_VT;
extern struct LUCY_VIEWBYTEBUF_VT LUCY_VIEWBYTEBUF_vt;
#define LUCY_VIEWBYTEBUF ((cfish_VTable*)&LUCY_VIEWBYTEBUF_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ViewByteBuf lucy_ViewByteBuf
  #define VIEWBYTEBUF LUCY_VIEWBYTEBUF
  #define ViewBB_new lucy_ViewBB_new
  #define ViewBB_init lucy_ViewBB_init
  #define ViewBB_destroy_t lucy_ViewBB_destroy_t
  #define ViewBB_destroy lucy_ViewBB_destroy
  #define ViewBB_assign_bytes_t lucy_ViewBB_assign_bytes_t
  #define ViewBB_assign_bytes lucy_ViewBB_assign_bytes
  #define ViewBB_assign_t lucy_ViewBB_assign_t
  #define ViewBB_assign lucy_ViewBB_assign
  #define ViewBB_Make Lucy_ViewBB_Make
  #define ViewBB_Get_RefCount Lucy_ViewBB_Get_RefCount
  #define ViewBB_Inc_RefCount Lucy_ViewBB_Inc_RefCount
  #define ViewBB_Dec_RefCount Lucy_ViewBB_Dec_RefCount
  #define ViewBB_To_Host Lucy_ViewBB_To_Host
  #define ViewBB_Clone Lucy_ViewBB_Clone
  #define ViewBB_Destroy Lucy_ViewBB_Destroy
  #define ViewBB_Equals Lucy_ViewBB_Equals
  #define ViewBB_Compare_To Lucy_ViewBB_Compare_To
  #define ViewBB_Hash_Sum Lucy_ViewBB_Hash_Sum
  #define ViewBB_Get_VTable Lucy_ViewBB_Get_VTable
  #define ViewBB_Get_Class_Name Lucy_ViewBB_Get_Class_Name
  #define ViewBB_Is_A Lucy_ViewBB_Is_A
  #define ViewBB_To_String Lucy_ViewBB_To_String
  #define ViewBB_To_I64 Lucy_ViewBB_To_I64
  #define ViewBB_To_F64 Lucy_ViewBB_To_F64
  #define ViewBB_To_Bool Lucy_ViewBB_To_Bool
  #define ViewBB_Serialize Lucy_ViewBB_Serialize
  #define ViewBB_Deserialize Lucy_ViewBB_Deserialize
  #define ViewBB_Dump Lucy_ViewBB_Dump
  #define ViewBB_Load Lucy_ViewBB_Load
  #define ViewBB_Mimic Lucy_ViewBB_Mimic
  #define ViewBB_Set_Size Lucy_ViewBB_Set_Size
  #define ViewBB_Get_Size Lucy_ViewBB_Get_Size
  #define ViewBB_Get_Buf Lucy_ViewBB_Get_Buf
  #define ViewBB_Get_Capacity Lucy_ViewBB_Get_Capacity
  #define ViewBB_Mimic_Bytes Lucy_ViewBB_Mimic_Bytes
  #define ViewBB_Cat_Bytes Lucy_ViewBB_Cat_Bytes
  #define ViewBB_Cat Lucy_ViewBB_Cat
  #define ViewBB_Grow Lucy_ViewBB_Grow
  #define ViewBB_Equals_Bytes Lucy_ViewBB_Equals_Bytes
  #define ViewBB_Assign_Bytes Lucy_ViewBB_Assign_Bytes
  #define ViewBB_Assign Lucy_ViewBB_Assign
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_BYTEBUF */




