/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_CHARBUF
#define H_LUCY_OBJECT_CHARBUF 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_CHARBUF
struct lucy_CharBuf {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* ptr;
    size_t size;
    size_t cap;
};

#endif /* C_LUCY_CHARBUF */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_CharBuf*
lucy_CB_new(size_t size);

lucy_CharBuf*
lucy_CB_init(lucy_CharBuf* self, size_t size);

lucy_CharBuf*
lucy_CB_new_from_utf8(const char* utf8, size_t size);

lucy_CharBuf*
lucy_CB_new_from_trusted_utf8(const char* utf8, size_t size);

lucy_CharBuf*
lucy_CB_new_steal_str(char* ptr, size_t size, size_t cap);

lucy_CharBuf*
lucy_CB_new_steal_from_trusted_str(char* ptr, size_t size, size_t cap);

lucy_CharBuf*
lucy_CB_newf(const char* pattern, ...);

int
lucy_CB_compare(const void* va, const void* vb);

chy_bool_t
lucy_CB_less_than(const void* va, const void* vb);

void
lucy_CB_catf(lucy_CharBuf* self, const char* pattern, ...);

void
lucy_CB_setf(lucy_CharBuf* self, const char* pattern, ...);

lucy_CharBuf*
lucy_CB_clone(lucy_CharBuf* self);

void
lucy_CB_destroy(lucy_CharBuf* self);

chy_bool_t
lucy_CB_equals(lucy_CharBuf* self, lucy_Obj* other);

int32_t
lucy_CB_compare_to(lucy_CharBuf* self, lucy_Obj* other);

int32_t
lucy_CB_hash_sum(lucy_CharBuf* self);

lucy_CharBuf*
lucy_CB_to_string(lucy_CharBuf* self);

int64_t
lucy_CB_to_i64(lucy_CharBuf* self);

double
lucy_CB_to_f64(lucy_CharBuf* self);

void
lucy_CB_serialize(lucy_CharBuf* self, lucy_OutStream* outstream);

lucy_CharBuf*
lucy_CB_deserialize(lucy_CharBuf* self, lucy_InStream* instream);

lucy_CharBuf*
lucy_CB_load(lucy_CharBuf* self, lucy_Obj* dump);

void
lucy_CB_mimic(lucy_CharBuf* self, lucy_Obj* other);

void
lucy_CB_mimic_str(lucy_CharBuf* self, const char* ptr, size_t size);

void
lucy_CB_cat_str(lucy_CharBuf* self, const char* ptr, size_t size);

void
lucy_CB_cat(lucy_CharBuf* self, const lucy_CharBuf* other);

void
lucy_CB_vcatf(lucy_CharBuf* self, const char* pattern, va_list args);

void
lucy_CB_cat_char(lucy_CharBuf* self, uint32_t code_point);

int32_t
lucy_CB_swap_chars(lucy_CharBuf* self, uint32_t match, uint32_t replacement);

int64_t
lucy_CB_basex_to_i64(lucy_CharBuf* self, uint32_t base);

char*
lucy_CB_grow(lucy_CharBuf* self, size_t size);

chy_bool_t
lucy_CB_starts_with(lucy_CharBuf* self, const lucy_CharBuf* prefix);

chy_bool_t
lucy_CB_starts_with_str(lucy_CharBuf* self, const char* prefix, size_t size);

chy_bool_t
lucy_CB_ends_with(lucy_CharBuf* self, const lucy_CharBuf* postfix);

chy_bool_t
lucy_CB_ends_with_str(lucy_CharBuf* self, const char* postfix, size_t size);

int64_t
lucy_CB_find(lucy_CharBuf* self, const lucy_CharBuf* substring);

int64_t
lucy_CB_find_str(lucy_CharBuf* self, const char* ptr, size_t size);

chy_bool_t
lucy_CB_equals_str(lucy_CharBuf* self, const char* ptr, size_t size);

size_t
lucy_CB_length(lucy_CharBuf* self);

void
lucy_CB_set_size(lucy_CharBuf* self, size_t size);

size_t
lucy_CB_get_size(lucy_CharBuf* self);

uint8_t*
lucy_CB_get_ptr8(lucy_CharBuf* self);

lucy_CharBuf*
lucy_CB_to_cb8(lucy_CharBuf* self);

uint32_t
lucy_CB_trim(lucy_CharBuf* self);

uint32_t
lucy_CB_trim_top(lucy_CharBuf* self);

uint32_t
lucy_CB_trim_tail(lucy_CharBuf* self);

size_t
lucy_CB_nip(lucy_CharBuf* self, size_t count);

int32_t
lucy_CB_nip_one(lucy_CharBuf* self);

size_t
lucy_CB_chop(lucy_CharBuf* self, size_t count);

size_t
lucy_CB_truncate(lucy_CharBuf* self, size_t count);

uint32_t
lucy_CB_code_point_at(lucy_CharBuf* self, size_t tick);

uint32_t
lucy_CB_code_point_from(lucy_CharBuf* self, size_t tick);

lucy_CharBuf*
lucy_CB_substring(lucy_CharBuf* self, size_t offset, size_t len);

void
lucy_CB_cat_trusted_str(lucy_CharBuf* self, const char* ptr, size_t size);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_CB_clone_CALLBACK;
extern cfish_Callback lucy_CB_destroy_CALLBACK;
extern cfish_Callback lucy_CB_equals_CALLBACK;
extern cfish_Callback lucy_CB_compare_to_CALLBACK;
extern cfish_Callback lucy_CB_hash_sum_CALLBACK;
extern cfish_Callback lucy_CB_to_string_CALLBACK;
extern cfish_Callback lucy_CB_to_i64_CALLBACK;
extern cfish_Callback lucy_CB_to_f64_CALLBACK;
extern cfish_Callback lucy_CB_serialize_CALLBACK;
extern cfish_Callback lucy_CB_deserialize_CALLBACK;
extern cfish_Callback lucy_CB_load_CALLBACK;
extern cfish_Callback lucy_CB_mimic_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_CharBuf*
(*lucy_CB_clone_t)(lucy_CharBuf* self);

typedef void
(*lucy_CB_destroy_t)(lucy_CharBuf* self);

typedef chy_bool_t
(*lucy_CB_equals_t)(lucy_CharBuf* self, lucy_Obj* other);

typedef int32_t
(*lucy_CB_compare_to_t)(lucy_CharBuf* self, lucy_Obj* other);

typedef int32_t
(*lucy_CB_hash_sum_t)(lucy_CharBuf* self);

typedef lucy_CharBuf*
(*lucy_CB_to_string_t)(lucy_CharBuf* self);

typedef int64_t
(*lucy_CB_to_i64_t)(lucy_CharBuf* self);

typedef double
(*lucy_CB_to_f64_t)(lucy_CharBuf* self);

typedef void
(*lucy_CB_serialize_t)(lucy_CharBuf* self, lucy_OutStream* outstream);

typedef lucy_CharBuf*
(*lucy_CB_deserialize_t)(lucy_CharBuf* self, lucy_InStream* instream);

typedef lucy_CharBuf*
(*lucy_CB_load_t)(lucy_CharBuf* self, lucy_Obj* dump);

typedef void
(*lucy_CB_mimic_t)(lucy_CharBuf* self, lucy_Obj* other);

typedef void
(*lucy_CB_mimic_str_t)(lucy_CharBuf* self, const char* ptr, size_t size);

typedef void
(*lucy_CB_cat_str_t)(lucy_CharBuf* self, const char* ptr, size_t size);

typedef void
(*lucy_CB_cat_t)(lucy_CharBuf* self, const lucy_CharBuf* other);

typedef void
(*lucy_CB_vcatf_t)(lucy_CharBuf* self, const char* pattern, va_list args);

typedef void
(*lucy_CB_cat_char_t)(lucy_CharBuf* self, uint32_t code_point);

typedef int32_t
(*lucy_CB_swap_chars_t)(lucy_CharBuf* self, uint32_t match, uint32_t replacement);

typedef int64_t
(*lucy_CB_basex_to_i64_t)(lucy_CharBuf* self, uint32_t base);

typedef char*
(*lucy_CB_grow_t)(lucy_CharBuf* self, size_t size);

typedef chy_bool_t
(*lucy_CB_starts_with_t)(lucy_CharBuf* self, const lucy_CharBuf* prefix);

typedef chy_bool_t
(*lucy_CB_starts_with_str_t)(lucy_CharBuf* self, const char* prefix, size_t size);

typedef chy_bool_t
(*lucy_CB_ends_with_t)(lucy_CharBuf* self, const lucy_CharBuf* postfix);

typedef chy_bool_t
(*lucy_CB_ends_with_str_t)(lucy_CharBuf* self, const char* postfix, size_t size);

typedef int64_t
(*lucy_CB_find_t)(lucy_CharBuf* self, const lucy_CharBuf* substring);

typedef int64_t
(*lucy_CB_find_str_t)(lucy_CharBuf* self, const char* ptr, size_t size);

typedef chy_bool_t
(*lucy_CB_equals_str_t)(lucy_CharBuf* self, const char* ptr, size_t size);

typedef size_t
(*lucy_CB_length_t)(lucy_CharBuf* self);

typedef void
(*lucy_CB_set_size_t)(lucy_CharBuf* self, size_t size);

typedef size_t
(*lucy_CB_get_size_t)(lucy_CharBuf* self);

typedef uint8_t*
(*lucy_CB_get_ptr8_t)(lucy_CharBuf* self);

typedef lucy_CharBuf*
(*lucy_CB_to_cb8_t)(lucy_CharBuf* self);

typedef uint32_t
(*lucy_CB_trim_t)(lucy_CharBuf* self);

typedef uint32_t
(*lucy_CB_trim_top_t)(lucy_CharBuf* self);

typedef uint32_t
(*lucy_CB_trim_tail_t)(lucy_CharBuf* self);

typedef size_t
(*lucy_CB_nip_t)(lucy_CharBuf* self, size_t count);

typedef int32_t
(*lucy_CB_nip_one_t)(lucy_CharBuf* self);

typedef size_t
(*lucy_CB_chop_t)(lucy_CharBuf* self, size_t count);

typedef size_t
(*lucy_CB_truncate_t)(lucy_CharBuf* self, size_t count);

typedef uint32_t
(*lucy_CB_code_point_at_t)(lucy_CharBuf* self, size_t tick);

typedef uint32_t
(*lucy_CB_code_point_from_t)(lucy_CharBuf* self, size_t tick);

typedef lucy_CharBuf*
(*lucy_CB_substring_t)(lucy_CharBuf* self, size_t offset, size_t len);

typedef void
(*lucy_CB_cat_trusted_str_t)(lucy_CharBuf* self, const char* ptr, size_t size);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_CB_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CB_Make(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Get_RefCount(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CB_Inc_RefCount(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Dec_RefCount(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_CB_To_Host(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Clone_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_Clone(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Clone_OFFSET;
    const lucy_CB_clone_t method = *((lucy_CB_clone_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Destroy_OFFSET;
static CHY_INLINE void
Lucy_CB_Destroy(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Destroy_OFFSET;
    const lucy_CB_destroy_t method = *((lucy_CB_destroy_t*)method_address);
    method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Equals(const lucy_CharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CB_Equals_OFFSET;
    const lucy_CB_equals_t method = *((lucy_CB_equals_t*)method_address);
    return method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_CB_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_CB_Compare_To(const lucy_CharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CB_Compare_To_OFFSET;
    const lucy_CB_compare_to_t method = *((lucy_CB_compare_to_t*)method_address);
    return method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_CB_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_CB_Hash_Sum(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Hash_Sum_OFFSET;
    const lucy_CB_hash_sum_t method = *((lucy_CB_hash_sum_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_CB_Get_VTable(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_Get_Class_Name(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Is_A(const lucy_CharBuf *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_CB_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_CB_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_To_String(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_To_String_OFFSET;
    const lucy_CB_to_string_t method = *((lucy_CB_to_string_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_CB_To_I64(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_To_I64_OFFSET;
    const lucy_CB_to_i64_t method = *((lucy_CB_to_i64_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_To_F64_OFFSET;
static CHY_INLINE double
Lucy_CB_To_F64(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_To_F64_OFFSET;
    const lucy_CB_to_f64_t method = *((lucy_CB_to_f64_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_To_Bool(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Serialize_OFFSET;
static CHY_INLINE void
Lucy_CB_Serialize(const lucy_CharBuf *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_CB_Serialize_OFFSET;
    const lucy_CB_serialize_t method = *((lucy_CB_serialize_t*)method_address);
    method((lucy_CharBuf*)self, outstream);
}

extern size_t Lucy_CB_Deserialize_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_Deserialize(const lucy_CharBuf *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_CB_Deserialize_OFFSET;
    const lucy_CB_deserialize_t method = *((lucy_CB_deserialize_t*)method_address);
    return method((lucy_CharBuf*)self, instream);
}

extern size_t Lucy_CB_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CB_Dump(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CB_Load_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_Load(const lucy_CharBuf *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_CB_Load_OFFSET;
    const lucy_CB_load_t method = *((lucy_CB_load_t*)method_address);
    return method((lucy_CharBuf*)self, dump);
}

extern size_t Lucy_CB_Mimic_OFFSET;
static CHY_INLINE void
Lucy_CB_Mimic(const lucy_CharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CB_Mimic_OFFSET;
    const lucy_CB_mimic_t method = *((lucy_CB_mimic_t*)method_address);
    method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_CB_Mimic_Str_OFFSET;
static CHY_INLINE void
Lucy_CB_Mimic_Str(const lucy_CharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Mimic_Str_OFFSET;
    const lucy_CB_mimic_str_t method = *((lucy_CB_mimic_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_CB_Cat_Str_OFFSET;
static CHY_INLINE void
Lucy_CB_Cat_Str(const lucy_CharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Cat_Str_OFFSET;
    const lucy_CB_cat_str_t method = *((lucy_CB_cat_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_CB_Cat_OFFSET;
static CHY_INLINE void
Lucy_CB_Cat(const lucy_CharBuf *self, const lucy_CharBuf* other) {
    char *const method_address = *(char**)self + Lucy_CB_Cat_OFFSET;
    const lucy_CB_cat_t method = *((lucy_CB_cat_t*)method_address);
    method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_CB_VCatF_OFFSET;
static CHY_INLINE void
Lucy_CB_VCatF(const lucy_CharBuf *self, const char* pattern, va_list args) {
    char *const method_address = *(char**)self + Lucy_CB_VCatF_OFFSET;
    const lucy_CB_vcatf_t method = *((lucy_CB_vcatf_t*)method_address);
    method((lucy_CharBuf*)self, pattern, args);
}

extern size_t Lucy_CB_Cat_Char_OFFSET;
static CHY_INLINE void
Lucy_CB_Cat_Char(const lucy_CharBuf *self, uint32_t code_point) {
    char *const method_address = *(char**)self + Lucy_CB_Cat_Char_OFFSET;
    const lucy_CB_cat_char_t method = *((lucy_CB_cat_char_t*)method_address);
    method((lucy_CharBuf*)self, code_point);
}

extern size_t Lucy_CB_Swap_Chars_OFFSET;
static CHY_INLINE int32_t
Lucy_CB_Swap_Chars(const lucy_CharBuf *self, uint32_t match, uint32_t replacement) {
    char *const method_address = *(char**)self + Lucy_CB_Swap_Chars_OFFSET;
    const lucy_CB_swap_chars_t method = *((lucy_CB_swap_chars_t*)method_address);
    return method((lucy_CharBuf*)self, match, replacement);
}

extern size_t Lucy_CB_BaseX_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_CB_BaseX_To_I64(const lucy_CharBuf *self, uint32_t base) {
    char *const method_address = *(char**)self + Lucy_CB_BaseX_To_I64_OFFSET;
    const lucy_CB_basex_to_i64_t method = *((lucy_CB_basex_to_i64_t*)method_address);
    return method((lucy_CharBuf*)self, base);
}

extern size_t Lucy_CB_Grow_OFFSET;
static CHY_INLINE char*
Lucy_CB_Grow(const lucy_CharBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Grow_OFFSET;
    const lucy_CB_grow_t method = *((lucy_CB_grow_t*)method_address);
    return method((lucy_CharBuf*)self, size);
}

extern size_t Lucy_CB_Starts_With_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Starts_With(const lucy_CharBuf *self, const lucy_CharBuf* prefix) {
    char *const method_address = *(char**)self + Lucy_CB_Starts_With_OFFSET;
    const lucy_CB_starts_with_t method = *((lucy_CB_starts_with_t*)method_address);
    return method((lucy_CharBuf*)self, prefix);
}

extern size_t Lucy_CB_Starts_With_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Starts_With_Str(const lucy_CharBuf *self, const char* prefix, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Starts_With_Str_OFFSET;
    const lucy_CB_starts_with_str_t method = *((lucy_CB_starts_with_str_t*)method_address);
    return method((lucy_CharBuf*)self, prefix, size);
}

extern size_t Lucy_CB_Ends_With_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Ends_With(const lucy_CharBuf *self, const lucy_CharBuf* postfix) {
    char *const method_address = *(char**)self + Lucy_CB_Ends_With_OFFSET;
    const lucy_CB_ends_with_t method = *((lucy_CB_ends_with_t*)method_address);
    return method((lucy_CharBuf*)self, postfix);
}

extern size_t Lucy_CB_Ends_With_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Ends_With_Str(const lucy_CharBuf *self, const char* postfix, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Ends_With_Str_OFFSET;
    const lucy_CB_ends_with_str_t method = *((lucy_CB_ends_with_str_t*)method_address);
    return method((lucy_CharBuf*)self, postfix, size);
}

extern size_t Lucy_CB_Find_OFFSET;
static CHY_INLINE int64_t
Lucy_CB_Find(const lucy_CharBuf *self, const lucy_CharBuf* substring) {
    char *const method_address = *(char**)self + Lucy_CB_Find_OFFSET;
    const lucy_CB_find_t method = *((lucy_CB_find_t*)method_address);
    return method((lucy_CharBuf*)self, substring);
}

extern size_t Lucy_CB_Find_Str_OFFSET;
static CHY_INLINE int64_t
Lucy_CB_Find_Str(const lucy_CharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Find_Str_OFFSET;
    const lucy_CB_find_str_t method = *((lucy_CB_find_str_t*)method_address);
    return method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_CB_Equals_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CB_Equals_Str(const lucy_CharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Equals_Str_OFFSET;
    const lucy_CB_equals_str_t method = *((lucy_CB_equals_str_t*)method_address);
    return method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_CB_Length_OFFSET;
static CHY_INLINE size_t
Lucy_CB_Length(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Length_OFFSET;
    const lucy_CB_length_t method = *((lucy_CB_length_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Set_Size_OFFSET;
static CHY_INLINE void
Lucy_CB_Set_Size(const lucy_CharBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Set_Size_OFFSET;
    const lucy_CB_set_size_t method = *((lucy_CB_set_size_t*)method_address);
    method((lucy_CharBuf*)self, size);
}

extern size_t Lucy_CB_Get_Size_OFFSET;
static CHY_INLINE size_t
Lucy_CB_Get_Size(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Get_Size_OFFSET;
    const lucy_CB_get_size_t method = *((lucy_CB_get_size_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Get_Ptr8_OFFSET;
static CHY_INLINE uint8_t*
Lucy_CB_Get_Ptr8(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Get_Ptr8_OFFSET;
    const lucy_CB_get_ptr8_t method = *((lucy_CB_get_ptr8_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_To_CB8_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_To_CB8(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_To_CB8_OFFSET;
    const lucy_CB_to_cb8_t method = *((lucy_CB_to_cb8_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Trim_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Trim(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Trim_OFFSET;
    const lucy_CB_trim_t method = *((lucy_CB_trim_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Trim_Top_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Trim_Top(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Trim_Top_OFFSET;
    const lucy_CB_trim_top_t method = *((lucy_CB_trim_top_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Trim_Tail_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Trim_Tail(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Trim_Tail_OFFSET;
    const lucy_CB_trim_tail_t method = *((lucy_CB_trim_tail_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Nip_OFFSET;
static CHY_INLINE size_t
Lucy_CB_Nip(const lucy_CharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_CB_Nip_OFFSET;
    const lucy_CB_nip_t method = *((lucy_CB_nip_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_CB_Nip_One_OFFSET;
static CHY_INLINE int32_t
Lucy_CB_Nip_One(const lucy_CharBuf *self) {
    char *const method_address = *(char**)self + Lucy_CB_Nip_One_OFFSET;
    const lucy_CB_nip_one_t method = *((lucy_CB_nip_one_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_CB_Chop_OFFSET;
static CHY_INLINE size_t
Lucy_CB_Chop(const lucy_CharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_CB_Chop_OFFSET;
    const lucy_CB_chop_t method = *((lucy_CB_chop_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_CB_Truncate_OFFSET;
static CHY_INLINE size_t
Lucy_CB_Truncate(const lucy_CharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_CB_Truncate_OFFSET;
    const lucy_CB_truncate_t method = *((lucy_CB_truncate_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_CB_Code_Point_At_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Code_Point_At(const lucy_CharBuf *self, size_t tick) {
    char *const method_address = *(char**)self + Lucy_CB_Code_Point_At_OFFSET;
    const lucy_CB_code_point_at_t method = *((lucy_CB_code_point_at_t*)method_address);
    return method((lucy_CharBuf*)self, tick);
}

extern size_t Lucy_CB_Code_Point_From_OFFSET;
static CHY_INLINE uint32_t
Lucy_CB_Code_Point_From(const lucy_CharBuf *self, size_t tick) {
    char *const method_address = *(char**)self + Lucy_CB_Code_Point_From_OFFSET;
    const lucy_CB_code_point_from_t method = *((lucy_CB_code_point_from_t*)method_address);
    return method((lucy_CharBuf*)self, tick);
}

extern size_t Lucy_CB_SubString_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CB_SubString(const lucy_CharBuf *self, size_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_CB_SubString_OFFSET;
    const lucy_CB_substring_t method = *((lucy_CB_substring_t*)method_address);
    return method((lucy_CharBuf*)self, offset, len);
}

extern size_t Lucy_CB_Cat_Trusted_Str_OFFSET;
static CHY_INLINE void
Lucy_CB_Cat_Trusted_Str(const lucy_CharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_CB_Cat_Trusted_Str_OFFSET;
    const lucy_CB_cat_trusted_str_t method = *((lucy_CB_cat_trusted_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_CHARBUF_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[53];
} LUCY_CHARBUF_VT;
extern struct LUCY_CHARBUF_VT LUCY_CHARBUF_vt;
#define LUCY_CHARBUF ((cfish_VTable*)&LUCY_CHARBUF_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define CharBuf lucy_CharBuf
  #define CHARBUF LUCY_CHARBUF
  #define CB_new lucy_CB_new
  #define CB_init lucy_CB_init
  #define CB_new_from_utf8 lucy_CB_new_from_utf8
  #define CB_new_from_trusted_utf8 lucy_CB_new_from_trusted_utf8
  #define CB_new_steal_str lucy_CB_new_steal_str
  #define CB_new_steal_from_trusted_str lucy_CB_new_steal_from_trusted_str
  #define CB_newf lucy_CB_newf
  #define CB_compare lucy_CB_compare
  #define CB_less_than lucy_CB_less_than
  #define CB_catf lucy_CB_catf
  #define CB_setf lucy_CB_setf
  #define CB_clone_t lucy_CB_clone_t
  #define CB_clone lucy_CB_clone
  #define CB_destroy_t lucy_CB_destroy_t
  #define CB_destroy lucy_CB_destroy
  #define CB_equals_t lucy_CB_equals_t
  #define CB_equals lucy_CB_equals
  #define CB_compare_to_t lucy_CB_compare_to_t
  #define CB_compare_to lucy_CB_compare_to
  #define CB_hash_sum_t lucy_CB_hash_sum_t
  #define CB_hash_sum lucy_CB_hash_sum
  #define CB_to_string_t lucy_CB_to_string_t
  #define CB_to_string lucy_CB_to_string
  #define CB_to_i64_t lucy_CB_to_i64_t
  #define CB_to_i64 lucy_CB_to_i64
  #define CB_to_f64_t lucy_CB_to_f64_t
  #define CB_to_f64 lucy_CB_to_f64
  #define CB_serialize_t lucy_CB_serialize_t
  #define CB_serialize lucy_CB_serialize
  #define CB_deserialize_t lucy_CB_deserialize_t
  #define CB_deserialize lucy_CB_deserialize
  #define CB_load_t lucy_CB_load_t
  #define CB_load lucy_CB_load
  #define CB_mimic_t lucy_CB_mimic_t
  #define CB_mimic lucy_CB_mimic
  #define CB_mimic_str_t lucy_CB_mimic_str_t
  #define CB_mimic_str lucy_CB_mimic_str
  #define CB_cat_str_t lucy_CB_cat_str_t
  #define CB_cat_str lucy_CB_cat_str
  #define CB_cat_t lucy_CB_cat_t
  #define CB_cat lucy_CB_cat
  #define CB_vcatf_t lucy_CB_vcatf_t
  #define CB_vcatf lucy_CB_vcatf
  #define CB_cat_char_t lucy_CB_cat_char_t
  #define CB_cat_char lucy_CB_cat_char
  #define CB_swap_chars_t lucy_CB_swap_chars_t
  #define CB_swap_chars lucy_CB_swap_chars
  #define CB_basex_to_i64_t lucy_CB_basex_to_i64_t
  #define CB_basex_to_i64 lucy_CB_basex_to_i64
  #define CB_grow_t lucy_CB_grow_t
  #define CB_grow lucy_CB_grow
  #define CB_starts_with_t lucy_CB_starts_with_t
  #define CB_starts_with lucy_CB_starts_with
  #define CB_starts_with_str_t lucy_CB_starts_with_str_t
  #define CB_starts_with_str lucy_CB_starts_with_str
  #define CB_ends_with_t lucy_CB_ends_with_t
  #define CB_ends_with lucy_CB_ends_with
  #define CB_ends_with_str_t lucy_CB_ends_with_str_t
  #define CB_ends_with_str lucy_CB_ends_with_str
  #define CB_find_t lucy_CB_find_t
  #define CB_find lucy_CB_find
  #define CB_find_str_t lucy_CB_find_str_t
  #define CB_find_str lucy_CB_find_str
  #define CB_equals_str_t lucy_CB_equals_str_t
  #define CB_equals_str lucy_CB_equals_str
  #define CB_length_t lucy_CB_length_t
  #define CB_length lucy_CB_length
  #define CB_set_size_t lucy_CB_set_size_t
  #define CB_set_size lucy_CB_set_size
  #define CB_get_size_t lucy_CB_get_size_t
  #define CB_get_size lucy_CB_get_size
  #define CB_get_ptr8_t lucy_CB_get_ptr8_t
  #define CB_get_ptr8 lucy_CB_get_ptr8
  #define CB_to_cb8_t lucy_CB_to_cb8_t
  #define CB_to_cb8 lucy_CB_to_cb8
  #define CB_trim_t lucy_CB_trim_t
  #define CB_trim lucy_CB_trim
  #define CB_trim_top_t lucy_CB_trim_top_t
  #define CB_trim_top lucy_CB_trim_top
  #define CB_trim_tail_t lucy_CB_trim_tail_t
  #define CB_trim_tail lucy_CB_trim_tail
  #define CB_nip_t lucy_CB_nip_t
  #define CB_nip lucy_CB_nip
  #define CB_nip_one_t lucy_CB_nip_one_t
  #define CB_nip_one lucy_CB_nip_one
  #define CB_chop_t lucy_CB_chop_t
  #define CB_chop lucy_CB_chop
  #define CB_truncate_t lucy_CB_truncate_t
  #define CB_truncate lucy_CB_truncate
  #define CB_code_point_at_t lucy_CB_code_point_at_t
  #define CB_code_point_at lucy_CB_code_point_at
  #define CB_code_point_from_t lucy_CB_code_point_from_t
  #define CB_code_point_from lucy_CB_code_point_from
  #define CB_substring_t lucy_CB_substring_t
  #define CB_substring lucy_CB_substring
  #define CB_cat_trusted_str_t lucy_CB_cat_trusted_str_t
  #define CB_cat_trusted_str lucy_CB_cat_trusted_str
  #define CB_Make Lucy_CB_Make
  #define CB_Get_RefCount Lucy_CB_Get_RefCount
  #define CB_Inc_RefCount Lucy_CB_Inc_RefCount
  #define CB_Dec_RefCount Lucy_CB_Dec_RefCount
  #define CB_To_Host Lucy_CB_To_Host
  #define CB_Clone Lucy_CB_Clone
  #define CB_Destroy Lucy_CB_Destroy
  #define CB_Equals Lucy_CB_Equals
  #define CB_Compare_To Lucy_CB_Compare_To
  #define CB_Hash_Sum Lucy_CB_Hash_Sum
  #define CB_Get_VTable Lucy_CB_Get_VTable
  #define CB_Get_Class_Name Lucy_CB_Get_Class_Name
  #define CB_Is_A Lucy_CB_Is_A
  #define CB_To_String Lucy_CB_To_String
  #define CB_To_I64 Lucy_CB_To_I64
  #define CB_To_F64 Lucy_CB_To_F64
  #define CB_To_Bool Lucy_CB_To_Bool
  #define CB_Serialize Lucy_CB_Serialize
  #define CB_Deserialize Lucy_CB_Deserialize
  #define CB_Dump Lucy_CB_Dump
  #define CB_Load Lucy_CB_Load
  #define CB_Mimic Lucy_CB_Mimic
  #define CB_Mimic_Str Lucy_CB_Mimic_Str
  #define CB_Cat_Str Lucy_CB_Cat_Str
  #define CB_Cat Lucy_CB_Cat
  #define CB_VCatF Lucy_CB_VCatF
  #define CB_Cat_Char Lucy_CB_Cat_Char
  #define CB_Swap_Chars Lucy_CB_Swap_Chars
  #define CB_BaseX_To_I64 Lucy_CB_BaseX_To_I64
  #define CB_Grow Lucy_CB_Grow
  #define CB_Starts_With Lucy_CB_Starts_With
  #define CB_Starts_With_Str Lucy_CB_Starts_With_Str
  #define CB_Ends_With Lucy_CB_Ends_With
  #define CB_Ends_With_Str Lucy_CB_Ends_With_Str
  #define CB_Find Lucy_CB_Find
  #define CB_Find_Str Lucy_CB_Find_Str
  #define CB_Equals_Str Lucy_CB_Equals_Str
  #define CB_Length Lucy_CB_Length
  #define CB_Set_Size Lucy_CB_Set_Size
  #define CB_Get_Size Lucy_CB_Get_Size
  #define CB_Get_Ptr8 Lucy_CB_Get_Ptr8
  #define CB_To_CB8 Lucy_CB_To_CB8
  #define CB_Trim Lucy_CB_Trim
  #define CB_Trim_Top Lucy_CB_Trim_Top
  #define CB_Trim_Tail Lucy_CB_Trim_Tail
  #define CB_Nip Lucy_CB_Nip
  #define CB_Nip_One Lucy_CB_Nip_One
  #define CB_Chop Lucy_CB_Chop
  #define CB_Truncate Lucy_CB_Truncate
  #define CB_Code_Point_At Lucy_CB_Code_Point_At
  #define CB_Code_Point_From Lucy_CB_Code_Point_From
  #define CB_SubString Lucy_CB_SubString
  #define CB_Cat_Trusted_Str Lucy_CB_Cat_Trusted_Str
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/CharBuf.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_VIEWCHARBUF
struct lucy_ViewCharBuf {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* ptr;
    size_t size;
    size_t cap;
};

#endif /* C_LUCY_VIEWCHARBUF */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ViewCharBuf*
lucy_ViewCB_new_from_utf8(const char* utf8, size_t size);

lucy_ViewCharBuf*
lucy_ViewCB_new_from_trusted_utf8(const char* utf8, size_t size);

lucy_ViewCharBuf*
lucy_ViewCB_init(lucy_ViewCharBuf* self, const char* utf8, size_t size);

void
lucy_ViewCB_destroy(lucy_ViewCharBuf* self);

char*
lucy_ViewCB_grow(lucy_ViewCharBuf* self, size_t size);

uint32_t
lucy_ViewCB_trim_top(lucy_ViewCharBuf* self);

size_t
lucy_ViewCB_nip(lucy_ViewCharBuf* self, size_t count);

int32_t
lucy_ViewCB_nip_one(lucy_ViewCharBuf* self);

void
lucy_ViewCB_assign(lucy_ViewCharBuf* self, const lucy_CharBuf* other);

void
lucy_ViewCB_assign_str(lucy_ViewCharBuf* self, const char* utf8, size_t size);

void
lucy_ViewCB_assign_trusted_str(lucy_ViewCharBuf* self, const char* utf8, size_t size);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ViewCB_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ViewCB_destroy_t)(lucy_ViewCharBuf* self);

typedef char*
(*lucy_ViewCB_grow_t)(lucy_ViewCharBuf* self, size_t size);

typedef uint32_t
(*lucy_ViewCB_trim_top_t)(lucy_ViewCharBuf* self);

typedef size_t
(*lucy_ViewCB_nip_t)(lucy_ViewCharBuf* self, size_t count);

typedef int32_t
(*lucy_ViewCB_nip_one_t)(lucy_ViewCharBuf* self);

typedef void
(*lucy_ViewCB_assign_t)(lucy_ViewCharBuf* self, const lucy_CharBuf* other);

typedef void
(*lucy_ViewCB_assign_str_t)(lucy_ViewCharBuf* self, const char* utf8, size_t size);

typedef void
(*lucy_ViewCB_assign_trusted_str_t)(lucy_ViewCharBuf* self, const char* utf8, size_t size);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ViewCB_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewCB_Make(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Get_RefCount(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewCB_Inc_RefCount(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Dec_RefCount(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ViewCB_To_Host(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Clone_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_Clone(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Clone_OFFSET;
    const lucy_CB_clone_t method = *((lucy_CB_clone_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Destroy(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Destroy_OFFSET;
    const lucy_ViewCB_destroy_t method = *((lucy_ViewCB_destroy_t*)method_address);
    method((lucy_ViewCharBuf*)self);
}

extern size_t Lucy_ViewCB_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Equals(const lucy_ViewCharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Equals_OFFSET;
    const lucy_CB_equals_t method = *((lucy_CB_equals_t*)method_address);
    return method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ViewCB_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ViewCB_Compare_To(const lucy_ViewCharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Compare_To_OFFSET;
    const lucy_CB_compare_to_t method = *((lucy_CB_compare_to_t*)method_address);
    return method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ViewCB_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ViewCB_Hash_Sum(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Hash_Sum_OFFSET;
    const lucy_CB_hash_sum_t method = *((lucy_CB_hash_sum_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ViewCB_Get_VTable(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_Get_Class_Name(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Is_A(const lucy_ViewCharBuf *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ViewCB_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_To_String(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_To_String_OFFSET;
    const lucy_CB_to_string_t method = *((lucy_CB_to_string_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ViewCB_To_I64(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_To_I64_OFFSET;
    const lucy_CB_to_i64_t method = *((lucy_CB_to_i64_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ViewCB_To_F64(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_To_F64_OFFSET;
    const lucy_CB_to_f64_t method = *((lucy_CB_to_f64_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_To_Bool(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Serialize(const lucy_ViewCharBuf *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Serialize_OFFSET;
    const lucy_CB_serialize_t method = *((lucy_CB_serialize_t*)method_address);
    method((lucy_CharBuf*)self, outstream);
}

extern size_t Lucy_ViewCB_Deserialize_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_Deserialize(const lucy_ViewCharBuf *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Deserialize_OFFSET;
    const lucy_CB_deserialize_t method = *((lucy_CB_deserialize_t*)method_address);
    return method((lucy_CharBuf*)self, instream);
}

extern size_t Lucy_ViewCB_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ViewCB_Dump(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ViewCB_Load_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_Load(const lucy_ViewCharBuf *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Load_OFFSET;
    const lucy_CB_load_t method = *((lucy_CB_load_t*)method_address);
    return method((lucy_CharBuf*)self, dump);
}

extern size_t Lucy_ViewCB_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Mimic(const lucy_ViewCharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Mimic_OFFSET;
    const lucy_CB_mimic_t method = *((lucy_CB_mimic_t*)method_address);
    method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ViewCB_Mimic_Str_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Mimic_Str(const lucy_ViewCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Mimic_Str_OFFSET;
    const lucy_CB_mimic_str_t method = *((lucy_CB_mimic_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ViewCB_Cat_Str_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Cat_Str(const lucy_ViewCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Cat_Str_OFFSET;
    const lucy_CB_cat_str_t method = *((lucy_CB_cat_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ViewCB_Cat_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Cat(const lucy_ViewCharBuf *self, const lucy_CharBuf* other) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Cat_OFFSET;
    const lucy_CB_cat_t method = *((lucy_CB_cat_t*)method_address);
    method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ViewCB_VCatF_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_VCatF(const lucy_ViewCharBuf *self, const char* pattern, va_list args) {
    char *const method_address = *(char**)self + Lucy_ViewCB_VCatF_OFFSET;
    const lucy_CB_vcatf_t method = *((lucy_CB_vcatf_t*)method_address);
    method((lucy_CharBuf*)self, pattern, args);
}

extern size_t Lucy_ViewCB_Cat_Char_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Cat_Char(const lucy_ViewCharBuf *self, uint32_t code_point) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Cat_Char_OFFSET;
    const lucy_CB_cat_char_t method = *((lucy_CB_cat_char_t*)method_address);
    method((lucy_CharBuf*)self, code_point);
}

extern size_t Lucy_ViewCB_Swap_Chars_OFFSET;
static CHY_INLINE int32_t
Lucy_ViewCB_Swap_Chars(const lucy_ViewCharBuf *self, uint32_t match, uint32_t replacement) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Swap_Chars_OFFSET;
    const lucy_CB_swap_chars_t method = *((lucy_CB_swap_chars_t*)method_address);
    return method((lucy_CharBuf*)self, match, replacement);
}

extern size_t Lucy_ViewCB_BaseX_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ViewCB_BaseX_To_I64(const lucy_ViewCharBuf *self, uint32_t base) {
    char *const method_address = *(char**)self + Lucy_ViewCB_BaseX_To_I64_OFFSET;
    const lucy_CB_basex_to_i64_t method = *((lucy_CB_basex_to_i64_t*)method_address);
    return method((lucy_CharBuf*)self, base);
}

extern size_t Lucy_ViewCB_Grow_OFFSET;
static CHY_INLINE char*
Lucy_ViewCB_Grow(const lucy_ViewCharBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Grow_OFFSET;
    const lucy_ViewCB_grow_t method = *((lucy_ViewCB_grow_t*)method_address);
    return method((lucy_ViewCharBuf*)self, size);
}

extern size_t Lucy_ViewCB_Starts_With_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Starts_With(const lucy_ViewCharBuf *self, const lucy_CharBuf* prefix) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Starts_With_OFFSET;
    const lucy_CB_starts_with_t method = *((lucy_CB_starts_with_t*)method_address);
    return method((lucy_CharBuf*)self, prefix);
}

extern size_t Lucy_ViewCB_Starts_With_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Starts_With_Str(const lucy_ViewCharBuf *self, const char* prefix, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Starts_With_Str_OFFSET;
    const lucy_CB_starts_with_str_t method = *((lucy_CB_starts_with_str_t*)method_address);
    return method((lucy_CharBuf*)self, prefix, size);
}

extern size_t Lucy_ViewCB_Ends_With_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Ends_With(const lucy_ViewCharBuf *self, const lucy_CharBuf* postfix) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Ends_With_OFFSET;
    const lucy_CB_ends_with_t method = *((lucy_CB_ends_with_t*)method_address);
    return method((lucy_CharBuf*)self, postfix);
}

extern size_t Lucy_ViewCB_Ends_With_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Ends_With_Str(const lucy_ViewCharBuf *self, const char* postfix, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Ends_With_Str_OFFSET;
    const lucy_CB_ends_with_str_t method = *((lucy_CB_ends_with_str_t*)method_address);
    return method((lucy_CharBuf*)self, postfix, size);
}

extern size_t Lucy_ViewCB_Find_OFFSET;
static CHY_INLINE int64_t
Lucy_ViewCB_Find(const lucy_ViewCharBuf *self, const lucy_CharBuf* substring) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Find_OFFSET;
    const lucy_CB_find_t method = *((lucy_CB_find_t*)method_address);
    return method((lucy_CharBuf*)self, substring);
}

extern size_t Lucy_ViewCB_Find_Str_OFFSET;
static CHY_INLINE int64_t
Lucy_ViewCB_Find_Str(const lucy_ViewCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Find_Str_OFFSET;
    const lucy_CB_find_str_t method = *((lucy_CB_find_str_t*)method_address);
    return method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ViewCB_Equals_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ViewCB_Equals_Str(const lucy_ViewCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Equals_Str_OFFSET;
    const lucy_CB_equals_str_t method = *((lucy_CB_equals_str_t*)method_address);
    return method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ViewCB_Length_OFFSET;
static CHY_INLINE size_t
Lucy_ViewCB_Length(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Length_OFFSET;
    const lucy_CB_length_t method = *((lucy_CB_length_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Set_Size_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Set_Size(const lucy_ViewCharBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Set_Size_OFFSET;
    const lucy_CB_set_size_t method = *((lucy_CB_set_size_t*)method_address);
    method((lucy_CharBuf*)self, size);
}

extern size_t Lucy_ViewCB_Get_Size_OFFSET;
static CHY_INLINE size_t
Lucy_ViewCB_Get_Size(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Get_Size_OFFSET;
    const lucy_CB_get_size_t method = *((lucy_CB_get_size_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Get_Ptr8_OFFSET;
static CHY_INLINE uint8_t*
Lucy_ViewCB_Get_Ptr8(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Get_Ptr8_OFFSET;
    const lucy_CB_get_ptr8_t method = *((lucy_CB_get_ptr8_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_To_CB8_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_To_CB8(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_To_CB8_OFFSET;
    const lucy_CB_to_cb8_t method = *((lucy_CB_to_cb8_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Trim_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Trim(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Trim_OFFSET;
    const lucy_CB_trim_t method = *((lucy_CB_trim_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Trim_Top_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Trim_Top(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Trim_Top_OFFSET;
    const lucy_ViewCB_trim_top_t method = *((lucy_ViewCB_trim_top_t*)method_address);
    return method((lucy_ViewCharBuf*)self);
}

extern size_t Lucy_ViewCB_Trim_Tail_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Trim_Tail(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Trim_Tail_OFFSET;
    const lucy_CB_trim_tail_t method = *((lucy_CB_trim_tail_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ViewCB_Nip_OFFSET;
static CHY_INLINE size_t
Lucy_ViewCB_Nip(const lucy_ViewCharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Nip_OFFSET;
    const lucy_ViewCB_nip_t method = *((lucy_ViewCB_nip_t*)method_address);
    return method((lucy_ViewCharBuf*)self, count);
}

extern size_t Lucy_ViewCB_Nip_One_OFFSET;
static CHY_INLINE int32_t
Lucy_ViewCB_Nip_One(const lucy_ViewCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Nip_One_OFFSET;
    const lucy_ViewCB_nip_one_t method = *((lucy_ViewCB_nip_one_t*)method_address);
    return method((lucy_ViewCharBuf*)self);
}

extern size_t Lucy_ViewCB_Chop_OFFSET;
static CHY_INLINE size_t
Lucy_ViewCB_Chop(const lucy_ViewCharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Chop_OFFSET;
    const lucy_CB_chop_t method = *((lucy_CB_chop_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_ViewCB_Truncate_OFFSET;
static CHY_INLINE size_t
Lucy_ViewCB_Truncate(const lucy_ViewCharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Truncate_OFFSET;
    const lucy_CB_truncate_t method = *((lucy_CB_truncate_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_ViewCB_Code_Point_At_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Code_Point_At(const lucy_ViewCharBuf *self, size_t tick) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Code_Point_At_OFFSET;
    const lucy_CB_code_point_at_t method = *((lucy_CB_code_point_at_t*)method_address);
    return method((lucy_CharBuf*)self, tick);
}

extern size_t Lucy_ViewCB_Code_Point_From_OFFSET;
static CHY_INLINE uint32_t
Lucy_ViewCB_Code_Point_From(const lucy_ViewCharBuf *self, size_t tick) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Code_Point_From_OFFSET;
    const lucy_CB_code_point_from_t method = *((lucy_CB_code_point_from_t*)method_address);
    return method((lucy_CharBuf*)self, tick);
}

extern size_t Lucy_ViewCB_SubString_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ViewCB_SubString(const lucy_ViewCharBuf *self, size_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_ViewCB_SubString_OFFSET;
    const lucy_CB_substring_t method = *((lucy_CB_substring_t*)method_address);
    return method((lucy_CharBuf*)self, offset, len);
}

extern size_t Lucy_ViewCB_Cat_Trusted_Str_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Cat_Trusted_Str(const lucy_ViewCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Cat_Trusted_Str_OFFSET;
    const lucy_CB_cat_trusted_str_t method = *((lucy_CB_cat_trusted_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ViewCB_Assign_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Assign(const lucy_ViewCharBuf *self, const lucy_CharBuf* other) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Assign_OFFSET;
    const lucy_ViewCB_assign_t method = *((lucy_ViewCB_assign_t*)method_address);
    method((lucy_ViewCharBuf*)self, other);
}

extern size_t Lucy_ViewCB_Assign_Str_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Assign_Str(const lucy_ViewCharBuf *self, const char* utf8, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Assign_Str_OFFSET;
    const lucy_ViewCB_assign_str_t method = *((lucy_ViewCB_assign_str_t*)method_address);
    method((lucy_ViewCharBuf*)self, utf8, size);
}

extern size_t Lucy_ViewCB_Assign_Trusted_Str_OFFSET;
static CHY_INLINE void
Lucy_ViewCB_Assign_Trusted_Str(const lucy_ViewCharBuf *self, const char* utf8, size_t size) {
    char *const method_address = *(char**)self + Lucy_ViewCB_Assign_Trusted_Str_OFFSET;
    const lucy_ViewCB_assign_trusted_str_t method = *((lucy_ViewCB_assign_trusted_str_t*)method_address);
    method((lucy_ViewCharBuf*)self, utf8, size);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_VIEWCHARBUF_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[56];
} LUCY_VIEWCHARBUF_VT;
extern struct LUCY_VIEWCHARBUF_VT LUCY_VIEWCHARBUF_vt;
#define LUCY_VIEWCHARBUF ((cfish_VTable*)&LUCY_VIEWCHARBUF_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ViewCharBuf lucy_ViewCharBuf
  #define VIEWCHARBUF LUCY_VIEWCHARBUF
  #define ViewCB_new_from_utf8 lucy_ViewCB_new_from_utf8
  #define ViewCB_new_from_trusted_utf8 lucy_ViewCB_new_from_trusted_utf8
  #define ViewCB_init lucy_ViewCB_init
  #define ViewCB_destroy_t lucy_ViewCB_destroy_t
  #define ViewCB_destroy lucy_ViewCB_destroy
  #define ViewCB_grow_t lucy_ViewCB_grow_t
  #define ViewCB_grow lucy_ViewCB_grow
  #define ViewCB_trim_top_t lucy_ViewCB_trim_top_t
  #define ViewCB_trim_top lucy_ViewCB_trim_top
  #define ViewCB_nip_t lucy_ViewCB_nip_t
  #define ViewCB_nip lucy_ViewCB_nip
  #define ViewCB_nip_one_t lucy_ViewCB_nip_one_t
  #define ViewCB_nip_one lucy_ViewCB_nip_one
  #define ViewCB_assign_t lucy_ViewCB_assign_t
  #define ViewCB_assign lucy_ViewCB_assign
  #define ViewCB_assign_str_t lucy_ViewCB_assign_str_t
  #define ViewCB_assign_str lucy_ViewCB_assign_str
  #define ViewCB_assign_trusted_str_t lucy_ViewCB_assign_trusted_str_t
  #define ViewCB_assign_trusted_str lucy_ViewCB_assign_trusted_str
  #define ViewCB_Make Lucy_ViewCB_Make
  #define ViewCB_Get_RefCount Lucy_ViewCB_Get_RefCount
  #define ViewCB_Inc_RefCount Lucy_ViewCB_Inc_RefCount
  #define ViewCB_Dec_RefCount Lucy_ViewCB_Dec_RefCount
  #define ViewCB_To_Host Lucy_ViewCB_To_Host
  #define ViewCB_Clone Lucy_ViewCB_Clone
  #define ViewCB_Destroy Lucy_ViewCB_Destroy
  #define ViewCB_Equals Lucy_ViewCB_Equals
  #define ViewCB_Compare_To Lucy_ViewCB_Compare_To
  #define ViewCB_Hash_Sum Lucy_ViewCB_Hash_Sum
  #define ViewCB_Get_VTable Lucy_ViewCB_Get_VTable
  #define ViewCB_Get_Class_Name Lucy_ViewCB_Get_Class_Name
  #define ViewCB_Is_A Lucy_ViewCB_Is_A
  #define ViewCB_To_String Lucy_ViewCB_To_String
  #define ViewCB_To_I64 Lucy_ViewCB_To_I64
  #define ViewCB_To_F64 Lucy_ViewCB_To_F64
  #define ViewCB_To_Bool Lucy_ViewCB_To_Bool
  #define ViewCB_Serialize Lucy_ViewCB_Serialize
  #define ViewCB_Deserialize Lucy_ViewCB_Deserialize
  #define ViewCB_Dump Lucy_ViewCB_Dump
  #define ViewCB_Load Lucy_ViewCB_Load
  #define ViewCB_Mimic Lucy_ViewCB_Mimic
  #define ViewCB_Mimic_Str Lucy_ViewCB_Mimic_Str
  #define ViewCB_Cat_Str Lucy_ViewCB_Cat_Str
  #define ViewCB_Cat Lucy_ViewCB_Cat
  #define ViewCB_VCatF Lucy_ViewCB_VCatF
  #define ViewCB_Cat_Char Lucy_ViewCB_Cat_Char
  #define ViewCB_Swap_Chars Lucy_ViewCB_Swap_Chars
  #define ViewCB_BaseX_To_I64 Lucy_ViewCB_BaseX_To_I64
  #define ViewCB_Grow Lucy_ViewCB_Grow
  #define ViewCB_Starts_With Lucy_ViewCB_Starts_With
  #define ViewCB_Starts_With_Str Lucy_ViewCB_Starts_With_Str
  #define ViewCB_Ends_With Lucy_ViewCB_Ends_With
  #define ViewCB_Ends_With_Str Lucy_ViewCB_Ends_With_Str
  #define ViewCB_Find Lucy_ViewCB_Find
  #define ViewCB_Find_Str Lucy_ViewCB_Find_Str
  #define ViewCB_Equals_Str Lucy_ViewCB_Equals_Str
  #define ViewCB_Length Lucy_ViewCB_Length
  #define ViewCB_Set_Size Lucy_ViewCB_Set_Size
  #define ViewCB_Get_Size Lucy_ViewCB_Get_Size
  #define ViewCB_Get_Ptr8 Lucy_ViewCB_Get_Ptr8
  #define ViewCB_To_CB8 Lucy_ViewCB_To_CB8
  #define ViewCB_Trim Lucy_ViewCB_Trim
  #define ViewCB_Trim_Top Lucy_ViewCB_Trim_Top
  #define ViewCB_Trim_Tail Lucy_ViewCB_Trim_Tail
  #define ViewCB_Nip Lucy_ViewCB_Nip
  #define ViewCB_Nip_One Lucy_ViewCB_Nip_One
  #define ViewCB_Chop Lucy_ViewCB_Chop
  #define ViewCB_Truncate Lucy_ViewCB_Truncate
  #define ViewCB_Code_Point_At Lucy_ViewCB_Code_Point_At
  #define ViewCB_Code_Point_From Lucy_ViewCB_Code_Point_From
  #define ViewCB_SubString Lucy_ViewCB_SubString
  #define ViewCB_Cat_Trusted_Str Lucy_ViewCB_Cat_Trusted_Str
  #define ViewCB_Assign Lucy_ViewCB_Assign
  #define ViewCB_Assign_Str Lucy_ViewCB_Assign_Str
  #define ViewCB_Assign_Trusted_Str Lucy_ViewCB_Assign_Trusted_Str
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/CharBuf.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ZOMBIECHARBUF
struct lucy_ZombieCharBuf {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* ptr;
    size_t size;
    size_t cap;
};

#endif /* C_LUCY_ZOMBIECHARBUF */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ZombieCharBuf*
lucy_ZCB_new(void* allocation);

lucy_ZombieCharBuf*
lucy_ZCB_newf(void* allocation, size_t alloc_size, const char* pattern, ...);

lucy_ZombieCharBuf*
lucy_ZCB_wrap(void* allocation, const lucy_CharBuf* source);

lucy_ZombieCharBuf*
lucy_ZCB_wrap_str(void* allocation, const char* ptr, size_t size);

size_t
lucy_ZCB_size();

void
lucy_ZCB_destroy(lucy_ZombieCharBuf* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ZCB_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ZCB_destroy_t)(lucy_ZombieCharBuf* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ZCB_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZCB_Make(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Get_RefCount(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZCB_Inc_RefCount(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Dec_RefCount(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ZCB_To_Host(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Clone_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_Clone(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Clone_OFFSET;
    const lucy_CB_clone_t method = *((lucy_CB_clone_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Destroy(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Destroy_OFFSET;
    const lucy_ZCB_destroy_t method = *((lucy_ZCB_destroy_t*)method_address);
    method((lucy_ZombieCharBuf*)self);
}

extern size_t Lucy_ZCB_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Equals(const lucy_ZombieCharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ZCB_Equals_OFFSET;
    const lucy_CB_equals_t method = *((lucy_CB_equals_t*)method_address);
    return method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ZCB_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ZCB_Compare_To(const lucy_ZombieCharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ZCB_Compare_To_OFFSET;
    const lucy_CB_compare_to_t method = *((lucy_CB_compare_to_t*)method_address);
    return method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ZCB_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ZCB_Hash_Sum(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Hash_Sum_OFFSET;
    const lucy_CB_hash_sum_t method = *((lucy_CB_hash_sum_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ZCB_Get_VTable(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_Get_Class_Name(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Is_A(const lucy_ZombieCharBuf *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ZCB_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ZCB_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_To_String(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_To_String_OFFSET;
    const lucy_CB_to_string_t method = *((lucy_CB_to_string_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ZCB_To_I64(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_To_I64_OFFSET;
    const lucy_CB_to_i64_t method = *((lucy_CB_to_i64_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ZCB_To_F64(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_To_F64_OFFSET;
    const lucy_CB_to_f64_t method = *((lucy_CB_to_f64_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_To_Bool(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Serialize(const lucy_ZombieCharBuf *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ZCB_Serialize_OFFSET;
    const lucy_CB_serialize_t method = *((lucy_CB_serialize_t*)method_address);
    method((lucy_CharBuf*)self, outstream);
}

extern size_t Lucy_ZCB_Deserialize_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_Deserialize(const lucy_ZombieCharBuf *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ZCB_Deserialize_OFFSET;
    const lucy_CB_deserialize_t method = *((lucy_CB_deserialize_t*)method_address);
    return method((lucy_CharBuf*)self, instream);
}

extern size_t Lucy_ZCB_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ZCB_Dump(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ZCB_Load_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_Load(const lucy_ZombieCharBuf *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ZCB_Load_OFFSET;
    const lucy_CB_load_t method = *((lucy_CB_load_t*)method_address);
    return method((lucy_CharBuf*)self, dump);
}

extern size_t Lucy_ZCB_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Mimic(const lucy_ZombieCharBuf *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ZCB_Mimic_OFFSET;
    const lucy_CB_mimic_t method = *((lucy_CB_mimic_t*)method_address);
    method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ZCB_Mimic_Str_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Mimic_Str(const lucy_ZombieCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Mimic_Str_OFFSET;
    const lucy_CB_mimic_str_t method = *((lucy_CB_mimic_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ZCB_Cat_Str_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Cat_Str(const lucy_ZombieCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Cat_Str_OFFSET;
    const lucy_CB_cat_str_t method = *((lucy_CB_cat_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ZCB_Cat_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Cat(const lucy_ZombieCharBuf *self, const lucy_CharBuf* other) {
    char *const method_address = *(char**)self + Lucy_ZCB_Cat_OFFSET;
    const lucy_CB_cat_t method = *((lucy_CB_cat_t*)method_address);
    method((lucy_CharBuf*)self, other);
}

extern size_t Lucy_ZCB_VCatF_OFFSET;
static CHY_INLINE void
Lucy_ZCB_VCatF(const lucy_ZombieCharBuf *self, const char* pattern, va_list args) {
    char *const method_address = *(char**)self + Lucy_ZCB_VCatF_OFFSET;
    const lucy_CB_vcatf_t method = *((lucy_CB_vcatf_t*)method_address);
    method((lucy_CharBuf*)self, pattern, args);
}

extern size_t Lucy_ZCB_Cat_Char_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Cat_Char(const lucy_ZombieCharBuf *self, uint32_t code_point) {
    char *const method_address = *(char**)self + Lucy_ZCB_Cat_Char_OFFSET;
    const lucy_CB_cat_char_t method = *((lucy_CB_cat_char_t*)method_address);
    method((lucy_CharBuf*)self, code_point);
}

extern size_t Lucy_ZCB_Swap_Chars_OFFSET;
static CHY_INLINE int32_t
Lucy_ZCB_Swap_Chars(const lucy_ZombieCharBuf *self, uint32_t match, uint32_t replacement) {
    char *const method_address = *(char**)self + Lucy_ZCB_Swap_Chars_OFFSET;
    const lucy_CB_swap_chars_t method = *((lucy_CB_swap_chars_t*)method_address);
    return method((lucy_CharBuf*)self, match, replacement);
}

extern size_t Lucy_ZCB_BaseX_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ZCB_BaseX_To_I64(const lucy_ZombieCharBuf *self, uint32_t base) {
    char *const method_address = *(char**)self + Lucy_ZCB_BaseX_To_I64_OFFSET;
    const lucy_CB_basex_to_i64_t method = *((lucy_CB_basex_to_i64_t*)method_address);
    return method((lucy_CharBuf*)self, base);
}

extern size_t Lucy_ZCB_Grow_OFFSET;
static CHY_INLINE char*
Lucy_ZCB_Grow(const lucy_ZombieCharBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Grow_OFFSET;
    const lucy_ViewCB_grow_t method = *((lucy_ViewCB_grow_t*)method_address);
    return method((lucy_ViewCharBuf*)self, size);
}

extern size_t Lucy_ZCB_Starts_With_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Starts_With(const lucy_ZombieCharBuf *self, const lucy_CharBuf* prefix) {
    char *const method_address = *(char**)self + Lucy_ZCB_Starts_With_OFFSET;
    const lucy_CB_starts_with_t method = *((lucy_CB_starts_with_t*)method_address);
    return method((lucy_CharBuf*)self, prefix);
}

extern size_t Lucy_ZCB_Starts_With_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Starts_With_Str(const lucy_ZombieCharBuf *self, const char* prefix, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Starts_With_Str_OFFSET;
    const lucy_CB_starts_with_str_t method = *((lucy_CB_starts_with_str_t*)method_address);
    return method((lucy_CharBuf*)self, prefix, size);
}

extern size_t Lucy_ZCB_Ends_With_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Ends_With(const lucy_ZombieCharBuf *self, const lucy_CharBuf* postfix) {
    char *const method_address = *(char**)self + Lucy_ZCB_Ends_With_OFFSET;
    const lucy_CB_ends_with_t method = *((lucy_CB_ends_with_t*)method_address);
    return method((lucy_CharBuf*)self, postfix);
}

extern size_t Lucy_ZCB_Ends_With_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Ends_With_Str(const lucy_ZombieCharBuf *self, const char* postfix, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Ends_With_Str_OFFSET;
    const lucy_CB_ends_with_str_t method = *((lucy_CB_ends_with_str_t*)method_address);
    return method((lucy_CharBuf*)self, postfix, size);
}

extern size_t Lucy_ZCB_Find_OFFSET;
static CHY_INLINE int64_t
Lucy_ZCB_Find(const lucy_ZombieCharBuf *self, const lucy_CharBuf* substring) {
    char *const method_address = *(char**)self + Lucy_ZCB_Find_OFFSET;
    const lucy_CB_find_t method = *((lucy_CB_find_t*)method_address);
    return method((lucy_CharBuf*)self, substring);
}

extern size_t Lucy_ZCB_Find_Str_OFFSET;
static CHY_INLINE int64_t
Lucy_ZCB_Find_Str(const lucy_ZombieCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Find_Str_OFFSET;
    const lucy_CB_find_str_t method = *((lucy_CB_find_str_t*)method_address);
    return method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ZCB_Equals_Str_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ZCB_Equals_Str(const lucy_ZombieCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Equals_Str_OFFSET;
    const lucy_CB_equals_str_t method = *((lucy_CB_equals_str_t*)method_address);
    return method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ZCB_Length_OFFSET;
static CHY_INLINE size_t
Lucy_ZCB_Length(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Length_OFFSET;
    const lucy_CB_length_t method = *((lucy_CB_length_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Set_Size_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Set_Size(const lucy_ZombieCharBuf *self, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Set_Size_OFFSET;
    const lucy_CB_set_size_t method = *((lucy_CB_set_size_t*)method_address);
    method((lucy_CharBuf*)self, size);
}

extern size_t Lucy_ZCB_Get_Size_OFFSET;
static CHY_INLINE size_t
Lucy_ZCB_Get_Size(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Get_Size_OFFSET;
    const lucy_CB_get_size_t method = *((lucy_CB_get_size_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Get_Ptr8_OFFSET;
static CHY_INLINE uint8_t*
Lucy_ZCB_Get_Ptr8(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Get_Ptr8_OFFSET;
    const lucy_CB_get_ptr8_t method = *((lucy_CB_get_ptr8_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_To_CB8_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_To_CB8(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_To_CB8_OFFSET;
    const lucy_CB_to_cb8_t method = *((lucy_CB_to_cb8_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Trim_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Trim(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Trim_OFFSET;
    const lucy_CB_trim_t method = *((lucy_CB_trim_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Trim_Top_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Trim_Top(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Trim_Top_OFFSET;
    const lucy_ViewCB_trim_top_t method = *((lucy_ViewCB_trim_top_t*)method_address);
    return method((lucy_ViewCharBuf*)self);
}

extern size_t Lucy_ZCB_Trim_Tail_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Trim_Tail(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Trim_Tail_OFFSET;
    const lucy_CB_trim_tail_t method = *((lucy_CB_trim_tail_t*)method_address);
    return method((lucy_CharBuf*)self);
}

extern size_t Lucy_ZCB_Nip_OFFSET;
static CHY_INLINE size_t
Lucy_ZCB_Nip(const lucy_ZombieCharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_ZCB_Nip_OFFSET;
    const lucy_ViewCB_nip_t method = *((lucy_ViewCB_nip_t*)method_address);
    return method((lucy_ViewCharBuf*)self, count);
}

extern size_t Lucy_ZCB_Nip_One_OFFSET;
static CHY_INLINE int32_t
Lucy_ZCB_Nip_One(const lucy_ZombieCharBuf *self) {
    char *const method_address = *(char**)self + Lucy_ZCB_Nip_One_OFFSET;
    const lucy_ViewCB_nip_one_t method = *((lucy_ViewCB_nip_one_t*)method_address);
    return method((lucy_ViewCharBuf*)self);
}

extern size_t Lucy_ZCB_Chop_OFFSET;
static CHY_INLINE size_t
Lucy_ZCB_Chop(const lucy_ZombieCharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_ZCB_Chop_OFFSET;
    const lucy_CB_chop_t method = *((lucy_CB_chop_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_ZCB_Truncate_OFFSET;
static CHY_INLINE size_t
Lucy_ZCB_Truncate(const lucy_ZombieCharBuf *self, size_t count) {
    char *const method_address = *(char**)self + Lucy_ZCB_Truncate_OFFSET;
    const lucy_CB_truncate_t method = *((lucy_CB_truncate_t*)method_address);
    return method((lucy_CharBuf*)self, count);
}

extern size_t Lucy_ZCB_Code_Point_At_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Code_Point_At(const lucy_ZombieCharBuf *self, size_t tick) {
    char *const method_address = *(char**)self + Lucy_ZCB_Code_Point_At_OFFSET;
    const lucy_CB_code_point_at_t method = *((lucy_CB_code_point_at_t*)method_address);
    return method((lucy_CharBuf*)self, tick);
}

extern size_t Lucy_ZCB_Code_Point_From_OFFSET;
static CHY_INLINE uint32_t
Lucy_ZCB_Code_Point_From(const lucy_ZombieCharBuf *self, size_t tick) {
    char *const method_address = *(char**)self + Lucy_ZCB_Code_Point_From_OFFSET;
    const lucy_CB_code_point_from_t method = *((lucy_CB_code_point_from_t*)method_address);
    return method((lucy_CharBuf*)self, tick);
}

extern size_t Lucy_ZCB_SubString_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ZCB_SubString(const lucy_ZombieCharBuf *self, size_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_ZCB_SubString_OFFSET;
    const lucy_CB_substring_t method = *((lucy_CB_substring_t*)method_address);
    return method((lucy_CharBuf*)self, offset, len);
}

extern size_t Lucy_ZCB_Cat_Trusted_Str_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Cat_Trusted_Str(const lucy_ZombieCharBuf *self, const char* ptr, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Cat_Trusted_Str_OFFSET;
    const lucy_CB_cat_trusted_str_t method = *((lucy_CB_cat_trusted_str_t*)method_address);
    method((lucy_CharBuf*)self, ptr, size);
}

extern size_t Lucy_ZCB_Assign_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Assign(const lucy_ZombieCharBuf *self, const lucy_CharBuf* other) {
    char *const method_address = *(char**)self + Lucy_ZCB_Assign_OFFSET;
    const lucy_ViewCB_assign_t method = *((lucy_ViewCB_assign_t*)method_address);
    method((lucy_ViewCharBuf*)self, other);
}

extern size_t Lucy_ZCB_Assign_Str_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Assign_Str(const lucy_ZombieCharBuf *self, const char* utf8, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Assign_Str_OFFSET;
    const lucy_ViewCB_assign_str_t method = *((lucy_ViewCB_assign_str_t*)method_address);
    method((lucy_ViewCharBuf*)self, utf8, size);
}

extern size_t Lucy_ZCB_Assign_Trusted_Str_OFFSET;
static CHY_INLINE void
Lucy_ZCB_Assign_Trusted_Str(const lucy_ZombieCharBuf *self, const char* utf8, size_t size) {
    char *const method_address = *(char**)self + Lucy_ZCB_Assign_Trusted_Str_OFFSET;
    const lucy_ViewCB_assign_trusted_str_t method = *((lucy_ViewCB_assign_trusted_str_t*)method_address);
    method((lucy_ViewCharBuf*)self, utf8, size);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_ZOMBIECHARBUF_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[56];
} LUCY_ZOMBIECHARBUF_VT;
extern struct LUCY_ZOMBIECHARBUF_VT LUCY_ZOMBIECHARBUF_vt;
#define LUCY_ZOMBIECHARBUF ((cfish_VTable*)&LUCY_ZOMBIECHARBUF_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ZombieCharBuf lucy_ZombieCharBuf
  #define ZOMBIECHARBUF LUCY_ZOMBIECHARBUF
  #define ZCB_new lucy_ZCB_new
  #define ZCB_newf lucy_ZCB_newf
  #define ZCB_wrap lucy_ZCB_wrap
  #define ZCB_wrap_str lucy_ZCB_wrap_str
  #define ZCB_size lucy_ZCB_size
  #define ZCB_destroy_t lucy_ZCB_destroy_t
  #define ZCB_destroy lucy_ZCB_destroy
  #define ZCB_Make Lucy_ZCB_Make
  #define ZCB_Get_RefCount Lucy_ZCB_Get_RefCount
  #define ZCB_Inc_RefCount Lucy_ZCB_Inc_RefCount
  #define ZCB_Dec_RefCount Lucy_ZCB_Dec_RefCount
  #define ZCB_To_Host Lucy_ZCB_To_Host
  #define ZCB_Clone Lucy_ZCB_Clone
  #define ZCB_Destroy Lucy_ZCB_Destroy
  #define ZCB_Equals Lucy_ZCB_Equals
  #define ZCB_Compare_To Lucy_ZCB_Compare_To
  #define ZCB_Hash_Sum Lucy_ZCB_Hash_Sum
  #define ZCB_Get_VTable Lucy_ZCB_Get_VTable
  #define ZCB_Get_Class_Name Lucy_ZCB_Get_Class_Name
  #define ZCB_Is_A Lucy_ZCB_Is_A
  #define ZCB_To_String Lucy_ZCB_To_String
  #define ZCB_To_I64 Lucy_ZCB_To_I64
  #define ZCB_To_F64 Lucy_ZCB_To_F64
  #define ZCB_To_Bool Lucy_ZCB_To_Bool
  #define ZCB_Serialize Lucy_ZCB_Serialize
  #define ZCB_Deserialize Lucy_ZCB_Deserialize
  #define ZCB_Dump Lucy_ZCB_Dump
  #define ZCB_Load Lucy_ZCB_Load
  #define ZCB_Mimic Lucy_ZCB_Mimic
  #define ZCB_Mimic_Str Lucy_ZCB_Mimic_Str
  #define ZCB_Cat_Str Lucy_ZCB_Cat_Str
  #define ZCB_Cat Lucy_ZCB_Cat
  #define ZCB_VCatF Lucy_ZCB_VCatF
  #define ZCB_Cat_Char Lucy_ZCB_Cat_Char
  #define ZCB_Swap_Chars Lucy_ZCB_Swap_Chars
  #define ZCB_BaseX_To_I64 Lucy_ZCB_BaseX_To_I64
  #define ZCB_Grow Lucy_ZCB_Grow
  #define ZCB_Starts_With Lucy_ZCB_Starts_With
  #define ZCB_Starts_With_Str Lucy_ZCB_Starts_With_Str
  #define ZCB_Ends_With Lucy_ZCB_Ends_With
  #define ZCB_Ends_With_Str Lucy_ZCB_Ends_With_Str
  #define ZCB_Find Lucy_ZCB_Find
  #define ZCB_Find_Str Lucy_ZCB_Find_Str
  #define ZCB_Equals_Str Lucy_ZCB_Equals_Str
  #define ZCB_Length Lucy_ZCB_Length
  #define ZCB_Set_Size Lucy_ZCB_Set_Size
  #define ZCB_Get_Size Lucy_ZCB_Get_Size
  #define ZCB_Get_Ptr8 Lucy_ZCB_Get_Ptr8
  #define ZCB_To_CB8 Lucy_ZCB_To_CB8
  #define ZCB_Trim Lucy_ZCB_Trim
  #define ZCB_Trim_Top Lucy_ZCB_Trim_Top
  #define ZCB_Trim_Tail Lucy_ZCB_Trim_Tail
  #define ZCB_Nip Lucy_ZCB_Nip
  #define ZCB_Nip_One Lucy_ZCB_Nip_One
  #define ZCB_Chop Lucy_ZCB_Chop
  #define ZCB_Truncate Lucy_ZCB_Truncate
  #define ZCB_Code_Point_At Lucy_ZCB_Code_Point_At
  #define ZCB_Code_Point_From Lucy_ZCB_Code_Point_From
  #define ZCB_SubString Lucy_ZCB_SubString
  #define ZCB_Cat_Trusted_Str Lucy_ZCB_Cat_Trusted_Str
  #define ZCB_Assign Lucy_ZCB_Assign
  #define ZCB_Assign_Str Lucy_ZCB_Assign_Str
  #define ZCB_Assign_Trusted_Str Lucy_ZCB_Assign_Trusted_Str
#endif /* LUCY_USE_SHORT_NAMES */



#define CFISH_ZCB_BLANK() lucy_ZCB_new(alloca(lucy_ZCB_size()))

#define CFISH_ZCB_LITERAL(string) \
    { LUCY_ZOMBIECHARBUF, {1}, string "", sizeof(string) -1, sizeof(string) }

#define CFISH_ZCB_WRAP(source) \
    lucy_ZCB_wrap(alloca(lucy_ZCB_size()), source)

#define CFISH_ZCB_WRAP_STR(ptr, size) \
    lucy_ZCB_wrap_str(alloca(lucy_ZCB_size()), ptr, size)

extern lucy_ZombieCharBuf CFISH_ZCB_EMPTY;

#ifdef LUCY_USE_SHORT_NAMES
  #define ZCB_BLANK             CFISH_ZCB_BLANK
  #define ZCB_LITERAL(_string)  CFISH_ZCB_LITERAL(_string)
  #define EMPTY                 CFISH_ZCB_EMPTY
  #define ZCB_WRAP              CFISH_ZCB_WRAP
  #define ZCB_WRAP_STR          CFISH_ZCB_WRAP_STR
#endif



#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_CHARBUF */




