/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_ERR
#define H_LUCY_OBJECT_ERR 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ERR
struct lucy_Err {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* mess;
};

#endif /* C_LUCY_ERR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Err*
lucy_Err_new(lucy_CharBuf* mess);

lucy_Err*
lucy_Err_init(lucy_Err* self, lucy_CharBuf* mess);

void
lucy_Err_set_error(lucy_Err* error);

lucy_Err*
lucy_Err_get_error();

void
lucy_Err_warn_at(const char* file, int line, const char* func, const char* pattern, ...);

void
lucy_Err_throw_at(lucy_VTable* vtable, const char* file, int line, const char* func, const char* pattern, ...);

void
lucy_Err_rethrow(lucy_Err* error, const char* file, int line, const char* func);

void
lucy_Err_throw_mess(lucy_VTable* vtable, lucy_CharBuf* message);

void
lucy_Err_do_throw(lucy_Err* self);

void
lucy_Err_warn_mess(lucy_CharBuf* message);

lucy_CharBuf*
lucy_Err_make_mess(const char* file, int line, const char* func, const char* pattern, ...);

lucy_Obj*
lucy_Err_downcast(lucy_Obj* obj, lucy_VTable* vtable, const char* file, int line, const char* func);

lucy_Obj*
lucy_Err_certify(lucy_Obj* obj, lucy_VTable* vtable, const char* file, int line, const char* func);

static CHY_INLINE void
lucy_Err_abstract_class_check(lucy_Obj* obj, lucy_VTable* vtable);

char*
lucy_Err_win_error();

lucy_Err*
lucy_Err_make(lucy_Err* self);

void*
lucy_Err_to_host(lucy_Err* self);

void
lucy_Err_destroy(lucy_Err* self);

lucy_CharBuf*
lucy_Err_to_string(lucy_Err* self);

void
lucy_Err_cat_mess(lucy_Err* self, const lucy_CharBuf* mess);

lucy_CharBuf*
lucy_Err_get_mess(lucy_Err* self);

void
lucy_Err_add_frame(lucy_Err* self, const char* file, int line, const char* func);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Err_make_CALLBACK;
extern cfish_Callback lucy_Err_destroy_CALLBACK;
extern cfish_Callback lucy_Err_to_string_CALLBACK;
extern cfish_Callback lucy_Err_cat_mess_CALLBACK;
extern cfish_Callback lucy_Err_get_mess_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_Err*
(*lucy_Err_make_t)(lucy_Err* self);

typedef void*
(*lucy_Err_to_host_t)(lucy_Err* self);

typedef void
(*lucy_Err_destroy_t)(lucy_Err* self);

typedef lucy_CharBuf*
(*lucy_Err_to_string_t)(lucy_Err* self);

typedef void
(*lucy_Err_cat_mess_t)(lucy_Err* self, const lucy_CharBuf* mess);

typedef lucy_CharBuf*
(*lucy_Err_get_mess_t)(lucy_Err* self);

typedef void
(*lucy_Err_add_frame_t)(lucy_Err* self, const char* file, int line, const char* func);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Err_Make_OFFSET;
static CHY_INLINE lucy_Err*
Lucy_Err_Make(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Make_OFFSET;
    const lucy_Err_make_t method = *((lucy_Err_make_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_Err_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Err_Get_RefCount(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Err_Inc_RefCount(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Err_Dec_RefCount(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Err_To_Host(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_To_Host_OFFSET;
    const lucy_Err_to_host_t method = *((lucy_Err_to_host_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_Err_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Err_Clone(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Err_Destroy(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Destroy_OFFSET;
    const lucy_Err_destroy_t method = *((lucy_Err_destroy_t*)method_address);
    method((lucy_Err*)self);
}

extern size_t Lucy_Err_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Err_Equals(const lucy_Err *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Err_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Err_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Err_Compare_To(const lucy_Err *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Err_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Err_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Err_Hash_Sum(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Err_Get_VTable(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Err_Get_Class_Name(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Err_Is_A(const lucy_Err *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Err_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Err_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Err_To_String(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_To_String_OFFSET;
    const lucy_Err_to_string_t method = *((lucy_Err_to_string_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_Err_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Err_To_I64(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Err_To_F64(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Err_To_Bool(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Err_Serialize(const lucy_Err *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Err_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Err_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Err_Deserialize(const lucy_Err *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Err_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Err_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Err_Dump(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Err_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Err_Load(const lucy_Err *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Err_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Err_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Err_Mimic(const lucy_Err *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Err_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Err_Cat_Mess_OFFSET;
static CHY_INLINE void
Lucy_Err_Cat_Mess(const lucy_Err *self, const lucy_CharBuf* mess) {
    char *const method_address = *(char**)self + Lucy_Err_Cat_Mess_OFFSET;
    const lucy_Err_cat_mess_t method = *((lucy_Err_cat_mess_t*)method_address);
    method((lucy_Err*)self, mess);
}

extern size_t Lucy_Err_Get_Mess_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Err_Get_Mess(const lucy_Err *self) {
    char *const method_address = *(char**)self + Lucy_Err_Get_Mess_OFFSET;
    const lucy_Err_get_mess_t method = *((lucy_Err_get_mess_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_Err_Add_Frame_OFFSET;
static CHY_INLINE void
Lucy_Err_Add_Frame(const lucy_Err *self, const char* file, int line, const char* func) {
    char *const method_address = *(char**)self + Lucy_Err_Add_Frame_OFFSET;
    const lucy_Err_add_frame_t method = *((lucy_Err_add_frame_t*)method_address);
    method((lucy_Err*)self, file, line, func);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_ERR_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_ERR_VT;
extern struct LUCY_ERR_VT LUCY_ERR_vt;
#define LUCY_ERR ((cfish_VTable*)&LUCY_ERR_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Err lucy_Err
  #define ERR LUCY_ERR
  #define Err_new lucy_Err_new
  #define Err_init lucy_Err_init
  #define Err_set_error lucy_Err_set_error
  #define Err_get_error lucy_Err_get_error
  #define Err_warn_at lucy_Err_warn_at
  #define Err_throw_at lucy_Err_throw_at
  #define Err_rethrow lucy_Err_rethrow
  #define Err_throw_mess lucy_Err_throw_mess
  #define Err_do_throw lucy_Err_do_throw
  #define Err_warn_mess lucy_Err_warn_mess
  #define Err_make_mess lucy_Err_make_mess
  #define Err_downcast lucy_Err_downcast
  #define Err_certify lucy_Err_certify
  #define Err_abstract_class_check lucy_Err_abstract_class_check
  #define Err_win_error lucy_Err_win_error
  #define Err_make_t lucy_Err_make_t
  #define Err_make lucy_Err_make
  #define Err_to_host_t lucy_Err_to_host_t
  #define Err_to_host lucy_Err_to_host
  #define Err_destroy_t lucy_Err_destroy_t
  #define Err_destroy lucy_Err_destroy
  #define Err_to_string_t lucy_Err_to_string_t
  #define Err_to_string lucy_Err_to_string
  #define Err_cat_mess_t lucy_Err_cat_mess_t
  #define Err_cat_mess lucy_Err_cat_mess
  #define Err_get_mess_t lucy_Err_get_mess_t
  #define Err_get_mess lucy_Err_get_mess
  #define Err_add_frame_t lucy_Err_add_frame_t
  #define Err_add_frame lucy_Err_add_frame
  #define Err_Make Lucy_Err_Make
  #define Err_Get_RefCount Lucy_Err_Get_RefCount
  #define Err_Inc_RefCount Lucy_Err_Inc_RefCount
  #define Err_Dec_RefCount Lucy_Err_Dec_RefCount
  #define Err_To_Host Lucy_Err_To_Host
  #define Err_Clone Lucy_Err_Clone
  #define Err_Destroy Lucy_Err_Destroy
  #define Err_Equals Lucy_Err_Equals
  #define Err_Compare_To Lucy_Err_Compare_To
  #define Err_Hash_Sum Lucy_Err_Hash_Sum
  #define Err_Get_VTable Lucy_Err_Get_VTable
  #define Err_Get_Class_Name Lucy_Err_Get_Class_Name
  #define Err_Is_A Lucy_Err_Is_A
  #define Err_To_String Lucy_Err_To_String
  #define Err_To_I64 Lucy_Err_To_I64
  #define Err_To_F64 Lucy_Err_To_F64
  #define Err_To_Bool Lucy_Err_To_Bool
  #define Err_Serialize Lucy_Err_Serialize
  #define Err_Deserialize Lucy_Err_Deserialize
  #define Err_Dump Lucy_Err_Dump
  #define Err_Load Lucy_Err_Load
  #define Err_Mimic Lucy_Err_Mimic
  #define Err_Cat_Mess Lucy_Err_Cat_Mess
  #define Err_Get_Mess Lucy_Err_Get_Mess
  #define Err_Add_Frame Lucy_Err_Add_Frame
#endif /* LUCY_USE_SHORT_NAMES */



#ifdef CHY_HAS_FUNC_MACRO
 #define CFISH_ERR_FUNC_MACRO CHY_FUNC_MACRO
#else
 #define CFISH_ERR_FUNC_MACRO NULL
#endif

#define CFISH_ERR_ADD_FRAME(_error) \
    Lucy_Err_Add_Frame(_error, __FILE__, __LINE__, \
                       CFISH_ERR_FUNC_MACRO)

#define CFISH_RETHROW(_error) \
    lucy_Err_rethrow((lucy_Err*)_error, __FILE__, __LINE__, \
                     CFISH_ERR_FUNC_MACRO)

/** Macro version of lucy_Err_throw_at which inserts contextual information
 * automatically, provided that the compiler supports the necessary features.
 */
#ifdef CHY_HAS_VARIADIC_MACROS
 #ifdef CHY_HAS_ISO_VARIADIC_MACROS
  #define CFISH_THROW(_vtable, ...) \
    lucy_Err_throw_at(_vtable, __FILE__, __LINE__, CFISH_ERR_FUNC_MACRO, \
                      __VA_ARGS__)
  #define CFISH_WARN(...) \
    lucy_Err_warn_at(__FILE__, __LINE__, CFISH_ERR_FUNC_MACRO, __VA_ARGS__)
  #define CFISH_MAKE_MESS(...) \
    lucy_Err_make_mess(__FILE__, __LINE__, CFISH_ERR_FUNC_MACRO, \
                       __VA_ARGS__)
 #elif defined(CHY_HAS_GNUC_VARIADIC_MACROS)
  #define CFISH_THROW(_vtable, args...) \
    lucy_Err_throw_at(_vtable, __FILE__, __LINE__, \
                      CFISH_ERR_FUNC_MACRO, ##args)
  #define CFISH_WARN(args...) \
    lucy_Err_warn_at(__FILE__, __LINE__, CFISH_ERR_FUNC_MACRO, ##args)
  #define CFISH_MAKE_MESS(args...) \
    lucy_Err_make_mess(__FILE__, __LINE__, CFISH_ERR_FUNC_MACRO, ##args)
 #endif
#else
  void
  CFISH_THROW(lucy_VTable *vtable, char* format, ...);
  void
  CFISH_WARN(char* format, ...);
  lucy_CharBuf*
  CFISH_MAKE_MESS(char* format, ...);
#endif

#define CFISH_DOWNCAST(_obj, _vtable) \
    lucy_Err_downcast((lucy_Obj*)(_obj), (_vtable), \
                      __FILE__, __LINE__, CFISH_ERR_FUNC_MACRO)


#define CFISH_CERTIFY(_obj, _vtable) \
    lucy_Err_certify((lucy_Obj*)(_obj), (_vtable), \
                     __FILE__, __LINE__, CFISH_ERR_FUNC_MACRO)

static CHY_INLINE void
lucy_Err_abstract_class_check(lucy_Obj *obj, lucy_VTable *vtable) {
    lucy_VTable *const my_vtable = *(lucy_VTable**)obj;
    if (my_vtable == vtable) {
        lucy_CharBuf *mess = CFISH_MAKE_MESS("%o is an abstract class",
                                             Lucy_Obj_Get_Class_Name(obj));
        Lucy_Obj_Dec_RefCount(obj);
        lucy_Err_throw_mess(LUCY_ERR, mess);
    }
}

#define CFISH_ABSTRACT_CLASS_CHECK(_obj, _vtable) \
    lucy_Err_abstract_class_check(((lucy_Obj*)_obj), _vtable)

#ifdef LUCY_USE_SHORT_NAMES
  #define THROW                 CFISH_THROW
  #define RETHROW               CFISH_RETHROW
  #define WARN                  CFISH_WARN
  #define MAKE_MESS             CFISH_MAKE_MESS
  #define ERR_ADD_FRAME         CFISH_ERR_ADD_FRAME
  #define ERR_FUNC_MACRO        CFISH_ERR_FUNC_MACRO
  #define DOWNCAST              CFISH_DOWNCAST
  #define CERTIFY               CFISH_CERTIFY
  #define ABSTRACT_CLASS_CHECK  CFISH_ABSTRACT_CLASS_CHECK
#endif



#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_ERR */




