/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_HASH
#define H_LUCY_OBJECT_HASH 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HASH
struct lucy_Hash {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    void* entries;
    uint32_t capacity;
    uint32_t size;
    uint32_t threshold;
    int32_t iter_tick;
};

#endif /* C_LUCY_HASH */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Hash*
lucy_Hash_new(uint32_t capacity);

lucy_Hash*
lucy_Hash_init(lucy_Hash* self, uint32_t capacity);

void
lucy_Hash_destroy(lucy_Hash* self);

chy_bool_t
lucy_Hash_equals(lucy_Hash* self, lucy_Obj* other);

void
lucy_Hash_serialize(lucy_Hash* self, lucy_OutStream* outstream);

lucy_Hash*
lucy_Hash_deserialize(lucy_Hash* self, lucy_InStream* instream);

lucy_Hash*
lucy_Hash_dump(lucy_Hash* self);

lucy_Obj*
lucy_Hash_load(lucy_Hash* self, lucy_Obj* dump);

void
lucy_Hash_clear(lucy_Hash* self);

void
lucy_Hash_store(lucy_Hash* self, lucy_Obj* key, lucy_Obj* value);

void
lucy_Hash_store_str(lucy_Hash* self, const char* str, size_t len, lucy_Obj* value);

lucy_Obj*
lucy_Hash_fetch(lucy_Hash* self, const lucy_Obj* key);

lucy_Obj*
lucy_Hash_fetch_str(lucy_Hash* self, const char* key, size_t key_len);

lucy_Obj*
lucy_Hash_delete(lucy_Hash* self, const lucy_Obj* key);

lucy_Obj*
lucy_Hash_delete_str(lucy_Hash* self, const char* key, size_t key_ley);

uint32_t
lucy_Hash_iterate(lucy_Hash* self);

chy_bool_t
lucy_Hash_next(lucy_Hash* self, lucy_Obj** key, lucy_Obj** value);

lucy_Obj*
lucy_Hash_find_key(lucy_Hash* self, const lucy_Obj* key, int32_t hash_sum);

lucy_VArray*
lucy_Hash_keys(lucy_Hash* self);

lucy_VArray*
lucy_Hash_values(lucy_Hash* self);

lucy_Obj*
lucy_Hash_make_key(lucy_Hash* self, lucy_Obj* key, int32_t hash_sum);

uint32_t
lucy_Hash_get_capacity(lucy_Hash* self);

uint32_t
lucy_Hash_get_size(lucy_Hash* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Hash_destroy_CALLBACK;
extern cfish_Callback lucy_Hash_equals_CALLBACK;
extern cfish_Callback lucy_Hash_serialize_CALLBACK;
extern cfish_Callback lucy_Hash_deserialize_CALLBACK;
extern cfish_Callback lucy_Hash_dump_CALLBACK;
extern cfish_Callback lucy_Hash_load_CALLBACK;
extern cfish_Callback lucy_Hash_make_key_CALLBACK;
extern cfish_Callback lucy_Hash_get_size_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Hash_destroy_t)(lucy_Hash* self);

typedef chy_bool_t
(*lucy_Hash_equals_t)(lucy_Hash* self, lucy_Obj* other);

typedef void
(*lucy_Hash_serialize_t)(lucy_Hash* self, lucy_OutStream* outstream);

typedef lucy_Hash*
(*lucy_Hash_deserialize_t)(lucy_Hash* self, lucy_InStream* instream);

typedef lucy_Hash*
(*lucy_Hash_dump_t)(lucy_Hash* self);

typedef lucy_Obj*
(*lucy_Hash_load_t)(lucy_Hash* self, lucy_Obj* dump);

typedef void
(*lucy_Hash_clear_t)(lucy_Hash* self);

typedef void
(*lucy_Hash_store_t)(lucy_Hash* self, lucy_Obj* key, lucy_Obj* value);

typedef void
(*lucy_Hash_store_str_t)(lucy_Hash* self, const char* str, size_t len, lucy_Obj* value);

typedef lucy_Obj*
(*lucy_Hash_fetch_t)(lucy_Hash* self, const lucy_Obj* key);

typedef lucy_Obj*
(*lucy_Hash_fetch_str_t)(lucy_Hash* self, const char* key, size_t key_len);

typedef lucy_Obj*
(*lucy_Hash_delete_t)(lucy_Hash* self, const lucy_Obj* key);

typedef lucy_Obj*
(*lucy_Hash_delete_str_t)(lucy_Hash* self, const char* key, size_t key_ley);

typedef uint32_t
(*lucy_Hash_iterate_t)(lucy_Hash* self);

typedef chy_bool_t
(*lucy_Hash_next_t)(lucy_Hash* self, lucy_Obj** key, lucy_Obj** value);

typedef lucy_Obj*
(*lucy_Hash_find_key_t)(lucy_Hash* self, const lucy_Obj* key, int32_t hash_sum);

typedef lucy_VArray*
(*lucy_Hash_keys_t)(lucy_Hash* self);

typedef lucy_VArray*
(*lucy_Hash_values_t)(lucy_Hash* self);

typedef lucy_Obj*
(*lucy_Hash_make_key_t)(lucy_Hash* self, lucy_Obj* key, int32_t hash_sum);

typedef uint32_t
(*lucy_Hash_get_capacity_t)(lucy_Hash* self);

typedef uint32_t
(*lucy_Hash_get_size_t)(lucy_Hash* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Hash_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Make(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hash_Get_RefCount(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Inc_RefCount(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hash_Dec_RefCount(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Hash_To_Host(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Clone(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Hash_Destroy(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Destroy_OFFSET;
    const lucy_Hash_destroy_t method = *((lucy_Hash_destroy_t*)method_address);
    method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hash_Equals(const lucy_Hash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Hash_Equals_OFFSET;
    const lucy_Hash_equals_t method = *((lucy_Hash_equals_t*)method_address);
    return method((lucy_Hash*)self, other);
}

extern size_t Lucy_Hash_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Hash_Compare_To(const lucy_Hash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Hash_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Hash_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Hash_Hash_Sum(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Hash_Get_VTable(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Hash_Get_Class_Name(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hash_Is_A(const lucy_Hash *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Hash_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Hash_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Hash_To_String(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Hash_To_I64(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Hash_To_F64(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hash_To_Bool(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hash_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Hash_Serialize(const lucy_Hash *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Hash_Serialize_OFFSET;
    const lucy_Hash_serialize_t method = *((lucy_Hash_serialize_t*)method_address);
    method((lucy_Hash*)self, outstream);
}

extern size_t Lucy_Hash_Deserialize_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_Hash_Deserialize(const lucy_Hash *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Hash_Deserialize_OFFSET;
    const lucy_Hash_deserialize_t method = *((lucy_Hash_deserialize_t*)method_address);
    return method((lucy_Hash*)self, instream);
}

extern size_t Lucy_Hash_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_Hash_Dump(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Dump_OFFSET;
    const lucy_Hash_dump_t method = *((lucy_Hash_dump_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Load(const lucy_Hash *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Hash_Load_OFFSET;
    const lucy_Hash_load_t method = *((lucy_Hash_load_t*)method_address);
    return method((lucy_Hash*)self, dump);
}

extern size_t Lucy_Hash_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Hash_Mimic(const lucy_Hash *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Hash_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Hash_Clear_OFFSET;
static CHY_INLINE void
Lucy_Hash_Clear(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Clear_OFFSET;
    const lucy_Hash_clear_t method = *((lucy_Hash_clear_t*)method_address);
    method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Store_OFFSET;
static CHY_INLINE void
Lucy_Hash_Store(const lucy_Hash *self, lucy_Obj* key, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_Hash_Store_OFFSET;
    const lucy_Hash_store_t method = *((lucy_Hash_store_t*)method_address);
    method((lucy_Hash*)self, key, value);
}

extern size_t Lucy_Hash_Store_Str_OFFSET;
static CHY_INLINE void
Lucy_Hash_Store_Str(const lucy_Hash *self, const char* str, size_t len, lucy_Obj* value) {
    char *const method_address = *(char**)self + Lucy_Hash_Store_Str_OFFSET;
    const lucy_Hash_store_str_t method = *((lucy_Hash_store_str_t*)method_address);
    method((lucy_Hash*)self, str, len, value);
}

extern size_t Lucy_Hash_Fetch_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Fetch(const lucy_Hash *self, const lucy_Obj* key) {
    char *const method_address = *(char**)self + Lucy_Hash_Fetch_OFFSET;
    const lucy_Hash_fetch_t method = *((lucy_Hash_fetch_t*)method_address);
    return method((lucy_Hash*)self, key);
}

extern size_t Lucy_Hash_Fetch_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Fetch_Str(const lucy_Hash *self, const char* key, size_t key_len) {
    char *const method_address = *(char**)self + Lucy_Hash_Fetch_Str_OFFSET;
    const lucy_Hash_fetch_str_t method = *((lucy_Hash_fetch_str_t*)method_address);
    return method((lucy_Hash*)self, key, key_len);
}

extern size_t Lucy_Hash_Delete_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Delete(const lucy_Hash *self, const lucy_Obj* key) {
    char *const method_address = *(char**)self + Lucy_Hash_Delete_OFFSET;
    const lucy_Hash_delete_t method = *((lucy_Hash_delete_t*)method_address);
    return method((lucy_Hash*)self, key);
}

extern size_t Lucy_Hash_Delete_Str_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Delete_Str(const lucy_Hash *self, const char* key, size_t key_ley) {
    char *const method_address = *(char**)self + Lucy_Hash_Delete_Str_OFFSET;
    const lucy_Hash_delete_str_t method = *((lucy_Hash_delete_str_t*)method_address);
    return method((lucy_Hash*)self, key, key_ley);
}

extern size_t Lucy_Hash_Iterate_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hash_Iterate(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Iterate_OFFSET;
    const lucy_Hash_iterate_t method = *((lucy_Hash_iterate_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hash_Next(const lucy_Hash *self, lucy_Obj** key, lucy_Obj** value) {
    char *const method_address = *(char**)self + Lucy_Hash_Next_OFFSET;
    const lucy_Hash_next_t method = *((lucy_Hash_next_t*)method_address);
    return method((lucy_Hash*)self, key, value);
}

extern size_t Lucy_Hash_Find_Key_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Find_Key(const lucy_Hash *self, const lucy_Obj* key, int32_t hash_sum) {
    char *const method_address = *(char**)self + Lucy_Hash_Find_Key_OFFSET;
    const lucy_Hash_find_key_t method = *((lucy_Hash_find_key_t*)method_address);
    return method((lucy_Hash*)self, key, hash_sum);
}

extern size_t Lucy_Hash_Keys_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Hash_Keys(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Keys_OFFSET;
    const lucy_Hash_keys_t method = *((lucy_Hash_keys_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Values_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Hash_Values(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Values_OFFSET;
    const lucy_Hash_values_t method = *((lucy_Hash_values_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Make_Key_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hash_Make_Key(const lucy_Hash *self, lucy_Obj* key, int32_t hash_sum) {
    char *const method_address = *(char**)self + Lucy_Hash_Make_Key_OFFSET;
    const lucy_Hash_make_key_t method = *((lucy_Hash_make_key_t*)method_address);
    return method((lucy_Hash*)self, key, hash_sum);
}

extern size_t Lucy_Hash_Get_Capacity_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hash_Get_Capacity(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Get_Capacity_OFFSET;
    const lucy_Hash_get_capacity_t method = *((lucy_Hash_get_capacity_t*)method_address);
    return method((lucy_Hash*)self);
}

extern size_t Lucy_Hash_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hash_Get_Size(const lucy_Hash *self) {
    char *const method_address = *(char**)self + Lucy_Hash_Get_Size_OFFSET;
    const lucy_Hash_get_size_t method = *((lucy_Hash_get_size_t*)method_address);
    return method((lucy_Hash*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HASH_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[37];
} LUCY_HASH_VT;
extern struct LUCY_HASH_VT LUCY_HASH_vt;
#define LUCY_HASH ((cfish_VTable*)&LUCY_HASH_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Hash lucy_Hash
  #define HASH LUCY_HASH
  #define Hash_new lucy_Hash_new
  #define Hash_init lucy_Hash_init
  #define Hash_destroy_t lucy_Hash_destroy_t
  #define Hash_destroy lucy_Hash_destroy
  #define Hash_equals_t lucy_Hash_equals_t
  #define Hash_equals lucy_Hash_equals
  #define Hash_serialize_t lucy_Hash_serialize_t
  #define Hash_serialize lucy_Hash_serialize
  #define Hash_deserialize_t lucy_Hash_deserialize_t
  #define Hash_deserialize lucy_Hash_deserialize
  #define Hash_dump_t lucy_Hash_dump_t
  #define Hash_dump lucy_Hash_dump
  #define Hash_load_t lucy_Hash_load_t
  #define Hash_load lucy_Hash_load
  #define Hash_clear_t lucy_Hash_clear_t
  #define Hash_clear lucy_Hash_clear
  #define Hash_store_t lucy_Hash_store_t
  #define Hash_store lucy_Hash_store
  #define Hash_store_str_t lucy_Hash_store_str_t
  #define Hash_store_str lucy_Hash_store_str
  #define Hash_fetch_t lucy_Hash_fetch_t
  #define Hash_fetch lucy_Hash_fetch
  #define Hash_fetch_str_t lucy_Hash_fetch_str_t
  #define Hash_fetch_str lucy_Hash_fetch_str
  #define Hash_delete_t lucy_Hash_delete_t
  #define Hash_delete lucy_Hash_delete
  #define Hash_delete_str_t lucy_Hash_delete_str_t
  #define Hash_delete_str lucy_Hash_delete_str
  #define Hash_iterate_t lucy_Hash_iterate_t
  #define Hash_iterate lucy_Hash_iterate
  #define Hash_next_t lucy_Hash_next_t
  #define Hash_next lucy_Hash_next
  #define Hash_find_key_t lucy_Hash_find_key_t
  #define Hash_find_key lucy_Hash_find_key
  #define Hash_keys_t lucy_Hash_keys_t
  #define Hash_keys lucy_Hash_keys
  #define Hash_values_t lucy_Hash_values_t
  #define Hash_values lucy_Hash_values
  #define Hash_make_key_t lucy_Hash_make_key_t
  #define Hash_make_key lucy_Hash_make_key
  #define Hash_get_capacity_t lucy_Hash_get_capacity_t
  #define Hash_get_capacity lucy_Hash_get_capacity
  #define Hash_get_size_t lucy_Hash_get_size_t
  #define Hash_get_size lucy_Hash_get_size
  #define Hash_Make Lucy_Hash_Make
  #define Hash_Get_RefCount Lucy_Hash_Get_RefCount
  #define Hash_Inc_RefCount Lucy_Hash_Inc_RefCount
  #define Hash_Dec_RefCount Lucy_Hash_Dec_RefCount
  #define Hash_To_Host Lucy_Hash_To_Host
  #define Hash_Clone Lucy_Hash_Clone
  #define Hash_Destroy Lucy_Hash_Destroy
  #define Hash_Equals Lucy_Hash_Equals
  #define Hash_Compare_To Lucy_Hash_Compare_To
  #define Hash_Hash_Sum Lucy_Hash_Hash_Sum
  #define Hash_Get_VTable Lucy_Hash_Get_VTable
  #define Hash_Get_Class_Name Lucy_Hash_Get_Class_Name
  #define Hash_Is_A Lucy_Hash_Is_A
  #define Hash_To_String Lucy_Hash_To_String
  #define Hash_To_I64 Lucy_Hash_To_I64
  #define Hash_To_F64 Lucy_Hash_To_F64
  #define Hash_To_Bool Lucy_Hash_To_Bool
  #define Hash_Serialize Lucy_Hash_Serialize
  #define Hash_Deserialize Lucy_Hash_Deserialize
  #define Hash_Dump Lucy_Hash_Dump
  #define Hash_Load Lucy_Hash_Load
  #define Hash_Mimic Lucy_Hash_Mimic
  #define Hash_Clear Lucy_Hash_Clear
  #define Hash_Store Lucy_Hash_Store
  #define Hash_Store_Str Lucy_Hash_Store_Str
  #define Hash_Fetch Lucy_Hash_Fetch
  #define Hash_Fetch_Str Lucy_Hash_Fetch_Str
  #define Hash_Delete Lucy_Hash_Delete
  #define Hash_Delete_Str Lucy_Hash_Delete_Str
  #define Hash_Iterate Lucy_Hash_Iterate
  #define Hash_Next Lucy_Hash_Next
  #define Hash_Find_Key Lucy_Hash_Find_Key
  #define Hash_Keys Lucy_Hash_Keys
  #define Hash_Values Lucy_Hash_Values
  #define Hash_Make_Key Lucy_Hash_Make_Key
  #define Hash_Get_Capacity Lucy_Hash_Get_Capacity
  #define Hash_Get_Size Lucy_Hash_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HASHTOMBSTONE
struct lucy_HashTombStone {
    lucy_VTable* vtable;
    lucy_ref_t ref;
};

#endif /* C_LUCY_HASHTOMBSTONE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

uint32_t
lucy_HashTombStone_get_refcount(lucy_HashTombStone* self);

lucy_HashTombStone*
lucy_HashTombStone_inc_refcount(lucy_HashTombStone* self);

uint32_t
lucy_HashTombStone_dec_refcount(lucy_HashTombStone* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*lucy_HashTombStone_get_refcount_t)(lucy_HashTombStone* self);

typedef lucy_HashTombStone*
(*lucy_HashTombStone_inc_refcount_t)(lucy_HashTombStone* self);

typedef uint32_t
(*lucy_HashTombStone_dec_refcount_t)(lucy_HashTombStone* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_HashTombStone_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HashTombStone_Make(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HashTombStone_Get_RefCount(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Get_RefCount_OFFSET;
    const lucy_HashTombStone_get_refcount_t method = *((lucy_HashTombStone_get_refcount_t*)method_address);
    return method((lucy_HashTombStone*)self);
}

extern size_t Lucy_HashTombStone_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_HashTombStone*
Lucy_HashTombStone_Inc_RefCount(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Inc_RefCount_OFFSET;
    const lucy_HashTombStone_inc_refcount_t method = *((lucy_HashTombStone_inc_refcount_t*)method_address);
    return method((lucy_HashTombStone*)self);
}

extern size_t Lucy_HashTombStone_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HashTombStone_Dec_RefCount(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Dec_RefCount_OFFSET;
    const lucy_HashTombStone_dec_refcount_t method = *((lucy_HashTombStone_dec_refcount_t*)method_address);
    return method((lucy_HashTombStone*)self);
}

extern size_t Lucy_HashTombStone_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_HashTombStone_To_Host(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HashTombStone_Clone(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Destroy_OFFSET;
static CHY_INLINE void
Lucy_HashTombStone_Destroy(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HashTombStone_Equals(const lucy_HashTombStone *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HashTombStone_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_HashTombStone_Compare_To(const lucy_HashTombStone *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HashTombStone_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_HashTombStone_Hash_Sum(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_HashTombStone_Get_VTable(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HashTombStone_Get_Class_Name(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HashTombStone_Is_A(const lucy_HashTombStone *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_HashTombStone_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HashTombStone_To_String(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_HashTombStone_To_I64(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_To_F64_OFFSET;
static CHY_INLINE double
Lucy_HashTombStone_To_F64(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HashTombStone_To_Bool(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Serialize_OFFSET;
static CHY_INLINE void
Lucy_HashTombStone_Serialize(const lucy_HashTombStone *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_HashTombStone_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HashTombStone_Deserialize(const lucy_HashTombStone *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_HashTombStone_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HashTombStone_Dump(const lucy_HashTombStone *self) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HashTombStone_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HashTombStone_Load(const lucy_HashTombStone *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_HashTombStone_Mimic_OFFSET;
static CHY_INLINE void
Lucy_HashTombStone_Mimic(const lucy_HashTombStone *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HashTombStone_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HASHTOMBSTONE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[22];
} LUCY_HASHTOMBSTONE_VT;
extern struct LUCY_HASHTOMBSTONE_VT LUCY_HASHTOMBSTONE_vt;
#define LUCY_HASHTOMBSTONE ((cfish_VTable*)&LUCY_HASHTOMBSTONE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define HashTombStone lucy_HashTombStone
  #define HASHTOMBSTONE LUCY_HASHTOMBSTONE
  #define HashTombStone_get_refcount_t lucy_HashTombStone_get_refcount_t
  #define HashTombStone_get_refcount lucy_HashTombStone_get_refcount
  #define HashTombStone_inc_refcount_t lucy_HashTombStone_inc_refcount_t
  #define HashTombStone_inc_refcount lucy_HashTombStone_inc_refcount
  #define HashTombStone_dec_refcount_t lucy_HashTombStone_dec_refcount_t
  #define HashTombStone_dec_refcount lucy_HashTombStone_dec_refcount
  #define HashTombStone_Make Lucy_HashTombStone_Make
  #define HashTombStone_Get_RefCount Lucy_HashTombStone_Get_RefCount
  #define HashTombStone_Inc_RefCount Lucy_HashTombStone_Inc_RefCount
  #define HashTombStone_Dec_RefCount Lucy_HashTombStone_Dec_RefCount
  #define HashTombStone_To_Host Lucy_HashTombStone_To_Host
  #define HashTombStone_Clone Lucy_HashTombStone_Clone
  #define HashTombStone_Destroy Lucy_HashTombStone_Destroy
  #define HashTombStone_Equals Lucy_HashTombStone_Equals
  #define HashTombStone_Compare_To Lucy_HashTombStone_Compare_To
  #define HashTombStone_Hash_Sum Lucy_HashTombStone_Hash_Sum
  #define HashTombStone_Get_VTable Lucy_HashTombStone_Get_VTable
  #define HashTombStone_Get_Class_Name Lucy_HashTombStone_Get_Class_Name
  #define HashTombStone_Is_A Lucy_HashTombStone_Is_A
  #define HashTombStone_To_String Lucy_HashTombStone_To_String
  #define HashTombStone_To_I64 Lucy_HashTombStone_To_I64
  #define HashTombStone_To_F64 Lucy_HashTombStone_To_F64
  #define HashTombStone_To_Bool Lucy_HashTombStone_To_Bool
  #define HashTombStone_Serialize Lucy_HashTombStone_Serialize
  #define HashTombStone_Deserialize Lucy_HashTombStone_Deserialize
  #define HashTombStone_Dump Lucy_HashTombStone_Dump
  #define HashTombStone_Load Lucy_HashTombStone_Load
  #define HashTombStone_Mimic Lucy_HashTombStone_Mimic
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_HASH */




