/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_VARRAY
#define H_LUCY_OBJECT_VARRAY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "Lucy/Util/SortUtils.h"

typedef chy_bool_t
(*lucy_VA_gather_test_t)(lucy_VArray *self, uint32_t tick, void *data);

#ifdef LUCY_USE_SHORT_NAMES
  #define lucy_VA_gather_test_t lucy_VA_gather_test_t
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_VARRAY
struct lucy_VArray {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Obj** elems;
    uint32_t size;
    uint32_t cap;
};

#endif /* C_LUCY_VARRAY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_VArray*
lucy_VA_new(uint32_t capacity);

lucy_VArray*
lucy_VA_init(lucy_VArray* self, uint32_t capacity);

lucy_VArray*
lucy_VA_clone(lucy_VArray* self);

void
lucy_VA_destroy(lucy_VArray* self);

chy_bool_t
lucy_VA_equals(lucy_VArray* self, lucy_Obj* other);

void
lucy_VA_serialize(lucy_VArray* self, lucy_OutStream* outstream);

lucy_VArray*
lucy_VA_deserialize(lucy_VArray* self, lucy_InStream* instream);

lucy_VArray*
lucy_VA_dump(lucy_VArray* self);

lucy_VArray*
lucy_VA_load(lucy_VArray* self, lucy_Obj* dump);

void
lucy_VA_push(lucy_VArray* self, lucy_Obj* element);

void
lucy_VA_push_varray(lucy_VArray* self, lucy_VArray* other);

lucy_Obj*
lucy_VA_pop(lucy_VArray* self);

void
lucy_VA_unshift(lucy_VArray* self, lucy_Obj* element);

lucy_Obj*
lucy_VA_shift(lucy_VArray* self);

void
lucy_VA_grow(lucy_VArray* self, uint32_t capacity);

lucy_Obj*
lucy_VA_fetch(lucy_VArray* self, uint32_t tick);

void
lucy_VA_store(lucy_VArray* self, uint32_t tick, lucy_Obj* elem);

lucy_Obj*
lucy_VA_delete(lucy_VArray* self, uint32_t tick);

void
lucy_VA_excise(lucy_VArray* self, uint32_t offset, uint32_t length);

lucy_VArray*
lucy_VA_shallow_copy(lucy_VArray* self);

void
lucy_VA_sort(lucy_VArray* self, lucy_Sort_compare_t compare, void* context);

void
lucy_VA_resize(lucy_VArray* self, uint32_t size);

void
lucy_VA_clear(lucy_VArray* self);

uint32_t
lucy_VA_get_size(lucy_VArray* self);

uint32_t
lucy_VA_get_capacity(lucy_VArray* self);

lucy_VArray*
lucy_VA_gather(lucy_VArray* self, lucy_VA_gather_test_t test, void* data);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_VA_clone_CALLBACK;
extern cfish_Callback lucy_VA_destroy_CALLBACK;
extern cfish_Callback lucy_VA_equals_CALLBACK;
extern cfish_Callback lucy_VA_serialize_CALLBACK;
extern cfish_Callback lucy_VA_deserialize_CALLBACK;
extern cfish_Callback lucy_VA_dump_CALLBACK;
extern cfish_Callback lucy_VA_load_CALLBACK;
extern cfish_Callback lucy_VA_get_size_CALLBACK;
extern cfish_Callback lucy_VA_gather_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_VArray*
(*lucy_VA_clone_t)(lucy_VArray* self);

typedef void
(*lucy_VA_destroy_t)(lucy_VArray* self);

typedef chy_bool_t
(*lucy_VA_equals_t)(lucy_VArray* self, lucy_Obj* other);

typedef void
(*lucy_VA_serialize_t)(lucy_VArray* self, lucy_OutStream* outstream);

typedef lucy_VArray*
(*lucy_VA_deserialize_t)(lucy_VArray* self, lucy_InStream* instream);

typedef lucy_VArray*
(*lucy_VA_dump_t)(lucy_VArray* self);

typedef lucy_VArray*
(*lucy_VA_load_t)(lucy_VArray* self, lucy_Obj* dump);

typedef void
(*lucy_VA_push_t)(lucy_VArray* self, lucy_Obj* element);

typedef void
(*lucy_VA_push_varray_t)(lucy_VArray* self, lucy_VArray* other);

typedef lucy_Obj*
(*lucy_VA_pop_t)(lucy_VArray* self);

typedef void
(*lucy_VA_unshift_t)(lucy_VArray* self, lucy_Obj* element);

typedef lucy_Obj*
(*lucy_VA_shift_t)(lucy_VArray* self);

typedef void
(*lucy_VA_grow_t)(lucy_VArray* self, uint32_t capacity);

typedef lucy_Obj*
(*lucy_VA_fetch_t)(lucy_VArray* self, uint32_t tick);

typedef void
(*lucy_VA_store_t)(lucy_VArray* self, uint32_t tick, lucy_Obj* elem);

typedef lucy_Obj*
(*lucy_VA_delete_t)(lucy_VArray* self, uint32_t tick);

typedef void
(*lucy_VA_excise_t)(lucy_VArray* self, uint32_t offset, uint32_t length);

typedef lucy_VArray*
(*lucy_VA_shallow_copy_t)(lucy_VArray* self);

typedef void
(*lucy_VA_sort_t)(lucy_VArray* self, lucy_Sort_compare_t compare, void* context);

typedef void
(*lucy_VA_resize_t)(lucy_VArray* self, uint32_t size);

typedef void
(*lucy_VA_clear_t)(lucy_VArray* self);

typedef uint32_t
(*lucy_VA_get_size_t)(lucy_VArray* self);

typedef uint32_t
(*lucy_VA_get_capacity_t)(lucy_VArray* self);

typedef lucy_VArray*
(*lucy_VA_gather_t)(lucy_VArray* self, lucy_VA_gather_test_t test, void* data);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_VA_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VA_Make(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_VA_Get_RefCount(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VA_Inc_RefCount(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_VA_Dec_RefCount(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_VA_To_Host(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Clone_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_VA_Clone(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Clone_OFFSET;
    const lucy_VA_clone_t method = *((lucy_VA_clone_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Destroy_OFFSET;
static CHY_INLINE void
Lucy_VA_Destroy(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Destroy_OFFSET;
    const lucy_VA_destroy_t method = *((lucy_VA_destroy_t*)method_address);
    method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_VA_Equals(const lucy_VArray *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_VA_Equals_OFFSET;
    const lucy_VA_equals_t method = *((lucy_VA_equals_t*)method_address);
    return method((lucy_VArray*)self, other);
}

extern size_t Lucy_VA_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_VA_Compare_To(const lucy_VArray *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_VA_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_VA_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_VA_Hash_Sum(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_VA_Get_VTable(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_VA_Get_Class_Name(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_VA_Is_A(const lucy_VArray *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_VA_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_VA_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_VA_To_String(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_VA_To_I64(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_To_F64_OFFSET;
static CHY_INLINE double
Lucy_VA_To_F64(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_VA_To_Bool(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VA_Serialize_OFFSET;
static CHY_INLINE void
Lucy_VA_Serialize(const lucy_VArray *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_VA_Serialize_OFFSET;
    const lucy_VA_serialize_t method = *((lucy_VA_serialize_t*)method_address);
    method((lucy_VArray*)self, outstream);
}

extern size_t Lucy_VA_Deserialize_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_VA_Deserialize(const lucy_VArray *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_VA_Deserialize_OFFSET;
    const lucy_VA_deserialize_t method = *((lucy_VA_deserialize_t*)method_address);
    return method((lucy_VArray*)self, instream);
}

extern size_t Lucy_VA_Dump_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_VA_Dump(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Dump_OFFSET;
    const lucy_VA_dump_t method = *((lucy_VA_dump_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Load_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_VA_Load(const lucy_VArray *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_VA_Load_OFFSET;
    const lucy_VA_load_t method = *((lucy_VA_load_t*)method_address);
    return method((lucy_VArray*)self, dump);
}

extern size_t Lucy_VA_Mimic_OFFSET;
static CHY_INLINE void
Lucy_VA_Mimic(const lucy_VArray *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_VA_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_VA_Push_OFFSET;
static CHY_INLINE void
Lucy_VA_Push(const lucy_VArray *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_VA_Push_OFFSET;
    const lucy_VA_push_t method = *((lucy_VA_push_t*)method_address);
    method((lucy_VArray*)self, element);
}

extern size_t Lucy_VA_Push_VArray_OFFSET;
static CHY_INLINE void
Lucy_VA_Push_VArray(const lucy_VArray *self, lucy_VArray* other) {
    char *const method_address = *(char**)self + Lucy_VA_Push_VArray_OFFSET;
    const lucy_VA_push_varray_t method = *((lucy_VA_push_varray_t*)method_address);
    method((lucy_VArray*)self, other);
}

extern size_t Lucy_VA_Pop_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VA_Pop(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Pop_OFFSET;
    const lucy_VA_pop_t method = *((lucy_VA_pop_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Unshift_OFFSET;
static CHY_INLINE void
Lucy_VA_Unshift(const lucy_VArray *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_VA_Unshift_OFFSET;
    const lucy_VA_unshift_t method = *((lucy_VA_unshift_t*)method_address);
    method((lucy_VArray*)self, element);
}

extern size_t Lucy_VA_Shift_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VA_Shift(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Shift_OFFSET;
    const lucy_VA_shift_t method = *((lucy_VA_shift_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Grow_OFFSET;
static CHY_INLINE void
Lucy_VA_Grow(const lucy_VArray *self, uint32_t capacity) {
    char *const method_address = *(char**)self + Lucy_VA_Grow_OFFSET;
    const lucy_VA_grow_t method = *((lucy_VA_grow_t*)method_address);
    method((lucy_VArray*)self, capacity);
}

extern size_t Lucy_VA_Fetch_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VA_Fetch(const lucy_VArray *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_VA_Fetch_OFFSET;
    const lucy_VA_fetch_t method = *((lucy_VA_fetch_t*)method_address);
    return method((lucy_VArray*)self, tick);
}

extern size_t Lucy_VA_Store_OFFSET;
static CHY_INLINE void
Lucy_VA_Store(const lucy_VArray *self, uint32_t tick, lucy_Obj* elem) {
    char *const method_address = *(char**)self + Lucy_VA_Store_OFFSET;
    const lucy_VA_store_t method = *((lucy_VA_store_t*)method_address);
    method((lucy_VArray*)self, tick, elem);
}

extern size_t Lucy_VA_Delete_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VA_Delete(const lucy_VArray *self, uint32_t tick) {
    char *const method_address = *(char**)self + Lucy_VA_Delete_OFFSET;
    const lucy_VA_delete_t method = *((lucy_VA_delete_t*)method_address);
    return method((lucy_VArray*)self, tick);
}

extern size_t Lucy_VA_Excise_OFFSET;
static CHY_INLINE void
Lucy_VA_Excise(const lucy_VArray *self, uint32_t offset, uint32_t length) {
    char *const method_address = *(char**)self + Lucy_VA_Excise_OFFSET;
    const lucy_VA_excise_t method = *((lucy_VA_excise_t*)method_address);
    method((lucy_VArray*)self, offset, length);
}

extern size_t Lucy_VA_Shallow_Copy_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_VA_Shallow_Copy(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Shallow_Copy_OFFSET;
    const lucy_VA_shallow_copy_t method = *((lucy_VA_shallow_copy_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Sort_OFFSET;
static CHY_INLINE void
Lucy_VA_Sort(const lucy_VArray *self, lucy_Sort_compare_t compare, void* context) {
    char *const method_address = *(char**)self + Lucy_VA_Sort_OFFSET;
    const lucy_VA_sort_t method = *((lucy_VA_sort_t*)method_address);
    method((lucy_VArray*)self, compare, context);
}

extern size_t Lucy_VA_Resize_OFFSET;
static CHY_INLINE void
Lucy_VA_Resize(const lucy_VArray *self, uint32_t size) {
    char *const method_address = *(char**)self + Lucy_VA_Resize_OFFSET;
    const lucy_VA_resize_t method = *((lucy_VA_resize_t*)method_address);
    method((lucy_VArray*)self, size);
}

extern size_t Lucy_VA_Clear_OFFSET;
static CHY_INLINE void
Lucy_VA_Clear(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Clear_OFFSET;
    const lucy_VA_clear_t method = *((lucy_VA_clear_t*)method_address);
    method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_VA_Get_Size(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Get_Size_OFFSET;
    const lucy_VA_get_size_t method = *((lucy_VA_get_size_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Get_Capacity_OFFSET;
static CHY_INLINE uint32_t
Lucy_VA_Get_Capacity(const lucy_VArray *self) {
    char *const method_address = *(char**)self + Lucy_VA_Get_Capacity_OFFSET;
    const lucy_VA_get_capacity_t method = *((lucy_VA_get_capacity_t*)method_address);
    return method((lucy_VArray*)self);
}

extern size_t Lucy_VA_Gather_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_VA_Gather(const lucy_VArray *self, lucy_VA_gather_test_t test, void* data) {
    char *const method_address = *(char**)self + Lucy_VA_Gather_OFFSET;
    const lucy_VA_gather_t method = *((lucy_VA_gather_t*)method_address);
    return method((lucy_VArray*)self, test, data);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_VARRAY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[39];
} LUCY_VARRAY_VT;
extern struct LUCY_VARRAY_VT LUCY_VARRAY_vt;
#define LUCY_VARRAY ((cfish_VTable*)&LUCY_VARRAY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define VArray lucy_VArray
  #define VARRAY LUCY_VARRAY
  #define VA_new lucy_VA_new
  #define VA_init lucy_VA_init
  #define VA_clone_t lucy_VA_clone_t
  #define VA_clone lucy_VA_clone
  #define VA_destroy_t lucy_VA_destroy_t
  #define VA_destroy lucy_VA_destroy
  #define VA_equals_t lucy_VA_equals_t
  #define VA_equals lucy_VA_equals
  #define VA_serialize_t lucy_VA_serialize_t
  #define VA_serialize lucy_VA_serialize
  #define VA_deserialize_t lucy_VA_deserialize_t
  #define VA_deserialize lucy_VA_deserialize
  #define VA_dump_t lucy_VA_dump_t
  #define VA_dump lucy_VA_dump
  #define VA_load_t lucy_VA_load_t
  #define VA_load lucy_VA_load
  #define VA_push_t lucy_VA_push_t
  #define VA_push lucy_VA_push
  #define VA_push_varray_t lucy_VA_push_varray_t
  #define VA_push_varray lucy_VA_push_varray
  #define VA_pop_t lucy_VA_pop_t
  #define VA_pop lucy_VA_pop
  #define VA_unshift_t lucy_VA_unshift_t
  #define VA_unshift lucy_VA_unshift
  #define VA_shift_t lucy_VA_shift_t
  #define VA_shift lucy_VA_shift
  #define VA_grow_t lucy_VA_grow_t
  #define VA_grow lucy_VA_grow
  #define VA_fetch_t lucy_VA_fetch_t
  #define VA_fetch lucy_VA_fetch
  #define VA_store_t lucy_VA_store_t
  #define VA_store lucy_VA_store
  #define VA_delete_t lucy_VA_delete_t
  #define VA_delete lucy_VA_delete
  #define VA_excise_t lucy_VA_excise_t
  #define VA_excise lucy_VA_excise
  #define VA_shallow_copy_t lucy_VA_shallow_copy_t
  #define VA_shallow_copy lucy_VA_shallow_copy
  #define VA_sort_t lucy_VA_sort_t
  #define VA_sort lucy_VA_sort
  #define VA_resize_t lucy_VA_resize_t
  #define VA_resize lucy_VA_resize
  #define VA_clear_t lucy_VA_clear_t
  #define VA_clear lucy_VA_clear
  #define VA_get_size_t lucy_VA_get_size_t
  #define VA_get_size lucy_VA_get_size
  #define VA_get_capacity_t lucy_VA_get_capacity_t
  #define VA_get_capacity lucy_VA_get_capacity
  #define VA_gather_t lucy_VA_gather_t
  #define VA_gather lucy_VA_gather
  #define VA_Make Lucy_VA_Make
  #define VA_Get_RefCount Lucy_VA_Get_RefCount
  #define VA_Inc_RefCount Lucy_VA_Inc_RefCount
  #define VA_Dec_RefCount Lucy_VA_Dec_RefCount
  #define VA_To_Host Lucy_VA_To_Host
  #define VA_Clone Lucy_VA_Clone
  #define VA_Destroy Lucy_VA_Destroy
  #define VA_Equals Lucy_VA_Equals
  #define VA_Compare_To Lucy_VA_Compare_To
  #define VA_Hash_Sum Lucy_VA_Hash_Sum
  #define VA_Get_VTable Lucy_VA_Get_VTable
  #define VA_Get_Class_Name Lucy_VA_Get_Class_Name
  #define VA_Is_A Lucy_VA_Is_A
  #define VA_To_String Lucy_VA_To_String
  #define VA_To_I64 Lucy_VA_To_I64
  #define VA_To_F64 Lucy_VA_To_F64
  #define VA_To_Bool Lucy_VA_To_Bool
  #define VA_Serialize Lucy_VA_Serialize
  #define VA_Deserialize Lucy_VA_Deserialize
  #define VA_Dump Lucy_VA_Dump
  #define VA_Load Lucy_VA_Load
  #define VA_Mimic Lucy_VA_Mimic
  #define VA_Push Lucy_VA_Push
  #define VA_Push_VArray Lucy_VA_Push_VArray
  #define VA_Pop Lucy_VA_Pop
  #define VA_Unshift Lucy_VA_Unshift
  #define VA_Shift Lucy_VA_Shift
  #define VA_Grow Lucy_VA_Grow
  #define VA_Fetch Lucy_VA_Fetch
  #define VA_Store Lucy_VA_Store
  #define VA_Delete Lucy_VA_Delete
  #define VA_Excise Lucy_VA_Excise
  #define VA_Shallow_Copy Lucy_VA_Shallow_Copy
  #define VA_Sort Lucy_VA_Sort
  #define VA_Resize Lucy_VA_Resize
  #define VA_Clear Lucy_VA_Clear
  #define VA_Get_Size Lucy_VA_Get_Size
  #define VA_Get_Capacity Lucy_VA_Get_Capacity
  #define VA_Gather Lucy_VA_Gather
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_VARRAY */




