/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_OBJECT_VTABLE
#define H_LUCY_OBJECT_VTABLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_VTABLE
struct lucy_VTable {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VTable* parent;
    lucy_CharBuf* name;
    uint32_t flags;
    void* x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void* callbacks;
    lucy_method_t methods[1];
};

#endif /* C_LUCY_VTABLE */

/* Declare this class's inert variables.
 */

extern lucy_LockFreeRegistry* lucy_VTable_registry;
extern size_t lucy_VTable_offset_of_parent;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_VTable*
lucy_VTable_singleton(const lucy_CharBuf* subclass_name, lucy_VTable* parent);

chy_bool_t
lucy_VTable_add_to_registry(lucy_VTable* vtable);

chy_bool_t
lucy_VTable_add_alias_to_registry(lucy_VTable* vtable, lucy_CharBuf* alias);

void
lucy_VTable_init_registry();

void
lucy_VTable_register_with_host(lucy_VTable* vtable, lucy_VTable* parent);

lucy_VTable*
lucy_VTable_fetch_vtable(const lucy_CharBuf* class_name);

lucy_CharBuf*
lucy_VTable_find_parent_class(const lucy_CharBuf* class_name);

lucy_VArray*
lucy_VTable_novel_host_methods(const lucy_CharBuf* class_name);

uint32_t
lucy_VTable_get_refcount(lucy_VTable* self);

lucy_Obj*
lucy_VTable_inc_refcount(lucy_VTable* self);

uint32_t
lucy_VTable_dec_refcount(lucy_VTable* self);

void*
lucy_VTable_to_host(lucy_VTable* self);

lucy_VTable*
lucy_VTable_clone(lucy_VTable* self);

void
lucy_VTable_destroy(lucy_VTable* self);

void
lucy_VTable_override(lucy_VTable* self, lucy_method_t method_ptr, size_t offset);

lucy_Obj*
lucy_VTable_make_obj(lucy_VTable* self);

lucy_Obj*
lucy_VTable_init_obj(lucy_VTable* self, void* allocation);

lucy_Obj*
lucy_VTable_load_obj(lucy_VTable* self, lucy_Obj* dump);

lucy_Obj*
lucy_VTable_foster_obj(lucy_VTable* self, void* host_obj);

lucy_CharBuf*
lucy_VTable_get_name(lucy_VTable* self);

lucy_VTable*
lucy_VTable_get_parent(lucy_VTable* self);

size_t
lucy_VTable_get_obj_alloc_size(lucy_VTable* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_VTable_clone_CALLBACK;
extern cfish_Callback lucy_VTable_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*lucy_VTable_get_refcount_t)(lucy_VTable* self);

typedef lucy_Obj*
(*lucy_VTable_inc_refcount_t)(lucy_VTable* self);

typedef uint32_t
(*lucy_VTable_dec_refcount_t)(lucy_VTable* self);

typedef void*
(*lucy_VTable_to_host_t)(lucy_VTable* self);

typedef lucy_VTable*
(*lucy_VTable_clone_t)(lucy_VTable* self);

typedef void
(*lucy_VTable_destroy_t)(lucy_VTable* self);

typedef void
(*lucy_VTable_override_t)(lucy_VTable* self, lucy_method_t method_ptr, size_t offset);

typedef lucy_Obj*
(*lucy_VTable_make_obj_t)(lucy_VTable* self);

typedef lucy_Obj*
(*lucy_VTable_init_obj_t)(lucy_VTable* self, void* allocation);

typedef lucy_Obj*
(*lucy_VTable_load_obj_t)(lucy_VTable* self, lucy_Obj* dump);

typedef lucy_Obj*
(*lucy_VTable_foster_obj_t)(lucy_VTable* self, void* host_obj);

typedef lucy_CharBuf*
(*lucy_VTable_get_name_t)(lucy_VTable* self);

typedef lucy_VTable*
(*lucy_VTable_get_parent_t)(lucy_VTable* self);

typedef size_t
(*lucy_VTable_get_obj_alloc_size_t)(lucy_VTable* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_VTable_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Make(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_VTable_Get_RefCount(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Get_RefCount_OFFSET;
    const lucy_VTable_get_refcount_t method = *((lucy_VTable_get_refcount_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Inc_RefCount(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Inc_RefCount_OFFSET;
    const lucy_VTable_inc_refcount_t method = *((lucy_VTable_inc_refcount_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_VTable_Dec_RefCount(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Dec_RefCount_OFFSET;
    const lucy_VTable_dec_refcount_t method = *((lucy_VTable_dec_refcount_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_VTable_To_Host(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_To_Host_OFFSET;
    const lucy_VTable_to_host_t method = *((lucy_VTable_to_host_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Clone_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_VTable_Clone(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Clone_OFFSET;
    const lucy_VTable_clone_t method = *((lucy_VTable_clone_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Destroy_OFFSET;
static CHY_INLINE void
Lucy_VTable_Destroy(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Destroy_OFFSET;
    const lucy_VTable_destroy_t method = *((lucy_VTable_destroy_t*)method_address);
    method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_VTable_Equals(const lucy_VTable *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_VTable_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_VTable_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_VTable_Compare_To(const lucy_VTable *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_VTable_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_VTable_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_VTable_Hash_Sum(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_VTable_Get_VTable(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_VTable_Get_Class_Name(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_VTable_Is_A(const lucy_VTable *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_VTable_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_VTable_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_VTable_To_String(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_VTable_To_I64(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_To_F64_OFFSET;
static CHY_INLINE double
Lucy_VTable_To_F64(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_VTable_To_Bool(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_Serialize_OFFSET;
static CHY_INLINE void
Lucy_VTable_Serialize(const lucy_VTable *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_VTable_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_VTable_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Deserialize(const lucy_VTable *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_VTable_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_VTable_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Dump(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_VTable_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Load(const lucy_VTable *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_VTable_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_VTable_Mimic_OFFSET;
static CHY_INLINE void
Lucy_VTable_Mimic(const lucy_VTable *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_VTable_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_VTable_Override_OFFSET;
static CHY_INLINE void
Lucy_VTable_Override(const lucy_VTable *self, lucy_method_t method_ptr, size_t offset) {
    char *const method_address = *(char**)self + Lucy_VTable_Override_OFFSET;
    const lucy_VTable_override_t method = *((lucy_VTable_override_t*)method_address);
    method((lucy_VTable*)self, method_ptr, offset);
}

extern size_t Lucy_VTable_Make_Obj_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Make_Obj(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Make_Obj_OFFSET;
    const lucy_VTable_make_obj_t method = *((lucy_VTable_make_obj_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Init_Obj_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Init_Obj(const lucy_VTable *self, void* allocation) {
    char *const method_address = *(char**)self + Lucy_VTable_Init_Obj_OFFSET;
    const lucy_VTable_init_obj_t method = *((lucy_VTable_init_obj_t*)method_address);
    return method((lucy_VTable*)self, allocation);
}

extern size_t Lucy_VTable_Load_Obj_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Load_Obj(const lucy_VTable *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_VTable_Load_Obj_OFFSET;
    const lucy_VTable_load_obj_t method = *((lucy_VTable_load_obj_t*)method_address);
    return method((lucy_VTable*)self, dump);
}

extern size_t Lucy_VTable_Foster_Obj_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_VTable_Foster_Obj(const lucy_VTable *self, void* host_obj) {
    char *const method_address = *(char**)self + Lucy_VTable_Foster_Obj_OFFSET;
    const lucy_VTable_foster_obj_t method = *((lucy_VTable_foster_obj_t*)method_address);
    return method((lucy_VTable*)self, host_obj);
}

extern size_t Lucy_VTable_Get_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_VTable_Get_Name(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Get_Name_OFFSET;
    const lucy_VTable_get_name_t method = *((lucy_VTable_get_name_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Get_Parent_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_VTable_Get_Parent(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Get_Parent_OFFSET;
    const lucy_VTable_get_parent_t method = *((lucy_VTable_get_parent_t*)method_address);
    return method((lucy_VTable*)self);
}

extern size_t Lucy_VTable_Get_Obj_Alloc_Size_OFFSET;
static CHY_INLINE size_t
Lucy_VTable_Get_Obj_Alloc_Size(const lucy_VTable *self) {
    char *const method_address = *(char**)self + Lucy_VTable_Get_Obj_Alloc_Size_OFFSET;
    const lucy_VTable_get_obj_alloc_size_t method = *((lucy_VTable_get_obj_alloc_size_t*)method_address);
    return method((lucy_VTable*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_VTABLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[30];
} LUCY_VTABLE_VT;
extern struct LUCY_VTABLE_VT LUCY_VTABLE_vt;
#define LUCY_VTABLE ((cfish_VTable*)&LUCY_VTABLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define VTable lucy_VTable
  #define VTABLE LUCY_VTABLE
  #define VTable_singleton lucy_VTable_singleton
  #define VTable_add_to_registry lucy_VTable_add_to_registry
  #define VTable_add_alias_to_registry lucy_VTable_add_alias_to_registry
  #define VTable_init_registry lucy_VTable_init_registry
  #define VTable_register_with_host lucy_VTable_register_with_host
  #define VTable_fetch_vtable lucy_VTable_fetch_vtable
  #define VTable_find_parent_class lucy_VTable_find_parent_class
  #define VTable_novel_host_methods lucy_VTable_novel_host_methods
  #define VTable_registry lucy_VTable_registry
  #define VTable_offset_of_parent lucy_VTable_offset_of_parent
  #define VTable_get_refcount_t lucy_VTable_get_refcount_t
  #define VTable_get_refcount lucy_VTable_get_refcount
  #define VTable_inc_refcount_t lucy_VTable_inc_refcount_t
  #define VTable_inc_refcount lucy_VTable_inc_refcount
  #define VTable_dec_refcount_t lucy_VTable_dec_refcount_t
  #define VTable_dec_refcount lucy_VTable_dec_refcount
  #define VTable_to_host_t lucy_VTable_to_host_t
  #define VTable_to_host lucy_VTable_to_host
  #define VTable_clone_t lucy_VTable_clone_t
  #define VTable_clone lucy_VTable_clone
  #define VTable_destroy_t lucy_VTable_destroy_t
  #define VTable_destroy lucy_VTable_destroy
  #define VTable_override_t lucy_VTable_override_t
  #define VTable_override lucy_VTable_override
  #define VTable_make_obj_t lucy_VTable_make_obj_t
  #define VTable_make_obj lucy_VTable_make_obj
  #define VTable_init_obj_t lucy_VTable_init_obj_t
  #define VTable_init_obj lucy_VTable_init_obj
  #define VTable_load_obj_t lucy_VTable_load_obj_t
  #define VTable_load_obj lucy_VTable_load_obj
  #define VTable_foster_obj_t lucy_VTable_foster_obj_t
  #define VTable_foster_obj lucy_VTable_foster_obj
  #define VTable_get_name_t lucy_VTable_get_name_t
  #define VTable_get_name lucy_VTable_get_name
  #define VTable_get_parent_t lucy_VTable_get_parent_t
  #define VTable_get_parent lucy_VTable_get_parent
  #define VTable_get_obj_alloc_size_t lucy_VTable_get_obj_alloc_size_t
  #define VTable_get_obj_alloc_size lucy_VTable_get_obj_alloc_size
  #define VTable_Make Lucy_VTable_Make
  #define VTable_Get_RefCount Lucy_VTable_Get_RefCount
  #define VTable_Inc_RefCount Lucy_VTable_Inc_RefCount
  #define VTable_Dec_RefCount Lucy_VTable_Dec_RefCount
  #define VTable_To_Host Lucy_VTable_To_Host
  #define VTable_Clone Lucy_VTable_Clone
  #define VTable_Destroy Lucy_VTable_Destroy
  #define VTable_Equals Lucy_VTable_Equals
  #define VTable_Compare_To Lucy_VTable_Compare_To
  #define VTable_Hash_Sum Lucy_VTable_Hash_Sum
  #define VTable_Get_VTable Lucy_VTable_Get_VTable
  #define VTable_Get_Class_Name Lucy_VTable_Get_Class_Name
  #define VTable_Is_A Lucy_VTable_Is_A
  #define VTable_To_String Lucy_VTable_To_String
  #define VTable_To_I64 Lucy_VTable_To_I64
  #define VTable_To_F64 Lucy_VTable_To_F64
  #define VTable_To_Bool Lucy_VTable_To_Bool
  #define VTable_Serialize Lucy_VTable_Serialize
  #define VTable_Deserialize Lucy_VTable_Deserialize
  #define VTable_Dump Lucy_VTable_Dump
  #define VTable_Load Lucy_VTable_Load
  #define VTable_Mimic Lucy_VTable_Mimic
  #define VTable_Override Lucy_VTable_Override
  #define VTable_Make_Obj Lucy_VTable_Make_Obj
  #define VTable_Init_Obj Lucy_VTable_Init_Obj
  #define VTable_Load_Obj Lucy_VTable_Load_Obj
  #define VTable_Foster_Obj Lucy_VTable_Foster_Obj
  #define VTable_Get_Name Lucy_VTable_Get_Name
  #define VTable_Get_Parent Lucy_VTable_Get_Parent
  #define VTable_Get_Obj_Alloc_Size Lucy_VTable_Get_Obj_Alloc_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_OBJECT_VTABLE */




