/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_PLAN_FIELDTYPE
#define H_LUCY_PLAN_FIELDTYPE 1


#ifdef __cplusplus
extern "C" {
#endif

#define lucy_FType_TEXT    1
#define lucy_FType_BLOB    2
#define lucy_FType_INT32   3
#define lucy_FType_INT64   4
#define lucy_FType_FLOAT32 5
#define lucy_FType_FLOAT64 6
#define lucy_FType_PRIMITIVE_ID_MASK 0x7

#ifdef LUCY_USE_SHORT_NAMES
  #define FType_TEXT              lucy_FType_TEXT
  #define FType_BLOB              lucy_FType_BLOB
  #define FType_INT32             lucy_FType_INT32
  #define FType_INT64             lucy_FType_INT64
  #define FType_FLOAT32           lucy_FType_FLOAT32
  #define FType_FLOAT64           lucy_FType_FLOAT64
  #define FType_PRIMITIVE_ID_MASK lucy_FType_PRIMITIVE_ID_MASK
#endif


#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FIELDTYPE
struct lucy_FieldType {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    chy_bool_t indexed;
    chy_bool_t stored;
    chy_bool_t sortable;
};

#endif /* C_LUCY_FIELDTYPE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_FieldType*
lucy_FType_init(lucy_FieldType* self);

lucy_FieldType*
lucy_FType_init2(lucy_FieldType* self, float boost, chy_bool_t indexed, chy_bool_t stored, chy_bool_t sortable);

static CHY_INLINE int32_t
lucy_FType_null_back_compare_values(lucy_FieldType* self, lucy_Obj* a, lucy_Obj* b);

chy_bool_t
lucy_FType_equals(lucy_FieldType* self, lucy_Obj* other);

void
lucy_FType_set_boost(lucy_FieldType* self, float boost);

float
lucy_FType_get_boost(lucy_FieldType* self);

void
lucy_FType_set_indexed(lucy_FieldType* self, chy_bool_t indexed);

chy_bool_t
lucy_FType_indexed(lucy_FieldType* self);

void
lucy_FType_set_stored(lucy_FieldType* self, chy_bool_t stored);

chy_bool_t
lucy_FType_stored(lucy_FieldType* self);

void
lucy_FType_set_sortable(lucy_FieldType* self, chy_bool_t sortable);

chy_bool_t
lucy_FType_sortable(lucy_FieldType* self);

chy_bool_t
lucy_FType_binary(lucy_FieldType* self);

int32_t
lucy_FType_compare_values(lucy_FieldType* self, lucy_Obj* a, lucy_Obj* b);

lucy_TermStepper*
lucy_FType_make_term_stepper(lucy_FieldType* self);

int8_t
lucy_FType_primitive_id(lucy_FieldType* self);

lucy_Hash*
lucy_FType_dump_for_schema(lucy_FieldType* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_FType_equals_CALLBACK;
extern cfish_Callback lucy_FType_set_boost_CALLBACK;
extern cfish_Callback lucy_FType_get_boost_CALLBACK;
extern cfish_Callback lucy_FType_set_indexed_CALLBACK;
extern cfish_Callback lucy_FType_indexed_CALLBACK;
extern cfish_Callback lucy_FType_set_stored_CALLBACK;
extern cfish_Callback lucy_FType_stored_CALLBACK;
extern cfish_Callback lucy_FType_set_sortable_CALLBACK;
extern cfish_Callback lucy_FType_sortable_CALLBACK;
extern cfish_Callback lucy_FType_binary_CALLBACK;
extern cfish_Callback lucy_FType_compare_values_CALLBACK;
extern cfish_Callback lucy_FType_make_term_stepper_CALLBACK;
extern cfish_Callback lucy_FType_primitive_id_CALLBACK;
extern cfish_Callback lucy_FType_dump_for_schema_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_FType_equals_t)(lucy_FieldType* self, lucy_Obj* other);

typedef void
(*lucy_FType_set_boost_t)(lucy_FieldType* self, float boost);

typedef float
(*lucy_FType_get_boost_t)(lucy_FieldType* self);

typedef void
(*lucy_FType_set_indexed_t)(lucy_FieldType* self, chy_bool_t indexed);

typedef chy_bool_t
(*lucy_FType_indexed_t)(lucy_FieldType* self);

typedef void
(*lucy_FType_set_stored_t)(lucy_FieldType* self, chy_bool_t stored);

typedef chy_bool_t
(*lucy_FType_stored_t)(lucy_FieldType* self);

typedef void
(*lucy_FType_set_sortable_t)(lucy_FieldType* self, chy_bool_t sortable);

typedef chy_bool_t
(*lucy_FType_sortable_t)(lucy_FieldType* self);

typedef chy_bool_t
(*lucy_FType_binary_t)(lucy_FieldType* self);

typedef int32_t
(*lucy_FType_compare_values_t)(lucy_FieldType* self, lucy_Obj* a, lucy_Obj* b);

typedef lucy_TermStepper*
(*lucy_FType_make_term_stepper_t)(lucy_FieldType* self);

typedef int8_t
(*lucy_FType_primitive_id_t)(lucy_FieldType* self);

typedef lucy_Hash*
(*lucy_FType_dump_for_schema_t)(lucy_FieldType* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_FType_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FType_Make(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FType_Get_RefCount(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FType_Inc_RefCount(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FType_Dec_RefCount(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_FType_To_Host(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FType_Clone(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Destroy_OFFSET;
static CHY_INLINE void
Lucy_FType_Destroy(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Destroy_OFFSET;
    const lucy_Obj_destroy_t method = *((lucy_Obj_destroy_t*)method_address);
    method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_Equals(const lucy_FieldType *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FType_Equals_OFFSET;
    const lucy_FType_equals_t method = *((lucy_FType_equals_t*)method_address);
    return method((lucy_FieldType*)self, other);
}

extern size_t Lucy_FType_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_FType_Compare_To(const lucy_FieldType *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FType_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FType_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_FType_Hash_Sum(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_FType_Get_VTable(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FType_Get_Class_Name(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_Is_A(const lucy_FieldType *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_FType_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_FType_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FType_To_String(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_FType_To_I64(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_To_F64_OFFSET;
static CHY_INLINE double
Lucy_FType_To_F64(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_To_Bool(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Serialize_OFFSET;
static CHY_INLINE void
Lucy_FType_Serialize(const lucy_FieldType *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_FType_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_FType_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FType_Deserialize(const lucy_FieldType *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_FType_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_FType_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FType_Dump(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FType_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FType_Load(const lucy_FieldType *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_FType_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_FType_Mimic_OFFSET;
static CHY_INLINE void
Lucy_FType_Mimic(const lucy_FieldType *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FType_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_FType_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_FType_Set_Boost(const lucy_FieldType *self, float boost) {
    char *const method_address = *(char**)self + Lucy_FType_Set_Boost_OFFSET;
    const lucy_FType_set_boost_t method = *((lucy_FType_set_boost_t*)method_address);
    method((lucy_FieldType*)self, boost);
}

extern size_t Lucy_FType_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_FType_Get_Boost(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Get_Boost_OFFSET;
    const lucy_FType_get_boost_t method = *((lucy_FType_get_boost_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Set_Indexed_OFFSET;
static CHY_INLINE void
Lucy_FType_Set_Indexed(const lucy_FieldType *self, chy_bool_t indexed) {
    char *const method_address = *(char**)self + Lucy_FType_Set_Indexed_OFFSET;
    const lucy_FType_set_indexed_t method = *((lucy_FType_set_indexed_t*)method_address);
    method((lucy_FieldType*)self, indexed);
}

extern size_t Lucy_FType_Indexed_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_Indexed(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Indexed_OFFSET;
    const lucy_FType_indexed_t method = *((lucy_FType_indexed_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Set_Stored_OFFSET;
static CHY_INLINE void
Lucy_FType_Set_Stored(const lucy_FieldType *self, chy_bool_t stored) {
    char *const method_address = *(char**)self + Lucy_FType_Set_Stored_OFFSET;
    const lucy_FType_set_stored_t method = *((lucy_FType_set_stored_t*)method_address);
    method((lucy_FieldType*)self, stored);
}

extern size_t Lucy_FType_Stored_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_Stored(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Stored_OFFSET;
    const lucy_FType_stored_t method = *((lucy_FType_stored_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Set_Sortable_OFFSET;
static CHY_INLINE void
Lucy_FType_Set_Sortable(const lucy_FieldType *self, chy_bool_t sortable) {
    char *const method_address = *(char**)self + Lucy_FType_Set_Sortable_OFFSET;
    const lucy_FType_set_sortable_t method = *((lucy_FType_set_sortable_t*)method_address);
    method((lucy_FieldType*)self, sortable);
}

extern size_t Lucy_FType_Sortable_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_Sortable(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Sortable_OFFSET;
    const lucy_FType_sortable_t method = *((lucy_FType_sortable_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Binary_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FType_Binary(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Binary_OFFSET;
    const lucy_FType_binary_t method = *((lucy_FType_binary_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Compare_Values_OFFSET;
static CHY_INLINE int32_t
Lucy_FType_Compare_Values(const lucy_FieldType *self, lucy_Obj* a, lucy_Obj* b) {
    char *const method_address = *(char**)self + Lucy_FType_Compare_Values_OFFSET;
    const lucy_FType_compare_values_t method = *((lucy_FType_compare_values_t*)method_address);
    return method((lucy_FieldType*)self, a, b);
}

extern size_t Lucy_FType_Make_Term_Stepper_OFFSET;
static CHY_INLINE lucy_TermStepper*
Lucy_FType_Make_Term_Stepper(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Make_Term_Stepper_OFFSET;
    const lucy_FType_make_term_stepper_t method = *((lucy_FType_make_term_stepper_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Primitive_ID_OFFSET;
static CHY_INLINE int8_t
Lucy_FType_Primitive_ID(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Primitive_ID_OFFSET;
    const lucy_FType_primitive_id_t method = *((lucy_FType_primitive_id_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FType_Dump_For_Schema_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_FType_Dump_For_Schema(const lucy_FieldType *self) {
    char *const method_address = *(char**)self + Lucy_FType_Dump_For_Schema_OFFSET;
    const lucy_FType_dump_for_schema_t method = *((lucy_FType_dump_for_schema_t*)method_address);
    return method((lucy_FieldType*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FIELDTYPE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_FIELDTYPE_VT;
extern struct LUCY_FIELDTYPE_VT LUCY_FIELDTYPE_vt;
#define LUCY_FIELDTYPE ((cfish_VTable*)&LUCY_FIELDTYPE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FieldType lucy_FieldType
  #define FIELDTYPE LUCY_FIELDTYPE
  #define FType_init lucy_FType_init
  #define FType_init2 lucy_FType_init2
  #define FType_null_back_compare_values lucy_FType_null_back_compare_values
  #define FType_equals_t lucy_FType_equals_t
  #define FType_equals lucy_FType_equals
  #define FType_set_boost_t lucy_FType_set_boost_t
  #define FType_set_boost lucy_FType_set_boost
  #define FType_get_boost_t lucy_FType_get_boost_t
  #define FType_get_boost lucy_FType_get_boost
  #define FType_set_indexed_t lucy_FType_set_indexed_t
  #define FType_set_indexed lucy_FType_set_indexed
  #define FType_indexed_t lucy_FType_indexed_t
  #define FType_indexed lucy_FType_indexed
  #define FType_set_stored_t lucy_FType_set_stored_t
  #define FType_set_stored lucy_FType_set_stored
  #define FType_stored_t lucy_FType_stored_t
  #define FType_stored lucy_FType_stored
  #define FType_set_sortable_t lucy_FType_set_sortable_t
  #define FType_set_sortable lucy_FType_set_sortable
  #define FType_sortable_t lucy_FType_sortable_t
  #define FType_sortable lucy_FType_sortable
  #define FType_binary_t lucy_FType_binary_t
  #define FType_binary lucy_FType_binary
  #define FType_compare_values_t lucy_FType_compare_values_t
  #define FType_compare_values lucy_FType_compare_values
  #define FType_make_term_stepper_t lucy_FType_make_term_stepper_t
  #define FType_make_term_stepper lucy_FType_make_term_stepper
  #define FType_primitive_id_t lucy_FType_primitive_id_t
  #define FType_primitive_id lucy_FType_primitive_id
  #define FType_dump_for_schema_t lucy_FType_dump_for_schema_t
  #define FType_dump_for_schema lucy_FType_dump_for_schema
  #define FType_Make Lucy_FType_Make
  #define FType_Get_RefCount Lucy_FType_Get_RefCount
  #define FType_Inc_RefCount Lucy_FType_Inc_RefCount
  #define FType_Dec_RefCount Lucy_FType_Dec_RefCount
  #define FType_To_Host Lucy_FType_To_Host
  #define FType_Clone Lucy_FType_Clone
  #define FType_Destroy Lucy_FType_Destroy
  #define FType_Equals Lucy_FType_Equals
  #define FType_Compare_To Lucy_FType_Compare_To
  #define FType_Hash_Sum Lucy_FType_Hash_Sum
  #define FType_Get_VTable Lucy_FType_Get_VTable
  #define FType_Get_Class_Name Lucy_FType_Get_Class_Name
  #define FType_Is_A Lucy_FType_Is_A
  #define FType_To_String Lucy_FType_To_String
  #define FType_To_I64 Lucy_FType_To_I64
  #define FType_To_F64 Lucy_FType_To_F64
  #define FType_To_Bool Lucy_FType_To_Bool
  #define FType_Serialize Lucy_FType_Serialize
  #define FType_Deserialize Lucy_FType_Deserialize
  #define FType_Dump Lucy_FType_Dump
  #define FType_Load Lucy_FType_Load
  #define FType_Mimic Lucy_FType_Mimic
  #define FType_Set_Boost Lucy_FType_Set_Boost
  #define FType_Get_Boost Lucy_FType_Get_Boost
  #define FType_Set_Indexed Lucy_FType_Set_Indexed
  #define FType_Indexed Lucy_FType_Indexed
  #define FType_Set_Stored Lucy_FType_Set_Stored
  #define FType_Stored Lucy_FType_Stored
  #define FType_Set_Sortable Lucy_FType_Set_Sortable
  #define FType_Sortable Lucy_FType_Sortable
  #define FType_Binary Lucy_FType_Binary
  #define FType_Compare_Values Lucy_FType_Compare_Values
  #define FType_Make_Term_Stepper Lucy_FType_Make_Term_Stepper
  #define FType_Primitive_ID Lucy_FType_Primitive_ID
  #define FType_Dump_For_Schema Lucy_FType_Dump_For_Schema
#endif /* LUCY_USE_SHORT_NAMES */



static CHY_INLINE int32_t
lucy_FType_null_back_compare_values(lucy_FieldType *self,
                                    lucy_Obj *a, lucy_Obj *b) {
    if (a == NULL) {
        if (b == NULL) { return 0; }
        else { return 1; }
    }
    else if (b == NULL) {
        return -1;
    }
    else {
        return Lucy_FType_Compare_Values(self, a, b);
    }
}




#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_PLAN_FIELDTYPE */




