/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_PLAN_FULLTEXTTYPE
#define H_LUCY_PLAN_FULLTEXTTYPE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Plan/TextType.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FULLTEXTTYPE
struct lucy_FullTextType {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    chy_bool_t indexed;
    chy_bool_t stored;
    chy_bool_t sortable;
    chy_bool_t highlightable;
    lucy_Analyzer* analyzer;
};

#endif /* C_LUCY_FULLTEXTTYPE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_FullTextType*
lucy_FullTextType_init(lucy_FullTextType* self, lucy_Analyzer* analyzer);

lucy_FullTextType*
lucy_FullTextType_init2(lucy_FullTextType* self, lucy_Analyzer* analyzer, float boost, chy_bool_t indexed, chy_bool_t stored, chy_bool_t sortable, chy_bool_t highlightable);

lucy_FullTextType*
lucy_FullTextType_new(lucy_Analyzer* analyzer);

void
lucy_FullTextType_destroy(lucy_FullTextType* self);

chy_bool_t
lucy_FullTextType_equals(lucy_FullTextType* self, lucy_Obj* other);

lucy_Hash*
lucy_FullTextType_dump(lucy_FullTextType* self);

lucy_FullTextType*
lucy_FullTextType_load(lucy_FullTextType* self, lucy_Obj* dump);

lucy_Hash*
lucy_FullTextType_dump_for_schema(lucy_FullTextType* self);

void
lucy_FullTextType_set_highlightable(lucy_FullTextType* self, chy_bool_t highlightable);

chy_bool_t
lucy_FullTextType_highlightable(lucy_FullTextType* self);

lucy_Analyzer*
lucy_FullTextType_get_analyzer(lucy_FullTextType* self);

lucy_Similarity*
lucy_FullTextType_make_similarity(lucy_FullTextType* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_FullTextType_destroy_CALLBACK;
extern cfish_Callback lucy_FullTextType_equals_CALLBACK;
extern cfish_Callback lucy_FullTextType_dump_CALLBACK;
extern cfish_Callback lucy_FullTextType_load_CALLBACK;
extern cfish_Callback lucy_FullTextType_set_highlightable_CALLBACK;
extern cfish_Callback lucy_FullTextType_highlightable_CALLBACK;
extern cfish_Callback lucy_FullTextType_get_analyzer_CALLBACK;
extern cfish_Callback lucy_FullTextType_make_similarity_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_FullTextType_destroy_t)(lucy_FullTextType* self);

typedef chy_bool_t
(*lucy_FullTextType_equals_t)(lucy_FullTextType* self, lucy_Obj* other);

typedef lucy_Hash*
(*lucy_FullTextType_dump_t)(lucy_FullTextType* self);

typedef lucy_FullTextType*
(*lucy_FullTextType_load_t)(lucy_FullTextType* self, lucy_Obj* dump);

typedef lucy_Hash*
(*lucy_FullTextType_dump_for_schema_t)(lucy_FullTextType* self);

typedef void
(*lucy_FullTextType_set_highlightable_t)(lucy_FullTextType* self, chy_bool_t highlightable);

typedef chy_bool_t
(*lucy_FullTextType_highlightable_t)(lucy_FullTextType* self);

typedef lucy_Analyzer*
(*lucy_FullTextType_get_analyzer_t)(lucy_FullTextType* self);

typedef lucy_Similarity*
(*lucy_FullTextType_make_similarity_t)(lucy_FullTextType* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_FullTextType_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FullTextType_Make(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FullTextType_Get_RefCount(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FullTextType_Inc_RefCount(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FullTextType_Dec_RefCount(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_FullTextType_To_Host(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FullTextType_Clone(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Destroy_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Destroy(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Destroy_OFFSET;
    const lucy_FullTextType_destroy_t method = *((lucy_FullTextType_destroy_t*)method_address);
    method((lucy_FullTextType*)self);
}

extern size_t Lucy_FullTextType_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Equals(const lucy_FullTextType *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Equals_OFFSET;
    const lucy_FullTextType_equals_t method = *((lucy_FullTextType_equals_t*)method_address);
    return method((lucy_FullTextType*)self, other);
}

extern size_t Lucy_FullTextType_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_FullTextType_Compare_To(const lucy_FullTextType *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FullTextType_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_FullTextType_Hash_Sum(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_FullTextType_Get_VTable(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FullTextType_Get_Class_Name(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Is_A(const lucy_FullTextType *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_FullTextType_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FullTextType_To_String(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_FullTextType_To_I64(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_To_F64_OFFSET;
static CHY_INLINE double
Lucy_FullTextType_To_F64(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_To_Bool(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FullTextType_Serialize_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Serialize(const lucy_FullTextType *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_FullTextType_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FullTextType_Deserialize(const lucy_FullTextType *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_FullTextType_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_FullTextType_Dump(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Dump_OFFSET;
    const lucy_FullTextType_dump_t method = *((lucy_FullTextType_dump_t*)method_address);
    return method((lucy_FullTextType*)self);
}

extern size_t Lucy_FullTextType_Load_OFFSET;
static CHY_INLINE lucy_FullTextType*
Lucy_FullTextType_Load(const lucy_FullTextType *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Load_OFFSET;
    const lucy_FullTextType_load_t method = *((lucy_FullTextType_load_t*)method_address);
    return method((lucy_FullTextType*)self, dump);
}

extern size_t Lucy_FullTextType_Mimic_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Mimic(const lucy_FullTextType *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_FullTextType_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Set_Boost(const lucy_FullTextType *self, float boost) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Set_Boost_OFFSET;
    const lucy_FType_set_boost_t method = *((lucy_FType_set_boost_t*)method_address);
    method((lucy_FieldType*)self, boost);
}

extern size_t Lucy_FullTextType_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_FullTextType_Get_Boost(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Get_Boost_OFFSET;
    const lucy_FType_get_boost_t method = *((lucy_FType_get_boost_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FullTextType_Set_Indexed_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Set_Indexed(const lucy_FullTextType *self, chy_bool_t indexed) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Set_Indexed_OFFSET;
    const lucy_FType_set_indexed_t method = *((lucy_FType_set_indexed_t*)method_address);
    method((lucy_FieldType*)self, indexed);
}

extern size_t Lucy_FullTextType_Indexed_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Indexed(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Indexed_OFFSET;
    const lucy_FType_indexed_t method = *((lucy_FType_indexed_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FullTextType_Set_Stored_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Set_Stored(const lucy_FullTextType *self, chy_bool_t stored) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Set_Stored_OFFSET;
    const lucy_FType_set_stored_t method = *((lucy_FType_set_stored_t*)method_address);
    method((lucy_FieldType*)self, stored);
}

extern size_t Lucy_FullTextType_Stored_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Stored(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Stored_OFFSET;
    const lucy_FType_stored_t method = *((lucy_FType_stored_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FullTextType_Set_Sortable_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Set_Sortable(const lucy_FullTextType *self, chy_bool_t sortable) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Set_Sortable_OFFSET;
    const lucy_FType_set_sortable_t method = *((lucy_FType_set_sortable_t*)method_address);
    method((lucy_FieldType*)self, sortable);
}

extern size_t Lucy_FullTextType_Sortable_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Sortable(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Sortable_OFFSET;
    const lucy_FType_sortable_t method = *((lucy_FType_sortable_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FullTextType_Binary_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Binary(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Binary_OFFSET;
    const lucy_FType_binary_t method = *((lucy_FType_binary_t*)method_address);
    return method((lucy_FieldType*)self);
}

extern size_t Lucy_FullTextType_Compare_Values_OFFSET;
static CHY_INLINE int32_t
Lucy_FullTextType_Compare_Values(const lucy_FullTextType *self, lucy_Obj* a, lucy_Obj* b) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Compare_Values_OFFSET;
    const lucy_FType_compare_values_t method = *((lucy_FType_compare_values_t*)method_address);
    return method((lucy_FieldType*)self, a, b);
}

extern size_t Lucy_FullTextType_Make_Term_Stepper_OFFSET;
static CHY_INLINE lucy_TermStepper*
Lucy_FullTextType_Make_Term_Stepper(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Make_Term_Stepper_OFFSET;
    const lucy_TextType_make_term_stepper_t method = *((lucy_TextType_make_term_stepper_t*)method_address);
    return method((lucy_TextType*)self);
}

extern size_t Lucy_FullTextType_Primitive_ID_OFFSET;
static CHY_INLINE int8_t
Lucy_FullTextType_Primitive_ID(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Primitive_ID_OFFSET;
    const lucy_TextType_primitive_id_t method = *((lucy_TextType_primitive_id_t*)method_address);
    return method((lucy_TextType*)self);
}

extern size_t Lucy_FullTextType_Dump_For_Schema_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_FullTextType_Dump_For_Schema(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Dump_For_Schema_OFFSET;
    const lucy_FullTextType_dump_for_schema_t method = *((lucy_FullTextType_dump_for_schema_t*)method_address);
    return method((lucy_FullTextType*)self);
}

extern size_t Lucy_FullTextType_Make_Blank_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FullTextType_Make_Blank(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Make_Blank_OFFSET;
    const lucy_TextType_make_blank_t method = *((lucy_TextType_make_blank_t*)method_address);
    return method((lucy_TextType*)self);
}

extern size_t Lucy_FullTextType_Set_Highlightable_OFFSET;
static CHY_INLINE void
Lucy_FullTextType_Set_Highlightable(const lucy_FullTextType *self, chy_bool_t highlightable) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Set_Highlightable_OFFSET;
    const lucy_FullTextType_set_highlightable_t method = *((lucy_FullTextType_set_highlightable_t*)method_address);
    method((lucy_FullTextType*)self, highlightable);
}

extern size_t Lucy_FullTextType_Highlightable_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FullTextType_Highlightable(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Highlightable_OFFSET;
    const lucy_FullTextType_highlightable_t method = *((lucy_FullTextType_highlightable_t*)method_address);
    return method((lucy_FullTextType*)self);
}

extern size_t Lucy_FullTextType_Get_Analyzer_OFFSET;
static CHY_INLINE lucy_Analyzer*
Lucy_FullTextType_Get_Analyzer(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Get_Analyzer_OFFSET;
    const lucy_FullTextType_get_analyzer_t method = *((lucy_FullTextType_get_analyzer_t*)method_address);
    return method((lucy_FullTextType*)self);
}

extern size_t Lucy_FullTextType_Make_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_FullTextType_Make_Similarity(const lucy_FullTextType *self) {
    char *const method_address = *(char**)self + Lucy_FullTextType_Make_Similarity_OFFSET;
    const lucy_FullTextType_make_similarity_t method = *((lucy_FullTextType_make_similarity_t*)method_address);
    return method((lucy_FullTextType*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FULLTEXTTYPE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[40];
} LUCY_FULLTEXTTYPE_VT;
extern struct LUCY_FULLTEXTTYPE_VT LUCY_FULLTEXTTYPE_vt;
#define LUCY_FULLTEXTTYPE ((cfish_VTable*)&LUCY_FULLTEXTTYPE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FullTextType lucy_FullTextType
  #define FULLTEXTTYPE LUCY_FULLTEXTTYPE
  #define FullTextType_init lucy_FullTextType_init
  #define FullTextType_init2 lucy_FullTextType_init2
  #define FullTextType_new lucy_FullTextType_new
  #define FullTextType_destroy_t lucy_FullTextType_destroy_t
  #define FullTextType_destroy lucy_FullTextType_destroy
  #define FullTextType_equals_t lucy_FullTextType_equals_t
  #define FullTextType_equals lucy_FullTextType_equals
  #define FullTextType_dump_t lucy_FullTextType_dump_t
  #define FullTextType_dump lucy_FullTextType_dump
  #define FullTextType_load_t lucy_FullTextType_load_t
  #define FullTextType_load lucy_FullTextType_load
  #define FullTextType_dump_for_schema_t lucy_FullTextType_dump_for_schema_t
  #define FullTextType_dump_for_schema lucy_FullTextType_dump_for_schema
  #define FullTextType_set_highlightable_t lucy_FullTextType_set_highlightable_t
  #define FullTextType_set_highlightable lucy_FullTextType_set_highlightable
  #define FullTextType_highlightable_t lucy_FullTextType_highlightable_t
  #define FullTextType_highlightable lucy_FullTextType_highlightable
  #define FullTextType_get_analyzer_t lucy_FullTextType_get_analyzer_t
  #define FullTextType_get_analyzer lucy_FullTextType_get_analyzer
  #define FullTextType_make_similarity_t lucy_FullTextType_make_similarity_t
  #define FullTextType_make_similarity lucy_FullTextType_make_similarity
  #define FullTextType_Make Lucy_FullTextType_Make
  #define FullTextType_Get_RefCount Lucy_FullTextType_Get_RefCount
  #define FullTextType_Inc_RefCount Lucy_FullTextType_Inc_RefCount
  #define FullTextType_Dec_RefCount Lucy_FullTextType_Dec_RefCount
  #define FullTextType_To_Host Lucy_FullTextType_To_Host
  #define FullTextType_Clone Lucy_FullTextType_Clone
  #define FullTextType_Destroy Lucy_FullTextType_Destroy
  #define FullTextType_Equals Lucy_FullTextType_Equals
  #define FullTextType_Compare_To Lucy_FullTextType_Compare_To
  #define FullTextType_Hash_Sum Lucy_FullTextType_Hash_Sum
  #define FullTextType_Get_VTable Lucy_FullTextType_Get_VTable
  #define FullTextType_Get_Class_Name Lucy_FullTextType_Get_Class_Name
  #define FullTextType_Is_A Lucy_FullTextType_Is_A
  #define FullTextType_To_String Lucy_FullTextType_To_String
  #define FullTextType_To_I64 Lucy_FullTextType_To_I64
  #define FullTextType_To_F64 Lucy_FullTextType_To_F64
  #define FullTextType_To_Bool Lucy_FullTextType_To_Bool
  #define FullTextType_Serialize Lucy_FullTextType_Serialize
  #define FullTextType_Deserialize Lucy_FullTextType_Deserialize
  #define FullTextType_Dump Lucy_FullTextType_Dump
  #define FullTextType_Load Lucy_FullTextType_Load
  #define FullTextType_Mimic Lucy_FullTextType_Mimic
  #define FullTextType_Set_Boost Lucy_FullTextType_Set_Boost
  #define FullTextType_Get_Boost Lucy_FullTextType_Get_Boost
  #define FullTextType_Set_Indexed Lucy_FullTextType_Set_Indexed
  #define FullTextType_Indexed Lucy_FullTextType_Indexed
  #define FullTextType_Set_Stored Lucy_FullTextType_Set_Stored
  #define FullTextType_Stored Lucy_FullTextType_Stored
  #define FullTextType_Set_Sortable Lucy_FullTextType_Set_Sortable
  #define FullTextType_Sortable Lucy_FullTextType_Sortable
  #define FullTextType_Binary Lucy_FullTextType_Binary
  #define FullTextType_Compare_Values Lucy_FullTextType_Compare_Values
  #define FullTextType_Make_Term_Stepper Lucy_FullTextType_Make_Term_Stepper
  #define FullTextType_Primitive_ID Lucy_FullTextType_Primitive_ID
  #define FullTextType_Dump_For_Schema Lucy_FullTextType_Dump_For_Schema
  #define FullTextType_Make_Blank Lucy_FullTextType_Make_Blank
  #define FullTextType_Set_Highlightable Lucy_FullTextType_Set_Highlightable
  #define FullTextType_Highlightable Lucy_FullTextType_Highlightable
  #define FullTextType_Get_Analyzer Lucy_FullTextType_Get_Analyzer
  #define FullTextType_Make_Similarity Lucy_FullTextType_Make_Similarity
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_PLAN_FULLTEXTTYPE */




