/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_PLAN_SCHEMA
#define H_LUCY_PLAN_SCHEMA 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SCHEMA
struct lucy_Schema {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Architecture* arch;
    lucy_Similarity* sim;
    lucy_Hash* types;
    lucy_Hash* sims;
    lucy_Hash* analyzers;
    lucy_VArray* uniq_analyzers;
};

#endif /* C_LUCY_SCHEMA */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Schema*
lucy_Schema_new();

lucy_Schema*
lucy_Schema_init(lucy_Schema* self);

void
lucy_Schema_destroy(lucy_Schema* self);

lucy_Hash*
lucy_Schema_dump(lucy_Schema* self);

lucy_Schema*
lucy_Schema_load(lucy_Schema* self, lucy_Obj* dump);

lucy_Architecture*
lucy_Schema_architecture(lucy_Schema* self);

void
lucy_Schema_spec_field(lucy_Schema* self, const lucy_CharBuf* name, lucy_FieldType* type);

lucy_FieldType*
lucy_Schema_fetch_type(lucy_Schema* self, const lucy_CharBuf* field);

lucy_Analyzer*
lucy_Schema_fetch_analyzer(lucy_Schema* self, const lucy_CharBuf* field);

lucy_Similarity*
lucy_Schema_fetch_sim(lucy_Schema* self, const lucy_CharBuf* field);

uint32_t
lucy_Schema_num_fields(lucy_Schema* self);

lucy_VArray*
lucy_Schema_all_fields(lucy_Schema* self);

lucy_Architecture*
lucy_Schema_get_architecture(lucy_Schema* self);

lucy_Similarity*
lucy_Schema_get_similarity(lucy_Schema* self);

void
lucy_Schema_eat(lucy_Schema* self, lucy_Schema* other);

void
lucy_Schema_write(lucy_Schema* self, lucy_Folder* folder, const lucy_CharBuf* filename);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Schema_destroy_CALLBACK;
extern cfish_Callback lucy_Schema_dump_CALLBACK;
extern cfish_Callback lucy_Schema_load_CALLBACK;
extern cfish_Callback lucy_Schema_architecture_CALLBACK;
extern cfish_Callback lucy_Schema_spec_field_CALLBACK;
extern cfish_Callback lucy_Schema_fetch_type_CALLBACK;
extern cfish_Callback lucy_Schema_fetch_sim_CALLBACK;
extern cfish_Callback lucy_Schema_num_fields_CALLBACK;
extern cfish_Callback lucy_Schema_all_fields_CALLBACK;
extern cfish_Callback lucy_Schema_get_architecture_CALLBACK;
extern cfish_Callback lucy_Schema_get_similarity_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Schema_destroy_t)(lucy_Schema* self);

typedef lucy_Hash*
(*lucy_Schema_dump_t)(lucy_Schema* self);

typedef lucy_Schema*
(*lucy_Schema_load_t)(lucy_Schema* self, lucy_Obj* dump);

typedef lucy_Architecture*
(*lucy_Schema_architecture_t)(lucy_Schema* self);

typedef void
(*lucy_Schema_spec_field_t)(lucy_Schema* self, const lucy_CharBuf* name, lucy_FieldType* type);

typedef lucy_FieldType*
(*lucy_Schema_fetch_type_t)(lucy_Schema* self, const lucy_CharBuf* field);

typedef lucy_Analyzer*
(*lucy_Schema_fetch_analyzer_t)(lucy_Schema* self, const lucy_CharBuf* field);

typedef lucy_Similarity*
(*lucy_Schema_fetch_sim_t)(lucy_Schema* self, const lucy_CharBuf* field);

typedef uint32_t
(*lucy_Schema_num_fields_t)(lucy_Schema* self);

typedef lucy_VArray*
(*lucy_Schema_all_fields_t)(lucy_Schema* self);

typedef lucy_Architecture*
(*lucy_Schema_get_architecture_t)(lucy_Schema* self);

typedef lucy_Similarity*
(*lucy_Schema_get_similarity_t)(lucy_Schema* self);

typedef void
(*lucy_Schema_eat_t)(lucy_Schema* self, lucy_Schema* other);

typedef void
(*lucy_Schema_write_t)(lucy_Schema* self, lucy_Folder* folder, const lucy_CharBuf* filename);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Schema_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Schema_Make(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Schema_Get_RefCount(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Schema_Inc_RefCount(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Schema_Dec_RefCount(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Schema_To_Host(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Schema_Clone(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Schema_Destroy(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Destroy_OFFSET;
    const lucy_Schema_destroy_t method = *((lucy_Schema_destroy_t*)method_address);
    method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Schema_Equals(const lucy_Schema *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Schema_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Schema_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Schema_Compare_To(const lucy_Schema *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Schema_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Schema_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Schema_Hash_Sum(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Schema_Get_VTable(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Schema_Get_Class_Name(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Schema_Is_A(const lucy_Schema *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Schema_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Schema_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Schema_To_String(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Schema_To_I64(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Schema_To_F64(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Schema_To_Bool(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Schema_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Schema_Serialize(const lucy_Schema *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Schema_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Schema_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Schema_Deserialize(const lucy_Schema *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Schema_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Schema_Dump_OFFSET;
static CHY_INLINE lucy_Hash*
Lucy_Schema_Dump(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Dump_OFFSET;
    const lucy_Schema_dump_t method = *((lucy_Schema_dump_t*)method_address);
    return method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_Load_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_Schema_Load(const lucy_Schema *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Schema_Load_OFFSET;
    const lucy_Schema_load_t method = *((lucy_Schema_load_t*)method_address);
    return method((lucy_Schema*)self, dump);
}

extern size_t Lucy_Schema_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Schema_Mimic(const lucy_Schema *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Schema_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Schema_Architecture_OFFSET;
static CHY_INLINE lucy_Architecture*
Lucy_Schema_Architecture(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Architecture_OFFSET;
    const lucy_Schema_architecture_t method = *((lucy_Schema_architecture_t*)method_address);
    return method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_Spec_Field_OFFSET;
static CHY_INLINE void
Lucy_Schema_Spec_Field(const lucy_Schema *self, const lucy_CharBuf* name, lucy_FieldType* type) {
    char *const method_address = *(char**)self + Lucy_Schema_Spec_Field_OFFSET;
    const lucy_Schema_spec_field_t method = *((lucy_Schema_spec_field_t*)method_address);
    method((lucy_Schema*)self, name, type);
}

extern size_t Lucy_Schema_Fetch_Type_OFFSET;
static CHY_INLINE lucy_FieldType*
Lucy_Schema_Fetch_Type(const lucy_Schema *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_Schema_Fetch_Type_OFFSET;
    const lucy_Schema_fetch_type_t method = *((lucy_Schema_fetch_type_t*)method_address);
    return method((lucy_Schema*)self, field);
}

extern size_t Lucy_Schema_Fetch_Analyzer_OFFSET;
static CHY_INLINE lucy_Analyzer*
Lucy_Schema_Fetch_Analyzer(const lucy_Schema *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_Schema_Fetch_Analyzer_OFFSET;
    const lucy_Schema_fetch_analyzer_t method = *((lucy_Schema_fetch_analyzer_t*)method_address);
    return method((lucy_Schema*)self, field);
}

extern size_t Lucy_Schema_Fetch_Sim_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_Schema_Fetch_Sim(const lucy_Schema *self, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_Schema_Fetch_Sim_OFFSET;
    const lucy_Schema_fetch_sim_t method = *((lucy_Schema_fetch_sim_t*)method_address);
    return method((lucy_Schema*)self, field);
}

extern size_t Lucy_Schema_Num_Fields_OFFSET;
static CHY_INLINE uint32_t
Lucy_Schema_Num_Fields(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Num_Fields_OFFSET;
    const lucy_Schema_num_fields_t method = *((lucy_Schema_num_fields_t*)method_address);
    return method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_All_Fields_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Schema_All_Fields(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_All_Fields_OFFSET;
    const lucy_Schema_all_fields_t method = *((lucy_Schema_all_fields_t*)method_address);
    return method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_Get_Architecture_OFFSET;
static CHY_INLINE lucy_Architecture*
Lucy_Schema_Get_Architecture(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Get_Architecture_OFFSET;
    const lucy_Schema_get_architecture_t method = *((lucy_Schema_get_architecture_t*)method_address);
    return method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_Schema_Get_Similarity(const lucy_Schema *self) {
    char *const method_address = *(char**)self + Lucy_Schema_Get_Similarity_OFFSET;
    const lucy_Schema_get_similarity_t method = *((lucy_Schema_get_similarity_t*)method_address);
    return method((lucy_Schema*)self);
}

extern size_t Lucy_Schema_Eat_OFFSET;
static CHY_INLINE void
Lucy_Schema_Eat(const lucy_Schema *self, lucy_Schema* other) {
    char *const method_address = *(char**)self + Lucy_Schema_Eat_OFFSET;
    const lucy_Schema_eat_t method = *((lucy_Schema_eat_t*)method_address);
    method((lucy_Schema*)self, other);
}

extern size_t Lucy_Schema_Write_OFFSET;
static CHY_INLINE void
Lucy_Schema_Write(const lucy_Schema *self, lucy_Folder* folder, const lucy_CharBuf* filename) {
    char *const method_address = *(char**)self + Lucy_Schema_Write_OFFSET;
    const lucy_Schema_write_t method = *((lucy_Schema_write_t*)method_address);
    method((lucy_Schema*)self, folder, filename);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SCHEMA_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_SCHEMA_VT;
extern struct LUCY_SCHEMA_VT LUCY_SCHEMA_vt;
#define LUCY_SCHEMA ((cfish_VTable*)&LUCY_SCHEMA_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Schema lucy_Schema
  #define SCHEMA LUCY_SCHEMA
  #define Schema_new lucy_Schema_new
  #define Schema_init lucy_Schema_init
  #define Schema_destroy_t lucy_Schema_destroy_t
  #define Schema_destroy lucy_Schema_destroy
  #define Schema_dump_t lucy_Schema_dump_t
  #define Schema_dump lucy_Schema_dump
  #define Schema_load_t lucy_Schema_load_t
  #define Schema_load lucy_Schema_load
  #define Schema_architecture_t lucy_Schema_architecture_t
  #define Schema_architecture lucy_Schema_architecture
  #define Schema_spec_field_t lucy_Schema_spec_field_t
  #define Schema_spec_field lucy_Schema_spec_field
  #define Schema_fetch_type_t lucy_Schema_fetch_type_t
  #define Schema_fetch_type lucy_Schema_fetch_type
  #define Schema_fetch_analyzer_t lucy_Schema_fetch_analyzer_t
  #define Schema_fetch_analyzer lucy_Schema_fetch_analyzer
  #define Schema_fetch_sim_t lucy_Schema_fetch_sim_t
  #define Schema_fetch_sim lucy_Schema_fetch_sim
  #define Schema_num_fields_t lucy_Schema_num_fields_t
  #define Schema_num_fields lucy_Schema_num_fields
  #define Schema_all_fields_t lucy_Schema_all_fields_t
  #define Schema_all_fields lucy_Schema_all_fields
  #define Schema_get_architecture_t lucy_Schema_get_architecture_t
  #define Schema_get_architecture lucy_Schema_get_architecture
  #define Schema_get_similarity_t lucy_Schema_get_similarity_t
  #define Schema_get_similarity lucy_Schema_get_similarity
  #define Schema_eat_t lucy_Schema_eat_t
  #define Schema_eat lucy_Schema_eat
  #define Schema_write_t lucy_Schema_write_t
  #define Schema_write lucy_Schema_write
  #define Schema_Make Lucy_Schema_Make
  #define Schema_Get_RefCount Lucy_Schema_Get_RefCount
  #define Schema_Inc_RefCount Lucy_Schema_Inc_RefCount
  #define Schema_Dec_RefCount Lucy_Schema_Dec_RefCount
  #define Schema_To_Host Lucy_Schema_To_Host
  #define Schema_Clone Lucy_Schema_Clone
  #define Schema_Destroy Lucy_Schema_Destroy
  #define Schema_Equals Lucy_Schema_Equals
  #define Schema_Compare_To Lucy_Schema_Compare_To
  #define Schema_Hash_Sum Lucy_Schema_Hash_Sum
  #define Schema_Get_VTable Lucy_Schema_Get_VTable
  #define Schema_Get_Class_Name Lucy_Schema_Get_Class_Name
  #define Schema_Is_A Lucy_Schema_Is_A
  #define Schema_To_String Lucy_Schema_To_String
  #define Schema_To_I64 Lucy_Schema_To_I64
  #define Schema_To_F64 Lucy_Schema_To_F64
  #define Schema_To_Bool Lucy_Schema_To_Bool
  #define Schema_Serialize Lucy_Schema_Serialize
  #define Schema_Deserialize Lucy_Schema_Deserialize
  #define Schema_Dump Lucy_Schema_Dump
  #define Schema_Load Lucy_Schema_Load
  #define Schema_Mimic Lucy_Schema_Mimic
  #define Schema_Architecture Lucy_Schema_Architecture
  #define Schema_Spec_Field Lucy_Schema_Spec_Field
  #define Schema_Fetch_Type Lucy_Schema_Fetch_Type
  #define Schema_Fetch_Analyzer Lucy_Schema_Fetch_Analyzer
  #define Schema_Fetch_Sim Lucy_Schema_Fetch_Sim
  #define Schema_Num_Fields Lucy_Schema_Num_Fields
  #define Schema_All_Fields Lucy_Schema_All_Fields
  #define Schema_Get_Architecture Lucy_Schema_Get_Architecture
  #define Schema_Get_Similarity Lucy_Schema_Get_Similarity
  #define Schema_Eat Lucy_Schema_Eat
  #define Schema_Write Lucy_Schema_Write
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_PLAN_SCHEMA */




