/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_ANDMATCHER
#define H_LUCY_SEARCH_ANDMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/PolyMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ANDMATCHER
struct lucy_ANDMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
    lucy_Matcher** kids;
    chy_bool_t more;
    chy_bool_t first_time;
};

#endif /* C_LUCY_ANDMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ANDMatcher*
lucy_ANDMatcher_new(lucy_VArray* children, lucy_Similarity* sim);

lucy_ANDMatcher*
lucy_ANDMatcher_init(lucy_ANDMatcher* self, lucy_VArray* children, lucy_Similarity* similarity);

void
lucy_ANDMatcher_destroy(lucy_ANDMatcher* self);

int32_t
lucy_ANDMatcher_next(lucy_ANDMatcher* self);

int32_t
lucy_ANDMatcher_advance(lucy_ANDMatcher* self, int32_t target);

int32_t
lucy_ANDMatcher_get_doc_id(lucy_ANDMatcher* self);

float
lucy_ANDMatcher_score(lucy_ANDMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ANDMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_ANDMatcher_next_CALLBACK;
extern cfish_Callback lucy_ANDMatcher_advance_CALLBACK;
extern cfish_Callback lucy_ANDMatcher_get_doc_id_CALLBACK;
extern cfish_Callback lucy_ANDMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ANDMatcher_destroy_t)(lucy_ANDMatcher* self);

typedef int32_t
(*lucy_ANDMatcher_next_t)(lucy_ANDMatcher* self);

typedef int32_t
(*lucy_ANDMatcher_advance_t)(lucy_ANDMatcher* self, int32_t target);

typedef int32_t
(*lucy_ANDMatcher_get_doc_id_t)(lucy_ANDMatcher* self);

typedef float
(*lucy_ANDMatcher_score_t)(lucy_ANDMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ANDMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ANDMatcher_Make(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ANDMatcher_Get_RefCount(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ANDMatcher_Inc_RefCount(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ANDMatcher_Dec_RefCount(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ANDMatcher_To_Host(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ANDMatcher_Clone(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ANDMatcher_Destroy(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Destroy_OFFSET;
    const lucy_ANDMatcher_destroy_t method = *((lucy_ANDMatcher_destroy_t*)method_address);
    method((lucy_ANDMatcher*)self);
}

extern size_t Lucy_ANDMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ANDMatcher_Equals(const lucy_ANDMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ANDMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ANDMatcher_Compare_To(const lucy_ANDMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ANDMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ANDMatcher_Hash_Sum(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ANDMatcher_Get_VTable(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ANDMatcher_Get_Class_Name(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ANDMatcher_Is_A(const lucy_ANDMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ANDMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ANDMatcher_To_String(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ANDMatcher_To_I64(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ANDMatcher_To_F64(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ANDMatcher_To_Bool(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ANDMatcher_Serialize(const lucy_ANDMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ANDMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ANDMatcher_Deserialize(const lucy_ANDMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ANDMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ANDMatcher_Dump(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ANDMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ANDMatcher_Load(const lucy_ANDMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ANDMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ANDMatcher_Mimic(const lucy_ANDMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ANDMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_ANDMatcher_Next(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Next_OFFSET;
    const lucy_ANDMatcher_next_t method = *((lucy_ANDMatcher_next_t*)method_address);
    return method((lucy_ANDMatcher*)self);
}

extern size_t Lucy_ANDMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_ANDMatcher_Advance(const lucy_ANDMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Advance_OFFSET;
    const lucy_ANDMatcher_advance_t method = *((lucy_ANDMatcher_advance_t*)method_address);
    return method((lucy_ANDMatcher*)self, target);
}

extern size_t Lucy_ANDMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ANDMatcher_Get_Doc_ID(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Get_Doc_ID_OFFSET;
    const lucy_ANDMatcher_get_doc_id_t method = *((lucy_ANDMatcher_get_doc_id_t*)method_address);
    return method((lucy_ANDMatcher*)self);
}

extern size_t Lucy_ANDMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_ANDMatcher_Score(const lucy_ANDMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Score_OFFSET;
    const lucy_ANDMatcher_score_t method = *((lucy_ANDMatcher_score_t*)method_address);
    return method((lucy_ANDMatcher*)self);
}

extern size_t Lucy_ANDMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_ANDMatcher_Collect(const lucy_ANDMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_ANDMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_ANDMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_ANDMATCHER_VT;
extern struct LUCY_ANDMATCHER_VT LUCY_ANDMATCHER_vt;
#define LUCY_ANDMATCHER ((cfish_VTable*)&LUCY_ANDMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ANDMatcher lucy_ANDMatcher
  #define ANDMATCHER LUCY_ANDMATCHER
  #define ANDMatcher_new lucy_ANDMatcher_new
  #define ANDMatcher_init lucy_ANDMatcher_init
  #define ANDMatcher_destroy_t lucy_ANDMatcher_destroy_t
  #define ANDMatcher_destroy lucy_ANDMatcher_destroy
  #define ANDMatcher_next_t lucy_ANDMatcher_next_t
  #define ANDMatcher_next lucy_ANDMatcher_next
  #define ANDMatcher_advance_t lucy_ANDMatcher_advance_t
  #define ANDMatcher_advance lucy_ANDMatcher_advance
  #define ANDMatcher_get_doc_id_t lucy_ANDMatcher_get_doc_id_t
  #define ANDMatcher_get_doc_id lucy_ANDMatcher_get_doc_id
  #define ANDMatcher_score_t lucy_ANDMatcher_score_t
  #define ANDMatcher_score lucy_ANDMatcher_score
  #define ANDMatcher_Make Lucy_ANDMatcher_Make
  #define ANDMatcher_Get_RefCount Lucy_ANDMatcher_Get_RefCount
  #define ANDMatcher_Inc_RefCount Lucy_ANDMatcher_Inc_RefCount
  #define ANDMatcher_Dec_RefCount Lucy_ANDMatcher_Dec_RefCount
  #define ANDMatcher_To_Host Lucy_ANDMatcher_To_Host
  #define ANDMatcher_Clone Lucy_ANDMatcher_Clone
  #define ANDMatcher_Destroy Lucy_ANDMatcher_Destroy
  #define ANDMatcher_Equals Lucy_ANDMatcher_Equals
  #define ANDMatcher_Compare_To Lucy_ANDMatcher_Compare_To
  #define ANDMatcher_Hash_Sum Lucy_ANDMatcher_Hash_Sum
  #define ANDMatcher_Get_VTable Lucy_ANDMatcher_Get_VTable
  #define ANDMatcher_Get_Class_Name Lucy_ANDMatcher_Get_Class_Name
  #define ANDMatcher_Is_A Lucy_ANDMatcher_Is_A
  #define ANDMatcher_To_String Lucy_ANDMatcher_To_String
  #define ANDMatcher_To_I64 Lucy_ANDMatcher_To_I64
  #define ANDMatcher_To_F64 Lucy_ANDMatcher_To_F64
  #define ANDMatcher_To_Bool Lucy_ANDMatcher_To_Bool
  #define ANDMatcher_Serialize Lucy_ANDMatcher_Serialize
  #define ANDMatcher_Deserialize Lucy_ANDMatcher_Deserialize
  #define ANDMatcher_Dump Lucy_ANDMatcher_Dump
  #define ANDMatcher_Load Lucy_ANDMatcher_Load
  #define ANDMatcher_Mimic Lucy_ANDMatcher_Mimic
  #define ANDMatcher_Next Lucy_ANDMatcher_Next
  #define ANDMatcher_Advance Lucy_ANDMatcher_Advance
  #define ANDMatcher_Get_Doc_ID Lucy_ANDMatcher_Get_Doc_ID
  #define ANDMatcher_Score Lucy_ANDMatcher_Score
  #define ANDMatcher_Collect Lucy_ANDMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_ANDMATCHER */




