/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_COLLECTOR_SORTCOLLECTOR
#define H_LUCY_SEARCH_COLLECTOR_SORTCOLLECTOR 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Collector.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTCOLLECTOR
struct lucy_SortCollector {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_SegReader* reader;
    lucy_Matcher* matcher;
    int32_t base;
    uint32_t wanted;
    uint32_t total_hits;
    lucy_HitQueue* hit_q;
    lucy_MatchDoc* bumped;
    lucy_VArray* rules;
    lucy_SortCache** sort_caches;
    void** ord_arrays;
    uint8_t* actions;
    uint8_t* auto_actions;
    uint8_t* derived_actions;
    uint32_t num_rules;
    uint32_t num_actions;
    float bubble_score;
    int32_t bubble_doc;
    int32_t seg_doc_max;
    chy_bool_t need_score;
    chy_bool_t need_values;
};

#endif /* C_LUCY_SORTCOLLECTOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SortCollector*
lucy_SortColl_new(lucy_Schema* schema, lucy_SortSpec* sort_spec, uint32_t wanted);

lucy_SortCollector*
lucy_SortColl_init(lucy_SortCollector* self, lucy_Schema* schema, lucy_SortSpec* sort_spec, uint32_t wanted);

void
lucy_SortColl_destroy(lucy_SortCollector* self);

void
lucy_SortColl_collect(lucy_SortCollector* self, int32_t doc_id);

void
lucy_SortColl_set_reader(lucy_SortCollector* self, lucy_SegReader* reader);

chy_bool_t
lucy_SortColl_need_score(lucy_SortCollector* self);

lucy_VArray*
lucy_SortColl_pop_match_docs(lucy_SortCollector* self);

uint32_t
lucy_SortColl_get_total_hits(lucy_SortCollector* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SortColl_destroy_CALLBACK;
extern cfish_Callback lucy_SortColl_collect_CALLBACK;
extern cfish_Callback lucy_SortColl_set_reader_CALLBACK;
extern cfish_Callback lucy_SortColl_need_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SortColl_destroy_t)(lucy_SortCollector* self);

typedef void
(*lucy_SortColl_collect_t)(lucy_SortCollector* self, int32_t doc_id);

typedef void
(*lucy_SortColl_set_reader_t)(lucy_SortCollector* self, lucy_SegReader* reader);

typedef chy_bool_t
(*lucy_SortColl_need_score_t)(lucy_SortCollector* self);

typedef lucy_VArray*
(*lucy_SortColl_pop_match_docs_t)(lucy_SortCollector* self);

typedef uint32_t
(*lucy_SortColl_get_total_hits_t)(lucy_SortCollector* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SortColl_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortColl_Make(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortColl_Get_RefCount(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortColl_Inc_RefCount(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortColl_Dec_RefCount(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SortColl_To_Host(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortColl_Clone(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Destroy(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Destroy_OFFSET;
    const lucy_SortColl_destroy_t method = *((lucy_SortColl_destroy_t*)method_address);
    method((lucy_SortCollector*)self);
}

extern size_t Lucy_SortColl_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortColl_Equals(const lucy_SortCollector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortColl_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortColl_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SortColl_Compare_To(const lucy_SortCollector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortColl_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortColl_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SortColl_Hash_Sum(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SortColl_Get_VTable(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortColl_Get_Class_Name(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortColl_Is_A(const lucy_SortCollector *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SortColl_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SortColl_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortColl_To_String(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SortColl_To_I64(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SortColl_To_F64(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortColl_To_Bool(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Serialize(const lucy_SortCollector *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SortColl_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SortColl_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortColl_Deserialize(const lucy_SortCollector *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SortColl_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SortColl_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortColl_Dump(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortColl_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortColl_Load(const lucy_SortCollector *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SortColl_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SortColl_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Mimic(const lucy_SortCollector *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortColl_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortColl_Collect_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Collect(const lucy_SortCollector *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_SortColl_Collect_OFFSET;
    const lucy_SortColl_collect_t method = *((lucy_SortColl_collect_t*)method_address);
    method((lucy_SortCollector*)self, doc_id);
}

extern size_t Lucy_SortColl_Set_Reader_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Set_Reader(const lucy_SortCollector *self, lucy_SegReader* reader) {
    char *const method_address = *(char**)self + Lucy_SortColl_Set_Reader_OFFSET;
    const lucy_SortColl_set_reader_t method = *((lucy_SortColl_set_reader_t*)method_address);
    method((lucy_SortCollector*)self, reader);
}

extern size_t Lucy_SortColl_Set_Base_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Set_Base(const lucy_SortCollector *self, int32_t base) {
    char *const method_address = *(char**)self + Lucy_SortColl_Set_Base_OFFSET;
    const lucy_Coll_set_base_t method = *((lucy_Coll_set_base_t*)method_address);
    method((lucy_Collector*)self, base);
}

extern size_t Lucy_SortColl_Need_Score_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortColl_Need_Score(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Need_Score_OFFSET;
    const lucy_SortColl_need_score_t method = *((lucy_SortColl_need_score_t*)method_address);
    return method((lucy_SortCollector*)self);
}

extern size_t Lucy_SortColl_Set_Matcher_OFFSET;
static CHY_INLINE void
Lucy_SortColl_Set_Matcher(const lucy_SortCollector *self, lucy_Matcher* matcher) {
    char *const method_address = *(char**)self + Lucy_SortColl_Set_Matcher_OFFSET;
    const lucy_Coll_set_matcher_t method = *((lucy_Coll_set_matcher_t*)method_address);
    method((lucy_Collector*)self, matcher);
}

extern size_t Lucy_SortColl_Pop_Match_Docs_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_SortColl_Pop_Match_Docs(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Pop_Match_Docs_OFFSET;
    const lucy_SortColl_pop_match_docs_t method = *((lucy_SortColl_pop_match_docs_t*)method_address);
    return method((lucy_SortCollector*)self);
}

extern size_t Lucy_SortColl_Get_Total_Hits_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortColl_Get_Total_Hits(const lucy_SortCollector *self) {
    char *const method_address = *(char**)self + Lucy_SortColl_Get_Total_Hits_OFFSET;
    const lucy_SortColl_get_total_hits_t method = *((lucy_SortColl_get_total_hits_t*)method_address);
    return method((lucy_SortCollector*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SORTCOLLECTOR_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_SORTCOLLECTOR_VT;
extern struct LUCY_SORTCOLLECTOR_VT LUCY_SORTCOLLECTOR_vt;
#define LUCY_SORTCOLLECTOR ((cfish_VTable*)&LUCY_SORTCOLLECTOR_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortCollector lucy_SortCollector
  #define SORTCOLLECTOR LUCY_SORTCOLLECTOR
  #define SortColl_new lucy_SortColl_new
  #define SortColl_init lucy_SortColl_init
  #define SortColl_destroy_t lucy_SortColl_destroy_t
  #define SortColl_destroy lucy_SortColl_destroy
  #define SortColl_collect_t lucy_SortColl_collect_t
  #define SortColl_collect lucy_SortColl_collect
  #define SortColl_set_reader_t lucy_SortColl_set_reader_t
  #define SortColl_set_reader lucy_SortColl_set_reader
  #define SortColl_need_score_t lucy_SortColl_need_score_t
  #define SortColl_need_score lucy_SortColl_need_score
  #define SortColl_pop_match_docs_t lucy_SortColl_pop_match_docs_t
  #define SortColl_pop_match_docs lucy_SortColl_pop_match_docs
  #define SortColl_get_total_hits_t lucy_SortColl_get_total_hits_t
  #define SortColl_get_total_hits lucy_SortColl_get_total_hits
  #define SortColl_Make Lucy_SortColl_Make
  #define SortColl_Get_RefCount Lucy_SortColl_Get_RefCount
  #define SortColl_Inc_RefCount Lucy_SortColl_Inc_RefCount
  #define SortColl_Dec_RefCount Lucy_SortColl_Dec_RefCount
  #define SortColl_To_Host Lucy_SortColl_To_Host
  #define SortColl_Clone Lucy_SortColl_Clone
  #define SortColl_Destroy Lucy_SortColl_Destroy
  #define SortColl_Equals Lucy_SortColl_Equals
  #define SortColl_Compare_To Lucy_SortColl_Compare_To
  #define SortColl_Hash_Sum Lucy_SortColl_Hash_Sum
  #define SortColl_Get_VTable Lucy_SortColl_Get_VTable
  #define SortColl_Get_Class_Name Lucy_SortColl_Get_Class_Name
  #define SortColl_Is_A Lucy_SortColl_Is_A
  #define SortColl_To_String Lucy_SortColl_To_String
  #define SortColl_To_I64 Lucy_SortColl_To_I64
  #define SortColl_To_F64 Lucy_SortColl_To_F64
  #define SortColl_To_Bool Lucy_SortColl_To_Bool
  #define SortColl_Serialize Lucy_SortColl_Serialize
  #define SortColl_Deserialize Lucy_SortColl_Deserialize
  #define SortColl_Dump Lucy_SortColl_Dump
  #define SortColl_Load Lucy_SortColl_Load
  #define SortColl_Mimic Lucy_SortColl_Mimic
  #define SortColl_Collect Lucy_SortColl_Collect
  #define SortColl_Set_Reader Lucy_SortColl_Set_Reader
  #define SortColl_Set_Base Lucy_SortColl_Set_Base
  #define SortColl_Need_Score Lucy_SortColl_Need_Score
  #define SortColl_Set_Matcher Lucy_SortColl_Set_Matcher
  #define SortColl_Pop_Match_Docs Lucy_SortColl_Pop_Match_Docs
  #define SortColl_Get_Total_Hits Lucy_SortColl_Get_Total_Hits
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_COLLECTOR_SORTCOLLECTOR */




