/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_COMPILER
#define H_LUCY_SEARCH_COMPILER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_COMPILER
struct lucy_Compiler {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
};

#endif /* C_LUCY_COMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Compiler*
lucy_Compiler_init(lucy_Compiler* self, lucy_Query* parent, lucy_Searcher* searcher, lucy_Similarity* similarity, float boost);

void
lucy_Compiler_destroy(lucy_Compiler* self);

chy_bool_t
lucy_Compiler_equals(lucy_Compiler* self, lucy_Obj* other);

lucy_CharBuf*
lucy_Compiler_to_string(lucy_Compiler* self);

void
lucy_Compiler_serialize(lucy_Compiler* self, lucy_OutStream* outstream);

lucy_Compiler*
lucy_Compiler_deserialize(lucy_Compiler* self, lucy_InStream* instream);

lucy_Matcher*
lucy_Compiler_make_matcher(lucy_Compiler* self, lucy_SegReader* reader, chy_bool_t need_score);

float
lucy_Compiler_get_weight(lucy_Compiler* self);

lucy_Similarity*
lucy_Compiler_get_similarity(lucy_Compiler* self);

lucy_Query*
lucy_Compiler_get_parent(lucy_Compiler* self);

float
lucy_Compiler_sum_of_squared_weights(lucy_Compiler* self);

void
lucy_Compiler_apply_norm_factor(lucy_Compiler* self, float factor);

void
lucy_Compiler_normalize(lucy_Compiler* self);

lucy_VArray*
lucy_Compiler_highlight_spans(lucy_Compiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Compiler_destroy_CALLBACK;
extern cfish_Callback lucy_Compiler_equals_CALLBACK;
extern cfish_Callback lucy_Compiler_to_string_CALLBACK;
extern cfish_Callback lucy_Compiler_serialize_CALLBACK;
extern cfish_Callback lucy_Compiler_deserialize_CALLBACK;
extern cfish_Callback lucy_Compiler_make_matcher_CALLBACK;
extern cfish_Callback lucy_Compiler_get_weight_CALLBACK;
extern cfish_Callback lucy_Compiler_get_similarity_CALLBACK;
extern cfish_Callback lucy_Compiler_get_parent_CALLBACK;
extern cfish_Callback lucy_Compiler_sum_of_squared_weights_CALLBACK;
extern cfish_Callback lucy_Compiler_apply_norm_factor_CALLBACK;
extern cfish_Callback lucy_Compiler_normalize_CALLBACK;
extern cfish_Callback lucy_Compiler_highlight_spans_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Compiler_destroy_t)(lucy_Compiler* self);

typedef chy_bool_t
(*lucy_Compiler_equals_t)(lucy_Compiler* self, lucy_Obj* other);

typedef lucy_CharBuf*
(*lucy_Compiler_to_string_t)(lucy_Compiler* self);

typedef void
(*lucy_Compiler_serialize_t)(lucy_Compiler* self, lucy_OutStream* outstream);

typedef lucy_Compiler*
(*lucy_Compiler_deserialize_t)(lucy_Compiler* self, lucy_InStream* instream);

typedef lucy_Matcher*
(*lucy_Compiler_make_matcher_t)(lucy_Compiler* self, lucy_SegReader* reader, chy_bool_t need_score);

typedef float
(*lucy_Compiler_get_weight_t)(lucy_Compiler* self);

typedef lucy_Similarity*
(*lucy_Compiler_get_similarity_t)(lucy_Compiler* self);

typedef lucy_Query*
(*lucy_Compiler_get_parent_t)(lucy_Compiler* self);

typedef float
(*lucy_Compiler_sum_of_squared_weights_t)(lucy_Compiler* self);

typedef void
(*lucy_Compiler_apply_norm_factor_t)(lucy_Compiler* self, float factor);

typedef void
(*lucy_Compiler_normalize_t)(lucy_Compiler* self);

typedef lucy_VArray*
(*lucy_Compiler_highlight_spans_t)(lucy_Compiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Compiler_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Compiler_Make(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Compiler_Get_RefCount(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Compiler_Inc_RefCount(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Compiler_Dec_RefCount(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Compiler_To_Host(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Compiler_Clone(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Compiler_Destroy(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Destroy_OFFSET;
    const lucy_Compiler_destroy_t method = *((lucy_Compiler_destroy_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Compiler_Equals(const lucy_Compiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Compiler_Equals_OFFSET;
    const lucy_Compiler_equals_t method = *((lucy_Compiler_equals_t*)method_address);
    return method((lucy_Compiler*)self, other);
}

extern size_t Lucy_Compiler_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Compiler_Compare_To(const lucy_Compiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Compiler_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Compiler_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Compiler_Hash_Sum(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Compiler_Get_VTable(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Compiler_Get_Class_Name(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Compiler_Is_A(const lucy_Compiler *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Compiler_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Compiler_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Compiler_To_String(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_To_String_OFFSET;
    const lucy_Compiler_to_string_t method = *((lucy_Compiler_to_string_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Compiler_To_I64(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Compiler_To_F64(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Compiler_To_Bool(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Compiler_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Compiler_Serialize(const lucy_Compiler *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Compiler_Serialize_OFFSET;
    const lucy_Compiler_serialize_t method = *((lucy_Compiler_serialize_t*)method_address);
    method((lucy_Compiler*)self, outstream);
}

extern size_t Lucy_Compiler_Deserialize_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_Compiler_Deserialize(const lucy_Compiler *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Compiler_Deserialize_OFFSET;
    const lucy_Compiler_deserialize_t method = *((lucy_Compiler_deserialize_t*)method_address);
    return method((lucy_Compiler*)self, instream);
}

extern size_t Lucy_Compiler_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Compiler_Dump(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Dump_OFFSET;
    const lucy_Query_dump_t method = *((lucy_Query_dump_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_Compiler_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Compiler_Load(const lucy_Compiler *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Compiler_Load_OFFSET;
    const lucy_Query_load_t method = *((lucy_Query_load_t*)method_address);
    return method((lucy_Query*)self, dump);
}

extern size_t Lucy_Compiler_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Compiler_Mimic(const lucy_Compiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Compiler_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Compiler_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_Compiler_Make_Compiler(const lucy_Compiler *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_Compiler_Make_Compiler_OFFSET;
    const lucy_Query_make_compiler_t method = *((lucy_Query_make_compiler_t*)method_address);
    return method((lucy_Query*)self, searcher, boost, subordinate);
}

extern size_t Lucy_Compiler_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_Compiler_Set_Boost(const lucy_Compiler *self, float boost) {
    char *const method_address = *(char**)self + Lucy_Compiler_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_Compiler_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_Compiler_Get_Boost(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_Compiler_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_Compiler_Make_Matcher(const lucy_Compiler *self, lucy_SegReader* reader, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_Compiler_Make_Matcher_OFFSET;
    const lucy_Compiler_make_matcher_t method = *((lucy_Compiler_make_matcher_t*)method_address);
    return method((lucy_Compiler*)self, reader, need_score);
}

extern size_t Lucy_Compiler_Get_Weight_OFFSET;
static CHY_INLINE float
Lucy_Compiler_Get_Weight(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_Weight_OFFSET;
    const lucy_Compiler_get_weight_t method = *((lucy_Compiler_get_weight_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_Compiler_Get_Similarity(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_Similarity_OFFSET;
    const lucy_Compiler_get_similarity_t method = *((lucy_Compiler_get_similarity_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_Get_Parent_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_Compiler_Get_Parent(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Get_Parent_OFFSET;
    const lucy_Compiler_get_parent_t method = *((lucy_Compiler_get_parent_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_Sum_Of_Squared_Weights_OFFSET;
static CHY_INLINE float
Lucy_Compiler_Sum_Of_Squared_Weights(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Sum_Of_Squared_Weights_OFFSET;
    const lucy_Compiler_sum_of_squared_weights_t method = *((lucy_Compiler_sum_of_squared_weights_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_Apply_Norm_Factor_OFFSET;
static CHY_INLINE void
Lucy_Compiler_Apply_Norm_Factor(const lucy_Compiler *self, float factor) {
    char *const method_address = *(char**)self + Lucy_Compiler_Apply_Norm_Factor_OFFSET;
    const lucy_Compiler_apply_norm_factor_t method = *((lucy_Compiler_apply_norm_factor_t*)method_address);
    method((lucy_Compiler*)self, factor);
}

extern size_t Lucy_Compiler_Normalize_OFFSET;
static CHY_INLINE void
Lucy_Compiler_Normalize(const lucy_Compiler *self) {
    char *const method_address = *(char**)self + Lucy_Compiler_Normalize_OFFSET;
    const lucy_Compiler_normalize_t method = *((lucy_Compiler_normalize_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_Compiler_Highlight_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Compiler_Highlight_Spans(const lucy_Compiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_Compiler_Highlight_Spans_OFFSET;
    const lucy_Compiler_highlight_spans_t method = *((lucy_Compiler_highlight_spans_t*)method_address);
    return method((lucy_Compiler*)self, searcher, doc_vec, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_COMPILER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_COMPILER_VT;
extern struct LUCY_COMPILER_VT LUCY_COMPILER_vt;
#define LUCY_COMPILER ((cfish_VTable*)&LUCY_COMPILER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Compiler lucy_Compiler
  #define COMPILER LUCY_COMPILER
  #define Compiler_init lucy_Compiler_init
  #define Compiler_destroy_t lucy_Compiler_destroy_t
  #define Compiler_destroy lucy_Compiler_destroy
  #define Compiler_equals_t lucy_Compiler_equals_t
  #define Compiler_equals lucy_Compiler_equals
  #define Compiler_to_string_t lucy_Compiler_to_string_t
  #define Compiler_to_string lucy_Compiler_to_string
  #define Compiler_serialize_t lucy_Compiler_serialize_t
  #define Compiler_serialize lucy_Compiler_serialize
  #define Compiler_deserialize_t lucy_Compiler_deserialize_t
  #define Compiler_deserialize lucy_Compiler_deserialize
  #define Compiler_make_matcher_t lucy_Compiler_make_matcher_t
  #define Compiler_make_matcher lucy_Compiler_make_matcher
  #define Compiler_get_weight_t lucy_Compiler_get_weight_t
  #define Compiler_get_weight lucy_Compiler_get_weight
  #define Compiler_get_similarity_t lucy_Compiler_get_similarity_t
  #define Compiler_get_similarity lucy_Compiler_get_similarity
  #define Compiler_get_parent_t lucy_Compiler_get_parent_t
  #define Compiler_get_parent lucy_Compiler_get_parent
  #define Compiler_sum_of_squared_weights_t lucy_Compiler_sum_of_squared_weights_t
  #define Compiler_sum_of_squared_weights lucy_Compiler_sum_of_squared_weights
  #define Compiler_apply_norm_factor_t lucy_Compiler_apply_norm_factor_t
  #define Compiler_apply_norm_factor lucy_Compiler_apply_norm_factor
  #define Compiler_normalize_t lucy_Compiler_normalize_t
  #define Compiler_normalize lucy_Compiler_normalize
  #define Compiler_highlight_spans_t lucy_Compiler_highlight_spans_t
  #define Compiler_highlight_spans lucy_Compiler_highlight_spans
  #define Compiler_Make Lucy_Compiler_Make
  #define Compiler_Get_RefCount Lucy_Compiler_Get_RefCount
  #define Compiler_Inc_RefCount Lucy_Compiler_Inc_RefCount
  #define Compiler_Dec_RefCount Lucy_Compiler_Dec_RefCount
  #define Compiler_To_Host Lucy_Compiler_To_Host
  #define Compiler_Clone Lucy_Compiler_Clone
  #define Compiler_Destroy Lucy_Compiler_Destroy
  #define Compiler_Equals Lucy_Compiler_Equals
  #define Compiler_Compare_To Lucy_Compiler_Compare_To
  #define Compiler_Hash_Sum Lucy_Compiler_Hash_Sum
  #define Compiler_Get_VTable Lucy_Compiler_Get_VTable
  #define Compiler_Get_Class_Name Lucy_Compiler_Get_Class_Name
  #define Compiler_Is_A Lucy_Compiler_Is_A
  #define Compiler_To_String Lucy_Compiler_To_String
  #define Compiler_To_I64 Lucy_Compiler_To_I64
  #define Compiler_To_F64 Lucy_Compiler_To_F64
  #define Compiler_To_Bool Lucy_Compiler_To_Bool
  #define Compiler_Serialize Lucy_Compiler_Serialize
  #define Compiler_Deserialize Lucy_Compiler_Deserialize
  #define Compiler_Dump Lucy_Compiler_Dump
  #define Compiler_Load Lucy_Compiler_Load
  #define Compiler_Mimic Lucy_Compiler_Mimic
  #define Compiler_Make_Compiler Lucy_Compiler_Make_Compiler
  #define Compiler_Set_Boost Lucy_Compiler_Set_Boost
  #define Compiler_Get_Boost Lucy_Compiler_Get_Boost
  #define Compiler_Make_Matcher Lucy_Compiler_Make_Matcher
  #define Compiler_Get_Weight Lucy_Compiler_Get_Weight
  #define Compiler_Get_Similarity Lucy_Compiler_Get_Similarity
  #define Compiler_Get_Parent Lucy_Compiler_Get_Parent
  #define Compiler_Sum_Of_Squared_Weights Lucy_Compiler_Sum_Of_Squared_Weights
  #define Compiler_Apply_Norm_Factor Lucy_Compiler_Apply_Norm_Factor
  #define Compiler_Normalize Lucy_Compiler_Normalize
  #define Compiler_Highlight_Spans Lucy_Compiler_Highlight_Spans
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_COMPILER */




