/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_HITQUEUE
#define H_LUCY_SEARCH_HITQUEUE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/PriorityQueue.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HITQUEUE
struct lucy_HitQueue {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t size;
    uint32_t max_size;
    lucy_Obj** heap;
    lucy_FieldType** field_types;
    uint8_t* actions;
    uint32_t num_actions;
    chy_bool_t need_values;
};

#endif /* C_LUCY_HITQUEUE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_HitQueue*
lucy_HitQ_new(lucy_Schema* schema, lucy_SortSpec* sort_spec, uint32_t wanted);

lucy_HitQueue*
lucy_HitQ_init(lucy_HitQueue* self, lucy_Schema* schema, lucy_SortSpec* sort_spec, uint32_t wanted);

void
lucy_HitQ_destroy(lucy_HitQueue* self);

chy_bool_t
lucy_HitQ_less_than(lucy_HitQueue* self, lucy_Obj* a, lucy_Obj* b);

lucy_Obj*
lucy_HitQ_jostle(lucy_HitQueue* self, lucy_Obj* element);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_HitQ_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_HitQ_destroy_t)(lucy_HitQueue* self);

typedef chy_bool_t
(*lucy_HitQ_less_than_t)(lucy_HitQueue* self, lucy_Obj* a, lucy_Obj* b);

typedef lucy_Obj*
(*lucy_HitQ_jostle_t)(lucy_HitQueue* self, lucy_Obj* element);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_HitQ_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Make(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HitQ_Get_RefCount(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Inc_RefCount(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_HitQ_Dec_RefCount(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_HitQ_To_Host(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Clone(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Destroy_OFFSET;
static CHY_INLINE void
Lucy_HitQ_Destroy(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Destroy_OFFSET;
    const lucy_HitQ_destroy_t method = *((lucy_HitQ_destroy_t*)method_address);
    method((lucy_HitQueue*)self);
}

extern size_t Lucy_HitQ_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HitQ_Equals(const lucy_HitQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HitQ_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HitQ_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_HitQ_Compare_To(const lucy_HitQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HitQ_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_HitQ_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_HitQ_Hash_Sum(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_HitQ_Get_VTable(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HitQ_Get_Class_Name(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HitQ_Is_A(const lucy_HitQueue *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_HitQ_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_HitQ_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_HitQ_To_String(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_HitQ_To_I64(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_To_F64_OFFSET;
static CHY_INLINE double
Lucy_HitQ_To_F64(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HitQ_To_Bool(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Serialize_OFFSET;
static CHY_INLINE void
Lucy_HitQ_Serialize(const lucy_HitQueue *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_HitQ_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_HitQ_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Deserialize(const lucy_HitQueue *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_HitQ_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_HitQ_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Dump(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_HitQ_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Load(const lucy_HitQueue *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_HitQ_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_HitQ_Mimic_OFFSET;
static CHY_INLINE void
Lucy_HitQ_Mimic(const lucy_HitQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_HitQ_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_HitQ_Less_Than_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HitQ_Less_Than(const lucy_HitQueue *self, lucy_Obj* a, lucy_Obj* b) {
    char *const method_address = *(char**)self + Lucy_HitQ_Less_Than_OFFSET;
    const lucy_HitQ_less_than_t method = *((lucy_HitQ_less_than_t*)method_address);
    return method((lucy_HitQueue*)self, a, b);
}

extern size_t Lucy_HitQ_Insert_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_HitQ_Insert(const lucy_HitQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_HitQ_Insert_OFFSET;
    const lucy_PriQ_insert_t method = *((lucy_PriQ_insert_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_HitQ_Jostle_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Jostle(const lucy_HitQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_HitQ_Jostle_OFFSET;
    const lucy_HitQ_jostle_t method = *((lucy_HitQ_jostle_t*)method_address);
    return method((lucy_HitQueue*)self, element);
}

extern size_t Lucy_HitQ_Pop_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Pop(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Pop_OFFSET;
    const lucy_PriQ_pop_t method = *((lucy_PriQ_pop_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_HitQ_Pop_All_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_HitQ_Pop_All(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Pop_All_OFFSET;
    const lucy_PriQ_pop_all_t method = *((lucy_PriQ_pop_all_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_HitQ_Peek_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_HitQ_Peek(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Peek_OFFSET;
    const lucy_PriQ_peek_t method = *((lucy_PriQ_peek_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_HitQ_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_HitQ_Get_Size(const lucy_HitQueue *self) {
    char *const method_address = *(char**)self + Lucy_HitQ_Get_Size_OFFSET;
    const lucy_PriQ_get_size_t method = *((lucy_PriQ_get_size_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HITQUEUE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_HITQUEUE_VT;
extern struct LUCY_HITQUEUE_VT LUCY_HITQUEUE_vt;
#define LUCY_HITQUEUE ((cfish_VTable*)&LUCY_HITQUEUE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define HitQueue lucy_HitQueue
  #define HITQUEUE LUCY_HITQUEUE
  #define HitQ_new lucy_HitQ_new
  #define HitQ_init lucy_HitQ_init
  #define HitQ_destroy_t lucy_HitQ_destroy_t
  #define HitQ_destroy lucy_HitQ_destroy
  #define HitQ_less_than_t lucy_HitQ_less_than_t
  #define HitQ_less_than lucy_HitQ_less_than
  #define HitQ_jostle_t lucy_HitQ_jostle_t
  #define HitQ_jostle lucy_HitQ_jostle
  #define HitQ_Make Lucy_HitQ_Make
  #define HitQ_Get_RefCount Lucy_HitQ_Get_RefCount
  #define HitQ_Inc_RefCount Lucy_HitQ_Inc_RefCount
  #define HitQ_Dec_RefCount Lucy_HitQ_Dec_RefCount
  #define HitQ_To_Host Lucy_HitQ_To_Host
  #define HitQ_Clone Lucy_HitQ_Clone
  #define HitQ_Destroy Lucy_HitQ_Destroy
  #define HitQ_Equals Lucy_HitQ_Equals
  #define HitQ_Compare_To Lucy_HitQ_Compare_To
  #define HitQ_Hash_Sum Lucy_HitQ_Hash_Sum
  #define HitQ_Get_VTable Lucy_HitQ_Get_VTable
  #define HitQ_Get_Class_Name Lucy_HitQ_Get_Class_Name
  #define HitQ_Is_A Lucy_HitQ_Is_A
  #define HitQ_To_String Lucy_HitQ_To_String
  #define HitQ_To_I64 Lucy_HitQ_To_I64
  #define HitQ_To_F64 Lucy_HitQ_To_F64
  #define HitQ_To_Bool Lucy_HitQ_To_Bool
  #define HitQ_Serialize Lucy_HitQ_Serialize
  #define HitQ_Deserialize Lucy_HitQ_Deserialize
  #define HitQ_Dump Lucy_HitQ_Dump
  #define HitQ_Load Lucy_HitQ_Load
  #define HitQ_Mimic Lucy_HitQ_Mimic
  #define HitQ_Less_Than Lucy_HitQ_Less_Than
  #define HitQ_Insert Lucy_HitQ_Insert
  #define HitQ_Jostle Lucy_HitQ_Jostle
  #define HitQ_Pop Lucy_HitQ_Pop
  #define HitQ_Pop_All Lucy_HitQ_Pop_All
  #define HitQ_Peek Lucy_HitQ_Peek
  #define HitQ_Get_Size Lucy_HitQ_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_HITQUEUE */




