/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_HITS
#define H_LUCY_SEARCH_HITS 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_HITS
struct lucy_Hits {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Searcher* searcher;
    lucy_TopDocs* top_docs;
    lucy_VArray* match_docs;
    uint32_t offset;
};

#endif /* C_LUCY_HITS */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Hits*
lucy_Hits_new(lucy_Searcher* searcher, lucy_TopDocs* top_docs, uint32_t offset);

lucy_Hits*
lucy_Hits_init(lucy_Hits* self, lucy_Searcher* searcher, lucy_TopDocs* top_docs, uint32_t offset);

void
lucy_Hits_destroy(lucy_Hits* self);

lucy_HitDoc*
lucy_Hits_next(lucy_Hits* self);

uint32_t
lucy_Hits_total_hits(lucy_Hits* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Hits_destroy_CALLBACK;
extern cfish_Callback lucy_Hits_next_CALLBACK;
extern cfish_Callback lucy_Hits_total_hits_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Hits_destroy_t)(lucy_Hits* self);

typedef lucy_HitDoc*
(*lucy_Hits_next_t)(lucy_Hits* self);

typedef uint32_t
(*lucy_Hits_total_hits_t)(lucy_Hits* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Hits_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hits_Make(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hits_Get_RefCount(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hits_Inc_RefCount(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hits_Dec_RefCount(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Hits_To_Host(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hits_Clone(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Hits_Destroy(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Destroy_OFFSET;
    const lucy_Hits_destroy_t method = *((lucy_Hits_destroy_t*)method_address);
    method((lucy_Hits*)self);
}

extern size_t Lucy_Hits_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hits_Equals(const lucy_Hits *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Hits_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Hits_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Hits_Compare_To(const lucy_Hits *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Hits_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Hits_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Hits_Hash_Sum(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Hits_Get_VTable(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Hits_Get_Class_Name(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hits_Is_A(const lucy_Hits *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Hits_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Hits_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Hits_To_String(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Hits_To_I64(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Hits_To_F64(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Hits_To_Bool(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Hits_Serialize(const lucy_Hits *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Hits_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Hits_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hits_Deserialize(const lucy_Hits *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Hits_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Hits_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hits_Dump(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Hits_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Hits_Load(const lucy_Hits *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Hits_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Hits_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Hits_Mimic(const lucy_Hits *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Hits_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Hits_Next_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_Hits_Next(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Next_OFFSET;
    const lucy_Hits_next_t method = *((lucy_Hits_next_t*)method_address);
    return method((lucy_Hits*)self);
}

extern size_t Lucy_Hits_Total_Hits_OFFSET;
static CHY_INLINE uint32_t
Lucy_Hits_Total_Hits(const lucy_Hits *self) {
    char *const method_address = *(char**)self + Lucy_Hits_Total_Hits_OFFSET;
    const lucy_Hits_total_hits_t method = *((lucy_Hits_total_hits_t*)method_address);
    return method((lucy_Hits*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_HITS_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[24];
} LUCY_HITS_VT;
extern struct LUCY_HITS_VT LUCY_HITS_vt;
#define LUCY_HITS ((cfish_VTable*)&LUCY_HITS_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Hits lucy_Hits
  #define HITS LUCY_HITS
  #define Hits_new lucy_Hits_new
  #define Hits_init lucy_Hits_init
  #define Hits_destroy_t lucy_Hits_destroy_t
  #define Hits_destroy lucy_Hits_destroy
  #define Hits_next_t lucy_Hits_next_t
  #define Hits_next lucy_Hits_next
  #define Hits_total_hits_t lucy_Hits_total_hits_t
  #define Hits_total_hits lucy_Hits_total_hits
  #define Hits_Make Lucy_Hits_Make
  #define Hits_Get_RefCount Lucy_Hits_Get_RefCount
  #define Hits_Inc_RefCount Lucy_Hits_Inc_RefCount
  #define Hits_Dec_RefCount Lucy_Hits_Dec_RefCount
  #define Hits_To_Host Lucy_Hits_To_Host
  #define Hits_Clone Lucy_Hits_Clone
  #define Hits_Destroy Lucy_Hits_Destroy
  #define Hits_Equals Lucy_Hits_Equals
  #define Hits_Compare_To Lucy_Hits_Compare_To
  #define Hits_Hash_Sum Lucy_Hits_Hash_Sum
  #define Hits_Get_VTable Lucy_Hits_Get_VTable
  #define Hits_Get_Class_Name Lucy_Hits_Get_Class_Name
  #define Hits_Is_A Lucy_Hits_Is_A
  #define Hits_To_String Lucy_Hits_To_String
  #define Hits_To_I64 Lucy_Hits_To_I64
  #define Hits_To_F64 Lucy_Hits_To_F64
  #define Hits_To_Bool Lucy_Hits_To_Bool
  #define Hits_Serialize Lucy_Hits_Serialize
  #define Hits_Deserialize Lucy_Hits_Deserialize
  #define Hits_Dump Lucy_Hits_Dump
  #define Hits_Load Lucy_Hits_Load
  #define Hits_Mimic Lucy_Hits_Mimic
  #define Hits_Next Lucy_Hits_Next
  #define Hits_Total_Hits Lucy_Hits_Total_Hits
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_HITS */




