/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_INDEXSEARCHER
#define H_LUCY_SEARCH_INDEXSEARCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Searcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INDEXSEARCHER
struct lucy_IndexSearcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_QueryParser* qparser;
    lucy_IndexReader* reader;
    lucy_DocReader* doc_reader;
    lucy_HighlightReader* hl_reader;
    lucy_VArray* seg_readers;
    lucy_I32Array* seg_starts;
};

#endif /* C_LUCY_INDEXSEARCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_IndexSearcher*
lucy_IxSearcher_new(lucy_Obj* index);

lucy_IndexSearcher*
lucy_IxSearcher_init(lucy_IndexSearcher* self, lucy_Obj* index);

void
lucy_IxSearcher_destroy(lucy_IndexSearcher* self);

int32_t
lucy_IxSearcher_doc_max(lucy_IndexSearcher* self);

uint32_t
lucy_IxSearcher_doc_freq(lucy_IndexSearcher* self, const lucy_CharBuf* field, lucy_Obj* term);

void
lucy_IxSearcher_collect(lucy_IndexSearcher* self, lucy_Query* query, lucy_Collector* collector);

lucy_TopDocs*
lucy_IxSearcher_top_docs(lucy_IndexSearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

lucy_HitDoc*
lucy_IxSearcher_fetch_doc(lucy_IndexSearcher* self, int32_t doc_id);

lucy_DocVector*
lucy_IxSearcher_fetch_doc_vec(lucy_IndexSearcher* self, int32_t doc_id);

void
lucy_IxSearcher_close(lucy_IndexSearcher* self);

lucy_IndexReader*
lucy_IxSearcher_get_reader(lucy_IndexSearcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_IxSearcher_destroy_CALLBACK;
extern cfish_Callback lucy_IxSearcher_doc_max_CALLBACK;
extern cfish_Callback lucy_IxSearcher_doc_freq_CALLBACK;
extern cfish_Callback lucy_IxSearcher_collect_CALLBACK;
extern cfish_Callback lucy_IxSearcher_fetch_doc_CALLBACK;
extern cfish_Callback lucy_IxSearcher_get_reader_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_IxSearcher_destroy_t)(lucy_IndexSearcher* self);

typedef int32_t
(*lucy_IxSearcher_doc_max_t)(lucy_IndexSearcher* self);

typedef uint32_t
(*lucy_IxSearcher_doc_freq_t)(lucy_IndexSearcher* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef void
(*lucy_IxSearcher_collect_t)(lucy_IndexSearcher* self, lucy_Query* query, lucy_Collector* collector);

typedef lucy_TopDocs*
(*lucy_IxSearcher_top_docs_t)(lucy_IndexSearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

typedef lucy_HitDoc*
(*lucy_IxSearcher_fetch_doc_t)(lucy_IndexSearcher* self, int32_t doc_id);

typedef lucy_DocVector*
(*lucy_IxSearcher_fetch_doc_vec_t)(lucy_IndexSearcher* self, int32_t doc_id);

typedef void
(*lucy_IxSearcher_close_t)(lucy_IndexSearcher* self);

typedef lucy_IndexReader*
(*lucy_IxSearcher_get_reader_t)(lucy_IndexSearcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_IxSearcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxSearcher_Make(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxSearcher_Get_RefCount(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxSearcher_Inc_RefCount(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxSearcher_Dec_RefCount(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_IxSearcher_To_Host(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxSearcher_Clone(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_IxSearcher_Destroy(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Destroy_OFFSET;
    const lucy_IxSearcher_destroy_t method = *((lucy_IxSearcher_destroy_t*)method_address);
    method((lucy_IndexSearcher*)self);
}

extern size_t Lucy_IxSearcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxSearcher_Equals(const lucy_IndexSearcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxSearcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_IxSearcher_Compare_To(const lucy_IndexSearcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxSearcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_IxSearcher_Hash_Sum(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_IxSearcher_Get_VTable(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxSearcher_Get_Class_Name(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxSearcher_Is_A(const lucy_IndexSearcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_IxSearcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_IxSearcher_To_String(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_IxSearcher_To_I64(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_IxSearcher_To_F64(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_IxSearcher_To_Bool(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_IxSearcher_Serialize(const lucy_IndexSearcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_IxSearcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxSearcher_Deserialize(const lucy_IndexSearcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_IxSearcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxSearcher_Dump(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_IxSearcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_IxSearcher_Load(const lucy_IndexSearcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_IxSearcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_IxSearcher_Mimic(const lucy_IndexSearcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_IxSearcher_Doc_Max_OFFSET;
static CHY_INLINE int32_t
Lucy_IxSearcher_Doc_Max(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Doc_Max_OFFSET;
    const lucy_IxSearcher_doc_max_t method = *((lucy_IxSearcher_doc_max_t*)method_address);
    return method((lucy_IndexSearcher*)self);
}

extern size_t Lucy_IxSearcher_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_IxSearcher_Doc_Freq(const lucy_IndexSearcher *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Doc_Freq_OFFSET;
    const lucy_IxSearcher_doc_freq_t method = *((lucy_IxSearcher_doc_freq_t*)method_address);
    return method((lucy_IndexSearcher*)self, field, term);
}

extern size_t Lucy_IxSearcher_Glean_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_IxSearcher_Glean_Query(const lucy_IndexSearcher *self, lucy_Obj* query) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Glean_Query_OFFSET;
    const lucy_Searcher_glean_query_t method = *((lucy_Searcher_glean_query_t*)method_address);
    return method((lucy_Searcher*)self, query);
}

extern size_t Lucy_IxSearcher_Hits_OFFSET;
static CHY_INLINE lucy_Hits*
Lucy_IxSearcher_Hits(const lucy_IndexSearcher *self, lucy_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Hits_OFFSET;
    const lucy_Searcher_hits_t method = *((lucy_Searcher_hits_t*)method_address);
    return method((lucy_Searcher*)self, query, offset, num_wanted, sort_spec);
}

extern size_t Lucy_IxSearcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_IxSearcher_Collect(const lucy_IndexSearcher *self, lucy_Query* query, lucy_Collector* collector) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Collect_OFFSET;
    const lucy_IxSearcher_collect_t method = *((lucy_IxSearcher_collect_t*)method_address);
    method((lucy_IndexSearcher*)self, query, collector);
}

extern size_t Lucy_IxSearcher_Top_Docs_OFFSET;
static CHY_INLINE lucy_TopDocs*
Lucy_IxSearcher_Top_Docs(const lucy_IndexSearcher *self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Top_Docs_OFFSET;
    const lucy_IxSearcher_top_docs_t method = *((lucy_IxSearcher_top_docs_t*)method_address);
    return method((lucy_IndexSearcher*)self, query, num_wanted, sort_spec);
}

extern size_t Lucy_IxSearcher_Fetch_Doc_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_IxSearcher_Fetch_Doc(const lucy_IndexSearcher *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Fetch_Doc_OFFSET;
    const lucy_IxSearcher_fetch_doc_t method = *((lucy_IxSearcher_fetch_doc_t*)method_address);
    return method((lucy_IndexSearcher*)self, doc_id);
}

extern size_t Lucy_IxSearcher_Fetch_Doc_Vec_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_IxSearcher_Fetch_Doc_Vec(const lucy_IndexSearcher *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Fetch_Doc_Vec_OFFSET;
    const lucy_IxSearcher_fetch_doc_vec_t method = *((lucy_IxSearcher_fetch_doc_vec_t*)method_address);
    return method((lucy_IndexSearcher*)self, doc_id);
}

extern size_t Lucy_IxSearcher_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_IxSearcher_Get_Schema(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Get_Schema_OFFSET;
    const lucy_Searcher_get_schema_t method = *((lucy_Searcher_get_schema_t*)method_address);
    return method((lucy_Searcher*)self);
}

extern size_t Lucy_IxSearcher_Close_OFFSET;
static CHY_INLINE void
Lucy_IxSearcher_Close(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Close_OFFSET;
    const lucy_IxSearcher_close_t method = *((lucy_IxSearcher_close_t*)method_address);
    method((lucy_IndexSearcher*)self);
}

extern size_t Lucy_IxSearcher_Get_Reader_OFFSET;
static CHY_INLINE lucy_IndexReader*
Lucy_IxSearcher_Get_Reader(const lucy_IndexSearcher *self) {
    char *const method_address = *(char**)self + Lucy_IxSearcher_Get_Reader_OFFSET;
    const lucy_IxSearcher_get_reader_t method = *((lucy_IxSearcher_get_reader_t*)method_address);
    return method((lucy_IndexSearcher*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INDEXSEARCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_INDEXSEARCHER_VT;
extern struct LUCY_INDEXSEARCHER_VT LUCY_INDEXSEARCHER_vt;
#define LUCY_INDEXSEARCHER ((cfish_VTable*)&LUCY_INDEXSEARCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define IndexSearcher lucy_IndexSearcher
  #define INDEXSEARCHER LUCY_INDEXSEARCHER
  #define IxSearcher_new lucy_IxSearcher_new
  #define IxSearcher_init lucy_IxSearcher_init
  #define IxSearcher_destroy_t lucy_IxSearcher_destroy_t
  #define IxSearcher_destroy lucy_IxSearcher_destroy
  #define IxSearcher_doc_max_t lucy_IxSearcher_doc_max_t
  #define IxSearcher_doc_max lucy_IxSearcher_doc_max
  #define IxSearcher_doc_freq_t lucy_IxSearcher_doc_freq_t
  #define IxSearcher_doc_freq lucy_IxSearcher_doc_freq
  #define IxSearcher_collect_t lucy_IxSearcher_collect_t
  #define IxSearcher_collect lucy_IxSearcher_collect
  #define IxSearcher_top_docs_t lucy_IxSearcher_top_docs_t
  #define IxSearcher_top_docs lucy_IxSearcher_top_docs
  #define IxSearcher_fetch_doc_t lucy_IxSearcher_fetch_doc_t
  #define IxSearcher_fetch_doc lucy_IxSearcher_fetch_doc
  #define IxSearcher_fetch_doc_vec_t lucy_IxSearcher_fetch_doc_vec_t
  #define IxSearcher_fetch_doc_vec lucy_IxSearcher_fetch_doc_vec
  #define IxSearcher_close_t lucy_IxSearcher_close_t
  #define IxSearcher_close lucy_IxSearcher_close
  #define IxSearcher_get_reader_t lucy_IxSearcher_get_reader_t
  #define IxSearcher_get_reader lucy_IxSearcher_get_reader
  #define IxSearcher_Make Lucy_IxSearcher_Make
  #define IxSearcher_Get_RefCount Lucy_IxSearcher_Get_RefCount
  #define IxSearcher_Inc_RefCount Lucy_IxSearcher_Inc_RefCount
  #define IxSearcher_Dec_RefCount Lucy_IxSearcher_Dec_RefCount
  #define IxSearcher_To_Host Lucy_IxSearcher_To_Host
  #define IxSearcher_Clone Lucy_IxSearcher_Clone
  #define IxSearcher_Destroy Lucy_IxSearcher_Destroy
  #define IxSearcher_Equals Lucy_IxSearcher_Equals
  #define IxSearcher_Compare_To Lucy_IxSearcher_Compare_To
  #define IxSearcher_Hash_Sum Lucy_IxSearcher_Hash_Sum
  #define IxSearcher_Get_VTable Lucy_IxSearcher_Get_VTable
  #define IxSearcher_Get_Class_Name Lucy_IxSearcher_Get_Class_Name
  #define IxSearcher_Is_A Lucy_IxSearcher_Is_A
  #define IxSearcher_To_String Lucy_IxSearcher_To_String
  #define IxSearcher_To_I64 Lucy_IxSearcher_To_I64
  #define IxSearcher_To_F64 Lucy_IxSearcher_To_F64
  #define IxSearcher_To_Bool Lucy_IxSearcher_To_Bool
  #define IxSearcher_Serialize Lucy_IxSearcher_Serialize
  #define IxSearcher_Deserialize Lucy_IxSearcher_Deserialize
  #define IxSearcher_Dump Lucy_IxSearcher_Dump
  #define IxSearcher_Load Lucy_IxSearcher_Load
  #define IxSearcher_Mimic Lucy_IxSearcher_Mimic
  #define IxSearcher_Doc_Max Lucy_IxSearcher_Doc_Max
  #define IxSearcher_Doc_Freq Lucy_IxSearcher_Doc_Freq
  #define IxSearcher_Glean_Query Lucy_IxSearcher_Glean_Query
  #define IxSearcher_Hits Lucy_IxSearcher_Hits
  #define IxSearcher_Collect Lucy_IxSearcher_Collect
  #define IxSearcher_Top_Docs Lucy_IxSearcher_Top_Docs
  #define IxSearcher_Fetch_Doc Lucy_IxSearcher_Fetch_Doc
  #define IxSearcher_Fetch_Doc_Vec Lucy_IxSearcher_Fetch_Doc_Vec
  #define IxSearcher_Get_Schema Lucy_IxSearcher_Get_Schema
  #define IxSearcher_Close Lucy_IxSearcher_Close
  #define IxSearcher_Get_Reader Lucy_IxSearcher_Get_Reader
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_INDEXSEARCHER */




