/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_LEAFQUERY
#define H_LUCY_SEARCH_LEAFQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LEAFQUERY
struct lucy_LeafQuery {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_CharBuf* field;
    lucy_CharBuf* text;
};

#endif /* C_LUCY_LEAFQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LeafQuery*
lucy_LeafQuery_new(const lucy_CharBuf* field, const lucy_CharBuf* text);

lucy_LeafQuery*
lucy_LeafQuery_init(lucy_LeafQuery* self, const lucy_CharBuf* field, const lucy_CharBuf* text);

void
lucy_LeafQuery_destroy(lucy_LeafQuery* self);

chy_bool_t
lucy_LeafQuery_equals(lucy_LeafQuery* self, lucy_Obj* other);

lucy_CharBuf*
lucy_LeafQuery_to_string(lucy_LeafQuery* self);

void
lucy_LeafQuery_serialize(lucy_LeafQuery* self, lucy_OutStream* outstream);

lucy_LeafQuery*
lucy_LeafQuery_deserialize(lucy_LeafQuery* self, lucy_InStream* instream);

lucy_Obj*
lucy_LeafQuery_dump(lucy_LeafQuery* self);

lucy_Obj*
lucy_LeafQuery_load(lucy_LeafQuery* self, lucy_Obj* dump);

lucy_Compiler*
lucy_LeafQuery_make_compiler(lucy_LeafQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

lucy_CharBuf*
lucy_LeafQuery_get_field(lucy_LeafQuery* self);

lucy_CharBuf*
lucy_LeafQuery_get_text(lucy_LeafQuery* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LeafQuery_destroy_CALLBACK;
extern cfish_Callback lucy_LeafQuery_equals_CALLBACK;
extern cfish_Callback lucy_LeafQuery_to_string_CALLBACK;
extern cfish_Callback lucy_LeafQuery_serialize_CALLBACK;
extern cfish_Callback lucy_LeafQuery_deserialize_CALLBACK;
extern cfish_Callback lucy_LeafQuery_dump_CALLBACK;
extern cfish_Callback lucy_LeafQuery_load_CALLBACK;
extern cfish_Callback lucy_LeafQuery_make_compiler_CALLBACK;
extern cfish_Callback lucy_LeafQuery_get_field_CALLBACK;
extern cfish_Callback lucy_LeafQuery_get_text_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_LeafQuery_destroy_t)(lucy_LeafQuery* self);

typedef chy_bool_t
(*lucy_LeafQuery_equals_t)(lucy_LeafQuery* self, lucy_Obj* other);

typedef lucy_CharBuf*
(*lucy_LeafQuery_to_string_t)(lucy_LeafQuery* self);

typedef void
(*lucy_LeafQuery_serialize_t)(lucy_LeafQuery* self, lucy_OutStream* outstream);

typedef lucy_LeafQuery*
(*lucy_LeafQuery_deserialize_t)(lucy_LeafQuery* self, lucy_InStream* instream);

typedef lucy_Obj*
(*lucy_LeafQuery_dump_t)(lucy_LeafQuery* self);

typedef lucy_Obj*
(*lucy_LeafQuery_load_t)(lucy_LeafQuery* self, lucy_Obj* dump);

typedef lucy_Compiler*
(*lucy_LeafQuery_make_compiler_t)(lucy_LeafQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

typedef lucy_CharBuf*
(*lucy_LeafQuery_get_field_t)(lucy_LeafQuery* self);

typedef lucy_CharBuf*
(*lucy_LeafQuery_get_text_t)(lucy_LeafQuery* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LeafQuery_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LeafQuery_Make(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LeafQuery_Get_RefCount(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LeafQuery_Inc_RefCount(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LeafQuery_Dec_RefCount(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LeafQuery_To_Host(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LeafQuery_Clone(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LeafQuery_Destroy(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Destroy_OFFSET;
    const lucy_LeafQuery_destroy_t method = *((lucy_LeafQuery_destroy_t*)method_address);
    method((lucy_LeafQuery*)self);
}

extern size_t Lucy_LeafQuery_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LeafQuery_Equals(const lucy_LeafQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Equals_OFFSET;
    const lucy_LeafQuery_equals_t method = *((lucy_LeafQuery_equals_t*)method_address);
    return method((lucy_LeafQuery*)self, other);
}

extern size_t Lucy_LeafQuery_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LeafQuery_Compare_To(const lucy_LeafQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LeafQuery_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LeafQuery_Hash_Sum(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LeafQuery_Get_VTable(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LeafQuery_Get_Class_Name(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LeafQuery_Is_A(const lucy_LeafQuery *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LeafQuery_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LeafQuery_To_String(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_To_String_OFFSET;
    const lucy_LeafQuery_to_string_t method = *((lucy_LeafQuery_to_string_t*)method_address);
    return method((lucy_LeafQuery*)self);
}

extern size_t Lucy_LeafQuery_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LeafQuery_To_I64(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LeafQuery_To_F64(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LeafQuery_To_Bool(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LeafQuery_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LeafQuery_Serialize(const lucy_LeafQuery *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Serialize_OFFSET;
    const lucy_LeafQuery_serialize_t method = *((lucy_LeafQuery_serialize_t*)method_address);
    method((lucy_LeafQuery*)self, outstream);
}

extern size_t Lucy_LeafQuery_Deserialize_OFFSET;
static CHY_INLINE lucy_LeafQuery*
Lucy_LeafQuery_Deserialize(const lucy_LeafQuery *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Deserialize_OFFSET;
    const lucy_LeafQuery_deserialize_t method = *((lucy_LeafQuery_deserialize_t*)method_address);
    return method((lucy_LeafQuery*)self, instream);
}

extern size_t Lucy_LeafQuery_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LeafQuery_Dump(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Dump_OFFSET;
    const lucy_LeafQuery_dump_t method = *((lucy_LeafQuery_dump_t*)method_address);
    return method((lucy_LeafQuery*)self);
}

extern size_t Lucy_LeafQuery_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LeafQuery_Load(const lucy_LeafQuery *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Load_OFFSET;
    const lucy_LeafQuery_load_t method = *((lucy_LeafQuery_load_t*)method_address);
    return method((lucy_LeafQuery*)self, dump);
}

extern size_t Lucy_LeafQuery_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LeafQuery_Mimic(const lucy_LeafQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LeafQuery_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_LeafQuery_Make_Compiler(const lucy_LeafQuery *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Make_Compiler_OFFSET;
    const lucy_LeafQuery_make_compiler_t method = *((lucy_LeafQuery_make_compiler_t*)method_address);
    return method((lucy_LeafQuery*)self, searcher, boost, subordinate);
}

extern size_t Lucy_LeafQuery_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_LeafQuery_Set_Boost(const lucy_LeafQuery *self, float boost) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_LeafQuery_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_LeafQuery_Get_Boost(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_LeafQuery_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LeafQuery_Get_Field(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Get_Field_OFFSET;
    const lucy_LeafQuery_get_field_t method = *((lucy_LeafQuery_get_field_t*)method_address);
    return method((lucy_LeafQuery*)self);
}

extern size_t Lucy_LeafQuery_Get_Text_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LeafQuery_Get_Text(const lucy_LeafQuery *self) {
    char *const method_address = *(char**)self + Lucy_LeafQuery_Get_Text_OFFSET;
    const lucy_LeafQuery_get_text_t method = *((lucy_LeafQuery_get_text_t*)method_address);
    return method((lucy_LeafQuery*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LEAFQUERY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_LEAFQUERY_VT;
extern struct LUCY_LEAFQUERY_VT LUCY_LEAFQUERY_vt;
#define LUCY_LEAFQUERY ((cfish_VTable*)&LUCY_LEAFQUERY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LeafQuery lucy_LeafQuery
  #define LEAFQUERY LUCY_LEAFQUERY
  #define LeafQuery_new lucy_LeafQuery_new
  #define LeafQuery_init lucy_LeafQuery_init
  #define LeafQuery_destroy_t lucy_LeafQuery_destroy_t
  #define LeafQuery_destroy lucy_LeafQuery_destroy
  #define LeafQuery_equals_t lucy_LeafQuery_equals_t
  #define LeafQuery_equals lucy_LeafQuery_equals
  #define LeafQuery_to_string_t lucy_LeafQuery_to_string_t
  #define LeafQuery_to_string lucy_LeafQuery_to_string
  #define LeafQuery_serialize_t lucy_LeafQuery_serialize_t
  #define LeafQuery_serialize lucy_LeafQuery_serialize
  #define LeafQuery_deserialize_t lucy_LeafQuery_deserialize_t
  #define LeafQuery_deserialize lucy_LeafQuery_deserialize
  #define LeafQuery_dump_t lucy_LeafQuery_dump_t
  #define LeafQuery_dump lucy_LeafQuery_dump
  #define LeafQuery_load_t lucy_LeafQuery_load_t
  #define LeafQuery_load lucy_LeafQuery_load
  #define LeafQuery_make_compiler_t lucy_LeafQuery_make_compiler_t
  #define LeafQuery_make_compiler lucy_LeafQuery_make_compiler
  #define LeafQuery_get_field_t lucy_LeafQuery_get_field_t
  #define LeafQuery_get_field lucy_LeafQuery_get_field
  #define LeafQuery_get_text_t lucy_LeafQuery_get_text_t
  #define LeafQuery_get_text lucy_LeafQuery_get_text
  #define LeafQuery_Make Lucy_LeafQuery_Make
  #define LeafQuery_Get_RefCount Lucy_LeafQuery_Get_RefCount
  #define LeafQuery_Inc_RefCount Lucy_LeafQuery_Inc_RefCount
  #define LeafQuery_Dec_RefCount Lucy_LeafQuery_Dec_RefCount
  #define LeafQuery_To_Host Lucy_LeafQuery_To_Host
  #define LeafQuery_Clone Lucy_LeafQuery_Clone
  #define LeafQuery_Destroy Lucy_LeafQuery_Destroy
  #define LeafQuery_Equals Lucy_LeafQuery_Equals
  #define LeafQuery_Compare_To Lucy_LeafQuery_Compare_To
  #define LeafQuery_Hash_Sum Lucy_LeafQuery_Hash_Sum
  #define LeafQuery_Get_VTable Lucy_LeafQuery_Get_VTable
  #define LeafQuery_Get_Class_Name Lucy_LeafQuery_Get_Class_Name
  #define LeafQuery_Is_A Lucy_LeafQuery_Is_A
  #define LeafQuery_To_String Lucy_LeafQuery_To_String
  #define LeafQuery_To_I64 Lucy_LeafQuery_To_I64
  #define LeafQuery_To_F64 Lucy_LeafQuery_To_F64
  #define LeafQuery_To_Bool Lucy_LeafQuery_To_Bool
  #define LeafQuery_Serialize Lucy_LeafQuery_Serialize
  #define LeafQuery_Deserialize Lucy_LeafQuery_Deserialize
  #define LeafQuery_Dump Lucy_LeafQuery_Dump
  #define LeafQuery_Load Lucy_LeafQuery_Load
  #define LeafQuery_Mimic Lucy_LeafQuery_Mimic
  #define LeafQuery_Make_Compiler Lucy_LeafQuery_Make_Compiler
  #define LeafQuery_Set_Boost Lucy_LeafQuery_Set_Boost
  #define LeafQuery_Get_Boost Lucy_LeafQuery_Get_Boost
  #define LeafQuery_Get_Field Lucy_LeafQuery_Get_Field
  #define LeafQuery_Get_Text Lucy_LeafQuery_Get_Text
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_LEAFQUERY */




