/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_NOTMATCHER
#define H_LUCY_SEARCH_NOTMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/PolyMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_NOTMATCHER
struct lucy_NOTMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
    lucy_Matcher* negated_matcher;
    int32_t doc_id;
    int32_t doc_max;
    int32_t next_negation;
};

#endif /* C_LUCY_NOTMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_NOTMatcher*
lucy_NOTMatcher_new(lucy_Matcher* negated_matcher, int32_t doc_max);

lucy_NOTMatcher*
lucy_NOTMatcher_init(lucy_NOTMatcher* self, lucy_Matcher* negated_matcher, int32_t doc_max);

void
lucy_NOTMatcher_destroy(lucy_NOTMatcher* self);

int32_t
lucy_NOTMatcher_next(lucy_NOTMatcher* self);

int32_t
lucy_NOTMatcher_advance(lucy_NOTMatcher* self, int32_t target);

int32_t
lucy_NOTMatcher_get_doc_id(lucy_NOTMatcher* self);

float
lucy_NOTMatcher_score(lucy_NOTMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_NOTMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_NOTMatcher_next_CALLBACK;
extern cfish_Callback lucy_NOTMatcher_advance_CALLBACK;
extern cfish_Callback lucy_NOTMatcher_get_doc_id_CALLBACK;
extern cfish_Callback lucy_NOTMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_NOTMatcher_destroy_t)(lucy_NOTMatcher* self);

typedef int32_t
(*lucy_NOTMatcher_next_t)(lucy_NOTMatcher* self);

typedef int32_t
(*lucy_NOTMatcher_advance_t)(lucy_NOTMatcher* self, int32_t target);

typedef int32_t
(*lucy_NOTMatcher_get_doc_id_t)(lucy_NOTMatcher* self);

typedef float
(*lucy_NOTMatcher_score_t)(lucy_NOTMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_NOTMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NOTMatcher_Make(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NOTMatcher_Get_RefCount(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NOTMatcher_Inc_RefCount(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NOTMatcher_Dec_RefCount(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_NOTMatcher_To_Host(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NOTMatcher_Clone(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_NOTMatcher_Destroy(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Destroy_OFFSET;
    const lucy_NOTMatcher_destroy_t method = *((lucy_NOTMatcher_destroy_t*)method_address);
    method((lucy_NOTMatcher*)self);
}

extern size_t Lucy_NOTMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NOTMatcher_Equals(const lucy_NOTMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NOTMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_NOTMatcher_Compare_To(const lucy_NOTMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NOTMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_NOTMatcher_Hash_Sum(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_NOTMatcher_Get_VTable(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NOTMatcher_Get_Class_Name(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NOTMatcher_Is_A(const lucy_NOTMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_NOTMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NOTMatcher_To_String(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_NOTMatcher_To_I64(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_NOTMatcher_To_F64(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NOTMatcher_To_Bool(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_NOTMatcher_Serialize(const lucy_NOTMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_NOTMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NOTMatcher_Deserialize(const lucy_NOTMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_NOTMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NOTMatcher_Dump(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NOTMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NOTMatcher_Load(const lucy_NOTMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_NOTMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_NOTMatcher_Mimic(const lucy_NOTMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_NOTMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_NOTMatcher_Next(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Next_OFFSET;
    const lucy_NOTMatcher_next_t method = *((lucy_NOTMatcher_next_t*)method_address);
    return method((lucy_NOTMatcher*)self);
}

extern size_t Lucy_NOTMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_NOTMatcher_Advance(const lucy_NOTMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Advance_OFFSET;
    const lucy_NOTMatcher_advance_t method = *((lucy_NOTMatcher_advance_t*)method_address);
    return method((lucy_NOTMatcher*)self, target);
}

extern size_t Lucy_NOTMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_NOTMatcher_Get_Doc_ID(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Get_Doc_ID_OFFSET;
    const lucy_NOTMatcher_get_doc_id_t method = *((lucy_NOTMatcher_get_doc_id_t*)method_address);
    return method((lucy_NOTMatcher*)self);
}

extern size_t Lucy_NOTMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_NOTMatcher_Score(const lucy_NOTMatcher *self) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Score_OFFSET;
    const lucy_NOTMatcher_score_t method = *((lucy_NOTMatcher_score_t*)method_address);
    return method((lucy_NOTMatcher*)self);
}

extern size_t Lucy_NOTMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_NOTMatcher_Collect(const lucy_NOTMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_NOTMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_NOTMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_NOTMATCHER_VT;
extern struct LUCY_NOTMATCHER_VT LUCY_NOTMATCHER_vt;
#define LUCY_NOTMATCHER ((cfish_VTable*)&LUCY_NOTMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define NOTMatcher lucy_NOTMatcher
  #define NOTMATCHER LUCY_NOTMATCHER
  #define NOTMatcher_new lucy_NOTMatcher_new
  #define NOTMatcher_init lucy_NOTMatcher_init
  #define NOTMatcher_destroy_t lucy_NOTMatcher_destroy_t
  #define NOTMatcher_destroy lucy_NOTMatcher_destroy
  #define NOTMatcher_next_t lucy_NOTMatcher_next_t
  #define NOTMatcher_next lucy_NOTMatcher_next
  #define NOTMatcher_advance_t lucy_NOTMatcher_advance_t
  #define NOTMatcher_advance lucy_NOTMatcher_advance
  #define NOTMatcher_get_doc_id_t lucy_NOTMatcher_get_doc_id_t
  #define NOTMatcher_get_doc_id lucy_NOTMatcher_get_doc_id
  #define NOTMatcher_score_t lucy_NOTMatcher_score_t
  #define NOTMatcher_score lucy_NOTMatcher_score
  #define NOTMatcher_Make Lucy_NOTMatcher_Make
  #define NOTMatcher_Get_RefCount Lucy_NOTMatcher_Get_RefCount
  #define NOTMatcher_Inc_RefCount Lucy_NOTMatcher_Inc_RefCount
  #define NOTMatcher_Dec_RefCount Lucy_NOTMatcher_Dec_RefCount
  #define NOTMatcher_To_Host Lucy_NOTMatcher_To_Host
  #define NOTMatcher_Clone Lucy_NOTMatcher_Clone
  #define NOTMatcher_Destroy Lucy_NOTMatcher_Destroy
  #define NOTMatcher_Equals Lucy_NOTMatcher_Equals
  #define NOTMatcher_Compare_To Lucy_NOTMatcher_Compare_To
  #define NOTMatcher_Hash_Sum Lucy_NOTMatcher_Hash_Sum
  #define NOTMatcher_Get_VTable Lucy_NOTMatcher_Get_VTable
  #define NOTMatcher_Get_Class_Name Lucy_NOTMatcher_Get_Class_Name
  #define NOTMatcher_Is_A Lucy_NOTMatcher_Is_A
  #define NOTMatcher_To_String Lucy_NOTMatcher_To_String
  #define NOTMatcher_To_I64 Lucy_NOTMatcher_To_I64
  #define NOTMatcher_To_F64 Lucy_NOTMatcher_To_F64
  #define NOTMatcher_To_Bool Lucy_NOTMatcher_To_Bool
  #define NOTMatcher_Serialize Lucy_NOTMatcher_Serialize
  #define NOTMatcher_Deserialize Lucy_NOTMatcher_Deserialize
  #define NOTMatcher_Dump Lucy_NOTMatcher_Dump
  #define NOTMatcher_Load Lucy_NOTMatcher_Load
  #define NOTMatcher_Mimic Lucy_NOTMatcher_Mimic
  #define NOTMatcher_Next Lucy_NOTMatcher_Next
  #define NOTMatcher_Advance Lucy_NOTMatcher_Advance
  #define NOTMatcher_Get_Doc_ID Lucy_NOTMatcher_Get_Doc_ID
  #define NOTMatcher_Score Lucy_NOTMatcher_Score
  #define NOTMatcher_Collect Lucy_NOTMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_NOTMATCHER */




