/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_ORMATCHER
#define H_LUCY_SEARCH_ORMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "Lucy/Search/Matcher.h"

/* A wrapper for a Matcher which caches the result of Matcher_Get_Doc_ID().
 */
typedef struct lucy_HeapedMatcherDoc {
    lucy_Matcher *matcher;
    int32_t   doc;
} lucy_HeapedMatcherDoc;

#ifdef LUCY_USE_SHORT_NAMES
  #define HeapedMatcherDoc              lucy_HeapedMatcherDoc
#endif


#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/PolyMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ORMATCHER
struct lucy_ORMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
    lucy_HeapedMatcherDoc** heap;
    lucy_HeapedMatcherDoc** pool;
    char* blob;
    lucy_HeapedMatcherDoc* top_hmd;
    uint32_t size;
    uint32_t max_size;
};

#endif /* C_LUCY_ORMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ORMatcher*
lucy_ORMatcher_new(lucy_VArray* children);

lucy_ORMatcher*
lucy_ORMatcher_init(lucy_ORMatcher* self, lucy_VArray* children);

void
lucy_ORMatcher_destroy(lucy_ORMatcher* self);

int32_t
lucy_ORMatcher_next(lucy_ORMatcher* self);

int32_t
lucy_ORMatcher_advance(lucy_ORMatcher* self, int32_t target);

int32_t
lucy_ORMatcher_get_doc_id(lucy_ORMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ORMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_ORMatcher_next_CALLBACK;
extern cfish_Callback lucy_ORMatcher_advance_CALLBACK;
extern cfish_Callback lucy_ORMatcher_get_doc_id_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ORMatcher_destroy_t)(lucy_ORMatcher* self);

typedef int32_t
(*lucy_ORMatcher_next_t)(lucy_ORMatcher* self);

typedef int32_t
(*lucy_ORMatcher_advance_t)(lucy_ORMatcher* self, int32_t target);

typedef int32_t
(*lucy_ORMatcher_get_doc_id_t)(lucy_ORMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ORMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORMatcher_Make(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ORMatcher_Get_RefCount(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORMatcher_Inc_RefCount(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ORMatcher_Dec_RefCount(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ORMatcher_To_Host(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORMatcher_Clone(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ORMatcher_Destroy(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Destroy_OFFSET;
    const lucy_ORMatcher_destroy_t method = *((lucy_ORMatcher_destroy_t*)method_address);
    method((lucy_ORMatcher*)self);
}

extern size_t Lucy_ORMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ORMatcher_Equals(const lucy_ORMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ORMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ORMatcher_Compare_To(const lucy_ORMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ORMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ORMatcher_Hash_Sum(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ORMatcher_Get_VTable(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ORMatcher_Get_Class_Name(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ORMatcher_Is_A(const lucy_ORMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ORMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ORMatcher_To_String(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ORMatcher_To_I64(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ORMatcher_To_F64(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ORMatcher_To_Bool(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ORMatcher_Serialize(const lucy_ORMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ORMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORMatcher_Deserialize(const lucy_ORMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ORMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORMatcher_Dump(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORMatcher_Load(const lucy_ORMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ORMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ORMatcher_Mimic(const lucy_ORMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ORMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_ORMatcher_Next(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Next_OFFSET;
    const lucy_ORMatcher_next_t method = *((lucy_ORMatcher_next_t*)method_address);
    return method((lucy_ORMatcher*)self);
}

extern size_t Lucy_ORMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_ORMatcher_Advance(const lucy_ORMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Advance_OFFSET;
    const lucy_ORMatcher_advance_t method = *((lucy_ORMatcher_advance_t*)method_address);
    return method((lucy_ORMatcher*)self, target);
}

extern size_t Lucy_ORMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ORMatcher_Get_Doc_ID(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Get_Doc_ID_OFFSET;
    const lucy_ORMatcher_get_doc_id_t method = *((lucy_ORMatcher_get_doc_id_t*)method_address);
    return method((lucy_ORMatcher*)self);
}

extern size_t Lucy_ORMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_ORMatcher_Score(const lucy_ORMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Score_OFFSET;
    const lucy_Matcher_score_t method = *((lucy_Matcher_score_t*)method_address);
    return method((lucy_Matcher*)self);
}

extern size_t Lucy_ORMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_ORMatcher_Collect(const lucy_ORMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_ORMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_ORMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_ORMATCHER_VT;
extern struct LUCY_ORMATCHER_VT LUCY_ORMATCHER_vt;
#define LUCY_ORMATCHER ((cfish_VTable*)&LUCY_ORMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ORMatcher lucy_ORMatcher
  #define ORMATCHER LUCY_ORMATCHER
  #define ORMatcher_new lucy_ORMatcher_new
  #define ORMatcher_init lucy_ORMatcher_init
  #define ORMatcher_destroy_t lucy_ORMatcher_destroy_t
  #define ORMatcher_destroy lucy_ORMatcher_destroy
  #define ORMatcher_next_t lucy_ORMatcher_next_t
  #define ORMatcher_next lucy_ORMatcher_next
  #define ORMatcher_advance_t lucy_ORMatcher_advance_t
  #define ORMatcher_advance lucy_ORMatcher_advance
  #define ORMatcher_get_doc_id_t lucy_ORMatcher_get_doc_id_t
  #define ORMatcher_get_doc_id lucy_ORMatcher_get_doc_id
  #define ORMatcher_Make Lucy_ORMatcher_Make
  #define ORMatcher_Get_RefCount Lucy_ORMatcher_Get_RefCount
  #define ORMatcher_Inc_RefCount Lucy_ORMatcher_Inc_RefCount
  #define ORMatcher_Dec_RefCount Lucy_ORMatcher_Dec_RefCount
  #define ORMatcher_To_Host Lucy_ORMatcher_To_Host
  #define ORMatcher_Clone Lucy_ORMatcher_Clone
  #define ORMatcher_Destroy Lucy_ORMatcher_Destroy
  #define ORMatcher_Equals Lucy_ORMatcher_Equals
  #define ORMatcher_Compare_To Lucy_ORMatcher_Compare_To
  #define ORMatcher_Hash_Sum Lucy_ORMatcher_Hash_Sum
  #define ORMatcher_Get_VTable Lucy_ORMatcher_Get_VTable
  #define ORMatcher_Get_Class_Name Lucy_ORMatcher_Get_Class_Name
  #define ORMatcher_Is_A Lucy_ORMatcher_Is_A
  #define ORMatcher_To_String Lucy_ORMatcher_To_String
  #define ORMatcher_To_I64 Lucy_ORMatcher_To_I64
  #define ORMatcher_To_F64 Lucy_ORMatcher_To_F64
  #define ORMatcher_To_Bool Lucy_ORMatcher_To_Bool
  #define ORMatcher_Serialize Lucy_ORMatcher_Serialize
  #define ORMatcher_Deserialize Lucy_ORMatcher_Deserialize
  #define ORMatcher_Dump Lucy_ORMatcher_Dump
  #define ORMatcher_Load Lucy_ORMatcher_Load
  #define ORMatcher_Mimic Lucy_ORMatcher_Mimic
  #define ORMatcher_Next Lucy_ORMatcher_Next
  #define ORMatcher_Advance Lucy_ORMatcher_Advance
  #define ORMatcher_Get_Doc_ID Lucy_ORMatcher_Get_Doc_ID
  #define ORMatcher_Score Lucy_ORMatcher_Score
  #define ORMatcher_Collect Lucy_ORMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/ORMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ORSCORER
struct lucy_ORScorer {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
    lucy_HeapedMatcherDoc** heap;
    lucy_HeapedMatcherDoc** pool;
    char* blob;
    lucy_HeapedMatcherDoc* top_hmd;
    uint32_t size;
    uint32_t max_size;
    float* scores;
    int32_t doc_id;
};

#endif /* C_LUCY_ORSCORER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ORScorer*
lucy_ORScorer_new(lucy_VArray* children, lucy_Similarity* similarity);

lucy_ORScorer*
lucy_ORScorer_init(lucy_ORScorer* self, lucy_VArray* children, lucy_Similarity* similarity);

void
lucy_ORScorer_destroy(lucy_ORScorer* self);

int32_t
lucy_ORScorer_next(lucy_ORScorer* self);

int32_t
lucy_ORScorer_advance(lucy_ORScorer* self, int32_t target);

int32_t
lucy_ORScorer_get_doc_id(lucy_ORScorer* self);

float
lucy_ORScorer_score(lucy_ORScorer* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ORScorer_destroy_CALLBACK;
extern cfish_Callback lucy_ORScorer_next_CALLBACK;
extern cfish_Callback lucy_ORScorer_advance_CALLBACK;
extern cfish_Callback lucy_ORScorer_get_doc_id_CALLBACK;
extern cfish_Callback lucy_ORScorer_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ORScorer_destroy_t)(lucy_ORScorer* self);

typedef int32_t
(*lucy_ORScorer_next_t)(lucy_ORScorer* self);

typedef int32_t
(*lucy_ORScorer_advance_t)(lucy_ORScorer* self, int32_t target);

typedef int32_t
(*lucy_ORScorer_get_doc_id_t)(lucy_ORScorer* self);

typedef float
(*lucy_ORScorer_score_t)(lucy_ORScorer* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ORScorer_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORScorer_Make(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ORScorer_Get_RefCount(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORScorer_Inc_RefCount(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ORScorer_Dec_RefCount(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ORScorer_To_Host(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORScorer_Clone(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ORScorer_Destroy(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Destroy_OFFSET;
    const lucy_ORScorer_destroy_t method = *((lucy_ORScorer_destroy_t*)method_address);
    method((lucy_ORScorer*)self);
}

extern size_t Lucy_ORScorer_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ORScorer_Equals(const lucy_ORScorer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ORScorer_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ORScorer_Compare_To(const lucy_ORScorer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ORScorer_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ORScorer_Hash_Sum(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ORScorer_Get_VTable(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ORScorer_Get_Class_Name(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ORScorer_Is_A(const lucy_ORScorer *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ORScorer_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ORScorer_To_String(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ORScorer_To_I64(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ORScorer_To_F64(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ORScorer_To_Bool(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ORScorer_Serialize(const lucy_ORScorer *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ORScorer_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORScorer_Deserialize(const lucy_ORScorer *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ORScorer_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORScorer_Dump(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ORScorer_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ORScorer_Load(const lucy_ORScorer *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ORScorer_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ORScorer_Mimic(const lucy_ORScorer *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ORScorer_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_ORScorer_Next(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Next_OFFSET;
    const lucy_ORScorer_next_t method = *((lucy_ORScorer_next_t*)method_address);
    return method((lucy_ORScorer*)self);
}

extern size_t Lucy_ORScorer_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_ORScorer_Advance(const lucy_ORScorer *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Advance_OFFSET;
    const lucy_ORScorer_advance_t method = *((lucy_ORScorer_advance_t*)method_address);
    return method((lucy_ORScorer*)self, target);
}

extern size_t Lucy_ORScorer_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ORScorer_Get_Doc_ID(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Get_Doc_ID_OFFSET;
    const lucy_ORScorer_get_doc_id_t method = *((lucy_ORScorer_get_doc_id_t*)method_address);
    return method((lucy_ORScorer*)self);
}

extern size_t Lucy_ORScorer_Score_OFFSET;
static CHY_INLINE float
Lucy_ORScorer_Score(const lucy_ORScorer *self) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Score_OFFSET;
    const lucy_ORScorer_score_t method = *((lucy_ORScorer_score_t*)method_address);
    return method((lucy_ORScorer*)self);
}

extern size_t Lucy_ORScorer_Collect_OFFSET;
static CHY_INLINE void
Lucy_ORScorer_Collect(const lucy_ORScorer *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_ORScorer_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_ORSCORER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_ORSCORER_VT;
extern struct LUCY_ORSCORER_VT LUCY_ORSCORER_vt;
#define LUCY_ORSCORER ((cfish_VTable*)&LUCY_ORSCORER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ORScorer lucy_ORScorer
  #define ORSCORER LUCY_ORSCORER
  #define ORScorer_new lucy_ORScorer_new
  #define ORScorer_init lucy_ORScorer_init
  #define ORScorer_destroy_t lucy_ORScorer_destroy_t
  #define ORScorer_destroy lucy_ORScorer_destroy
  #define ORScorer_next_t lucy_ORScorer_next_t
  #define ORScorer_next lucy_ORScorer_next
  #define ORScorer_advance_t lucy_ORScorer_advance_t
  #define ORScorer_advance lucy_ORScorer_advance
  #define ORScorer_get_doc_id_t lucy_ORScorer_get_doc_id_t
  #define ORScorer_get_doc_id lucy_ORScorer_get_doc_id
  #define ORScorer_score_t lucy_ORScorer_score_t
  #define ORScorer_score lucy_ORScorer_score
  #define ORScorer_Make Lucy_ORScorer_Make
  #define ORScorer_Get_RefCount Lucy_ORScorer_Get_RefCount
  #define ORScorer_Inc_RefCount Lucy_ORScorer_Inc_RefCount
  #define ORScorer_Dec_RefCount Lucy_ORScorer_Dec_RefCount
  #define ORScorer_To_Host Lucy_ORScorer_To_Host
  #define ORScorer_Clone Lucy_ORScorer_Clone
  #define ORScorer_Destroy Lucy_ORScorer_Destroy
  #define ORScorer_Equals Lucy_ORScorer_Equals
  #define ORScorer_Compare_To Lucy_ORScorer_Compare_To
  #define ORScorer_Hash_Sum Lucy_ORScorer_Hash_Sum
  #define ORScorer_Get_VTable Lucy_ORScorer_Get_VTable
  #define ORScorer_Get_Class_Name Lucy_ORScorer_Get_Class_Name
  #define ORScorer_Is_A Lucy_ORScorer_Is_A
  #define ORScorer_To_String Lucy_ORScorer_To_String
  #define ORScorer_To_I64 Lucy_ORScorer_To_I64
  #define ORScorer_To_F64 Lucy_ORScorer_To_F64
  #define ORScorer_To_Bool Lucy_ORScorer_To_Bool
  #define ORScorer_Serialize Lucy_ORScorer_Serialize
  #define ORScorer_Deserialize Lucy_ORScorer_Deserialize
  #define ORScorer_Dump Lucy_ORScorer_Dump
  #define ORScorer_Load Lucy_ORScorer_Load
  #define ORScorer_Mimic Lucy_ORScorer_Mimic
  #define ORScorer_Next Lucy_ORScorer_Next
  #define ORScorer_Advance Lucy_ORScorer_Advance
  #define ORScorer_Get_Doc_ID Lucy_ORScorer_Get_Doc_ID
  #define ORScorer_Score Lucy_ORScorer_Score
  #define ORScorer_Collect Lucy_ORScorer_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_ORMATCHER */




