/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_PHRASEMATCHER
#define H_LUCY_SEARCH_PHRASEMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PHRASEMATCHER
struct lucy_PhraseMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    uint32_t num_elements;
    lucy_Similarity* sim;
    lucy_PostingList** plists;
    lucy_ByteBuf* anchor_set;
    float phrase_freq;
    float phrase_boost;
    lucy_Compiler* compiler;
    float weight;
    chy_bool_t first_time;
    chy_bool_t more;
};

#endif /* C_LUCY_PHRASEMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PhraseMatcher*
lucy_PhraseMatcher_new(lucy_Similarity* similarity, lucy_VArray* posting_lists, lucy_Compiler* compiler);

lucy_PhraseMatcher*
lucy_PhraseMatcher_init(lucy_PhraseMatcher* self, lucy_Similarity* similarity, lucy_VArray* posting_lists, lucy_Compiler* compiler);

void
lucy_PhraseMatcher_destroy(lucy_PhraseMatcher* self);

int32_t
lucy_PhraseMatcher_next(lucy_PhraseMatcher* self);

int32_t
lucy_PhraseMatcher_advance(lucy_PhraseMatcher* self, int32_t target);

int32_t
lucy_PhraseMatcher_get_doc_id(lucy_PhraseMatcher* self);

float
lucy_PhraseMatcher_score(lucy_PhraseMatcher* self);

float
lucy_PhraseMatcher_calc_phrase_freq(lucy_PhraseMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PhraseMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_PhraseMatcher_next_CALLBACK;
extern cfish_Callback lucy_PhraseMatcher_advance_CALLBACK;
extern cfish_Callback lucy_PhraseMatcher_get_doc_id_CALLBACK;
extern cfish_Callback lucy_PhraseMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PhraseMatcher_destroy_t)(lucy_PhraseMatcher* self);

typedef int32_t
(*lucy_PhraseMatcher_next_t)(lucy_PhraseMatcher* self);

typedef int32_t
(*lucy_PhraseMatcher_advance_t)(lucy_PhraseMatcher* self, int32_t target);

typedef int32_t
(*lucy_PhraseMatcher_get_doc_id_t)(lucy_PhraseMatcher* self);

typedef float
(*lucy_PhraseMatcher_score_t)(lucy_PhraseMatcher* self);

typedef float
(*lucy_PhraseMatcher_calc_phrase_freq_t)(lucy_PhraseMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PhraseMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseMatcher_Make(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PhraseMatcher_Get_RefCount(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseMatcher_Inc_RefCount(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PhraseMatcher_Dec_RefCount(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PhraseMatcher_To_Host(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseMatcher_Clone(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PhraseMatcher_Destroy(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Destroy_OFFSET;
    const lucy_PhraseMatcher_destroy_t method = *((lucy_PhraseMatcher_destroy_t*)method_address);
    method((lucy_PhraseMatcher*)self);
}

extern size_t Lucy_PhraseMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseMatcher_Equals(const lucy_PhraseMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseMatcher_Compare_To(const lucy_PhraseMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseMatcher_Hash_Sum(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PhraseMatcher_Get_VTable(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseMatcher_Get_Class_Name(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseMatcher_Is_A(const lucy_PhraseMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PhraseMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseMatcher_To_String(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PhraseMatcher_To_I64(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PhraseMatcher_To_F64(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseMatcher_To_Bool(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PhraseMatcher_Serialize(const lucy_PhraseMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PhraseMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseMatcher_Deserialize(const lucy_PhraseMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PhraseMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseMatcher_Dump(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseMatcher_Load(const lucy_PhraseMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PhraseMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PhraseMatcher_Mimic(const lucy_PhraseMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseMatcher_Next(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Next_OFFSET;
    const lucy_PhraseMatcher_next_t method = *((lucy_PhraseMatcher_next_t*)method_address);
    return method((lucy_PhraseMatcher*)self);
}

extern size_t Lucy_PhraseMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseMatcher_Advance(const lucy_PhraseMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Advance_OFFSET;
    const lucy_PhraseMatcher_advance_t method = *((lucy_PhraseMatcher_advance_t*)method_address);
    return method((lucy_PhraseMatcher*)self, target);
}

extern size_t Lucy_PhraseMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseMatcher_Get_Doc_ID(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Get_Doc_ID_OFFSET;
    const lucy_PhraseMatcher_get_doc_id_t method = *((lucy_PhraseMatcher_get_doc_id_t*)method_address);
    return method((lucy_PhraseMatcher*)self);
}

extern size_t Lucy_PhraseMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_PhraseMatcher_Score(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Score_OFFSET;
    const lucy_PhraseMatcher_score_t method = *((lucy_PhraseMatcher_score_t*)method_address);
    return method((lucy_PhraseMatcher*)self);
}

extern size_t Lucy_PhraseMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_PhraseMatcher_Collect(const lucy_PhraseMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}

extern size_t Lucy_PhraseMatcher_Calc_Phrase_Freq_OFFSET;
static CHY_INLINE float
Lucy_PhraseMatcher_Calc_Phrase_Freq(const lucy_PhraseMatcher *self) {
    char *const method_address = *(char**)self + Lucy_PhraseMatcher_Calc_Phrase_Freq_OFFSET;
    const lucy_PhraseMatcher_calc_phrase_freq_t method = *((lucy_PhraseMatcher_calc_phrase_freq_t*)method_address);
    return method((lucy_PhraseMatcher*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PHRASEMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_PHRASEMATCHER_VT;
extern struct LUCY_PHRASEMATCHER_VT LUCY_PHRASEMATCHER_vt;
#define LUCY_PHRASEMATCHER ((cfish_VTable*)&LUCY_PHRASEMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PhraseMatcher lucy_PhraseMatcher
  #define PHRASEMATCHER LUCY_PHRASEMATCHER
  #define PhraseMatcher_new lucy_PhraseMatcher_new
  #define PhraseMatcher_init lucy_PhraseMatcher_init
  #define PhraseMatcher_destroy_t lucy_PhraseMatcher_destroy_t
  #define PhraseMatcher_destroy lucy_PhraseMatcher_destroy
  #define PhraseMatcher_next_t lucy_PhraseMatcher_next_t
  #define PhraseMatcher_next lucy_PhraseMatcher_next
  #define PhraseMatcher_advance_t lucy_PhraseMatcher_advance_t
  #define PhraseMatcher_advance lucy_PhraseMatcher_advance
  #define PhraseMatcher_get_doc_id_t lucy_PhraseMatcher_get_doc_id_t
  #define PhraseMatcher_get_doc_id lucy_PhraseMatcher_get_doc_id
  #define PhraseMatcher_score_t lucy_PhraseMatcher_score_t
  #define PhraseMatcher_score lucy_PhraseMatcher_score
  #define PhraseMatcher_calc_phrase_freq_t lucy_PhraseMatcher_calc_phrase_freq_t
  #define PhraseMatcher_calc_phrase_freq lucy_PhraseMatcher_calc_phrase_freq
  #define PhraseMatcher_Make Lucy_PhraseMatcher_Make
  #define PhraseMatcher_Get_RefCount Lucy_PhraseMatcher_Get_RefCount
  #define PhraseMatcher_Inc_RefCount Lucy_PhraseMatcher_Inc_RefCount
  #define PhraseMatcher_Dec_RefCount Lucy_PhraseMatcher_Dec_RefCount
  #define PhraseMatcher_To_Host Lucy_PhraseMatcher_To_Host
  #define PhraseMatcher_Clone Lucy_PhraseMatcher_Clone
  #define PhraseMatcher_Destroy Lucy_PhraseMatcher_Destroy
  #define PhraseMatcher_Equals Lucy_PhraseMatcher_Equals
  #define PhraseMatcher_Compare_To Lucy_PhraseMatcher_Compare_To
  #define PhraseMatcher_Hash_Sum Lucy_PhraseMatcher_Hash_Sum
  #define PhraseMatcher_Get_VTable Lucy_PhraseMatcher_Get_VTable
  #define PhraseMatcher_Get_Class_Name Lucy_PhraseMatcher_Get_Class_Name
  #define PhraseMatcher_Is_A Lucy_PhraseMatcher_Is_A
  #define PhraseMatcher_To_String Lucy_PhraseMatcher_To_String
  #define PhraseMatcher_To_I64 Lucy_PhraseMatcher_To_I64
  #define PhraseMatcher_To_F64 Lucy_PhraseMatcher_To_F64
  #define PhraseMatcher_To_Bool Lucy_PhraseMatcher_To_Bool
  #define PhraseMatcher_Serialize Lucy_PhraseMatcher_Serialize
  #define PhraseMatcher_Deserialize Lucy_PhraseMatcher_Deserialize
  #define PhraseMatcher_Dump Lucy_PhraseMatcher_Dump
  #define PhraseMatcher_Load Lucy_PhraseMatcher_Load
  #define PhraseMatcher_Mimic Lucy_PhraseMatcher_Mimic
  #define PhraseMatcher_Next Lucy_PhraseMatcher_Next
  #define PhraseMatcher_Advance Lucy_PhraseMatcher_Advance
  #define PhraseMatcher_Get_Doc_ID Lucy_PhraseMatcher_Get_Doc_ID
  #define PhraseMatcher_Score Lucy_PhraseMatcher_Score
  #define PhraseMatcher_Collect Lucy_PhraseMatcher_Collect
  #define PhraseMatcher_Calc_Phrase_Freq Lucy_PhraseMatcher_Calc_Phrase_Freq
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_PHRASEMATCHER */




