/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_PHRASEQUERY
#define H_LUCY_SEARCH_PHRASEQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PHRASEQUERY
struct lucy_PhraseQuery {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_CharBuf* field;
    lucy_VArray* terms;
};

#endif /* C_LUCY_PHRASEQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PhraseQuery*
lucy_PhraseQuery_new(const lucy_CharBuf* field, lucy_VArray* terms);

lucy_PhraseQuery*
lucy_PhraseQuery_init(lucy_PhraseQuery* self, const lucy_CharBuf* field, lucy_VArray* terms);

void
lucy_PhraseQuery_destroy(lucy_PhraseQuery* self);

chy_bool_t
lucy_PhraseQuery_equals(lucy_PhraseQuery* self, lucy_Obj* other);

lucy_CharBuf*
lucy_PhraseQuery_to_string(lucy_PhraseQuery* self);

void
lucy_PhraseQuery_serialize(lucy_PhraseQuery* self, lucy_OutStream* outstream);

lucy_PhraseQuery*
lucy_PhraseQuery_deserialize(lucy_PhraseQuery* self, lucy_InStream* instream);

lucy_Obj*
lucy_PhraseQuery_dump(lucy_PhraseQuery* self);

lucy_Obj*
lucy_PhraseQuery_load(lucy_PhraseQuery* self, lucy_Obj* dump);

lucy_Compiler*
lucy_PhraseQuery_make_compiler(lucy_PhraseQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

lucy_CharBuf*
lucy_PhraseQuery_get_field(lucy_PhraseQuery* self);

lucy_VArray*
lucy_PhraseQuery_get_terms(lucy_PhraseQuery* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PhraseQuery_destroy_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_equals_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_to_string_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_serialize_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_deserialize_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_dump_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_load_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_make_compiler_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_get_field_CALLBACK;
extern cfish_Callback lucy_PhraseQuery_get_terms_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PhraseQuery_destroy_t)(lucy_PhraseQuery* self);

typedef chy_bool_t
(*lucy_PhraseQuery_equals_t)(lucy_PhraseQuery* self, lucy_Obj* other);

typedef lucy_CharBuf*
(*lucy_PhraseQuery_to_string_t)(lucy_PhraseQuery* self);

typedef void
(*lucy_PhraseQuery_serialize_t)(lucy_PhraseQuery* self, lucy_OutStream* outstream);

typedef lucy_PhraseQuery*
(*lucy_PhraseQuery_deserialize_t)(lucy_PhraseQuery* self, lucy_InStream* instream);

typedef lucy_Obj*
(*lucy_PhraseQuery_dump_t)(lucy_PhraseQuery* self);

typedef lucy_Obj*
(*lucy_PhraseQuery_load_t)(lucy_PhraseQuery* self, lucy_Obj* dump);

typedef lucy_Compiler*
(*lucy_PhraseQuery_make_compiler_t)(lucy_PhraseQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

typedef lucy_CharBuf*
(*lucy_PhraseQuery_get_field_t)(lucy_PhraseQuery* self);

typedef lucy_VArray*
(*lucy_PhraseQuery_get_terms_t)(lucy_PhraseQuery* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PhraseQuery_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseQuery_Make(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PhraseQuery_Get_RefCount(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseQuery_Inc_RefCount(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PhraseQuery_Dec_RefCount(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PhraseQuery_To_Host(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseQuery_Clone(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PhraseQuery_Destroy(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Destroy_OFFSET;
    const lucy_PhraseQuery_destroy_t method = *((lucy_PhraseQuery_destroy_t*)method_address);
    method((lucy_PhraseQuery*)self);
}

extern size_t Lucy_PhraseQuery_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseQuery_Equals(const lucy_PhraseQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Equals_OFFSET;
    const lucy_PhraseQuery_equals_t method = *((lucy_PhraseQuery_equals_t*)method_address);
    return method((lucy_PhraseQuery*)self, other);
}

extern size_t Lucy_PhraseQuery_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseQuery_Compare_To(const lucy_PhraseQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseQuery_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseQuery_Hash_Sum(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PhraseQuery_Get_VTable(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseQuery_Get_Class_Name(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseQuery_Is_A(const lucy_PhraseQuery *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PhraseQuery_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseQuery_To_String(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_To_String_OFFSET;
    const lucy_PhraseQuery_to_string_t method = *((lucy_PhraseQuery_to_string_t*)method_address);
    return method((lucy_PhraseQuery*)self);
}

extern size_t Lucy_PhraseQuery_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PhraseQuery_To_I64(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PhraseQuery_To_F64(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseQuery_To_Bool(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseQuery_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PhraseQuery_Serialize(const lucy_PhraseQuery *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Serialize_OFFSET;
    const lucy_PhraseQuery_serialize_t method = *((lucy_PhraseQuery_serialize_t*)method_address);
    method((lucy_PhraseQuery*)self, outstream);
}

extern size_t Lucy_PhraseQuery_Deserialize_OFFSET;
static CHY_INLINE lucy_PhraseQuery*
Lucy_PhraseQuery_Deserialize(const lucy_PhraseQuery *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Deserialize_OFFSET;
    const lucy_PhraseQuery_deserialize_t method = *((lucy_PhraseQuery_deserialize_t*)method_address);
    return method((lucy_PhraseQuery*)self, instream);
}

extern size_t Lucy_PhraseQuery_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseQuery_Dump(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Dump_OFFSET;
    const lucy_PhraseQuery_dump_t method = *((lucy_PhraseQuery_dump_t*)method_address);
    return method((lucy_PhraseQuery*)self);
}

extern size_t Lucy_PhraseQuery_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseQuery_Load(const lucy_PhraseQuery *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Load_OFFSET;
    const lucy_PhraseQuery_load_t method = *((lucy_PhraseQuery_load_t*)method_address);
    return method((lucy_PhraseQuery*)self, dump);
}

extern size_t Lucy_PhraseQuery_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PhraseQuery_Mimic(const lucy_PhraseQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseQuery_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_PhraseQuery_Make_Compiler(const lucy_PhraseQuery *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Make_Compiler_OFFSET;
    const lucy_PhraseQuery_make_compiler_t method = *((lucy_PhraseQuery_make_compiler_t*)method_address);
    return method((lucy_PhraseQuery*)self, searcher, boost, subordinate);
}

extern size_t Lucy_PhraseQuery_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_PhraseQuery_Set_Boost(const lucy_PhraseQuery *self, float boost) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_PhraseQuery_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_PhraseQuery_Get_Boost(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_PhraseQuery_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseQuery_Get_Field(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Get_Field_OFFSET;
    const lucy_PhraseQuery_get_field_t method = *((lucy_PhraseQuery_get_field_t*)method_address);
    return method((lucy_PhraseQuery*)self);
}

extern size_t Lucy_PhraseQuery_Get_Terms_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PhraseQuery_Get_Terms(const lucy_PhraseQuery *self) {
    char *const method_address = *(char**)self + Lucy_PhraseQuery_Get_Terms_OFFSET;
    const lucy_PhraseQuery_get_terms_t method = *((lucy_PhraseQuery_get_terms_t*)method_address);
    return method((lucy_PhraseQuery*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PHRASEQUERY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_PHRASEQUERY_VT;
extern struct LUCY_PHRASEQUERY_VT LUCY_PHRASEQUERY_vt;
#define LUCY_PHRASEQUERY ((cfish_VTable*)&LUCY_PHRASEQUERY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PhraseQuery lucy_PhraseQuery
  #define PHRASEQUERY LUCY_PHRASEQUERY
  #define PhraseQuery_new lucy_PhraseQuery_new
  #define PhraseQuery_init lucy_PhraseQuery_init
  #define PhraseQuery_destroy_t lucy_PhraseQuery_destroy_t
  #define PhraseQuery_destroy lucy_PhraseQuery_destroy
  #define PhraseQuery_equals_t lucy_PhraseQuery_equals_t
  #define PhraseQuery_equals lucy_PhraseQuery_equals
  #define PhraseQuery_to_string_t lucy_PhraseQuery_to_string_t
  #define PhraseQuery_to_string lucy_PhraseQuery_to_string
  #define PhraseQuery_serialize_t lucy_PhraseQuery_serialize_t
  #define PhraseQuery_serialize lucy_PhraseQuery_serialize
  #define PhraseQuery_deserialize_t lucy_PhraseQuery_deserialize_t
  #define PhraseQuery_deserialize lucy_PhraseQuery_deserialize
  #define PhraseQuery_dump_t lucy_PhraseQuery_dump_t
  #define PhraseQuery_dump lucy_PhraseQuery_dump
  #define PhraseQuery_load_t lucy_PhraseQuery_load_t
  #define PhraseQuery_load lucy_PhraseQuery_load
  #define PhraseQuery_make_compiler_t lucy_PhraseQuery_make_compiler_t
  #define PhraseQuery_make_compiler lucy_PhraseQuery_make_compiler
  #define PhraseQuery_get_field_t lucy_PhraseQuery_get_field_t
  #define PhraseQuery_get_field lucy_PhraseQuery_get_field
  #define PhraseQuery_get_terms_t lucy_PhraseQuery_get_terms_t
  #define PhraseQuery_get_terms lucy_PhraseQuery_get_terms
  #define PhraseQuery_Make Lucy_PhraseQuery_Make
  #define PhraseQuery_Get_RefCount Lucy_PhraseQuery_Get_RefCount
  #define PhraseQuery_Inc_RefCount Lucy_PhraseQuery_Inc_RefCount
  #define PhraseQuery_Dec_RefCount Lucy_PhraseQuery_Dec_RefCount
  #define PhraseQuery_To_Host Lucy_PhraseQuery_To_Host
  #define PhraseQuery_Clone Lucy_PhraseQuery_Clone
  #define PhraseQuery_Destroy Lucy_PhraseQuery_Destroy
  #define PhraseQuery_Equals Lucy_PhraseQuery_Equals
  #define PhraseQuery_Compare_To Lucy_PhraseQuery_Compare_To
  #define PhraseQuery_Hash_Sum Lucy_PhraseQuery_Hash_Sum
  #define PhraseQuery_Get_VTable Lucy_PhraseQuery_Get_VTable
  #define PhraseQuery_Get_Class_Name Lucy_PhraseQuery_Get_Class_Name
  #define PhraseQuery_Is_A Lucy_PhraseQuery_Is_A
  #define PhraseQuery_To_String Lucy_PhraseQuery_To_String
  #define PhraseQuery_To_I64 Lucy_PhraseQuery_To_I64
  #define PhraseQuery_To_F64 Lucy_PhraseQuery_To_F64
  #define PhraseQuery_To_Bool Lucy_PhraseQuery_To_Bool
  #define PhraseQuery_Serialize Lucy_PhraseQuery_Serialize
  #define PhraseQuery_Deserialize Lucy_PhraseQuery_Deserialize
  #define PhraseQuery_Dump Lucy_PhraseQuery_Dump
  #define PhraseQuery_Load Lucy_PhraseQuery_Load
  #define PhraseQuery_Mimic Lucy_PhraseQuery_Mimic
  #define PhraseQuery_Make_Compiler Lucy_PhraseQuery_Make_Compiler
  #define PhraseQuery_Set_Boost Lucy_PhraseQuery_Set_Boost
  #define PhraseQuery_Get_Boost Lucy_PhraseQuery_Get_Boost
  #define PhraseQuery_Get_Field Lucy_PhraseQuery_Get_Field
  #define PhraseQuery_Get_Terms Lucy_PhraseQuery_Get_Terms
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Compiler.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PHRASECOMPILER
struct lucy_PhraseCompiler {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
    float idf;
    float raw_weight;
    float query_norm_factor;
    float normalized_weight;
};

#endif /* C_LUCY_PHRASECOMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PhraseCompiler*
lucy_PhraseCompiler_new(lucy_PhraseQuery* parent, lucy_Searcher* searcher, float boost);

lucy_PhraseCompiler*
lucy_PhraseCompiler_init(lucy_PhraseCompiler* self, lucy_PhraseQuery* parent, lucy_Searcher* searcher, float boost);

chy_bool_t
lucy_PhraseCompiler_equals(lucy_PhraseCompiler* self, lucy_Obj* other);

void
lucy_PhraseCompiler_serialize(lucy_PhraseCompiler* self, lucy_OutStream* outstream);

lucy_PhraseCompiler*
lucy_PhraseCompiler_deserialize(lucy_PhraseCompiler* self, lucy_InStream* instream);

lucy_Matcher*
lucy_PhraseCompiler_make_matcher(lucy_PhraseCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);

float
lucy_PhraseCompiler_get_weight(lucy_PhraseCompiler* self);

float
lucy_PhraseCompiler_sum_of_squared_weights(lucy_PhraseCompiler* self);

void
lucy_PhraseCompiler_apply_norm_factor(lucy_PhraseCompiler* self, float factor);

lucy_VArray*
lucy_PhraseCompiler_highlight_spans(lucy_PhraseCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PhraseCompiler_equals_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_serialize_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_deserialize_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_make_matcher_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_get_weight_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_sum_of_squared_weights_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_apply_norm_factor_CALLBACK;
extern cfish_Callback lucy_PhraseCompiler_highlight_spans_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_PhraseCompiler_equals_t)(lucy_PhraseCompiler* self, lucy_Obj* other);

typedef void
(*lucy_PhraseCompiler_serialize_t)(lucy_PhraseCompiler* self, lucy_OutStream* outstream);

typedef lucy_PhraseCompiler*
(*lucy_PhraseCompiler_deserialize_t)(lucy_PhraseCompiler* self, lucy_InStream* instream);

typedef lucy_Matcher*
(*lucy_PhraseCompiler_make_matcher_t)(lucy_PhraseCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);

typedef float
(*lucy_PhraseCompiler_get_weight_t)(lucy_PhraseCompiler* self);

typedef float
(*lucy_PhraseCompiler_sum_of_squared_weights_t)(lucy_PhraseCompiler* self);

typedef void
(*lucy_PhraseCompiler_apply_norm_factor_t)(lucy_PhraseCompiler* self, float factor);

typedef lucy_VArray*
(*lucy_PhraseCompiler_highlight_spans_t)(lucy_PhraseCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PhraseCompiler_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseCompiler_Make(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PhraseCompiler_Get_RefCount(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseCompiler_Inc_RefCount(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PhraseCompiler_Dec_RefCount(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PhraseCompiler_To_Host(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseCompiler_Clone(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PhraseCompiler_Destroy(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Destroy_OFFSET;
    const lucy_Compiler_destroy_t method = *((lucy_Compiler_destroy_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_PhraseCompiler_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseCompiler_Equals(const lucy_PhraseCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Equals_OFFSET;
    const lucy_PhraseCompiler_equals_t method = *((lucy_PhraseCompiler_equals_t*)method_address);
    return method((lucy_PhraseCompiler*)self, other);
}

extern size_t Lucy_PhraseCompiler_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseCompiler_Compare_To(const lucy_PhraseCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseCompiler_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PhraseCompiler_Hash_Sum(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PhraseCompiler_Get_VTable(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseCompiler_Get_Class_Name(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseCompiler_Is_A(const lucy_PhraseCompiler *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PhraseCompiler_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PhraseCompiler_To_String(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_To_String_OFFSET;
    const lucy_Compiler_to_string_t method = *((lucy_Compiler_to_string_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_PhraseCompiler_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PhraseCompiler_To_I64(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PhraseCompiler_To_F64(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PhraseCompiler_To_Bool(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PhraseCompiler_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PhraseCompiler_Serialize(const lucy_PhraseCompiler *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Serialize_OFFSET;
    const lucy_PhraseCompiler_serialize_t method = *((lucy_PhraseCompiler_serialize_t*)method_address);
    method((lucy_PhraseCompiler*)self, outstream);
}

extern size_t Lucy_PhraseCompiler_Deserialize_OFFSET;
static CHY_INLINE lucy_PhraseCompiler*
Lucy_PhraseCompiler_Deserialize(const lucy_PhraseCompiler *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Deserialize_OFFSET;
    const lucy_PhraseCompiler_deserialize_t method = *((lucy_PhraseCompiler_deserialize_t*)method_address);
    return method((lucy_PhraseCompiler*)self, instream);
}

extern size_t Lucy_PhraseCompiler_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseCompiler_Dump(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Dump_OFFSET;
    const lucy_Query_dump_t method = *((lucy_Query_dump_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_PhraseCompiler_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PhraseCompiler_Load(const lucy_PhraseCompiler *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Load_OFFSET;
    const lucy_Query_load_t method = *((lucy_Query_load_t*)method_address);
    return method((lucy_Query*)self, dump);
}

extern size_t Lucy_PhraseCompiler_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PhraseCompiler_Mimic(const lucy_PhraseCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PhraseCompiler_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_PhraseCompiler_Make_Compiler(const lucy_PhraseCompiler *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Make_Compiler_OFFSET;
    const lucy_Query_make_compiler_t method = *((lucy_Query_make_compiler_t*)method_address);
    return method((lucy_Query*)self, searcher, boost, subordinate);
}

extern size_t Lucy_PhraseCompiler_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_PhraseCompiler_Set_Boost(const lucy_PhraseCompiler *self, float boost) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_PhraseCompiler_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_PhraseCompiler_Get_Boost(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_PhraseCompiler_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_PhraseCompiler_Make_Matcher(const lucy_PhraseCompiler *self, lucy_SegReader* reader, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Make_Matcher_OFFSET;
    const lucy_PhraseCompiler_make_matcher_t method = *((lucy_PhraseCompiler_make_matcher_t*)method_address);
    return method((lucy_PhraseCompiler*)self, reader, need_score);
}

extern size_t Lucy_PhraseCompiler_Get_Weight_OFFSET;
static CHY_INLINE float
Lucy_PhraseCompiler_Get_Weight(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_Weight_OFFSET;
    const lucy_PhraseCompiler_get_weight_t method = *((lucy_PhraseCompiler_get_weight_t*)method_address);
    return method((lucy_PhraseCompiler*)self);
}

extern size_t Lucy_PhraseCompiler_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_PhraseCompiler_Get_Similarity(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_Similarity_OFFSET;
    const lucy_Compiler_get_similarity_t method = *((lucy_Compiler_get_similarity_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_PhraseCompiler_Get_Parent_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_PhraseCompiler_Get_Parent(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Get_Parent_OFFSET;
    const lucy_Compiler_get_parent_t method = *((lucy_Compiler_get_parent_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_PhraseCompiler_Sum_Of_Squared_Weights_OFFSET;
static CHY_INLINE float
Lucy_PhraseCompiler_Sum_Of_Squared_Weights(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Sum_Of_Squared_Weights_OFFSET;
    const lucy_PhraseCompiler_sum_of_squared_weights_t method = *((lucy_PhraseCompiler_sum_of_squared_weights_t*)method_address);
    return method((lucy_PhraseCompiler*)self);
}

extern size_t Lucy_PhraseCompiler_Apply_Norm_Factor_OFFSET;
static CHY_INLINE void
Lucy_PhraseCompiler_Apply_Norm_Factor(const lucy_PhraseCompiler *self, float factor) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Apply_Norm_Factor_OFFSET;
    const lucy_PhraseCompiler_apply_norm_factor_t method = *((lucy_PhraseCompiler_apply_norm_factor_t*)method_address);
    method((lucy_PhraseCompiler*)self, factor);
}

extern size_t Lucy_PhraseCompiler_Normalize_OFFSET;
static CHY_INLINE void
Lucy_PhraseCompiler_Normalize(const lucy_PhraseCompiler *self) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Normalize_OFFSET;
    const lucy_Compiler_normalize_t method = *((lucy_Compiler_normalize_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_PhraseCompiler_Highlight_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PhraseCompiler_Highlight_Spans(const lucy_PhraseCompiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_PhraseCompiler_Highlight_Spans_OFFSET;
    const lucy_PhraseCompiler_highlight_spans_t method = *((lucy_PhraseCompiler_highlight_spans_t*)method_address);
    return method((lucy_PhraseCompiler*)self, searcher, doc_vec, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PHRASECOMPILER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_PHRASECOMPILER_VT;
extern struct LUCY_PHRASECOMPILER_VT LUCY_PHRASECOMPILER_vt;
#define LUCY_PHRASECOMPILER ((cfish_VTable*)&LUCY_PHRASECOMPILER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PhraseCompiler lucy_PhraseCompiler
  #define PHRASECOMPILER LUCY_PHRASECOMPILER
  #define PhraseCompiler_new lucy_PhraseCompiler_new
  #define PhraseCompiler_init lucy_PhraseCompiler_init
  #define PhraseCompiler_equals_t lucy_PhraseCompiler_equals_t
  #define PhraseCompiler_equals lucy_PhraseCompiler_equals
  #define PhraseCompiler_serialize_t lucy_PhraseCompiler_serialize_t
  #define PhraseCompiler_serialize lucy_PhraseCompiler_serialize
  #define PhraseCompiler_deserialize_t lucy_PhraseCompiler_deserialize_t
  #define PhraseCompiler_deserialize lucy_PhraseCompiler_deserialize
  #define PhraseCompiler_make_matcher_t lucy_PhraseCompiler_make_matcher_t
  #define PhraseCompiler_make_matcher lucy_PhraseCompiler_make_matcher
  #define PhraseCompiler_get_weight_t lucy_PhraseCompiler_get_weight_t
  #define PhraseCompiler_get_weight lucy_PhraseCompiler_get_weight
  #define PhraseCompiler_sum_of_squared_weights_t lucy_PhraseCompiler_sum_of_squared_weights_t
  #define PhraseCompiler_sum_of_squared_weights lucy_PhraseCompiler_sum_of_squared_weights
  #define PhraseCompiler_apply_norm_factor_t lucy_PhraseCompiler_apply_norm_factor_t
  #define PhraseCompiler_apply_norm_factor lucy_PhraseCompiler_apply_norm_factor
  #define PhraseCompiler_highlight_spans_t lucy_PhraseCompiler_highlight_spans_t
  #define PhraseCompiler_highlight_spans lucy_PhraseCompiler_highlight_spans
  #define PhraseCompiler_Make Lucy_PhraseCompiler_Make
  #define PhraseCompiler_Get_RefCount Lucy_PhraseCompiler_Get_RefCount
  #define PhraseCompiler_Inc_RefCount Lucy_PhraseCompiler_Inc_RefCount
  #define PhraseCompiler_Dec_RefCount Lucy_PhraseCompiler_Dec_RefCount
  #define PhraseCompiler_To_Host Lucy_PhraseCompiler_To_Host
  #define PhraseCompiler_Clone Lucy_PhraseCompiler_Clone
  #define PhraseCompiler_Destroy Lucy_PhraseCompiler_Destroy
  #define PhraseCompiler_Equals Lucy_PhraseCompiler_Equals
  #define PhraseCompiler_Compare_To Lucy_PhraseCompiler_Compare_To
  #define PhraseCompiler_Hash_Sum Lucy_PhraseCompiler_Hash_Sum
  #define PhraseCompiler_Get_VTable Lucy_PhraseCompiler_Get_VTable
  #define PhraseCompiler_Get_Class_Name Lucy_PhraseCompiler_Get_Class_Name
  #define PhraseCompiler_Is_A Lucy_PhraseCompiler_Is_A
  #define PhraseCompiler_To_String Lucy_PhraseCompiler_To_String
  #define PhraseCompiler_To_I64 Lucy_PhraseCompiler_To_I64
  #define PhraseCompiler_To_F64 Lucy_PhraseCompiler_To_F64
  #define PhraseCompiler_To_Bool Lucy_PhraseCompiler_To_Bool
  #define PhraseCompiler_Serialize Lucy_PhraseCompiler_Serialize
  #define PhraseCompiler_Deserialize Lucy_PhraseCompiler_Deserialize
  #define PhraseCompiler_Dump Lucy_PhraseCompiler_Dump
  #define PhraseCompiler_Load Lucy_PhraseCompiler_Load
  #define PhraseCompiler_Mimic Lucy_PhraseCompiler_Mimic
  #define PhraseCompiler_Make_Compiler Lucy_PhraseCompiler_Make_Compiler
  #define PhraseCompiler_Set_Boost Lucy_PhraseCompiler_Set_Boost
  #define PhraseCompiler_Get_Boost Lucy_PhraseCompiler_Get_Boost
  #define PhraseCompiler_Make_Matcher Lucy_PhraseCompiler_Make_Matcher
  #define PhraseCompiler_Get_Weight Lucy_PhraseCompiler_Get_Weight
  #define PhraseCompiler_Get_Similarity Lucy_PhraseCompiler_Get_Similarity
  #define PhraseCompiler_Get_Parent Lucy_PhraseCompiler_Get_Parent
  #define PhraseCompiler_Sum_Of_Squared_Weights Lucy_PhraseCompiler_Sum_Of_Squared_Weights
  #define PhraseCompiler_Apply_Norm_Factor Lucy_PhraseCompiler_Apply_Norm_Factor
  #define PhraseCompiler_Normalize Lucy_PhraseCompiler_Normalize
  #define PhraseCompiler_Highlight_Spans Lucy_PhraseCompiler_Highlight_Spans
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_PHRASEQUERY */




