/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_POLYSEARCHER
#define H_LUCY_SEARCH_POLYSEARCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Searcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYSEARCHER
struct lucy_PolySearcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_QueryParser* qparser;
    lucy_VArray* searchers;
    lucy_I32Array* starts;
    int32_t doc_max;
};

#endif /* C_LUCY_POLYSEARCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PolySearcher*
lucy_PolySearcher_new(lucy_Schema* schema, lucy_VArray* searchers);

lucy_PolySearcher*
lucy_PolySearcher_init(lucy_PolySearcher* self, lucy_Schema* schema, lucy_VArray* searchers);

void
lucy_PolySearcher_destroy(lucy_PolySearcher* self);

int32_t
lucy_PolySearcher_doc_max(lucy_PolySearcher* self);

uint32_t
lucy_PolySearcher_doc_freq(lucy_PolySearcher* self, const lucy_CharBuf* field, lucy_Obj* term);

void
lucy_PolySearcher_collect(lucy_PolySearcher* self, lucy_Query* query, lucy_Collector* collector);

lucy_TopDocs*
lucy_PolySearcher_top_docs(lucy_PolySearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

lucy_HitDoc*
lucy_PolySearcher_fetch_doc(lucy_PolySearcher* self, int32_t doc_id);

lucy_DocVector*
lucy_PolySearcher_fetch_doc_vec(lucy_PolySearcher* self, int32_t doc_id);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PolySearcher_destroy_CALLBACK;
extern cfish_Callback lucy_PolySearcher_doc_max_CALLBACK;
extern cfish_Callback lucy_PolySearcher_doc_freq_CALLBACK;
extern cfish_Callback lucy_PolySearcher_collect_CALLBACK;
extern cfish_Callback lucy_PolySearcher_fetch_doc_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PolySearcher_destroy_t)(lucy_PolySearcher* self);

typedef int32_t
(*lucy_PolySearcher_doc_max_t)(lucy_PolySearcher* self);

typedef uint32_t
(*lucy_PolySearcher_doc_freq_t)(lucy_PolySearcher* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef void
(*lucy_PolySearcher_collect_t)(lucy_PolySearcher* self, lucy_Query* query, lucy_Collector* collector);

typedef lucy_TopDocs*
(*lucy_PolySearcher_top_docs_t)(lucy_PolySearcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

typedef lucy_HitDoc*
(*lucy_PolySearcher_fetch_doc_t)(lucy_PolySearcher* self, int32_t doc_id);

typedef lucy_DocVector*
(*lucy_PolySearcher_fetch_doc_vec_t)(lucy_PolySearcher* self, int32_t doc_id);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PolySearcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolySearcher_Make(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolySearcher_Get_RefCount(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolySearcher_Inc_RefCount(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolySearcher_Dec_RefCount(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PolySearcher_To_Host(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolySearcher_Clone(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PolySearcher_Destroy(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Destroy_OFFSET;
    const lucy_PolySearcher_destroy_t method = *((lucy_PolySearcher_destroy_t*)method_address);
    method((lucy_PolySearcher*)self);
}

extern size_t Lucy_PolySearcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolySearcher_Equals(const lucy_PolySearcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolySearcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PolySearcher_Compare_To(const lucy_PolySearcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolySearcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PolySearcher_Hash_Sum(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PolySearcher_Get_VTable(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolySearcher_Get_Class_Name(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolySearcher_Is_A(const lucy_PolySearcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PolySearcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PolySearcher_To_String(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PolySearcher_To_I64(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PolySearcher_To_F64(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PolySearcher_To_Bool(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PolySearcher_Serialize(const lucy_PolySearcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PolySearcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolySearcher_Deserialize(const lucy_PolySearcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PolySearcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolySearcher_Dump(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PolySearcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PolySearcher_Load(const lucy_PolySearcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PolySearcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PolySearcher_Mimic(const lucy_PolySearcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PolySearcher_Doc_Max_OFFSET;
static CHY_INLINE int32_t
Lucy_PolySearcher_Doc_Max(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Doc_Max_OFFSET;
    const lucy_PolySearcher_doc_max_t method = *((lucy_PolySearcher_doc_max_t*)method_address);
    return method((lucy_PolySearcher*)self);
}

extern size_t Lucy_PolySearcher_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_PolySearcher_Doc_Freq(const lucy_PolySearcher *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Doc_Freq_OFFSET;
    const lucy_PolySearcher_doc_freq_t method = *((lucy_PolySearcher_doc_freq_t*)method_address);
    return method((lucy_PolySearcher*)self, field, term);
}

extern size_t Lucy_PolySearcher_Glean_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_PolySearcher_Glean_Query(const lucy_PolySearcher *self, lucy_Obj* query) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Glean_Query_OFFSET;
    const lucy_Searcher_glean_query_t method = *((lucy_Searcher_glean_query_t*)method_address);
    return method((lucy_Searcher*)self, query);
}

extern size_t Lucy_PolySearcher_Hits_OFFSET;
static CHY_INLINE lucy_Hits*
Lucy_PolySearcher_Hits(const lucy_PolySearcher *self, lucy_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Hits_OFFSET;
    const lucy_Searcher_hits_t method = *((lucy_Searcher_hits_t*)method_address);
    return method((lucy_Searcher*)self, query, offset, num_wanted, sort_spec);
}

extern size_t Lucy_PolySearcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_PolySearcher_Collect(const lucy_PolySearcher *self, lucy_Query* query, lucy_Collector* collector) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Collect_OFFSET;
    const lucy_PolySearcher_collect_t method = *((lucy_PolySearcher_collect_t*)method_address);
    method((lucy_PolySearcher*)self, query, collector);
}

extern size_t Lucy_PolySearcher_Top_Docs_OFFSET;
static CHY_INLINE lucy_TopDocs*
Lucy_PolySearcher_Top_Docs(const lucy_PolySearcher *self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Top_Docs_OFFSET;
    const lucy_PolySearcher_top_docs_t method = *((lucy_PolySearcher_top_docs_t*)method_address);
    return method((lucy_PolySearcher*)self, query, num_wanted, sort_spec);
}

extern size_t Lucy_PolySearcher_Fetch_Doc_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_PolySearcher_Fetch_Doc(const lucy_PolySearcher *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Fetch_Doc_OFFSET;
    const lucy_PolySearcher_fetch_doc_t method = *((lucy_PolySearcher_fetch_doc_t*)method_address);
    return method((lucy_PolySearcher*)self, doc_id);
}

extern size_t Lucy_PolySearcher_Fetch_Doc_Vec_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_PolySearcher_Fetch_Doc_Vec(const lucy_PolySearcher *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Fetch_Doc_Vec_OFFSET;
    const lucy_PolySearcher_fetch_doc_vec_t method = *((lucy_PolySearcher_fetch_doc_vec_t*)method_address);
    return method((lucy_PolySearcher*)self, doc_id);
}

extern size_t Lucy_PolySearcher_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_PolySearcher_Get_Schema(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Get_Schema_OFFSET;
    const lucy_Searcher_get_schema_t method = *((lucy_Searcher_get_schema_t*)method_address);
    return method((lucy_Searcher*)self);
}

extern size_t Lucy_PolySearcher_Close_OFFSET;
static CHY_INLINE void
Lucy_PolySearcher_Close(const lucy_PolySearcher *self) {
    char *const method_address = *(char**)self + Lucy_PolySearcher_Close_OFFSET;
    const lucy_Searcher_close_t method = *((lucy_Searcher_close_t*)method_address);
    method((lucy_Searcher*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_POLYSEARCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_POLYSEARCHER_VT;
extern struct LUCY_POLYSEARCHER_VT LUCY_POLYSEARCHER_vt;
#define LUCY_POLYSEARCHER ((cfish_VTable*)&LUCY_POLYSEARCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolySearcher lucy_PolySearcher
  #define POLYSEARCHER LUCY_POLYSEARCHER
  #define PolySearcher_new lucy_PolySearcher_new
  #define PolySearcher_init lucy_PolySearcher_init
  #define PolySearcher_destroy_t lucy_PolySearcher_destroy_t
  #define PolySearcher_destroy lucy_PolySearcher_destroy
  #define PolySearcher_doc_max_t lucy_PolySearcher_doc_max_t
  #define PolySearcher_doc_max lucy_PolySearcher_doc_max
  #define PolySearcher_doc_freq_t lucy_PolySearcher_doc_freq_t
  #define PolySearcher_doc_freq lucy_PolySearcher_doc_freq
  #define PolySearcher_collect_t lucy_PolySearcher_collect_t
  #define PolySearcher_collect lucy_PolySearcher_collect
  #define PolySearcher_top_docs_t lucy_PolySearcher_top_docs_t
  #define PolySearcher_top_docs lucy_PolySearcher_top_docs
  #define PolySearcher_fetch_doc_t lucy_PolySearcher_fetch_doc_t
  #define PolySearcher_fetch_doc lucy_PolySearcher_fetch_doc
  #define PolySearcher_fetch_doc_vec_t lucy_PolySearcher_fetch_doc_vec_t
  #define PolySearcher_fetch_doc_vec lucy_PolySearcher_fetch_doc_vec
  #define PolySearcher_Make Lucy_PolySearcher_Make
  #define PolySearcher_Get_RefCount Lucy_PolySearcher_Get_RefCount
  #define PolySearcher_Inc_RefCount Lucy_PolySearcher_Inc_RefCount
  #define PolySearcher_Dec_RefCount Lucy_PolySearcher_Dec_RefCount
  #define PolySearcher_To_Host Lucy_PolySearcher_To_Host
  #define PolySearcher_Clone Lucy_PolySearcher_Clone
  #define PolySearcher_Destroy Lucy_PolySearcher_Destroy
  #define PolySearcher_Equals Lucy_PolySearcher_Equals
  #define PolySearcher_Compare_To Lucy_PolySearcher_Compare_To
  #define PolySearcher_Hash_Sum Lucy_PolySearcher_Hash_Sum
  #define PolySearcher_Get_VTable Lucy_PolySearcher_Get_VTable
  #define PolySearcher_Get_Class_Name Lucy_PolySearcher_Get_Class_Name
  #define PolySearcher_Is_A Lucy_PolySearcher_Is_A
  #define PolySearcher_To_String Lucy_PolySearcher_To_String
  #define PolySearcher_To_I64 Lucy_PolySearcher_To_I64
  #define PolySearcher_To_F64 Lucy_PolySearcher_To_F64
  #define PolySearcher_To_Bool Lucy_PolySearcher_To_Bool
  #define PolySearcher_Serialize Lucy_PolySearcher_Serialize
  #define PolySearcher_Deserialize Lucy_PolySearcher_Deserialize
  #define PolySearcher_Dump Lucy_PolySearcher_Dump
  #define PolySearcher_Load Lucy_PolySearcher_Load
  #define PolySearcher_Mimic Lucy_PolySearcher_Mimic
  #define PolySearcher_Doc_Max Lucy_PolySearcher_Doc_Max
  #define PolySearcher_Doc_Freq Lucy_PolySearcher_Doc_Freq
  #define PolySearcher_Glean_Query Lucy_PolySearcher_Glean_Query
  #define PolySearcher_Hits Lucy_PolySearcher_Hits
  #define PolySearcher_Collect Lucy_PolySearcher_Collect
  #define PolySearcher_Top_Docs Lucy_PolySearcher_Top_Docs
  #define PolySearcher_Fetch_Doc Lucy_PolySearcher_Fetch_Doc
  #define PolySearcher_Fetch_Doc_Vec Lucy_PolySearcher_Fetch_Doc_Vec
  #define PolySearcher_Get_Schema Lucy_PolySearcher_Get_Schema
  #define PolySearcher_Close Lucy_PolySearcher_Close
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_POLYSEARCHER */




