/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_QUERYPARSER
#define H_LUCY_SEARCH_QUERYPARSER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_QUERYPARSER
struct lucy_QueryParser {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_Analyzer* analyzer;
    lucy_CharBuf* default_boolop;
    lucy_VArray* fields;
    lucy_CharBuf* phrase_label;
    lucy_CharBuf* bool_group_label;
    chy_bool_t heed_colons;
    uint32_t label_inc;
};

#endif /* C_LUCY_QUERYPARSER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_QueryParser*
lucy_QParser_new(lucy_Schema* schema, lucy_Analyzer* analyzer, const lucy_CharBuf* default_boolop, lucy_VArray* fields);

lucy_QueryParser*
lucy_QParser_init(lucy_QueryParser* self, lucy_Schema* schema, lucy_Analyzer* analyzer, const lucy_CharBuf* default_boolop, lucy_VArray* fields);

void
lucy_QParser_destroy(lucy_QueryParser* self);

lucy_Query*
lucy_QParser_parse(lucy_QueryParser* self, const lucy_CharBuf* query_string);

lucy_Query*
lucy_QParser_tree(lucy_QueryParser* self, const lucy_CharBuf* query_string);

lucy_Query*
lucy_QParser_expand(lucy_QueryParser* self, lucy_Query* query);

lucy_Query*
lucy_QParser_expand_leaf(lucy_QueryParser* self, lucy_Query* query);

lucy_Query*
lucy_QParser_prune(lucy_QueryParser* self, lucy_Query* query);

lucy_Query*
lucy_QParser_make_term_query(lucy_QueryParser* self, const lucy_CharBuf* field, lucy_Obj* term);

lucy_Query*
lucy_QParser_make_phrase_query(lucy_QueryParser* self, const lucy_CharBuf* field, lucy_VArray* terms);

lucy_Query*
lucy_QParser_make_or_query(lucy_QueryParser* self, lucy_VArray* children);

lucy_Query*
lucy_QParser_make_and_query(lucy_QueryParser* self, lucy_VArray* children);

lucy_Query*
lucy_QParser_make_not_query(lucy_QueryParser* self, lucy_Query* negated_query);

lucy_Query*
lucy_QParser_make_req_opt_query(lucy_QueryParser* self, lucy_Query* required_query, lucy_Query* optional_query);

lucy_Analyzer*
lucy_QParser_get_analyzer(lucy_QueryParser* self);

lucy_Schema*
lucy_QParser_get_schema(lucy_QueryParser* self);

lucy_CharBuf*
lucy_QParser_get_default_boolop(lucy_QueryParser* self);

lucy_VArray*
lucy_QParser_get_fields(lucy_QueryParser* self);

chy_bool_t
lucy_QParser_heed_colons(lucy_QueryParser* self);

void
lucy_QParser_set_heed_colons(lucy_QueryParser* self, chy_bool_t heed_colons);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_QParser_destroy_CALLBACK;
extern cfish_Callback lucy_QParser_parse_CALLBACK;
extern cfish_Callback lucy_QParser_tree_CALLBACK;
extern cfish_Callback lucy_QParser_expand_CALLBACK;
extern cfish_Callback lucy_QParser_expand_leaf_CALLBACK;
extern cfish_Callback lucy_QParser_prune_CALLBACK;
extern cfish_Callback lucy_QParser_make_term_query_CALLBACK;
extern cfish_Callback lucy_QParser_make_phrase_query_CALLBACK;
extern cfish_Callback lucy_QParser_make_or_query_CALLBACK;
extern cfish_Callback lucy_QParser_make_and_query_CALLBACK;
extern cfish_Callback lucy_QParser_make_not_query_CALLBACK;
extern cfish_Callback lucy_QParser_make_req_opt_query_CALLBACK;
extern cfish_Callback lucy_QParser_set_heed_colons_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_QParser_destroy_t)(lucy_QueryParser* self);

typedef lucy_Query*
(*lucy_QParser_parse_t)(lucy_QueryParser* self, const lucy_CharBuf* query_string);

typedef lucy_Query*
(*lucy_QParser_tree_t)(lucy_QueryParser* self, const lucy_CharBuf* query_string);

typedef lucy_Query*
(*lucy_QParser_expand_t)(lucy_QueryParser* self, lucy_Query* query);

typedef lucy_Query*
(*lucy_QParser_expand_leaf_t)(lucy_QueryParser* self, lucy_Query* query);

typedef lucy_Query*
(*lucy_QParser_prune_t)(lucy_QueryParser* self, lucy_Query* query);

typedef lucy_Query*
(*lucy_QParser_make_term_query_t)(lucy_QueryParser* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef lucy_Query*
(*lucy_QParser_make_phrase_query_t)(lucy_QueryParser* self, const lucy_CharBuf* field, lucy_VArray* terms);

typedef lucy_Query*
(*lucy_QParser_make_or_query_t)(lucy_QueryParser* self, lucy_VArray* children);

typedef lucy_Query*
(*lucy_QParser_make_and_query_t)(lucy_QueryParser* self, lucy_VArray* children);

typedef lucy_Query*
(*lucy_QParser_make_not_query_t)(lucy_QueryParser* self, lucy_Query* negated_query);

typedef lucy_Query*
(*lucy_QParser_make_req_opt_query_t)(lucy_QueryParser* self, lucy_Query* required_query, lucy_Query* optional_query);

typedef lucy_Analyzer*
(*lucy_QParser_get_analyzer_t)(lucy_QueryParser* self);

typedef lucy_Schema*
(*lucy_QParser_get_schema_t)(lucy_QueryParser* self);

typedef lucy_CharBuf*
(*lucy_QParser_get_default_boolop_t)(lucy_QueryParser* self);

typedef lucy_VArray*
(*lucy_QParser_get_fields_t)(lucy_QueryParser* self);

typedef chy_bool_t
(*lucy_QParser_heed_colons_t)(lucy_QueryParser* self);

typedef void
(*lucy_QParser_set_heed_colons_t)(lucy_QueryParser* self, chy_bool_t heed_colons);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_QParser_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_QParser_Make(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_QParser_Get_RefCount(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_QParser_Inc_RefCount(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_QParser_Dec_RefCount(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_QParser_To_Host(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_QParser_Clone(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Destroy_OFFSET;
static CHY_INLINE void
Lucy_QParser_Destroy(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Destroy_OFFSET;
    const lucy_QParser_destroy_t method = *((lucy_QParser_destroy_t*)method_address);
    method((lucy_QueryParser*)self);
}

extern size_t Lucy_QParser_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_QParser_Equals(const lucy_QueryParser *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_QParser_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_QParser_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_QParser_Compare_To(const lucy_QueryParser *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_QParser_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_QParser_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_QParser_Hash_Sum(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_QParser_Get_VTable(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_QParser_Get_Class_Name(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_QParser_Is_A(const lucy_QueryParser *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_QParser_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_QParser_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_QParser_To_String(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_QParser_To_I64(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_To_F64_OFFSET;
static CHY_INLINE double
Lucy_QParser_To_F64(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_QParser_To_Bool(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Serialize_OFFSET;
static CHY_INLINE void
Lucy_QParser_Serialize(const lucy_QueryParser *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_QParser_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_QParser_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_QParser_Deserialize(const lucy_QueryParser *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_QParser_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_QParser_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_QParser_Dump(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_QParser_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_QParser_Load(const lucy_QueryParser *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_QParser_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_QParser_Mimic_OFFSET;
static CHY_INLINE void
Lucy_QParser_Mimic(const lucy_QueryParser *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_QParser_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_QParser_Parse_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Parse(const lucy_QueryParser *self, const lucy_CharBuf* query_string) {
    char *const method_address = *(char**)self + Lucy_QParser_Parse_OFFSET;
    const lucy_QParser_parse_t method = *((lucy_QParser_parse_t*)method_address);
    return method((lucy_QueryParser*)self, query_string);
}

extern size_t Lucy_QParser_Tree_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Tree(const lucy_QueryParser *self, const lucy_CharBuf* query_string) {
    char *const method_address = *(char**)self + Lucy_QParser_Tree_OFFSET;
    const lucy_QParser_tree_t method = *((lucy_QParser_tree_t*)method_address);
    return method((lucy_QueryParser*)self, query_string);
}

extern size_t Lucy_QParser_Expand_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Expand(const lucy_QueryParser *self, lucy_Query* query) {
    char *const method_address = *(char**)self + Lucy_QParser_Expand_OFFSET;
    const lucy_QParser_expand_t method = *((lucy_QParser_expand_t*)method_address);
    return method((lucy_QueryParser*)self, query);
}

extern size_t Lucy_QParser_Expand_Leaf_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Expand_Leaf(const lucy_QueryParser *self, lucy_Query* query) {
    char *const method_address = *(char**)self + Lucy_QParser_Expand_Leaf_OFFSET;
    const lucy_QParser_expand_leaf_t method = *((lucy_QParser_expand_leaf_t*)method_address);
    return method((lucy_QueryParser*)self, query);
}

extern size_t Lucy_QParser_Prune_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Prune(const lucy_QueryParser *self, lucy_Query* query) {
    char *const method_address = *(char**)self + Lucy_QParser_Prune_OFFSET;
    const lucy_QParser_prune_t method = *((lucy_QParser_prune_t*)method_address);
    return method((lucy_QueryParser*)self, query);
}

extern size_t Lucy_QParser_Make_Term_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Make_Term_Query(const lucy_QueryParser *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_Term_Query_OFFSET;
    const lucy_QParser_make_term_query_t method = *((lucy_QParser_make_term_query_t*)method_address);
    return method((lucy_QueryParser*)self, field, term);
}

extern size_t Lucy_QParser_Make_Phrase_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Make_Phrase_Query(const lucy_QueryParser *self, const lucy_CharBuf* field, lucy_VArray* terms) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_Phrase_Query_OFFSET;
    const lucy_QParser_make_phrase_query_t method = *((lucy_QParser_make_phrase_query_t*)method_address);
    return method((lucy_QueryParser*)self, field, terms);
}

extern size_t Lucy_QParser_Make_OR_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Make_OR_Query(const lucy_QueryParser *self, lucy_VArray* children) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_OR_Query_OFFSET;
    const lucy_QParser_make_or_query_t method = *((lucy_QParser_make_or_query_t*)method_address);
    return method((lucy_QueryParser*)self, children);
}

extern size_t Lucy_QParser_Make_AND_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Make_AND_Query(const lucy_QueryParser *self, lucy_VArray* children) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_AND_Query_OFFSET;
    const lucy_QParser_make_and_query_t method = *((lucy_QParser_make_and_query_t*)method_address);
    return method((lucy_QueryParser*)self, children);
}

extern size_t Lucy_QParser_Make_NOT_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Make_NOT_Query(const lucy_QueryParser *self, lucy_Query* negated_query) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_NOT_Query_OFFSET;
    const lucy_QParser_make_not_query_t method = *((lucy_QParser_make_not_query_t*)method_address);
    return method((lucy_QueryParser*)self, negated_query);
}

extern size_t Lucy_QParser_Make_Req_Opt_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_QParser_Make_Req_Opt_Query(const lucy_QueryParser *self, lucy_Query* required_query, lucy_Query* optional_query) {
    char *const method_address = *(char**)self + Lucy_QParser_Make_Req_Opt_Query_OFFSET;
    const lucy_QParser_make_req_opt_query_t method = *((lucy_QParser_make_req_opt_query_t*)method_address);
    return method((lucy_QueryParser*)self, required_query, optional_query);
}

extern size_t Lucy_QParser_Get_Analyzer_OFFSET;
static CHY_INLINE lucy_Analyzer*
Lucy_QParser_Get_Analyzer(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_Analyzer_OFFSET;
    const lucy_QParser_get_analyzer_t method = *((lucy_QParser_get_analyzer_t*)method_address);
    return method((lucy_QueryParser*)self);
}

extern size_t Lucy_QParser_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_QParser_Get_Schema(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_Schema_OFFSET;
    const lucy_QParser_get_schema_t method = *((lucy_QParser_get_schema_t*)method_address);
    return method((lucy_QueryParser*)self);
}

extern size_t Lucy_QParser_Get_Default_BoolOp_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_QParser_Get_Default_BoolOp(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_Default_BoolOp_OFFSET;
    const lucy_QParser_get_default_boolop_t method = *((lucy_QParser_get_default_boolop_t*)method_address);
    return method((lucy_QueryParser*)self);
}

extern size_t Lucy_QParser_Get_Fields_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_QParser_Get_Fields(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Get_Fields_OFFSET;
    const lucy_QParser_get_fields_t method = *((lucy_QParser_get_fields_t*)method_address);
    return method((lucy_QueryParser*)self);
}

extern size_t Lucy_QParser_Heed_Colons_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_QParser_Heed_Colons(const lucy_QueryParser *self) {
    char *const method_address = *(char**)self + Lucy_QParser_Heed_Colons_OFFSET;
    const lucy_QParser_heed_colons_t method = *((lucy_QParser_heed_colons_t*)method_address);
    return method((lucy_QueryParser*)self);
}

extern size_t Lucy_QParser_Set_Heed_Colons_OFFSET;
static CHY_INLINE void
Lucy_QParser_Set_Heed_Colons(const lucy_QueryParser *self, chy_bool_t heed_colons) {
    char *const method_address = *(char**)self + Lucy_QParser_Set_Heed_Colons_OFFSET;
    const lucy_QParser_set_heed_colons_t method = *((lucy_QParser_set_heed_colons_t*)method_address);
    method((lucy_QueryParser*)self, heed_colons);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_QUERYPARSER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[39];
} LUCY_QUERYPARSER_VT;
extern struct LUCY_QUERYPARSER_VT LUCY_QUERYPARSER_vt;
#define LUCY_QUERYPARSER ((cfish_VTable*)&LUCY_QUERYPARSER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define QueryParser lucy_QueryParser
  #define QUERYPARSER LUCY_QUERYPARSER
  #define QParser_new lucy_QParser_new
  #define QParser_init lucy_QParser_init
  #define QParser_destroy_t lucy_QParser_destroy_t
  #define QParser_destroy lucy_QParser_destroy
  #define QParser_parse_t lucy_QParser_parse_t
  #define QParser_parse lucy_QParser_parse
  #define QParser_tree_t lucy_QParser_tree_t
  #define QParser_tree lucy_QParser_tree
  #define QParser_expand_t lucy_QParser_expand_t
  #define QParser_expand lucy_QParser_expand
  #define QParser_expand_leaf_t lucy_QParser_expand_leaf_t
  #define QParser_expand_leaf lucy_QParser_expand_leaf
  #define QParser_prune_t lucy_QParser_prune_t
  #define QParser_prune lucy_QParser_prune
  #define QParser_make_term_query_t lucy_QParser_make_term_query_t
  #define QParser_make_term_query lucy_QParser_make_term_query
  #define QParser_make_phrase_query_t lucy_QParser_make_phrase_query_t
  #define QParser_make_phrase_query lucy_QParser_make_phrase_query
  #define QParser_make_or_query_t lucy_QParser_make_or_query_t
  #define QParser_make_or_query lucy_QParser_make_or_query
  #define QParser_make_and_query_t lucy_QParser_make_and_query_t
  #define QParser_make_and_query lucy_QParser_make_and_query
  #define QParser_make_not_query_t lucy_QParser_make_not_query_t
  #define QParser_make_not_query lucy_QParser_make_not_query
  #define QParser_make_req_opt_query_t lucy_QParser_make_req_opt_query_t
  #define QParser_make_req_opt_query lucy_QParser_make_req_opt_query
  #define QParser_get_analyzer_t lucy_QParser_get_analyzer_t
  #define QParser_get_analyzer lucy_QParser_get_analyzer
  #define QParser_get_schema_t lucy_QParser_get_schema_t
  #define QParser_get_schema lucy_QParser_get_schema
  #define QParser_get_default_boolop_t lucy_QParser_get_default_boolop_t
  #define QParser_get_default_boolop lucy_QParser_get_default_boolop
  #define QParser_get_fields_t lucy_QParser_get_fields_t
  #define QParser_get_fields lucy_QParser_get_fields
  #define QParser_heed_colons_t lucy_QParser_heed_colons_t
  #define QParser_heed_colons lucy_QParser_heed_colons
  #define QParser_set_heed_colons_t lucy_QParser_set_heed_colons_t
  #define QParser_set_heed_colons lucy_QParser_set_heed_colons
  #define QParser_Make Lucy_QParser_Make
  #define QParser_Get_RefCount Lucy_QParser_Get_RefCount
  #define QParser_Inc_RefCount Lucy_QParser_Inc_RefCount
  #define QParser_Dec_RefCount Lucy_QParser_Dec_RefCount
  #define QParser_To_Host Lucy_QParser_To_Host
  #define QParser_Clone Lucy_QParser_Clone
  #define QParser_Destroy Lucy_QParser_Destroy
  #define QParser_Equals Lucy_QParser_Equals
  #define QParser_Compare_To Lucy_QParser_Compare_To
  #define QParser_Hash_Sum Lucy_QParser_Hash_Sum
  #define QParser_Get_VTable Lucy_QParser_Get_VTable
  #define QParser_Get_Class_Name Lucy_QParser_Get_Class_Name
  #define QParser_Is_A Lucy_QParser_Is_A
  #define QParser_To_String Lucy_QParser_To_String
  #define QParser_To_I64 Lucy_QParser_To_I64
  #define QParser_To_F64 Lucy_QParser_To_F64
  #define QParser_To_Bool Lucy_QParser_To_Bool
  #define QParser_Serialize Lucy_QParser_Serialize
  #define QParser_Deserialize Lucy_QParser_Deserialize
  #define QParser_Dump Lucy_QParser_Dump
  #define QParser_Load Lucy_QParser_Load
  #define QParser_Mimic Lucy_QParser_Mimic
  #define QParser_Parse Lucy_QParser_Parse
  #define QParser_Tree Lucy_QParser_Tree
  #define QParser_Expand Lucy_QParser_Expand
  #define QParser_Expand_Leaf Lucy_QParser_Expand_Leaf
  #define QParser_Prune Lucy_QParser_Prune
  #define QParser_Make_Term_Query Lucy_QParser_Make_Term_Query
  #define QParser_Make_Phrase_Query Lucy_QParser_Make_Phrase_Query
  #define QParser_Make_OR_Query Lucy_QParser_Make_OR_Query
  #define QParser_Make_AND_Query Lucy_QParser_Make_AND_Query
  #define QParser_Make_NOT_Query Lucy_QParser_Make_NOT_Query
  #define QParser_Make_Req_Opt_Query Lucy_QParser_Make_Req_Opt_Query
  #define QParser_Get_Analyzer Lucy_QParser_Get_Analyzer
  #define QParser_Get_Schema Lucy_QParser_Get_Schema
  #define QParser_Get_Default_BoolOp Lucy_QParser_Get_Default_BoolOp
  #define QParser_Get_Fields Lucy_QParser_Get_Fields
  #define QParser_Heed_Colons Lucy_QParser_Heed_Colons
  #define QParser_Set_Heed_Colons Lucy_QParser_Set_Heed_Colons
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PARSERCLAUSE
struct lucy_ParserClause {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t occur;
    lucy_Query* query;
};

#endif /* C_LUCY_PARSERCLAUSE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ParserClause*
lucy_ParserClause_new(lucy_Query* query, uint32_t occur);

lucy_ParserClause*
lucy_ParserClause_init(lucy_ParserClause* self, lucy_Query* query, uint32_t occur);

void
lucy_ParserClause_destroy(lucy_ParserClause* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ParserClause_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ParserClause_destroy_t)(lucy_ParserClause* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ParserClause_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserClause_Make(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ParserClause_Get_RefCount(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserClause_Inc_RefCount(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ParserClause_Dec_RefCount(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ParserClause_To_Host(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserClause_Clone(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ParserClause_Destroy(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Destroy_OFFSET;
    const lucy_ParserClause_destroy_t method = *((lucy_ParserClause_destroy_t*)method_address);
    method((lucy_ParserClause*)self);
}

extern size_t Lucy_ParserClause_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ParserClause_Equals(const lucy_ParserClause *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ParserClause_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ParserClause_Compare_To(const lucy_ParserClause *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ParserClause_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ParserClause_Hash_Sum(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ParserClause_Get_VTable(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ParserClause_Get_Class_Name(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ParserClause_Is_A(const lucy_ParserClause *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ParserClause_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ParserClause_To_String(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ParserClause_To_I64(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ParserClause_To_F64(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ParserClause_To_Bool(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ParserClause_Serialize(const lucy_ParserClause *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ParserClause_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserClause_Deserialize(const lucy_ParserClause *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ParserClause_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserClause_Dump(const lucy_ParserClause *self) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserClause_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserClause_Load(const lucy_ParserClause *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ParserClause_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ParserClause_Mimic(const lucy_ParserClause *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ParserClause_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PARSERCLAUSE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[22];
} LUCY_PARSERCLAUSE_VT;
extern struct LUCY_PARSERCLAUSE_VT LUCY_PARSERCLAUSE_vt;
#define LUCY_PARSERCLAUSE ((cfish_VTable*)&LUCY_PARSERCLAUSE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ParserClause lucy_ParserClause
  #define PARSERCLAUSE LUCY_PARSERCLAUSE
  #define ParserClause_new lucy_ParserClause_new
  #define ParserClause_init lucy_ParserClause_init
  #define ParserClause_destroy_t lucy_ParserClause_destroy_t
  #define ParserClause_destroy lucy_ParserClause_destroy
  #define ParserClause_Make Lucy_ParserClause_Make
  #define ParserClause_Get_RefCount Lucy_ParserClause_Get_RefCount
  #define ParserClause_Inc_RefCount Lucy_ParserClause_Inc_RefCount
  #define ParserClause_Dec_RefCount Lucy_ParserClause_Dec_RefCount
  #define ParserClause_To_Host Lucy_ParserClause_To_Host
  #define ParserClause_Clone Lucy_ParserClause_Clone
  #define ParserClause_Destroy Lucy_ParserClause_Destroy
  #define ParserClause_Equals Lucy_ParserClause_Equals
  #define ParserClause_Compare_To Lucy_ParserClause_Compare_To
  #define ParserClause_Hash_Sum Lucy_ParserClause_Hash_Sum
  #define ParserClause_Get_VTable Lucy_ParserClause_Get_VTable
  #define ParserClause_Get_Class_Name Lucy_ParserClause_Get_Class_Name
  #define ParserClause_Is_A Lucy_ParserClause_Is_A
  #define ParserClause_To_String Lucy_ParserClause_To_String
  #define ParserClause_To_I64 Lucy_ParserClause_To_I64
  #define ParserClause_To_F64 Lucy_ParserClause_To_F64
  #define ParserClause_To_Bool Lucy_ParserClause_To_Bool
  #define ParserClause_Serialize Lucy_ParserClause_Serialize
  #define ParserClause_Deserialize Lucy_ParserClause_Deserialize
  #define ParserClause_Dump Lucy_ParserClause_Dump
  #define ParserClause_Load Lucy_ParserClause_Load
  #define ParserClause_Mimic Lucy_ParserClause_Mimic
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PARSERTOKEN
struct lucy_ParserToken {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t type;
    lucy_CharBuf* text;
};

#endif /* C_LUCY_PARSERTOKEN */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ParserToken*
lucy_ParserToken_new(uint32_t type, const char* text, size_t len);

lucy_ParserToken*
lucy_ParserToken_init(lucy_ParserToken* self, uint32_t type, const char* text, size_t len);

void
lucy_ParserToken_destroy(lucy_ParserToken* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ParserToken_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ParserToken_destroy_t)(lucy_ParserToken* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ParserToken_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserToken_Make(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ParserToken_Get_RefCount(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserToken_Inc_RefCount(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ParserToken_Dec_RefCount(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ParserToken_To_Host(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserToken_Clone(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ParserToken_Destroy(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Destroy_OFFSET;
    const lucy_ParserToken_destroy_t method = *((lucy_ParserToken_destroy_t*)method_address);
    method((lucy_ParserToken*)self);
}

extern size_t Lucy_ParserToken_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ParserToken_Equals(const lucy_ParserToken *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ParserToken_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ParserToken_Compare_To(const lucy_ParserToken *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ParserToken_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ParserToken_Hash_Sum(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ParserToken_Get_VTable(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ParserToken_Get_Class_Name(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ParserToken_Is_A(const lucy_ParserToken *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ParserToken_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ParserToken_To_String(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ParserToken_To_I64(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ParserToken_To_F64(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ParserToken_To_Bool(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ParserToken_Serialize(const lucy_ParserToken *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ParserToken_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserToken_Deserialize(const lucy_ParserToken *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ParserToken_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserToken_Dump(const lucy_ParserToken *self) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ParserToken_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ParserToken_Load(const lucy_ParserToken *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ParserToken_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ParserToken_Mimic(const lucy_ParserToken *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ParserToken_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PARSERTOKEN_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[22];
} LUCY_PARSERTOKEN_VT;
extern struct LUCY_PARSERTOKEN_VT LUCY_PARSERTOKEN_vt;
#define LUCY_PARSERTOKEN ((cfish_VTable*)&LUCY_PARSERTOKEN_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ParserToken lucy_ParserToken
  #define PARSERTOKEN LUCY_PARSERTOKEN
  #define ParserToken_new lucy_ParserToken_new
  #define ParserToken_init lucy_ParserToken_init
  #define ParserToken_destroy_t lucy_ParserToken_destroy_t
  #define ParserToken_destroy lucy_ParserToken_destroy
  #define ParserToken_Make Lucy_ParserToken_Make
  #define ParserToken_Get_RefCount Lucy_ParserToken_Get_RefCount
  #define ParserToken_Inc_RefCount Lucy_ParserToken_Inc_RefCount
  #define ParserToken_Dec_RefCount Lucy_ParserToken_Dec_RefCount
  #define ParserToken_To_Host Lucy_ParserToken_To_Host
  #define ParserToken_Clone Lucy_ParserToken_Clone
  #define ParserToken_Destroy Lucy_ParserToken_Destroy
  #define ParserToken_Equals Lucy_ParserToken_Equals
  #define ParserToken_Compare_To Lucy_ParserToken_Compare_To
  #define ParserToken_Hash_Sum Lucy_ParserToken_Hash_Sum
  #define ParserToken_Get_VTable Lucy_ParserToken_Get_VTable
  #define ParserToken_Get_Class_Name Lucy_ParserToken_Get_Class_Name
  #define ParserToken_Is_A Lucy_ParserToken_Is_A
  #define ParserToken_To_String Lucy_ParserToken_To_String
  #define ParserToken_To_I64 Lucy_ParserToken_To_I64
  #define ParserToken_To_F64 Lucy_ParserToken_To_F64
  #define ParserToken_To_Bool Lucy_ParserToken_To_Bool
  #define ParserToken_Serialize Lucy_ParserToken_Serialize
  #define ParserToken_Deserialize Lucy_ParserToken_Deserialize
  #define ParserToken_Dump Lucy_ParserToken_Dump
  #define ParserToken_Load Lucy_ParserToken_Load
  #define ParserToken_Mimic Lucy_ParserToken_Mimic
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_QUERYPARSER */




