/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_RANGEMATCHER
#define H_LUCY_SEARCH_RANGEMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RANGEMATCHER
struct lucy_RangeMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    int32_t doc_max;
    int32_t lower_bound;
    int32_t upper_bound;
    lucy_SortCache* sort_cache;
};

#endif /* C_LUCY_RANGEMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RangeMatcher*
lucy_RangeMatcher_new(int32_t lower_bound, int32_t upper_bound, lucy_SortCache* sort_cache, int32_t doc_max);

lucy_RangeMatcher*
lucy_RangeMatcher_init(lucy_RangeMatcher* self, int32_t lower_bound, int32_t upper_bound, lucy_SortCache* sort_cache, int32_t doc_max);

void
lucy_RangeMatcher_destroy(lucy_RangeMatcher* self);

int32_t
lucy_RangeMatcher_next(lucy_RangeMatcher* self);

int32_t
lucy_RangeMatcher_advance(lucy_RangeMatcher* self, int32_t target);

int32_t
lucy_RangeMatcher_get_doc_id(lucy_RangeMatcher* self);

float
lucy_RangeMatcher_score(lucy_RangeMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RangeMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_RangeMatcher_next_CALLBACK;
extern cfish_Callback lucy_RangeMatcher_advance_CALLBACK;
extern cfish_Callback lucy_RangeMatcher_get_doc_id_CALLBACK;
extern cfish_Callback lucy_RangeMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RangeMatcher_destroy_t)(lucy_RangeMatcher* self);

typedef int32_t
(*lucy_RangeMatcher_next_t)(lucy_RangeMatcher* self);

typedef int32_t
(*lucy_RangeMatcher_advance_t)(lucy_RangeMatcher* self, int32_t target);

typedef int32_t
(*lucy_RangeMatcher_get_doc_id_t)(lucy_RangeMatcher* self);

typedef float
(*lucy_RangeMatcher_score_t)(lucy_RangeMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RangeMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeMatcher_Make(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RangeMatcher_Get_RefCount(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeMatcher_Inc_RefCount(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RangeMatcher_Dec_RefCount(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RangeMatcher_To_Host(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeMatcher_Clone(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RangeMatcher_Destroy(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Destroy_OFFSET;
    const lucy_RangeMatcher_destroy_t method = *((lucy_RangeMatcher_destroy_t*)method_address);
    method((lucy_RangeMatcher*)self);
}

extern size_t Lucy_RangeMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeMatcher_Equals(const lucy_RangeMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeMatcher_Compare_To(const lucy_RangeMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeMatcher_Hash_Sum(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RangeMatcher_Get_VTable(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RangeMatcher_Get_Class_Name(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeMatcher_Is_A(const lucy_RangeMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RangeMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RangeMatcher_To_String(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RangeMatcher_To_I64(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RangeMatcher_To_F64(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeMatcher_To_Bool(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RangeMatcher_Serialize(const lucy_RangeMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RangeMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeMatcher_Deserialize(const lucy_RangeMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RangeMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeMatcher_Dump(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeMatcher_Load(const lucy_RangeMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RangeMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RangeMatcher_Mimic(const lucy_RangeMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeMatcher_Next(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Next_OFFSET;
    const lucy_RangeMatcher_next_t method = *((lucy_RangeMatcher_next_t*)method_address);
    return method((lucy_RangeMatcher*)self);
}

extern size_t Lucy_RangeMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeMatcher_Advance(const lucy_RangeMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Advance_OFFSET;
    const lucy_RangeMatcher_advance_t method = *((lucy_RangeMatcher_advance_t*)method_address);
    return method((lucy_RangeMatcher*)self, target);
}

extern size_t Lucy_RangeMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeMatcher_Get_Doc_ID(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Get_Doc_ID_OFFSET;
    const lucy_RangeMatcher_get_doc_id_t method = *((lucy_RangeMatcher_get_doc_id_t*)method_address);
    return method((lucy_RangeMatcher*)self);
}

extern size_t Lucy_RangeMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_RangeMatcher_Score(const lucy_RangeMatcher *self) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Score_OFFSET;
    const lucy_RangeMatcher_score_t method = *((lucy_RangeMatcher_score_t*)method_address);
    return method((lucy_RangeMatcher*)self);
}

extern size_t Lucy_RangeMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_RangeMatcher_Collect(const lucy_RangeMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_RangeMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RANGEMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_RANGEMATCHER_VT;
extern struct LUCY_RANGEMATCHER_VT LUCY_RANGEMATCHER_vt;
#define LUCY_RANGEMATCHER ((cfish_VTable*)&LUCY_RANGEMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RangeMatcher lucy_RangeMatcher
  #define RANGEMATCHER LUCY_RANGEMATCHER
  #define RangeMatcher_new lucy_RangeMatcher_new
  #define RangeMatcher_init lucy_RangeMatcher_init
  #define RangeMatcher_destroy_t lucy_RangeMatcher_destroy_t
  #define RangeMatcher_destroy lucy_RangeMatcher_destroy
  #define RangeMatcher_next_t lucy_RangeMatcher_next_t
  #define RangeMatcher_next lucy_RangeMatcher_next
  #define RangeMatcher_advance_t lucy_RangeMatcher_advance_t
  #define RangeMatcher_advance lucy_RangeMatcher_advance
  #define RangeMatcher_get_doc_id_t lucy_RangeMatcher_get_doc_id_t
  #define RangeMatcher_get_doc_id lucy_RangeMatcher_get_doc_id
  #define RangeMatcher_score_t lucy_RangeMatcher_score_t
  #define RangeMatcher_score lucy_RangeMatcher_score
  #define RangeMatcher_Make Lucy_RangeMatcher_Make
  #define RangeMatcher_Get_RefCount Lucy_RangeMatcher_Get_RefCount
  #define RangeMatcher_Inc_RefCount Lucy_RangeMatcher_Inc_RefCount
  #define RangeMatcher_Dec_RefCount Lucy_RangeMatcher_Dec_RefCount
  #define RangeMatcher_To_Host Lucy_RangeMatcher_To_Host
  #define RangeMatcher_Clone Lucy_RangeMatcher_Clone
  #define RangeMatcher_Destroy Lucy_RangeMatcher_Destroy
  #define RangeMatcher_Equals Lucy_RangeMatcher_Equals
  #define RangeMatcher_Compare_To Lucy_RangeMatcher_Compare_To
  #define RangeMatcher_Hash_Sum Lucy_RangeMatcher_Hash_Sum
  #define RangeMatcher_Get_VTable Lucy_RangeMatcher_Get_VTable
  #define RangeMatcher_Get_Class_Name Lucy_RangeMatcher_Get_Class_Name
  #define RangeMatcher_Is_A Lucy_RangeMatcher_Is_A
  #define RangeMatcher_To_String Lucy_RangeMatcher_To_String
  #define RangeMatcher_To_I64 Lucy_RangeMatcher_To_I64
  #define RangeMatcher_To_F64 Lucy_RangeMatcher_To_F64
  #define RangeMatcher_To_Bool Lucy_RangeMatcher_To_Bool
  #define RangeMatcher_Serialize Lucy_RangeMatcher_Serialize
  #define RangeMatcher_Deserialize Lucy_RangeMatcher_Deserialize
  #define RangeMatcher_Dump Lucy_RangeMatcher_Dump
  #define RangeMatcher_Load Lucy_RangeMatcher_Load
  #define RangeMatcher_Mimic Lucy_RangeMatcher_Mimic
  #define RangeMatcher_Next Lucy_RangeMatcher_Next
  #define RangeMatcher_Advance Lucy_RangeMatcher_Advance
  #define RangeMatcher_Get_Doc_ID Lucy_RangeMatcher_Get_Doc_ID
  #define RangeMatcher_Score Lucy_RangeMatcher_Score
  #define RangeMatcher_Collect Lucy_RangeMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_RANGEMATCHER */




