/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_RANGEQUERY
#define H_LUCY_SEARCH_RANGEQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RANGEQUERY
struct lucy_RangeQuery {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_CharBuf* field;
    lucy_Obj* lower_term;
    lucy_Obj* upper_term;
    chy_bool_t include_lower;
    chy_bool_t include_upper;
};

#endif /* C_LUCY_RANGEQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RangeQuery*
lucy_RangeQuery_new(const lucy_CharBuf* field, lucy_Obj* lower_term, lucy_Obj* upper_term, chy_bool_t include_lower, chy_bool_t include_upper);

lucy_RangeQuery*
lucy_RangeQuery_init(lucy_RangeQuery* self, const lucy_CharBuf* field, lucy_Obj* lower_term, lucy_Obj* upper_term, chy_bool_t include_lower, chy_bool_t include_upper);

void
lucy_RangeQuery_destroy(lucy_RangeQuery* self);

chy_bool_t
lucy_RangeQuery_equals(lucy_RangeQuery* self, lucy_Obj* other);

lucy_CharBuf*
lucy_RangeQuery_to_string(lucy_RangeQuery* self);

void
lucy_RangeQuery_serialize(lucy_RangeQuery* self, lucy_OutStream* outstream);

lucy_RangeQuery*
lucy_RangeQuery_deserialize(lucy_RangeQuery* self, lucy_InStream* instream);

lucy_Obj*
lucy_RangeQuery_dump(lucy_RangeQuery* self);

lucy_Obj*
lucy_RangeQuery_load(lucy_RangeQuery* self, lucy_Obj* dump);

lucy_RangeCompiler*
lucy_RangeQuery_make_compiler(lucy_RangeQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RangeQuery_destroy_CALLBACK;
extern cfish_Callback lucy_RangeQuery_equals_CALLBACK;
extern cfish_Callback lucy_RangeQuery_to_string_CALLBACK;
extern cfish_Callback lucy_RangeQuery_serialize_CALLBACK;
extern cfish_Callback lucy_RangeQuery_deserialize_CALLBACK;
extern cfish_Callback lucy_RangeQuery_dump_CALLBACK;
extern cfish_Callback lucy_RangeQuery_load_CALLBACK;
extern cfish_Callback lucy_RangeQuery_make_compiler_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RangeQuery_destroy_t)(lucy_RangeQuery* self);

typedef chy_bool_t
(*lucy_RangeQuery_equals_t)(lucy_RangeQuery* self, lucy_Obj* other);

typedef lucy_CharBuf*
(*lucy_RangeQuery_to_string_t)(lucy_RangeQuery* self);

typedef void
(*lucy_RangeQuery_serialize_t)(lucy_RangeQuery* self, lucy_OutStream* outstream);

typedef lucy_RangeQuery*
(*lucy_RangeQuery_deserialize_t)(lucy_RangeQuery* self, lucy_InStream* instream);

typedef lucy_Obj*
(*lucy_RangeQuery_dump_t)(lucy_RangeQuery* self);

typedef lucy_Obj*
(*lucy_RangeQuery_load_t)(lucy_RangeQuery* self, lucy_Obj* dump);

typedef lucy_RangeCompiler*
(*lucy_RangeQuery_make_compiler_t)(lucy_RangeQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RangeQuery_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeQuery_Make(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RangeQuery_Get_RefCount(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeQuery_Inc_RefCount(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RangeQuery_Dec_RefCount(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RangeQuery_To_Host(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeQuery_Clone(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RangeQuery_Destroy(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Destroy_OFFSET;
    const lucy_RangeQuery_destroy_t method = *((lucy_RangeQuery_destroy_t*)method_address);
    method((lucy_RangeQuery*)self);
}

extern size_t Lucy_RangeQuery_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeQuery_Equals(const lucy_RangeQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Equals_OFFSET;
    const lucy_RangeQuery_equals_t method = *((lucy_RangeQuery_equals_t*)method_address);
    return method((lucy_RangeQuery*)self, other);
}

extern size_t Lucy_RangeQuery_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeQuery_Compare_To(const lucy_RangeQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeQuery_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeQuery_Hash_Sum(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RangeQuery_Get_VTable(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RangeQuery_Get_Class_Name(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeQuery_Is_A(const lucy_RangeQuery *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RangeQuery_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RangeQuery_To_String(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_To_String_OFFSET;
    const lucy_RangeQuery_to_string_t method = *((lucy_RangeQuery_to_string_t*)method_address);
    return method((lucy_RangeQuery*)self);
}

extern size_t Lucy_RangeQuery_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RangeQuery_To_I64(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RangeQuery_To_F64(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeQuery_To_Bool(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeQuery_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RangeQuery_Serialize(const lucy_RangeQuery *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Serialize_OFFSET;
    const lucy_RangeQuery_serialize_t method = *((lucy_RangeQuery_serialize_t*)method_address);
    method((lucy_RangeQuery*)self, outstream);
}

extern size_t Lucy_RangeQuery_Deserialize_OFFSET;
static CHY_INLINE lucy_RangeQuery*
Lucy_RangeQuery_Deserialize(const lucy_RangeQuery *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Deserialize_OFFSET;
    const lucy_RangeQuery_deserialize_t method = *((lucy_RangeQuery_deserialize_t*)method_address);
    return method((lucy_RangeQuery*)self, instream);
}

extern size_t Lucy_RangeQuery_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeQuery_Dump(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Dump_OFFSET;
    const lucy_RangeQuery_dump_t method = *((lucy_RangeQuery_dump_t*)method_address);
    return method((lucy_RangeQuery*)self);
}

extern size_t Lucy_RangeQuery_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeQuery_Load(const lucy_RangeQuery *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Load_OFFSET;
    const lucy_RangeQuery_load_t method = *((lucy_RangeQuery_load_t*)method_address);
    return method((lucy_RangeQuery*)self, dump);
}

extern size_t Lucy_RangeQuery_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RangeQuery_Mimic(const lucy_RangeQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeQuery_Make_Compiler_OFFSET;
static CHY_INLINE lucy_RangeCompiler*
Lucy_RangeQuery_Make_Compiler(const lucy_RangeQuery *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Make_Compiler_OFFSET;
    const lucy_RangeQuery_make_compiler_t method = *((lucy_RangeQuery_make_compiler_t*)method_address);
    return method((lucy_RangeQuery*)self, searcher, boost, subordinate);
}

extern size_t Lucy_RangeQuery_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_RangeQuery_Set_Boost(const lucy_RangeQuery *self, float boost) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_RangeQuery_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_RangeQuery_Get_Boost(const lucy_RangeQuery *self) {
    char *const method_address = *(char**)self + Lucy_RangeQuery_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RANGEQUERY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_RANGEQUERY_VT;
extern struct LUCY_RANGEQUERY_VT LUCY_RANGEQUERY_vt;
#define LUCY_RANGEQUERY ((cfish_VTable*)&LUCY_RANGEQUERY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RangeQuery lucy_RangeQuery
  #define RANGEQUERY LUCY_RANGEQUERY
  #define RangeQuery_new lucy_RangeQuery_new
  #define RangeQuery_init lucy_RangeQuery_init
  #define RangeQuery_destroy_t lucy_RangeQuery_destroy_t
  #define RangeQuery_destroy lucy_RangeQuery_destroy
  #define RangeQuery_equals_t lucy_RangeQuery_equals_t
  #define RangeQuery_equals lucy_RangeQuery_equals
  #define RangeQuery_to_string_t lucy_RangeQuery_to_string_t
  #define RangeQuery_to_string lucy_RangeQuery_to_string
  #define RangeQuery_serialize_t lucy_RangeQuery_serialize_t
  #define RangeQuery_serialize lucy_RangeQuery_serialize
  #define RangeQuery_deserialize_t lucy_RangeQuery_deserialize_t
  #define RangeQuery_deserialize lucy_RangeQuery_deserialize
  #define RangeQuery_dump_t lucy_RangeQuery_dump_t
  #define RangeQuery_dump lucy_RangeQuery_dump
  #define RangeQuery_load_t lucy_RangeQuery_load_t
  #define RangeQuery_load lucy_RangeQuery_load
  #define RangeQuery_make_compiler_t lucy_RangeQuery_make_compiler_t
  #define RangeQuery_make_compiler lucy_RangeQuery_make_compiler
  #define RangeQuery_Make Lucy_RangeQuery_Make
  #define RangeQuery_Get_RefCount Lucy_RangeQuery_Get_RefCount
  #define RangeQuery_Inc_RefCount Lucy_RangeQuery_Inc_RefCount
  #define RangeQuery_Dec_RefCount Lucy_RangeQuery_Dec_RefCount
  #define RangeQuery_To_Host Lucy_RangeQuery_To_Host
  #define RangeQuery_Clone Lucy_RangeQuery_Clone
  #define RangeQuery_Destroy Lucy_RangeQuery_Destroy
  #define RangeQuery_Equals Lucy_RangeQuery_Equals
  #define RangeQuery_Compare_To Lucy_RangeQuery_Compare_To
  #define RangeQuery_Hash_Sum Lucy_RangeQuery_Hash_Sum
  #define RangeQuery_Get_VTable Lucy_RangeQuery_Get_VTable
  #define RangeQuery_Get_Class_Name Lucy_RangeQuery_Get_Class_Name
  #define RangeQuery_Is_A Lucy_RangeQuery_Is_A
  #define RangeQuery_To_String Lucy_RangeQuery_To_String
  #define RangeQuery_To_I64 Lucy_RangeQuery_To_I64
  #define RangeQuery_To_F64 Lucy_RangeQuery_To_F64
  #define RangeQuery_To_Bool Lucy_RangeQuery_To_Bool
  #define RangeQuery_Serialize Lucy_RangeQuery_Serialize
  #define RangeQuery_Deserialize Lucy_RangeQuery_Deserialize
  #define RangeQuery_Dump Lucy_RangeQuery_Dump
  #define RangeQuery_Load Lucy_RangeQuery_Load
  #define RangeQuery_Mimic Lucy_RangeQuery_Mimic
  #define RangeQuery_Make_Compiler Lucy_RangeQuery_Make_Compiler
  #define RangeQuery_Set_Boost Lucy_RangeQuery_Set_Boost
  #define RangeQuery_Get_Boost Lucy_RangeQuery_Get_Boost
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Compiler.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RANGECOMPILER
struct lucy_RangeCompiler {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
};

#endif /* C_LUCY_RANGECOMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RangeCompiler*
lucy_RangeCompiler_new(lucy_RangeQuery* parent, lucy_Searcher* searcher, float boost);

lucy_RangeCompiler*
lucy_RangeCompiler_init(lucy_RangeCompiler* self, lucy_RangeQuery* parent, lucy_Searcher* searcher, float boost);

lucy_RangeCompiler*
lucy_RangeCompiler_deserialize(lucy_RangeCompiler* self, lucy_InStream* instream);

lucy_Matcher*
lucy_RangeCompiler_make_matcher(lucy_RangeCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RangeCompiler_deserialize_CALLBACK;
extern cfish_Callback lucy_RangeCompiler_make_matcher_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_RangeCompiler*
(*lucy_RangeCompiler_deserialize_t)(lucy_RangeCompiler* self, lucy_InStream* instream);

typedef lucy_Matcher*
(*lucy_RangeCompiler_make_matcher_t)(lucy_RangeCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RangeCompiler_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeCompiler_Make(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RangeCompiler_Get_RefCount(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeCompiler_Inc_RefCount(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RangeCompiler_Dec_RefCount(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RangeCompiler_To_Host(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeCompiler_Clone(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RangeCompiler_Destroy(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Destroy_OFFSET;
    const lucy_Compiler_destroy_t method = *((lucy_Compiler_destroy_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeCompiler_Equals(const lucy_RangeCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Equals_OFFSET;
    const lucy_Compiler_equals_t method = *((lucy_Compiler_equals_t*)method_address);
    return method((lucy_Compiler*)self, other);
}

extern size_t Lucy_RangeCompiler_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeCompiler_Compare_To(const lucy_RangeCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeCompiler_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RangeCompiler_Hash_Sum(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RangeCompiler_Get_VTable(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RangeCompiler_Get_Class_Name(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeCompiler_Is_A(const lucy_RangeCompiler *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RangeCompiler_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RangeCompiler_To_String(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_To_String_OFFSET;
    const lucy_Compiler_to_string_t method = *((lucy_Compiler_to_string_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RangeCompiler_To_I64(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RangeCompiler_To_F64(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RangeCompiler_To_Bool(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RangeCompiler_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RangeCompiler_Serialize(const lucy_RangeCompiler *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Serialize_OFFSET;
    const lucy_Compiler_serialize_t method = *((lucy_Compiler_serialize_t*)method_address);
    method((lucy_Compiler*)self, outstream);
}

extern size_t Lucy_RangeCompiler_Deserialize_OFFSET;
static CHY_INLINE lucy_RangeCompiler*
Lucy_RangeCompiler_Deserialize(const lucy_RangeCompiler *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Deserialize_OFFSET;
    const lucy_RangeCompiler_deserialize_t method = *((lucy_RangeCompiler_deserialize_t*)method_address);
    return method((lucy_RangeCompiler*)self, instream);
}

extern size_t Lucy_RangeCompiler_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeCompiler_Dump(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Dump_OFFSET;
    const lucy_Query_dump_t method = *((lucy_Query_dump_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_RangeCompiler_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RangeCompiler_Load(const lucy_RangeCompiler *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Load_OFFSET;
    const lucy_Query_load_t method = *((lucy_Query_load_t*)method_address);
    return method((lucy_Query*)self, dump);
}

extern size_t Lucy_RangeCompiler_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RangeCompiler_Mimic(const lucy_RangeCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RangeCompiler_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_RangeCompiler_Make_Compiler(const lucy_RangeCompiler *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Make_Compiler_OFFSET;
    const lucy_Query_make_compiler_t method = *((lucy_Query_make_compiler_t*)method_address);
    return method((lucy_Query*)self, searcher, boost, subordinate);
}

extern size_t Lucy_RangeCompiler_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_RangeCompiler_Set_Boost(const lucy_RangeCompiler *self, float boost) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_RangeCompiler_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_RangeCompiler_Get_Boost(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_RangeCompiler_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_RangeCompiler_Make_Matcher(const lucy_RangeCompiler *self, lucy_SegReader* reader, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Make_Matcher_OFFSET;
    const lucy_RangeCompiler_make_matcher_t method = *((lucy_RangeCompiler_make_matcher_t*)method_address);
    return method((lucy_RangeCompiler*)self, reader, need_score);
}

extern size_t Lucy_RangeCompiler_Get_Weight_OFFSET;
static CHY_INLINE float
Lucy_RangeCompiler_Get_Weight(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_Weight_OFFSET;
    const lucy_Compiler_get_weight_t method = *((lucy_Compiler_get_weight_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_RangeCompiler_Get_Similarity(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_Similarity_OFFSET;
    const lucy_Compiler_get_similarity_t method = *((lucy_Compiler_get_similarity_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_Get_Parent_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_RangeCompiler_Get_Parent(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Get_Parent_OFFSET;
    const lucy_Compiler_get_parent_t method = *((lucy_Compiler_get_parent_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_Sum_Of_Squared_Weights_OFFSET;
static CHY_INLINE float
Lucy_RangeCompiler_Sum_Of_Squared_Weights(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Sum_Of_Squared_Weights_OFFSET;
    const lucy_Compiler_sum_of_squared_weights_t method = *((lucy_Compiler_sum_of_squared_weights_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_Apply_Norm_Factor_OFFSET;
static CHY_INLINE void
Lucy_RangeCompiler_Apply_Norm_Factor(const lucy_RangeCompiler *self, float factor) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Apply_Norm_Factor_OFFSET;
    const lucy_Compiler_apply_norm_factor_t method = *((lucy_Compiler_apply_norm_factor_t*)method_address);
    method((lucy_Compiler*)self, factor);
}

extern size_t Lucy_RangeCompiler_Normalize_OFFSET;
static CHY_INLINE void
Lucy_RangeCompiler_Normalize(const lucy_RangeCompiler *self) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Normalize_OFFSET;
    const lucy_Compiler_normalize_t method = *((lucy_Compiler_normalize_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_RangeCompiler_Highlight_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_RangeCompiler_Highlight_Spans(const lucy_RangeCompiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_RangeCompiler_Highlight_Spans_OFFSET;
    const lucy_Compiler_highlight_spans_t method = *((lucy_Compiler_highlight_spans_t*)method_address);
    return method((lucy_Compiler*)self, searcher, doc_vec, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RANGECOMPILER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_RANGECOMPILER_VT;
extern struct LUCY_RANGECOMPILER_VT LUCY_RANGECOMPILER_vt;
#define LUCY_RANGECOMPILER ((cfish_VTable*)&LUCY_RANGECOMPILER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RangeCompiler lucy_RangeCompiler
  #define RANGECOMPILER LUCY_RANGECOMPILER
  #define RangeCompiler_new lucy_RangeCompiler_new
  #define RangeCompiler_init lucy_RangeCompiler_init
  #define RangeCompiler_deserialize_t lucy_RangeCompiler_deserialize_t
  #define RangeCompiler_deserialize lucy_RangeCompiler_deserialize
  #define RangeCompiler_make_matcher_t lucy_RangeCompiler_make_matcher_t
  #define RangeCompiler_make_matcher lucy_RangeCompiler_make_matcher
  #define RangeCompiler_Make Lucy_RangeCompiler_Make
  #define RangeCompiler_Get_RefCount Lucy_RangeCompiler_Get_RefCount
  #define RangeCompiler_Inc_RefCount Lucy_RangeCompiler_Inc_RefCount
  #define RangeCompiler_Dec_RefCount Lucy_RangeCompiler_Dec_RefCount
  #define RangeCompiler_To_Host Lucy_RangeCompiler_To_Host
  #define RangeCompiler_Clone Lucy_RangeCompiler_Clone
  #define RangeCompiler_Destroy Lucy_RangeCompiler_Destroy
  #define RangeCompiler_Equals Lucy_RangeCompiler_Equals
  #define RangeCompiler_Compare_To Lucy_RangeCompiler_Compare_To
  #define RangeCompiler_Hash_Sum Lucy_RangeCompiler_Hash_Sum
  #define RangeCompiler_Get_VTable Lucy_RangeCompiler_Get_VTable
  #define RangeCompiler_Get_Class_Name Lucy_RangeCompiler_Get_Class_Name
  #define RangeCompiler_Is_A Lucy_RangeCompiler_Is_A
  #define RangeCompiler_To_String Lucy_RangeCompiler_To_String
  #define RangeCompiler_To_I64 Lucy_RangeCompiler_To_I64
  #define RangeCompiler_To_F64 Lucy_RangeCompiler_To_F64
  #define RangeCompiler_To_Bool Lucy_RangeCompiler_To_Bool
  #define RangeCompiler_Serialize Lucy_RangeCompiler_Serialize
  #define RangeCompiler_Deserialize Lucy_RangeCompiler_Deserialize
  #define RangeCompiler_Dump Lucy_RangeCompiler_Dump
  #define RangeCompiler_Load Lucy_RangeCompiler_Load
  #define RangeCompiler_Mimic Lucy_RangeCompiler_Mimic
  #define RangeCompiler_Make_Compiler Lucy_RangeCompiler_Make_Compiler
  #define RangeCompiler_Set_Boost Lucy_RangeCompiler_Set_Boost
  #define RangeCompiler_Get_Boost Lucy_RangeCompiler_Get_Boost
  #define RangeCompiler_Make_Matcher Lucy_RangeCompiler_Make_Matcher
  #define RangeCompiler_Get_Weight Lucy_RangeCompiler_Get_Weight
  #define RangeCompiler_Get_Similarity Lucy_RangeCompiler_Get_Similarity
  #define RangeCompiler_Get_Parent Lucy_RangeCompiler_Get_Parent
  #define RangeCompiler_Sum_Of_Squared_Weights Lucy_RangeCompiler_Sum_Of_Squared_Weights
  #define RangeCompiler_Apply_Norm_Factor Lucy_RangeCompiler_Apply_Norm_Factor
  #define RangeCompiler_Normalize Lucy_RangeCompiler_Normalize
  #define RangeCompiler_Highlight_Spans Lucy_RangeCompiler_Highlight_Spans
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_RANGEQUERY */




