/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_REQUIREDOPTIONALMATCHER
#define H_LUCY_SEARCH_REQUIREDOPTIONALMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/PolyMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_REQUIREDOPTIONALMATCHER
struct lucy_RequiredOptionalMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_VArray* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
    lucy_Matcher* req_matcher;
    lucy_Matcher* opt_matcher;
    chy_bool_t opt_matcher_first_time;
};

#endif /* C_LUCY_REQUIREDOPTIONALMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RequiredOptionalMatcher*
lucy_ReqOptMatcher_new(lucy_Similarity* similarity, lucy_Matcher* required_matcher, lucy_Matcher* optional_matcher);

lucy_RequiredOptionalMatcher*
lucy_ReqOptMatcher_init(lucy_RequiredOptionalMatcher* self, lucy_Similarity* similarity, lucy_Matcher* required_matcher, lucy_Matcher* optional_matcher);

void
lucy_ReqOptMatcher_destroy(lucy_RequiredOptionalMatcher* self);

int32_t
lucy_ReqOptMatcher_next(lucy_RequiredOptionalMatcher* self);

int32_t
lucy_ReqOptMatcher_advance(lucy_RequiredOptionalMatcher* self, int32_t target);

int32_t
lucy_ReqOptMatcher_get_doc_id(lucy_RequiredOptionalMatcher* self);

float
lucy_ReqOptMatcher_score(lucy_RequiredOptionalMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ReqOptMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_ReqOptMatcher_next_CALLBACK;
extern cfish_Callback lucy_ReqOptMatcher_advance_CALLBACK;
extern cfish_Callback lucy_ReqOptMatcher_get_doc_id_CALLBACK;
extern cfish_Callback lucy_ReqOptMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ReqOptMatcher_destroy_t)(lucy_RequiredOptionalMatcher* self);

typedef int32_t
(*lucy_ReqOptMatcher_next_t)(lucy_RequiredOptionalMatcher* self);

typedef int32_t
(*lucy_ReqOptMatcher_advance_t)(lucy_RequiredOptionalMatcher* self, int32_t target);

typedef int32_t
(*lucy_ReqOptMatcher_get_doc_id_t)(lucy_RequiredOptionalMatcher* self);

typedef float
(*lucy_ReqOptMatcher_score_t)(lucy_RequiredOptionalMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ReqOptMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ReqOptMatcher_Make(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ReqOptMatcher_Get_RefCount(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ReqOptMatcher_Inc_RefCount(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ReqOptMatcher_Dec_RefCount(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ReqOptMatcher_To_Host(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ReqOptMatcher_Clone(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ReqOptMatcher_Destroy(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Destroy_OFFSET;
    const lucy_ReqOptMatcher_destroy_t method = *((lucy_ReqOptMatcher_destroy_t*)method_address);
    method((lucy_RequiredOptionalMatcher*)self);
}

extern size_t Lucy_ReqOptMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ReqOptMatcher_Equals(const lucy_RequiredOptionalMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ReqOptMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ReqOptMatcher_Compare_To(const lucy_RequiredOptionalMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ReqOptMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ReqOptMatcher_Hash_Sum(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ReqOptMatcher_Get_VTable(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ReqOptMatcher_Get_Class_Name(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ReqOptMatcher_Is_A(const lucy_RequiredOptionalMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ReqOptMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ReqOptMatcher_To_String(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ReqOptMatcher_To_I64(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ReqOptMatcher_To_F64(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ReqOptMatcher_To_Bool(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ReqOptMatcher_Serialize(const lucy_RequiredOptionalMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ReqOptMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ReqOptMatcher_Deserialize(const lucy_RequiredOptionalMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ReqOptMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ReqOptMatcher_Dump(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ReqOptMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ReqOptMatcher_Load(const lucy_RequiredOptionalMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ReqOptMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ReqOptMatcher_Mimic(const lucy_RequiredOptionalMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ReqOptMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_ReqOptMatcher_Next(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Next_OFFSET;
    const lucy_ReqOptMatcher_next_t method = *((lucy_ReqOptMatcher_next_t*)method_address);
    return method((lucy_RequiredOptionalMatcher*)self);
}

extern size_t Lucy_ReqOptMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_ReqOptMatcher_Advance(const lucy_RequiredOptionalMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Advance_OFFSET;
    const lucy_ReqOptMatcher_advance_t method = *((lucy_ReqOptMatcher_advance_t*)method_address);
    return method((lucy_RequiredOptionalMatcher*)self, target);
}

extern size_t Lucy_ReqOptMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ReqOptMatcher_Get_Doc_ID(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Get_Doc_ID_OFFSET;
    const lucy_ReqOptMatcher_get_doc_id_t method = *((lucy_ReqOptMatcher_get_doc_id_t*)method_address);
    return method((lucy_RequiredOptionalMatcher*)self);
}

extern size_t Lucy_ReqOptMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_ReqOptMatcher_Score(const lucy_RequiredOptionalMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Score_OFFSET;
    const lucy_ReqOptMatcher_score_t method = *((lucy_ReqOptMatcher_score_t*)method_address);
    return method((lucy_RequiredOptionalMatcher*)self);
}

extern size_t Lucy_ReqOptMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_ReqOptMatcher_Collect(const lucy_RequiredOptionalMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_ReqOptMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_REQUIREDOPTIONALMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_REQUIREDOPTIONALMATCHER_VT;
extern struct LUCY_REQUIREDOPTIONALMATCHER_VT LUCY_REQUIREDOPTIONALMATCHER_vt;
#define LUCY_REQUIREDOPTIONALMATCHER ((cfish_VTable*)&LUCY_REQUIREDOPTIONALMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RequiredOptionalMatcher lucy_RequiredOptionalMatcher
  #define REQUIREDOPTIONALMATCHER LUCY_REQUIREDOPTIONALMATCHER
  #define ReqOptMatcher_new lucy_ReqOptMatcher_new
  #define ReqOptMatcher_init lucy_ReqOptMatcher_init
  #define ReqOptMatcher_destroy_t lucy_ReqOptMatcher_destroy_t
  #define ReqOptMatcher_destroy lucy_ReqOptMatcher_destroy
  #define ReqOptMatcher_next_t lucy_ReqOptMatcher_next_t
  #define ReqOptMatcher_next lucy_ReqOptMatcher_next
  #define ReqOptMatcher_advance_t lucy_ReqOptMatcher_advance_t
  #define ReqOptMatcher_advance lucy_ReqOptMatcher_advance
  #define ReqOptMatcher_get_doc_id_t lucy_ReqOptMatcher_get_doc_id_t
  #define ReqOptMatcher_get_doc_id lucy_ReqOptMatcher_get_doc_id
  #define ReqOptMatcher_score_t lucy_ReqOptMatcher_score_t
  #define ReqOptMatcher_score lucy_ReqOptMatcher_score
  #define ReqOptMatcher_Make Lucy_ReqOptMatcher_Make
  #define ReqOptMatcher_Get_RefCount Lucy_ReqOptMatcher_Get_RefCount
  #define ReqOptMatcher_Inc_RefCount Lucy_ReqOptMatcher_Inc_RefCount
  #define ReqOptMatcher_Dec_RefCount Lucy_ReqOptMatcher_Dec_RefCount
  #define ReqOptMatcher_To_Host Lucy_ReqOptMatcher_To_Host
  #define ReqOptMatcher_Clone Lucy_ReqOptMatcher_Clone
  #define ReqOptMatcher_Destroy Lucy_ReqOptMatcher_Destroy
  #define ReqOptMatcher_Equals Lucy_ReqOptMatcher_Equals
  #define ReqOptMatcher_Compare_To Lucy_ReqOptMatcher_Compare_To
  #define ReqOptMatcher_Hash_Sum Lucy_ReqOptMatcher_Hash_Sum
  #define ReqOptMatcher_Get_VTable Lucy_ReqOptMatcher_Get_VTable
  #define ReqOptMatcher_Get_Class_Name Lucy_ReqOptMatcher_Get_Class_Name
  #define ReqOptMatcher_Is_A Lucy_ReqOptMatcher_Is_A
  #define ReqOptMatcher_To_String Lucy_ReqOptMatcher_To_String
  #define ReqOptMatcher_To_I64 Lucy_ReqOptMatcher_To_I64
  #define ReqOptMatcher_To_F64 Lucy_ReqOptMatcher_To_F64
  #define ReqOptMatcher_To_Bool Lucy_ReqOptMatcher_To_Bool
  #define ReqOptMatcher_Serialize Lucy_ReqOptMatcher_Serialize
  #define ReqOptMatcher_Deserialize Lucy_ReqOptMatcher_Deserialize
  #define ReqOptMatcher_Dump Lucy_ReqOptMatcher_Dump
  #define ReqOptMatcher_Load Lucy_ReqOptMatcher_Load
  #define ReqOptMatcher_Mimic Lucy_ReqOptMatcher_Mimic
  #define ReqOptMatcher_Next Lucy_ReqOptMatcher_Next
  #define ReqOptMatcher_Advance Lucy_ReqOptMatcher_Advance
  #define ReqOptMatcher_Get_Doc_ID Lucy_ReqOptMatcher_Get_Doc_ID
  #define ReqOptMatcher_Score Lucy_ReqOptMatcher_Score
  #define ReqOptMatcher_Collect Lucy_ReqOptMatcher_Collect
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_REQUIREDOPTIONALMATCHER */




