/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_SEARCHER
#define H_LUCY_SEARCH_SEARCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEARCHER
struct lucy_Searcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Schema* schema;
    lucy_QueryParser* qparser;
};

#endif /* C_LUCY_SEARCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Searcher*
lucy_Searcher_init(lucy_Searcher* self, lucy_Schema* schema);

void
lucy_Searcher_destroy(lucy_Searcher* self);

int32_t
lucy_Searcher_doc_max(lucy_Searcher* self);

uint32_t
lucy_Searcher_doc_freq(lucy_Searcher* self, const lucy_CharBuf* field, lucy_Obj* term);

lucy_Query*
lucy_Searcher_glean_query(lucy_Searcher* self, lucy_Obj* query);

lucy_Hits*
lucy_Searcher_hits(lucy_Searcher* self, lucy_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec);

void
lucy_Searcher_collect(lucy_Searcher* self, lucy_Query* query, lucy_Collector* collector);

lucy_TopDocs*
lucy_Searcher_top_docs(lucy_Searcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

lucy_HitDoc*
lucy_Searcher_fetch_doc(lucy_Searcher* self, int32_t doc_id);

lucy_DocVector*
lucy_Searcher_fetch_doc_vec(lucy_Searcher* self, int32_t doc_id);

lucy_Schema*
lucy_Searcher_get_schema(lucy_Searcher* self);

void
lucy_Searcher_close(lucy_Searcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Searcher_destroy_CALLBACK;
extern cfish_Callback lucy_Searcher_doc_max_CALLBACK;
extern cfish_Callback lucy_Searcher_doc_freq_CALLBACK;
extern cfish_Callback lucy_Searcher_glean_query_CALLBACK;
extern cfish_Callback lucy_Searcher_hits_CALLBACK;
extern cfish_Callback lucy_Searcher_collect_CALLBACK;
extern cfish_Callback lucy_Searcher_top_docs_CALLBACK;
extern cfish_Callback lucy_Searcher_fetch_doc_CALLBACK;
extern cfish_Callback lucy_Searcher_fetch_doc_vec_CALLBACK;
extern cfish_Callback lucy_Searcher_get_schema_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Searcher_destroy_t)(lucy_Searcher* self);

typedef int32_t
(*lucy_Searcher_doc_max_t)(lucy_Searcher* self);

typedef uint32_t
(*lucy_Searcher_doc_freq_t)(lucy_Searcher* self, const lucy_CharBuf* field, lucy_Obj* term);

typedef lucy_Query*
(*lucy_Searcher_glean_query_t)(lucy_Searcher* self, lucy_Obj* query);

typedef lucy_Hits*
(*lucy_Searcher_hits_t)(lucy_Searcher* self, lucy_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec);

typedef void
(*lucy_Searcher_collect_t)(lucy_Searcher* self, lucy_Query* query, lucy_Collector* collector);

typedef lucy_TopDocs*
(*lucy_Searcher_top_docs_t)(lucy_Searcher* self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec);

typedef lucy_HitDoc*
(*lucy_Searcher_fetch_doc_t)(lucy_Searcher* self, int32_t doc_id);

typedef lucy_DocVector*
(*lucy_Searcher_fetch_doc_vec_t)(lucy_Searcher* self, int32_t doc_id);

typedef lucy_Schema*
(*lucy_Searcher_get_schema_t)(lucy_Searcher* self);

typedef void
(*lucy_Searcher_close_t)(lucy_Searcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Searcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Searcher_Make(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Searcher_Get_RefCount(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Searcher_Inc_RefCount(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Searcher_Dec_RefCount(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Searcher_To_Host(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Searcher_Clone(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Searcher_Destroy(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Destroy_OFFSET;
    const lucy_Searcher_destroy_t method = *((lucy_Searcher_destroy_t*)method_address);
    method((lucy_Searcher*)self);
}

extern size_t Lucy_Searcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Searcher_Equals(const lucy_Searcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Searcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Searcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Searcher_Compare_To(const lucy_Searcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Searcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Searcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Searcher_Hash_Sum(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Searcher_Get_VTable(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Searcher_Get_Class_Name(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Searcher_Is_A(const lucy_Searcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Searcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Searcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Searcher_To_String(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Searcher_To_I64(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Searcher_To_F64(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Searcher_To_Bool(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Searcher_Serialize(const lucy_Searcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Searcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Searcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Searcher_Deserialize(const lucy_Searcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Searcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Searcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Searcher_Dump(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Searcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Searcher_Load(const lucy_Searcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Searcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Searcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Searcher_Mimic(const lucy_Searcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Searcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Searcher_Doc_Max_OFFSET;
static CHY_INLINE int32_t
Lucy_Searcher_Doc_Max(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Doc_Max_OFFSET;
    const lucy_Searcher_doc_max_t method = *((lucy_Searcher_doc_max_t*)method_address);
    return method((lucy_Searcher*)self);
}

extern size_t Lucy_Searcher_Doc_Freq_OFFSET;
static CHY_INLINE uint32_t
Lucy_Searcher_Doc_Freq(const lucy_Searcher *self, const lucy_CharBuf* field, lucy_Obj* term) {
    char *const method_address = *(char**)self + Lucy_Searcher_Doc_Freq_OFFSET;
    const lucy_Searcher_doc_freq_t method = *((lucy_Searcher_doc_freq_t*)method_address);
    return method((lucy_Searcher*)self, field, term);
}

extern size_t Lucy_Searcher_Glean_Query_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_Searcher_Glean_Query(const lucy_Searcher *self, lucy_Obj* query) {
    char *const method_address = *(char**)self + Lucy_Searcher_Glean_Query_OFFSET;
    const lucy_Searcher_glean_query_t method = *((lucy_Searcher_glean_query_t*)method_address);
    return method((lucy_Searcher*)self, query);
}

extern size_t Lucy_Searcher_Hits_OFFSET;
static CHY_INLINE lucy_Hits*
Lucy_Searcher_Hits(const lucy_Searcher *self, lucy_Obj* query, uint32_t offset, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    char *const method_address = *(char**)self + Lucy_Searcher_Hits_OFFSET;
    const lucy_Searcher_hits_t method = *((lucy_Searcher_hits_t*)method_address);
    return method((lucy_Searcher*)self, query, offset, num_wanted, sort_spec);
}

extern size_t Lucy_Searcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_Searcher_Collect(const lucy_Searcher *self, lucy_Query* query, lucy_Collector* collector) {
    char *const method_address = *(char**)self + Lucy_Searcher_Collect_OFFSET;
    const lucy_Searcher_collect_t method = *((lucy_Searcher_collect_t*)method_address);
    method((lucy_Searcher*)self, query, collector);
}

extern size_t Lucy_Searcher_Top_Docs_OFFSET;
static CHY_INLINE lucy_TopDocs*
Lucy_Searcher_Top_Docs(const lucy_Searcher *self, lucy_Query* query, uint32_t num_wanted, lucy_SortSpec* sort_spec) {
    char *const method_address = *(char**)self + Lucy_Searcher_Top_Docs_OFFSET;
    const lucy_Searcher_top_docs_t method = *((lucy_Searcher_top_docs_t*)method_address);
    return method((lucy_Searcher*)self, query, num_wanted, sort_spec);
}

extern size_t Lucy_Searcher_Fetch_Doc_OFFSET;
static CHY_INLINE lucy_HitDoc*
Lucy_Searcher_Fetch_Doc(const lucy_Searcher *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_Searcher_Fetch_Doc_OFFSET;
    const lucy_Searcher_fetch_doc_t method = *((lucy_Searcher_fetch_doc_t*)method_address);
    return method((lucy_Searcher*)self, doc_id);
}

extern size_t Lucy_Searcher_Fetch_Doc_Vec_OFFSET;
static CHY_INLINE lucy_DocVector*
Lucy_Searcher_Fetch_Doc_Vec(const lucy_Searcher *self, int32_t doc_id) {
    char *const method_address = *(char**)self + Lucy_Searcher_Fetch_Doc_Vec_OFFSET;
    const lucy_Searcher_fetch_doc_vec_t method = *((lucy_Searcher_fetch_doc_vec_t*)method_address);
    return method((lucy_Searcher*)self, doc_id);
}

extern size_t Lucy_Searcher_Get_Schema_OFFSET;
static CHY_INLINE lucy_Schema*
Lucy_Searcher_Get_Schema(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Get_Schema_OFFSET;
    const lucy_Searcher_get_schema_t method = *((lucy_Searcher_get_schema_t*)method_address);
    return method((lucy_Searcher*)self);
}

extern size_t Lucy_Searcher_Close_OFFSET;
static CHY_INLINE void
Lucy_Searcher_Close(const lucy_Searcher *self) {
    char *const method_address = *(char**)self + Lucy_Searcher_Close_OFFSET;
    const lucy_Searcher_close_t method = *((lucy_Searcher_close_t*)method_address);
    method((lucy_Searcher*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SEARCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_SEARCHER_VT;
extern struct LUCY_SEARCHER_VT LUCY_SEARCHER_vt;
#define LUCY_SEARCHER ((cfish_VTable*)&LUCY_SEARCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Searcher lucy_Searcher
  #define SEARCHER LUCY_SEARCHER
  #define Searcher_init lucy_Searcher_init
  #define Searcher_destroy_t lucy_Searcher_destroy_t
  #define Searcher_destroy lucy_Searcher_destroy
  #define Searcher_doc_max_t lucy_Searcher_doc_max_t
  #define Searcher_doc_max lucy_Searcher_doc_max
  #define Searcher_doc_freq_t lucy_Searcher_doc_freq_t
  #define Searcher_doc_freq lucy_Searcher_doc_freq
  #define Searcher_glean_query_t lucy_Searcher_glean_query_t
  #define Searcher_glean_query lucy_Searcher_glean_query
  #define Searcher_hits_t lucy_Searcher_hits_t
  #define Searcher_hits lucy_Searcher_hits
  #define Searcher_collect_t lucy_Searcher_collect_t
  #define Searcher_collect lucy_Searcher_collect
  #define Searcher_top_docs_t lucy_Searcher_top_docs_t
  #define Searcher_top_docs lucy_Searcher_top_docs
  #define Searcher_fetch_doc_t lucy_Searcher_fetch_doc_t
  #define Searcher_fetch_doc lucy_Searcher_fetch_doc
  #define Searcher_fetch_doc_vec_t lucy_Searcher_fetch_doc_vec_t
  #define Searcher_fetch_doc_vec lucy_Searcher_fetch_doc_vec
  #define Searcher_get_schema_t lucy_Searcher_get_schema_t
  #define Searcher_get_schema lucy_Searcher_get_schema
  #define Searcher_close_t lucy_Searcher_close_t
  #define Searcher_close lucy_Searcher_close
  #define Searcher_Make Lucy_Searcher_Make
  #define Searcher_Get_RefCount Lucy_Searcher_Get_RefCount
  #define Searcher_Inc_RefCount Lucy_Searcher_Inc_RefCount
  #define Searcher_Dec_RefCount Lucy_Searcher_Dec_RefCount
  #define Searcher_To_Host Lucy_Searcher_To_Host
  #define Searcher_Clone Lucy_Searcher_Clone
  #define Searcher_Destroy Lucy_Searcher_Destroy
  #define Searcher_Equals Lucy_Searcher_Equals
  #define Searcher_Compare_To Lucy_Searcher_Compare_To
  #define Searcher_Hash_Sum Lucy_Searcher_Hash_Sum
  #define Searcher_Get_VTable Lucy_Searcher_Get_VTable
  #define Searcher_Get_Class_Name Lucy_Searcher_Get_Class_Name
  #define Searcher_Is_A Lucy_Searcher_Is_A
  #define Searcher_To_String Lucy_Searcher_To_String
  #define Searcher_To_I64 Lucy_Searcher_To_I64
  #define Searcher_To_F64 Lucy_Searcher_To_F64
  #define Searcher_To_Bool Lucy_Searcher_To_Bool
  #define Searcher_Serialize Lucy_Searcher_Serialize
  #define Searcher_Deserialize Lucy_Searcher_Deserialize
  #define Searcher_Dump Lucy_Searcher_Dump
  #define Searcher_Load Lucy_Searcher_Load
  #define Searcher_Mimic Lucy_Searcher_Mimic
  #define Searcher_Doc_Max Lucy_Searcher_Doc_Max
  #define Searcher_Doc_Freq Lucy_Searcher_Doc_Freq
  #define Searcher_Glean_Query Lucy_Searcher_Glean_Query
  #define Searcher_Hits Lucy_Searcher_Hits
  #define Searcher_Collect Lucy_Searcher_Collect
  #define Searcher_Top_Docs Lucy_Searcher_Top_Docs
  #define Searcher_Fetch_Doc Lucy_Searcher_Fetch_Doc
  #define Searcher_Fetch_Doc_Vec Lucy_Searcher_Fetch_Doc_Vec
  #define Searcher_Get_Schema Lucy_Searcher_Get_Schema
  #define Searcher_Close Lucy_Searcher_Close
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_SEARCHER */




