/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_TERMQUERY
#define H_LUCY_SEARCH_TERMQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TERMQUERY
struct lucy_TermQuery {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_CharBuf* field;
    lucy_Obj* term;
};

#endif /* C_LUCY_TERMQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_TermQuery*
lucy_TermQuery_new(const lucy_CharBuf* field, const lucy_Obj* term);

lucy_TermQuery*
lucy_TermQuery_init(lucy_TermQuery* self, const lucy_CharBuf* field, const lucy_Obj* term);

void
lucy_TermQuery_destroy(lucy_TermQuery* self);

chy_bool_t
lucy_TermQuery_equals(lucy_TermQuery* self, lucy_Obj* other);

lucy_CharBuf*
lucy_TermQuery_to_string(lucy_TermQuery* self);

void
lucy_TermQuery_serialize(lucy_TermQuery* self, lucy_OutStream* outstream);

lucy_TermQuery*
lucy_TermQuery_deserialize(lucy_TermQuery* self, lucy_InStream* instream);

lucy_Obj*
lucy_TermQuery_dump(lucy_TermQuery* self);

lucy_Obj*
lucy_TermQuery_load(lucy_TermQuery* self, lucy_Obj* dump);

lucy_Compiler*
lucy_TermQuery_make_compiler(lucy_TermQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

lucy_CharBuf*
lucy_TermQuery_get_field(lucy_TermQuery* self);

lucy_Obj*
lucy_TermQuery_get_term(lucy_TermQuery* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_TermQuery_destroy_CALLBACK;
extern cfish_Callback lucy_TermQuery_equals_CALLBACK;
extern cfish_Callback lucy_TermQuery_to_string_CALLBACK;
extern cfish_Callback lucy_TermQuery_serialize_CALLBACK;
extern cfish_Callback lucy_TermQuery_deserialize_CALLBACK;
extern cfish_Callback lucy_TermQuery_dump_CALLBACK;
extern cfish_Callback lucy_TermQuery_load_CALLBACK;
extern cfish_Callback lucy_TermQuery_make_compiler_CALLBACK;
extern cfish_Callback lucy_TermQuery_get_field_CALLBACK;
extern cfish_Callback lucy_TermQuery_get_term_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_TermQuery_destroy_t)(lucy_TermQuery* self);

typedef chy_bool_t
(*lucy_TermQuery_equals_t)(lucy_TermQuery* self, lucy_Obj* other);

typedef lucy_CharBuf*
(*lucy_TermQuery_to_string_t)(lucy_TermQuery* self);

typedef void
(*lucy_TermQuery_serialize_t)(lucy_TermQuery* self, lucy_OutStream* outstream);

typedef lucy_TermQuery*
(*lucy_TermQuery_deserialize_t)(lucy_TermQuery* self, lucy_InStream* instream);

typedef lucy_Obj*
(*lucy_TermQuery_dump_t)(lucy_TermQuery* self);

typedef lucy_Obj*
(*lucy_TermQuery_load_t)(lucy_TermQuery* self, lucy_Obj* dump);

typedef lucy_Compiler*
(*lucy_TermQuery_make_compiler_t)(lucy_TermQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

typedef lucy_CharBuf*
(*lucy_TermQuery_get_field_t)(lucy_TermQuery* self);

typedef lucy_Obj*
(*lucy_TermQuery_get_term_t)(lucy_TermQuery* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_TermQuery_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermQuery_Make(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TermQuery_Get_RefCount(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermQuery_Inc_RefCount(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TermQuery_Dec_RefCount(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_TermQuery_To_Host(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermQuery_Clone(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Destroy_OFFSET;
static CHY_INLINE void
Lucy_TermQuery_Destroy(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Destroy_OFFSET;
    const lucy_TermQuery_destroy_t method = *((lucy_TermQuery_destroy_t*)method_address);
    method((lucy_TermQuery*)self);
}

extern size_t Lucy_TermQuery_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TermQuery_Equals(const lucy_TermQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Equals_OFFSET;
    const lucy_TermQuery_equals_t method = *((lucy_TermQuery_equals_t*)method_address);
    return method((lucy_TermQuery*)self, other);
}

extern size_t Lucy_TermQuery_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_TermQuery_Compare_To(const lucy_TermQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TermQuery_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_TermQuery_Hash_Sum(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_TermQuery_Get_VTable(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TermQuery_Get_Class_Name(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TermQuery_Is_A(const lucy_TermQuery *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_TermQuery_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TermQuery_To_String(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_To_String_OFFSET;
    const lucy_TermQuery_to_string_t method = *((lucy_TermQuery_to_string_t*)method_address);
    return method((lucy_TermQuery*)self);
}

extern size_t Lucy_TermQuery_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_TermQuery_To_I64(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_To_F64_OFFSET;
static CHY_INLINE double
Lucy_TermQuery_To_F64(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TermQuery_To_Bool(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermQuery_Serialize_OFFSET;
static CHY_INLINE void
Lucy_TermQuery_Serialize(const lucy_TermQuery *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Serialize_OFFSET;
    const lucy_TermQuery_serialize_t method = *((lucy_TermQuery_serialize_t*)method_address);
    method((lucy_TermQuery*)self, outstream);
}

extern size_t Lucy_TermQuery_Deserialize_OFFSET;
static CHY_INLINE lucy_TermQuery*
Lucy_TermQuery_Deserialize(const lucy_TermQuery *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Deserialize_OFFSET;
    const lucy_TermQuery_deserialize_t method = *((lucy_TermQuery_deserialize_t*)method_address);
    return method((lucy_TermQuery*)self, instream);
}

extern size_t Lucy_TermQuery_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermQuery_Dump(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Dump_OFFSET;
    const lucy_TermQuery_dump_t method = *((lucy_TermQuery_dump_t*)method_address);
    return method((lucy_TermQuery*)self);
}

extern size_t Lucy_TermQuery_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermQuery_Load(const lucy_TermQuery *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Load_OFFSET;
    const lucy_TermQuery_load_t method = *((lucy_TermQuery_load_t*)method_address);
    return method((lucy_TermQuery*)self, dump);
}

extern size_t Lucy_TermQuery_Mimic_OFFSET;
static CHY_INLINE void
Lucy_TermQuery_Mimic(const lucy_TermQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_TermQuery_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_TermQuery_Make_Compiler(const lucy_TermQuery *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Make_Compiler_OFFSET;
    const lucy_TermQuery_make_compiler_t method = *((lucy_TermQuery_make_compiler_t*)method_address);
    return method((lucy_TermQuery*)self, searcher, boost, subordinate);
}

extern size_t Lucy_TermQuery_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_TermQuery_Set_Boost(const lucy_TermQuery *self, float boost) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_TermQuery_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_TermQuery_Get_Boost(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_TermQuery_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TermQuery_Get_Field(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Get_Field_OFFSET;
    const lucy_TermQuery_get_field_t method = *((lucy_TermQuery_get_field_t*)method_address);
    return method((lucy_TermQuery*)self);
}

extern size_t Lucy_TermQuery_Get_Term_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermQuery_Get_Term(const lucy_TermQuery *self) {
    char *const method_address = *(char**)self + Lucy_TermQuery_Get_Term_OFFSET;
    const lucy_TermQuery_get_term_t method = *((lucy_TermQuery_get_term_t*)method_address);
    return method((lucy_TermQuery*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_TERMQUERY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_TERMQUERY_VT;
extern struct LUCY_TERMQUERY_VT LUCY_TERMQUERY_vt;
#define LUCY_TERMQUERY ((cfish_VTable*)&LUCY_TERMQUERY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TermQuery lucy_TermQuery
  #define TERMQUERY LUCY_TERMQUERY
  #define TermQuery_new lucy_TermQuery_new
  #define TermQuery_init lucy_TermQuery_init
  #define TermQuery_destroy_t lucy_TermQuery_destroy_t
  #define TermQuery_destroy lucy_TermQuery_destroy
  #define TermQuery_equals_t lucy_TermQuery_equals_t
  #define TermQuery_equals lucy_TermQuery_equals
  #define TermQuery_to_string_t lucy_TermQuery_to_string_t
  #define TermQuery_to_string lucy_TermQuery_to_string
  #define TermQuery_serialize_t lucy_TermQuery_serialize_t
  #define TermQuery_serialize lucy_TermQuery_serialize
  #define TermQuery_deserialize_t lucy_TermQuery_deserialize_t
  #define TermQuery_deserialize lucy_TermQuery_deserialize
  #define TermQuery_dump_t lucy_TermQuery_dump_t
  #define TermQuery_dump lucy_TermQuery_dump
  #define TermQuery_load_t lucy_TermQuery_load_t
  #define TermQuery_load lucy_TermQuery_load
  #define TermQuery_make_compiler_t lucy_TermQuery_make_compiler_t
  #define TermQuery_make_compiler lucy_TermQuery_make_compiler
  #define TermQuery_get_field_t lucy_TermQuery_get_field_t
  #define TermQuery_get_field lucy_TermQuery_get_field
  #define TermQuery_get_term_t lucy_TermQuery_get_term_t
  #define TermQuery_get_term lucy_TermQuery_get_term
  #define TermQuery_Make Lucy_TermQuery_Make
  #define TermQuery_Get_RefCount Lucy_TermQuery_Get_RefCount
  #define TermQuery_Inc_RefCount Lucy_TermQuery_Inc_RefCount
  #define TermQuery_Dec_RefCount Lucy_TermQuery_Dec_RefCount
  #define TermQuery_To_Host Lucy_TermQuery_To_Host
  #define TermQuery_Clone Lucy_TermQuery_Clone
  #define TermQuery_Destroy Lucy_TermQuery_Destroy
  #define TermQuery_Equals Lucy_TermQuery_Equals
  #define TermQuery_Compare_To Lucy_TermQuery_Compare_To
  #define TermQuery_Hash_Sum Lucy_TermQuery_Hash_Sum
  #define TermQuery_Get_VTable Lucy_TermQuery_Get_VTable
  #define TermQuery_Get_Class_Name Lucy_TermQuery_Get_Class_Name
  #define TermQuery_Is_A Lucy_TermQuery_Is_A
  #define TermQuery_To_String Lucy_TermQuery_To_String
  #define TermQuery_To_I64 Lucy_TermQuery_To_I64
  #define TermQuery_To_F64 Lucy_TermQuery_To_F64
  #define TermQuery_To_Bool Lucy_TermQuery_To_Bool
  #define TermQuery_Serialize Lucy_TermQuery_Serialize
  #define TermQuery_Deserialize Lucy_TermQuery_Deserialize
  #define TermQuery_Dump Lucy_TermQuery_Dump
  #define TermQuery_Load Lucy_TermQuery_Load
  #define TermQuery_Mimic Lucy_TermQuery_Mimic
  #define TermQuery_Make_Compiler Lucy_TermQuery_Make_Compiler
  #define TermQuery_Set_Boost Lucy_TermQuery_Set_Boost
  #define TermQuery_Get_Boost Lucy_TermQuery_Get_Boost
  #define TermQuery_Get_Field Lucy_TermQuery_Get_Field
  #define TermQuery_Get_Term Lucy_TermQuery_Get_Term
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Compiler.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_TERMCOMPILER
struct lucy_TermCompiler {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
    float idf;
    float raw_weight;
    float query_norm_factor;
    float normalized_weight;
};

#endif /* C_LUCY_TERMCOMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_TermCompiler*
lucy_TermCompiler_new(lucy_Query* parent, lucy_Searcher* searcher, float boost);

lucy_TermCompiler*
lucy_TermCompiler_init(lucy_TermCompiler* self, lucy_Query* parent, lucy_Searcher* searcher, float boost);

chy_bool_t
lucy_TermCompiler_equals(lucy_TermCompiler* self, lucy_Obj* other);

void
lucy_TermCompiler_serialize(lucy_TermCompiler* self, lucy_OutStream* outstream);

lucy_TermCompiler*
lucy_TermCompiler_deserialize(lucy_TermCompiler* self, lucy_InStream* instream);

lucy_Matcher*
lucy_TermCompiler_make_matcher(lucy_TermCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);

float
lucy_TermCompiler_get_weight(lucy_TermCompiler* self);

float
lucy_TermCompiler_sum_of_squared_weights(lucy_TermCompiler* self);

void
lucy_TermCompiler_apply_norm_factor(lucy_TermCompiler* self, float factor);

lucy_VArray*
lucy_TermCompiler_highlight_spans(lucy_TermCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_TermCompiler_equals_CALLBACK;
extern cfish_Callback lucy_TermCompiler_serialize_CALLBACK;
extern cfish_Callback lucy_TermCompiler_deserialize_CALLBACK;
extern cfish_Callback lucy_TermCompiler_make_matcher_CALLBACK;
extern cfish_Callback lucy_TermCompiler_get_weight_CALLBACK;
extern cfish_Callback lucy_TermCompiler_sum_of_squared_weights_CALLBACK;
extern cfish_Callback lucy_TermCompiler_apply_norm_factor_CALLBACK;
extern cfish_Callback lucy_TermCompiler_highlight_spans_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_TermCompiler_equals_t)(lucy_TermCompiler* self, lucy_Obj* other);

typedef void
(*lucy_TermCompiler_serialize_t)(lucy_TermCompiler* self, lucy_OutStream* outstream);

typedef lucy_TermCompiler*
(*lucy_TermCompiler_deserialize_t)(lucy_TermCompiler* self, lucy_InStream* instream);

typedef lucy_Matcher*
(*lucy_TermCompiler_make_matcher_t)(lucy_TermCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);

typedef float
(*lucy_TermCompiler_get_weight_t)(lucy_TermCompiler* self);

typedef float
(*lucy_TermCompiler_sum_of_squared_weights_t)(lucy_TermCompiler* self);

typedef void
(*lucy_TermCompiler_apply_norm_factor_t)(lucy_TermCompiler* self, float factor);

typedef lucy_VArray*
(*lucy_TermCompiler_highlight_spans_t)(lucy_TermCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_TermCompiler_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermCompiler_Make(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TermCompiler_Get_RefCount(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermCompiler_Inc_RefCount(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_TermCompiler_Dec_RefCount(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_TermCompiler_To_Host(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermCompiler_Clone(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Destroy_OFFSET;
static CHY_INLINE void
Lucy_TermCompiler_Destroy(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Destroy_OFFSET;
    const lucy_Compiler_destroy_t method = *((lucy_Compiler_destroy_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_TermCompiler_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TermCompiler_Equals(const lucy_TermCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Equals_OFFSET;
    const lucy_TermCompiler_equals_t method = *((lucy_TermCompiler_equals_t*)method_address);
    return method((lucy_TermCompiler*)self, other);
}

extern size_t Lucy_TermCompiler_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_TermCompiler_Compare_To(const lucy_TermCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_TermCompiler_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_TermCompiler_Hash_Sum(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_TermCompiler_Get_VTable(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TermCompiler_Get_Class_Name(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TermCompiler_Is_A(const lucy_TermCompiler *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_TermCompiler_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_TermCompiler_To_String(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_To_String_OFFSET;
    const lucy_Compiler_to_string_t method = *((lucy_Compiler_to_string_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_TermCompiler_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_TermCompiler_To_I64(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_To_F64_OFFSET;
static CHY_INLINE double
Lucy_TermCompiler_To_F64(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_TermCompiler_To_Bool(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_TermCompiler_Serialize_OFFSET;
static CHY_INLINE void
Lucy_TermCompiler_Serialize(const lucy_TermCompiler *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Serialize_OFFSET;
    const lucy_TermCompiler_serialize_t method = *((lucy_TermCompiler_serialize_t*)method_address);
    method((lucy_TermCompiler*)self, outstream);
}

extern size_t Lucy_TermCompiler_Deserialize_OFFSET;
static CHY_INLINE lucy_TermCompiler*
Lucy_TermCompiler_Deserialize(const lucy_TermCompiler *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Deserialize_OFFSET;
    const lucy_TermCompiler_deserialize_t method = *((lucy_TermCompiler_deserialize_t*)method_address);
    return method((lucy_TermCompiler*)self, instream);
}

extern size_t Lucy_TermCompiler_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermCompiler_Dump(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Dump_OFFSET;
    const lucy_Query_dump_t method = *((lucy_Query_dump_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_TermCompiler_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_TermCompiler_Load(const lucy_TermCompiler *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Load_OFFSET;
    const lucy_Query_load_t method = *((lucy_Query_load_t*)method_address);
    return method((lucy_Query*)self, dump);
}

extern size_t Lucy_TermCompiler_Mimic_OFFSET;
static CHY_INLINE void
Lucy_TermCompiler_Mimic(const lucy_TermCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_TermCompiler_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_TermCompiler_Make_Compiler(const lucy_TermCompiler *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Make_Compiler_OFFSET;
    const lucy_Query_make_compiler_t method = *((lucy_Query_make_compiler_t*)method_address);
    return method((lucy_Query*)self, searcher, boost, subordinate);
}

extern size_t Lucy_TermCompiler_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_TermCompiler_Set_Boost(const lucy_TermCompiler *self, float boost) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_TermCompiler_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_TermCompiler_Get_Boost(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_TermCompiler_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_TermCompiler_Make_Matcher(const lucy_TermCompiler *self, lucy_SegReader* reader, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Make_Matcher_OFFSET;
    const lucy_TermCompiler_make_matcher_t method = *((lucy_TermCompiler_make_matcher_t*)method_address);
    return method((lucy_TermCompiler*)self, reader, need_score);
}

extern size_t Lucy_TermCompiler_Get_Weight_OFFSET;
static CHY_INLINE float
Lucy_TermCompiler_Get_Weight(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_Weight_OFFSET;
    const lucy_TermCompiler_get_weight_t method = *((lucy_TermCompiler_get_weight_t*)method_address);
    return method((lucy_TermCompiler*)self);
}

extern size_t Lucy_TermCompiler_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_TermCompiler_Get_Similarity(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_Similarity_OFFSET;
    const lucy_Compiler_get_similarity_t method = *((lucy_Compiler_get_similarity_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_TermCompiler_Get_Parent_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_TermCompiler_Get_Parent(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Get_Parent_OFFSET;
    const lucy_Compiler_get_parent_t method = *((lucy_Compiler_get_parent_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_TermCompiler_Sum_Of_Squared_Weights_OFFSET;
static CHY_INLINE float
Lucy_TermCompiler_Sum_Of_Squared_Weights(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Sum_Of_Squared_Weights_OFFSET;
    const lucy_TermCompiler_sum_of_squared_weights_t method = *((lucy_TermCompiler_sum_of_squared_weights_t*)method_address);
    return method((lucy_TermCompiler*)self);
}

extern size_t Lucy_TermCompiler_Apply_Norm_Factor_OFFSET;
static CHY_INLINE void
Lucy_TermCompiler_Apply_Norm_Factor(const lucy_TermCompiler *self, float factor) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Apply_Norm_Factor_OFFSET;
    const lucy_TermCompiler_apply_norm_factor_t method = *((lucy_TermCompiler_apply_norm_factor_t*)method_address);
    method((lucy_TermCompiler*)self, factor);
}

extern size_t Lucy_TermCompiler_Normalize_OFFSET;
static CHY_INLINE void
Lucy_TermCompiler_Normalize(const lucy_TermCompiler *self) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Normalize_OFFSET;
    const lucy_Compiler_normalize_t method = *((lucy_Compiler_normalize_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_TermCompiler_Highlight_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_TermCompiler_Highlight_Spans(const lucy_TermCompiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_TermCompiler_Highlight_Spans_OFFSET;
    const lucy_TermCompiler_highlight_spans_t method = *((lucy_TermCompiler_highlight_spans_t*)method_address);
    return method((lucy_TermCompiler*)self, searcher, doc_vec, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_TERMCOMPILER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_TERMCOMPILER_VT;
extern struct LUCY_TERMCOMPILER_VT LUCY_TERMCOMPILER_vt;
#define LUCY_TERMCOMPILER ((cfish_VTable*)&LUCY_TERMCOMPILER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TermCompiler lucy_TermCompiler
  #define TERMCOMPILER LUCY_TERMCOMPILER
  #define TermCompiler_new lucy_TermCompiler_new
  #define TermCompiler_init lucy_TermCompiler_init
  #define TermCompiler_equals_t lucy_TermCompiler_equals_t
  #define TermCompiler_equals lucy_TermCompiler_equals
  #define TermCompiler_serialize_t lucy_TermCompiler_serialize_t
  #define TermCompiler_serialize lucy_TermCompiler_serialize
  #define TermCompiler_deserialize_t lucy_TermCompiler_deserialize_t
  #define TermCompiler_deserialize lucy_TermCompiler_deserialize
  #define TermCompiler_make_matcher_t lucy_TermCompiler_make_matcher_t
  #define TermCompiler_make_matcher lucy_TermCompiler_make_matcher
  #define TermCompiler_get_weight_t lucy_TermCompiler_get_weight_t
  #define TermCompiler_get_weight lucy_TermCompiler_get_weight
  #define TermCompiler_sum_of_squared_weights_t lucy_TermCompiler_sum_of_squared_weights_t
  #define TermCompiler_sum_of_squared_weights lucy_TermCompiler_sum_of_squared_weights
  #define TermCompiler_apply_norm_factor_t lucy_TermCompiler_apply_norm_factor_t
  #define TermCompiler_apply_norm_factor lucy_TermCompiler_apply_norm_factor
  #define TermCompiler_highlight_spans_t lucy_TermCompiler_highlight_spans_t
  #define TermCompiler_highlight_spans lucy_TermCompiler_highlight_spans
  #define TermCompiler_Make Lucy_TermCompiler_Make
  #define TermCompiler_Get_RefCount Lucy_TermCompiler_Get_RefCount
  #define TermCompiler_Inc_RefCount Lucy_TermCompiler_Inc_RefCount
  #define TermCompiler_Dec_RefCount Lucy_TermCompiler_Dec_RefCount
  #define TermCompiler_To_Host Lucy_TermCompiler_To_Host
  #define TermCompiler_Clone Lucy_TermCompiler_Clone
  #define TermCompiler_Destroy Lucy_TermCompiler_Destroy
  #define TermCompiler_Equals Lucy_TermCompiler_Equals
  #define TermCompiler_Compare_To Lucy_TermCompiler_Compare_To
  #define TermCompiler_Hash_Sum Lucy_TermCompiler_Hash_Sum
  #define TermCompiler_Get_VTable Lucy_TermCompiler_Get_VTable
  #define TermCompiler_Get_Class_Name Lucy_TermCompiler_Get_Class_Name
  #define TermCompiler_Is_A Lucy_TermCompiler_Is_A
  #define TermCompiler_To_String Lucy_TermCompiler_To_String
  #define TermCompiler_To_I64 Lucy_TermCompiler_To_I64
  #define TermCompiler_To_F64 Lucy_TermCompiler_To_F64
  #define TermCompiler_To_Bool Lucy_TermCompiler_To_Bool
  #define TermCompiler_Serialize Lucy_TermCompiler_Serialize
  #define TermCompiler_Deserialize Lucy_TermCompiler_Deserialize
  #define TermCompiler_Dump Lucy_TermCompiler_Dump
  #define TermCompiler_Load Lucy_TermCompiler_Load
  #define TermCompiler_Mimic Lucy_TermCompiler_Mimic
  #define TermCompiler_Make_Compiler Lucy_TermCompiler_Make_Compiler
  #define TermCompiler_Set_Boost Lucy_TermCompiler_Set_Boost
  #define TermCompiler_Get_Boost Lucy_TermCompiler_Get_Boost
  #define TermCompiler_Make_Matcher Lucy_TermCompiler_Make_Matcher
  #define TermCompiler_Get_Weight Lucy_TermCompiler_Get_Weight
  #define TermCompiler_Get_Similarity Lucy_TermCompiler_Get_Similarity
  #define TermCompiler_Get_Parent Lucy_TermCompiler_Get_Parent
  #define TermCompiler_Sum_Of_Squared_Weights Lucy_TermCompiler_Sum_Of_Squared_Weights
  #define TermCompiler_Apply_Norm_Factor Lucy_TermCompiler_Apply_Norm_Factor
  #define TermCompiler_Normalize Lucy_TermCompiler_Normalize
  #define TermCompiler_Highlight_Spans Lucy_TermCompiler_Highlight_Spans
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_TERMQUERY */




