/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_COMPOUNDFILEREADER
#define H_LUCY_STORE_COMPOUNDFILEREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/Folder.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_COMPOUNDFILEREADER
struct lucy_CompoundFileReader {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    lucy_Hash* entries;
    lucy_Folder* real_folder;
    lucy_Hash* records;
    lucy_InStream* instream;
    int32_t format;
};

#endif /* C_LUCY_COMPOUNDFILEREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_CompoundFileReader*
lucy_CFReader_open(lucy_Folder* folder);

lucy_CompoundFileReader*
lucy_CFReader_do_open(lucy_CompoundFileReader* self, lucy_Folder* folder);

void
lucy_CFReader_destroy(lucy_CompoundFileReader* self);

void
lucy_CFReader_set_path(lucy_CompoundFileReader* self, const lucy_CharBuf* path);

void
lucy_CFReader_close(lucy_CompoundFileReader* self);

lucy_FileHandle*
lucy_CFReader_local_open_filehandle(lucy_CompoundFileReader* self, const lucy_CharBuf* name, uint32_t flags);

lucy_InStream*
lucy_CFReader_local_open_in(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

lucy_DirHandle*
lucy_CFReader_local_open_dir(lucy_CompoundFileReader* self);

chy_bool_t
lucy_CFReader_local_mkdir(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

chy_bool_t
lucy_CFReader_local_exists(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

chy_bool_t
lucy_CFReader_local_is_directory(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

lucy_Folder*
lucy_CFReader_local_find_folder(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

chy_bool_t
lucy_CFReader_local_delete(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

lucy_Folder*
lucy_CFReader_get_real_folder(lucy_CompoundFileReader* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_CFReader_destroy_CALLBACK;
extern cfish_Callback lucy_CFReader_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_CFReader_destroy_t)(lucy_CompoundFileReader* self);

typedef void
(*lucy_CFReader_set_path_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* path);

typedef void
(*lucy_CFReader_close_t)(lucy_CompoundFileReader* self);

typedef lucy_FileHandle*
(*lucy_CFReader_local_open_filehandle_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name, uint32_t flags);

typedef lucy_InStream*
(*lucy_CFReader_local_open_in_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

typedef lucy_DirHandle*
(*lucy_CFReader_local_open_dir_t)(lucy_CompoundFileReader* self);

typedef chy_bool_t
(*lucy_CFReader_local_mkdir_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_CFReader_local_exists_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_CFReader_local_is_directory_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

typedef lucy_Folder*
(*lucy_CFReader_local_find_folder_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_CFReader_local_delete_t)(lucy_CompoundFileReader* self, const lucy_CharBuf* name);

typedef lucy_Folder*
(*lucy_CFReader_get_real_folder_t)(lucy_CompoundFileReader* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_CFReader_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReader_Make(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_CFReader_Get_RefCount(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReader_Inc_RefCount(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_CFReader_Dec_RefCount(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_CFReader_To_Host(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReader_Clone(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Destroy_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Destroy(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Destroy_OFFSET;
    const lucy_CFReader_destroy_t method = *((lucy_CFReader_destroy_t*)method_address);
    method((lucy_CompoundFileReader*)self);
}

extern size_t Lucy_CFReader_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Equals(const lucy_CompoundFileReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CFReader_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_CFReader_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_CFReader_Compare_To(const lucy_CompoundFileReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CFReader_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_CFReader_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_CFReader_Hash_Sum(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_CFReader_Get_VTable(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReader_Get_Class_Name(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Is_A(const lucy_CompoundFileReader *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_CFReader_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_CFReader_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReader_To_String(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_CFReader_To_I64(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_To_F64_OFFSET;
static CHY_INLINE double
Lucy_CFReader_To_F64(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_To_Bool(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Serialize_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Serialize(const lucy_CompoundFileReader *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_CFReader_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_CFReader_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReader_Deserialize(const lucy_CompoundFileReader *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_CFReader_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_CFReader_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReader_Dump(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReader_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReader_Load(const lucy_CompoundFileReader *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_CFReader_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_CFReader_Mimic_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Mimic(const lucy_CompoundFileReader *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CFReader_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_CFReader_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReader_Get_Path(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Get_Path_OFFSET;
    const lucy_Folder_get_path_t method = *((lucy_Folder_get_path_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_CFReader_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Set_Path(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Set_Path_OFFSET;
    const lucy_CFReader_set_path_t method = *((lucy_CFReader_set_path_t*)method_address);
    method((lucy_CompoundFileReader*)self, path);
}

extern size_t Lucy_CFReader_Open_Out_OFFSET;
static CHY_INLINE lucy_OutStream*
Lucy_CFReader_Open_Out(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Open_Out_OFFSET;
    const lucy_Folder_open_out_t method = *((lucy_Folder_open_out_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_CFReader_Open_In(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Open_In_OFFSET;
    const lucy_Folder_open_in_t method = *((lucy_Folder_open_in_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_CFReader_Open_FileHandle(const lucy_CompoundFileReader *self, const lucy_CharBuf* path, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_CFReader_Open_FileHandle_OFFSET;
    const lucy_Folder_open_filehandle_t method = *((lucy_Folder_open_filehandle_t*)method_address);
    return method((lucy_Folder*)self, path, flags);
}

extern size_t Lucy_CFReader_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_CFReader_Open_Dir(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Open_Dir_OFFSET;
    const lucy_Folder_open_dir_t method = *((lucy_Folder_open_dir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_MkDir(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_MkDir_OFFSET;
    const lucy_Folder_mkdir_t method = *((lucy_Folder_mkdir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_List_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_CFReader_List(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_List_OFFSET;
    const lucy_Folder_list_t method = *((lucy_Folder_list_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_List_R_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_CFReader_List_R(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_List_R_OFFSET;
    const lucy_Folder_list_r_t method = *((lucy_Folder_list_r_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Exists(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Exists_OFFSET;
    const lucy_Folder_exists_t method = *((lucy_Folder_exists_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Is_Directory(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Is_Directory_OFFSET;
    const lucy_Folder_is_directory_t method = *((lucy_Folder_is_directory_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Delete(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Delete_OFFSET;
    const lucy_Folder_delete_t method = *((lucy_Folder_delete_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Delete_Tree_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Delete_Tree(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Delete_Tree_OFFSET;
    const lucy_Folder_delete_tree_t method = *((lucy_Folder_delete_tree_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Rename_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Rename(const lucy_CompoundFileReader *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_CFReader_Rename_OFFSET;
    const lucy_Folder_rename_t method = *((lucy_Folder_rename_t*)method_address);
    return method((lucy_Folder*)self, from, to);
}

extern size_t Lucy_CFReader_Hard_Link_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Hard_Link(const lucy_CompoundFileReader *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_CFReader_Hard_Link_OFFSET;
    const lucy_Folder_hard_link_t method = *((lucy_Folder_hard_link_t*)method_address);
    return method((lucy_Folder*)self, from, to);
}

extern size_t Lucy_CFReader_Slurp_File_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_CFReader_Slurp_File(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Slurp_File_OFFSET;
    const lucy_Folder_slurp_file_t method = *((lucy_Folder_slurp_file_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Consolidate_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Consolidate(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Consolidate_OFFSET;
    const lucy_Folder_consolidate_t method = *((lucy_Folder_consolidate_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Enclosing_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_CFReader_Enclosing_Folder(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Enclosing_Folder_OFFSET;
    const lucy_Folder_enclosing_folder_t method = *((lucy_Folder_enclosing_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_CFReader_Find_Folder(const lucy_CompoundFileReader *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_CFReader_Find_Folder_OFFSET;
    const lucy_Folder_find_folder_t method = *((lucy_Folder_find_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_CFReader_Initialize_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Initialize(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Initialize_OFFSET;
    const lucy_Folder_initialize_t method = *((lucy_Folder_initialize_t*)method_address);
    method((lucy_Folder*)self);
}

extern size_t Lucy_CFReader_Check_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Check(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Check_OFFSET;
    const lucy_Folder_check_t method = *((lucy_Folder_check_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_CFReader_Close_OFFSET;
static CHY_INLINE void
Lucy_CFReader_Close(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Close_OFFSET;
    const lucy_CFReader_close_t method = *((lucy_CFReader_close_t*)method_address);
    method((lucy_CompoundFileReader*)self);
}

extern size_t Lucy_CFReader_Local_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_CFReader_Local_Open_FileHandle(const lucy_CompoundFileReader *self, const lucy_CharBuf* name, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Open_FileHandle_OFFSET;
    const lucy_CFReader_local_open_filehandle_t method = *((lucy_CFReader_local_open_filehandle_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name, flags);
}

extern size_t Lucy_CFReader_Local_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_CFReader_Local_Open_In(const lucy_CompoundFileReader *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Open_In_OFFSET;
    const lucy_CFReader_local_open_in_t method = *((lucy_CFReader_local_open_in_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name);
}

extern size_t Lucy_CFReader_Local_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_CFReader_Local_Open_Dir(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Open_Dir_OFFSET;
    const lucy_CFReader_local_open_dir_t method = *((lucy_CFReader_local_open_dir_t*)method_address);
    return method((lucy_CompoundFileReader*)self);
}

extern size_t Lucy_CFReader_Local_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Local_MkDir(const lucy_CompoundFileReader *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_MkDir_OFFSET;
    const lucy_CFReader_local_mkdir_t method = *((lucy_CFReader_local_mkdir_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name);
}

extern size_t Lucy_CFReader_Local_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Local_Exists(const lucy_CompoundFileReader *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Exists_OFFSET;
    const lucy_CFReader_local_exists_t method = *((lucy_CFReader_local_exists_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name);
}

extern size_t Lucy_CFReader_Local_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Local_Is_Directory(const lucy_CompoundFileReader *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Is_Directory_OFFSET;
    const lucy_CFReader_local_is_directory_t method = *((lucy_CFReader_local_is_directory_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name);
}

extern size_t Lucy_CFReader_Local_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_CFReader_Local_Find_Folder(const lucy_CompoundFileReader *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Find_Folder_OFFSET;
    const lucy_CFReader_local_find_folder_t method = *((lucy_CFReader_local_find_folder_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name);
}

extern size_t Lucy_CFReader_Local_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReader_Local_Delete(const lucy_CompoundFileReader *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_CFReader_Local_Delete_OFFSET;
    const lucy_CFReader_local_delete_t method = *((lucy_CFReader_local_delete_t*)method_address);
    return method((lucy_CompoundFileReader*)self, name);
}

extern size_t Lucy_CFReader_Get_Real_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_CFReader_Get_Real_Folder(const lucy_CompoundFileReader *self) {
    char *const method_address = *(char**)self + Lucy_CFReader_Get_Real_Folder_OFFSET;
    const lucy_CFReader_get_real_folder_t method = *((lucy_CFReader_get_real_folder_t*)method_address);
    return method((lucy_CompoundFileReader*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_COMPOUNDFILEREADER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[53];
} LUCY_COMPOUNDFILEREADER_VT;
extern struct LUCY_COMPOUNDFILEREADER_VT LUCY_COMPOUNDFILEREADER_vt;
#define LUCY_COMPOUNDFILEREADER ((cfish_VTable*)&LUCY_COMPOUNDFILEREADER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define CompoundFileReader lucy_CompoundFileReader
  #define COMPOUNDFILEREADER LUCY_COMPOUNDFILEREADER
  #define CFReader_open lucy_CFReader_open
  #define CFReader_do_open lucy_CFReader_do_open
  #define CFReader_destroy_t lucy_CFReader_destroy_t
  #define CFReader_destroy lucy_CFReader_destroy
  #define CFReader_set_path_t lucy_CFReader_set_path_t
  #define CFReader_set_path lucy_CFReader_set_path
  #define CFReader_close_t lucy_CFReader_close_t
  #define CFReader_close lucy_CFReader_close
  #define CFReader_local_open_filehandle_t lucy_CFReader_local_open_filehandle_t
  #define CFReader_local_open_filehandle lucy_CFReader_local_open_filehandle
  #define CFReader_local_open_in_t lucy_CFReader_local_open_in_t
  #define CFReader_local_open_in lucy_CFReader_local_open_in
  #define CFReader_local_open_dir_t lucy_CFReader_local_open_dir_t
  #define CFReader_local_open_dir lucy_CFReader_local_open_dir
  #define CFReader_local_mkdir_t lucy_CFReader_local_mkdir_t
  #define CFReader_local_mkdir lucy_CFReader_local_mkdir
  #define CFReader_local_exists_t lucy_CFReader_local_exists_t
  #define CFReader_local_exists lucy_CFReader_local_exists
  #define CFReader_local_is_directory_t lucy_CFReader_local_is_directory_t
  #define CFReader_local_is_directory lucy_CFReader_local_is_directory
  #define CFReader_local_find_folder_t lucy_CFReader_local_find_folder_t
  #define CFReader_local_find_folder lucy_CFReader_local_find_folder
  #define CFReader_local_delete_t lucy_CFReader_local_delete_t
  #define CFReader_local_delete lucy_CFReader_local_delete
  #define CFReader_get_real_folder_t lucy_CFReader_get_real_folder_t
  #define CFReader_get_real_folder lucy_CFReader_get_real_folder
  #define CFReader_Make Lucy_CFReader_Make
  #define CFReader_Get_RefCount Lucy_CFReader_Get_RefCount
  #define CFReader_Inc_RefCount Lucy_CFReader_Inc_RefCount
  #define CFReader_Dec_RefCount Lucy_CFReader_Dec_RefCount
  #define CFReader_To_Host Lucy_CFReader_To_Host
  #define CFReader_Clone Lucy_CFReader_Clone
  #define CFReader_Destroy Lucy_CFReader_Destroy
  #define CFReader_Equals Lucy_CFReader_Equals
  #define CFReader_Compare_To Lucy_CFReader_Compare_To
  #define CFReader_Hash_Sum Lucy_CFReader_Hash_Sum
  #define CFReader_Get_VTable Lucy_CFReader_Get_VTable
  #define CFReader_Get_Class_Name Lucy_CFReader_Get_Class_Name
  #define CFReader_Is_A Lucy_CFReader_Is_A
  #define CFReader_To_String Lucy_CFReader_To_String
  #define CFReader_To_I64 Lucy_CFReader_To_I64
  #define CFReader_To_F64 Lucy_CFReader_To_F64
  #define CFReader_To_Bool Lucy_CFReader_To_Bool
  #define CFReader_Serialize Lucy_CFReader_Serialize
  #define CFReader_Deserialize Lucy_CFReader_Deserialize
  #define CFReader_Dump Lucy_CFReader_Dump
  #define CFReader_Load Lucy_CFReader_Load
  #define CFReader_Mimic Lucy_CFReader_Mimic
  #define CFReader_Get_Path Lucy_CFReader_Get_Path
  #define CFReader_Set_Path Lucy_CFReader_Set_Path
  #define CFReader_Open_Out Lucy_CFReader_Open_Out
  #define CFReader_Open_In Lucy_CFReader_Open_In
  #define CFReader_Open_FileHandle Lucy_CFReader_Open_FileHandle
  #define CFReader_Open_Dir Lucy_CFReader_Open_Dir
  #define CFReader_MkDir Lucy_CFReader_MkDir
  #define CFReader_List Lucy_CFReader_List
  #define CFReader_List_R Lucy_CFReader_List_R
  #define CFReader_Exists Lucy_CFReader_Exists
  #define CFReader_Is_Directory Lucy_CFReader_Is_Directory
  #define CFReader_Delete Lucy_CFReader_Delete
  #define CFReader_Delete_Tree Lucy_CFReader_Delete_Tree
  #define CFReader_Rename Lucy_CFReader_Rename
  #define CFReader_Hard_Link Lucy_CFReader_Hard_Link
  #define CFReader_Slurp_File Lucy_CFReader_Slurp_File
  #define CFReader_Consolidate Lucy_CFReader_Consolidate
  #define CFReader_Enclosing_Folder Lucy_CFReader_Enclosing_Folder
  #define CFReader_Find_Folder Lucy_CFReader_Find_Folder
  #define CFReader_Initialize Lucy_CFReader_Initialize
  #define CFReader_Check Lucy_CFReader_Check
  #define CFReader_Close Lucy_CFReader_Close
  #define CFReader_Local_Open_FileHandle Lucy_CFReader_Local_Open_FileHandle
  #define CFReader_Local_Open_In Lucy_CFReader_Local_Open_In
  #define CFReader_Local_Open_Dir Lucy_CFReader_Local_Open_Dir
  #define CFReader_Local_MkDir Lucy_CFReader_Local_MkDir
  #define CFReader_Local_Exists Lucy_CFReader_Local_Exists
  #define CFReader_Local_Is_Directory Lucy_CFReader_Local_Is_Directory
  #define CFReader_Local_Find_Folder Lucy_CFReader_Local_Find_Folder
  #define CFReader_Local_Delete Lucy_CFReader_Local_Delete
  #define CFReader_Get_Real_Folder Lucy_CFReader_Get_Real_Folder
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/DirHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_CFREADERDIRHANDLE
struct lucy_CFReaderDirHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* dir;
    lucy_CharBuf* entry;
    lucy_CompoundFileReader* cf_reader;
    lucy_VArray* elems;
    int32_t tick;
};

#endif /* C_LUCY_CFREADERDIRHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_CFReaderDirHandle*
lucy_CFReaderDH_new(lucy_CompoundFileReader* cf_reader);

lucy_CFReaderDirHandle*
lucy_CFReaderDH_init(lucy_CFReaderDirHandle* self, lucy_CompoundFileReader* cf_reader);

chy_bool_t
lucy_CFReaderDH_next(lucy_CFReaderDirHandle* self);

chy_bool_t
lucy_CFReaderDH_close(lucy_CFReaderDirHandle* self);

chy_bool_t
lucy_CFReaderDH_entry_is_dir(lucy_CFReaderDirHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_CFReaderDH_next_t)(lucy_CFReaderDirHandle* self);

typedef chy_bool_t
(*lucy_CFReaderDH_close_t)(lucy_CFReaderDirHandle* self);

typedef chy_bool_t
(*lucy_CFReaderDH_entry_is_dir_t)(lucy_CFReaderDirHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_CFReaderDH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReaderDH_Make(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_CFReaderDH_Get_RefCount(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReaderDH_Inc_RefCount(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_CFReaderDH_Dec_RefCount(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_CFReaderDH_To_Host(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReaderDH_Clone(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_CFReaderDH_Destroy(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Destroy_OFFSET;
    const lucy_DH_destroy_t method = *((lucy_DH_destroy_t*)method_address);
    method((lucy_DirHandle*)self);
}

extern size_t Lucy_CFReaderDH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_Equals(const lucy_CFReaderDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_CFReaderDH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_CFReaderDH_Compare_To(const lucy_CFReaderDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_CFReaderDH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_CFReaderDH_Hash_Sum(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_CFReaderDH_Get_VTable(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReaderDH_Get_Class_Name(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_Is_A(const lucy_CFReaderDirHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_CFReaderDH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReaderDH_To_String(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_CFReaderDH_To_I64(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_CFReaderDH_To_F64(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_To_Bool(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_CFReaderDH_Serialize(const lucy_CFReaderDirHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_CFReaderDH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReaderDH_Deserialize(const lucy_CFReaderDirHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_CFReaderDH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReaderDH_Dump(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_CFReaderDH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_CFReaderDH_Load(const lucy_CFReaderDirHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_CFReaderDH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_CFReaderDH_Mimic(const lucy_CFReaderDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_CFReaderDH_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_Next(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Next_OFFSET;
    const lucy_CFReaderDH_next_t method = *((lucy_CFReaderDH_next_t*)method_address);
    return method((lucy_CFReaderDirHandle*)self);
}

extern size_t Lucy_CFReaderDH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_Close(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Close_OFFSET;
    const lucy_CFReaderDH_close_t method = *((lucy_CFReaderDH_close_t*)method_address);
    return method((lucy_CFReaderDirHandle*)self);
}

extern size_t Lucy_CFReaderDH_Get_Dir_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReaderDH_Get_Dir(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Get_Dir_OFFSET;
    const lucy_DH_get_dir_t method = *((lucy_DH_get_dir_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_CFReaderDH_Get_Entry_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_CFReaderDH_Get_Entry(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Get_Entry_OFFSET;
    const lucy_DH_get_entry_t method = *((lucy_DH_get_entry_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_CFReaderDH_Entry_Is_Dir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_Entry_Is_Dir(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Entry_Is_Dir_OFFSET;
    const lucy_CFReaderDH_entry_is_dir_t method = *((lucy_CFReaderDH_entry_is_dir_t*)method_address);
    return method((lucy_CFReaderDirHandle*)self);
}

extern size_t Lucy_CFReaderDH_Entry_Is_Symlink_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_CFReaderDH_Entry_Is_Symlink(const lucy_CFReaderDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_CFReaderDH_Entry_Is_Symlink_OFFSET;
    const lucy_DH_entry_is_symlink_t method = *((lucy_DH_entry_is_symlink_t*)method_address);
    return method((lucy_DirHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_CFREADERDIRHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_CFREADERDIRHANDLE_VT;
extern struct LUCY_CFREADERDIRHANDLE_VT LUCY_CFREADERDIRHANDLE_vt;
#define LUCY_CFREADERDIRHANDLE ((cfish_VTable*)&LUCY_CFREADERDIRHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define CFReaderDirHandle lucy_CFReaderDirHandle
  #define CFREADERDIRHANDLE LUCY_CFREADERDIRHANDLE
  #define CFReaderDH_new lucy_CFReaderDH_new
  #define CFReaderDH_init lucy_CFReaderDH_init
  #define CFReaderDH_next_t lucy_CFReaderDH_next_t
  #define CFReaderDH_next lucy_CFReaderDH_next
  #define CFReaderDH_close_t lucy_CFReaderDH_close_t
  #define CFReaderDH_close lucy_CFReaderDH_close
  #define CFReaderDH_entry_is_dir_t lucy_CFReaderDH_entry_is_dir_t
  #define CFReaderDH_entry_is_dir lucy_CFReaderDH_entry_is_dir
  #define CFReaderDH_Make Lucy_CFReaderDH_Make
  #define CFReaderDH_Get_RefCount Lucy_CFReaderDH_Get_RefCount
  #define CFReaderDH_Inc_RefCount Lucy_CFReaderDH_Inc_RefCount
  #define CFReaderDH_Dec_RefCount Lucy_CFReaderDH_Dec_RefCount
  #define CFReaderDH_To_Host Lucy_CFReaderDH_To_Host
  #define CFReaderDH_Clone Lucy_CFReaderDH_Clone
  #define CFReaderDH_Destroy Lucy_CFReaderDH_Destroy
  #define CFReaderDH_Equals Lucy_CFReaderDH_Equals
  #define CFReaderDH_Compare_To Lucy_CFReaderDH_Compare_To
  #define CFReaderDH_Hash_Sum Lucy_CFReaderDH_Hash_Sum
  #define CFReaderDH_Get_VTable Lucy_CFReaderDH_Get_VTable
  #define CFReaderDH_Get_Class_Name Lucy_CFReaderDH_Get_Class_Name
  #define CFReaderDH_Is_A Lucy_CFReaderDH_Is_A
  #define CFReaderDH_To_String Lucy_CFReaderDH_To_String
  #define CFReaderDH_To_I64 Lucy_CFReaderDH_To_I64
  #define CFReaderDH_To_F64 Lucy_CFReaderDH_To_F64
  #define CFReaderDH_To_Bool Lucy_CFReaderDH_To_Bool
  #define CFReaderDH_Serialize Lucy_CFReaderDH_Serialize
  #define CFReaderDH_Deserialize Lucy_CFReaderDH_Deserialize
  #define CFReaderDH_Dump Lucy_CFReaderDH_Dump
  #define CFReaderDH_Load Lucy_CFReaderDH_Load
  #define CFReaderDH_Mimic Lucy_CFReaderDH_Mimic
  #define CFReaderDH_Next Lucy_CFReaderDH_Next
  #define CFReaderDH_Close Lucy_CFReaderDH_Close
  #define CFReaderDH_Get_Dir Lucy_CFReaderDH_Get_Dir
  #define CFReaderDH_Get_Entry Lucy_CFReaderDH_Get_Entry
  #define CFReaderDH_Entry_Is_Dir Lucy_CFReaderDH_Entry_Is_Dir
  #define CFReaderDH_Entry_Is_Symlink Lucy_CFReaderDH_Entry_Is_Symlink
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_COMPOUNDFILEREADER */




