/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_DIRHANDLE
#define H_LUCY_STORE_DIRHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DIRHANDLE
struct lucy_DirHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* dir;
    lucy_CharBuf* entry;
};

#endif /* C_LUCY_DIRHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_DirHandle*
lucy_DH_init(lucy_DirHandle* self, const lucy_CharBuf* dir);

void
lucy_DH_destroy(lucy_DirHandle* self);

chy_bool_t
lucy_DH_next(lucy_DirHandle* self);

chy_bool_t
lucy_DH_close(lucy_DirHandle* self);

lucy_CharBuf*
lucy_DH_get_dir(lucy_DirHandle* self);

lucy_CharBuf*
lucy_DH_get_entry(lucy_DirHandle* self);

chy_bool_t
lucy_DH_entry_is_dir(lucy_DirHandle* self);

chy_bool_t
lucy_DH_entry_is_symlink(lucy_DirHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_DH_destroy_CALLBACK;
extern cfish_Callback lucy_DH_next_CALLBACK;
extern cfish_Callback lucy_DH_close_CALLBACK;
extern cfish_Callback lucy_DH_entry_is_dir_CALLBACK;
extern cfish_Callback lucy_DH_entry_is_symlink_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_DH_destroy_t)(lucy_DirHandle* self);

typedef chy_bool_t
(*lucy_DH_next_t)(lucy_DirHandle* self);

typedef chy_bool_t
(*lucy_DH_close_t)(lucy_DirHandle* self);

typedef lucy_CharBuf*
(*lucy_DH_get_dir_t)(lucy_DirHandle* self);

typedef lucy_CharBuf*
(*lucy_DH_get_entry_t)(lucy_DirHandle* self);

typedef chy_bool_t
(*lucy_DH_entry_is_dir_t)(lucy_DirHandle* self);

typedef chy_bool_t
(*lucy_DH_entry_is_symlink_t)(lucy_DirHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_DH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DH_Make(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DH_Get_RefCount(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DH_Inc_RefCount(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_DH_Dec_RefCount(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_DH_To_Host(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DH_Clone(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_DH_Destroy(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Destroy_OFFSET;
    const lucy_DH_destroy_t method = *((lucy_DH_destroy_t*)method_address);
    method((lucy_DirHandle*)self);
}

extern size_t Lucy_DH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_Equals(const lucy_DirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_DH_Compare_To(const lucy_DirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_DH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_DH_Hash_Sum(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_DH_Get_VTable(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DH_Get_Class_Name(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_Is_A(const lucy_DirHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_DH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_DH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DH_To_String(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_DH_To_I64(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_DH_To_F64(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_To_Bool(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_DH_Serialize(const lucy_DirHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_DH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_DH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DH_Deserialize(const lucy_DirHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_DH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_DH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DH_Dump(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_DH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_DH_Load(const lucy_DirHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_DH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_DH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_DH_Mimic(const lucy_DirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_DH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_DH_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_Next(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Next_OFFSET;
    const lucy_DH_next_t method = *((lucy_DH_next_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_DH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_Close(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Close_OFFSET;
    const lucy_DH_close_t method = *((lucy_DH_close_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_DH_Get_Dir_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DH_Get_Dir(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Get_Dir_OFFSET;
    const lucy_DH_get_dir_t method = *((lucy_DH_get_dir_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_DH_Get_Entry_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_DH_Get_Entry(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Get_Entry_OFFSET;
    const lucy_DH_get_entry_t method = *((lucy_DH_get_entry_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_DH_Entry_Is_Dir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_Entry_Is_Dir(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Entry_Is_Dir_OFFSET;
    const lucy_DH_entry_is_dir_t method = *((lucy_DH_entry_is_dir_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_DH_Entry_Is_Symlink_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_DH_Entry_Is_Symlink(const lucy_DirHandle *self) {
    char *const method_address = *(char**)self + Lucy_DH_Entry_Is_Symlink_OFFSET;
    const lucy_DH_entry_is_symlink_t method = *((lucy_DH_entry_is_symlink_t*)method_address);
    return method((lucy_DirHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_DIRHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_DIRHANDLE_VT;
extern struct LUCY_DIRHANDLE_VT LUCY_DIRHANDLE_vt;
#define LUCY_DIRHANDLE ((cfish_VTable*)&LUCY_DIRHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DirHandle lucy_DirHandle
  #define DIRHANDLE LUCY_DIRHANDLE
  #define DH_init lucy_DH_init
  #define DH_destroy_t lucy_DH_destroy_t
  #define DH_destroy lucy_DH_destroy
  #define DH_next_t lucy_DH_next_t
  #define DH_next lucy_DH_next
  #define DH_close_t lucy_DH_close_t
  #define DH_close lucy_DH_close
  #define DH_get_dir_t lucy_DH_get_dir_t
  #define DH_get_dir lucy_DH_get_dir
  #define DH_get_entry_t lucy_DH_get_entry_t
  #define DH_get_entry lucy_DH_get_entry
  #define DH_entry_is_dir_t lucy_DH_entry_is_dir_t
  #define DH_entry_is_dir lucy_DH_entry_is_dir
  #define DH_entry_is_symlink_t lucy_DH_entry_is_symlink_t
  #define DH_entry_is_symlink lucy_DH_entry_is_symlink
  #define DH_Make Lucy_DH_Make
  #define DH_Get_RefCount Lucy_DH_Get_RefCount
  #define DH_Inc_RefCount Lucy_DH_Inc_RefCount
  #define DH_Dec_RefCount Lucy_DH_Dec_RefCount
  #define DH_To_Host Lucy_DH_To_Host
  #define DH_Clone Lucy_DH_Clone
  #define DH_Destroy Lucy_DH_Destroy
  #define DH_Equals Lucy_DH_Equals
  #define DH_Compare_To Lucy_DH_Compare_To
  #define DH_Hash_Sum Lucy_DH_Hash_Sum
  #define DH_Get_VTable Lucy_DH_Get_VTable
  #define DH_Get_Class_Name Lucy_DH_Get_Class_Name
  #define DH_Is_A Lucy_DH_Is_A
  #define DH_To_String Lucy_DH_To_String
  #define DH_To_I64 Lucy_DH_To_I64
  #define DH_To_F64 Lucy_DH_To_F64
  #define DH_To_Bool Lucy_DH_To_Bool
  #define DH_Serialize Lucy_DH_Serialize
  #define DH_Deserialize Lucy_DH_Deserialize
  #define DH_Dump Lucy_DH_Dump
  #define DH_Load Lucy_DH_Load
  #define DH_Mimic Lucy_DH_Mimic
  #define DH_Next Lucy_DH_Next
  #define DH_Close Lucy_DH_Close
  #define DH_Get_Dir Lucy_DH_Get_Dir
  #define DH_Get_Entry Lucy_DH_Get_Entry
  #define DH_Entry_Is_Dir Lucy_DH_Entry_Is_Dir
  #define DH_Entry_Is_Symlink Lucy_DH_Entry_Is_Symlink
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_DIRHANDLE */




