/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_FSDIRHANDLE
#define H_LUCY_STORE_FSDIRHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/DirHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FSDIRHANDLE
struct lucy_FSDirHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* dir;
    lucy_CharBuf* entry;
    void* sys_dirhandle;
    void* sys_dir_entry;
    lucy_CharBuf* fullpath;
    lucy_Err* saved_error;
    chy_bool_t delayed_iter;
};

#endif /* C_LUCY_FSDIRHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_FSDirHandle*
lucy_FSDH_open(const lucy_CharBuf* path);

lucy_FSDirHandle*
lucy_FSDH_do_open(lucy_FSDirHandle* self, const lucy_CharBuf* path);

void
lucy_FSDH_destroy(lucy_FSDirHandle* self);

chy_bool_t
lucy_FSDH_next(lucy_FSDirHandle* self);

chy_bool_t
lucy_FSDH_close(lucy_FSDirHandle* self);

chy_bool_t
lucy_FSDH_entry_is_dir(lucy_FSDirHandle* self);

chy_bool_t
lucy_FSDH_entry_is_symlink(lucy_FSDirHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_FSDH_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_FSDH_destroy_t)(lucy_FSDirHandle* self);

typedef chy_bool_t
(*lucy_FSDH_next_t)(lucy_FSDirHandle* self);

typedef chy_bool_t
(*lucy_FSDH_close_t)(lucy_FSDirHandle* self);

typedef chy_bool_t
(*lucy_FSDH_entry_is_dir_t)(lucy_FSDirHandle* self);

typedef chy_bool_t
(*lucy_FSDH_entry_is_symlink_t)(lucy_FSDirHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_FSDH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSDH_Make(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FSDH_Get_RefCount(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSDH_Inc_RefCount(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FSDH_Dec_RefCount(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_FSDH_To_Host(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSDH_Clone(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_FSDH_Destroy(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Destroy_OFFSET;
    const lucy_FSDH_destroy_t method = *((lucy_FSDH_destroy_t*)method_address);
    method((lucy_FSDirHandle*)self);
}

extern size_t Lucy_FSDH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_Equals(const lucy_FSDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSDH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSDH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_FSDH_Compare_To(const lucy_FSDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSDH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSDH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_FSDH_Hash_Sum(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_FSDH_Get_VTable(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSDH_Get_Class_Name(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_Is_A(const lucy_FSDirHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_FSDH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_FSDH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSDH_To_String(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_FSDH_To_I64(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_FSDH_To_F64(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_To_Bool(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_FSDH_Serialize(const lucy_FSDirHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_FSDH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_FSDH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSDH_Deserialize(const lucy_FSDirHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_FSDH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_FSDH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSDH_Dump(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSDH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSDH_Load(const lucy_FSDirHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_FSDH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_FSDH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_FSDH_Mimic(const lucy_FSDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSDH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSDH_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_Next(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Next_OFFSET;
    const lucy_FSDH_next_t method = *((lucy_FSDH_next_t*)method_address);
    return method((lucy_FSDirHandle*)self);
}

extern size_t Lucy_FSDH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_Close(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Close_OFFSET;
    const lucy_FSDH_close_t method = *((lucy_FSDH_close_t*)method_address);
    return method((lucy_FSDirHandle*)self);
}

extern size_t Lucy_FSDH_Get_Dir_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSDH_Get_Dir(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Get_Dir_OFFSET;
    const lucy_DH_get_dir_t method = *((lucy_DH_get_dir_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_FSDH_Get_Entry_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSDH_Get_Entry(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Get_Entry_OFFSET;
    const lucy_DH_get_entry_t method = *((lucy_DH_get_entry_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_FSDH_Entry_Is_Dir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_Entry_Is_Dir(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Entry_Is_Dir_OFFSET;
    const lucy_FSDH_entry_is_dir_t method = *((lucy_FSDH_entry_is_dir_t*)method_address);
    return method((lucy_FSDirHandle*)self);
}

extern size_t Lucy_FSDH_Entry_Is_Symlink_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSDH_Entry_Is_Symlink(const lucy_FSDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSDH_Entry_Is_Symlink_OFFSET;
    const lucy_FSDH_entry_is_symlink_t method = *((lucy_FSDH_entry_is_symlink_t*)method_address);
    return method((lucy_FSDirHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FSDIRHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_FSDIRHANDLE_VT;
extern struct LUCY_FSDIRHANDLE_VT LUCY_FSDIRHANDLE_vt;
#define LUCY_FSDIRHANDLE ((cfish_VTable*)&LUCY_FSDIRHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FSDirHandle lucy_FSDirHandle
  #define FSDIRHANDLE LUCY_FSDIRHANDLE
  #define FSDH_open lucy_FSDH_open
  #define FSDH_do_open lucy_FSDH_do_open
  #define FSDH_destroy_t lucy_FSDH_destroy_t
  #define FSDH_destroy lucy_FSDH_destroy
  #define FSDH_next_t lucy_FSDH_next_t
  #define FSDH_next lucy_FSDH_next
  #define FSDH_close_t lucy_FSDH_close_t
  #define FSDH_close lucy_FSDH_close
  #define FSDH_entry_is_dir_t lucy_FSDH_entry_is_dir_t
  #define FSDH_entry_is_dir lucy_FSDH_entry_is_dir
  #define FSDH_entry_is_symlink_t lucy_FSDH_entry_is_symlink_t
  #define FSDH_entry_is_symlink lucy_FSDH_entry_is_symlink
  #define FSDH_Make Lucy_FSDH_Make
  #define FSDH_Get_RefCount Lucy_FSDH_Get_RefCount
  #define FSDH_Inc_RefCount Lucy_FSDH_Inc_RefCount
  #define FSDH_Dec_RefCount Lucy_FSDH_Dec_RefCount
  #define FSDH_To_Host Lucy_FSDH_To_Host
  #define FSDH_Clone Lucy_FSDH_Clone
  #define FSDH_Destroy Lucy_FSDH_Destroy
  #define FSDH_Equals Lucy_FSDH_Equals
  #define FSDH_Compare_To Lucy_FSDH_Compare_To
  #define FSDH_Hash_Sum Lucy_FSDH_Hash_Sum
  #define FSDH_Get_VTable Lucy_FSDH_Get_VTable
  #define FSDH_Get_Class_Name Lucy_FSDH_Get_Class_Name
  #define FSDH_Is_A Lucy_FSDH_Is_A
  #define FSDH_To_String Lucy_FSDH_To_String
  #define FSDH_To_I64 Lucy_FSDH_To_I64
  #define FSDH_To_F64 Lucy_FSDH_To_F64
  #define FSDH_To_Bool Lucy_FSDH_To_Bool
  #define FSDH_Serialize Lucy_FSDH_Serialize
  #define FSDH_Deserialize Lucy_FSDH_Deserialize
  #define FSDH_Dump Lucy_FSDH_Dump
  #define FSDH_Load Lucy_FSDH_Load
  #define FSDH_Mimic Lucy_FSDH_Mimic
  #define FSDH_Next Lucy_FSDH_Next
  #define FSDH_Close Lucy_FSDH_Close
  #define FSDH_Get_Dir Lucy_FSDH_Get_Dir
  #define FSDH_Get_Entry Lucy_FSDH_Get_Entry
  #define FSDH_Entry_Is_Dir Lucy_FSDH_Entry_Is_Dir
  #define FSDH_Entry_Is_Symlink Lucy_FSDH_Entry_Is_Symlink
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_FSDIRHANDLE */




