/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_FSFILEHANDLE
#define H_LUCY_STORE_FSFILEHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/FileHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FSFILEHANDLE
struct lucy_FSFileHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    uint32_t flags;
    int fd;
    void* win_fhandle;
    void* win_maphandle;
    int64_t len;
    int64_t page_size;
    char* buf;
};

#endif /* C_LUCY_FSFILEHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_FSFileHandle*
lucy_FSFH_open(const lucy_CharBuf* path, uint32_t flags);

lucy_FSFileHandle*
lucy_FSFH_do_open(lucy_FSFileHandle* self, const lucy_CharBuf* path, uint32_t flags);

chy_bool_t
lucy_FSFH_window(lucy_FSFileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

chy_bool_t
lucy_FSFH_release_window(lucy_FSFileHandle* self, lucy_FileWindow* window);

chy_bool_t
lucy_FSFH_read(lucy_FSFileHandle* self, char* dest, int64_t offset, size_t len);

chy_bool_t
lucy_FSFH_write(lucy_FSFileHandle* self, const void* data, size_t len);

int64_t
lucy_FSFH_length(lucy_FSFileHandle* self);

chy_bool_t
lucy_FSFH_close(lucy_FSFileHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_FSFH_window_t)(lucy_FSFileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

typedef chy_bool_t
(*lucy_FSFH_release_window_t)(lucy_FSFileHandle* self, lucy_FileWindow* window);

typedef chy_bool_t
(*lucy_FSFH_read_t)(lucy_FSFileHandle* self, char* dest, int64_t offset, size_t len);

typedef chy_bool_t
(*lucy_FSFH_write_t)(lucy_FSFileHandle* self, const void* data, size_t len);

typedef int64_t
(*lucy_FSFH_length_t)(lucy_FSFileHandle* self);

typedef chy_bool_t
(*lucy_FSFH_close_t)(lucy_FSFileHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_FSFH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFH_Make(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FSFH_Get_RefCount(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFH_Inc_RefCount(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FSFH_Dec_RefCount(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_FSFH_To_Host(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFH_Clone(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_FSFH_Destroy(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Destroy_OFFSET;
    const lucy_FH_destroy_t method = *((lucy_FH_destroy_t*)method_address);
    method((lucy_FileHandle*)self);
}

extern size_t Lucy_FSFH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Equals(const lucy_FSFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSFH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSFH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_FSFH_Compare_To(const lucy_FSFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSFH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSFH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_FSFH_Hash_Sum(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_FSFH_Get_VTable(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSFH_Get_Class_Name(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Is_A(const lucy_FSFileHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_FSFH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_FSFH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSFH_To_String(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_FSFH_To_I64(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_FSFH_To_F64(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_To_Bool(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_FSFH_Serialize(const lucy_FSFileHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_FSFH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_FSFH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFH_Deserialize(const lucy_FSFileHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_FSFH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_FSFH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFH_Dump(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFH_Load(const lucy_FSFileHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_FSFH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_FSFH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_FSFH_Mimic(const lucy_FSFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSFH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSFH_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Window(const lucy_FSFileHandle *self, lucy_FileWindow* window, int64_t offset, int64_t len) {
    char *const method_address = *(char**)self + Lucy_FSFH_Window_OFFSET;
    const lucy_FSFH_window_t method = *((lucy_FSFH_window_t*)method_address);
    return method((lucy_FSFileHandle*)self, window, offset, len);
}

extern size_t Lucy_FSFH_Release_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Release_Window(const lucy_FSFileHandle *self, lucy_FileWindow* window) {
    char *const method_address = *(char**)self + Lucy_FSFH_Release_Window_OFFSET;
    const lucy_FSFH_release_window_t method = *((lucy_FSFH_release_window_t*)method_address);
    return method((lucy_FSFileHandle*)self, window);
}

extern size_t Lucy_FSFH_Read_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Read(const lucy_FSFileHandle *self, char* dest, int64_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_FSFH_Read_OFFSET;
    const lucy_FSFH_read_t method = *((lucy_FSFH_read_t*)method_address);
    return method((lucy_FSFileHandle*)self, dest, offset, len);
}

extern size_t Lucy_FSFH_Write_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Write(const lucy_FSFileHandle *self, const void* data, size_t len) {
    char *const method_address = *(char**)self + Lucy_FSFH_Write_OFFSET;
    const lucy_FSFH_write_t method = *((lucy_FSFH_write_t*)method_address);
    return method((lucy_FSFileHandle*)self, data, len);
}

extern size_t Lucy_FSFH_Length_OFFSET;
static CHY_INLINE int64_t
Lucy_FSFH_Length(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Length_OFFSET;
    const lucy_FSFH_length_t method = *((lucy_FSFH_length_t*)method_address);
    return method((lucy_FSFileHandle*)self);
}

extern size_t Lucy_FSFH_Grow_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Grow(const lucy_FSFileHandle *self, int64_t len) {
    char *const method_address = *(char**)self + Lucy_FSFH_Grow_OFFSET;
    const lucy_FH_grow_t method = *((lucy_FH_grow_t*)method_address);
    return method((lucy_FileHandle*)self, len);
}

extern size_t Lucy_FSFH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFH_Close(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Close_OFFSET;
    const lucy_FSFH_close_t method = *((lucy_FSFH_close_t*)method_address);
    return method((lucy_FSFileHandle*)self);
}

extern size_t Lucy_FSFH_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_FSFH_Set_Path(const lucy_FSFileHandle *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFH_Set_Path_OFFSET;
    const lucy_FH_set_path_t method = *((lucy_FH_set_path_t*)method_address);
    method((lucy_FileHandle*)self, path);
}

extern size_t Lucy_FSFH_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSFH_Get_Path(const lucy_FSFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FSFH_Get_Path_OFFSET;
    const lucy_FH_get_path_t method = *((lucy_FH_get_path_t*)method_address);
    return method((lucy_FileHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FSFILEHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_FSFILEHANDLE_VT;
extern struct LUCY_FSFILEHANDLE_VT LUCY_FSFILEHANDLE_vt;
#define LUCY_FSFILEHANDLE ((cfish_VTable*)&LUCY_FSFILEHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FSFileHandle lucy_FSFileHandle
  #define FSFILEHANDLE LUCY_FSFILEHANDLE
  #define FSFH_open lucy_FSFH_open
  #define FSFH_do_open lucy_FSFH_do_open
  #define FSFH_window_t lucy_FSFH_window_t
  #define FSFH_window lucy_FSFH_window
  #define FSFH_release_window_t lucy_FSFH_release_window_t
  #define FSFH_release_window lucy_FSFH_release_window
  #define FSFH_read_t lucy_FSFH_read_t
  #define FSFH_read lucy_FSFH_read
  #define FSFH_write_t lucy_FSFH_write_t
  #define FSFH_write lucy_FSFH_write
  #define FSFH_length_t lucy_FSFH_length_t
  #define FSFH_length lucy_FSFH_length
  #define FSFH_close_t lucy_FSFH_close_t
  #define FSFH_close lucy_FSFH_close
  #define FSFH_Make Lucy_FSFH_Make
  #define FSFH_Get_RefCount Lucy_FSFH_Get_RefCount
  #define FSFH_Inc_RefCount Lucy_FSFH_Inc_RefCount
  #define FSFH_Dec_RefCount Lucy_FSFH_Dec_RefCount
  #define FSFH_To_Host Lucy_FSFH_To_Host
  #define FSFH_Clone Lucy_FSFH_Clone
  #define FSFH_Destroy Lucy_FSFH_Destroy
  #define FSFH_Equals Lucy_FSFH_Equals
  #define FSFH_Compare_To Lucy_FSFH_Compare_To
  #define FSFH_Hash_Sum Lucy_FSFH_Hash_Sum
  #define FSFH_Get_VTable Lucy_FSFH_Get_VTable
  #define FSFH_Get_Class_Name Lucy_FSFH_Get_Class_Name
  #define FSFH_Is_A Lucy_FSFH_Is_A
  #define FSFH_To_String Lucy_FSFH_To_String
  #define FSFH_To_I64 Lucy_FSFH_To_I64
  #define FSFH_To_F64 Lucy_FSFH_To_F64
  #define FSFH_To_Bool Lucy_FSFH_To_Bool
  #define FSFH_Serialize Lucy_FSFH_Serialize
  #define FSFH_Deserialize Lucy_FSFH_Deserialize
  #define FSFH_Dump Lucy_FSFH_Dump
  #define FSFH_Load Lucy_FSFH_Load
  #define FSFH_Mimic Lucy_FSFH_Mimic
  #define FSFH_Window Lucy_FSFH_Window
  #define FSFH_Release_Window Lucy_FSFH_Release_Window
  #define FSFH_Read Lucy_FSFH_Read
  #define FSFH_Write Lucy_FSFH_Write
  #define FSFH_Length Lucy_FSFH_Length
  #define FSFH_Grow Lucy_FSFH_Grow
  #define FSFH_Close Lucy_FSFH_Close
  #define FSFH_Set_Path Lucy_FSFH_Set_Path
  #define FSFH_Get_Path Lucy_FSFH_Get_Path
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_FSFILEHANDLE */




