/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_FSFOLDER
#define H_LUCY_STORE_FSFOLDER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/Folder.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FSFOLDER
struct lucy_FSFolder {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    lucy_Hash* entries;
};

#endif /* C_LUCY_FSFOLDER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_FSFolder*
lucy_FSFolder_new(const lucy_CharBuf* path);

lucy_FSFolder*
lucy_FSFolder_init(lucy_FSFolder* self, const lucy_CharBuf* path);

lucy_CharBuf*
lucy_FSFolder_absolutify(const lucy_CharBuf* path);

chy_bool_t
lucy_FSFolder_rename(lucy_FSFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

chy_bool_t
lucy_FSFolder_hard_link(lucy_FSFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

void
lucy_FSFolder_initialize(lucy_FSFolder* self);

chy_bool_t
lucy_FSFolder_check(lucy_FSFolder* self);

void
lucy_FSFolder_close(lucy_FSFolder* self);

lucy_FileHandle*
lucy_FSFolder_local_open_filehandle(lucy_FSFolder* self, const lucy_CharBuf* name, uint32_t flags);

lucy_DirHandle*
lucy_FSFolder_local_open_dir(lucy_FSFolder* self);

chy_bool_t
lucy_FSFolder_local_mkdir(lucy_FSFolder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_FSFolder_local_exists(lucy_FSFolder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_FSFolder_local_is_directory(lucy_FSFolder* self, const lucy_CharBuf* name);

lucy_Folder*
lucy_FSFolder_local_find_folder(lucy_FSFolder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_FSFolder_local_delete(lucy_FSFolder* self, const lucy_CharBuf* name);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_FSFolder_rename_CALLBACK;
extern cfish_Callback lucy_FSFolder_hard_link_CALLBACK;
extern cfish_Callback lucy_FSFolder_initialize_CALLBACK;
extern cfish_Callback lucy_FSFolder_check_CALLBACK;
extern cfish_Callback lucy_FSFolder_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_FSFolder_rename_t)(lucy_FSFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

typedef chy_bool_t
(*lucy_FSFolder_hard_link_t)(lucy_FSFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

typedef void
(*lucy_FSFolder_initialize_t)(lucy_FSFolder* self);

typedef chy_bool_t
(*lucy_FSFolder_check_t)(lucy_FSFolder* self);

typedef void
(*lucy_FSFolder_close_t)(lucy_FSFolder* self);

typedef lucy_FileHandle*
(*lucy_FSFolder_local_open_filehandle_t)(lucy_FSFolder* self, const lucy_CharBuf* name, uint32_t flags);

typedef lucy_DirHandle*
(*lucy_FSFolder_local_open_dir_t)(lucy_FSFolder* self);

typedef chy_bool_t
(*lucy_FSFolder_local_mkdir_t)(lucy_FSFolder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_FSFolder_local_exists_t)(lucy_FSFolder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_FSFolder_local_is_directory_t)(lucy_FSFolder* self, const lucy_CharBuf* name);

typedef lucy_Folder*
(*lucy_FSFolder_local_find_folder_t)(lucy_FSFolder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_FSFolder_local_delete_t)(lucy_FSFolder* self, const lucy_CharBuf* name);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_FSFolder_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFolder_Make(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FSFolder_Get_RefCount(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFolder_Inc_RefCount(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FSFolder_Dec_RefCount(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_FSFolder_To_Host(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFolder_Clone(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Destroy_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Destroy(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Destroy_OFFSET;
    const lucy_Folder_destroy_t method = *((lucy_Folder_destroy_t*)method_address);
    method((lucy_Folder*)self);
}

extern size_t Lucy_FSFolder_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Equals(const lucy_FSFolder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSFolder_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_FSFolder_Compare_To(const lucy_FSFolder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSFolder_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_FSFolder_Hash_Sum(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_FSFolder_Get_VTable(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSFolder_Get_Class_Name(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Is_A(const lucy_FSFolder *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_FSFolder_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSFolder_To_String(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_FSFolder_To_I64(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_To_F64_OFFSET;
static CHY_INLINE double
Lucy_FSFolder_To_F64(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_To_Bool(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Serialize_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Serialize(const lucy_FSFolder *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_FSFolder_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFolder_Deserialize(const lucy_FSFolder *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_FSFolder_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFolder_Dump(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FSFolder_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FSFolder_Load(const lucy_FSFolder *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_FSFolder_Mimic_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Mimic(const lucy_FSFolder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_FSFolder_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FSFolder_Get_Path(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Get_Path_OFFSET;
    const lucy_Folder_get_path_t method = *((lucy_Folder_get_path_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_FSFolder_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Set_Path(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Set_Path_OFFSET;
    const lucy_Folder_set_path_t method = *((lucy_Folder_set_path_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Open_Out_OFFSET;
static CHY_INLINE lucy_OutStream*
Lucy_FSFolder_Open_Out(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Open_Out_OFFSET;
    const lucy_Folder_open_out_t method = *((lucy_Folder_open_out_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_FSFolder_Open_In(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Open_In_OFFSET;
    const lucy_Folder_open_in_t method = *((lucy_Folder_open_in_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_FSFolder_Open_FileHandle(const lucy_FSFolder *self, const lucy_CharBuf* path, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Open_FileHandle_OFFSET;
    const lucy_Folder_open_filehandle_t method = *((lucy_Folder_open_filehandle_t*)method_address);
    return method((lucy_Folder*)self, path, flags);
}

extern size_t Lucy_FSFolder_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_FSFolder_Open_Dir(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Open_Dir_OFFSET;
    const lucy_Folder_open_dir_t method = *((lucy_Folder_open_dir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_MkDir(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_MkDir_OFFSET;
    const lucy_Folder_mkdir_t method = *((lucy_Folder_mkdir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_List_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_FSFolder_List(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_List_OFFSET;
    const lucy_Folder_list_t method = *((lucy_Folder_list_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_List_R_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_FSFolder_List_R(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_List_R_OFFSET;
    const lucy_Folder_list_r_t method = *((lucy_Folder_list_r_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Exists(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Exists_OFFSET;
    const lucy_Folder_exists_t method = *((lucy_Folder_exists_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Is_Directory(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Is_Directory_OFFSET;
    const lucy_Folder_is_directory_t method = *((lucy_Folder_is_directory_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Delete(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Delete_OFFSET;
    const lucy_Folder_delete_t method = *((lucy_Folder_delete_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Delete_Tree_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Delete_Tree(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Delete_Tree_OFFSET;
    const lucy_Folder_delete_tree_t method = *((lucy_Folder_delete_tree_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Rename_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Rename(const lucy_FSFolder *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Rename_OFFSET;
    const lucy_FSFolder_rename_t method = *((lucy_FSFolder_rename_t*)method_address);
    return method((lucy_FSFolder*)self, from, to);
}

extern size_t Lucy_FSFolder_Hard_Link_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Hard_Link(const lucy_FSFolder *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Hard_Link_OFFSET;
    const lucy_FSFolder_hard_link_t method = *((lucy_FSFolder_hard_link_t*)method_address);
    return method((lucy_FSFolder*)self, from, to);
}

extern size_t Lucy_FSFolder_Slurp_File_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_FSFolder_Slurp_File(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Slurp_File_OFFSET;
    const lucy_Folder_slurp_file_t method = *((lucy_Folder_slurp_file_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Consolidate_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Consolidate(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Consolidate_OFFSET;
    const lucy_Folder_consolidate_t method = *((lucy_Folder_consolidate_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Enclosing_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_FSFolder_Enclosing_Folder(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Enclosing_Folder_OFFSET;
    const lucy_Folder_enclosing_folder_t method = *((lucy_Folder_enclosing_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_FSFolder_Find_Folder(const lucy_FSFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Find_Folder_OFFSET;
    const lucy_Folder_find_folder_t method = *((lucy_Folder_find_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_FSFolder_Initialize_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Initialize(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Initialize_OFFSET;
    const lucy_FSFolder_initialize_t method = *((lucy_FSFolder_initialize_t*)method_address);
    method((lucy_FSFolder*)self);
}

extern size_t Lucy_FSFolder_Check_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Check(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Check_OFFSET;
    const lucy_FSFolder_check_t method = *((lucy_FSFolder_check_t*)method_address);
    return method((lucy_FSFolder*)self);
}

extern size_t Lucy_FSFolder_Close_OFFSET;
static CHY_INLINE void
Lucy_FSFolder_Close(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Close_OFFSET;
    const lucy_FSFolder_close_t method = *((lucy_FSFolder_close_t*)method_address);
    method((lucy_FSFolder*)self);
}

extern size_t Lucy_FSFolder_Local_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_FSFolder_Local_Open_FileHandle(const lucy_FSFolder *self, const lucy_CharBuf* name, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Open_FileHandle_OFFSET;
    const lucy_FSFolder_local_open_filehandle_t method = *((lucy_FSFolder_local_open_filehandle_t*)method_address);
    return method((lucy_FSFolder*)self, name, flags);
}

extern size_t Lucy_FSFolder_Local_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_FSFolder_Local_Open_In(const lucy_FSFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Open_In_OFFSET;
    const lucy_Folder_local_open_in_t method = *((lucy_Folder_local_open_in_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_FSFolder_Local_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_FSFolder_Local_Open_Dir(const lucy_FSFolder *self) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Open_Dir_OFFSET;
    const lucy_FSFolder_local_open_dir_t method = *((lucy_FSFolder_local_open_dir_t*)method_address);
    return method((lucy_FSFolder*)self);
}

extern size_t Lucy_FSFolder_Local_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Local_MkDir(const lucy_FSFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_MkDir_OFFSET;
    const lucy_FSFolder_local_mkdir_t method = *((lucy_FSFolder_local_mkdir_t*)method_address);
    return method((lucy_FSFolder*)self, name);
}

extern size_t Lucy_FSFolder_Local_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Local_Exists(const lucy_FSFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Exists_OFFSET;
    const lucy_FSFolder_local_exists_t method = *((lucy_FSFolder_local_exists_t*)method_address);
    return method((lucy_FSFolder*)self, name);
}

extern size_t Lucy_FSFolder_Local_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Local_Is_Directory(const lucy_FSFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Is_Directory_OFFSET;
    const lucy_FSFolder_local_is_directory_t method = *((lucy_FSFolder_local_is_directory_t*)method_address);
    return method((lucy_FSFolder*)self, name);
}

extern size_t Lucy_FSFolder_Local_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_FSFolder_Local_Find_Folder(const lucy_FSFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Find_Folder_OFFSET;
    const lucy_FSFolder_local_find_folder_t method = *((lucy_FSFolder_local_find_folder_t*)method_address);
    return method((lucy_FSFolder*)self, name);
}

extern size_t Lucy_FSFolder_Local_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FSFolder_Local_Delete(const lucy_FSFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_FSFolder_Local_Delete_OFFSET;
    const lucy_FSFolder_local_delete_t method = *((lucy_FSFolder_local_delete_t*)method_address);
    return method((lucy_FSFolder*)self, name);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FSFOLDER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[52];
} LUCY_FSFOLDER_VT;
extern struct LUCY_FSFOLDER_VT LUCY_FSFOLDER_vt;
#define LUCY_FSFOLDER ((cfish_VTable*)&LUCY_FSFOLDER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FSFolder lucy_FSFolder
  #define FSFOLDER LUCY_FSFOLDER
  #define FSFolder_new lucy_FSFolder_new
  #define FSFolder_init lucy_FSFolder_init
  #define FSFolder_absolutify lucy_FSFolder_absolutify
  #define FSFolder_rename_t lucy_FSFolder_rename_t
  #define FSFolder_rename lucy_FSFolder_rename
  #define FSFolder_hard_link_t lucy_FSFolder_hard_link_t
  #define FSFolder_hard_link lucy_FSFolder_hard_link
  #define FSFolder_initialize_t lucy_FSFolder_initialize_t
  #define FSFolder_initialize lucy_FSFolder_initialize
  #define FSFolder_check_t lucy_FSFolder_check_t
  #define FSFolder_check lucy_FSFolder_check
  #define FSFolder_close_t lucy_FSFolder_close_t
  #define FSFolder_close lucy_FSFolder_close
  #define FSFolder_local_open_filehandle_t lucy_FSFolder_local_open_filehandle_t
  #define FSFolder_local_open_filehandle lucy_FSFolder_local_open_filehandle
  #define FSFolder_local_open_dir_t lucy_FSFolder_local_open_dir_t
  #define FSFolder_local_open_dir lucy_FSFolder_local_open_dir
  #define FSFolder_local_mkdir_t lucy_FSFolder_local_mkdir_t
  #define FSFolder_local_mkdir lucy_FSFolder_local_mkdir
  #define FSFolder_local_exists_t lucy_FSFolder_local_exists_t
  #define FSFolder_local_exists lucy_FSFolder_local_exists
  #define FSFolder_local_is_directory_t lucy_FSFolder_local_is_directory_t
  #define FSFolder_local_is_directory lucy_FSFolder_local_is_directory
  #define FSFolder_local_find_folder_t lucy_FSFolder_local_find_folder_t
  #define FSFolder_local_find_folder lucy_FSFolder_local_find_folder
  #define FSFolder_local_delete_t lucy_FSFolder_local_delete_t
  #define FSFolder_local_delete lucy_FSFolder_local_delete
  #define FSFolder_Make Lucy_FSFolder_Make
  #define FSFolder_Get_RefCount Lucy_FSFolder_Get_RefCount
  #define FSFolder_Inc_RefCount Lucy_FSFolder_Inc_RefCount
  #define FSFolder_Dec_RefCount Lucy_FSFolder_Dec_RefCount
  #define FSFolder_To_Host Lucy_FSFolder_To_Host
  #define FSFolder_Clone Lucy_FSFolder_Clone
  #define FSFolder_Destroy Lucy_FSFolder_Destroy
  #define FSFolder_Equals Lucy_FSFolder_Equals
  #define FSFolder_Compare_To Lucy_FSFolder_Compare_To
  #define FSFolder_Hash_Sum Lucy_FSFolder_Hash_Sum
  #define FSFolder_Get_VTable Lucy_FSFolder_Get_VTable
  #define FSFolder_Get_Class_Name Lucy_FSFolder_Get_Class_Name
  #define FSFolder_Is_A Lucy_FSFolder_Is_A
  #define FSFolder_To_String Lucy_FSFolder_To_String
  #define FSFolder_To_I64 Lucy_FSFolder_To_I64
  #define FSFolder_To_F64 Lucy_FSFolder_To_F64
  #define FSFolder_To_Bool Lucy_FSFolder_To_Bool
  #define FSFolder_Serialize Lucy_FSFolder_Serialize
  #define FSFolder_Deserialize Lucy_FSFolder_Deserialize
  #define FSFolder_Dump Lucy_FSFolder_Dump
  #define FSFolder_Load Lucy_FSFolder_Load
  #define FSFolder_Mimic Lucy_FSFolder_Mimic
  #define FSFolder_Get_Path Lucy_FSFolder_Get_Path
  #define FSFolder_Set_Path Lucy_FSFolder_Set_Path
  #define FSFolder_Open_Out Lucy_FSFolder_Open_Out
  #define FSFolder_Open_In Lucy_FSFolder_Open_In
  #define FSFolder_Open_FileHandle Lucy_FSFolder_Open_FileHandle
  #define FSFolder_Open_Dir Lucy_FSFolder_Open_Dir
  #define FSFolder_MkDir Lucy_FSFolder_MkDir
  #define FSFolder_List Lucy_FSFolder_List
  #define FSFolder_List_R Lucy_FSFolder_List_R
  #define FSFolder_Exists Lucy_FSFolder_Exists
  #define FSFolder_Is_Directory Lucy_FSFolder_Is_Directory
  #define FSFolder_Delete Lucy_FSFolder_Delete
  #define FSFolder_Delete_Tree Lucy_FSFolder_Delete_Tree
  #define FSFolder_Rename Lucy_FSFolder_Rename
  #define FSFolder_Hard_Link Lucy_FSFolder_Hard_Link
  #define FSFolder_Slurp_File Lucy_FSFolder_Slurp_File
  #define FSFolder_Consolidate Lucy_FSFolder_Consolidate
  #define FSFolder_Enclosing_Folder Lucy_FSFolder_Enclosing_Folder
  #define FSFolder_Find_Folder Lucy_FSFolder_Find_Folder
  #define FSFolder_Initialize Lucy_FSFolder_Initialize
  #define FSFolder_Check Lucy_FSFolder_Check
  #define FSFolder_Close Lucy_FSFolder_Close
  #define FSFolder_Local_Open_FileHandle Lucy_FSFolder_Local_Open_FileHandle
  #define FSFolder_Local_Open_In Lucy_FSFolder_Local_Open_In
  #define FSFolder_Local_Open_Dir Lucy_FSFolder_Local_Open_Dir
  #define FSFolder_Local_MkDir Lucy_FSFolder_Local_MkDir
  #define FSFolder_Local_Exists Lucy_FSFolder_Local_Exists
  #define FSFolder_Local_Is_Directory Lucy_FSFolder_Local_Is_Directory
  #define FSFolder_Local_Find_Folder Lucy_FSFolder_Local_Find_Folder
  #define FSFolder_Local_Delete Lucy_FSFolder_Local_Delete
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_FSFOLDER */




