/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_FILEHANDLE
#define H_LUCY_STORE_FILEHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FILEHANDLE
struct lucy_FileHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    uint32_t flags;
};

#endif /* C_LUCY_FILEHANDLE */

/* Declare this class's inert variables.
 */

extern int32_t lucy_FH_object_count;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_FileHandle*
lucy_FH_do_open(lucy_FileHandle* self, const lucy_CharBuf* path, uint32_t flags);

void
lucy_FH_destroy(lucy_FileHandle* self);

chy_bool_t
lucy_FH_window(lucy_FileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

chy_bool_t
lucy_FH_release_window(lucy_FileHandle* self, lucy_FileWindow* window);

chy_bool_t
lucy_FH_read(lucy_FileHandle* self, char* dest, int64_t offset, size_t len);

chy_bool_t
lucy_FH_write(lucy_FileHandle* self, const void* data, size_t len);

int64_t
lucy_FH_length(lucy_FileHandle* self);

chy_bool_t
lucy_FH_grow(lucy_FileHandle* self, int64_t len);

chy_bool_t
lucy_FH_close(lucy_FileHandle* self);

void
lucy_FH_set_path(lucy_FileHandle* self, const lucy_CharBuf* path);

lucy_CharBuf*
lucy_FH_get_path(lucy_FileHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_FH_destroy_CALLBACK;
extern cfish_Callback lucy_FH_window_CALLBACK;
extern cfish_Callback lucy_FH_release_window_CALLBACK;
extern cfish_Callback lucy_FH_read_CALLBACK;
extern cfish_Callback lucy_FH_write_CALLBACK;
extern cfish_Callback lucy_FH_length_CALLBACK;
extern cfish_Callback lucy_FH_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_FH_destroy_t)(lucy_FileHandle* self);

typedef chy_bool_t
(*lucy_FH_window_t)(lucy_FileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

typedef chy_bool_t
(*lucy_FH_release_window_t)(lucy_FileHandle* self, lucy_FileWindow* window);

typedef chy_bool_t
(*lucy_FH_read_t)(lucy_FileHandle* self, char* dest, int64_t offset, size_t len);

typedef chy_bool_t
(*lucy_FH_write_t)(lucy_FileHandle* self, const void* data, size_t len);

typedef int64_t
(*lucy_FH_length_t)(lucy_FileHandle* self);

typedef chy_bool_t
(*lucy_FH_grow_t)(lucy_FileHandle* self, int64_t len);

typedef chy_bool_t
(*lucy_FH_close_t)(lucy_FileHandle* self);

typedef void
(*lucy_FH_set_path_t)(lucy_FileHandle* self, const lucy_CharBuf* path);

typedef lucy_CharBuf*
(*lucy_FH_get_path_t)(lucy_FileHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_FH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FH_Make(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FH_Get_RefCount(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FH_Inc_RefCount(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_FH_Dec_RefCount(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_FH_To_Host(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FH_Clone(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_FH_Destroy(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Destroy_OFFSET;
    const lucy_FH_destroy_t method = *((lucy_FH_destroy_t*)method_address);
    method((lucy_FileHandle*)self);
}

extern size_t Lucy_FH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Equals(const lucy_FileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_FH_Compare_To(const lucy_FileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_FH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_FH_Hash_Sum(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_FH_Get_VTable(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FH_Get_Class_Name(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Is_A(const lucy_FileHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_FH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_FH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FH_To_String(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_FH_To_I64(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_FH_To_F64(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_To_Bool(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_FH_Serialize(const lucy_FileHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_FH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_FH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FH_Deserialize(const lucy_FileHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_FH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_FH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FH_Dump(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_FH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_FH_Load(const lucy_FileHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_FH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_FH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_FH_Mimic(const lucy_FileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_FH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_FH_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Window(const lucy_FileHandle *self, lucy_FileWindow* window, int64_t offset, int64_t len) {
    char *const method_address = *(char**)self + Lucy_FH_Window_OFFSET;
    const lucy_FH_window_t method = *((lucy_FH_window_t*)method_address);
    return method((lucy_FileHandle*)self, window, offset, len);
}

extern size_t Lucy_FH_Release_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Release_Window(const lucy_FileHandle *self, lucy_FileWindow* window) {
    char *const method_address = *(char**)self + Lucy_FH_Release_Window_OFFSET;
    const lucy_FH_release_window_t method = *((lucy_FH_release_window_t*)method_address);
    return method((lucy_FileHandle*)self, window);
}

extern size_t Lucy_FH_Read_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Read(const lucy_FileHandle *self, char* dest, int64_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_FH_Read_OFFSET;
    const lucy_FH_read_t method = *((lucy_FH_read_t*)method_address);
    return method((lucy_FileHandle*)self, dest, offset, len);
}

extern size_t Lucy_FH_Write_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Write(const lucy_FileHandle *self, const void* data, size_t len) {
    char *const method_address = *(char**)self + Lucy_FH_Write_OFFSET;
    const lucy_FH_write_t method = *((lucy_FH_write_t*)method_address);
    return method((lucy_FileHandle*)self, data, len);
}

extern size_t Lucy_FH_Length_OFFSET;
static CHY_INLINE int64_t
Lucy_FH_Length(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Length_OFFSET;
    const lucy_FH_length_t method = *((lucy_FH_length_t*)method_address);
    return method((lucy_FileHandle*)self);
}

extern size_t Lucy_FH_Grow_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Grow(const lucy_FileHandle *self, int64_t len) {
    char *const method_address = *(char**)self + Lucy_FH_Grow_OFFSET;
    const lucy_FH_grow_t method = *((lucy_FH_grow_t*)method_address);
    return method((lucy_FileHandle*)self, len);
}

extern size_t Lucy_FH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_FH_Close(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Close_OFFSET;
    const lucy_FH_close_t method = *((lucy_FH_close_t*)method_address);
    return method((lucy_FileHandle*)self);
}

extern size_t Lucy_FH_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_FH_Set_Path(const lucy_FileHandle *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_FH_Set_Path_OFFSET;
    const lucy_FH_set_path_t method = *((lucy_FH_set_path_t*)method_address);
    method((lucy_FileHandle*)self, path);
}

extern size_t Lucy_FH_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_FH_Get_Path(const lucy_FileHandle *self) {
    char *const method_address = *(char**)self + Lucy_FH_Get_Path_OFFSET;
    const lucy_FH_get_path_t method = *((lucy_FH_get_path_t*)method_address);
    return method((lucy_FileHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FILEHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_FILEHANDLE_VT;
extern struct LUCY_FILEHANDLE_VT LUCY_FILEHANDLE_vt;
#define LUCY_FILEHANDLE ((cfish_VTable*)&LUCY_FILEHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define FileHandle lucy_FileHandle
  #define FILEHANDLE LUCY_FILEHANDLE
  #define FH_do_open lucy_FH_do_open
  #define FH_object_count lucy_FH_object_count
  #define FH_destroy_t lucy_FH_destroy_t
  #define FH_destroy lucy_FH_destroy
  #define FH_window_t lucy_FH_window_t
  #define FH_window lucy_FH_window
  #define FH_release_window_t lucy_FH_release_window_t
  #define FH_release_window lucy_FH_release_window
  #define FH_read_t lucy_FH_read_t
  #define FH_read lucy_FH_read
  #define FH_write_t lucy_FH_write_t
  #define FH_write lucy_FH_write
  #define FH_length_t lucy_FH_length_t
  #define FH_length lucy_FH_length
  #define FH_grow_t lucy_FH_grow_t
  #define FH_grow lucy_FH_grow
  #define FH_close_t lucy_FH_close_t
  #define FH_close lucy_FH_close
  #define FH_set_path_t lucy_FH_set_path_t
  #define FH_set_path lucy_FH_set_path
  #define FH_get_path_t lucy_FH_get_path_t
  #define FH_get_path lucy_FH_get_path
  #define FH_Make Lucy_FH_Make
  #define FH_Get_RefCount Lucy_FH_Get_RefCount
  #define FH_Inc_RefCount Lucy_FH_Inc_RefCount
  #define FH_Dec_RefCount Lucy_FH_Dec_RefCount
  #define FH_To_Host Lucy_FH_To_Host
  #define FH_Clone Lucy_FH_Clone
  #define FH_Destroy Lucy_FH_Destroy
  #define FH_Equals Lucy_FH_Equals
  #define FH_Compare_To Lucy_FH_Compare_To
  #define FH_Hash_Sum Lucy_FH_Hash_Sum
  #define FH_Get_VTable Lucy_FH_Get_VTable
  #define FH_Get_Class_Name Lucy_FH_Get_Class_Name
  #define FH_Is_A Lucy_FH_Is_A
  #define FH_To_String Lucy_FH_To_String
  #define FH_To_I64 Lucy_FH_To_I64
  #define FH_To_F64 Lucy_FH_To_F64
  #define FH_To_Bool Lucy_FH_To_Bool
  #define FH_Serialize Lucy_FH_Serialize
  #define FH_Deserialize Lucy_FH_Deserialize
  #define FH_Dump Lucy_FH_Dump
  #define FH_Load Lucy_FH_Load
  #define FH_Mimic Lucy_FH_Mimic
  #define FH_Window Lucy_FH_Window
  #define FH_Release_Window Lucy_FH_Release_Window
  #define FH_Read Lucy_FH_Read
  #define FH_Write Lucy_FH_Write
  #define FH_Length Lucy_FH_Length
  #define FH_Grow Lucy_FH_Grow
  #define FH_Close Lucy_FH_Close
  #define FH_Set_Path Lucy_FH_Set_Path
  #define FH_Get_Path Lucy_FH_Get_Path
#endif /* LUCY_USE_SHORT_NAMES */



#define LUCY_FH_READ_ONLY  0x1
#define LUCY_FH_WRITE_ONLY 0x2
#define LUCY_FH_CREATE     0x4
#define LUCY_FH_EXCLUSIVE  0x8

// Default size for the memory buffer used by both InStream and OutStream.
#define LUCY_IO_STREAM_BUF_SIZE 1024

#ifdef LUCY_USE_SHORT_NAMES
  #define IO_STREAM_BUF_SIZE          LUCY_IO_STREAM_BUF_SIZE
  #define FH_READ_ONLY                LUCY_FH_READ_ONLY
  #define FH_WRITE_ONLY               LUCY_FH_WRITE_ONLY
  #define FH_CREATE                   LUCY_FH_CREATE
  #define FH_EXCLUSIVE                LUCY_FH_EXCLUSIVE
#endif



#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_FILEHANDLE */




