/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_FOLDER
#define H_LUCY_STORE_FOLDER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_FOLDER
struct lucy_Folder {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    lucy_Hash* entries;
};

#endif /* C_LUCY_FOLDER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Folder*
lucy_Folder_init(lucy_Folder* self, const lucy_CharBuf* path);

void
lucy_Folder_destroy(lucy_Folder* self);

lucy_CharBuf*
lucy_Folder_get_path(lucy_Folder* self);

void
lucy_Folder_set_path(lucy_Folder* self, const lucy_CharBuf* path);

lucy_OutStream*
lucy_Folder_open_out(lucy_Folder* self, const lucy_CharBuf* path);

lucy_InStream*
lucy_Folder_open_in(lucy_Folder* self, const lucy_CharBuf* path);

lucy_FileHandle*
lucy_Folder_open_filehandle(lucy_Folder* self, const lucy_CharBuf* path, uint32_t flags);

lucy_DirHandle*
lucy_Folder_open_dir(lucy_Folder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_Folder_mkdir(lucy_Folder* self, const lucy_CharBuf* path);

lucy_VArray*
lucy_Folder_list(lucy_Folder* self, const lucy_CharBuf* path);

lucy_VArray*
lucy_Folder_list_r(lucy_Folder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_Folder_exists(lucy_Folder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_Folder_is_directory(lucy_Folder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_Folder_delete(lucy_Folder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_Folder_delete_tree(lucy_Folder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_Folder_rename(lucy_Folder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

chy_bool_t
lucy_Folder_hard_link(lucy_Folder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

lucy_ByteBuf*
lucy_Folder_slurp_file(lucy_Folder* self, const lucy_CharBuf* path);

void
lucy_Folder_consolidate(lucy_Folder* self, const lucy_CharBuf* path);

lucy_Folder*
lucy_Folder_enclosing_folder(lucy_Folder* self, const lucy_CharBuf* path);

lucy_Folder*
lucy_Folder_find_folder(lucy_Folder* self, const lucy_CharBuf* path);

void
lucy_Folder_initialize(lucy_Folder* self);

chy_bool_t
lucy_Folder_check(lucy_Folder* self);

void
lucy_Folder_close(lucy_Folder* self);

lucy_FileHandle*
lucy_Folder_local_open_filehandle(lucy_Folder* self, const lucy_CharBuf* name, uint32_t flags);

lucy_InStream*
lucy_Folder_local_open_in(lucy_Folder* self, const lucy_CharBuf* name);

lucy_DirHandle*
lucy_Folder_local_open_dir(lucy_Folder* self);

chy_bool_t
lucy_Folder_local_mkdir(lucy_Folder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_Folder_local_exists(lucy_Folder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_Folder_local_is_directory(lucy_Folder* self, const lucy_CharBuf* name);

lucy_Folder*
lucy_Folder_local_find_folder(lucy_Folder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_Folder_local_delete(lucy_Folder* self, const lucy_CharBuf* name);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Folder_destroy_CALLBACK;
extern cfish_Callback lucy_Folder_get_path_CALLBACK;
extern cfish_Callback lucy_Folder_open_out_CALLBACK;
extern cfish_Callback lucy_Folder_open_in_CALLBACK;
extern cfish_Callback lucy_Folder_open_filehandle_CALLBACK;
extern cfish_Callback lucy_Folder_open_dir_CALLBACK;
extern cfish_Callback lucy_Folder_mkdir_CALLBACK;
extern cfish_Callback lucy_Folder_exists_CALLBACK;
extern cfish_Callback lucy_Folder_delete_CALLBACK;
extern cfish_Callback lucy_Folder_delete_tree_CALLBACK;
extern cfish_Callback lucy_Folder_rename_CALLBACK;
extern cfish_Callback lucy_Folder_hard_link_CALLBACK;
extern cfish_Callback lucy_Folder_slurp_file_CALLBACK;
extern cfish_Callback lucy_Folder_initialize_CALLBACK;
extern cfish_Callback lucy_Folder_check_CALLBACK;
extern cfish_Callback lucy_Folder_close_CALLBACK;
extern cfish_Callback lucy_Folder_local_open_filehandle_CALLBACK;
extern cfish_Callback lucy_Folder_local_open_dir_CALLBACK;
extern cfish_Callback lucy_Folder_local_mkdir_CALLBACK;
extern cfish_Callback lucy_Folder_local_exists_CALLBACK;
extern cfish_Callback lucy_Folder_local_is_directory_CALLBACK;
extern cfish_Callback lucy_Folder_local_find_folder_CALLBACK;
extern cfish_Callback lucy_Folder_local_delete_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Folder_destroy_t)(lucy_Folder* self);

typedef lucy_CharBuf*
(*lucy_Folder_get_path_t)(lucy_Folder* self);

typedef void
(*lucy_Folder_set_path_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_OutStream*
(*lucy_Folder_open_out_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_InStream*
(*lucy_Folder_open_in_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_FileHandle*
(*lucy_Folder_open_filehandle_t)(lucy_Folder* self, const lucy_CharBuf* path, uint32_t flags);

typedef lucy_DirHandle*
(*lucy_Folder_open_dir_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef chy_bool_t
(*lucy_Folder_mkdir_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_VArray*
(*lucy_Folder_list_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_VArray*
(*lucy_Folder_list_r_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef chy_bool_t
(*lucy_Folder_exists_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef chy_bool_t
(*lucy_Folder_is_directory_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef chy_bool_t
(*lucy_Folder_delete_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef chy_bool_t
(*lucy_Folder_delete_tree_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef chy_bool_t
(*lucy_Folder_rename_t)(lucy_Folder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

typedef chy_bool_t
(*lucy_Folder_hard_link_t)(lucy_Folder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

typedef lucy_ByteBuf*
(*lucy_Folder_slurp_file_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef void
(*lucy_Folder_consolidate_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_Folder*
(*lucy_Folder_enclosing_folder_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef lucy_Folder*
(*lucy_Folder_find_folder_t)(lucy_Folder* self, const lucy_CharBuf* path);

typedef void
(*lucy_Folder_initialize_t)(lucy_Folder* self);

typedef chy_bool_t
(*lucy_Folder_check_t)(lucy_Folder* self);

typedef void
(*lucy_Folder_close_t)(lucy_Folder* self);

typedef lucy_FileHandle*
(*lucy_Folder_local_open_filehandle_t)(lucy_Folder* self, const lucy_CharBuf* name, uint32_t flags);

typedef lucy_InStream*
(*lucy_Folder_local_open_in_t)(lucy_Folder* self, const lucy_CharBuf* name);

typedef lucy_DirHandle*
(*lucy_Folder_local_open_dir_t)(lucy_Folder* self);

typedef chy_bool_t
(*lucy_Folder_local_mkdir_t)(lucy_Folder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_Folder_local_exists_t)(lucy_Folder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_Folder_local_is_directory_t)(lucy_Folder* self, const lucy_CharBuf* name);

typedef lucy_Folder*
(*lucy_Folder_local_find_folder_t)(lucy_Folder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_Folder_local_delete_t)(lucy_Folder* self, const lucy_CharBuf* name);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Folder_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Folder_Make(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Folder_Get_RefCount(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Folder_Inc_RefCount(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Folder_Dec_RefCount(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Folder_To_Host(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Folder_Clone(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Folder_Destroy(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Destroy_OFFSET;
    const lucy_Folder_destroy_t method = *((lucy_Folder_destroy_t*)method_address);
    method((lucy_Folder*)self);
}

extern size_t Lucy_Folder_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Equals(const lucy_Folder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Folder_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Folder_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Folder_Compare_To(const lucy_Folder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Folder_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Folder_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Folder_Hash_Sum(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Folder_Get_VTable(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Folder_Get_Class_Name(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Is_A(const lucy_Folder *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Folder_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Folder_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Folder_To_String(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Folder_To_I64(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Folder_To_F64(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_To_Bool(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Folder_Serialize(const lucy_Folder *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Folder_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Folder_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Folder_Deserialize(const lucy_Folder *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Folder_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Folder_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Folder_Dump(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Folder_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Folder_Load(const lucy_Folder *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Folder_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Folder_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Folder_Mimic(const lucy_Folder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Folder_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Folder_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Folder_Get_Path(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Get_Path_OFFSET;
    const lucy_Folder_get_path_t method = *((lucy_Folder_get_path_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_Folder_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_Folder_Set_Path(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Set_Path_OFFSET;
    const lucy_Folder_set_path_t method = *((lucy_Folder_set_path_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Open_Out_OFFSET;
static CHY_INLINE lucy_OutStream*
Lucy_Folder_Open_Out(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Open_Out_OFFSET;
    const lucy_Folder_open_out_t method = *((lucy_Folder_open_out_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_Folder_Open_In(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Open_In_OFFSET;
    const lucy_Folder_open_in_t method = *((lucy_Folder_open_in_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_Folder_Open_FileHandle(const lucy_Folder *self, const lucy_CharBuf* path, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_Folder_Open_FileHandle_OFFSET;
    const lucy_Folder_open_filehandle_t method = *((lucy_Folder_open_filehandle_t*)method_address);
    return method((lucy_Folder*)self, path, flags);
}

extern size_t Lucy_Folder_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_Folder_Open_Dir(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Open_Dir_OFFSET;
    const lucy_Folder_open_dir_t method = *((lucy_Folder_open_dir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_MkDir(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_MkDir_OFFSET;
    const lucy_Folder_mkdir_t method = *((lucy_Folder_mkdir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_List_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Folder_List(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_List_OFFSET;
    const lucy_Folder_list_t method = *((lucy_Folder_list_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_List_R_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_Folder_List_R(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_List_R_OFFSET;
    const lucy_Folder_list_r_t method = *((lucy_Folder_list_r_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Exists(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Exists_OFFSET;
    const lucy_Folder_exists_t method = *((lucy_Folder_exists_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Is_Directory(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Is_Directory_OFFSET;
    const lucy_Folder_is_directory_t method = *((lucy_Folder_is_directory_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Delete(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Delete_OFFSET;
    const lucy_Folder_delete_t method = *((lucy_Folder_delete_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Delete_Tree_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Delete_Tree(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Delete_Tree_OFFSET;
    const lucy_Folder_delete_tree_t method = *((lucy_Folder_delete_tree_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Rename_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Rename(const lucy_Folder *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_Folder_Rename_OFFSET;
    const lucy_Folder_rename_t method = *((lucy_Folder_rename_t*)method_address);
    return method((lucy_Folder*)self, from, to);
}

extern size_t Lucy_Folder_Hard_Link_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Hard_Link(const lucy_Folder *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_Folder_Hard_Link_OFFSET;
    const lucy_Folder_hard_link_t method = *((lucy_Folder_hard_link_t*)method_address);
    return method((lucy_Folder*)self, from, to);
}

extern size_t Lucy_Folder_Slurp_File_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_Folder_Slurp_File(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Slurp_File_OFFSET;
    const lucy_Folder_slurp_file_t method = *((lucy_Folder_slurp_file_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Consolidate_OFFSET;
static CHY_INLINE void
Lucy_Folder_Consolidate(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Consolidate_OFFSET;
    const lucy_Folder_consolidate_t method = *((lucy_Folder_consolidate_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Enclosing_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_Folder_Enclosing_Folder(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Enclosing_Folder_OFFSET;
    const lucy_Folder_enclosing_folder_t method = *((lucy_Folder_enclosing_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_Folder_Find_Folder(const lucy_Folder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_Folder_Find_Folder_OFFSET;
    const lucy_Folder_find_folder_t method = *((lucy_Folder_find_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_Folder_Initialize_OFFSET;
static CHY_INLINE void
Lucy_Folder_Initialize(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Initialize_OFFSET;
    const lucy_Folder_initialize_t method = *((lucy_Folder_initialize_t*)method_address);
    method((lucy_Folder*)self);
}

extern size_t Lucy_Folder_Check_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Check(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Check_OFFSET;
    const lucy_Folder_check_t method = *((lucy_Folder_check_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_Folder_Close_OFFSET;
static CHY_INLINE void
Lucy_Folder_Close(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Close_OFFSET;
    const lucy_Folder_close_t method = *((lucy_Folder_close_t*)method_address);
    method((lucy_Folder*)self);
}

extern size_t Lucy_Folder_Local_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_Folder_Local_Open_FileHandle(const lucy_Folder *self, const lucy_CharBuf* name, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Open_FileHandle_OFFSET;
    const lucy_Folder_local_open_filehandle_t method = *((lucy_Folder_local_open_filehandle_t*)method_address);
    return method((lucy_Folder*)self, name, flags);
}

extern size_t Lucy_Folder_Local_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_Folder_Local_Open_In(const lucy_Folder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Open_In_OFFSET;
    const lucy_Folder_local_open_in_t method = *((lucy_Folder_local_open_in_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_Folder_Local_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_Folder_Local_Open_Dir(const lucy_Folder *self) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Open_Dir_OFFSET;
    const lucy_Folder_local_open_dir_t method = *((lucy_Folder_local_open_dir_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_Folder_Local_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Local_MkDir(const lucy_Folder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_MkDir_OFFSET;
    const lucy_Folder_local_mkdir_t method = *((lucy_Folder_local_mkdir_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_Folder_Local_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Local_Exists(const lucy_Folder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Exists_OFFSET;
    const lucy_Folder_local_exists_t method = *((lucy_Folder_local_exists_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_Folder_Local_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Local_Is_Directory(const lucy_Folder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Is_Directory_OFFSET;
    const lucy_Folder_local_is_directory_t method = *((lucy_Folder_local_is_directory_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_Folder_Local_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_Folder_Local_Find_Folder(const lucy_Folder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Find_Folder_OFFSET;
    const lucy_Folder_local_find_folder_t method = *((lucy_Folder_local_find_folder_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_Folder_Local_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Folder_Local_Delete(const lucy_Folder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_Folder_Local_Delete_OFFSET;
    const lucy_Folder_local_delete_t method = *((lucy_Folder_local_delete_t*)method_address);
    return method((lucy_Folder*)self, name);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_FOLDER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[52];
} LUCY_FOLDER_VT;
extern struct LUCY_FOLDER_VT LUCY_FOLDER_vt;
#define LUCY_FOLDER ((cfish_VTable*)&LUCY_FOLDER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Folder lucy_Folder
  #define FOLDER LUCY_FOLDER
  #define Folder_init lucy_Folder_init
  #define Folder_destroy_t lucy_Folder_destroy_t
  #define Folder_destroy lucy_Folder_destroy
  #define Folder_get_path_t lucy_Folder_get_path_t
  #define Folder_get_path lucy_Folder_get_path
  #define Folder_set_path_t lucy_Folder_set_path_t
  #define Folder_set_path lucy_Folder_set_path
  #define Folder_open_out_t lucy_Folder_open_out_t
  #define Folder_open_out lucy_Folder_open_out
  #define Folder_open_in_t lucy_Folder_open_in_t
  #define Folder_open_in lucy_Folder_open_in
  #define Folder_open_filehandle_t lucy_Folder_open_filehandle_t
  #define Folder_open_filehandle lucy_Folder_open_filehandle
  #define Folder_open_dir_t lucy_Folder_open_dir_t
  #define Folder_open_dir lucy_Folder_open_dir
  #define Folder_mkdir_t lucy_Folder_mkdir_t
  #define Folder_mkdir lucy_Folder_mkdir
  #define Folder_list_t lucy_Folder_list_t
  #define Folder_list lucy_Folder_list
  #define Folder_list_r_t lucy_Folder_list_r_t
  #define Folder_list_r lucy_Folder_list_r
  #define Folder_exists_t lucy_Folder_exists_t
  #define Folder_exists lucy_Folder_exists
  #define Folder_is_directory_t lucy_Folder_is_directory_t
  #define Folder_is_directory lucy_Folder_is_directory
  #define Folder_delete_t lucy_Folder_delete_t
  #define Folder_delete lucy_Folder_delete
  #define Folder_delete_tree_t lucy_Folder_delete_tree_t
  #define Folder_delete_tree lucy_Folder_delete_tree
  #define Folder_rename_t lucy_Folder_rename_t
  #define Folder_rename lucy_Folder_rename
  #define Folder_hard_link_t lucy_Folder_hard_link_t
  #define Folder_hard_link lucy_Folder_hard_link
  #define Folder_slurp_file_t lucy_Folder_slurp_file_t
  #define Folder_slurp_file lucy_Folder_slurp_file
  #define Folder_consolidate_t lucy_Folder_consolidate_t
  #define Folder_consolidate lucy_Folder_consolidate
  #define Folder_enclosing_folder_t lucy_Folder_enclosing_folder_t
  #define Folder_enclosing_folder lucy_Folder_enclosing_folder
  #define Folder_find_folder_t lucy_Folder_find_folder_t
  #define Folder_find_folder lucy_Folder_find_folder
  #define Folder_initialize_t lucy_Folder_initialize_t
  #define Folder_initialize lucy_Folder_initialize
  #define Folder_check_t lucy_Folder_check_t
  #define Folder_check lucy_Folder_check
  #define Folder_close_t lucy_Folder_close_t
  #define Folder_close lucy_Folder_close
  #define Folder_local_open_filehandle_t lucy_Folder_local_open_filehandle_t
  #define Folder_local_open_filehandle lucy_Folder_local_open_filehandle
  #define Folder_local_open_in_t lucy_Folder_local_open_in_t
  #define Folder_local_open_in lucy_Folder_local_open_in
  #define Folder_local_open_dir_t lucy_Folder_local_open_dir_t
  #define Folder_local_open_dir lucy_Folder_local_open_dir
  #define Folder_local_mkdir_t lucy_Folder_local_mkdir_t
  #define Folder_local_mkdir lucy_Folder_local_mkdir
  #define Folder_local_exists_t lucy_Folder_local_exists_t
  #define Folder_local_exists lucy_Folder_local_exists
  #define Folder_local_is_directory_t lucy_Folder_local_is_directory_t
  #define Folder_local_is_directory lucy_Folder_local_is_directory
  #define Folder_local_find_folder_t lucy_Folder_local_find_folder_t
  #define Folder_local_find_folder lucy_Folder_local_find_folder
  #define Folder_local_delete_t lucy_Folder_local_delete_t
  #define Folder_local_delete lucy_Folder_local_delete
  #define Folder_Make Lucy_Folder_Make
  #define Folder_Get_RefCount Lucy_Folder_Get_RefCount
  #define Folder_Inc_RefCount Lucy_Folder_Inc_RefCount
  #define Folder_Dec_RefCount Lucy_Folder_Dec_RefCount
  #define Folder_To_Host Lucy_Folder_To_Host
  #define Folder_Clone Lucy_Folder_Clone
  #define Folder_Destroy Lucy_Folder_Destroy
  #define Folder_Equals Lucy_Folder_Equals
  #define Folder_Compare_To Lucy_Folder_Compare_To
  #define Folder_Hash_Sum Lucy_Folder_Hash_Sum
  #define Folder_Get_VTable Lucy_Folder_Get_VTable
  #define Folder_Get_Class_Name Lucy_Folder_Get_Class_Name
  #define Folder_Is_A Lucy_Folder_Is_A
  #define Folder_To_String Lucy_Folder_To_String
  #define Folder_To_I64 Lucy_Folder_To_I64
  #define Folder_To_F64 Lucy_Folder_To_F64
  #define Folder_To_Bool Lucy_Folder_To_Bool
  #define Folder_Serialize Lucy_Folder_Serialize
  #define Folder_Deserialize Lucy_Folder_Deserialize
  #define Folder_Dump Lucy_Folder_Dump
  #define Folder_Load Lucy_Folder_Load
  #define Folder_Mimic Lucy_Folder_Mimic
  #define Folder_Get_Path Lucy_Folder_Get_Path
  #define Folder_Set_Path Lucy_Folder_Set_Path
  #define Folder_Open_Out Lucy_Folder_Open_Out
  #define Folder_Open_In Lucy_Folder_Open_In
  #define Folder_Open_FileHandle Lucy_Folder_Open_FileHandle
  #define Folder_Open_Dir Lucy_Folder_Open_Dir
  #define Folder_MkDir Lucy_Folder_MkDir
  #define Folder_List Lucy_Folder_List
  #define Folder_List_R Lucy_Folder_List_R
  #define Folder_Exists Lucy_Folder_Exists
  #define Folder_Is_Directory Lucy_Folder_Is_Directory
  #define Folder_Delete Lucy_Folder_Delete
  #define Folder_Delete_Tree Lucy_Folder_Delete_Tree
  #define Folder_Rename Lucy_Folder_Rename
  #define Folder_Hard_Link Lucy_Folder_Hard_Link
  #define Folder_Slurp_File Lucy_Folder_Slurp_File
  #define Folder_Consolidate Lucy_Folder_Consolidate
  #define Folder_Enclosing_Folder Lucy_Folder_Enclosing_Folder
  #define Folder_Find_Folder Lucy_Folder_Find_Folder
  #define Folder_Initialize Lucy_Folder_Initialize
  #define Folder_Check Lucy_Folder_Check
  #define Folder_Close Lucy_Folder_Close
  #define Folder_Local_Open_FileHandle Lucy_Folder_Local_Open_FileHandle
  #define Folder_Local_Open_In Lucy_Folder_Local_Open_In
  #define Folder_Local_Open_Dir Lucy_Folder_Local_Open_Dir
  #define Folder_Local_MkDir Lucy_Folder_Local_MkDir
  #define Folder_Local_Exists Lucy_Folder_Local_Exists
  #define Folder_Local_Is_Directory Lucy_Folder_Local_Is_Directory
  #define Folder_Local_Find_Folder Lucy_Folder_Local_Find_Folder
  #define Folder_Local_Delete Lucy_Folder_Local_Delete
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_FOLDER */




