/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_INSTREAM
#define H_LUCY_STORE_INSTREAM 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INSTREAM
struct lucy_InStream {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int64_t offset;
    int64_t len;
    char* buf;
    char* limit;
    lucy_CharBuf* filename;
    lucy_FileHandle* file_handle;
    lucy_FileWindow* window;
};

#endif /* C_LUCY_INSTREAM */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_InStream*
lucy_InStream_open(lucy_Obj* file);

lucy_InStream*
lucy_InStream_do_open(lucy_InStream* self, lucy_Obj* file);

lucy_InStream*
lucy_InStream_clone(lucy_InStream* self);

void
lucy_InStream_destroy(lucy_InStream* self);

lucy_InStream*
lucy_InStream_reopen(lucy_InStream* self, const lucy_CharBuf* filename, int64_t offset, int64_t len);

void
lucy_InStream_close(lucy_InStream* self);

void
lucy_InStream_seek(lucy_InStream* self, int64_t target);

int64_t
lucy_InStream_tell(lucy_InStream* self);

int64_t
lucy_InStream_length(lucy_InStream* self);

void
lucy_InStream_refill(lucy_InStream* self);

void
lucy_InStream_fill(lucy_InStream* self, int64_t amount);

char*
lucy_InStream_buf(lucy_InStream* self, size_t request);

void
lucy_InStream_advance_buf(lucy_InStream* self, char* buf);

void
lucy_InStream_read_bytes(lucy_InStream* self, char* buf, size_t len);

int8_t
lucy_InStream_read_i8(lucy_InStream* self);

uint8_t
lucy_InStream_read_u8(lucy_InStream* self);

int32_t
lucy_InStream_read_i32(lucy_InStream* self);

uint32_t
lucy_InStream_read_u32(lucy_InStream* self);

int64_t
lucy_InStream_read_i64(lucy_InStream* self);

uint64_t
lucy_InStream_read_u64(lucy_InStream* self);

float
lucy_InStream_read_f32(lucy_InStream* self);

double
lucy_InStream_read_f64(lucy_InStream* self);

uint32_t
lucy_InStream_read_c32(lucy_InStream* self);

uint64_t
lucy_InStream_read_c64(lucy_InStream* self);

int
lucy_InStream_read_raw_c64(lucy_InStream* self, char* buf);

lucy_CharBuf*
lucy_InStream_get_filename(lucy_InStream* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_InStream_clone_CALLBACK;
extern cfish_Callback lucy_InStream_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_InStream*
(*lucy_InStream_clone_t)(lucy_InStream* self);

typedef void
(*lucy_InStream_destroy_t)(lucy_InStream* self);

typedef lucy_InStream*
(*lucy_InStream_reopen_t)(lucy_InStream* self, const lucy_CharBuf* filename, int64_t offset, int64_t len);

typedef void
(*lucy_InStream_close_t)(lucy_InStream* self);

typedef void
(*lucy_InStream_seek_t)(lucy_InStream* self, int64_t target);

typedef int64_t
(*lucy_InStream_tell_t)(lucy_InStream* self);

typedef int64_t
(*lucy_InStream_length_t)(lucy_InStream* self);

typedef void
(*lucy_InStream_refill_t)(lucy_InStream* self);

typedef void
(*lucy_InStream_fill_t)(lucy_InStream* self, int64_t amount);

typedef char*
(*lucy_InStream_buf_t)(lucy_InStream* self, size_t request);

typedef void
(*lucy_InStream_advance_buf_t)(lucy_InStream* self, char* buf);

typedef void
(*lucy_InStream_read_bytes_t)(lucy_InStream* self, char* buf, size_t len);

typedef int8_t
(*lucy_InStream_read_i8_t)(lucy_InStream* self);

typedef uint8_t
(*lucy_InStream_read_u8_t)(lucy_InStream* self);

typedef int32_t
(*lucy_InStream_read_i32_t)(lucy_InStream* self);

typedef uint32_t
(*lucy_InStream_read_u32_t)(lucy_InStream* self);

typedef int64_t
(*lucy_InStream_read_i64_t)(lucy_InStream* self);

typedef uint64_t
(*lucy_InStream_read_u64_t)(lucy_InStream* self);

typedef float
(*lucy_InStream_read_f32_t)(lucy_InStream* self);

typedef double
(*lucy_InStream_read_f64_t)(lucy_InStream* self);

typedef uint32_t
(*lucy_InStream_read_c32_t)(lucy_InStream* self);

typedef uint64_t
(*lucy_InStream_read_c64_t)(lucy_InStream* self);

typedef int
(*lucy_InStream_read_raw_c64_t)(lucy_InStream* self, char* buf);

typedef lucy_CharBuf*
(*lucy_InStream_get_filename_t)(lucy_InStream* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_InStream_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_InStream_Make(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_InStream_Get_RefCount(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_InStream_Inc_RefCount(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_InStream_Dec_RefCount(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_InStream_To_Host(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Clone_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_InStream_Clone(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Clone_OFFSET;
    const lucy_InStream_clone_t method = *((lucy_InStream_clone_t*)method_address);
    return method((lucy_InStream*)self);
}

extern size_t Lucy_InStream_Destroy_OFFSET;
static CHY_INLINE void
Lucy_InStream_Destroy(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Destroy_OFFSET;
    const lucy_InStream_destroy_t method = *((lucy_InStream_destroy_t*)method_address);
    method((lucy_InStream*)self);
}

extern size_t Lucy_InStream_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_InStream_Equals(const lucy_InStream *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_InStream_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_InStream_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_InStream_Compare_To(const lucy_InStream *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_InStream_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_InStream_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_InStream_Hash_Sum(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_InStream_Get_VTable(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_InStream_Get_Class_Name(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_InStream_Is_A(const lucy_InStream *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_InStream_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_InStream_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_InStream_To_String(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_InStream_To_I64(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_To_F64_OFFSET;
static CHY_INLINE double
Lucy_InStream_To_F64(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_InStream_To_Bool(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Serialize_OFFSET;
static CHY_INLINE void
Lucy_InStream_Serialize(const lucy_InStream *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_InStream_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_InStream_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_InStream_Deserialize(const lucy_InStream *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_InStream_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_InStream_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_InStream_Dump(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_InStream_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_InStream_Load(const lucy_InStream *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_InStream_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_InStream_Mimic_OFFSET;
static CHY_INLINE void
Lucy_InStream_Mimic(const lucy_InStream *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_InStream_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_InStream_Reopen_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_InStream_Reopen(const lucy_InStream *self, const lucy_CharBuf* filename, int64_t offset, int64_t len) {
    char *const method_address = *(char**)self + Lucy_InStream_Reopen_OFFSET;
    const lucy_InStream_reopen_t method = *((lucy_InStream_reopen_t*)method_address);
    return method((lucy_InStream*)self, filename, offset, len);
}

extern size_t Lucy_InStream_Close_OFFSET;
static CHY_INLINE void
Lucy_InStream_Close(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Close_OFFSET;
    const lucy_InStream_close_t method = *((lucy_InStream_close_t*)method_address);
    method((lucy_InStream*)self);
}

#define Lucy_InStream_Seek(self, target) \
    lucy_InStream_seek((lucy_InStream*)self, target)

#define Lucy_InStream_Tell(self) \
    lucy_InStream_tell((lucy_InStream*)self)

#define Lucy_InStream_Length(self) \
    lucy_InStream_length((lucy_InStream*)self)

extern size_t Lucy_InStream_Refill_OFFSET;
static CHY_INLINE void
Lucy_InStream_Refill(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Refill_OFFSET;
    const lucy_InStream_refill_t method = *((lucy_InStream_refill_t*)method_address);
    method((lucy_InStream*)self);
}

extern size_t Lucy_InStream_Fill_OFFSET;
static CHY_INLINE void
Lucy_InStream_Fill(const lucy_InStream *self, int64_t amount) {
    char *const method_address = *(char**)self + Lucy_InStream_Fill_OFFSET;
    const lucy_InStream_fill_t method = *((lucy_InStream_fill_t*)method_address);
    method((lucy_InStream*)self, amount);
}

#define Lucy_InStream_Buf(self, request) \
    lucy_InStream_buf((lucy_InStream*)self, request)

#define Lucy_InStream_Advance_Buf(self, buf) \
    lucy_InStream_advance_buf((lucy_InStream*)self, buf)

#define Lucy_InStream_Read_Bytes(self, buf, len) \
    lucy_InStream_read_bytes((lucy_InStream*)self, buf, len)

#define Lucy_InStream_Read_I8(self) \
    lucy_InStream_read_i8((lucy_InStream*)self)

#define Lucy_InStream_Read_U8(self) \
    lucy_InStream_read_u8((lucy_InStream*)self)

#define Lucy_InStream_Read_I32(self) \
    lucy_InStream_read_i32((lucy_InStream*)self)

#define Lucy_InStream_Read_U32(self) \
    lucy_InStream_read_u32((lucy_InStream*)self)

#define Lucy_InStream_Read_I64(self) \
    lucy_InStream_read_i64((lucy_InStream*)self)

#define Lucy_InStream_Read_U64(self) \
    lucy_InStream_read_u64((lucy_InStream*)self)

#define Lucy_InStream_Read_F32(self) \
    lucy_InStream_read_f32((lucy_InStream*)self)

#define Lucy_InStream_Read_F64(self) \
    lucy_InStream_read_f64((lucy_InStream*)self)

extern size_t Lucy_InStream_Read_C32_OFFSET;
static CHY_INLINE uint32_t
Lucy_InStream_Read_C32(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Read_C32_OFFSET;
    const lucy_InStream_read_c32_t method = *((lucy_InStream_read_c32_t*)method_address);
    return method((lucy_InStream*)self);
}

#define Lucy_InStream_Read_C64(self) \
    lucy_InStream_read_c64((lucy_InStream*)self)

#define Lucy_InStream_Read_Raw_C64(self, buf) \
    lucy_InStream_read_raw_c64((lucy_InStream*)self, buf)

extern size_t Lucy_InStream_Get_Filename_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_InStream_Get_Filename(const lucy_InStream *self) {
    char *const method_address = *(char**)self + Lucy_InStream_Get_Filename_OFFSET;
    const lucy_InStream_get_filename_t method = *((lucy_InStream_get_filename_t*)method_address);
    return method((lucy_InStream*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_INSTREAM_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[44];
} LUCY_INSTREAM_VT;
extern struct LUCY_INSTREAM_VT LUCY_INSTREAM_vt;
#define LUCY_INSTREAM ((cfish_VTable*)&LUCY_INSTREAM_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define InStream lucy_InStream
  #define INSTREAM LUCY_INSTREAM
  #define InStream_open lucy_InStream_open
  #define InStream_do_open lucy_InStream_do_open
  #define InStream_clone_t lucy_InStream_clone_t
  #define InStream_clone lucy_InStream_clone
  #define InStream_destroy_t lucy_InStream_destroy_t
  #define InStream_destroy lucy_InStream_destroy
  #define InStream_reopen_t lucy_InStream_reopen_t
  #define InStream_reopen lucy_InStream_reopen
  #define InStream_close_t lucy_InStream_close_t
  #define InStream_close lucy_InStream_close
  #define InStream_seek_t lucy_InStream_seek_t
  #define InStream_seek lucy_InStream_seek
  #define InStream_tell_t lucy_InStream_tell_t
  #define InStream_tell lucy_InStream_tell
  #define InStream_length_t lucy_InStream_length_t
  #define InStream_length lucy_InStream_length
  #define InStream_refill_t lucy_InStream_refill_t
  #define InStream_refill lucy_InStream_refill
  #define InStream_fill_t lucy_InStream_fill_t
  #define InStream_fill lucy_InStream_fill
  #define InStream_buf_t lucy_InStream_buf_t
  #define InStream_buf lucy_InStream_buf
  #define InStream_advance_buf_t lucy_InStream_advance_buf_t
  #define InStream_advance_buf lucy_InStream_advance_buf
  #define InStream_read_bytes_t lucy_InStream_read_bytes_t
  #define InStream_read_bytes lucy_InStream_read_bytes
  #define InStream_read_i8_t lucy_InStream_read_i8_t
  #define InStream_read_i8 lucy_InStream_read_i8
  #define InStream_read_u8_t lucy_InStream_read_u8_t
  #define InStream_read_u8 lucy_InStream_read_u8
  #define InStream_read_i32_t lucy_InStream_read_i32_t
  #define InStream_read_i32 lucy_InStream_read_i32
  #define InStream_read_u32_t lucy_InStream_read_u32_t
  #define InStream_read_u32 lucy_InStream_read_u32
  #define InStream_read_i64_t lucy_InStream_read_i64_t
  #define InStream_read_i64 lucy_InStream_read_i64
  #define InStream_read_u64_t lucy_InStream_read_u64_t
  #define InStream_read_u64 lucy_InStream_read_u64
  #define InStream_read_f32_t lucy_InStream_read_f32_t
  #define InStream_read_f32 lucy_InStream_read_f32
  #define InStream_read_f64_t lucy_InStream_read_f64_t
  #define InStream_read_f64 lucy_InStream_read_f64
  #define InStream_read_c32_t lucy_InStream_read_c32_t
  #define InStream_read_c32 lucy_InStream_read_c32
  #define InStream_read_c64_t lucy_InStream_read_c64_t
  #define InStream_read_c64 lucy_InStream_read_c64
  #define InStream_read_raw_c64_t lucy_InStream_read_raw_c64_t
  #define InStream_read_raw_c64 lucy_InStream_read_raw_c64
  #define InStream_get_filename_t lucy_InStream_get_filename_t
  #define InStream_get_filename lucy_InStream_get_filename
  #define InStream_Make Lucy_InStream_Make
  #define InStream_Get_RefCount Lucy_InStream_Get_RefCount
  #define InStream_Inc_RefCount Lucy_InStream_Inc_RefCount
  #define InStream_Dec_RefCount Lucy_InStream_Dec_RefCount
  #define InStream_To_Host Lucy_InStream_To_Host
  #define InStream_Clone Lucy_InStream_Clone
  #define InStream_Destroy Lucy_InStream_Destroy
  #define InStream_Equals Lucy_InStream_Equals
  #define InStream_Compare_To Lucy_InStream_Compare_To
  #define InStream_Hash_Sum Lucy_InStream_Hash_Sum
  #define InStream_Get_VTable Lucy_InStream_Get_VTable
  #define InStream_Get_Class_Name Lucy_InStream_Get_Class_Name
  #define InStream_Is_A Lucy_InStream_Is_A
  #define InStream_To_String Lucy_InStream_To_String
  #define InStream_To_I64 Lucy_InStream_To_I64
  #define InStream_To_F64 Lucy_InStream_To_F64
  #define InStream_To_Bool Lucy_InStream_To_Bool
  #define InStream_Serialize Lucy_InStream_Serialize
  #define InStream_Deserialize Lucy_InStream_Deserialize
  #define InStream_Dump Lucy_InStream_Dump
  #define InStream_Load Lucy_InStream_Load
  #define InStream_Mimic Lucy_InStream_Mimic
  #define InStream_Reopen Lucy_InStream_Reopen
  #define InStream_Close Lucy_InStream_Close
  #define InStream_Seek Lucy_InStream_Seek
  #define InStream_Tell Lucy_InStream_Tell
  #define InStream_Length Lucy_InStream_Length
  #define InStream_Refill Lucy_InStream_Refill
  #define InStream_Fill Lucy_InStream_Fill
  #define InStream_Buf Lucy_InStream_Buf
  #define InStream_Advance_Buf Lucy_InStream_Advance_Buf
  #define InStream_Read_Bytes Lucy_InStream_Read_Bytes
  #define InStream_Read_I8 Lucy_InStream_Read_I8
  #define InStream_Read_U8 Lucy_InStream_Read_U8
  #define InStream_Read_I32 Lucy_InStream_Read_I32
  #define InStream_Read_U32 Lucy_InStream_Read_U32
  #define InStream_Read_I64 Lucy_InStream_Read_I64
  #define InStream_Read_U64 Lucy_InStream_Read_U64
  #define InStream_Read_F32 Lucy_InStream_Read_F32
  #define InStream_Read_F64 Lucy_InStream_Read_F64
  #define InStream_Read_C32 Lucy_InStream_Read_C32
  #define InStream_Read_C64 Lucy_InStream_Read_C64
  #define InStream_Read_Raw_C64 Lucy_InStream_Read_Raw_C64
  #define InStream_Get_Filename Lucy_InStream_Get_Filename
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_INSTREAM */




