/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_LOCK
#define H_LUCY_STORE_LOCK 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LOCK
struct lucy_Lock {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Folder* folder;
    lucy_CharBuf* name;
    lucy_CharBuf* lock_path;
    lucy_CharBuf* host;
    int32_t timeout;
    int32_t interval;
};

#endif /* C_LUCY_LOCK */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_Lock*
lucy_Lock_init(lucy_Lock* self, lucy_Folder* folder, const lucy_CharBuf* name, const lucy_CharBuf* host, int32_t timeout, int32_t interval);

void
lucy_Lock_destroy(lucy_Lock* self);

chy_bool_t
lucy_Lock_shared(lucy_Lock* self);

chy_bool_t
lucy_Lock_obtain(lucy_Lock* self);

chy_bool_t
lucy_Lock_request(lucy_Lock* self);

void
lucy_Lock_release(lucy_Lock* self);

chy_bool_t
lucy_Lock_is_locked(lucy_Lock* self);

void
lucy_Lock_clear_stale(lucy_Lock* self);

lucy_CharBuf*
lucy_Lock_get_name(lucy_Lock* self);

lucy_CharBuf*
lucy_Lock_get_host(lucy_Lock* self);

lucy_CharBuf*
lucy_Lock_get_lock_path(lucy_Lock* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_Lock_destroy_CALLBACK;
extern cfish_Callback lucy_Lock_shared_CALLBACK;
extern cfish_Callback lucy_Lock_obtain_CALLBACK;
extern cfish_Callback lucy_Lock_request_CALLBACK;
extern cfish_Callback lucy_Lock_release_CALLBACK;
extern cfish_Callback lucy_Lock_is_locked_CALLBACK;
extern cfish_Callback lucy_Lock_clear_stale_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_Lock_destroy_t)(lucy_Lock* self);

typedef chy_bool_t
(*lucy_Lock_shared_t)(lucy_Lock* self);

typedef chy_bool_t
(*lucy_Lock_obtain_t)(lucy_Lock* self);

typedef chy_bool_t
(*lucy_Lock_request_t)(lucy_Lock* self);

typedef void
(*lucy_Lock_release_t)(lucy_Lock* self);

typedef chy_bool_t
(*lucy_Lock_is_locked_t)(lucy_Lock* self);

typedef void
(*lucy_Lock_clear_stale_t)(lucy_Lock* self);

typedef lucy_CharBuf*
(*lucy_Lock_get_name_t)(lucy_Lock* self);

typedef lucy_CharBuf*
(*lucy_Lock_get_host_t)(lucy_Lock* self);

typedef lucy_CharBuf*
(*lucy_Lock_get_lock_path_t)(lucy_Lock* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_Lock_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Lock_Make(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Lock_Get_RefCount(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Lock_Inc_RefCount(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_Lock_Dec_RefCount(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_Lock_To_Host(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Lock_Clone(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Destroy_OFFSET;
static CHY_INLINE void
Lucy_Lock_Destroy(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Destroy_OFFSET;
    const lucy_Lock_destroy_t method = *((lucy_Lock_destroy_t*)method_address);
    method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_Equals(const lucy_Lock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Lock_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Lock_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_Lock_Compare_To(const lucy_Lock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Lock_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_Lock_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_Lock_Hash_Sum(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_Lock_Get_VTable(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Lock_Get_Class_Name(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_Is_A(const lucy_Lock *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_Lock_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_Lock_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Lock_To_String(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_Lock_To_I64(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_To_F64_OFFSET;
static CHY_INLINE double
Lucy_Lock_To_F64(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_To_Bool(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Serialize_OFFSET;
static CHY_INLINE void
Lucy_Lock_Serialize(const lucy_Lock *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_Lock_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_Lock_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Lock_Deserialize(const lucy_Lock *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_Lock_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_Lock_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Lock_Dump(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_Lock_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_Lock_Load(const lucy_Lock *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_Lock_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_Lock_Mimic_OFFSET;
static CHY_INLINE void
Lucy_Lock_Mimic(const lucy_Lock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_Lock_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_Lock_Shared_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_Shared(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Shared_OFFSET;
    const lucy_Lock_shared_t method = *((lucy_Lock_shared_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Obtain_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_Obtain(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Obtain_OFFSET;
    const lucy_Lock_obtain_t method = *((lucy_Lock_obtain_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Request_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_Request(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Request_OFFSET;
    const lucy_Lock_request_t method = *((lucy_Lock_request_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Release_OFFSET;
static CHY_INLINE void
Lucy_Lock_Release(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Release_OFFSET;
    const lucy_Lock_release_t method = *((lucy_Lock_release_t*)method_address);
    method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Is_Locked_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_Lock_Is_Locked(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Is_Locked_OFFSET;
    const lucy_Lock_is_locked_t method = *((lucy_Lock_is_locked_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Clear_Stale_OFFSET;
static CHY_INLINE void
Lucy_Lock_Clear_Stale(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Clear_Stale_OFFSET;
    const lucy_Lock_clear_stale_t method = *((lucy_Lock_clear_stale_t*)method_address);
    method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Get_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Lock_Get_Name(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Get_Name_OFFSET;
    const lucy_Lock_get_name_t method = *((lucy_Lock_get_name_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Get_Host_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Lock_Get_Host(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Get_Host_OFFSET;
    const lucy_Lock_get_host_t method = *((lucy_Lock_get_host_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_Lock_Get_Lock_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_Lock_Get_Lock_Path(const lucy_Lock *self) {
    char *const method_address = *(char**)self + Lucy_Lock_Get_Lock_Path_OFFSET;
    const lucy_Lock_get_lock_path_t method = *((lucy_Lock_get_lock_path_t*)method_address);
    return method((lucy_Lock*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LOCK_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_LOCK_VT;
extern struct LUCY_LOCK_VT LUCY_LOCK_vt;
#define LUCY_LOCK ((cfish_VTable*)&LUCY_LOCK_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Lock lucy_Lock
  #define LOCK LUCY_LOCK
  #define Lock_init lucy_Lock_init
  #define Lock_destroy_t lucy_Lock_destroy_t
  #define Lock_destroy lucy_Lock_destroy
  #define Lock_shared_t lucy_Lock_shared_t
  #define Lock_shared lucy_Lock_shared
  #define Lock_obtain_t lucy_Lock_obtain_t
  #define Lock_obtain lucy_Lock_obtain
  #define Lock_request_t lucy_Lock_request_t
  #define Lock_request lucy_Lock_request
  #define Lock_release_t lucy_Lock_release_t
  #define Lock_release lucy_Lock_release
  #define Lock_is_locked_t lucy_Lock_is_locked_t
  #define Lock_is_locked lucy_Lock_is_locked
  #define Lock_clear_stale_t lucy_Lock_clear_stale_t
  #define Lock_clear_stale lucy_Lock_clear_stale
  #define Lock_get_name_t lucy_Lock_get_name_t
  #define Lock_get_name lucy_Lock_get_name
  #define Lock_get_host_t lucy_Lock_get_host_t
  #define Lock_get_host lucy_Lock_get_host
  #define Lock_get_lock_path_t lucy_Lock_get_lock_path_t
  #define Lock_get_lock_path lucy_Lock_get_lock_path
  #define Lock_Make Lucy_Lock_Make
  #define Lock_Get_RefCount Lucy_Lock_Get_RefCount
  #define Lock_Inc_RefCount Lucy_Lock_Inc_RefCount
  #define Lock_Dec_RefCount Lucy_Lock_Dec_RefCount
  #define Lock_To_Host Lucy_Lock_To_Host
  #define Lock_Clone Lucy_Lock_Clone
  #define Lock_Destroy Lucy_Lock_Destroy
  #define Lock_Equals Lucy_Lock_Equals
  #define Lock_Compare_To Lucy_Lock_Compare_To
  #define Lock_Hash_Sum Lucy_Lock_Hash_Sum
  #define Lock_Get_VTable Lucy_Lock_Get_VTable
  #define Lock_Get_Class_Name Lucy_Lock_Get_Class_Name
  #define Lock_Is_A Lucy_Lock_Is_A
  #define Lock_To_String Lucy_Lock_To_String
  #define Lock_To_I64 Lucy_Lock_To_I64
  #define Lock_To_F64 Lucy_Lock_To_F64
  #define Lock_To_Bool Lucy_Lock_To_Bool
  #define Lock_Serialize Lucy_Lock_Serialize
  #define Lock_Deserialize Lucy_Lock_Deserialize
  #define Lock_Dump Lucy_Lock_Dump
  #define Lock_Load Lucy_Lock_Load
  #define Lock_Mimic Lucy_Lock_Mimic
  #define Lock_Shared Lucy_Lock_Shared
  #define Lock_Obtain Lucy_Lock_Obtain
  #define Lock_Request Lucy_Lock_Request
  #define Lock_Release Lucy_Lock_Release
  #define Lock_Is_Locked Lucy_Lock_Is_Locked
  #define Lock_Clear_Stale Lucy_Lock_Clear_Stale
  #define Lock_Get_Name Lucy_Lock_Get_Name
  #define Lock_Get_Host Lucy_Lock_Get_Host
  #define Lock_Get_Lock_Path Lucy_Lock_Get_Lock_Path
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/Lock.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LOCKFILELOCK
struct lucy_LockFileLock {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Folder* folder;
    lucy_CharBuf* name;
    lucy_CharBuf* lock_path;
    lucy_CharBuf* host;
    int32_t timeout;
    int32_t interval;
    lucy_CharBuf* link_path;
};

#endif /* C_LUCY_LOCKFILELOCK */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LockFileLock*
lucy_LFLock_new(lucy_Folder* folder, const lucy_CharBuf* name, const lucy_CharBuf* host, int32_t timeout, int32_t interval);

lucy_LockFileLock*
lucy_LFLock_init(lucy_LockFileLock* self, lucy_Folder* folder, const lucy_CharBuf* name, const lucy_CharBuf* host, int32_t timeout, int32_t interval);

void
lucy_LFLock_destroy(lucy_LockFileLock* self);

chy_bool_t
lucy_LFLock_shared(lucy_LockFileLock* self);

chy_bool_t
lucy_LFLock_request(lucy_LockFileLock* self);

void
lucy_LFLock_release(lucy_LockFileLock* self);

chy_bool_t
lucy_LFLock_is_locked(lucy_LockFileLock* self);

void
lucy_LFLock_clear_stale(lucy_LockFileLock* self);

chy_bool_t
lucy_LFLock_maybe_delete_file(lucy_LockFileLock* self, const lucy_CharBuf* filepath, chy_bool_t delete_mine, chy_bool_t delete_other);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LFLock_destroy_CALLBACK;
extern cfish_Callback lucy_LFLock_shared_CALLBACK;
extern cfish_Callback lucy_LFLock_request_CALLBACK;
extern cfish_Callback lucy_LFLock_release_CALLBACK;
extern cfish_Callback lucy_LFLock_is_locked_CALLBACK;
extern cfish_Callback lucy_LFLock_clear_stale_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_LFLock_destroy_t)(lucy_LockFileLock* self);

typedef chy_bool_t
(*lucy_LFLock_shared_t)(lucy_LockFileLock* self);

typedef chy_bool_t
(*lucy_LFLock_request_t)(lucy_LockFileLock* self);

typedef void
(*lucy_LFLock_release_t)(lucy_LockFileLock* self);

typedef chy_bool_t
(*lucy_LFLock_is_locked_t)(lucy_LockFileLock* self);

typedef void
(*lucy_LFLock_clear_stale_t)(lucy_LockFileLock* self);

typedef chy_bool_t
(*lucy_LFLock_maybe_delete_file_t)(lucy_LockFileLock* self, const lucy_CharBuf* filepath, chy_bool_t delete_mine, chy_bool_t delete_other);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LFLock_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LFLock_Make(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LFLock_Get_RefCount(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LFLock_Inc_RefCount(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LFLock_Dec_RefCount(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LFLock_To_Host(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LFLock_Clone(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LFLock_Destroy(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Destroy_OFFSET;
    const lucy_LFLock_destroy_t method = *((lucy_LFLock_destroy_t*)method_address);
    method((lucy_LockFileLock*)self);
}

extern size_t Lucy_LFLock_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Equals(const lucy_LockFileLock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LFLock_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LFLock_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LFLock_Compare_To(const lucy_LockFileLock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LFLock_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LFLock_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LFLock_Hash_Sum(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LFLock_Get_VTable(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LFLock_Get_Class_Name(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Is_A(const lucy_LockFileLock *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LFLock_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LFLock_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LFLock_To_String(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LFLock_To_I64(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LFLock_To_F64(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_To_Bool(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LFLock_Serialize(const lucy_LockFileLock *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LFLock_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_LFLock_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LFLock_Deserialize(const lucy_LockFileLock *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LFLock_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_LFLock_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LFLock_Dump(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LFLock_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LFLock_Load(const lucy_LockFileLock *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LFLock_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_LFLock_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LFLock_Mimic(const lucy_LockFileLock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LFLock_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LFLock_Shared_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Shared(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Shared_OFFSET;
    const lucy_LFLock_shared_t method = *((lucy_LFLock_shared_t*)method_address);
    return method((lucy_LockFileLock*)self);
}

extern size_t Lucy_LFLock_Obtain_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Obtain(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Obtain_OFFSET;
    const lucy_Lock_obtain_t method = *((lucy_Lock_obtain_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_LFLock_Request_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Request(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Request_OFFSET;
    const lucy_LFLock_request_t method = *((lucy_LFLock_request_t*)method_address);
    return method((lucy_LockFileLock*)self);
}

extern size_t Lucy_LFLock_Release_OFFSET;
static CHY_INLINE void
Lucy_LFLock_Release(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Release_OFFSET;
    const lucy_LFLock_release_t method = *((lucy_LFLock_release_t*)method_address);
    method((lucy_LockFileLock*)self);
}

extern size_t Lucy_LFLock_Is_Locked_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Is_Locked(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Is_Locked_OFFSET;
    const lucy_LFLock_is_locked_t method = *((lucy_LFLock_is_locked_t*)method_address);
    return method((lucy_LockFileLock*)self);
}

extern size_t Lucy_LFLock_Clear_Stale_OFFSET;
static CHY_INLINE void
Lucy_LFLock_Clear_Stale(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Clear_Stale_OFFSET;
    const lucy_LFLock_clear_stale_t method = *((lucy_LFLock_clear_stale_t*)method_address);
    method((lucy_LockFileLock*)self);
}

extern size_t Lucy_LFLock_Get_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LFLock_Get_Name(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Get_Name_OFFSET;
    const lucy_Lock_get_name_t method = *((lucy_Lock_get_name_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_LFLock_Get_Host_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LFLock_Get_Host(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Get_Host_OFFSET;
    const lucy_Lock_get_host_t method = *((lucy_Lock_get_host_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_LFLock_Get_Lock_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LFLock_Get_Lock_Path(const lucy_LockFileLock *self) {
    char *const method_address = *(char**)self + Lucy_LFLock_Get_Lock_Path_OFFSET;
    const lucy_Lock_get_lock_path_t method = *((lucy_Lock_get_lock_path_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_LFLock_Maybe_Delete_File_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LFLock_Maybe_Delete_File(const lucy_LockFileLock *self, const lucy_CharBuf* filepath, chy_bool_t delete_mine, chy_bool_t delete_other) {
    char *const method_address = *(char**)self + Lucy_LFLock_Maybe_Delete_File_OFFSET;
    const lucy_LFLock_maybe_delete_file_t method = *((lucy_LFLock_maybe_delete_file_t*)method_address);
    return method((lucy_LockFileLock*)self, filepath, delete_mine, delete_other);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LOCKFILELOCK_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_LOCKFILELOCK_VT;
extern struct LUCY_LOCKFILELOCK_VT LUCY_LOCKFILELOCK_vt;
#define LUCY_LOCKFILELOCK ((cfish_VTable*)&LUCY_LOCKFILELOCK_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LockFileLock lucy_LockFileLock
  #define LOCKFILELOCK LUCY_LOCKFILELOCK
  #define LFLock_new lucy_LFLock_new
  #define LFLock_init lucy_LFLock_init
  #define LFLock_destroy_t lucy_LFLock_destroy_t
  #define LFLock_destroy lucy_LFLock_destroy
  #define LFLock_shared_t lucy_LFLock_shared_t
  #define LFLock_shared lucy_LFLock_shared
  #define LFLock_request_t lucy_LFLock_request_t
  #define LFLock_request lucy_LFLock_request
  #define LFLock_release_t lucy_LFLock_release_t
  #define LFLock_release lucy_LFLock_release
  #define LFLock_is_locked_t lucy_LFLock_is_locked_t
  #define LFLock_is_locked lucy_LFLock_is_locked
  #define LFLock_clear_stale_t lucy_LFLock_clear_stale_t
  #define LFLock_clear_stale lucy_LFLock_clear_stale
  #define LFLock_maybe_delete_file_t lucy_LFLock_maybe_delete_file_t
  #define LFLock_maybe_delete_file lucy_LFLock_maybe_delete_file
  #define LFLock_Make Lucy_LFLock_Make
  #define LFLock_Get_RefCount Lucy_LFLock_Get_RefCount
  #define LFLock_Inc_RefCount Lucy_LFLock_Inc_RefCount
  #define LFLock_Dec_RefCount Lucy_LFLock_Dec_RefCount
  #define LFLock_To_Host Lucy_LFLock_To_Host
  #define LFLock_Clone Lucy_LFLock_Clone
  #define LFLock_Destroy Lucy_LFLock_Destroy
  #define LFLock_Equals Lucy_LFLock_Equals
  #define LFLock_Compare_To Lucy_LFLock_Compare_To
  #define LFLock_Hash_Sum Lucy_LFLock_Hash_Sum
  #define LFLock_Get_VTable Lucy_LFLock_Get_VTable
  #define LFLock_Get_Class_Name Lucy_LFLock_Get_Class_Name
  #define LFLock_Is_A Lucy_LFLock_Is_A
  #define LFLock_To_String Lucy_LFLock_To_String
  #define LFLock_To_I64 Lucy_LFLock_To_I64
  #define LFLock_To_F64 Lucy_LFLock_To_F64
  #define LFLock_To_Bool Lucy_LFLock_To_Bool
  #define LFLock_Serialize Lucy_LFLock_Serialize
  #define LFLock_Deserialize Lucy_LFLock_Deserialize
  #define LFLock_Dump Lucy_LFLock_Dump
  #define LFLock_Load Lucy_LFLock_Load
  #define LFLock_Mimic Lucy_LFLock_Mimic
  #define LFLock_Shared Lucy_LFLock_Shared
  #define LFLock_Obtain Lucy_LFLock_Obtain
  #define LFLock_Request Lucy_LFLock_Request
  #define LFLock_Release Lucy_LFLock_Release
  #define LFLock_Is_Locked Lucy_LFLock_Is_Locked
  #define LFLock_Clear_Stale Lucy_LFLock_Clear_Stale
  #define LFLock_Get_Name Lucy_LFLock_Get_Name
  #define LFLock_Get_Host Lucy_LFLock_Get_Host
  #define LFLock_Get_Lock_Path Lucy_LFLock_Get_Lock_Path
  #define LFLock_Maybe_Delete_File Lucy_LFLock_Maybe_Delete_File
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Err.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LOCKERR
struct lucy_LockErr {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* mess;
};

#endif /* C_LUCY_LOCKERR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LockErr*
lucy_LockErr_new(lucy_CharBuf* message);

lucy_LockErr*
lucy_LockErr_init(lucy_LockErr* self, lucy_CharBuf* message);

lucy_LockErr*
lucy_LockErr_make(lucy_LockErr* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LockErr_make_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef lucy_LockErr*
(*lucy_LockErr_make_t)(lucy_LockErr* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LockErr_Make_OFFSET;
static CHY_INLINE lucy_LockErr*
Lucy_LockErr_Make(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Make_OFFSET;
    const lucy_LockErr_make_t method = *((lucy_LockErr_make_t*)method_address);
    return method((lucy_LockErr*)self);
}

extern size_t Lucy_LockErr_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LockErr_Get_RefCount(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockErr_Inc_RefCount(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LockErr_Dec_RefCount(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LockErr_To_Host(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_To_Host_OFFSET;
    const lucy_Err_to_host_t method = *((lucy_Err_to_host_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_LockErr_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockErr_Clone(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LockErr_Destroy(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Destroy_OFFSET;
    const lucy_Err_destroy_t method = *((lucy_Err_destroy_t*)method_address);
    method((lucy_Err*)self);
}

extern size_t Lucy_LockErr_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LockErr_Equals(const lucy_LockErr *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LockErr_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LockErr_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LockErr_Compare_To(const lucy_LockErr *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LockErr_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LockErr_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LockErr_Hash_Sum(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LockErr_Get_VTable(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LockErr_Get_Class_Name(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LockErr_Is_A(const lucy_LockErr *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LockErr_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LockErr_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LockErr_To_String(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_To_String_OFFSET;
    const lucy_Err_to_string_t method = *((lucy_Err_to_string_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_LockErr_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LockErr_To_I64(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LockErr_To_F64(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LockErr_To_Bool(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LockErr_Serialize(const lucy_LockErr *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LockErr_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_LockErr_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockErr_Deserialize(const lucy_LockErr *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LockErr_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_LockErr_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockErr_Dump(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockErr_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockErr_Load(const lucy_LockErr *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LockErr_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_LockErr_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LockErr_Mimic(const lucy_LockErr *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LockErr_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LockErr_Cat_Mess_OFFSET;
static CHY_INLINE void
Lucy_LockErr_Cat_Mess(const lucy_LockErr *self, const lucy_CharBuf* mess) {
    char *const method_address = *(char**)self + Lucy_LockErr_Cat_Mess_OFFSET;
    const lucy_Err_cat_mess_t method = *((lucy_Err_cat_mess_t*)method_address);
    method((lucy_Err*)self, mess);
}

extern size_t Lucy_LockErr_Get_Mess_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LockErr_Get_Mess(const lucy_LockErr *self) {
    char *const method_address = *(char**)self + Lucy_LockErr_Get_Mess_OFFSET;
    const lucy_Err_get_mess_t method = *((lucy_Err_get_mess_t*)method_address);
    return method((lucy_Err*)self);
}

extern size_t Lucy_LockErr_Add_Frame_OFFSET;
static CHY_INLINE void
Lucy_LockErr_Add_Frame(const lucy_LockErr *self, const char* file, int line, const char* func) {
    char *const method_address = *(char**)self + Lucy_LockErr_Add_Frame_OFFSET;
    const lucy_Err_add_frame_t method = *((lucy_Err_add_frame_t*)method_address);
    method((lucy_Err*)self, file, line, func);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LOCKERR_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[25];
} LUCY_LOCKERR_VT;
extern struct LUCY_LOCKERR_VT LUCY_LOCKERR_vt;
#define LUCY_LOCKERR ((cfish_VTable*)&LUCY_LOCKERR_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LockErr lucy_LockErr
  #define LOCKERR LUCY_LOCKERR
  #define LockErr_new lucy_LockErr_new
  #define LockErr_init lucy_LockErr_init
  #define LockErr_make_t lucy_LockErr_make_t
  #define LockErr_make lucy_LockErr_make
  #define LockErr_Make Lucy_LockErr_Make
  #define LockErr_Get_RefCount Lucy_LockErr_Get_RefCount
  #define LockErr_Inc_RefCount Lucy_LockErr_Inc_RefCount
  #define LockErr_Dec_RefCount Lucy_LockErr_Dec_RefCount
  #define LockErr_To_Host Lucy_LockErr_To_Host
  #define LockErr_Clone Lucy_LockErr_Clone
  #define LockErr_Destroy Lucy_LockErr_Destroy
  #define LockErr_Equals Lucy_LockErr_Equals
  #define LockErr_Compare_To Lucy_LockErr_Compare_To
  #define LockErr_Hash_Sum Lucy_LockErr_Hash_Sum
  #define LockErr_Get_VTable Lucy_LockErr_Get_VTable
  #define LockErr_Get_Class_Name Lucy_LockErr_Get_Class_Name
  #define LockErr_Is_A Lucy_LockErr_Is_A
  #define LockErr_To_String Lucy_LockErr_To_String
  #define LockErr_To_I64 Lucy_LockErr_To_I64
  #define LockErr_To_F64 Lucy_LockErr_To_F64
  #define LockErr_To_Bool Lucy_LockErr_To_Bool
  #define LockErr_Serialize Lucy_LockErr_Serialize
  #define LockErr_Deserialize Lucy_LockErr_Deserialize
  #define LockErr_Dump Lucy_LockErr_Dump
  #define LockErr_Load Lucy_LockErr_Load
  #define LockErr_Mimic Lucy_LockErr_Mimic
  #define LockErr_Cat_Mess Lucy_LockErr_Cat_Mess
  #define LockErr_Get_Mess Lucy_LockErr_Get_Mess
  #define LockErr_Add_Frame Lucy_LockErr_Add_Frame
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_LOCK */




