/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_LOCKFACTORY
#define H_LUCY_STORE_LOCKFACTORY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LOCKFACTORY
struct lucy_LockFactory {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Folder* folder;
    lucy_CharBuf* host;
};

#endif /* C_LUCY_LOCKFACTORY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_LockFactory*
lucy_LockFact_new(lucy_Folder* folder, const lucy_CharBuf* host);

lucy_LockFactory*
lucy_LockFact_init(lucy_LockFactory* self, lucy_Folder* folder, const lucy_CharBuf* host);

void
lucy_LockFact_destroy(lucy_LockFactory* self);

lucy_Lock*
lucy_LockFact_make_lock(lucy_LockFactory* self, const lucy_CharBuf* name, int32_t timeout, int32_t interval);

lucy_Lock*
lucy_LockFact_make_shared_lock(lucy_LockFactory* self, const lucy_CharBuf* name, int32_t timeout, int32_t interval);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_LockFact_destroy_CALLBACK;
extern cfish_Callback lucy_LockFact_make_lock_CALLBACK;
extern cfish_Callback lucy_LockFact_make_shared_lock_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_LockFact_destroy_t)(lucy_LockFactory* self);

typedef lucy_Lock*
(*lucy_LockFact_make_lock_t)(lucy_LockFactory* self, const lucy_CharBuf* name, int32_t timeout, int32_t interval);

typedef lucy_Lock*
(*lucy_LockFact_make_shared_lock_t)(lucy_LockFactory* self, const lucy_CharBuf* name, int32_t timeout, int32_t interval);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_LockFact_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockFact_Make(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LockFact_Get_RefCount(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockFact_Inc_RefCount(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_LockFact_Dec_RefCount(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_LockFact_To_Host(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockFact_Clone(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Destroy_OFFSET;
static CHY_INLINE void
Lucy_LockFact_Destroy(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Destroy_OFFSET;
    const lucy_LockFact_destroy_t method = *((lucy_LockFact_destroy_t*)method_address);
    method((lucy_LockFactory*)self);
}

extern size_t Lucy_LockFact_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LockFact_Equals(const lucy_LockFactory *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LockFact_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LockFact_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_LockFact_Compare_To(const lucy_LockFactory *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LockFact_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_LockFact_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_LockFact_Hash_Sum(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_LockFact_Get_VTable(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LockFact_Get_Class_Name(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LockFact_Is_A(const lucy_LockFactory *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_LockFact_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_LockFact_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_LockFact_To_String(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_LockFact_To_I64(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_To_F64_OFFSET;
static CHY_INLINE double
Lucy_LockFact_To_F64(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_LockFact_To_Bool(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Serialize_OFFSET;
static CHY_INLINE void
Lucy_LockFact_Serialize(const lucy_LockFactory *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_LockFact_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_LockFact_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockFact_Deserialize(const lucy_LockFactory *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_LockFact_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_LockFact_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockFact_Dump(const lucy_LockFactory *self) {
    char *const method_address = *(char**)self + Lucy_LockFact_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_LockFact_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_LockFact_Load(const lucy_LockFactory *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_LockFact_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_LockFact_Mimic_OFFSET;
static CHY_INLINE void
Lucy_LockFact_Mimic(const lucy_LockFactory *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_LockFact_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_LockFact_Make_Lock_OFFSET;
static CHY_INLINE lucy_Lock*
Lucy_LockFact_Make_Lock(const lucy_LockFactory *self, const lucy_CharBuf* name, int32_t timeout, int32_t interval) {
    char *const method_address = *(char**)self + Lucy_LockFact_Make_Lock_OFFSET;
    const lucy_LockFact_make_lock_t method = *((lucy_LockFact_make_lock_t*)method_address);
    return method((lucy_LockFactory*)self, name, timeout, interval);
}

extern size_t Lucy_LockFact_Make_Shared_Lock_OFFSET;
static CHY_INLINE lucy_Lock*
Lucy_LockFact_Make_Shared_Lock(const lucy_LockFactory *self, const lucy_CharBuf* name, int32_t timeout, int32_t interval) {
    char *const method_address = *(char**)self + Lucy_LockFact_Make_Shared_Lock_OFFSET;
    const lucy_LockFact_make_shared_lock_t method = *((lucy_LockFact_make_shared_lock_t*)method_address);
    return method((lucy_LockFactory*)self, name, timeout, interval);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_LOCKFACTORY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[24];
} LUCY_LOCKFACTORY_VT;
extern struct LUCY_LOCKFACTORY_VT LUCY_LOCKFACTORY_vt;
#define LUCY_LOCKFACTORY ((cfish_VTable*)&LUCY_LOCKFACTORY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LockFactory lucy_LockFactory
  #define LOCKFACTORY LUCY_LOCKFACTORY
  #define LockFact_new lucy_LockFact_new
  #define LockFact_init lucy_LockFact_init
  #define LockFact_destroy_t lucy_LockFact_destroy_t
  #define LockFact_destroy lucy_LockFact_destroy
  #define LockFact_make_lock_t lucy_LockFact_make_lock_t
  #define LockFact_make_lock lucy_LockFact_make_lock
  #define LockFact_make_shared_lock_t lucy_LockFact_make_shared_lock_t
  #define LockFact_make_shared_lock lucy_LockFact_make_shared_lock
  #define LockFact_Make Lucy_LockFact_Make
  #define LockFact_Get_RefCount Lucy_LockFact_Get_RefCount
  #define LockFact_Inc_RefCount Lucy_LockFact_Inc_RefCount
  #define LockFact_Dec_RefCount Lucy_LockFact_Dec_RefCount
  #define LockFact_To_Host Lucy_LockFact_To_Host
  #define LockFact_Clone Lucy_LockFact_Clone
  #define LockFact_Destroy Lucy_LockFact_Destroy
  #define LockFact_Equals Lucy_LockFact_Equals
  #define LockFact_Compare_To Lucy_LockFact_Compare_To
  #define LockFact_Hash_Sum Lucy_LockFact_Hash_Sum
  #define LockFact_Get_VTable Lucy_LockFact_Get_VTable
  #define LockFact_Get_Class_Name Lucy_LockFact_Get_Class_Name
  #define LockFact_Is_A Lucy_LockFact_Is_A
  #define LockFact_To_String Lucy_LockFact_To_String
  #define LockFact_To_I64 Lucy_LockFact_To_I64
  #define LockFact_To_F64 Lucy_LockFact_To_F64
  #define LockFact_To_Bool Lucy_LockFact_To_Bool
  #define LockFact_Serialize Lucy_LockFact_Serialize
  #define LockFact_Deserialize Lucy_LockFact_Deserialize
  #define LockFact_Dump Lucy_LockFact_Dump
  #define LockFact_Load Lucy_LockFact_Load
  #define LockFact_Mimic Lucy_LockFact_Mimic
  #define LockFact_Make_Lock Lucy_LockFact_Make_Lock
  #define LockFact_Make_Shared_Lock Lucy_LockFact_Make_Shared_Lock
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_LOCKFACTORY */




