/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_OUTSTREAM
#define H_LUCY_STORE_OUTSTREAM 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_OUTSTREAM
struct lucy_OutStream {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    char* buf;
    int64_t buf_start;
    size_t buf_pos;
    lucy_FileHandle* file_handle;
    lucy_CharBuf* path;
};

#endif /* C_LUCY_OUTSTREAM */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_OutStream*
lucy_OutStream_open(lucy_Obj* file);

lucy_OutStream*
lucy_OutStream_do_open(lucy_OutStream* self, lucy_Obj* file);

void
lucy_OutStream_destroy(lucy_OutStream* self);

lucy_CharBuf*
lucy_OutStream_get_path(lucy_OutStream* self);

int64_t
lucy_OutStream_tell(lucy_OutStream* self);

int64_t
lucy_OutStream_align(lucy_OutStream* self, int64_t modulus);

void
lucy_OutStream_flush(lucy_OutStream* self);

int64_t
lucy_OutStream_length(lucy_OutStream* self);

void
lucy_OutStream_grow(lucy_OutStream* self, int64_t length);

void
lucy_OutStream_write_bytes(lucy_OutStream* self, const void* buf, size_t len);

void
lucy_OutStream_write_i8(lucy_OutStream* self, int8_t value);

void
lucy_OutStream_write_u8(lucy_OutStream* self, uint8_t value);

void
lucy_OutStream_write_i32(lucy_OutStream* self, int32_t value);

void
lucy_OutStream_write_u32(lucy_OutStream* self, uint32_t value);

void
lucy_OutStream_write_i64(lucy_OutStream* self, int64_t value);

void
lucy_OutStream_write_u64(lucy_OutStream* self, uint64_t value);

void
lucy_OutStream_write_c32(lucy_OutStream* self, uint32_t value);

void
lucy_OutStream_write_c64(lucy_OutStream* self, uint64_t value);

void
lucy_OutStream_write_f32(lucy_OutStream* self, float value);

void
lucy_OutStream_write_f64(lucy_OutStream* self, double value);

void
lucy_OutStream_write_string(lucy_OutStream* self, const char* buf, size_t len);

void
lucy_OutStream_absorb(lucy_OutStream* self, lucy_InStream* instream);

void
lucy_OutStream_close(lucy_OutStream* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_OutStream_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_OutStream_destroy_t)(lucy_OutStream* self);

typedef lucy_CharBuf*
(*lucy_OutStream_get_path_t)(lucy_OutStream* self);

typedef int64_t
(*lucy_OutStream_tell_t)(lucy_OutStream* self);

typedef int64_t
(*lucy_OutStream_align_t)(lucy_OutStream* self, int64_t modulus);

typedef void
(*lucy_OutStream_flush_t)(lucy_OutStream* self);

typedef int64_t
(*lucy_OutStream_length_t)(lucy_OutStream* self);

typedef void
(*lucy_OutStream_grow_t)(lucy_OutStream* self, int64_t length);

typedef void
(*lucy_OutStream_write_bytes_t)(lucy_OutStream* self, const void* buf, size_t len);

typedef void
(*lucy_OutStream_write_i8_t)(lucy_OutStream* self, int8_t value);

typedef void
(*lucy_OutStream_write_u8_t)(lucy_OutStream* self, uint8_t value);

typedef void
(*lucy_OutStream_write_i32_t)(lucy_OutStream* self, int32_t value);

typedef void
(*lucy_OutStream_write_u32_t)(lucy_OutStream* self, uint32_t value);

typedef void
(*lucy_OutStream_write_i64_t)(lucy_OutStream* self, int64_t value);

typedef void
(*lucy_OutStream_write_u64_t)(lucy_OutStream* self, uint64_t value);

typedef void
(*lucy_OutStream_write_c32_t)(lucy_OutStream* self, uint32_t value);

typedef void
(*lucy_OutStream_write_c64_t)(lucy_OutStream* self, uint64_t value);

typedef void
(*lucy_OutStream_write_f32_t)(lucy_OutStream* self, float value);

typedef void
(*lucy_OutStream_write_f64_t)(lucy_OutStream* self, double value);

typedef void
(*lucy_OutStream_write_string_t)(lucy_OutStream* self, const char* buf, size_t len);

typedef void
(*lucy_OutStream_absorb_t)(lucy_OutStream* self, lucy_InStream* instream);

typedef void
(*lucy_OutStream_close_t)(lucy_OutStream* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_OutStream_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_OutStream_Make(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_OutStream_Get_RefCount(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_OutStream_Inc_RefCount(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_OutStream_Dec_RefCount(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_OutStream_To_Host(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_OutStream_Clone(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Destroy_OFFSET;
static CHY_INLINE void
Lucy_OutStream_Destroy(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Destroy_OFFSET;
    const lucy_OutStream_destroy_t method = *((lucy_OutStream_destroy_t*)method_address);
    method((lucy_OutStream*)self);
}

extern size_t Lucy_OutStream_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_OutStream_Equals(const lucy_OutStream *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_OutStream_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_OutStream_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_OutStream_Compare_To(const lucy_OutStream *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_OutStream_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_OutStream_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_OutStream_Hash_Sum(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_OutStream_Get_VTable(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_OutStream_Get_Class_Name(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_OutStream_Is_A(const lucy_OutStream *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_OutStream_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_OutStream_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_OutStream_To_String(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_OutStream_To_I64(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_To_F64_OFFSET;
static CHY_INLINE double
Lucy_OutStream_To_F64(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_OutStream_To_Bool(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Serialize_OFFSET;
static CHY_INLINE void
Lucy_OutStream_Serialize(const lucy_OutStream *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_OutStream_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_OutStream_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_OutStream_Deserialize(const lucy_OutStream *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_OutStream_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_OutStream_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_OutStream_Dump(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_OutStream_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_OutStream_Load(const lucy_OutStream *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_OutStream_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_OutStream_Mimic_OFFSET;
static CHY_INLINE void
Lucy_OutStream_Mimic(const lucy_OutStream *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_OutStream_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_OutStream_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_OutStream_Get_Path(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Get_Path_OFFSET;
    const lucy_OutStream_get_path_t method = *((lucy_OutStream_get_path_t*)method_address);
    return method((lucy_OutStream*)self);
}

#define Lucy_OutStream_Tell(self) \
    lucy_OutStream_tell((lucy_OutStream*)self)

#define Lucy_OutStream_Align(self, modulus) \
    lucy_OutStream_align((lucy_OutStream*)self, modulus)

#define Lucy_OutStream_Flush(self) \
    lucy_OutStream_flush((lucy_OutStream*)self)

#define Lucy_OutStream_Length(self) \
    lucy_OutStream_length((lucy_OutStream*)self)

extern size_t Lucy_OutStream_Grow_OFFSET;
static CHY_INLINE void
Lucy_OutStream_Grow(const lucy_OutStream *self, int64_t length) {
    char *const method_address = *(char**)self + Lucy_OutStream_Grow_OFFSET;
    const lucy_OutStream_grow_t method = *((lucy_OutStream_grow_t*)method_address);
    method((lucy_OutStream*)self, length);
}

#define Lucy_OutStream_Write_Bytes(self, buf, len) \
    lucy_OutStream_write_bytes((lucy_OutStream*)self, buf, len)

#define Lucy_OutStream_Write_I8(self, value) \
    lucy_OutStream_write_i8((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_U8(self, value) \
    lucy_OutStream_write_u8((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_I32(self, value) \
    lucy_OutStream_write_i32((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_U32(self, value) \
    lucy_OutStream_write_u32((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_I64(self, value) \
    lucy_OutStream_write_i64((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_U64(self, value) \
    lucy_OutStream_write_u64((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_C32(self, value) \
    lucy_OutStream_write_c32((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_C64(self, value) \
    lucy_OutStream_write_c64((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_F32(self, value) \
    lucy_OutStream_write_f32((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_F64(self, value) \
    lucy_OutStream_write_f64((lucy_OutStream*)self, value)

#define Lucy_OutStream_Write_String(self, buf, len) \
    lucy_OutStream_write_string((lucy_OutStream*)self, buf, len)

extern size_t Lucy_OutStream_Absorb_OFFSET;
static CHY_INLINE void
Lucy_OutStream_Absorb(const lucy_OutStream *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_OutStream_Absorb_OFFSET;
    const lucy_OutStream_absorb_t method = *((lucy_OutStream_absorb_t*)method_address);
    method((lucy_OutStream*)self, instream);
}

extern size_t Lucy_OutStream_Close_OFFSET;
static CHY_INLINE void
Lucy_OutStream_Close(const lucy_OutStream *self) {
    char *const method_address = *(char**)self + Lucy_OutStream_Close_OFFSET;
    const lucy_OutStream_close_t method = *((lucy_OutStream_close_t*)method_address);
    method((lucy_OutStream*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_OUTSTREAM_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[42];
} LUCY_OUTSTREAM_VT;
extern struct LUCY_OUTSTREAM_VT LUCY_OUTSTREAM_vt;
#define LUCY_OUTSTREAM ((cfish_VTable*)&LUCY_OUTSTREAM_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define OutStream lucy_OutStream
  #define OUTSTREAM LUCY_OUTSTREAM
  #define OutStream_open lucy_OutStream_open
  #define OutStream_do_open lucy_OutStream_do_open
  #define OutStream_destroy_t lucy_OutStream_destroy_t
  #define OutStream_destroy lucy_OutStream_destroy
  #define OutStream_get_path_t lucy_OutStream_get_path_t
  #define OutStream_get_path lucy_OutStream_get_path
  #define OutStream_tell_t lucy_OutStream_tell_t
  #define OutStream_tell lucy_OutStream_tell
  #define OutStream_align_t lucy_OutStream_align_t
  #define OutStream_align lucy_OutStream_align
  #define OutStream_flush_t lucy_OutStream_flush_t
  #define OutStream_flush lucy_OutStream_flush
  #define OutStream_length_t lucy_OutStream_length_t
  #define OutStream_length lucy_OutStream_length
  #define OutStream_grow_t lucy_OutStream_grow_t
  #define OutStream_grow lucy_OutStream_grow
  #define OutStream_write_bytes_t lucy_OutStream_write_bytes_t
  #define OutStream_write_bytes lucy_OutStream_write_bytes
  #define OutStream_write_i8_t lucy_OutStream_write_i8_t
  #define OutStream_write_i8 lucy_OutStream_write_i8
  #define OutStream_write_u8_t lucy_OutStream_write_u8_t
  #define OutStream_write_u8 lucy_OutStream_write_u8
  #define OutStream_write_i32_t lucy_OutStream_write_i32_t
  #define OutStream_write_i32 lucy_OutStream_write_i32
  #define OutStream_write_u32_t lucy_OutStream_write_u32_t
  #define OutStream_write_u32 lucy_OutStream_write_u32
  #define OutStream_write_i64_t lucy_OutStream_write_i64_t
  #define OutStream_write_i64 lucy_OutStream_write_i64
  #define OutStream_write_u64_t lucy_OutStream_write_u64_t
  #define OutStream_write_u64 lucy_OutStream_write_u64
  #define OutStream_write_c32_t lucy_OutStream_write_c32_t
  #define OutStream_write_c32 lucy_OutStream_write_c32
  #define OutStream_write_c64_t lucy_OutStream_write_c64_t
  #define OutStream_write_c64 lucy_OutStream_write_c64
  #define OutStream_write_f32_t lucy_OutStream_write_f32_t
  #define OutStream_write_f32 lucy_OutStream_write_f32
  #define OutStream_write_f64_t lucy_OutStream_write_f64_t
  #define OutStream_write_f64 lucy_OutStream_write_f64
  #define OutStream_write_string_t lucy_OutStream_write_string_t
  #define OutStream_write_string lucy_OutStream_write_string
  #define OutStream_absorb_t lucy_OutStream_absorb_t
  #define OutStream_absorb lucy_OutStream_absorb
  #define OutStream_close_t lucy_OutStream_close_t
  #define OutStream_close lucy_OutStream_close
  #define OutStream_Make Lucy_OutStream_Make
  #define OutStream_Get_RefCount Lucy_OutStream_Get_RefCount
  #define OutStream_Inc_RefCount Lucy_OutStream_Inc_RefCount
  #define OutStream_Dec_RefCount Lucy_OutStream_Dec_RefCount
  #define OutStream_To_Host Lucy_OutStream_To_Host
  #define OutStream_Clone Lucy_OutStream_Clone
  #define OutStream_Destroy Lucy_OutStream_Destroy
  #define OutStream_Equals Lucy_OutStream_Equals
  #define OutStream_Compare_To Lucy_OutStream_Compare_To
  #define OutStream_Hash_Sum Lucy_OutStream_Hash_Sum
  #define OutStream_Get_VTable Lucy_OutStream_Get_VTable
  #define OutStream_Get_Class_Name Lucy_OutStream_Get_Class_Name
  #define OutStream_Is_A Lucy_OutStream_Is_A
  #define OutStream_To_String Lucy_OutStream_To_String
  #define OutStream_To_I64 Lucy_OutStream_To_I64
  #define OutStream_To_F64 Lucy_OutStream_To_F64
  #define OutStream_To_Bool Lucy_OutStream_To_Bool
  #define OutStream_Serialize Lucy_OutStream_Serialize
  #define OutStream_Deserialize Lucy_OutStream_Deserialize
  #define OutStream_Dump Lucy_OutStream_Dump
  #define OutStream_Load Lucy_OutStream_Load
  #define OutStream_Mimic Lucy_OutStream_Mimic
  #define OutStream_Get_Path Lucy_OutStream_Get_Path
  #define OutStream_Tell Lucy_OutStream_Tell
  #define OutStream_Align Lucy_OutStream_Align
  #define OutStream_Flush Lucy_OutStream_Flush
  #define OutStream_Length Lucy_OutStream_Length
  #define OutStream_Grow Lucy_OutStream_Grow
  #define OutStream_Write_Bytes Lucy_OutStream_Write_Bytes
  #define OutStream_Write_I8 Lucy_OutStream_Write_I8
  #define OutStream_Write_U8 Lucy_OutStream_Write_U8
  #define OutStream_Write_I32 Lucy_OutStream_Write_I32
  #define OutStream_Write_U32 Lucy_OutStream_Write_U32
  #define OutStream_Write_I64 Lucy_OutStream_Write_I64
  #define OutStream_Write_U64 Lucy_OutStream_Write_U64
  #define OutStream_Write_C32 Lucy_OutStream_Write_C32
  #define OutStream_Write_C64 Lucy_OutStream_Write_C64
  #define OutStream_Write_F32 Lucy_OutStream_Write_F32
  #define OutStream_Write_F64 Lucy_OutStream_Write_F64
  #define OutStream_Write_String Lucy_OutStream_Write_String
  #define OutStream_Absorb Lucy_OutStream_Absorb
  #define OutStream_Close Lucy_OutStream_Close
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_OUTSTREAM */




