/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_RAMDIRHANDLE
#define H_LUCY_STORE_RAMDIRHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/DirHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAMDIRHANDLE
struct lucy_RAMDirHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* dir;
    lucy_CharBuf* entry;
    lucy_RAMFolder* folder;
    lucy_VArray* elems;
    int32_t tick;
};

#endif /* C_LUCY_RAMDIRHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RAMDirHandle*
lucy_RAMDH_new(lucy_RAMFolder* folder);

lucy_RAMDirHandle*
lucy_RAMDH_init(lucy_RAMDirHandle* self, lucy_RAMFolder* folder);

chy_bool_t
lucy_RAMDH_next(lucy_RAMDirHandle* self);

chy_bool_t
lucy_RAMDH_close(lucy_RAMDirHandle* self);

chy_bool_t
lucy_RAMDH_entry_is_dir(lucy_RAMDirHandle* self);

chy_bool_t
lucy_RAMDH_entry_is_symlink(lucy_RAMDirHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_RAMDH_next_t)(lucy_RAMDirHandle* self);

typedef chy_bool_t
(*lucy_RAMDH_close_t)(lucy_RAMDirHandle* self);

typedef chy_bool_t
(*lucy_RAMDH_entry_is_dir_t)(lucy_RAMDirHandle* self);

typedef chy_bool_t
(*lucy_RAMDH_entry_is_symlink_t)(lucy_RAMDirHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RAMDH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMDH_Make(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RAMDH_Get_RefCount(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMDH_Inc_RefCount(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RAMDH_Dec_RefCount(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RAMDH_To_Host(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMDH_Clone(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RAMDH_Destroy(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Destroy_OFFSET;
    const lucy_DH_destroy_t method = *((lucy_DH_destroy_t*)method_address);
    method((lucy_DirHandle*)self);
}

extern size_t Lucy_RAMDH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_Equals(const lucy_RAMDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMDH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RAMDH_Compare_To(const lucy_RAMDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMDH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RAMDH_Hash_Sum(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RAMDH_Get_VTable(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMDH_Get_Class_Name(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_Is_A(const lucy_RAMDirHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RAMDH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMDH_To_String(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RAMDH_To_I64(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RAMDH_To_F64(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_To_Bool(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RAMDH_Serialize(const lucy_RAMDirHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RAMDH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMDH_Deserialize(const lucy_RAMDirHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RAMDH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMDH_Dump(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMDH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMDH_Load(const lucy_RAMDirHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RAMDH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RAMDH_Mimic(const lucy_RAMDirHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMDH_Next_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_Next(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Next_OFFSET;
    const lucy_RAMDH_next_t method = *((lucy_RAMDH_next_t*)method_address);
    return method((lucy_RAMDirHandle*)self);
}

extern size_t Lucy_RAMDH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_Close(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Close_OFFSET;
    const lucy_RAMDH_close_t method = *((lucy_RAMDH_close_t*)method_address);
    return method((lucy_RAMDirHandle*)self);
}

extern size_t Lucy_RAMDH_Get_Dir_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMDH_Get_Dir(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Get_Dir_OFFSET;
    const lucy_DH_get_dir_t method = *((lucy_DH_get_dir_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_RAMDH_Get_Entry_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMDH_Get_Entry(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Get_Entry_OFFSET;
    const lucy_DH_get_entry_t method = *((lucy_DH_get_entry_t*)method_address);
    return method((lucy_DirHandle*)self);
}

extern size_t Lucy_RAMDH_Entry_Is_Dir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_Entry_Is_Dir(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Entry_Is_Dir_OFFSET;
    const lucy_RAMDH_entry_is_dir_t method = *((lucy_RAMDH_entry_is_dir_t*)method_address);
    return method((lucy_RAMDirHandle*)self);
}

extern size_t Lucy_RAMDH_Entry_Is_Symlink_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMDH_Entry_Is_Symlink(const lucy_RAMDirHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMDH_Entry_Is_Symlink_OFFSET;
    const lucy_RAMDH_entry_is_symlink_t method = *((lucy_RAMDH_entry_is_symlink_t*)method_address);
    return method((lucy_RAMDirHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RAMDIRHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_RAMDIRHANDLE_VT;
extern struct LUCY_RAMDIRHANDLE_VT LUCY_RAMDIRHANDLE_vt;
#define LUCY_RAMDIRHANDLE ((cfish_VTable*)&LUCY_RAMDIRHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RAMDirHandle lucy_RAMDirHandle
  #define RAMDIRHANDLE LUCY_RAMDIRHANDLE
  #define RAMDH_new lucy_RAMDH_new
  #define RAMDH_init lucy_RAMDH_init
  #define RAMDH_next_t lucy_RAMDH_next_t
  #define RAMDH_next lucy_RAMDH_next
  #define RAMDH_close_t lucy_RAMDH_close_t
  #define RAMDH_close lucy_RAMDH_close
  #define RAMDH_entry_is_dir_t lucy_RAMDH_entry_is_dir_t
  #define RAMDH_entry_is_dir lucy_RAMDH_entry_is_dir
  #define RAMDH_entry_is_symlink_t lucy_RAMDH_entry_is_symlink_t
  #define RAMDH_entry_is_symlink lucy_RAMDH_entry_is_symlink
  #define RAMDH_Make Lucy_RAMDH_Make
  #define RAMDH_Get_RefCount Lucy_RAMDH_Get_RefCount
  #define RAMDH_Inc_RefCount Lucy_RAMDH_Inc_RefCount
  #define RAMDH_Dec_RefCount Lucy_RAMDH_Dec_RefCount
  #define RAMDH_To_Host Lucy_RAMDH_To_Host
  #define RAMDH_Clone Lucy_RAMDH_Clone
  #define RAMDH_Destroy Lucy_RAMDH_Destroy
  #define RAMDH_Equals Lucy_RAMDH_Equals
  #define RAMDH_Compare_To Lucy_RAMDH_Compare_To
  #define RAMDH_Hash_Sum Lucy_RAMDH_Hash_Sum
  #define RAMDH_Get_VTable Lucy_RAMDH_Get_VTable
  #define RAMDH_Get_Class_Name Lucy_RAMDH_Get_Class_Name
  #define RAMDH_Is_A Lucy_RAMDH_Is_A
  #define RAMDH_To_String Lucy_RAMDH_To_String
  #define RAMDH_To_I64 Lucy_RAMDH_To_I64
  #define RAMDH_To_F64 Lucy_RAMDH_To_F64
  #define RAMDH_To_Bool Lucy_RAMDH_To_Bool
  #define RAMDH_Serialize Lucy_RAMDH_Serialize
  #define RAMDH_Deserialize Lucy_RAMDH_Deserialize
  #define RAMDH_Dump Lucy_RAMDH_Dump
  #define RAMDH_Load Lucy_RAMDH_Load
  #define RAMDH_Mimic Lucy_RAMDH_Mimic
  #define RAMDH_Next Lucy_RAMDH_Next
  #define RAMDH_Close Lucy_RAMDH_Close
  #define RAMDH_Get_Dir Lucy_RAMDH_Get_Dir
  #define RAMDH_Get_Entry Lucy_RAMDH_Get_Entry
  #define RAMDH_Entry_Is_Dir Lucy_RAMDH_Entry_Is_Dir
  #define RAMDH_Entry_Is_Symlink Lucy_RAMDH_Entry_Is_Symlink
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_RAMDIRHANDLE */




