/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_RAMFILEHANDLE
#define H_LUCY_STORE_RAMFILEHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/FileHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAMFILEHANDLE
struct lucy_RAMFileHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    uint32_t flags;
    lucy_RAMFile* ram_file;
    int64_t len;
};

#endif /* C_LUCY_RAMFILEHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RAMFileHandle*
lucy_RAMFH_open(const lucy_CharBuf* path, uint32_t flags, lucy_RAMFile* file);

lucy_RAMFileHandle*
lucy_RAMFH_do_open(lucy_RAMFileHandle* self, const lucy_CharBuf* path, uint32_t flags, lucy_RAMFile* file);

void
lucy_RAMFH_destroy(lucy_RAMFileHandle* self);

chy_bool_t
lucy_RAMFH_window(lucy_RAMFileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

chy_bool_t
lucy_RAMFH_release_window(lucy_RAMFileHandle* self, lucy_FileWindow* window);

chy_bool_t
lucy_RAMFH_read(lucy_RAMFileHandle* self, char* dest, int64_t offset, size_t len);

chy_bool_t
lucy_RAMFH_write(lucy_RAMFileHandle* self, const void* data, size_t len);

int64_t
lucy_RAMFH_length(lucy_RAMFileHandle* self);

chy_bool_t
lucy_RAMFH_grow(lucy_RAMFileHandle* self, int64_t len);

chy_bool_t
lucy_RAMFH_close(lucy_RAMFileHandle* self);

lucy_RAMFile*
lucy_RAMFH_get_file(lucy_RAMFileHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RAMFH_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_RAMFH_destroy_t)(lucy_RAMFileHandle* self);

typedef chy_bool_t
(*lucy_RAMFH_window_t)(lucy_RAMFileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

typedef chy_bool_t
(*lucy_RAMFH_release_window_t)(lucy_RAMFileHandle* self, lucy_FileWindow* window);

typedef chy_bool_t
(*lucy_RAMFH_read_t)(lucy_RAMFileHandle* self, char* dest, int64_t offset, size_t len);

typedef chy_bool_t
(*lucy_RAMFH_write_t)(lucy_RAMFileHandle* self, const void* data, size_t len);

typedef int64_t
(*lucy_RAMFH_length_t)(lucy_RAMFileHandle* self);

typedef chy_bool_t
(*lucy_RAMFH_grow_t)(lucy_RAMFileHandle* self, int64_t len);

typedef chy_bool_t
(*lucy_RAMFH_close_t)(lucy_RAMFileHandle* self);

typedef lucy_RAMFile*
(*lucy_RAMFH_get_file_t)(lucy_RAMFileHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RAMFH_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFH_Make(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RAMFH_Get_RefCount(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFH_Inc_RefCount(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RAMFH_Dec_RefCount(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RAMFH_To_Host(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFH_Clone(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RAMFH_Destroy(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Destroy_OFFSET;
    const lucy_RAMFH_destroy_t method = *((lucy_RAMFH_destroy_t*)method_address);
    method((lucy_RAMFileHandle*)self);
}

extern size_t Lucy_RAMFH_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Equals(const lucy_RAMFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMFH_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RAMFH_Compare_To(const lucy_RAMFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMFH_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RAMFH_Hash_Sum(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RAMFH_Get_VTable(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMFH_Get_Class_Name(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Is_A(const lucy_RAMFileHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RAMFH_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMFH_To_String(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RAMFH_To_I64(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RAMFH_To_F64(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_To_Bool(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RAMFH_Serialize(const lucy_RAMFileHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RAMFH_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFH_Deserialize(const lucy_RAMFileHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RAMFH_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFH_Dump(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFH_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFH_Load(const lucy_RAMFileHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RAMFH_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RAMFH_Mimic(const lucy_RAMFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMFH_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Window(const lucy_RAMFileHandle *self, lucy_FileWindow* window, int64_t offset, int64_t len) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Window_OFFSET;
    const lucy_RAMFH_window_t method = *((lucy_RAMFH_window_t*)method_address);
    return method((lucy_RAMFileHandle*)self, window, offset, len);
}

extern size_t Lucy_RAMFH_Release_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Release_Window(const lucy_RAMFileHandle *self, lucy_FileWindow* window) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Release_Window_OFFSET;
    const lucy_RAMFH_release_window_t method = *((lucy_RAMFH_release_window_t*)method_address);
    return method((lucy_RAMFileHandle*)self, window);
}

extern size_t Lucy_RAMFH_Read_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Read(const lucy_RAMFileHandle *self, char* dest, int64_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Read_OFFSET;
    const lucy_RAMFH_read_t method = *((lucy_RAMFH_read_t*)method_address);
    return method((lucy_RAMFileHandle*)self, dest, offset, len);
}

extern size_t Lucy_RAMFH_Write_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Write(const lucy_RAMFileHandle *self, const void* data, size_t len) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Write_OFFSET;
    const lucy_RAMFH_write_t method = *((lucy_RAMFH_write_t*)method_address);
    return method((lucy_RAMFileHandle*)self, data, len);
}

extern size_t Lucy_RAMFH_Length_OFFSET;
static CHY_INLINE int64_t
Lucy_RAMFH_Length(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Length_OFFSET;
    const lucy_RAMFH_length_t method = *((lucy_RAMFH_length_t*)method_address);
    return method((lucy_RAMFileHandle*)self);
}

extern size_t Lucy_RAMFH_Grow_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Grow(const lucy_RAMFileHandle *self, int64_t len) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Grow_OFFSET;
    const lucy_RAMFH_grow_t method = *((lucy_RAMFH_grow_t*)method_address);
    return method((lucy_RAMFileHandle*)self, len);
}

extern size_t Lucy_RAMFH_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFH_Close(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Close_OFFSET;
    const lucy_RAMFH_close_t method = *((lucy_RAMFH_close_t*)method_address);
    return method((lucy_RAMFileHandle*)self);
}

extern size_t Lucy_RAMFH_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_RAMFH_Set_Path(const lucy_RAMFileHandle *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Set_Path_OFFSET;
    const lucy_FH_set_path_t method = *((lucy_FH_set_path_t*)method_address);
    method((lucy_FileHandle*)self, path);
}

extern size_t Lucy_RAMFH_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMFH_Get_Path(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Get_Path_OFFSET;
    const lucy_FH_get_path_t method = *((lucy_FH_get_path_t*)method_address);
    return method((lucy_FileHandle*)self);
}

extern size_t Lucy_RAMFH_Get_File_OFFSET;
static CHY_INLINE lucy_RAMFile*
Lucy_RAMFH_Get_File(const lucy_RAMFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_RAMFH_Get_File_OFFSET;
    const lucy_RAMFH_get_file_t method = *((lucy_RAMFH_get_file_t*)method_address);
    return method((lucy_RAMFileHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RAMFILEHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_RAMFILEHANDLE_VT;
extern struct LUCY_RAMFILEHANDLE_VT LUCY_RAMFILEHANDLE_vt;
#define LUCY_RAMFILEHANDLE ((cfish_VTable*)&LUCY_RAMFILEHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RAMFileHandle lucy_RAMFileHandle
  #define RAMFILEHANDLE LUCY_RAMFILEHANDLE
  #define RAMFH_open lucy_RAMFH_open
  #define RAMFH_do_open lucy_RAMFH_do_open
  #define RAMFH_destroy_t lucy_RAMFH_destroy_t
  #define RAMFH_destroy lucy_RAMFH_destroy
  #define RAMFH_window_t lucy_RAMFH_window_t
  #define RAMFH_window lucy_RAMFH_window
  #define RAMFH_release_window_t lucy_RAMFH_release_window_t
  #define RAMFH_release_window lucy_RAMFH_release_window
  #define RAMFH_read_t lucy_RAMFH_read_t
  #define RAMFH_read lucy_RAMFH_read
  #define RAMFH_write_t lucy_RAMFH_write_t
  #define RAMFH_write lucy_RAMFH_write
  #define RAMFH_length_t lucy_RAMFH_length_t
  #define RAMFH_length lucy_RAMFH_length
  #define RAMFH_grow_t lucy_RAMFH_grow_t
  #define RAMFH_grow lucy_RAMFH_grow
  #define RAMFH_close_t lucy_RAMFH_close_t
  #define RAMFH_close lucy_RAMFH_close
  #define RAMFH_get_file_t lucy_RAMFH_get_file_t
  #define RAMFH_get_file lucy_RAMFH_get_file
  #define RAMFH_Make Lucy_RAMFH_Make
  #define RAMFH_Get_RefCount Lucy_RAMFH_Get_RefCount
  #define RAMFH_Inc_RefCount Lucy_RAMFH_Inc_RefCount
  #define RAMFH_Dec_RefCount Lucy_RAMFH_Dec_RefCount
  #define RAMFH_To_Host Lucy_RAMFH_To_Host
  #define RAMFH_Clone Lucy_RAMFH_Clone
  #define RAMFH_Destroy Lucy_RAMFH_Destroy
  #define RAMFH_Equals Lucy_RAMFH_Equals
  #define RAMFH_Compare_To Lucy_RAMFH_Compare_To
  #define RAMFH_Hash_Sum Lucy_RAMFH_Hash_Sum
  #define RAMFH_Get_VTable Lucy_RAMFH_Get_VTable
  #define RAMFH_Get_Class_Name Lucy_RAMFH_Get_Class_Name
  #define RAMFH_Is_A Lucy_RAMFH_Is_A
  #define RAMFH_To_String Lucy_RAMFH_To_String
  #define RAMFH_To_I64 Lucy_RAMFH_To_I64
  #define RAMFH_To_F64 Lucy_RAMFH_To_F64
  #define RAMFH_To_Bool Lucy_RAMFH_To_Bool
  #define RAMFH_Serialize Lucy_RAMFH_Serialize
  #define RAMFH_Deserialize Lucy_RAMFH_Deserialize
  #define RAMFH_Dump Lucy_RAMFH_Dump
  #define RAMFH_Load Lucy_RAMFH_Load
  #define RAMFH_Mimic Lucy_RAMFH_Mimic
  #define RAMFH_Window Lucy_RAMFH_Window
  #define RAMFH_Release_Window Lucy_RAMFH_Release_Window
  #define RAMFH_Read Lucy_RAMFH_Read
  #define RAMFH_Write Lucy_RAMFH_Write
  #define RAMFH_Length Lucy_RAMFH_Length
  #define RAMFH_Grow Lucy_RAMFH_Grow
  #define RAMFH_Close Lucy_RAMFH_Close
  #define RAMFH_Set_Path Lucy_RAMFH_Set_Path
  #define RAMFH_Get_Path Lucy_RAMFH_Get_Path
  #define RAMFH_Get_File Lucy_RAMFH_Get_File
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_RAMFILEHANDLE */




