/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_RAMFOLDER
#define H_LUCY_STORE_RAMFOLDER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/Folder.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RAMFOLDER
struct lucy_RAMFolder {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    lucy_Hash* entries;
};

#endif /* C_LUCY_RAMFOLDER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_RAMFolder*
lucy_RAMFolder_new(const lucy_CharBuf* path);

lucy_RAMFolder*
lucy_RAMFolder_init(lucy_RAMFolder* self, const lucy_CharBuf* path);

chy_bool_t
lucy_RAMFolder_rename(lucy_RAMFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

chy_bool_t
lucy_RAMFolder_hard_link(lucy_RAMFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

void
lucy_RAMFolder_initialize(lucy_RAMFolder* self);

chy_bool_t
lucy_RAMFolder_check(lucy_RAMFolder* self);

void
lucy_RAMFolder_close(lucy_RAMFolder* self);

lucy_FileHandle*
lucy_RAMFolder_local_open_filehandle(lucy_RAMFolder* self, const lucy_CharBuf* name, uint32_t flags);

lucy_DirHandle*
lucy_RAMFolder_local_open_dir(lucy_RAMFolder* self);

chy_bool_t
lucy_RAMFolder_local_mkdir(lucy_RAMFolder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_RAMFolder_local_exists(lucy_RAMFolder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_RAMFolder_local_is_directory(lucy_RAMFolder* self, const lucy_CharBuf* name);

lucy_Folder*
lucy_RAMFolder_local_find_folder(lucy_RAMFolder* self, const lucy_CharBuf* name);

chy_bool_t
lucy_RAMFolder_local_delete(lucy_RAMFolder* self, const lucy_CharBuf* name);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_RAMFolder_rename_CALLBACK;
extern cfish_Callback lucy_RAMFolder_hard_link_CALLBACK;
extern cfish_Callback lucy_RAMFolder_initialize_CALLBACK;
extern cfish_Callback lucy_RAMFolder_check_CALLBACK;
extern cfish_Callback lucy_RAMFolder_close_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_RAMFolder_rename_t)(lucy_RAMFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

typedef chy_bool_t
(*lucy_RAMFolder_hard_link_t)(lucy_RAMFolder* self, const lucy_CharBuf* from, const lucy_CharBuf* to);

typedef void
(*lucy_RAMFolder_initialize_t)(lucy_RAMFolder* self);

typedef chy_bool_t
(*lucy_RAMFolder_check_t)(lucy_RAMFolder* self);

typedef void
(*lucy_RAMFolder_close_t)(lucy_RAMFolder* self);

typedef lucy_FileHandle*
(*lucy_RAMFolder_local_open_filehandle_t)(lucy_RAMFolder* self, const lucy_CharBuf* name, uint32_t flags);

typedef lucy_DirHandle*
(*lucy_RAMFolder_local_open_dir_t)(lucy_RAMFolder* self);

typedef chy_bool_t
(*lucy_RAMFolder_local_mkdir_t)(lucy_RAMFolder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_RAMFolder_local_exists_t)(lucy_RAMFolder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_RAMFolder_local_is_directory_t)(lucy_RAMFolder* self, const lucy_CharBuf* name);

typedef lucy_Folder*
(*lucy_RAMFolder_local_find_folder_t)(lucy_RAMFolder* self, const lucy_CharBuf* name);

typedef chy_bool_t
(*lucy_RAMFolder_local_delete_t)(lucy_RAMFolder* self, const lucy_CharBuf* name);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_RAMFolder_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFolder_Make(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RAMFolder_Get_RefCount(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFolder_Inc_RefCount(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_RAMFolder_Dec_RefCount(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_RAMFolder_To_Host(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFolder_Clone(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Destroy_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Destroy(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Destroy_OFFSET;
    const lucy_Folder_destroy_t method = *((lucy_Folder_destroy_t*)method_address);
    method((lucy_Folder*)self);
}

extern size_t Lucy_RAMFolder_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Equals(const lucy_RAMFolder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMFolder_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_RAMFolder_Compare_To(const lucy_RAMFolder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMFolder_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_RAMFolder_Hash_Sum(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_RAMFolder_Get_VTable(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMFolder_Get_Class_Name(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Is_A(const lucy_RAMFolder *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_RAMFolder_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMFolder_To_String(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_RAMFolder_To_I64(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_To_F64_OFFSET;
static CHY_INLINE double
Lucy_RAMFolder_To_F64(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_To_Bool(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Serialize_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Serialize(const lucy_RAMFolder *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_RAMFolder_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFolder_Deserialize(const lucy_RAMFolder *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_RAMFolder_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFolder_Dump(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_RAMFolder_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_RAMFolder_Load(const lucy_RAMFolder *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_RAMFolder_Mimic_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Mimic(const lucy_RAMFolder *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_RAMFolder_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_RAMFolder_Get_Path(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Get_Path_OFFSET;
    const lucy_Folder_get_path_t method = *((lucy_Folder_get_path_t*)method_address);
    return method((lucy_Folder*)self);
}

extern size_t Lucy_RAMFolder_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Set_Path(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Set_Path_OFFSET;
    const lucy_Folder_set_path_t method = *((lucy_Folder_set_path_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Open_Out_OFFSET;
static CHY_INLINE lucy_OutStream*
Lucy_RAMFolder_Open_Out(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Open_Out_OFFSET;
    const lucy_Folder_open_out_t method = *((lucy_Folder_open_out_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_RAMFolder_Open_In(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Open_In_OFFSET;
    const lucy_Folder_open_in_t method = *((lucy_Folder_open_in_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_RAMFolder_Open_FileHandle(const lucy_RAMFolder *self, const lucy_CharBuf* path, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Open_FileHandle_OFFSET;
    const lucy_Folder_open_filehandle_t method = *((lucy_Folder_open_filehandle_t*)method_address);
    return method((lucy_Folder*)self, path, flags);
}

extern size_t Lucy_RAMFolder_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_RAMFolder_Open_Dir(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Open_Dir_OFFSET;
    const lucy_Folder_open_dir_t method = *((lucy_Folder_open_dir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_MkDir(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_MkDir_OFFSET;
    const lucy_Folder_mkdir_t method = *((lucy_Folder_mkdir_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_List_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_RAMFolder_List(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_List_OFFSET;
    const lucy_Folder_list_t method = *((lucy_Folder_list_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_List_R_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_RAMFolder_List_R(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_List_R_OFFSET;
    const lucy_Folder_list_r_t method = *((lucy_Folder_list_r_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Exists(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Exists_OFFSET;
    const lucy_Folder_exists_t method = *((lucy_Folder_exists_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Is_Directory(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Is_Directory_OFFSET;
    const lucy_Folder_is_directory_t method = *((lucy_Folder_is_directory_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Delete(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Delete_OFFSET;
    const lucy_Folder_delete_t method = *((lucy_Folder_delete_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Delete_Tree_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Delete_Tree(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Delete_Tree_OFFSET;
    const lucy_Folder_delete_tree_t method = *((lucy_Folder_delete_tree_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Rename_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Rename(const lucy_RAMFolder *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Rename_OFFSET;
    const lucy_RAMFolder_rename_t method = *((lucy_RAMFolder_rename_t*)method_address);
    return method((lucy_RAMFolder*)self, from, to);
}

extern size_t Lucy_RAMFolder_Hard_Link_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Hard_Link(const lucy_RAMFolder *self, const lucy_CharBuf* from, const lucy_CharBuf* to) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Hard_Link_OFFSET;
    const lucy_RAMFolder_hard_link_t method = *((lucy_RAMFolder_hard_link_t*)method_address);
    return method((lucy_RAMFolder*)self, from, to);
}

extern size_t Lucy_RAMFolder_Slurp_File_OFFSET;
static CHY_INLINE lucy_ByteBuf*
Lucy_RAMFolder_Slurp_File(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Slurp_File_OFFSET;
    const lucy_Folder_slurp_file_t method = *((lucy_Folder_slurp_file_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Consolidate_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Consolidate(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Consolidate_OFFSET;
    const lucy_Folder_consolidate_t method = *((lucy_Folder_consolidate_t*)method_address);
    method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Enclosing_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_RAMFolder_Enclosing_Folder(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Enclosing_Folder_OFFSET;
    const lucy_Folder_enclosing_folder_t method = *((lucy_Folder_enclosing_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_RAMFolder_Find_Folder(const lucy_RAMFolder *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Find_Folder_OFFSET;
    const lucy_Folder_find_folder_t method = *((lucy_Folder_find_folder_t*)method_address);
    return method((lucy_Folder*)self, path);
}

extern size_t Lucy_RAMFolder_Initialize_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Initialize(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Initialize_OFFSET;
    const lucy_RAMFolder_initialize_t method = *((lucy_RAMFolder_initialize_t*)method_address);
    method((lucy_RAMFolder*)self);
}

extern size_t Lucy_RAMFolder_Check_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Check(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Check_OFFSET;
    const lucy_RAMFolder_check_t method = *((lucy_RAMFolder_check_t*)method_address);
    return method((lucy_RAMFolder*)self);
}

extern size_t Lucy_RAMFolder_Close_OFFSET;
static CHY_INLINE void
Lucy_RAMFolder_Close(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Close_OFFSET;
    const lucy_RAMFolder_close_t method = *((lucy_RAMFolder_close_t*)method_address);
    method((lucy_RAMFolder*)self);
}

extern size_t Lucy_RAMFolder_Local_Open_FileHandle_OFFSET;
static CHY_INLINE lucy_FileHandle*
Lucy_RAMFolder_Local_Open_FileHandle(const lucy_RAMFolder *self, const lucy_CharBuf* name, uint32_t flags) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Open_FileHandle_OFFSET;
    const lucy_RAMFolder_local_open_filehandle_t method = *((lucy_RAMFolder_local_open_filehandle_t*)method_address);
    return method((lucy_RAMFolder*)self, name, flags);
}

extern size_t Lucy_RAMFolder_Local_Open_In_OFFSET;
static CHY_INLINE lucy_InStream*
Lucy_RAMFolder_Local_Open_In(const lucy_RAMFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Open_In_OFFSET;
    const lucy_Folder_local_open_in_t method = *((lucy_Folder_local_open_in_t*)method_address);
    return method((lucy_Folder*)self, name);
}

extern size_t Lucy_RAMFolder_Local_Open_Dir_OFFSET;
static CHY_INLINE lucy_DirHandle*
Lucy_RAMFolder_Local_Open_Dir(const lucy_RAMFolder *self) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Open_Dir_OFFSET;
    const lucy_RAMFolder_local_open_dir_t method = *((lucy_RAMFolder_local_open_dir_t*)method_address);
    return method((lucy_RAMFolder*)self);
}

extern size_t Lucy_RAMFolder_Local_MkDir_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Local_MkDir(const lucy_RAMFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_MkDir_OFFSET;
    const lucy_RAMFolder_local_mkdir_t method = *((lucy_RAMFolder_local_mkdir_t*)method_address);
    return method((lucy_RAMFolder*)self, name);
}

extern size_t Lucy_RAMFolder_Local_Exists_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Local_Exists(const lucy_RAMFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Exists_OFFSET;
    const lucy_RAMFolder_local_exists_t method = *((lucy_RAMFolder_local_exists_t*)method_address);
    return method((lucy_RAMFolder*)self, name);
}

extern size_t Lucy_RAMFolder_Local_Is_Directory_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Local_Is_Directory(const lucy_RAMFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Is_Directory_OFFSET;
    const lucy_RAMFolder_local_is_directory_t method = *((lucy_RAMFolder_local_is_directory_t*)method_address);
    return method((lucy_RAMFolder*)self, name);
}

extern size_t Lucy_RAMFolder_Local_Find_Folder_OFFSET;
static CHY_INLINE lucy_Folder*
Lucy_RAMFolder_Local_Find_Folder(const lucy_RAMFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Find_Folder_OFFSET;
    const lucy_RAMFolder_local_find_folder_t method = *((lucy_RAMFolder_local_find_folder_t*)method_address);
    return method((lucy_RAMFolder*)self, name);
}

extern size_t Lucy_RAMFolder_Local_Delete_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_RAMFolder_Local_Delete(const lucy_RAMFolder *self, const lucy_CharBuf* name) {
    char *const method_address = *(char**)self + Lucy_RAMFolder_Local_Delete_OFFSET;
    const lucy_RAMFolder_local_delete_t method = *((lucy_RAMFolder_local_delete_t*)method_address);
    return method((lucy_RAMFolder*)self, name);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_RAMFOLDER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[52];
} LUCY_RAMFOLDER_VT;
extern struct LUCY_RAMFOLDER_VT LUCY_RAMFOLDER_vt;
#define LUCY_RAMFOLDER ((cfish_VTable*)&LUCY_RAMFOLDER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RAMFolder lucy_RAMFolder
  #define RAMFOLDER LUCY_RAMFOLDER
  #define RAMFolder_new lucy_RAMFolder_new
  #define RAMFolder_init lucy_RAMFolder_init
  #define RAMFolder_rename_t lucy_RAMFolder_rename_t
  #define RAMFolder_rename lucy_RAMFolder_rename
  #define RAMFolder_hard_link_t lucy_RAMFolder_hard_link_t
  #define RAMFolder_hard_link lucy_RAMFolder_hard_link
  #define RAMFolder_initialize_t lucy_RAMFolder_initialize_t
  #define RAMFolder_initialize lucy_RAMFolder_initialize
  #define RAMFolder_check_t lucy_RAMFolder_check_t
  #define RAMFolder_check lucy_RAMFolder_check
  #define RAMFolder_close_t lucy_RAMFolder_close_t
  #define RAMFolder_close lucy_RAMFolder_close
  #define RAMFolder_local_open_filehandle_t lucy_RAMFolder_local_open_filehandle_t
  #define RAMFolder_local_open_filehandle lucy_RAMFolder_local_open_filehandle
  #define RAMFolder_local_open_dir_t lucy_RAMFolder_local_open_dir_t
  #define RAMFolder_local_open_dir lucy_RAMFolder_local_open_dir
  #define RAMFolder_local_mkdir_t lucy_RAMFolder_local_mkdir_t
  #define RAMFolder_local_mkdir lucy_RAMFolder_local_mkdir
  #define RAMFolder_local_exists_t lucy_RAMFolder_local_exists_t
  #define RAMFolder_local_exists lucy_RAMFolder_local_exists
  #define RAMFolder_local_is_directory_t lucy_RAMFolder_local_is_directory_t
  #define RAMFolder_local_is_directory lucy_RAMFolder_local_is_directory
  #define RAMFolder_local_find_folder_t lucy_RAMFolder_local_find_folder_t
  #define RAMFolder_local_find_folder lucy_RAMFolder_local_find_folder
  #define RAMFolder_local_delete_t lucy_RAMFolder_local_delete_t
  #define RAMFolder_local_delete lucy_RAMFolder_local_delete
  #define RAMFolder_Make Lucy_RAMFolder_Make
  #define RAMFolder_Get_RefCount Lucy_RAMFolder_Get_RefCount
  #define RAMFolder_Inc_RefCount Lucy_RAMFolder_Inc_RefCount
  #define RAMFolder_Dec_RefCount Lucy_RAMFolder_Dec_RefCount
  #define RAMFolder_To_Host Lucy_RAMFolder_To_Host
  #define RAMFolder_Clone Lucy_RAMFolder_Clone
  #define RAMFolder_Destroy Lucy_RAMFolder_Destroy
  #define RAMFolder_Equals Lucy_RAMFolder_Equals
  #define RAMFolder_Compare_To Lucy_RAMFolder_Compare_To
  #define RAMFolder_Hash_Sum Lucy_RAMFolder_Hash_Sum
  #define RAMFolder_Get_VTable Lucy_RAMFolder_Get_VTable
  #define RAMFolder_Get_Class_Name Lucy_RAMFolder_Get_Class_Name
  #define RAMFolder_Is_A Lucy_RAMFolder_Is_A
  #define RAMFolder_To_String Lucy_RAMFolder_To_String
  #define RAMFolder_To_I64 Lucy_RAMFolder_To_I64
  #define RAMFolder_To_F64 Lucy_RAMFolder_To_F64
  #define RAMFolder_To_Bool Lucy_RAMFolder_To_Bool
  #define RAMFolder_Serialize Lucy_RAMFolder_Serialize
  #define RAMFolder_Deserialize Lucy_RAMFolder_Deserialize
  #define RAMFolder_Dump Lucy_RAMFolder_Dump
  #define RAMFolder_Load Lucy_RAMFolder_Load
  #define RAMFolder_Mimic Lucy_RAMFolder_Mimic
  #define RAMFolder_Get_Path Lucy_RAMFolder_Get_Path
  #define RAMFolder_Set_Path Lucy_RAMFolder_Set_Path
  #define RAMFolder_Open_Out Lucy_RAMFolder_Open_Out
  #define RAMFolder_Open_In Lucy_RAMFolder_Open_In
  #define RAMFolder_Open_FileHandle Lucy_RAMFolder_Open_FileHandle
  #define RAMFolder_Open_Dir Lucy_RAMFolder_Open_Dir
  #define RAMFolder_MkDir Lucy_RAMFolder_MkDir
  #define RAMFolder_List Lucy_RAMFolder_List
  #define RAMFolder_List_R Lucy_RAMFolder_List_R
  #define RAMFolder_Exists Lucy_RAMFolder_Exists
  #define RAMFolder_Is_Directory Lucy_RAMFolder_Is_Directory
  #define RAMFolder_Delete Lucy_RAMFolder_Delete
  #define RAMFolder_Delete_Tree Lucy_RAMFolder_Delete_Tree
  #define RAMFolder_Rename Lucy_RAMFolder_Rename
  #define RAMFolder_Hard_Link Lucy_RAMFolder_Hard_Link
  #define RAMFolder_Slurp_File Lucy_RAMFolder_Slurp_File
  #define RAMFolder_Consolidate Lucy_RAMFolder_Consolidate
  #define RAMFolder_Enclosing_Folder Lucy_RAMFolder_Enclosing_Folder
  #define RAMFolder_Find_Folder Lucy_RAMFolder_Find_Folder
  #define RAMFolder_Initialize Lucy_RAMFolder_Initialize
  #define RAMFolder_Check Lucy_RAMFolder_Check
  #define RAMFolder_Close Lucy_RAMFolder_Close
  #define RAMFolder_Local_Open_FileHandle Lucy_RAMFolder_Local_Open_FileHandle
  #define RAMFolder_Local_Open_In Lucy_RAMFolder_Local_Open_In
  #define RAMFolder_Local_Open_Dir Lucy_RAMFolder_Local_Open_Dir
  #define RAMFolder_Local_MkDir Lucy_RAMFolder_Local_MkDir
  #define RAMFolder_Local_Exists Lucy_RAMFolder_Local_Exists
  #define RAMFolder_Local_Is_Directory Lucy_RAMFolder_Local_Is_Directory
  #define RAMFolder_Local_Find_Folder Lucy_RAMFolder_Local_Find_Folder
  #define RAMFolder_Local_Delete Lucy_RAMFolder_Local_Delete
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_RAMFOLDER */




