/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_SHAREDLOCK
#define H_LUCY_STORE_SHAREDLOCK 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/Lock.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SHAREDLOCK
struct lucy_SharedLock {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_Folder* folder;
    lucy_CharBuf* name;
    lucy_CharBuf* lock_path;
    lucy_CharBuf* host;
    int32_t timeout;
    int32_t interval;
    lucy_CharBuf* link_path;
};

#endif /* C_LUCY_SHAREDLOCK */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SharedLock*
lucy_ShLock_new(lucy_Folder* folder, const lucy_CharBuf* name, const lucy_CharBuf* host, int32_t timeout, int32_t interval);

lucy_SharedLock*
lucy_ShLock_init(lucy_SharedLock* self, lucy_Folder* folder, const lucy_CharBuf* name, const lucy_CharBuf* host, int32_t timeout, int32_t interval);

chy_bool_t
lucy_ShLock_shared(lucy_SharedLock* self);

chy_bool_t
lucy_ShLock_request(lucy_SharedLock* self);

void
lucy_ShLock_release(lucy_SharedLock* self);

chy_bool_t
lucy_ShLock_is_locked(lucy_SharedLock* self);

void
lucy_ShLock_clear_stale(lucy_SharedLock* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ShLock_shared_CALLBACK;
extern cfish_Callback lucy_ShLock_request_CALLBACK;
extern cfish_Callback lucy_ShLock_release_CALLBACK;
extern cfish_Callback lucy_ShLock_is_locked_CALLBACK;
extern cfish_Callback lucy_ShLock_clear_stale_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_ShLock_shared_t)(lucy_SharedLock* self);

typedef chy_bool_t
(*lucy_ShLock_request_t)(lucy_SharedLock* self);

typedef void
(*lucy_ShLock_release_t)(lucy_SharedLock* self);

typedef chy_bool_t
(*lucy_ShLock_is_locked_t)(lucy_SharedLock* self);

typedef void
(*lucy_ShLock_clear_stale_t)(lucy_SharedLock* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ShLock_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ShLock_Make(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ShLock_Get_RefCount(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ShLock_Inc_RefCount(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ShLock_Dec_RefCount(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ShLock_To_Host(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ShLock_Clone(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ShLock_Destroy(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Destroy_OFFSET;
    const lucy_LFLock_destroy_t method = *((lucy_LFLock_destroy_t*)method_address);
    method((lucy_LockFileLock*)self);
}

extern size_t Lucy_ShLock_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Equals(const lucy_SharedLock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ShLock_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ShLock_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ShLock_Compare_To(const lucy_SharedLock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ShLock_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ShLock_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ShLock_Hash_Sum(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ShLock_Get_VTable(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ShLock_Get_Class_Name(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Is_A(const lucy_SharedLock *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ShLock_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ShLock_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ShLock_To_String(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ShLock_To_I64(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ShLock_To_F64(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_To_Bool(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ShLock_Serialize(const lucy_SharedLock *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ShLock_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ShLock_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ShLock_Deserialize(const lucy_SharedLock *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ShLock_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ShLock_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ShLock_Dump(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ShLock_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ShLock_Load(const lucy_SharedLock *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ShLock_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ShLock_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ShLock_Mimic(const lucy_SharedLock *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ShLock_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ShLock_Shared_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Shared(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Shared_OFFSET;
    const lucy_ShLock_shared_t method = *((lucy_ShLock_shared_t*)method_address);
    return method((lucy_SharedLock*)self);
}

extern size_t Lucy_ShLock_Obtain_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Obtain(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Obtain_OFFSET;
    const lucy_Lock_obtain_t method = *((lucy_Lock_obtain_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_ShLock_Request_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Request(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Request_OFFSET;
    const lucy_ShLock_request_t method = *((lucy_ShLock_request_t*)method_address);
    return method((lucy_SharedLock*)self);
}

extern size_t Lucy_ShLock_Release_OFFSET;
static CHY_INLINE void
Lucy_ShLock_Release(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Release_OFFSET;
    const lucy_ShLock_release_t method = *((lucy_ShLock_release_t*)method_address);
    method((lucy_SharedLock*)self);
}

extern size_t Lucy_ShLock_Is_Locked_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Is_Locked(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Is_Locked_OFFSET;
    const lucy_ShLock_is_locked_t method = *((lucy_ShLock_is_locked_t*)method_address);
    return method((lucy_SharedLock*)self);
}

extern size_t Lucy_ShLock_Clear_Stale_OFFSET;
static CHY_INLINE void
Lucy_ShLock_Clear_Stale(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Clear_Stale_OFFSET;
    const lucy_ShLock_clear_stale_t method = *((lucy_ShLock_clear_stale_t*)method_address);
    method((lucy_SharedLock*)self);
}

extern size_t Lucy_ShLock_Get_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ShLock_Get_Name(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Get_Name_OFFSET;
    const lucy_Lock_get_name_t method = *((lucy_Lock_get_name_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_ShLock_Get_Host_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ShLock_Get_Host(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Get_Host_OFFSET;
    const lucy_Lock_get_host_t method = *((lucy_Lock_get_host_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_ShLock_Get_Lock_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ShLock_Get_Lock_Path(const lucy_SharedLock *self) {
    char *const method_address = *(char**)self + Lucy_ShLock_Get_Lock_Path_OFFSET;
    const lucy_Lock_get_lock_path_t method = *((lucy_Lock_get_lock_path_t*)method_address);
    return method((lucy_Lock*)self);
}

extern size_t Lucy_ShLock_Maybe_Delete_File_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ShLock_Maybe_Delete_File(const lucy_SharedLock *self, const lucy_CharBuf* filepath, chy_bool_t delete_mine, chy_bool_t delete_other) {
    char *const method_address = *(char**)self + Lucy_ShLock_Maybe_Delete_File_OFFSET;
    const lucy_LFLock_maybe_delete_file_t method = *((lucy_LFLock_maybe_delete_file_t*)method_address);
    return method((lucy_LockFileLock*)self, filepath, delete_mine, delete_other);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SHAREDLOCK_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[32];
} LUCY_SHAREDLOCK_VT;
extern struct LUCY_SHAREDLOCK_VT LUCY_SHAREDLOCK_vt;
#define LUCY_SHAREDLOCK ((cfish_VTable*)&LUCY_SHAREDLOCK_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SharedLock lucy_SharedLock
  #define SHAREDLOCK LUCY_SHAREDLOCK
  #define ShLock_new lucy_ShLock_new
  #define ShLock_init lucy_ShLock_init
  #define ShLock_shared_t lucy_ShLock_shared_t
  #define ShLock_shared lucy_ShLock_shared
  #define ShLock_request_t lucy_ShLock_request_t
  #define ShLock_request lucy_ShLock_request
  #define ShLock_release_t lucy_ShLock_release_t
  #define ShLock_release lucy_ShLock_release
  #define ShLock_is_locked_t lucy_ShLock_is_locked_t
  #define ShLock_is_locked lucy_ShLock_is_locked
  #define ShLock_clear_stale_t lucy_ShLock_clear_stale_t
  #define ShLock_clear_stale lucy_ShLock_clear_stale
  #define ShLock_Make Lucy_ShLock_Make
  #define ShLock_Get_RefCount Lucy_ShLock_Get_RefCount
  #define ShLock_Inc_RefCount Lucy_ShLock_Inc_RefCount
  #define ShLock_Dec_RefCount Lucy_ShLock_Dec_RefCount
  #define ShLock_To_Host Lucy_ShLock_To_Host
  #define ShLock_Clone Lucy_ShLock_Clone
  #define ShLock_Destroy Lucy_ShLock_Destroy
  #define ShLock_Equals Lucy_ShLock_Equals
  #define ShLock_Compare_To Lucy_ShLock_Compare_To
  #define ShLock_Hash_Sum Lucy_ShLock_Hash_Sum
  #define ShLock_Get_VTable Lucy_ShLock_Get_VTable
  #define ShLock_Get_Class_Name Lucy_ShLock_Get_Class_Name
  #define ShLock_Is_A Lucy_ShLock_Is_A
  #define ShLock_To_String Lucy_ShLock_To_String
  #define ShLock_To_I64 Lucy_ShLock_To_I64
  #define ShLock_To_F64 Lucy_ShLock_To_F64
  #define ShLock_To_Bool Lucy_ShLock_To_Bool
  #define ShLock_Serialize Lucy_ShLock_Serialize
  #define ShLock_Deserialize Lucy_ShLock_Deserialize
  #define ShLock_Dump Lucy_ShLock_Dump
  #define ShLock_Load Lucy_ShLock_Load
  #define ShLock_Mimic Lucy_ShLock_Mimic
  #define ShLock_Shared Lucy_ShLock_Shared
  #define ShLock_Obtain Lucy_ShLock_Obtain
  #define ShLock_Request Lucy_ShLock_Request
  #define ShLock_Release Lucy_ShLock_Release
  #define ShLock_Is_Locked Lucy_ShLock_Is_Locked
  #define ShLock_Clear_Stale Lucy_ShLock_Clear_Stale
  #define ShLock_Get_Name Lucy_ShLock_Get_Name
  #define ShLock_Get_Host Lucy_ShLock_Get_Host
  #define ShLock_Get_Lock_Path Lucy_ShLock_Get_Lock_Path
  #define ShLock_Maybe_Delete_File Lucy_ShLock_Maybe_Delete_File
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_SHAREDLOCK */




