/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_TEST_STORE_MOCKFILEHANDLE
#define H_LUCY_TEST_STORE_MOCKFILEHANDLE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Store/FileHandle.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_MOCKFILEHANDLE
struct lucy_MockFileHandle {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    lucy_CharBuf* path;
    uint32_t flags;
    int64_t len;
};

#endif /* C_LUCY_MOCKFILEHANDLE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_MockFileHandle*
lucy_MockFileHandle_new(const lucy_CharBuf* path, int64_t length);

lucy_MockFileHandle*
lucy_MockFileHandle_init(lucy_MockFileHandle* self, const lucy_CharBuf* path, int64_t length);

chy_bool_t
lucy_MockFileHandle_window(lucy_MockFileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

chy_bool_t
lucy_MockFileHandle_release_window(lucy_MockFileHandle* self, lucy_FileWindow* window);

int64_t
lucy_MockFileHandle_length(lucy_MockFileHandle* self);

chy_bool_t
lucy_MockFileHandle_close(lucy_MockFileHandle* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_MockFileHandle_window_t)(lucy_MockFileHandle* self, lucy_FileWindow* window, int64_t offset, int64_t len);

typedef chy_bool_t
(*lucy_MockFileHandle_release_window_t)(lucy_MockFileHandle* self, lucy_FileWindow* window);

typedef int64_t
(*lucy_MockFileHandle_length_t)(lucy_MockFileHandle* self);

typedef chy_bool_t
(*lucy_MockFileHandle_close_t)(lucy_MockFileHandle* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_MockFileHandle_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MockFileHandle_Make(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MockFileHandle_Get_RefCount(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MockFileHandle_Inc_RefCount(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MockFileHandle_Dec_RefCount(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_MockFileHandle_To_Host(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MockFileHandle_Clone(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Destroy_OFFSET;
static CHY_INLINE void
Lucy_MockFileHandle_Destroy(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Destroy_OFFSET;
    const lucy_FH_destroy_t method = *((lucy_FH_destroy_t*)method_address);
    method((lucy_FileHandle*)self);
}

extern size_t Lucy_MockFileHandle_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Equals(const lucy_MockFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MockFileHandle_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_MockFileHandle_Compare_To(const lucy_MockFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MockFileHandle_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_MockFileHandle_Hash_Sum(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_MockFileHandle_Get_VTable(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MockFileHandle_Get_Class_Name(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Is_A(const lucy_MockFileHandle *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_MockFileHandle_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MockFileHandle_To_String(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_MockFileHandle_To_I64(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_To_F64_OFFSET;
static CHY_INLINE double
Lucy_MockFileHandle_To_F64(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_To_Bool(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Serialize_OFFSET;
static CHY_INLINE void
Lucy_MockFileHandle_Serialize(const lucy_MockFileHandle *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_MockFileHandle_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MockFileHandle_Deserialize(const lucy_MockFileHandle *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_MockFileHandle_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MockFileHandle_Dump(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MockFileHandle_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MockFileHandle_Load(const lucy_MockFileHandle *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_MockFileHandle_Mimic_OFFSET;
static CHY_INLINE void
Lucy_MockFileHandle_Mimic(const lucy_MockFileHandle *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_MockFileHandle_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Window(const lucy_MockFileHandle *self, lucy_FileWindow* window, int64_t offset, int64_t len) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Window_OFFSET;
    const lucy_MockFileHandle_window_t method = *((lucy_MockFileHandle_window_t*)method_address);
    return method((lucy_MockFileHandle*)self, window, offset, len);
}

extern size_t Lucy_MockFileHandle_Release_Window_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Release_Window(const lucy_MockFileHandle *self, lucy_FileWindow* window) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Release_Window_OFFSET;
    const lucy_MockFileHandle_release_window_t method = *((lucy_MockFileHandle_release_window_t*)method_address);
    return method((lucy_MockFileHandle*)self, window);
}

extern size_t Lucy_MockFileHandle_Read_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Read(const lucy_MockFileHandle *self, char* dest, int64_t offset, size_t len) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Read_OFFSET;
    const lucy_FH_read_t method = *((lucy_FH_read_t*)method_address);
    return method((lucy_FileHandle*)self, dest, offset, len);
}

extern size_t Lucy_MockFileHandle_Write_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Write(const lucy_MockFileHandle *self, const void* data, size_t len) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Write_OFFSET;
    const lucy_FH_write_t method = *((lucy_FH_write_t*)method_address);
    return method((lucy_FileHandle*)self, data, len);
}

extern size_t Lucy_MockFileHandle_Length_OFFSET;
static CHY_INLINE int64_t
Lucy_MockFileHandle_Length(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Length_OFFSET;
    const lucy_MockFileHandle_length_t method = *((lucy_MockFileHandle_length_t*)method_address);
    return method((lucy_MockFileHandle*)self);
}

extern size_t Lucy_MockFileHandle_Grow_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Grow(const lucy_MockFileHandle *self, int64_t len) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Grow_OFFSET;
    const lucy_FH_grow_t method = *((lucy_FH_grow_t*)method_address);
    return method((lucy_FileHandle*)self, len);
}

extern size_t Lucy_MockFileHandle_Close_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MockFileHandle_Close(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Close_OFFSET;
    const lucy_MockFileHandle_close_t method = *((lucy_MockFileHandle_close_t*)method_address);
    return method((lucy_MockFileHandle*)self);
}

extern size_t Lucy_MockFileHandle_Set_Path_OFFSET;
static CHY_INLINE void
Lucy_MockFileHandle_Set_Path(const lucy_MockFileHandle *self, const lucy_CharBuf* path) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Set_Path_OFFSET;
    const lucy_FH_set_path_t method = *((lucy_FH_set_path_t*)method_address);
    method((lucy_FileHandle*)self, path);
}

extern size_t Lucy_MockFileHandle_Get_Path_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MockFileHandle_Get_Path(const lucy_MockFileHandle *self) {
    char *const method_address = *(char**)self + Lucy_MockFileHandle_Get_Path_OFFSET;
    const lucy_FH_get_path_t method = *((lucy_FH_get_path_t*)method_address);
    return method((lucy_FileHandle*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_MOCKFILEHANDLE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[31];
} LUCY_MOCKFILEHANDLE_VT;
extern struct LUCY_MOCKFILEHANDLE_VT LUCY_MOCKFILEHANDLE_vt;
#define LUCY_MOCKFILEHANDLE ((cfish_VTable*)&LUCY_MOCKFILEHANDLE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define MockFileHandle lucy_MockFileHandle
  #define MOCKFILEHANDLE LUCY_MOCKFILEHANDLE
  #define MockFileHandle_new lucy_MockFileHandle_new
  #define MockFileHandle_init lucy_MockFileHandle_init
  #define MockFileHandle_window_t lucy_MockFileHandle_window_t
  #define MockFileHandle_window lucy_MockFileHandle_window
  #define MockFileHandle_release_window_t lucy_MockFileHandle_release_window_t
  #define MockFileHandle_release_window lucy_MockFileHandle_release_window
  #define MockFileHandle_length_t lucy_MockFileHandle_length_t
  #define MockFileHandle_length lucy_MockFileHandle_length
  #define MockFileHandle_close_t lucy_MockFileHandle_close_t
  #define MockFileHandle_close lucy_MockFileHandle_close
  #define MockFileHandle_Make Lucy_MockFileHandle_Make
  #define MockFileHandle_Get_RefCount Lucy_MockFileHandle_Get_RefCount
  #define MockFileHandle_Inc_RefCount Lucy_MockFileHandle_Inc_RefCount
  #define MockFileHandle_Dec_RefCount Lucy_MockFileHandle_Dec_RefCount
  #define MockFileHandle_To_Host Lucy_MockFileHandle_To_Host
  #define MockFileHandle_Clone Lucy_MockFileHandle_Clone
  #define MockFileHandle_Destroy Lucy_MockFileHandle_Destroy
  #define MockFileHandle_Equals Lucy_MockFileHandle_Equals
  #define MockFileHandle_Compare_To Lucy_MockFileHandle_Compare_To
  #define MockFileHandle_Hash_Sum Lucy_MockFileHandle_Hash_Sum
  #define MockFileHandle_Get_VTable Lucy_MockFileHandle_Get_VTable
  #define MockFileHandle_Get_Class_Name Lucy_MockFileHandle_Get_Class_Name
  #define MockFileHandle_Is_A Lucy_MockFileHandle_Is_A
  #define MockFileHandle_To_String Lucy_MockFileHandle_To_String
  #define MockFileHandle_To_I64 Lucy_MockFileHandle_To_I64
  #define MockFileHandle_To_F64 Lucy_MockFileHandle_To_F64
  #define MockFileHandle_To_Bool Lucy_MockFileHandle_To_Bool
  #define MockFileHandle_Serialize Lucy_MockFileHandle_Serialize
  #define MockFileHandle_Deserialize Lucy_MockFileHandle_Deserialize
  #define MockFileHandle_Dump Lucy_MockFileHandle_Dump
  #define MockFileHandle_Load Lucy_MockFileHandle_Load
  #define MockFileHandle_Mimic Lucy_MockFileHandle_Mimic
  #define MockFileHandle_Window Lucy_MockFileHandle_Window
  #define MockFileHandle_Release_Window Lucy_MockFileHandle_Release_Window
  #define MockFileHandle_Read Lucy_MockFileHandle_Read
  #define MockFileHandle_Write Lucy_MockFileHandle_Write
  #define MockFileHandle_Length Lucy_MockFileHandle_Length
  #define MockFileHandle_Grow Lucy_MockFileHandle_Grow
  #define MockFileHandle_Close Lucy_MockFileHandle_Close
  #define MockFileHandle_Set_Path Lucy_MockFileHandle_Set_Path
  #define MockFileHandle_Get_Path Lucy_MockFileHandle_Get_Path
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_TEST_STORE_MOCKFILEHANDLE */




