/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_TEST_UTIL_BBSORTEX
#define H_LUCY_TEST_UTIL_BBSORTEX 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/SortExternal.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_BBSORTEX
struct lucy_BBSortEx {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint8_t* cache;
    uint32_t cache_cap;
    uint32_t cache_max;
    uint32_t cache_tick;
    uint8_t* scratch;
    uint32_t scratch_cap;
    lucy_VArray* runs;
    uint32_t num_slices;
    uint8_t** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    size_t width;
    chy_bool_t flipped;
    lucy_VArray* external;
    uint32_t external_tick;
    uint32_t mem_consumed;
};

#endif /* C_LUCY_BBSORTEX */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_BBSortEx*
lucy_BBSortEx_new(uint32_t mem_thresh, lucy_VArray* external);

lucy_BBSortEx*
lucy_BBSortEx_init(lucy_BBSortEx* self, uint32_t mem_thresh, lucy_VArray* external);

void
lucy_BBSortEx_destroy(lucy_BBSortEx* self);

int
lucy_BBSortEx_compare(lucy_BBSortEx* self, void* va, void* vb);

void
lucy_BBSortEx_flush(lucy_BBSortEx* self);

void
lucy_BBSortEx_feed(lucy_BBSortEx* self, void* data);

void
lucy_BBSortEx_flip(lucy_BBSortEx* self);

uint32_t
lucy_BBSortEx_refill(lucy_BBSortEx* self);

void
lucy_BBSortEx_clear_cache(lucy_BBSortEx* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_BBSortEx_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_BBSortEx_destroy_t)(lucy_BBSortEx* self);

typedef int
(*lucy_BBSortEx_compare_t)(lucy_BBSortEx* self, void* va, void* vb);

typedef void
(*lucy_BBSortEx_flush_t)(lucy_BBSortEx* self);

typedef void
(*lucy_BBSortEx_feed_t)(lucy_BBSortEx* self, void* data);

typedef void
(*lucy_BBSortEx_flip_t)(lucy_BBSortEx* self);

typedef uint32_t
(*lucy_BBSortEx_refill_t)(lucy_BBSortEx* self);

typedef void
(*lucy_BBSortEx_clear_cache_t)(lucy_BBSortEx* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_BBSortEx_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BBSortEx_Make(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BBSortEx_Get_RefCount(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BBSortEx_Inc_RefCount(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_BBSortEx_Dec_RefCount(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_BBSortEx_To_Host(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BBSortEx_Clone(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Destroy_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Destroy(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Destroy_OFFSET;
    const lucy_BBSortEx_destroy_t method = *((lucy_BBSortEx_destroy_t*)method_address);
    method((lucy_BBSortEx*)self);
}

extern size_t Lucy_BBSortEx_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BBSortEx_Equals(const lucy_BBSortEx *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_BBSortEx_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_BBSortEx_Compare_To(const lucy_BBSortEx *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_BBSortEx_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_BBSortEx_Hash_Sum(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_BBSortEx_Get_VTable(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BBSortEx_Get_Class_Name(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BBSortEx_Is_A(const lucy_BBSortEx *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_BBSortEx_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_BBSortEx_To_String(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_BBSortEx_To_I64(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_To_F64_OFFSET;
static CHY_INLINE double
Lucy_BBSortEx_To_F64(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_BBSortEx_To_Bool(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Serialize_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Serialize(const lucy_BBSortEx *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_BBSortEx_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BBSortEx_Deserialize(const lucy_BBSortEx *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_BBSortEx_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BBSortEx_Dump(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_BBSortEx_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_BBSortEx_Load(const lucy_BBSortEx *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_BBSortEx_Mimic_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Mimic(const lucy_BBSortEx *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_BBSortEx_Compare_OFFSET;
static CHY_INLINE int
Lucy_BBSortEx_Compare(const lucy_BBSortEx *self, void* va, void* vb) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Compare_OFFSET;
    const lucy_BBSortEx_compare_t method = *((lucy_BBSortEx_compare_t*)method_address);
    return method((lucy_BBSortEx*)self, va, vb);
}

extern size_t Lucy_BBSortEx_Flush_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Flush(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Flush_OFFSET;
    const lucy_BBSortEx_flush_t method = *((lucy_BBSortEx_flush_t*)method_address);
    method((lucy_BBSortEx*)self);
}

extern size_t Lucy_BBSortEx_Feed_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Feed(const lucy_BBSortEx *self, void* data) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Feed_OFFSET;
    const lucy_BBSortEx_feed_t method = *((lucy_BBSortEx_feed_t*)method_address);
    method((lucy_BBSortEx*)self, data);
}

extern size_t Lucy_BBSortEx_Flip_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Flip(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Flip_OFFSET;
    const lucy_BBSortEx_flip_t method = *((lucy_BBSortEx_flip_t*)method_address);
    method((lucy_BBSortEx*)self);
}

extern size_t Lucy_BBSortEx_Fetch_OFFSET;
static CHY_INLINE void*
Lucy_BBSortEx_Fetch(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Fetch_OFFSET;
    const lucy_SortEx_fetch_t method = *((lucy_SortEx_fetch_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_BBSortEx_Peek_OFFSET;
static CHY_INLINE void*
Lucy_BBSortEx_Peek(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Peek_OFFSET;
    const lucy_SortEx_peek_t method = *((lucy_SortEx_peek_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_BBSortEx_Add_Run_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Add_Run(const lucy_BBSortEx *self, lucy_SortExternal* run) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Add_Run_OFFSET;
    const lucy_SortEx_add_run_t method = *((lucy_SortEx_add_run_t*)method_address);
    method((lucy_SortExternal*)self, run);
}

extern size_t Lucy_BBSortEx_Refill_OFFSET;
static CHY_INLINE uint32_t
Lucy_BBSortEx_Refill(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Refill_OFFSET;
    const lucy_BBSortEx_refill_t method = *((lucy_BBSortEx_refill_t*)method_address);
    return method((lucy_BBSortEx*)self);
}

extern size_t Lucy_BBSortEx_Sort_Cache_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Sort_Cache(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Sort_Cache_OFFSET;
    const lucy_SortEx_sort_cache_t method = *((lucy_SortEx_sort_cache_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_BBSortEx_Clear_Cache_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Clear_Cache(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Clear_Cache_OFFSET;
    const lucy_BBSortEx_clear_cache_t method = *((lucy_BBSortEx_clear_cache_t*)method_address);
    method((lucy_BBSortEx*)self);
}

extern size_t Lucy_BBSortEx_Cache_Count_OFFSET;
static CHY_INLINE uint32_t
Lucy_BBSortEx_Cache_Count(const lucy_BBSortEx *self) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Cache_Count_OFFSET;
    const lucy_SortEx_cache_count_t method = *((lucy_SortEx_cache_count_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_BBSortEx_Grow_Cache_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Grow_Cache(const lucy_BBSortEx *self, uint32_t new_cache_cap) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Grow_Cache_OFFSET;
    const lucy_SortEx_grow_cache_t method = *((lucy_SortEx_grow_cache_t*)method_address);
    method((lucy_SortExternal*)self, new_cache_cap);
}

extern size_t Lucy_BBSortEx_Set_Mem_Thresh_OFFSET;
static CHY_INLINE void
Lucy_BBSortEx_Set_Mem_Thresh(const lucy_BBSortEx *self, uint32_t mem_thresh) {
    char *const method_address = *(char**)self + Lucy_BBSortEx_Set_Mem_Thresh_OFFSET;
    const lucy_SortEx_set_mem_thresh_t method = *((lucy_SortEx_set_mem_thresh_t*)method_address);
    method((lucy_SortExternal*)self, mem_thresh);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_BBSORTEX_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_BBSORTEX_VT;
extern struct LUCY_BBSORTEX_VT LUCY_BBSORTEX_vt;
#define LUCY_BBSORTEX ((cfish_VTable*)&LUCY_BBSORTEX_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define BBSortEx lucy_BBSortEx
  #define BBSORTEX LUCY_BBSORTEX
  #define BBSortEx_new lucy_BBSortEx_new
  #define BBSortEx_init lucy_BBSortEx_init
  #define BBSortEx_destroy_t lucy_BBSortEx_destroy_t
  #define BBSortEx_destroy lucy_BBSortEx_destroy
  #define BBSortEx_compare_t lucy_BBSortEx_compare_t
  #define BBSortEx_compare lucy_BBSortEx_compare
  #define BBSortEx_flush_t lucy_BBSortEx_flush_t
  #define BBSortEx_flush lucy_BBSortEx_flush
  #define BBSortEx_feed_t lucy_BBSortEx_feed_t
  #define BBSortEx_feed lucy_BBSortEx_feed
  #define BBSortEx_flip_t lucy_BBSortEx_flip_t
  #define BBSortEx_flip lucy_BBSortEx_flip
  #define BBSortEx_refill_t lucy_BBSortEx_refill_t
  #define BBSortEx_refill lucy_BBSortEx_refill
  #define BBSortEx_clear_cache_t lucy_BBSortEx_clear_cache_t
  #define BBSortEx_clear_cache lucy_BBSortEx_clear_cache
  #define BBSortEx_Make Lucy_BBSortEx_Make
  #define BBSortEx_Get_RefCount Lucy_BBSortEx_Get_RefCount
  #define BBSortEx_Inc_RefCount Lucy_BBSortEx_Inc_RefCount
  #define BBSortEx_Dec_RefCount Lucy_BBSortEx_Dec_RefCount
  #define BBSortEx_To_Host Lucy_BBSortEx_To_Host
  #define BBSortEx_Clone Lucy_BBSortEx_Clone
  #define BBSortEx_Destroy Lucy_BBSortEx_Destroy
  #define BBSortEx_Equals Lucy_BBSortEx_Equals
  #define BBSortEx_Compare_To Lucy_BBSortEx_Compare_To
  #define BBSortEx_Hash_Sum Lucy_BBSortEx_Hash_Sum
  #define BBSortEx_Get_VTable Lucy_BBSortEx_Get_VTable
  #define BBSortEx_Get_Class_Name Lucy_BBSortEx_Get_Class_Name
  #define BBSortEx_Is_A Lucy_BBSortEx_Is_A
  #define BBSortEx_To_String Lucy_BBSortEx_To_String
  #define BBSortEx_To_I64 Lucy_BBSortEx_To_I64
  #define BBSortEx_To_F64 Lucy_BBSortEx_To_F64
  #define BBSortEx_To_Bool Lucy_BBSortEx_To_Bool
  #define BBSortEx_Serialize Lucy_BBSortEx_Serialize
  #define BBSortEx_Deserialize Lucy_BBSortEx_Deserialize
  #define BBSortEx_Dump Lucy_BBSortEx_Dump
  #define BBSortEx_Load Lucy_BBSortEx_Load
  #define BBSortEx_Mimic Lucy_BBSortEx_Mimic
  #define BBSortEx_Compare Lucy_BBSortEx_Compare
  #define BBSortEx_Flush Lucy_BBSortEx_Flush
  #define BBSortEx_Feed Lucy_BBSortEx_Feed
  #define BBSortEx_Flip Lucy_BBSortEx_Flip
  #define BBSortEx_Fetch Lucy_BBSortEx_Fetch
  #define BBSortEx_Peek Lucy_BBSortEx_Peek
  #define BBSortEx_Add_Run Lucy_BBSortEx_Add_Run
  #define BBSortEx_Refill Lucy_BBSortEx_Refill
  #define BBSortEx_Sort_Cache Lucy_BBSortEx_Sort_Cache
  #define BBSortEx_Clear_Cache Lucy_BBSortEx_Clear_Cache
  #define BBSortEx_Cache_Count Lucy_BBSortEx_Cache_Count
  #define BBSortEx_Grow_Cache Lucy_BBSortEx_Grow_Cache
  #define BBSortEx_Set_Mem_Thresh Lucy_BBSortEx_Set_Mem_Thresh
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_TEST_UTIL_BBSORTEX */




