/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_TEST_UTIL_TESTPRIORITYQUEUE
#define H_LUCY_TEST_UTIL_TESTPRIORITYQUEUE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/PriorityQueue.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_NUMPRIORITYQUEUE
struct lucy_NumPriorityQueue {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t size;
    uint32_t max_size;
    lucy_Obj** heap;
};

#endif /* C_LUCY_NUMPRIORITYQUEUE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_NumPriorityQueue*
lucy_NumPriQ_new(uint32_t max_size);

chy_bool_t
lucy_NumPriQ_less_than(lucy_NumPriorityQueue* self, lucy_Obj* a, lucy_Obj* b);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_NumPriQ_less_than_t)(lucy_NumPriorityQueue* self, lucy_Obj* a, lucy_Obj* b);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_NumPriQ_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Make(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NumPriQ_Get_RefCount(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Inc_RefCount(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_NumPriQ_Dec_RefCount(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_NumPriQ_To_Host(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Clone(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Destroy_OFFSET;
static CHY_INLINE void
Lucy_NumPriQ_Destroy(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Destroy_OFFSET;
    const lucy_PriQ_destroy_t method = *((lucy_PriQ_destroy_t*)method_address);
    method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_NumPriQ_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumPriQ_Equals(const lucy_NumPriorityQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NumPriQ_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_NumPriQ_Compare_To(const lucy_NumPriorityQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_NumPriQ_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_NumPriQ_Hash_Sum(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_NumPriQ_Get_VTable(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NumPriQ_Get_Class_Name(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumPriQ_Is_A(const lucy_NumPriorityQueue *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_NumPriQ_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_NumPriQ_To_String(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_NumPriQ_To_I64(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_To_F64_OFFSET;
static CHY_INLINE double
Lucy_NumPriQ_To_F64(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumPriQ_To_Bool(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Serialize_OFFSET;
static CHY_INLINE void
Lucy_NumPriQ_Serialize(const lucy_NumPriorityQueue *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_NumPriQ_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Deserialize(const lucy_NumPriorityQueue *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_NumPriQ_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Dump(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_NumPriQ_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Load(const lucy_NumPriorityQueue *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_NumPriQ_Mimic_OFFSET;
static CHY_INLINE void
Lucy_NumPriQ_Mimic(const lucy_NumPriorityQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_NumPriQ_Less_Than_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumPriQ_Less_Than(const lucy_NumPriorityQueue *self, lucy_Obj* a, lucy_Obj* b) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Less_Than_OFFSET;
    const lucy_NumPriQ_less_than_t method = *((lucy_NumPriQ_less_than_t*)method_address);
    return method((lucy_NumPriorityQueue*)self, a, b);
}

extern size_t Lucy_NumPriQ_Insert_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_NumPriQ_Insert(const lucy_NumPriorityQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Insert_OFFSET;
    const lucy_PriQ_insert_t method = *((lucy_PriQ_insert_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_NumPriQ_Jostle_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Jostle(const lucy_NumPriorityQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Jostle_OFFSET;
    const lucy_PriQ_jostle_t method = *((lucy_PriQ_jostle_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_NumPriQ_Pop_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Pop(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Pop_OFFSET;
    const lucy_PriQ_pop_t method = *((lucy_PriQ_pop_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_NumPriQ_Pop_All_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_NumPriQ_Pop_All(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Pop_All_OFFSET;
    const lucy_PriQ_pop_all_t method = *((lucy_PriQ_pop_all_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_NumPriQ_Peek_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_NumPriQ_Peek(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Peek_OFFSET;
    const lucy_PriQ_peek_t method = *((lucy_PriQ_peek_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_NumPriQ_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_NumPriQ_Get_Size(const lucy_NumPriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_NumPriQ_Get_Size_OFFSET;
    const lucy_PriQ_get_size_t method = *((lucy_PriQ_get_size_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_NUMPRIORITYQUEUE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_NUMPRIORITYQUEUE_VT;
extern struct LUCY_NUMPRIORITYQUEUE_VT LUCY_NUMPRIORITYQUEUE_vt;
#define LUCY_NUMPRIORITYQUEUE ((cfish_VTable*)&LUCY_NUMPRIORITYQUEUE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define NumPriorityQueue lucy_NumPriorityQueue
  #define NUMPRIORITYQUEUE LUCY_NUMPRIORITYQUEUE
  #define NumPriQ_new lucy_NumPriQ_new
  #define NumPriQ_less_than_t lucy_NumPriQ_less_than_t
  #define NumPriQ_less_than lucy_NumPriQ_less_than
  #define NumPriQ_Make Lucy_NumPriQ_Make
  #define NumPriQ_Get_RefCount Lucy_NumPriQ_Get_RefCount
  #define NumPriQ_Inc_RefCount Lucy_NumPriQ_Inc_RefCount
  #define NumPriQ_Dec_RefCount Lucy_NumPriQ_Dec_RefCount
  #define NumPriQ_To_Host Lucy_NumPriQ_To_Host
  #define NumPriQ_Clone Lucy_NumPriQ_Clone
  #define NumPriQ_Destroy Lucy_NumPriQ_Destroy
  #define NumPriQ_Equals Lucy_NumPriQ_Equals
  #define NumPriQ_Compare_To Lucy_NumPriQ_Compare_To
  #define NumPriQ_Hash_Sum Lucy_NumPriQ_Hash_Sum
  #define NumPriQ_Get_VTable Lucy_NumPriQ_Get_VTable
  #define NumPriQ_Get_Class_Name Lucy_NumPriQ_Get_Class_Name
  #define NumPriQ_Is_A Lucy_NumPriQ_Is_A
  #define NumPriQ_To_String Lucy_NumPriQ_To_String
  #define NumPriQ_To_I64 Lucy_NumPriQ_To_I64
  #define NumPriQ_To_F64 Lucy_NumPriQ_To_F64
  #define NumPriQ_To_Bool Lucy_NumPriQ_To_Bool
  #define NumPriQ_Serialize Lucy_NumPriQ_Serialize
  #define NumPriQ_Deserialize Lucy_NumPriQ_Deserialize
  #define NumPriQ_Dump Lucy_NumPriQ_Dump
  #define NumPriQ_Load Lucy_NumPriQ_Load
  #define NumPriQ_Mimic Lucy_NumPriQ_Mimic
  #define NumPriQ_Less_Than Lucy_NumPriQ_Less_Than
  #define NumPriQ_Insert Lucy_NumPriQ_Insert
  #define NumPriQ_Jostle Lucy_NumPriQ_Jostle
  #define NumPriQ_Pop Lucy_NumPriQ_Pop
  #define NumPriQ_Pop_All Lucy_NumPriQ_Pop_All
  #define NumPriQ_Peek Lucy_NumPriQ_Peek
  #define NumPriQ_Get_Size Lucy_NumPriQ_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Declare this class's inert variables.
 */



/* Declare this class's inert functions.
 */

void
lucy_TestPriQ_run_tests();



/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define TestPriQ_run_tests lucy_TestPriQ_run_tests
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_TEST_UTIL_TESTPRIORITYQUEUE */




