/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_UTIL_MEMORYPOOL
#define H_LUCY_UTIL_MEMORYPOOL 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_MEMORYPOOL
struct lucy_MemoryPool {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t arena_size;
    lucy_VArray* arenas;
    int32_t tick;
    char* buf;
    char* last_buf;
    char* limit;
    size_t consumed;
};

#endif /* C_LUCY_MEMORYPOOL */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_MemoryPool*
lucy_MemPool_new(uint32_t arena_size);

lucy_MemoryPool*
lucy_MemPool_init(lucy_MemoryPool* self, uint32_t arena_size);

void
lucy_MemPool_destroy(lucy_MemoryPool* self);

void*
lucy_MemPool_grab(lucy_MemoryPool* self, size_t amount);

void
lucy_MemPool_resize(lucy_MemoryPool* self, void* ptr, size_t revised_amount);

void
lucy_MemPool_release_all(lucy_MemoryPool* self);

void
lucy_MemPool_eat(lucy_MemoryPool* self, lucy_MemoryPool* other);

size_t
lucy_MemPool_get_consumed(lucy_MemoryPool* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_MemPool_destroy_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_MemPool_destroy_t)(lucy_MemoryPool* self);

typedef void*
(*lucy_MemPool_grab_t)(lucy_MemoryPool* self, size_t amount);

typedef void
(*lucy_MemPool_resize_t)(lucy_MemoryPool* self, void* ptr, size_t revised_amount);

typedef void
(*lucy_MemPool_release_all_t)(lucy_MemoryPool* self);

typedef void
(*lucy_MemPool_eat_t)(lucy_MemoryPool* self, lucy_MemoryPool* other);

typedef size_t
(*lucy_MemPool_get_consumed_t)(lucy_MemoryPool* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_MemPool_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MemPool_Make(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MemPool_Get_RefCount(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MemPool_Inc_RefCount(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_MemPool_Dec_RefCount(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_MemPool_To_Host(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MemPool_Clone(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Destroy_OFFSET;
static CHY_INLINE void
Lucy_MemPool_Destroy(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Destroy_OFFSET;
    const lucy_MemPool_destroy_t method = *((lucy_MemPool_destroy_t*)method_address);
    method((lucy_MemoryPool*)self);
}

extern size_t Lucy_MemPool_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MemPool_Equals(const lucy_MemoryPool *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MemPool_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MemPool_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_MemPool_Compare_To(const lucy_MemoryPool *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MemPool_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_MemPool_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_MemPool_Hash_Sum(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_MemPool_Get_VTable(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MemPool_Get_Class_Name(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MemPool_Is_A(const lucy_MemoryPool *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_MemPool_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_MemPool_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_MemPool_To_String(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_MemPool_To_I64(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_To_F64_OFFSET;
static CHY_INLINE double
Lucy_MemPool_To_F64(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_MemPool_To_Bool(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Serialize_OFFSET;
static CHY_INLINE void
Lucy_MemPool_Serialize(const lucy_MemoryPool *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_MemPool_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_MemPool_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MemPool_Deserialize(const lucy_MemoryPool *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_MemPool_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_MemPool_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MemPool_Dump(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_MemPool_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_MemPool_Load(const lucy_MemoryPool *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_MemPool_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_MemPool_Mimic_OFFSET;
static CHY_INLINE void
Lucy_MemPool_Mimic(const lucy_MemoryPool *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_MemPool_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_MemPool_Grab_OFFSET;
static CHY_INLINE void*
Lucy_MemPool_Grab(const lucy_MemoryPool *self, size_t amount) {
    char *const method_address = *(char**)self + Lucy_MemPool_Grab_OFFSET;
    const lucy_MemPool_grab_t method = *((lucy_MemPool_grab_t*)method_address);
    return method((lucy_MemoryPool*)self, amount);
}

extern size_t Lucy_MemPool_Resize_OFFSET;
static CHY_INLINE void
Lucy_MemPool_Resize(const lucy_MemoryPool *self, void* ptr, size_t revised_amount) {
    char *const method_address = *(char**)self + Lucy_MemPool_Resize_OFFSET;
    const lucy_MemPool_resize_t method = *((lucy_MemPool_resize_t*)method_address);
    method((lucy_MemoryPool*)self, ptr, revised_amount);
}

extern size_t Lucy_MemPool_Release_All_OFFSET;
static CHY_INLINE void
Lucy_MemPool_Release_All(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Release_All_OFFSET;
    const lucy_MemPool_release_all_t method = *((lucy_MemPool_release_all_t*)method_address);
    method((lucy_MemoryPool*)self);
}

extern size_t Lucy_MemPool_Eat_OFFSET;
static CHY_INLINE void
Lucy_MemPool_Eat(const lucy_MemoryPool *self, lucy_MemoryPool* other) {
    char *const method_address = *(char**)self + Lucy_MemPool_Eat_OFFSET;
    const lucy_MemPool_eat_t method = *((lucy_MemPool_eat_t*)method_address);
    method((lucy_MemoryPool*)self, other);
}

extern size_t Lucy_MemPool_Get_Consumed_OFFSET;
static CHY_INLINE size_t
Lucy_MemPool_Get_Consumed(const lucy_MemoryPool *self) {
    char *const method_address = *(char**)self + Lucy_MemPool_Get_Consumed_OFFSET;
    const lucy_MemPool_get_consumed_t method = *((lucy_MemPool_get_consumed_t*)method_address);
    return method((lucy_MemoryPool*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_MEMORYPOOL_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[27];
} LUCY_MEMORYPOOL_VT;
extern struct LUCY_MEMORYPOOL_VT LUCY_MEMORYPOOL_vt;
#define LUCY_MEMORYPOOL ((cfish_VTable*)&LUCY_MEMORYPOOL_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define MemoryPool lucy_MemoryPool
  #define MEMORYPOOL LUCY_MEMORYPOOL
  #define MemPool_new lucy_MemPool_new
  #define MemPool_init lucy_MemPool_init
  #define MemPool_destroy_t lucy_MemPool_destroy_t
  #define MemPool_destroy lucy_MemPool_destroy
  #define MemPool_grab_t lucy_MemPool_grab_t
  #define MemPool_grab lucy_MemPool_grab
  #define MemPool_resize_t lucy_MemPool_resize_t
  #define MemPool_resize lucy_MemPool_resize
  #define MemPool_release_all_t lucy_MemPool_release_all_t
  #define MemPool_release_all lucy_MemPool_release_all
  #define MemPool_eat_t lucy_MemPool_eat_t
  #define MemPool_eat lucy_MemPool_eat
  #define MemPool_get_consumed_t lucy_MemPool_get_consumed_t
  #define MemPool_get_consumed lucy_MemPool_get_consumed
  #define MemPool_Make Lucy_MemPool_Make
  #define MemPool_Get_RefCount Lucy_MemPool_Get_RefCount
  #define MemPool_Inc_RefCount Lucy_MemPool_Inc_RefCount
  #define MemPool_Dec_RefCount Lucy_MemPool_Dec_RefCount
  #define MemPool_To_Host Lucy_MemPool_To_Host
  #define MemPool_Clone Lucy_MemPool_Clone
  #define MemPool_Destroy Lucy_MemPool_Destroy
  #define MemPool_Equals Lucy_MemPool_Equals
  #define MemPool_Compare_To Lucy_MemPool_Compare_To
  #define MemPool_Hash_Sum Lucy_MemPool_Hash_Sum
  #define MemPool_Get_VTable Lucy_MemPool_Get_VTable
  #define MemPool_Get_Class_Name Lucy_MemPool_Get_Class_Name
  #define MemPool_Is_A Lucy_MemPool_Is_A
  #define MemPool_To_String Lucy_MemPool_To_String
  #define MemPool_To_I64 Lucy_MemPool_To_I64
  #define MemPool_To_F64 Lucy_MemPool_To_F64
  #define MemPool_To_Bool Lucy_MemPool_To_Bool
  #define MemPool_Serialize Lucy_MemPool_Serialize
  #define MemPool_Deserialize Lucy_MemPool_Deserialize
  #define MemPool_Dump Lucy_MemPool_Dump
  #define MemPool_Load Lucy_MemPool_Load
  #define MemPool_Mimic Lucy_MemPool_Mimic
  #define MemPool_Grab Lucy_MemPool_Grab
  #define MemPool_Resize Lucy_MemPool_Resize
  #define MemPool_Release_All Lucy_MemPool_Release_All
  #define MemPool_Eat Lucy_MemPool_Eat
  #define MemPool_Get_Consumed Lucy_MemPool_Get_Consumed
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_UTIL_MEMORYPOOL */




