/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_UTIL_PRIORITYQUEUE
#define H_LUCY_UTIL_PRIORITYQUEUE 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PRIORITYQUEUE
struct lucy_PriorityQueue {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint32_t size;
    uint32_t max_size;
    lucy_Obj** heap;
};

#endif /* C_LUCY_PRIORITYQUEUE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_PriorityQueue*
lucy_PriQ_init(lucy_PriorityQueue* self, uint32_t max_size);

void
lucy_PriQ_destroy(lucy_PriorityQueue* self);

chy_bool_t
lucy_PriQ_less_than(lucy_PriorityQueue* self, lucy_Obj* a, lucy_Obj* b);

chy_bool_t
lucy_PriQ_insert(lucy_PriorityQueue* self, lucy_Obj* element);

lucy_Obj*
lucy_PriQ_jostle(lucy_PriorityQueue* self, lucy_Obj* element);

lucy_Obj*
lucy_PriQ_pop(lucy_PriorityQueue* self);

lucy_VArray*
lucy_PriQ_pop_all(lucy_PriorityQueue* self);

lucy_Obj*
lucy_PriQ_peek(lucy_PriorityQueue* self);

uint32_t
lucy_PriQ_get_size(lucy_PriorityQueue* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_PriQ_destroy_CALLBACK;
extern cfish_Callback lucy_PriQ_less_than_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_PriQ_destroy_t)(lucy_PriorityQueue* self);

typedef chy_bool_t
(*lucy_PriQ_less_than_t)(lucy_PriorityQueue* self, lucy_Obj* a, lucy_Obj* b);

typedef chy_bool_t
(*lucy_PriQ_insert_t)(lucy_PriorityQueue* self, lucy_Obj* element);

typedef lucy_Obj*
(*lucy_PriQ_jostle_t)(lucy_PriorityQueue* self, lucy_Obj* element);

typedef lucy_Obj*
(*lucy_PriQ_pop_t)(lucy_PriorityQueue* self);

typedef lucy_VArray*
(*lucy_PriQ_pop_all_t)(lucy_PriorityQueue* self);

typedef lucy_Obj*
(*lucy_PriQ_peek_t)(lucy_PriorityQueue* self);

typedef uint32_t
(*lucy_PriQ_get_size_t)(lucy_PriorityQueue* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_PriQ_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Make(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PriQ_Get_RefCount(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Inc_RefCount(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_PriQ_Dec_RefCount(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_PriQ_To_Host(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Clone(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Destroy_OFFSET;
static CHY_INLINE void
Lucy_PriQ_Destroy(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Destroy_OFFSET;
    const lucy_PriQ_destroy_t method = *((lucy_PriQ_destroy_t*)method_address);
    method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_PriQ_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PriQ_Equals(const lucy_PriorityQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PriQ_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PriQ_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_PriQ_Compare_To(const lucy_PriorityQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PriQ_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_PriQ_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_PriQ_Hash_Sum(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_PriQ_Get_VTable(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PriQ_Get_Class_Name(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PriQ_Is_A(const lucy_PriorityQueue *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_PriQ_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_PriQ_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_PriQ_To_String(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_PriQ_To_I64(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_To_F64_OFFSET;
static CHY_INLINE double
Lucy_PriQ_To_F64(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PriQ_To_Bool(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Serialize_OFFSET;
static CHY_INLINE void
Lucy_PriQ_Serialize(const lucy_PriorityQueue *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_PriQ_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_PriQ_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Deserialize(const lucy_PriorityQueue *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_PriQ_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_PriQ_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Dump(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_PriQ_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Load(const lucy_PriorityQueue *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_PriQ_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_PriQ_Mimic_OFFSET;
static CHY_INLINE void
Lucy_PriQ_Mimic(const lucy_PriorityQueue *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_PriQ_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_PriQ_Less_Than_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PriQ_Less_Than(const lucy_PriorityQueue *self, lucy_Obj* a, lucy_Obj* b) {
    char *const method_address = *(char**)self + Lucy_PriQ_Less_Than_OFFSET;
    const lucy_PriQ_less_than_t method = *((lucy_PriQ_less_than_t*)method_address);
    return method((lucy_PriorityQueue*)self, a, b);
}

extern size_t Lucy_PriQ_Insert_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_PriQ_Insert(const lucy_PriorityQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_PriQ_Insert_OFFSET;
    const lucy_PriQ_insert_t method = *((lucy_PriQ_insert_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_PriQ_Jostle_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Jostle(const lucy_PriorityQueue *self, lucy_Obj* element) {
    char *const method_address = *(char**)self + Lucy_PriQ_Jostle_OFFSET;
    const lucy_PriQ_jostle_t method = *((lucy_PriQ_jostle_t*)method_address);
    return method((lucy_PriorityQueue*)self, element);
}

extern size_t Lucy_PriQ_Pop_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Pop(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Pop_OFFSET;
    const lucy_PriQ_pop_t method = *((lucy_PriQ_pop_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_PriQ_Pop_All_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_PriQ_Pop_All(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Pop_All_OFFSET;
    const lucy_PriQ_pop_all_t method = *((lucy_PriQ_pop_all_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_PriQ_Peek_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_PriQ_Peek(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Peek_OFFSET;
    const lucy_PriQ_peek_t method = *((lucy_PriQ_peek_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}

extern size_t Lucy_PriQ_Get_Size_OFFSET;
static CHY_INLINE uint32_t
Lucy_PriQ_Get_Size(const lucy_PriorityQueue *self) {
    char *const method_address = *(char**)self + Lucy_PriQ_Get_Size_OFFSET;
    const lucy_PriQ_get_size_t method = *((lucy_PriQ_get_size_t*)method_address);
    return method((lucy_PriorityQueue*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PRIORITYQUEUE_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[29];
} LUCY_PRIORITYQUEUE_VT;
extern struct LUCY_PRIORITYQUEUE_VT LUCY_PRIORITYQUEUE_vt;
#define LUCY_PRIORITYQUEUE ((cfish_VTable*)&LUCY_PRIORITYQUEUE_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PriorityQueue lucy_PriorityQueue
  #define PRIORITYQUEUE LUCY_PRIORITYQUEUE
  #define PriQ_init lucy_PriQ_init
  #define PriQ_destroy_t lucy_PriQ_destroy_t
  #define PriQ_destroy lucy_PriQ_destroy
  #define PriQ_less_than_t lucy_PriQ_less_than_t
  #define PriQ_less_than lucy_PriQ_less_than
  #define PriQ_insert_t lucy_PriQ_insert_t
  #define PriQ_insert lucy_PriQ_insert
  #define PriQ_jostle_t lucy_PriQ_jostle_t
  #define PriQ_jostle lucy_PriQ_jostle
  #define PriQ_pop_t lucy_PriQ_pop_t
  #define PriQ_pop lucy_PriQ_pop
  #define PriQ_pop_all_t lucy_PriQ_pop_all_t
  #define PriQ_pop_all lucy_PriQ_pop_all
  #define PriQ_peek_t lucy_PriQ_peek_t
  #define PriQ_peek lucy_PriQ_peek
  #define PriQ_get_size_t lucy_PriQ_get_size_t
  #define PriQ_get_size lucy_PriQ_get_size
  #define PriQ_Make Lucy_PriQ_Make
  #define PriQ_Get_RefCount Lucy_PriQ_Get_RefCount
  #define PriQ_Inc_RefCount Lucy_PriQ_Inc_RefCount
  #define PriQ_Dec_RefCount Lucy_PriQ_Dec_RefCount
  #define PriQ_To_Host Lucy_PriQ_To_Host
  #define PriQ_Clone Lucy_PriQ_Clone
  #define PriQ_Destroy Lucy_PriQ_Destroy
  #define PriQ_Equals Lucy_PriQ_Equals
  #define PriQ_Compare_To Lucy_PriQ_Compare_To
  #define PriQ_Hash_Sum Lucy_PriQ_Hash_Sum
  #define PriQ_Get_VTable Lucy_PriQ_Get_VTable
  #define PriQ_Get_Class_Name Lucy_PriQ_Get_Class_Name
  #define PriQ_Is_A Lucy_PriQ_Is_A
  #define PriQ_To_String Lucy_PriQ_To_String
  #define PriQ_To_I64 Lucy_PriQ_To_I64
  #define PriQ_To_F64 Lucy_PriQ_To_F64
  #define PriQ_To_Bool Lucy_PriQ_To_Bool
  #define PriQ_Serialize Lucy_PriQ_Serialize
  #define PriQ_Deserialize Lucy_PriQ_Deserialize
  #define PriQ_Dump Lucy_PriQ_Dump
  #define PriQ_Load Lucy_PriQ_Load
  #define PriQ_Mimic Lucy_PriQ_Mimic
  #define PriQ_Less_Than Lucy_PriQ_Less_Than
  #define PriQ_Insert Lucy_PriQ_Insert
  #define PriQ_Jostle Lucy_PriQ_Jostle
  #define PriQ_Pop Lucy_PriQ_Pop
  #define PriQ_Pop_All Lucy_PriQ_Pop_All
  #define PriQ_Peek Lucy_PriQ_Peek
  #define PriQ_Get_Size Lucy_PriQ_Get_Size
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_UTIL_PRIORITYQUEUE */




