/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_UTIL_SORTEXTERNAL
#define H_LUCY_UTIL_SORTEXTERNAL 1


#ifdef __cplusplus
extern "C" {
#endif

#include <stddef.h>
#include "Lucy/Object/Obj.h"
#include "Lucy/Util/SortUtils.h"

#define LUCY_SORTEX_DEFAULT_MEM_THRESHOLD 0x1000000
#ifdef LUCY_USE_SHORT_NAMES
  #define SORTEX_DEFAULT_MEM_THRESHOLD LUCY_SORTEX_DEFAULT_MEM_THRESHOLD
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Object/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTEXTERNAL
struct lucy_SortExternal {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    uint8_t* cache;
    uint32_t cache_cap;
    uint32_t cache_max;
    uint32_t cache_tick;
    uint8_t* scratch;
    uint32_t scratch_cap;
    lucy_VArray* runs;
    uint32_t num_slices;
    uint8_t** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    size_t width;
    chy_bool_t flipped;
};

#endif /* C_LUCY_SORTEXTERNAL */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_SortExternal*
lucy_SortEx_init(lucy_SortExternal* self, size_t width);

void
lucy_SortEx_destroy(lucy_SortExternal* self);

int
lucy_SortEx_compare(lucy_SortExternal* self, void* va, void* vb);

void
lucy_SortEx_flush(lucy_SortExternal* self);

void
lucy_SortEx_feed(lucy_SortExternal* self, void* data);

void
lucy_SortEx_flip(lucy_SortExternal* self);

void*
lucy_SortEx_fetch(lucy_SortExternal* self);

void*
lucy_SortEx_peek(lucy_SortExternal* self);

void
lucy_SortEx_add_run(lucy_SortExternal* self, lucy_SortExternal* run);

uint32_t
lucy_SortEx_refill(lucy_SortExternal* self);

void
lucy_SortEx_sort_cache(lucy_SortExternal* self);

void
lucy_SortEx_clear_cache(lucy_SortExternal* self);

uint32_t
lucy_SortEx_cache_count(lucy_SortExternal* self);

void
lucy_SortEx_grow_cache(lucy_SortExternal* self, uint32_t new_cache_cap);

void
lucy_SortEx_set_mem_thresh(lucy_SortExternal* self, uint32_t mem_thresh);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_SortEx_destroy_CALLBACK;
extern cfish_Callback lucy_SortEx_compare_CALLBACK;
extern cfish_Callback lucy_SortEx_flush_CALLBACK;
extern cfish_Callback lucy_SortEx_refill_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_SortEx_destroy_t)(lucy_SortExternal* self);

typedef int
(*lucy_SortEx_compare_t)(lucy_SortExternal* self, void* va, void* vb);

typedef void
(*lucy_SortEx_flush_t)(lucy_SortExternal* self);

typedef void
(*lucy_SortEx_feed_t)(lucy_SortExternal* self, void* data);

typedef void
(*lucy_SortEx_flip_t)(lucy_SortExternal* self);

typedef void*
(*lucy_SortEx_fetch_t)(lucy_SortExternal* self);

typedef void*
(*lucy_SortEx_peek_t)(lucy_SortExternal* self);

typedef void
(*lucy_SortEx_add_run_t)(lucy_SortExternal* self, lucy_SortExternal* run);

typedef uint32_t
(*lucy_SortEx_refill_t)(lucy_SortExternal* self);

typedef void
(*lucy_SortEx_sort_cache_t)(lucy_SortExternal* self);

typedef void
(*lucy_SortEx_clear_cache_t)(lucy_SortExternal* self);

typedef uint32_t
(*lucy_SortEx_cache_count_t)(lucy_SortExternal* self);

typedef void
(*lucy_SortEx_grow_cache_t)(lucy_SortExternal* self, uint32_t new_cache_cap);

typedef void
(*lucy_SortEx_set_mem_thresh_t)(lucy_SortExternal* self, uint32_t mem_thresh);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_SortEx_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortEx_Make(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortEx_Get_RefCount(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortEx_Inc_RefCount(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortEx_Dec_RefCount(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_SortEx_To_Host(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortEx_Clone(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Destroy_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Destroy(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Destroy_OFFSET;
    const lucy_SortEx_destroy_t method = *((lucy_SortEx_destroy_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortEx_Equals(const lucy_SortExternal *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortEx_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortEx_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_SortEx_Compare_To(const lucy_SortExternal *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortEx_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortEx_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_SortEx_Hash_Sum(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_SortEx_Get_VTable(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortEx_Get_Class_Name(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortEx_Is_A(const lucy_SortExternal *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_SortEx_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_SortEx_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_SortEx_To_String(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_SortEx_To_I64(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_To_F64_OFFSET;
static CHY_INLINE double
Lucy_SortEx_To_F64(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_SortEx_To_Bool(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Serialize_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Serialize(const lucy_SortExternal *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_SortEx_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_SortEx_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortEx_Deserialize(const lucy_SortExternal *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_SortEx_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_SortEx_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortEx_Dump(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_SortEx_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_SortEx_Load(const lucy_SortExternal *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_SortEx_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_SortEx_Mimic_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Mimic(const lucy_SortExternal *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_SortEx_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_SortEx_Compare_OFFSET;
static CHY_INLINE int
Lucy_SortEx_Compare(const lucy_SortExternal *self, void* va, void* vb) {
    char *const method_address = *(char**)self + Lucy_SortEx_Compare_OFFSET;
    const lucy_SortEx_compare_t method = *((lucy_SortEx_compare_t*)method_address);
    return method((lucy_SortExternal*)self, va, vb);
}

extern size_t Lucy_SortEx_Flush_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Flush(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Flush_OFFSET;
    const lucy_SortEx_flush_t method = *((lucy_SortEx_flush_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Feed_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Feed(const lucy_SortExternal *self, void* data) {
    char *const method_address = *(char**)self + Lucy_SortEx_Feed_OFFSET;
    const lucy_SortEx_feed_t method = *((lucy_SortEx_feed_t*)method_address);
    method((lucy_SortExternal*)self, data);
}

extern size_t Lucy_SortEx_Flip_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Flip(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Flip_OFFSET;
    const lucy_SortEx_flip_t method = *((lucy_SortEx_flip_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Fetch_OFFSET;
static CHY_INLINE void*
Lucy_SortEx_Fetch(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Fetch_OFFSET;
    const lucy_SortEx_fetch_t method = *((lucy_SortEx_fetch_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Peek_OFFSET;
static CHY_INLINE void*
Lucy_SortEx_Peek(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Peek_OFFSET;
    const lucy_SortEx_peek_t method = *((lucy_SortEx_peek_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Add_Run_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Add_Run(const lucy_SortExternal *self, lucy_SortExternal* run) {
    char *const method_address = *(char**)self + Lucy_SortEx_Add_Run_OFFSET;
    const lucy_SortEx_add_run_t method = *((lucy_SortEx_add_run_t*)method_address);
    method((lucy_SortExternal*)self, run);
}

extern size_t Lucy_SortEx_Refill_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortEx_Refill(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Refill_OFFSET;
    const lucy_SortEx_refill_t method = *((lucy_SortEx_refill_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Sort_Cache_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Sort_Cache(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Sort_Cache_OFFSET;
    const lucy_SortEx_sort_cache_t method = *((lucy_SortEx_sort_cache_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Clear_Cache_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Clear_Cache(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Clear_Cache_OFFSET;
    const lucy_SortEx_clear_cache_t method = *((lucy_SortEx_clear_cache_t*)method_address);
    method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Cache_Count_OFFSET;
static CHY_INLINE uint32_t
Lucy_SortEx_Cache_Count(const lucy_SortExternal *self) {
    char *const method_address = *(char**)self + Lucy_SortEx_Cache_Count_OFFSET;
    const lucy_SortEx_cache_count_t method = *((lucy_SortEx_cache_count_t*)method_address);
    return method((lucy_SortExternal*)self);
}

extern size_t Lucy_SortEx_Grow_Cache_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Grow_Cache(const lucy_SortExternal *self, uint32_t new_cache_cap) {
    char *const method_address = *(char**)self + Lucy_SortEx_Grow_Cache_OFFSET;
    const lucy_SortEx_grow_cache_t method = *((lucy_SortEx_grow_cache_t*)method_address);
    method((lucy_SortExternal*)self, new_cache_cap);
}

extern size_t Lucy_SortEx_Set_Mem_Thresh_OFFSET;
static CHY_INLINE void
Lucy_SortEx_Set_Mem_Thresh(const lucy_SortExternal *self, uint32_t mem_thresh) {
    char *const method_address = *(char**)self + Lucy_SortEx_Set_Mem_Thresh_OFFSET;
    const lucy_SortEx_set_mem_thresh_t method = *((lucy_SortEx_set_mem_thresh_t*)method_address);
    method((lucy_SortExternal*)self, mem_thresh);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_SORTEXTERNAL_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[35];
} LUCY_SORTEXTERNAL_VT;
extern struct LUCY_SORTEXTERNAL_VT LUCY_SORTEXTERNAL_vt;
#define LUCY_SORTEXTERNAL ((cfish_VTable*)&LUCY_SORTEXTERNAL_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortExternal lucy_SortExternal
  #define SORTEXTERNAL LUCY_SORTEXTERNAL
  #define SortEx_init lucy_SortEx_init
  #define SortEx_destroy_t lucy_SortEx_destroy_t
  #define SortEx_destroy lucy_SortEx_destroy
  #define SortEx_compare_t lucy_SortEx_compare_t
  #define SortEx_compare lucy_SortEx_compare
  #define SortEx_flush_t lucy_SortEx_flush_t
  #define SortEx_flush lucy_SortEx_flush
  #define SortEx_feed_t lucy_SortEx_feed_t
  #define SortEx_feed lucy_SortEx_feed
  #define SortEx_flip_t lucy_SortEx_flip_t
  #define SortEx_flip lucy_SortEx_flip
  #define SortEx_fetch_t lucy_SortEx_fetch_t
  #define SortEx_fetch lucy_SortEx_fetch
  #define SortEx_peek_t lucy_SortEx_peek_t
  #define SortEx_peek lucy_SortEx_peek
  #define SortEx_add_run_t lucy_SortEx_add_run_t
  #define SortEx_add_run lucy_SortEx_add_run
  #define SortEx_refill_t lucy_SortEx_refill_t
  #define SortEx_refill lucy_SortEx_refill
  #define SortEx_sort_cache_t lucy_SortEx_sort_cache_t
  #define SortEx_sort_cache lucy_SortEx_sort_cache
  #define SortEx_clear_cache_t lucy_SortEx_clear_cache_t
  #define SortEx_clear_cache lucy_SortEx_clear_cache
  #define SortEx_cache_count_t lucy_SortEx_cache_count_t
  #define SortEx_cache_count lucy_SortEx_cache_count
  #define SortEx_grow_cache_t lucy_SortEx_grow_cache_t
  #define SortEx_grow_cache lucy_SortEx_grow_cache
  #define SortEx_set_mem_thresh_t lucy_SortEx_set_mem_thresh_t
  #define SortEx_set_mem_thresh lucy_SortEx_set_mem_thresh
  #define SortEx_Make Lucy_SortEx_Make
  #define SortEx_Get_RefCount Lucy_SortEx_Get_RefCount
  #define SortEx_Inc_RefCount Lucy_SortEx_Inc_RefCount
  #define SortEx_Dec_RefCount Lucy_SortEx_Dec_RefCount
  #define SortEx_To_Host Lucy_SortEx_To_Host
  #define SortEx_Clone Lucy_SortEx_Clone
  #define SortEx_Destroy Lucy_SortEx_Destroy
  #define SortEx_Equals Lucy_SortEx_Equals
  #define SortEx_Compare_To Lucy_SortEx_Compare_To
  #define SortEx_Hash_Sum Lucy_SortEx_Hash_Sum
  #define SortEx_Get_VTable Lucy_SortEx_Get_VTable
  #define SortEx_Get_Class_Name Lucy_SortEx_Get_Class_Name
  #define SortEx_Is_A Lucy_SortEx_Is_A
  #define SortEx_To_String Lucy_SortEx_To_String
  #define SortEx_To_I64 Lucy_SortEx_To_I64
  #define SortEx_To_F64 Lucy_SortEx_To_F64
  #define SortEx_To_Bool Lucy_SortEx_To_Bool
  #define SortEx_Serialize Lucy_SortEx_Serialize
  #define SortEx_Deserialize Lucy_SortEx_Deserialize
  #define SortEx_Dump Lucy_SortEx_Dump
  #define SortEx_Load Lucy_SortEx_Load
  #define SortEx_Mimic Lucy_SortEx_Mimic
  #define SortEx_Compare Lucy_SortEx_Compare
  #define SortEx_Flush Lucy_SortEx_Flush
  #define SortEx_Feed Lucy_SortEx_Feed
  #define SortEx_Flip Lucy_SortEx_Flip
  #define SortEx_Fetch Lucy_SortEx_Fetch
  #define SortEx_Peek Lucy_SortEx_Peek
  #define SortEx_Add_Run Lucy_SortEx_Add_Run
  #define SortEx_Refill Lucy_SortEx_Refill
  #define SortEx_Sort_Cache Lucy_SortEx_Sort_Cache
  #define SortEx_Clear_Cache Lucy_SortEx_Clear_Cache
  #define SortEx_Cache_Count Lucy_SortEx_Cache_Count
  #define SortEx_Grow_Cache Lucy_SortEx_Grow_Cache
  #define SortEx_Set_Mem_Thresh Lucy_SortEx_Set_Mem_Thresh
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_UTIL_SORTEXTERNAL */




