/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCYX_SEARCH_PROXIMITYMATCHER
#define H_LUCYX_SEARCH_PROXIMITYMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PROXIMITYMATCHER
struct lucy_ProximityMatcher {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    int32_t doc_id;
    uint32_t num_elements;
    lucy_Similarity* sim;
    lucy_PostingList** plists;
    lucy_ByteBuf* anchor_set;
    float proximity_freq;
    float proximity_boost;
    lucy_Compiler* compiler;
    float weight;
    chy_bool_t first_time;
    chy_bool_t more;
    uint32_t within;
};

#endif /* C_LUCY_PROXIMITYMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ProximityMatcher*
lucy_ProximityMatcher_new(lucy_Similarity* similarity, lucy_VArray* posting_lists, lucy_Compiler* compiler, uint32_t within);

lucy_ProximityMatcher*
lucy_ProximityMatcher_init(lucy_ProximityMatcher* self, lucy_Similarity* similarity, lucy_VArray* posting_lists, lucy_Compiler* compiler, uint32_t within);

void
lucy_ProximityMatcher_destroy(lucy_ProximityMatcher* self);

int32_t
lucy_ProximityMatcher_next(lucy_ProximityMatcher* self);

int32_t
lucy_ProximityMatcher_advance(lucy_ProximityMatcher* self, int32_t target);

int32_t
lucy_ProximityMatcher_get_doc_id(lucy_ProximityMatcher* self);

float
lucy_ProximityMatcher_score(lucy_ProximityMatcher* self);

float
lucy_ProximityMatcher_calc_proximity_freq(lucy_ProximityMatcher* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ProximityMatcher_destroy_CALLBACK;
extern cfish_Callback lucy_ProximityMatcher_next_CALLBACK;
extern cfish_Callback lucy_ProximityMatcher_advance_CALLBACK;
extern cfish_Callback lucy_ProximityMatcher_get_doc_id_CALLBACK;
extern cfish_Callback lucy_ProximityMatcher_score_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ProximityMatcher_destroy_t)(lucy_ProximityMatcher* self);

typedef int32_t
(*lucy_ProximityMatcher_next_t)(lucy_ProximityMatcher* self);

typedef int32_t
(*lucy_ProximityMatcher_advance_t)(lucy_ProximityMatcher* self, int32_t target);

typedef int32_t
(*lucy_ProximityMatcher_get_doc_id_t)(lucy_ProximityMatcher* self);

typedef float
(*lucy_ProximityMatcher_score_t)(lucy_ProximityMatcher* self);

typedef float
(*lucy_ProximityMatcher_calc_proximity_freq_t)(lucy_ProximityMatcher* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ProximityMatcher_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityMatcher_Make(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityMatcher_Get_RefCount(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityMatcher_Inc_RefCount(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityMatcher_Dec_RefCount(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ProximityMatcher_To_Host(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityMatcher_Clone(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ProximityMatcher_Destroy(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Destroy_OFFSET;
    const lucy_ProximityMatcher_destroy_t method = *((lucy_ProximityMatcher_destroy_t*)method_address);
    method((lucy_ProximityMatcher*)self);
}

extern size_t Lucy_ProximityMatcher_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityMatcher_Equals(const lucy_ProximityMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Equals_OFFSET;
    const lucy_Obj_equals_t method = *((lucy_Obj_equals_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityMatcher_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityMatcher_Compare_To(const lucy_ProximityMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityMatcher_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityMatcher_Hash_Sum(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ProximityMatcher_Get_VTable(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityMatcher_Get_Class_Name(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityMatcher_Is_A(const lucy_ProximityMatcher *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ProximityMatcher_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityMatcher_To_String(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_To_String_OFFSET;
    const lucy_Obj_to_string_t method = *((lucy_Obj_to_string_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ProximityMatcher_To_I64(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ProximityMatcher_To_F64(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityMatcher_To_Bool(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ProximityMatcher_Serialize(const lucy_ProximityMatcher *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Serialize_OFFSET;
    const lucy_Obj_serialize_t method = *((lucy_Obj_serialize_t*)method_address);
    method((lucy_Obj*)self, outstream);
}

extern size_t Lucy_ProximityMatcher_Deserialize_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityMatcher_Deserialize(const lucy_ProximityMatcher *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Deserialize_OFFSET;
    const lucy_Obj_deserialize_t method = *((lucy_Obj_deserialize_t*)method_address);
    return method((lucy_Obj*)self, instream);
}

extern size_t Lucy_ProximityMatcher_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityMatcher_Dump(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Dump_OFFSET;
    const lucy_Obj_dump_t method = *((lucy_Obj_dump_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityMatcher_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityMatcher_Load(const lucy_ProximityMatcher *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Load_OFFSET;
    const lucy_Obj_load_t method = *((lucy_Obj_load_t*)method_address);
    return method((lucy_Obj*)self, dump);
}

extern size_t Lucy_ProximityMatcher_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ProximityMatcher_Mimic(const lucy_ProximityMatcher *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityMatcher_Next_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityMatcher_Next(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Next_OFFSET;
    const lucy_ProximityMatcher_next_t method = *((lucy_ProximityMatcher_next_t*)method_address);
    return method((lucy_ProximityMatcher*)self);
}

extern size_t Lucy_ProximityMatcher_Advance_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityMatcher_Advance(const lucy_ProximityMatcher *self, int32_t target) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Advance_OFFSET;
    const lucy_ProximityMatcher_advance_t method = *((lucy_ProximityMatcher_advance_t*)method_address);
    return method((lucy_ProximityMatcher*)self, target);
}

extern size_t Lucy_ProximityMatcher_Get_Doc_ID_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityMatcher_Get_Doc_ID(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Get_Doc_ID_OFFSET;
    const lucy_ProximityMatcher_get_doc_id_t method = *((lucy_ProximityMatcher_get_doc_id_t*)method_address);
    return method((lucy_ProximityMatcher*)self);
}

extern size_t Lucy_ProximityMatcher_Score_OFFSET;
static CHY_INLINE float
Lucy_ProximityMatcher_Score(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Score_OFFSET;
    const lucy_ProximityMatcher_score_t method = *((lucy_ProximityMatcher_score_t*)method_address);
    return method((lucy_ProximityMatcher*)self);
}

extern size_t Lucy_ProximityMatcher_Collect_OFFSET;
static CHY_INLINE void
Lucy_ProximityMatcher_Collect(const lucy_ProximityMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Collect_OFFSET;
    const lucy_Matcher_collect_t method = *((lucy_Matcher_collect_t*)method_address);
    method((lucy_Matcher*)self, collector, deletions);
}

extern size_t Lucy_ProximityMatcher_Calc_Proximity_Freq_OFFSET;
static CHY_INLINE float
Lucy_ProximityMatcher_Calc_Proximity_Freq(const lucy_ProximityMatcher *self) {
    char *const method_address = *(char**)self + Lucy_ProximityMatcher_Calc_Proximity_Freq_OFFSET;
    const lucy_ProximityMatcher_calc_proximity_freq_t method = *((lucy_ProximityMatcher_calc_proximity_freq_t*)method_address);
    return method((lucy_ProximityMatcher*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PROXIMITYMATCHER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_PROXIMITYMATCHER_VT;
extern struct LUCY_PROXIMITYMATCHER_VT LUCY_PROXIMITYMATCHER_vt;
#define LUCY_PROXIMITYMATCHER ((cfish_VTable*)&LUCY_PROXIMITYMATCHER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityMatcher lucy_ProximityMatcher
  #define PROXIMITYMATCHER LUCY_PROXIMITYMATCHER
  #define ProximityMatcher_new lucy_ProximityMatcher_new
  #define ProximityMatcher_init lucy_ProximityMatcher_init
  #define ProximityMatcher_destroy_t lucy_ProximityMatcher_destroy_t
  #define ProximityMatcher_destroy lucy_ProximityMatcher_destroy
  #define ProximityMatcher_next_t lucy_ProximityMatcher_next_t
  #define ProximityMatcher_next lucy_ProximityMatcher_next
  #define ProximityMatcher_advance_t lucy_ProximityMatcher_advance_t
  #define ProximityMatcher_advance lucy_ProximityMatcher_advance
  #define ProximityMatcher_get_doc_id_t lucy_ProximityMatcher_get_doc_id_t
  #define ProximityMatcher_get_doc_id lucy_ProximityMatcher_get_doc_id
  #define ProximityMatcher_score_t lucy_ProximityMatcher_score_t
  #define ProximityMatcher_score lucy_ProximityMatcher_score
  #define ProximityMatcher_calc_proximity_freq_t lucy_ProximityMatcher_calc_proximity_freq_t
  #define ProximityMatcher_calc_proximity_freq lucy_ProximityMatcher_calc_proximity_freq
  #define ProximityMatcher_Make Lucy_ProximityMatcher_Make
  #define ProximityMatcher_Get_RefCount Lucy_ProximityMatcher_Get_RefCount
  #define ProximityMatcher_Inc_RefCount Lucy_ProximityMatcher_Inc_RefCount
  #define ProximityMatcher_Dec_RefCount Lucy_ProximityMatcher_Dec_RefCount
  #define ProximityMatcher_To_Host Lucy_ProximityMatcher_To_Host
  #define ProximityMatcher_Clone Lucy_ProximityMatcher_Clone
  #define ProximityMatcher_Destroy Lucy_ProximityMatcher_Destroy
  #define ProximityMatcher_Equals Lucy_ProximityMatcher_Equals
  #define ProximityMatcher_Compare_To Lucy_ProximityMatcher_Compare_To
  #define ProximityMatcher_Hash_Sum Lucy_ProximityMatcher_Hash_Sum
  #define ProximityMatcher_Get_VTable Lucy_ProximityMatcher_Get_VTable
  #define ProximityMatcher_Get_Class_Name Lucy_ProximityMatcher_Get_Class_Name
  #define ProximityMatcher_Is_A Lucy_ProximityMatcher_Is_A
  #define ProximityMatcher_To_String Lucy_ProximityMatcher_To_String
  #define ProximityMatcher_To_I64 Lucy_ProximityMatcher_To_I64
  #define ProximityMatcher_To_F64 Lucy_ProximityMatcher_To_F64
  #define ProximityMatcher_To_Bool Lucy_ProximityMatcher_To_Bool
  #define ProximityMatcher_Serialize Lucy_ProximityMatcher_Serialize
  #define ProximityMatcher_Deserialize Lucy_ProximityMatcher_Deserialize
  #define ProximityMatcher_Dump Lucy_ProximityMatcher_Dump
  #define ProximityMatcher_Load Lucy_ProximityMatcher_Load
  #define ProximityMatcher_Mimic Lucy_ProximityMatcher_Mimic
  #define ProximityMatcher_Next Lucy_ProximityMatcher_Next
  #define ProximityMatcher_Advance Lucy_ProximityMatcher_Advance
  #define ProximityMatcher_Get_Doc_ID Lucy_ProximityMatcher_Get_Doc_ID
  #define ProximityMatcher_Score Lucy_ProximityMatcher_Score
  #define ProximityMatcher_Collect Lucy_ProximityMatcher_Collect
  #define ProximityMatcher_Calc_Proximity_Freq Lucy_ProximityMatcher_Calc_Proximity_Freq
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCYX_SEARCH_PROXIMITYMATCHER */




