/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCYX_SEARCH_PROXIMITYQUERY
#define H_LUCYX_SEARCH_PROXIMITYQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PROXIMITYQUERY
struct lucy_ProximityQuery {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_CharBuf* field;
    lucy_VArray* terms;
    uint32_t within;
};

#endif /* C_LUCY_PROXIMITYQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ProximityQuery*
lucy_ProximityQuery_new(const lucy_CharBuf* field, lucy_VArray* terms, uint32_t within);

lucy_ProximityQuery*
lucy_ProximityQuery_init(lucy_ProximityQuery* self, const lucy_CharBuf* field, lucy_VArray* terms, uint32_t within);

void
lucy_ProximityQuery_destroy(lucy_ProximityQuery* self);

chy_bool_t
lucy_ProximityQuery_equals(lucy_ProximityQuery* self, lucy_Obj* other);

lucy_CharBuf*
lucy_ProximityQuery_to_string(lucy_ProximityQuery* self);

void
lucy_ProximityQuery_serialize(lucy_ProximityQuery* self, lucy_OutStream* outstream);

lucy_ProximityQuery*
lucy_ProximityQuery_deserialize(lucy_ProximityQuery* self, lucy_InStream* instream);

lucy_Obj*
lucy_ProximityQuery_dump(lucy_ProximityQuery* self);

lucy_Obj*
lucy_ProximityQuery_load(lucy_ProximityQuery* self, lucy_Obj* dump);

lucy_Compiler*
lucy_ProximityQuery_make_compiler(lucy_ProximityQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

lucy_CharBuf*
lucy_ProximityQuery_get_field(lucy_ProximityQuery* self);

lucy_VArray*
lucy_ProximityQuery_get_terms(lucy_ProximityQuery* self);

uint32_t
lucy_ProximityQuery_get_within(lucy_ProximityQuery* self);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ProximityQuery_destroy_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_equals_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_to_string_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_serialize_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_deserialize_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_dump_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_load_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_make_compiler_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_get_field_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_get_terms_CALLBACK;
extern cfish_Callback lucy_ProximityQuery_get_within_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef void
(*lucy_ProximityQuery_destroy_t)(lucy_ProximityQuery* self);

typedef chy_bool_t
(*lucy_ProximityQuery_equals_t)(lucy_ProximityQuery* self, lucy_Obj* other);

typedef lucy_CharBuf*
(*lucy_ProximityQuery_to_string_t)(lucy_ProximityQuery* self);

typedef void
(*lucy_ProximityQuery_serialize_t)(lucy_ProximityQuery* self, lucy_OutStream* outstream);

typedef lucy_ProximityQuery*
(*lucy_ProximityQuery_deserialize_t)(lucy_ProximityQuery* self, lucy_InStream* instream);

typedef lucy_Obj*
(*lucy_ProximityQuery_dump_t)(lucy_ProximityQuery* self);

typedef lucy_Obj*
(*lucy_ProximityQuery_load_t)(lucy_ProximityQuery* self, lucy_Obj* dump);

typedef lucy_Compiler*
(*lucy_ProximityQuery_make_compiler_t)(lucy_ProximityQuery* self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate);

typedef lucy_CharBuf*
(*lucy_ProximityQuery_get_field_t)(lucy_ProximityQuery* self);

typedef lucy_VArray*
(*lucy_ProximityQuery_get_terms_t)(lucy_ProximityQuery* self);

typedef uint32_t
(*lucy_ProximityQuery_get_within_t)(lucy_ProximityQuery* self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ProximityQuery_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityQuery_Make(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityQuery_Get_RefCount(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityQuery_Inc_RefCount(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityQuery_Dec_RefCount(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ProximityQuery_To_Host(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityQuery_Clone(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ProximityQuery_Destroy(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Destroy_OFFSET;
    const lucy_ProximityQuery_destroy_t method = *((lucy_ProximityQuery_destroy_t*)method_address);
    method((lucy_ProximityQuery*)self);
}

extern size_t Lucy_ProximityQuery_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityQuery_Equals(const lucy_ProximityQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Equals_OFFSET;
    const lucy_ProximityQuery_equals_t method = *((lucy_ProximityQuery_equals_t*)method_address);
    return method((lucy_ProximityQuery*)self, other);
}

extern size_t Lucy_ProximityQuery_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityQuery_Compare_To(const lucy_ProximityQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityQuery_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityQuery_Hash_Sum(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ProximityQuery_Get_VTable(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityQuery_Get_Class_Name(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityQuery_Is_A(const lucy_ProximityQuery *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ProximityQuery_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityQuery_To_String(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_To_String_OFFSET;
    const lucy_ProximityQuery_to_string_t method = *((lucy_ProximityQuery_to_string_t*)method_address);
    return method((lucy_ProximityQuery*)self);
}

extern size_t Lucy_ProximityQuery_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ProximityQuery_To_I64(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ProximityQuery_To_F64(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityQuery_To_Bool(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityQuery_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ProximityQuery_Serialize(const lucy_ProximityQuery *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Serialize_OFFSET;
    const lucy_ProximityQuery_serialize_t method = *((lucy_ProximityQuery_serialize_t*)method_address);
    method((lucy_ProximityQuery*)self, outstream);
}

extern size_t Lucy_ProximityQuery_Deserialize_OFFSET;
static CHY_INLINE lucy_ProximityQuery*
Lucy_ProximityQuery_Deserialize(const lucy_ProximityQuery *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Deserialize_OFFSET;
    const lucy_ProximityQuery_deserialize_t method = *((lucy_ProximityQuery_deserialize_t*)method_address);
    return method((lucy_ProximityQuery*)self, instream);
}

extern size_t Lucy_ProximityQuery_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityQuery_Dump(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Dump_OFFSET;
    const lucy_ProximityQuery_dump_t method = *((lucy_ProximityQuery_dump_t*)method_address);
    return method((lucy_ProximityQuery*)self);
}

extern size_t Lucy_ProximityQuery_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityQuery_Load(const lucy_ProximityQuery *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Load_OFFSET;
    const lucy_ProximityQuery_load_t method = *((lucy_ProximityQuery_load_t*)method_address);
    return method((lucy_ProximityQuery*)self, dump);
}

extern size_t Lucy_ProximityQuery_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ProximityQuery_Mimic(const lucy_ProximityQuery *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityQuery_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_ProximityQuery_Make_Compiler(const lucy_ProximityQuery *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Make_Compiler_OFFSET;
    const lucy_ProximityQuery_make_compiler_t method = *((lucy_ProximityQuery_make_compiler_t*)method_address);
    return method((lucy_ProximityQuery*)self, searcher, boost, subordinate);
}

extern size_t Lucy_ProximityQuery_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_ProximityQuery_Set_Boost(const lucy_ProximityQuery *self, float boost) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_ProximityQuery_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_ProximityQuery_Get_Boost(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_ProximityQuery_Get_Field_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityQuery_Get_Field(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_Field_OFFSET;
    const lucy_ProximityQuery_get_field_t method = *((lucy_ProximityQuery_get_field_t*)method_address);
    return method((lucy_ProximityQuery*)self);
}

extern size_t Lucy_ProximityQuery_Get_Terms_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_ProximityQuery_Get_Terms(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_Terms_OFFSET;
    const lucy_ProximityQuery_get_terms_t method = *((lucy_ProximityQuery_get_terms_t*)method_address);
    return method((lucy_ProximityQuery*)self);
}

extern size_t Lucy_ProximityQuery_Get_Within_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityQuery_Get_Within(const lucy_ProximityQuery *self) {
    char *const method_address = *(char**)self + Lucy_ProximityQuery_Get_Within_OFFSET;
    const lucy_ProximityQuery_get_within_t method = *((lucy_ProximityQuery_get_within_t*)method_address);
    return method((lucy_ProximityQuery*)self);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PROXIMITYQUERY_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[28];
} LUCY_PROXIMITYQUERY_VT;
extern struct LUCY_PROXIMITYQUERY_VT LUCY_PROXIMITYQUERY_vt;
#define LUCY_PROXIMITYQUERY ((cfish_VTable*)&LUCY_PROXIMITYQUERY_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityQuery lucy_ProximityQuery
  #define PROXIMITYQUERY LUCY_PROXIMITYQUERY
  #define ProximityQuery_new lucy_ProximityQuery_new
  #define ProximityQuery_init lucy_ProximityQuery_init
  #define ProximityQuery_destroy_t lucy_ProximityQuery_destroy_t
  #define ProximityQuery_destroy lucy_ProximityQuery_destroy
  #define ProximityQuery_equals_t lucy_ProximityQuery_equals_t
  #define ProximityQuery_equals lucy_ProximityQuery_equals
  #define ProximityQuery_to_string_t lucy_ProximityQuery_to_string_t
  #define ProximityQuery_to_string lucy_ProximityQuery_to_string
  #define ProximityQuery_serialize_t lucy_ProximityQuery_serialize_t
  #define ProximityQuery_serialize lucy_ProximityQuery_serialize
  #define ProximityQuery_deserialize_t lucy_ProximityQuery_deserialize_t
  #define ProximityQuery_deserialize lucy_ProximityQuery_deserialize
  #define ProximityQuery_dump_t lucy_ProximityQuery_dump_t
  #define ProximityQuery_dump lucy_ProximityQuery_dump
  #define ProximityQuery_load_t lucy_ProximityQuery_load_t
  #define ProximityQuery_load lucy_ProximityQuery_load
  #define ProximityQuery_make_compiler_t lucy_ProximityQuery_make_compiler_t
  #define ProximityQuery_make_compiler lucy_ProximityQuery_make_compiler
  #define ProximityQuery_get_field_t lucy_ProximityQuery_get_field_t
  #define ProximityQuery_get_field lucy_ProximityQuery_get_field
  #define ProximityQuery_get_terms_t lucy_ProximityQuery_get_terms_t
  #define ProximityQuery_get_terms lucy_ProximityQuery_get_terms
  #define ProximityQuery_get_within_t lucy_ProximityQuery_get_within_t
  #define ProximityQuery_get_within lucy_ProximityQuery_get_within
  #define ProximityQuery_Make Lucy_ProximityQuery_Make
  #define ProximityQuery_Get_RefCount Lucy_ProximityQuery_Get_RefCount
  #define ProximityQuery_Inc_RefCount Lucy_ProximityQuery_Inc_RefCount
  #define ProximityQuery_Dec_RefCount Lucy_ProximityQuery_Dec_RefCount
  #define ProximityQuery_To_Host Lucy_ProximityQuery_To_Host
  #define ProximityQuery_Clone Lucy_ProximityQuery_Clone
  #define ProximityQuery_Destroy Lucy_ProximityQuery_Destroy
  #define ProximityQuery_Equals Lucy_ProximityQuery_Equals
  #define ProximityQuery_Compare_To Lucy_ProximityQuery_Compare_To
  #define ProximityQuery_Hash_Sum Lucy_ProximityQuery_Hash_Sum
  #define ProximityQuery_Get_VTable Lucy_ProximityQuery_Get_VTable
  #define ProximityQuery_Get_Class_Name Lucy_ProximityQuery_Get_Class_Name
  #define ProximityQuery_Is_A Lucy_ProximityQuery_Is_A
  #define ProximityQuery_To_String Lucy_ProximityQuery_To_String
  #define ProximityQuery_To_I64 Lucy_ProximityQuery_To_I64
  #define ProximityQuery_To_F64 Lucy_ProximityQuery_To_F64
  #define ProximityQuery_To_Bool Lucy_ProximityQuery_To_Bool
  #define ProximityQuery_Serialize Lucy_ProximityQuery_Serialize
  #define ProximityQuery_Deserialize Lucy_ProximityQuery_Deserialize
  #define ProximityQuery_Dump Lucy_ProximityQuery_Dump
  #define ProximityQuery_Load Lucy_ProximityQuery_Load
  #define ProximityQuery_Mimic Lucy_ProximityQuery_Mimic
  #define ProximityQuery_Make_Compiler Lucy_ProximityQuery_Make_Compiler
  #define ProximityQuery_Set_Boost Lucy_ProximityQuery_Set_Boost
  #define ProximityQuery_Get_Boost Lucy_ProximityQuery_Get_Boost
  #define ProximityQuery_Get_Field Lucy_ProximityQuery_Get_Field
  #define ProximityQuery_Get_Terms Lucy_ProximityQuery_Get_Terms
  #define ProximityQuery_Get_Within Lucy_ProximityQuery_Get_Within
#endif /* LUCY_USE_SHORT_NAMES */



#include "charmony.h"
#include "parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Compiler.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PROXIMITYCOMPILER
struct lucy_ProximityCompiler {
    lucy_VTable* vtable;
    lucy_ref_t ref;
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
    float idf;
    float raw_weight;
    float query_norm_factor;
    float normalized_weight;
    uint32_t within;
};

#endif /* C_LUCY_PROXIMITYCOMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

lucy_ProximityCompiler*
lucy_ProximityCompiler_new(lucy_ProximityQuery* parent, lucy_Searcher* searcher, float boost, uint32_t within);

lucy_ProximityCompiler*
lucy_ProximityCompiler_init(lucy_ProximityCompiler* self, lucy_ProximityQuery* parent, lucy_Searcher* searcher, float boost, uint32_t within);

chy_bool_t
lucy_ProximityCompiler_equals(lucy_ProximityCompiler* self, lucy_Obj* other);

void
lucy_ProximityCompiler_serialize(lucy_ProximityCompiler* self, lucy_OutStream* outstream);

lucy_ProximityCompiler*
lucy_ProximityCompiler_deserialize(lucy_ProximityCompiler* self, lucy_InStream* instream);

lucy_Matcher*
lucy_ProximityCompiler_make_matcher(lucy_ProximityCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);

float
lucy_ProximityCompiler_get_weight(lucy_ProximityCompiler* self);

float
lucy_ProximityCompiler_sum_of_squared_weights(lucy_ProximityCompiler* self);

void
lucy_ProximityCompiler_apply_norm_factor(lucy_ProximityCompiler* self, float factor);

lucy_VArray*
lucy_ProximityCompiler_highlight_spans(lucy_ProximityCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Declare the cfish_Callback objects which provide the introspection
 * information needed to perform method overriding at runtime.
 */

extern cfish_Callback lucy_ProximityCompiler_equals_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_serialize_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_deserialize_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_make_matcher_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_get_weight_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_sum_of_squared_weights_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_apply_norm_factor_CALLBACK;
extern cfish_Callback lucy_ProximityCompiler_highlight_spans_CALLBACK;


/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef chy_bool_t
(*lucy_ProximityCompiler_equals_t)(lucy_ProximityCompiler* self, lucy_Obj* other);

typedef void
(*lucy_ProximityCompiler_serialize_t)(lucy_ProximityCompiler* self, lucy_OutStream* outstream);

typedef lucy_ProximityCompiler*
(*lucy_ProximityCompiler_deserialize_t)(lucy_ProximityCompiler* self, lucy_InStream* instream);

typedef lucy_Matcher*
(*lucy_ProximityCompiler_make_matcher_t)(lucy_ProximityCompiler* self, lucy_SegReader* reader, chy_bool_t need_score);

typedef float
(*lucy_ProximityCompiler_get_weight_t)(lucy_ProximityCompiler* self);

typedef float
(*lucy_ProximityCompiler_sum_of_squared_weights_t)(lucy_ProximityCompiler* self);

typedef void
(*lucy_ProximityCompiler_apply_norm_factor_t)(lucy_ProximityCompiler* self, float factor);

typedef lucy_VArray*
(*lucy_ProximityCompiler_highlight_spans_t)(lucy_ProximityCompiler* self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t Lucy_ProximityCompiler_Make_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityCompiler_Make(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Make_OFFSET;
    const lucy_Obj_make_t method = *((lucy_Obj_make_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Get_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityCompiler_Get_RefCount(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_RefCount_OFFSET;
    const lucy_Obj_get_refcount_t method = *((lucy_Obj_get_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Inc_RefCount_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityCompiler_Inc_RefCount(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Inc_RefCount_OFFSET;
    const lucy_Obj_inc_refcount_t method = *((lucy_Obj_inc_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Dec_RefCount_OFFSET;
static CHY_INLINE uint32_t
Lucy_ProximityCompiler_Dec_RefCount(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Dec_RefCount_OFFSET;
    const lucy_Obj_dec_refcount_t method = *((lucy_Obj_dec_refcount_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_To_Host_OFFSET;
static CHY_INLINE void*
Lucy_ProximityCompiler_To_Host(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_To_Host_OFFSET;
    const lucy_Obj_to_host_t method = *((lucy_Obj_to_host_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Clone_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityCompiler_Clone(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Clone_OFFSET;
    const lucy_Obj_clone_t method = *((lucy_Obj_clone_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Destroy_OFFSET;
static CHY_INLINE void
Lucy_ProximityCompiler_Destroy(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Destroy_OFFSET;
    const lucy_Compiler_destroy_t method = *((lucy_Compiler_destroy_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_ProximityCompiler_Equals_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityCompiler_Equals(const lucy_ProximityCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Equals_OFFSET;
    const lucy_ProximityCompiler_equals_t method = *((lucy_ProximityCompiler_equals_t*)method_address);
    return method((lucy_ProximityCompiler*)self, other);
}

extern size_t Lucy_ProximityCompiler_Compare_To_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityCompiler_Compare_To(const lucy_ProximityCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Compare_To_OFFSET;
    const lucy_Obj_compare_to_t method = *((lucy_Obj_compare_to_t*)method_address);
    return method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityCompiler_Hash_Sum_OFFSET;
static CHY_INLINE int32_t
Lucy_ProximityCompiler_Hash_Sum(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Hash_Sum_OFFSET;
    const lucy_Obj_hash_sum_t method = *((lucy_Obj_hash_sum_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Get_VTable_OFFSET;
static CHY_INLINE lucy_VTable*
Lucy_ProximityCompiler_Get_VTable(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_VTable_OFFSET;
    const lucy_Obj_get_vtable_t method = *((lucy_Obj_get_vtable_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Get_Class_Name_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityCompiler_Get_Class_Name(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_Class_Name_OFFSET;
    const lucy_Obj_get_class_name_t method = *((lucy_Obj_get_class_name_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Is_A_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityCompiler_Is_A(const lucy_ProximityCompiler *self, lucy_VTable* ancestor) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Is_A_OFFSET;
    const lucy_Obj_is_a_t method = *((lucy_Obj_is_a_t*)method_address);
    return method((lucy_Obj*)self, ancestor);
}

extern size_t Lucy_ProximityCompiler_To_String_OFFSET;
static CHY_INLINE lucy_CharBuf*
Lucy_ProximityCompiler_To_String(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_To_String_OFFSET;
    const lucy_Compiler_to_string_t method = *((lucy_Compiler_to_string_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_ProximityCompiler_To_I64_OFFSET;
static CHY_INLINE int64_t
Lucy_ProximityCompiler_To_I64(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_To_I64_OFFSET;
    const lucy_Obj_to_i64_t method = *((lucy_Obj_to_i64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_To_F64_OFFSET;
static CHY_INLINE double
Lucy_ProximityCompiler_To_F64(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_To_F64_OFFSET;
    const lucy_Obj_to_f64_t method = *((lucy_Obj_to_f64_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_To_Bool_OFFSET;
static CHY_INLINE chy_bool_t
Lucy_ProximityCompiler_To_Bool(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_To_Bool_OFFSET;
    const lucy_Obj_to_bool_t method = *((lucy_Obj_to_bool_t*)method_address);
    return method((lucy_Obj*)self);
}

extern size_t Lucy_ProximityCompiler_Serialize_OFFSET;
static CHY_INLINE void
Lucy_ProximityCompiler_Serialize(const lucy_ProximityCompiler *self, lucy_OutStream* outstream) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Serialize_OFFSET;
    const lucy_ProximityCompiler_serialize_t method = *((lucy_ProximityCompiler_serialize_t*)method_address);
    method((lucy_ProximityCompiler*)self, outstream);
}

extern size_t Lucy_ProximityCompiler_Deserialize_OFFSET;
static CHY_INLINE lucy_ProximityCompiler*
Lucy_ProximityCompiler_Deserialize(const lucy_ProximityCompiler *self, lucy_InStream* instream) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Deserialize_OFFSET;
    const lucy_ProximityCompiler_deserialize_t method = *((lucy_ProximityCompiler_deserialize_t*)method_address);
    return method((lucy_ProximityCompiler*)self, instream);
}

extern size_t Lucy_ProximityCompiler_Dump_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityCompiler_Dump(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Dump_OFFSET;
    const lucy_Query_dump_t method = *((lucy_Query_dump_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_ProximityCompiler_Load_OFFSET;
static CHY_INLINE lucy_Obj*
Lucy_ProximityCompiler_Load(const lucy_ProximityCompiler *self, lucy_Obj* dump) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Load_OFFSET;
    const lucy_Query_load_t method = *((lucy_Query_load_t*)method_address);
    return method((lucy_Query*)self, dump);
}

extern size_t Lucy_ProximityCompiler_Mimic_OFFSET;
static CHY_INLINE void
Lucy_ProximityCompiler_Mimic(const lucy_ProximityCompiler *self, lucy_Obj* other) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Mimic_OFFSET;
    const lucy_Obj_mimic_t method = *((lucy_Obj_mimic_t*)method_address);
    method((lucy_Obj*)self, other);
}

extern size_t Lucy_ProximityCompiler_Make_Compiler_OFFSET;
static CHY_INLINE lucy_Compiler*
Lucy_ProximityCompiler_Make_Compiler(const lucy_ProximityCompiler *self, lucy_Searcher* searcher, float boost, chy_bool_t subordinate) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Make_Compiler_OFFSET;
    const lucy_Query_make_compiler_t method = *((lucy_Query_make_compiler_t*)method_address);
    return method((lucy_Query*)self, searcher, boost, subordinate);
}

extern size_t Lucy_ProximityCompiler_Set_Boost_OFFSET;
static CHY_INLINE void
Lucy_ProximityCompiler_Set_Boost(const lucy_ProximityCompiler *self, float boost) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Set_Boost_OFFSET;
    const lucy_Query_set_boost_t method = *((lucy_Query_set_boost_t*)method_address);
    method((lucy_Query*)self, boost);
}

extern size_t Lucy_ProximityCompiler_Get_Boost_OFFSET;
static CHY_INLINE float
Lucy_ProximityCompiler_Get_Boost(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_Boost_OFFSET;
    const lucy_Query_get_boost_t method = *((lucy_Query_get_boost_t*)method_address);
    return method((lucy_Query*)self);
}

extern size_t Lucy_ProximityCompiler_Make_Matcher_OFFSET;
static CHY_INLINE lucy_Matcher*
Lucy_ProximityCompiler_Make_Matcher(const lucy_ProximityCompiler *self, lucy_SegReader* reader, chy_bool_t need_score) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Make_Matcher_OFFSET;
    const lucy_ProximityCompiler_make_matcher_t method = *((lucy_ProximityCompiler_make_matcher_t*)method_address);
    return method((lucy_ProximityCompiler*)self, reader, need_score);
}

extern size_t Lucy_ProximityCompiler_Get_Weight_OFFSET;
static CHY_INLINE float
Lucy_ProximityCompiler_Get_Weight(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_Weight_OFFSET;
    const lucy_ProximityCompiler_get_weight_t method = *((lucy_ProximityCompiler_get_weight_t*)method_address);
    return method((lucy_ProximityCompiler*)self);
}

extern size_t Lucy_ProximityCompiler_Get_Similarity_OFFSET;
static CHY_INLINE lucy_Similarity*
Lucy_ProximityCompiler_Get_Similarity(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_Similarity_OFFSET;
    const lucy_Compiler_get_similarity_t method = *((lucy_Compiler_get_similarity_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_ProximityCompiler_Get_Parent_OFFSET;
static CHY_INLINE lucy_Query*
Lucy_ProximityCompiler_Get_Parent(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Get_Parent_OFFSET;
    const lucy_Compiler_get_parent_t method = *((lucy_Compiler_get_parent_t*)method_address);
    return method((lucy_Compiler*)self);
}

extern size_t Lucy_ProximityCompiler_Sum_Of_Squared_Weights_OFFSET;
static CHY_INLINE float
Lucy_ProximityCompiler_Sum_Of_Squared_Weights(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Sum_Of_Squared_Weights_OFFSET;
    const lucy_ProximityCompiler_sum_of_squared_weights_t method = *((lucy_ProximityCompiler_sum_of_squared_weights_t*)method_address);
    return method((lucy_ProximityCompiler*)self);
}

extern size_t Lucy_ProximityCompiler_Apply_Norm_Factor_OFFSET;
static CHY_INLINE void
Lucy_ProximityCompiler_Apply_Norm_Factor(const lucy_ProximityCompiler *self, float factor) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Apply_Norm_Factor_OFFSET;
    const lucy_ProximityCompiler_apply_norm_factor_t method = *((lucy_ProximityCompiler_apply_norm_factor_t*)method_address);
    method((lucy_ProximityCompiler*)self, factor);
}

extern size_t Lucy_ProximityCompiler_Normalize_OFFSET;
static CHY_INLINE void
Lucy_ProximityCompiler_Normalize(const lucy_ProximityCompiler *self) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Normalize_OFFSET;
    const lucy_Compiler_normalize_t method = *((lucy_Compiler_normalize_t*)method_address);
    method((lucy_Compiler*)self);
}

extern size_t Lucy_ProximityCompiler_Highlight_Spans_OFFSET;
static CHY_INLINE lucy_VArray*
Lucy_ProximityCompiler_Highlight_Spans(const lucy_ProximityCompiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, const lucy_CharBuf* field) {
    char *const method_address = *(char**)self + Lucy_ProximityCompiler_Highlight_Spans_OFFSET;
    const lucy_ProximityCompiler_highlight_spans_t method = *((lucy_ProximityCompiler_highlight_spans_t*)method_address);
    return method((lucy_ProximityCompiler*)self, searcher, doc_vec, field);
}



/* Define the VTable singleton for this class.
 */

typedef struct LUCY_PROXIMITYCOMPILER_VT {
    cfish_VTable *vtable;
    cfish_ref_t ref;
    cfish_VTable *parent;
    cfish_CharBuf *name;
    uint32_t flags;
    void *x;
    size_t obj_alloc_size;
    size_t vt_alloc_size;
    void *callbacks;
    cfish_method_t methods[33];
} LUCY_PROXIMITYCOMPILER_VT;
extern struct LUCY_PROXIMITYCOMPILER_VT LUCY_PROXIMITYCOMPILER_vt;
#define LUCY_PROXIMITYCOMPILER ((cfish_VTable*)&LUCY_PROXIMITYCOMPILER_vt)


/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ProximityCompiler lucy_ProximityCompiler
  #define PROXIMITYCOMPILER LUCY_PROXIMITYCOMPILER
  #define ProximityCompiler_new lucy_ProximityCompiler_new
  #define ProximityCompiler_init lucy_ProximityCompiler_init
  #define ProximityCompiler_equals_t lucy_ProximityCompiler_equals_t
  #define ProximityCompiler_equals lucy_ProximityCompiler_equals
  #define ProximityCompiler_serialize_t lucy_ProximityCompiler_serialize_t
  #define ProximityCompiler_serialize lucy_ProximityCompiler_serialize
  #define ProximityCompiler_deserialize_t lucy_ProximityCompiler_deserialize_t
  #define ProximityCompiler_deserialize lucy_ProximityCompiler_deserialize
  #define ProximityCompiler_make_matcher_t lucy_ProximityCompiler_make_matcher_t
  #define ProximityCompiler_make_matcher lucy_ProximityCompiler_make_matcher
  #define ProximityCompiler_get_weight_t lucy_ProximityCompiler_get_weight_t
  #define ProximityCompiler_get_weight lucy_ProximityCompiler_get_weight
  #define ProximityCompiler_sum_of_squared_weights_t lucy_ProximityCompiler_sum_of_squared_weights_t
  #define ProximityCompiler_sum_of_squared_weights lucy_ProximityCompiler_sum_of_squared_weights
  #define ProximityCompiler_apply_norm_factor_t lucy_ProximityCompiler_apply_norm_factor_t
  #define ProximityCompiler_apply_norm_factor lucy_ProximityCompiler_apply_norm_factor
  #define ProximityCompiler_highlight_spans_t lucy_ProximityCompiler_highlight_spans_t
  #define ProximityCompiler_highlight_spans lucy_ProximityCompiler_highlight_spans
  #define ProximityCompiler_Make Lucy_ProximityCompiler_Make
  #define ProximityCompiler_Get_RefCount Lucy_ProximityCompiler_Get_RefCount
  #define ProximityCompiler_Inc_RefCount Lucy_ProximityCompiler_Inc_RefCount
  #define ProximityCompiler_Dec_RefCount Lucy_ProximityCompiler_Dec_RefCount
  #define ProximityCompiler_To_Host Lucy_ProximityCompiler_To_Host
  #define ProximityCompiler_Clone Lucy_ProximityCompiler_Clone
  #define ProximityCompiler_Destroy Lucy_ProximityCompiler_Destroy
  #define ProximityCompiler_Equals Lucy_ProximityCompiler_Equals
  #define ProximityCompiler_Compare_To Lucy_ProximityCompiler_Compare_To
  #define ProximityCompiler_Hash_Sum Lucy_ProximityCompiler_Hash_Sum
  #define ProximityCompiler_Get_VTable Lucy_ProximityCompiler_Get_VTable
  #define ProximityCompiler_Get_Class_Name Lucy_ProximityCompiler_Get_Class_Name
  #define ProximityCompiler_Is_A Lucy_ProximityCompiler_Is_A
  #define ProximityCompiler_To_String Lucy_ProximityCompiler_To_String
  #define ProximityCompiler_To_I64 Lucy_ProximityCompiler_To_I64
  #define ProximityCompiler_To_F64 Lucy_ProximityCompiler_To_F64
  #define ProximityCompiler_To_Bool Lucy_ProximityCompiler_To_Bool
  #define ProximityCompiler_Serialize Lucy_ProximityCompiler_Serialize
  #define ProximityCompiler_Deserialize Lucy_ProximityCompiler_Deserialize
  #define ProximityCompiler_Dump Lucy_ProximityCompiler_Dump
  #define ProximityCompiler_Load Lucy_ProximityCompiler_Load
  #define ProximityCompiler_Mimic Lucy_ProximityCompiler_Mimic
  #define ProximityCompiler_Make_Compiler Lucy_ProximityCompiler_Make_Compiler
  #define ProximityCompiler_Set_Boost Lucy_ProximityCompiler_Set_Boost
  #define ProximityCompiler_Get_Boost Lucy_ProximityCompiler_Get_Boost
  #define ProximityCompiler_Make_Matcher Lucy_ProximityCompiler_Make_Matcher
  #define ProximityCompiler_Get_Weight Lucy_ProximityCompiler_Get_Weight
  #define ProximityCompiler_Get_Similarity Lucy_ProximityCompiler_Get_Similarity
  #define ProximityCompiler_Get_Parent Lucy_ProximityCompiler_Get_Parent
  #define ProximityCompiler_Sum_Of_Squared_Weights Lucy_ProximityCompiler_Sum_Of_Squared_Weights
  #define ProximityCompiler_Apply_Norm_Factor Lucy_ProximityCompiler_Apply_Norm_Factor
  #define ProximityCompiler_Normalize Lucy_ProximityCompiler_Normalize
  #define ProximityCompiler_Highlight_Spans Lucy_ProximityCompiler_Highlight_Spans
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCYX_SEARCH_PROXIMITYQUERY */




